/*!
 * EGroupware (http://www.egroupware.org/) minified Javascript
 *
 * full sources are available under https://github.com/EGroupware/egroupware/
 *
 * build Sun May 02 2021 09:04:42
 */

/**
 * EGroupware eTemplate2 - JS XML Code
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
function et2_loadXMLFromURL(_url,_callback,_context,_fail_callback){var win;void 0===_context&&(_context=null);try{opener&&opener.etemplate2&&(win=opener)}catch(e){}void 0===win&&(win=egw.top),win.jQuery.ajax({url:("/"==_url[0]?location.protocol+"//"+location.host:"")+_url,context:_context,type:"GET",dataType:"xml",success:function(_data,_status,_xmlhttp){_callback.call(_context,_data.documentElement)},error:function(_xmlhttp,_err){egw().debug("error","Loading eTemplate from "+_url+" failed! "+_xmlhttp.status+" "+_xmlhttp.statusText),void 0!==_fail_callback&&_fail_callback.call(_context,_err)}})}function et2_directChildrenByTagName(_node,_tagName){_tagName=_tagName.toLowerCase();for(var result=[],i=0;i<_node.childNodes.length;i++)_tagName==_node.childNodes[i].nodeName.toLowerCase()&&result.push(_node.childNodes[i]);return result}function et2_filteredNodeIterator(_node,_callback,_context){for(var i=0;i<_node.childNodes.length;i++){var node=_node.childNodes[i],nodeName=node.nodeName.toLowerCase();"#"!=nodeName.charAt(0)&&_callback.call(_context,node,nodeName)}}function et2_readAttrWithDefault(_node,_name,_default){var val=_node.getAttribute(_name);return null===val?_default:val}
/**
 * EGroupware eTemplate2 - File which contains all interfaces
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
function implements_methods(obj,methods){for(var i=0;i<methods.length;++i)if("function"!=typeof obj[methods[i]])return!1;return!0}var et2_IDOMNode="et2_IDOMNode";function implements_et2_IDOMNode(obj){return implements_methods(obj,["getDOMNode"])}var et2_IInput="et2_IInput";function implements_et2_IInput(obj){return implements_methods(obj,["getValue","isDirty","resetDirty","isValid"])}var et2_IResizeable="et2_IResizeable";function implements_et2_IResizeable(obj){return implements_methods(obj,["resize"])}var et2_IAligned="et2_IAligned";function implements_et2_IAligned(obj){return implements_methods(obj,["get_align"])}var et2_ISubmitListener="et2_ISubmitListener";function implements_et2_ISubmitListener(obj){return implements_methods(obj,["submit"])}var et2_IDetachedDOM="et2_IDetachedDOM";function implements_et2_IDetachedDOM(obj){return implements_methods(obj,["getDetachedAttributes","getDetachedNodes","setDetachedAttributes"])}var et2_IPrint="et2_IPrint";function implements_et2_IPrint(obj){return implements_methods(obj,["beforePrint","afterPrint"])}var et2_IExposable="et2_IExposable";function implements_et2_IExposable(obj){return implements_methods(obj,["getMedia"])}
/**
 * EGroupware eTemplate2 - JS Widget base class
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 */
void 0===Array.prototype.indexOf&&(Array.prototype.indexOf=function(_elem){for(var i=0;i<this.length;i++)if(this[i]===_elem)return i;return-1});var et2_validTypes=["boolean","string","rawstring","html","float","integer","any","js","dimension"],et2_typeDefaults={boolean:!1,string:"",rawstring:"",html:"",js:null,float:0,integer:0,any:null,dimension:"auto"};function et2_evalBool(_val){return("string"!=typeof _val||"false"!=_val&&"0"!=_val)&&!!_val}function et2_form_name(_cname,_name){for(var parts=[],i=0;i<arguments.length;++i){"string"==typeof(name=arguments[i])&&name.length>0&&(parts=parts.concat(name.replace(/]/g,"").split("[")))}var name=parts.shift();return parts.length?name+"["+parts.join("][")+"]":name}function et2_checkType(_val,_type,_attr,_widget){function _err(){var res=et2_typeDefaults[_type];return void 0!==_val&&_val&&egw.debug("warn","Widget %o: '"+_val+"' was not of specified _type '"+_type+(null!=_attr?"' for attribute '"+_attr+"' ":"")+"and is now '"+res+"'",_widget),res}if(void 0===_attr&&(_attr=null),"any"==_type)return _val;if(_val===et2_typeDefaults[_type])return _val;if("boolean"==_type){if(!0===_val||!1===_val)return _val;if("string"==typeof _val){var lcv=_val.toLowerCase();if("true"===lcv||"false"===lcv||""===lcv)return"true"===_val;if("0"===lcv||"1"===lcv)return"1"===_val}else if("number"==typeof _val)return 0!=_val;return _err()}if("string"==_type||"html"==_type||"rawstring"==_type)return"number"==typeof _val?_val.toString():"string"==typeof _val?"string"==_type?html_entity_decode(_val):_val:"object"==typeof _val&&jQuery.isEmptyObject(_val)?"":_err();if("float"==_type)return"number"==typeof _val?_val:isNaN(_val)?_err():parseFloat(_val);if("integer"==_type)return parseInt(_val)==_val?parseInt(_val):_err();if("dimension"==_type)return"auto"==_val?_val:isNaN(_val)?"string"==typeof _val&&(_val.indexOf("px")==_val.length-2&&!isNaN(_val.split("px")[0])||_val.indexOf("%")==_val.length-1&&!isNaN(_val.split("%")[0]))?_val:_err():parseFloat(_val)+"px";if("js"==_type){if("function"==typeof _val||void 0===_val)return _val;if(_val&&(_val=_val.replace(/window\.close\(\)/g,"egw(window).close()")),"string"==typeof _val&&"app."==_val.substr(0,4)&&app){for(var parts=_val.split("."),func=parts.pop(),parent=window,i=0;i<parts.length&&void 0!==parent[parts[i]];++i)parent=parent[parts[i]];if("function"==typeof parent[func])try{return jQuery.proxy(parent[func],parent)}catch(e){return egw.debug("error","Function",_val),_err()}}if(!_val||"string"==typeof _val)return _val}throw"Invalid type identifier '"+_attr+"': '"+_type+"'"}var et2_no_init=new Object;function et2_validateAttrib(_id,_attrib){void 0===_attrib.ignore&&(_attrib.ignore=!1),_attrib.ignore||(void 0===_attrib.name&&(_attrib.name=_id,egw.debug("log","Human name ('name'-Field) for attribute '"+_id+"' has not been supplied, set to '"+_id+"'")),void 0===_attrib.description&&(_attrib.description="",egw.debug("log","Description for attribute '"+_id+"' has not been supplied")),void 0===_attrib.type?_attrib.type="any":et2_validTypes.indexOf(_attrib.type)<0&&egw.debug("error","Invalid type '"+_attrib.type+"' for attribute '"+_id+"' supplied.  Valid types are ",et2_validTypes),void 0===_attrib.default&&(_attrib.default=et2_typeDefaults[_attrib.type]))}function et2_arrayValues(_arr){var result=[];for(var key in _arr)parseInt(key)==key&&result.push(_arr[key]);return result}function et2_arrayKeys(_arr){var result=[];for(var key in _arr)result.push(key);return result}function et2_arrayIntKeys(_arr){var result=[];for(var key in _arr)result.push(parseInt(key));return result}function et2_substr(str,start,len){var end=str.length;return start<0&&(start+=end),end=void 0===len?end:len<0?len+end:len+start,start>=str.length||start<0||start>end?"":str.slice(start,end)}function et2_csvSplit(_str,_num,_delimiter,_enclosure){if(void 0!==_str&&null!=_str||(_str=""),void 0===_num&&(_num=null),void 0===_delimiter&&(_delimiter=","),void 0===_enclosure&&(_enclosure='"'),-1==_str.indexOf(_enclosure))return null===_num?_str.split(_delimiter):_str.split(_delimiter,_num);for(var parts=_str.split(_delimiter),n=0;void 0!==parts[n];n++){if(parts[n].charAt(0)===_enclosure){for(var m=n;void 0!==parts[m+1]&&parts[n].substr(-1)!==_enclosure;)parts[n]+=_delimiter+parts[++m],delete parts[m];parts[n]=et2_substr(parts[n].replace(new RegExp(_enclosure+_enclosure,"g"),_enclosure),1,-1),n=m}}return parts=et2_arrayValues(parts),null!==_num&&_num>0&&_num<parts.length&&parts.length>0&&(parts[_num-1]=parts.slice(_num-1,parts.length).join(_delimiter),parts=parts.slice(0,_num)),parts}function et2_activateLinks(_content){var _match=!1,arr=[];function _splitPush(_matches,_proc){if(_matches){_match=!0;for(var i=1;i<_matches.length;i++)void 0===_matches[i]&&(_matches[i]="");var splitted=_content.split(_matches[0]),left=splitted.shift();left&&(arr=arr.concat(et2_activateLinks(left))),_proc(_matches),_content=splitted.join(_matches[0])}}var mail_regExp=/(mailto:)?([a-z0-9._-]+)@([a-z0-9_-]+)\.([a-z0-9._-]+)/i,domain="([\\w-]+\\.[\\w-.]+)",subdir="([\\w\\-\\.,@?^=%&;:\\/~\\+#]*[\\w\\-\\@?^=%&\\/~\\+#])?",http_regExp=new RegExp("(http:\\/\\/|(ftp:\\/\\/|https:\\/\\/))"+domain+subdir,"i"),www_regExp=(domain="www(\\.[\\w-.]+)",subdir="([\\w\\-\\.,@?^=%&:\\/~\\+#]*[\\w\\-\\@?^=%&\\/~\\+#])?",new RegExp(domain+subdir,"i"));do{if(_match=!1,!_content)break;_splitPush(_content.match(mail_regExp),(function(_matches){arr.push({href:(_matches[1]?"":"mailto:")+_matches[0],text:_matches[2]+"@"+_matches[3]+"."+_matches[4]})})),_splitPush(_content.match(http_regExp),(function(_matches){arr.push({href:_matches[0],text:_matches[2]+_matches[3]+_matches[4]})})),_splitPush(_content.match(www_regExp),(function(_matches){arr.push({href:"http://"+_matches[0],text:_matches[0]})}))}while(_match);return arr.push(_content),arr}function et2_insertLinkText(_text,_node,_target){var _a;if(_node){for(var i=_node.childNodes.length-1;i>=0;i--)_node.removeChild(_node.childNodes[i]);for(i=0;i<_text.length;i++){var s=_text[i];if("string"==typeof s||"number"==typeof s)for(var lines="number"!=typeof s&&s.split?s.split("\n"):[s+""],j=0;j<lines.length;j++)_node.appendChild(document.createTextNode(lines[j])),j<lines.length-1&&_node.appendChild(document.createElement("br"));else if(null===(_a=s)||void 0===_a?void 0:_a.text){s.href||(egw.debug("warn","et2_activateLinks gave bad data",s,_node,_target),s.href="");var a=jQuery(document.createElement("a")).attr("href",s.href).text(s.text);void 0!==_target&&_target&&"_self"!=_target&&"mailto:"!=s.href.substr(0,7)&&a.attr("target",_target),"mailto:"==s.href.substr(0,7)&&(egw.user("apps").mail||egw.user("apps").felamimail)&&"1"!=egw.preference("force_mailto","addressbook")&&a.click((function(event){return egw.open_link(this.href),!1})),a.appendTo(_node)}}}else egw.debug("warn","et2_insertLinkText called without node",_text,_node,_target)}function et2_cloneObject(_obj){var result={};for(var key in _obj)result[key]=_obj[key];return result}function et2_hasChild(_nodes,_child){for(var i=0;i<_nodes.length;i++){if(_nodes[i]==_child)return!0;if(_nodes[i].childNodes&&et2_hasChild(_nodes[i].childNodes,_child))return!0}return!1}function et2_range(_top,_height){return{top:_top,bottom:_top+_height}}function et2_bounds(_top,_bottom){return{top:_top,bottom:_bottom}}function et2_rangeIntersect(_ar1,_ar2){return!(_ar1.bottom<_ar2.top||_ar1.top>_ar2.bottom)}function et2_rangeIntersectDir(_ar1,_ar2){return _ar1.bottom<_ar2.top?-1:_ar1.top>_ar2.bottom?1:0}function et2_rangeEqual(_ar1,_ar2){return _ar1.top===_ar2.top&&_ar1.bottom===_ar2.bottom}function et2_rangeSubstract(_ar1,_ar2){var res=[_ar1];et2_rangeIntersect(_ar1,_ar2)&&(res=[et2_bounds(_ar1.top,_ar2.top),et2_bounds(_ar2.bottom,_ar1.bottom)]);for(var i=res.length-1;i>=0;i--)res[i].bottom-res[i].top<=0&&res.splice(i,1);return res}function html_entity_decode(_str){return _str&&-1!=_str.indexOf("&")?jQuery("<span>"+_str+"</span>").text():_str}"use strict";
/**
 * EGroupware eTemplate2 - JS code for implementing inheritance with attributes
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link: https://www.egroupware.org
 * @author Andreas Stöckel
 */Object.defineProperty(exports,"__esModule",{value:!0}),require("../jsapi/egw_global"),require("et2_core_common");var ClassWithAttributes=function(){function ClassWithAttributes(){}return ClassWithAttributes.prototype.getAttribute=function(_name){if(void 0!==this.attributes[_name]&&!this.attributes[_name].ignore)return"function"==typeof this["get_"+_name]?this["get_"+_name]():this[_name];egw.debug("error",this,"Attribute '"+_name+"' does not exist!")},ClassWithAttributes.prototype.setAttribute=function(_name,_value,_override){if(void 0!==this.attributes[_name]){if(!this.attributes[_name].ignore){void 0===_override&&(_override=!0);var val=et2_checkType(_value,this.attributes[_name].type,_name,this);"function"==typeof this["set_"+_name]?this["set_"+_name](val):(_override||void 0===this[_name])&&(this[_name]=val)}}else egw.debug("warn",this,"Attribute '"+_name+"' does not exist!")},ClassWithAttributes.generateAttributeSet=function(widget,_attrs){for(var key in _attrs)void 0!==widget[key]?widget[key].ignore||(_attrs[key]=et2_checkType(_attrs[key],widget[key].type,key,this)):(delete _attrs[key],egw.debug("warn",this,"Attribute '"+key+"' does not exist in "+_attrs.type+"!"));for(var key in widget)if(void 0===_attrs[key]){var _default=widget[key].default;_default==et2_no_init&&(_default=void 0),_attrs[key]=_default}return _attrs},ClassWithAttributes.prototype.initAttributes=function(_attrs){for(var key in _attrs)void 0===this.attributes[key]||this.attributes[key].ignore||null==_attrs[key]||this.setAttribute(key,_attrs[key],!1)},ClassWithAttributes.buildAttributes=function(class_prototype){var class_tree=[],attributes={},n=0;do{n++,class_tree.push(class_prototype),class_prototype=Object.getPrototypeOf(class_prototype)}while(class_prototype!==ClassWithAttributes&&n<50);for(var i=class_tree.length-1;i>=0;i--)attributes=ClassWithAttributes.extendAttributes(attributes,class_tree[i]._attributes);return attributes},ClassWithAttributes.extendAttributes=function(_parent,_attributes){function _copyMerge(_new,_old){var result={};if(void 0!==_new)for(var key in _new)result[key]=_new[key];for(var key in _old)void 0===result[key]&&(result[key]=_old[key]);return result}var attributes={};for(var key in _attributes)attributes[key]=_copyMerge({},_attributes[key]);for(var key in _parent){var _old=_parent[key];attributes[key]=_copyMerge(attributes[key],_old)}for(var key in attributes)et2_validateAttrib(key,attributes[key]);return attributes},ClassWithAttributes.prototype.implements=function(_iface_name){return!("function"!=typeof window["implements_"+_iface_name]||!window["implements_"+_iface_name](this))},ClassWithAttributes.prototype.instanceOf=function(_class_or_interfacename){return"string"==typeof _class_or_interfacename?this.implements(_class_or_interfacename):this instanceof _class_or_interfacename},ClassWithAttributes}();exports.ClassWithAttributes=ClassWithAttributes,
/**
 * EGroupware eTemplate2 - A simple PHP expression parser written in JS
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 */
function(){function _throwParserErr(_p,_err){throw"Syntax error while parsing '"+_p.expr+"' at "+_p.pos+", "+_err}function _php_parseDoubleQuoteString(_p,_tree){for(var state=0,str="";_p.pos<_p.expr.length;){var c=_p.expr.charAt(_p.pos++);switch(state){case 0:case 2:switch(c){case"\\":state=1;break;case"$":if("$"==_p.expr.charAt(_p.pos)&&0==state){_p.pos++,str+="$$";break}if(_p.pos==_p.expr.length){str+="$";break}if("/"==_p.expr.charAt(_p.pos)&&"/"==_p.expr.charAt(0)){str+="$";break}str&&(_tree.push(str),str=""),"{"==_p.expr.charAt(_p.pos)&&2!=state&&(state=2,_p.pos++),2==state?(_tree.push(_php_parseVariable(_p)),state=3):_tree.push(_php_parseVariable(_p));break;case"{":state=2;break;default:2==state&&(str+="{",state=0),str+=c}break;case 1:str+=c;break;case 3:"}"!=c&&_throwParserErr(_p,"expected '}', but got "+c),state=0}}3==state&&_throwParserErr(_p,"unexpected end of string, expected '}'"),2==state&&(str+="{"),str&&_tree.push(str)}var PHP_VAR_PREG=/^([A-Za-z0-9_]+)/;function _php_parseVariable(_p){for(var variable=function(_p){var vname=PHP_VAR_PREG.exec(_p.expr.substr(_p.pos));if(vname)return _p.pos+=vname[0].length,{variable:vname[0],accessExpressions:[]};_throwParserErr(_p,"expected variable identifier.")}(_p),state=0;_p.pos<_p.expr.length;){var c=_p.expr.charAt(_p.pos++);switch(state){case 0:switch(c){case"[":variable.accessExpressions.push(_php_parseExpression(_p)),state=4;break;default:return _p.pos--,variable}break;case 4:"]"!=c&&_throwParserErr(_p," expected ']', but got "+c),state=0}}return variable}function _php_readString(_p,_delim){for(var state=0,str="";_p.pos<_p.expr.length;){var c=_p.expr.charAt(_p.pos++);switch(state){case 0:if("\\"==c)state=1;else{if(c===_delim||"string"!=typeof _delim&&_delim.test(c))return str;str+=c}break;case 1:str+=c,state=0}}_throwParserErr(_p,"unexpected end of string while parsing string!")}function _php_parseExpression(_p){for(var state=5,result=null;_p.pos<_p.expr.length;){var c=_p.expr.charAt(_p.pos++);switch(state){case 5:switch(c){case" ":case"\n":case"\r":case"\t":break;case'"':result=[],_php_parseDoubleQuoteString(_php_parser(_php_readString(_p,'"')),result),state=6;break;case"'":result=_php_readString(_p,"'");state=6;break;case"$":result=_php_parseVariable(_p);state=6;break;default:_p.pos--,(result=_php_readString(_p,/[^A-Za-z0-9_#]/))||_throwParserErr(_p,"unexpected char "+c),_p.pos--,state=6}break;case 6:switch(c){case" ":case"\n":case"\r":case"\t":break;default:return _p.pos--,result}}}_throwParserErr(_p,"unexpected end of string while parsing access expressions!")}function _php_parser(_expr){return{expr:_expr,pos:0}}function _php_compileVariable(_vars,_variable){if(_vars.indexOf(_variable.variable)>=0){for(var result="_"+_variable.variable,i=0;i<_variable.accessExpressions.length;i++)result+="["+_php_compileString(_vars,_variable.accessExpressions[i])+"]";return"(typeof _"+_variable.variable+' != "undefined" && typeof '+result+'!="undefined" && '+result+" != null ? "+result+':"")'}!function(_err){throw"PHP to JS compiler error, "+_err}("Variable $"+_variable.variable+" is not defined.")}function _php_compileString(_vars,_string){_string instanceof Array||(_string=[_string]);for(var parts=[],hasString=!1,i=0;i<_string.length;i++){var part=_string[i];"string"==typeof part?(hasString=!0,parts.push("'"+part.replace(/\\/g,"\\\\").replace(/'/g,"\\'")+"'")):parts.push(_php_compileVariable(_vars,part))}return hasString||parts.push('""'),parts.join(" + ")}this.et2_compilePHPExpression=function(_expr,_vars){void 0===_vars&&(_vars=[]);try{var parser=_php_parser(_expr),syntaxTree=[];_php_parseDoubleQuoteString(parser,syntaxTree);var js=function(_vars,_tree){return"return "+_php_compileString(_vars,_tree)+";"}(_vars,syntaxTree);egw.debug("log","Compiled PHP "+_expr+" --\x3e "+js)}catch(e){return egw.debug("warn","Error compiling PHP "+_expr+" --\x3e using it literally ("+("string"==typeof e?e:e.message)+")!"),function(){return _expr}}for(var attrs=[],i=0;i<_vars.length;i++)attrs.push("_"+_vars[i]);return attrs.push(js),Function.apply(Function,attrs)}}.call(window);
/**
 * EGroupware eTemplate2 - JS content array manager
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 *

/*egw:uses
    et2_core_common;
    egw_inheritance;
    et2_core_phpExpressionCompiler;
*/
var __extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});var et2_arrayMgr=function(){function et2_arrayMgr(_data,_parentMgr){if(void 0===_data&&(_data={}),this.splitIds=!0,this.perspectiveData={owner:null,key:null,row:null},this.readOnly=!1,void 0===_parentMgr&&(_parentMgr=null),this._parentMgr=_parentMgr,void 0!==_data&&_data||(egw.debug("log","No data passed to content array manager.  Probably a mismatch between template namespaces and data."),_data={}),this.splitIds)for(var key in _data){var indexes=key.replace(/&#x5B;/g,"[").split("[");if(indexes.length>1){for(var value=_data[key],target=_data,i=0;i<indexes.length;i++)indexes[i]=indexes[i].replace(/&#x5D;/g,"").replace("]",""),void 0!==target[indexes[i]]&&null!==target[indexes[i]]||(target[indexes[i]]=i==indexes.length-1?value:{}),target=target[indexes[i]];delete _data[key]}}this.data=_data}return et2_arrayMgr.prototype.getRoot=function(){return null!=this._parentMgr?this._parentMgr.getRoot():this},et2_arrayMgr.prototype.getParentMgr=function(){return this._parentMgr},et2_arrayMgr.prototype.getPerspectiveData=function(){return this.perspectiveData},et2_arrayMgr.prototype.setPerspectiveData=function(new_perspective){this.perspectiveData=new_perspective},et2_arrayMgr.prototype.setRow=function(new_row){this.perspectiveData.row=new_row},et2_arrayMgr.prototype.explodeKey=function(_key){var indexes=[_key];if("string"==typeof _key&&(indexes=(_key=_key.replace(/&#x5B;/g,"[").replace(/&#x5D;/g,"]")).split("[")),indexes.length>1){(indexes=[indexes.shift(),indexes.join("[")])[1]=indexes[1].substring(0,indexes[1].length-1);var children=indexes[1].split("][");children.length&&(indexes=jQuery.merge([indexes[0]],children))}return indexes},et2_arrayMgr.prototype.getPath=function(_path){return void 0===_path&&(_path=[]),null!=this.perspectiveData.key&&(_path=this.perspectiveData.key.replace(/]/g,"").split("[").concat(_path)),null!=this._parentMgr&&(_path=this._parentMgr.getPath(_path)),_path},et2_arrayMgr.prototype.getEntry=function(_key,_referenceInto,_skipEmpty){void 0===_referenceInto&&(_referenceInto=!1),void 0===_skipEmpty&&(_skipEmpty=!1);for(var indexes=this.explodeKey(_key),entry=this.data,i=0;i<indexes.length;i++){var isObject="object"==typeof entry;if(!isObject&&!_referenceInto||null==entry||jQuery.isEmptyObject(entry))return null;var idx=indexes[i];if(_skipEmpty&&(!isObject||void 0===entry[idx]))return null;entry=entry[idx]}return entry},et2_arrayMgr.prototype.expandName=function(_ident){var is_index_in_content="@"==_ident.charAt(0),pos_var=_ident.indexOf("$");if(pos_var>=0&&(null!=this.perspectiveData.row||!_ident.match(/\$\{?row\}?/))&&pos_var!==_ident.indexOf("$/")){var row="number"==typeof this.perspectiveData.row?this.perspectiveData.row:"",row_cont=this.data[row]||{},cont=this.data,_cont=this.data;if(void 0===et2_arrayMgr.compiledExpressions[_ident])try{null==this.perspectiveData.row?et2_arrayMgr.compiledExpressions[_ident]=et2_compilePHPExpression(_ident,["cont","_cont"]):et2_arrayMgr.compiledExpressions[_ident]=et2_compilePHPExpression(_ident,["row","cont","row_cont","_cont"])}catch(e){et2_arrayMgr.compiledExpressions[_ident]=null,egw.debug("error","Error while compiling PHP->JS ",e)}if(et2_arrayMgr.compiledExpressions[_ident])try{_ident=null==this.perspectiveData.row?et2_arrayMgr.compiledExpressions[_ident](cont,_cont):et2_arrayMgr.compiledExpressions[_ident](row,cont,row_cont,_cont)}catch(e){egw.debug("log","object"==typeof e?e.message:e),_ident=null}}return is_index_in_content&&_ident?"@"==_ident.charAt(1)?this.getRoot().getEntry(_ident.substr(2)):this.getEntry(_ident.substr(1)):_ident},et2_arrayMgr.prototype.parseBoolExpression=function(_expression){if("!"==_expression.charAt(0))return!this.parseBoolExpression(_expression.substr(1));var parts=_expression.split("="),val=this.expandName(parts[0]);if(val=null==val?"":""+val,void 0!==parts[1]){var checkVal=""+this.expandName(parts[1]);return"/"==checkVal.charAt(0)?new RegExp(checkVal.substr(1,checkVal.length-2)).test(val):val==checkVal}return et2_evalBool(val)},et2_arrayMgr.prototype.openPerspective=function(_owner,_root,_row){var root="string"==typeof _root?this.data[_root]:null==_root?this.data:_root;void 0===root&&"string"==typeof _root&&(root=this.getEntry(_root));var mgr=new(this.readOnly?et2_readonlysArrayMgr:et2_arrayMgr)(root,this);return mgr.perspectiveData.owner=_owner,"string"==typeof _root&&(mgr.perspectiveData.key=_root),void 0!==_row&&(mgr.perspectiveData.row=_row),mgr},et2_arrayMgr.compiledExpressions={},et2_arrayMgr}();exports.et2_arrayMgr=et2_arrayMgr;var et2_readonlysArrayMgr=function(_super){function et2_readonlysArrayMgr(){var _this=null!==_super&&_super.apply(this,arguments)||this;return _this.readOnly=!0,_this}return __extends(et2_readonlysArrayMgr,_super),et2_readonlysArrayMgr.prototype.isReadOnly=function(_id,_attr,_parent){var entry=null;if(null!=_id){(_id.indexOf("$")>=0||_id.indexOf("@")>=0)&&(_id=this.expandName(_id));for(var mgr=this;mgr.getParentMgr()&&jQuery.isEmptyObject(mgr.data);)mgr=mgr.getParentMgr();entry=mgr.getEntry(_id)}return void 0!==entry&&"object"!=typeof entry?entry:null!=_attr?"editable"===this.expandName(_attr)?"editable":et2_evalBool(_attr):!(void 0===_parent||!_parent)||null!=(entry=this.getEntry("__ALL__"))},et2_readonlysArrayMgr.prototype.expandName=function(ident){return this.perspectiveData.owner.getArrayMgr("content").expandName(ident)},et2_readonlysArrayMgr}(et2_arrayMgr);function et2_arrayMgrs_expand(_owner,_mgrs,_data,_row){var result={};for(var key in _mgrs)if(result[key]=_mgrs[key],void 0!==_data[key]){var rowData={};rowData[_row]=_data[key],result[key]=_mgrs[key].openPerspective(_owner,rowData,_row)}return result}exports.et2_readonlysArrayMgr=et2_readonlysArrayMgr,exports.et2_arrayMgrs_expand=et2_arrayMgrs_expand;
/**
 * EGroupware eTemplate2 - JS Widget base class
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link https://www.egroupware.org
 * @author Andreas Stöckel
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});var et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_arrayMgr_1=require("./et2_core_arrayMgr"),et2_registry={},et2_attribute_registry={};function et2_register_widget(_constructor,_types){et2_attribute_registry[_constructor.name]=et2_core_inheritance_1.ClassWithAttributes.buildAttributes(_constructor);for(var i=0;i<_types.length;i++){var type=_types[i].toLowerCase();et2_registry[type]&&egw.debug("warn","Widget class registered for "+type+" will be overwritten."),et2_registry[type]=_constructor}}function et2_createWidget(_name,_attrs,_parent){void 0===_attrs&&(_attrs={}),"object"!=typeof _attrs&&(_attrs={}),void 0===_parent&&(_parent=null);var nodeName=_attrs.type=_name,readonly=_attrs.readonly=void 0!==_attrs.readonly&&_attrs.readonly,constructor=void 0===et2_registry[nodeName]?et2_placeholder:et2_registry[nodeName];return readonly&&void 0!==et2_registry[nodeName+"_ro"]&&(constructor=et2_registry[nodeName+"_ro"]),et2_core_inheritance_1.ClassWithAttributes.generateAttributeSet(et2_attribute_registry[constructor.name],_attrs),new constructor(_parent,_attrs)}exports.et2_register_widget=et2_register_widget,exports.et2_createWidget=et2_createWidget;var et2_widget=function(_super){function et2_widget(_parent,_attrs,_child){var _this=_super.call(this)||this;return _this._children=[],_this._mgrs={},_this._inst=null,_this.attributes=et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_widget._attributes,_child||{}),void 0===_parent&&(_parent=null),void 0===_attrs&&(_attrs={}),_attrs.attributes&&jQuery.extend(_attrs,_attrs.attributes),_this._mgrs={},_this._inst=null,_this._children=[],_this._type=_attrs.type,_this.id=_attrs.id,null!=_parent&&_parent.addChild(_this),_this.supportedWidgetClasses=[et2_widget],_attrs.id&&_this._createNamespace()&&_this.checkCreateNamespace(_attrs),_this.id,_this.transformAttributes(_attrs),_this.options=et2_cloneObject(_attrs),_this}return __extends(et2_widget,_super),et2_widget.prototype.destroy=function(){for(var i=this._children.length-1;i>=0;i--)this._children[i].destroy();for(var key in void 0!==this._parent&&null!==this._parent&&this._parent.removeChild(this),this._mgrs)this._mgrs[key]&&this._mgrs[key].owner==this&&this._mgrs[key].destroy()},et2_widget.prototype.getType=function(){return this._type},et2_widget.prototype.setType=function(_type){this._type=_type},et2_widget.prototype.clone=function(_parent){void 0===_parent&&(_parent=null);var copy=new this.constructor(_parent,this.options);return copy.assign(this),copy},et2_widget.prototype.assign=function(_obj){void 0===_obj._children&&this.egw().debug("log","Foo!");for(var i=0;i<_obj._children.length;i++)_obj._children[i].clone(this);this.setArrayMgrs(_obj.mgrs)},et2_widget.prototype.getParent=function(){return this._parent},et2_widget.prototype.getChildren=function(){return this._children},et2_widget.prototype.getRoot=function(){return null!=this._parent?this._parent.getRoot():this},et2_widget.prototype.addChild=function(_node){this.insertChild(_node,this._children.length)},et2_widget.prototype.insertChild=function(_node,_idx){this.isOfSupportedWidgetClass(_node)?(_node._parent&&_node._parent.removeChild(_node),_node._parent=this,this._children.splice(_idx,0,_node)):this.egw().debug("error","Widget "+_node._type+" is not supported by this widget class",this)},et2_widget.prototype.removeChild=function(_node){var idx=this._children.indexOf(_node);idx>=0&&(_node._parent=null,this._children.splice(idx,1))},et2_widget.prototype.getWidgetById=function(_id){if(this.id==_id)return this;if(!this._children)return null;for(var i=0;i<this._children.length;i++){var elem=this._children[i].getWidgetById(_id);if(null!=elem)return elem}if(this.id&&_id.indexOf("[")>-1&&this._children.length){var ids=(new et2_core_arrayMgr_1.et2_arrayMgr).explodeKey(_id),widget=this;for(i=0;i<ids.length&&null!==widget;i++)widget=widget.getWidgetById(ids[i]);return widget}return null},et2_widget.prototype.iterateOver=function(_callback,_context,_type){void 0===_type&&(_type=et2_widget),this.isInTree()&&this.instanceOf(_type)&&_callback.call(_context,this);for(var i=0;i<this._children.length;i++)this._children[i].iterateOver(_callback,_context,_type)},et2_widget.prototype.isInTree=function(_sender,_vis){return void 0===_vis&&(_vis=!0),this._parent?_vis&&this._parent.isInTree(this):_vis},et2_widget.prototype.isOfSupportedWidgetClass=function(_obj){for(var i=0;i<this.supportedWidgetClasses.length;i++)if(_obj instanceof this.supportedWidgetClasses[i])return!0;return!1},et2_widget.prototype.parseXMLAttrs=function(_attrsObj,_target,_proto){if(void 0!==_attrsObj)for(var mgr=this.getArrayMgr("content"),i=0;i<_attrsObj.length;i++){var attrName=_attrsObj[i].name,attrValue=_attrsObj[i].value;if("options"==attrName&&_proto.constructor.legacyOptions&&_proto.constructor.legacyOptions.length>0){var legacy=_proto.constructor.legacyOptions||[],attrs=et2_attribute_registry[Object.getPrototypeOf(_proto).constructor.name]||{};if(_target.id&&this.getArrayMgr("modifications").getEntry(_target.id)){var mod=this.getArrayMgr("modifications").getEntry(_target.id);void 0!==mod.options&&(attrValue=_attrsObj[i].value=mod.options)}"@"!=attrValue.charAt(0)&&-1==attrValue.indexOf("$")||(attrValue=mgr.expandName(attrValue));for(var splitted=et2_csvSplit(attrValue+""),j=0;j<splitted.length&&j<legacy.length;j++){if(!(0===splitted[j].trim().length&&legacy.length>=splitted.length))if(void 0===_target[legacy[j]])attrValue=splitted[j],j==legacy.length-1&&splitted.length>legacy.length&&(attrValue=splitted.slice(j)),"boolean"==(et2_attribute_registry[_proto.constructor.name][legacy[j]]||{}).type?attrValue=mgr.parseBoolExpression(attrValue):"object"!=typeof attrValue&&(attrValue=mgr.expandName(attrValue)),_target[legacy[j]]=attrValue}}else if("readonly"==attrName&&void 0!==_target[attrName]);else{attrs=et2_attribute_registry[_proto.constructor.name]||{};if(null!=mgr&&void 0!==attrs[attrName])attrValue="boolean"==attrs[attrName].type?mgr.parseBoolExpression(attrValue):mgr.expandName(attrValue);_target[attrName]=attrValue}}},et2_widget.prototype.transformAttributes=function(_attrs){if(this.id&&("string"!=typeof this.id&&console.log(this.id),this.getArrayMgr("modifications"))){var data=this.getArrayMgr("modifications").getEntry(this.id);if(this._createNamespace()&&this.getArrayMgr("modifications").perspectiveData.owner==this&&(data=this.getArrayMgr("modifications").data),"object"==typeof data)for(var key in data)_attrs[key]=data[key]}for(var key in _attrs)_attrs[key]&&void 0!==this.attributes[key]&&(!0===this.attributes[key].translate||"!no_lang"===this.attributes[key].translate&&!_attrs.no_lang)&&(_attrs[key]=this.egw().lang(_attrs[key]))},et2_widget.prototype.createElementFromNode=function(_node,_name){var attributes={},_nodeName=attributes.type=_node.getAttribute("type")?_node.getAttribute("type"):_node.nodeName.toLowerCase(),readonly=attributes.readonly=!!this.getArrayMgr("readonlys")&&this.getArrayMgr("readonlys").isReadOnly(_node.getAttribute("id"),_node.getAttribute("readonly"),void 0!==this.readonly?this.readonly:this.options.readonly),modifications=this.getArrayMgr("modifications");if(modifications&&_node.getAttribute("id")){var entry;if(null==(entry=modifications.getEntry(_node.getAttribute("id"))))(entry=modifications.data[_node.getAttribute("id")])?this.egw().debug("warn","getEntry("+_node.getAttribute("id")+") failed, but the data is there.",modifications,entry):entry=modifications.getRoot().getEntry(_node.getAttribute("id"));entry&&entry.type&&"string"==typeof entry.type&&(_nodeName=attributes.type=entry.type),entry=null}("@"==_nodeName.charAt(0)||_nodeName.indexOf("$")>=0)&&(_nodeName=attributes.type=this.getArrayMgr("content").expandName(_nodeName));var constructor=void 0===et2_registry[_nodeName]?et2_placeholder:et2_registry[_nodeName];!0===readonly&&void 0!==et2_registry[_nodeName+"_ro"]&&(constructor=et2_registry[_nodeName+"_ro"]),this.parseXMLAttrs(_node.attributes,attributes,constructor.prototype),et2_core_inheritance_1.ClassWithAttributes.generateAttributeSet(et2_attribute_registry[constructor.name],attributes);var widget=new constructor(this,attributes);return widget.loadFromXML(_node),widget},et2_widget.prototype.loadFromXML=function(_node){for(var i=0;i<_node.childNodes.length;i++){var node=_node.childNodes[i],widgetType=node.nodeName.toLowerCase();"#comment"!=widgetType&&("#text"!=widgetType?this.createElementFromNode(node):node.data.replace(/^\s+|\s+$/g,"")&&this.loadContent(node.data))}},et2_widget.prototype.loadContent=function(_content){},et2_widget.prototype.loadingFinished=function(promises){if(this.initAttributes(this.options),void 0===promises){promises=[];var warn_if_deferred=!0}var loadChildren=function(){for(var i=0;i<this._children.length;i++)try{this._children[i].loadingFinished(promises)}catch(e){egw.debug("error","There was an error with a widget:\nError:%o\nProblem widget:%o",e.valueOf(),this._children[i],e.stack)}},result=this.doLoadingFinished();"boolean"==typeof result&&result?loadChildren.apply(this,arguments):"object"==typeof result&&result.done&&(warn_if_deferred&&egw.debug("warn","Loading was deferred for widget %o, but creator is not checking.  Pass a list to loadingFinished().",this),promises.push(result),result.done(jQuery.proxy(loadChildren,this)))},et2_widget.prototype.initAttributes=function(_attrs){for(var key in _attrs)if(void 0!==this.attributes[key]&&!this.attributes[key].ignore&&null!=_attrs[key]){var val=_attrs[key];"js"==this.attributes[key].type&&"string"==typeof _attrs[key]&&(val=et2_compileLegacyJS(val,this,this.instanceOf(et2_inputWidget)?this.getInputNode():this.implements(et2_IDOMNode)?this.getDOMNode():null)),this.setAttribute(key,val,!1)}},et2_widget.prototype.doLoadingFinished=function(){return!0},et2_widget.prototype.egw=function(){if(void 0===this._egw){if(null!=this._parent)return this._parent.egw();var wnd=null;if(this.implements(et2_IDOMNode)){var node=this.getDOMNode();node&&node.ownerDocument&&(wnd=node.ownerDocument.parentNode||node.ownerDocument.defaultView)}return egw("phpgwapi",wnd)}return this._egw},et2_widget.prototype.setApiInstance=function(_egw){this._egw=_egw},et2_widget.prototype.setArrayMgrs=function(_mgrs){this._mgrs=et2_cloneObject(_mgrs)},et2_widget.prototype.getArrayMgrs=function(_mgrs){for(var key in void 0===_mgrs&&(_mgrs={}),this._mgrs)void 0===_mgrs[key]&&(_mgrs[key]=this._mgrs[key]);return this._parent&&this._parent.getArrayMgrs(_mgrs),_mgrs},et2_widget.prototype.setArrayMgr=function(_part,_mgr){this._mgrs[_part]=_mgr},et2_widget.prototype.getArrayMgr=function(managed_array_type){return this._mgrs&&void 0!==this._mgrs[managed_array_type]?this._mgrs[managed_array_type]:this._parent?this._parent.getArrayMgr(managed_array_type):null},et2_widget.prototype.checkCreateNamespace=function(_attrs){var mgrs=this.getArrayMgrs();for(var key in mgrs){var mgr=mgrs[key];void 0!==this._mgrs[key]&&mgr.perspectiveData.owner==this&&(mgr=mgr.parentMgr);var entry=mgr.getEntry(this.id);"object"==typeof entry&&null!==entry||this.id?this._mgrs[key]=mgr.openPerspective(this,this.id):delete this._mgrs[key]}},et2_widget.prototype._createNamespace=function(){return!1},et2_widget.prototype.setInstanceManager=function(_inst){this._inst=_inst},et2_widget.prototype.getInstanceManager=function(){return null!=this._inst?this._inst:this._parent?this._parent.getInstanceManager():null},et2_widget.prototype.getPath=function(){var path=this.getArrayMgr("content").getPath();return this.id&&this._createNamespace()&&path[path.length-1]==this.id&&path.pop(),path},et2_widget._attributes={id:{name:"ID",type:"string",description:"Unique identifier of the widget"},no_lang:{name:"No translation",type:"boolean",default:!1,description:"If true, no translations are made for this widget"},span:{ignore:!0},type:{name:"Widget type",type:"string",ignore:!0,description:"What kind of widget this is"},readonly:{ignore:!0},attributes:{name:"Widget attributes",type:"any",ignore:!0,description:"Object of widget attributes"}},et2_widget.legacyOptions=[],et2_widget}(et2_core_inheritance_1.ClassWithAttributes);exports.et2_widget=et2_widget;
/**
 * EGroupware eTemplate2 - JS DOM Widget class
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_inheritance_1=require("./et2_core_inheritance");require("./et2_core_interfaces"),require("./et2_core_common");var et2_core_widget_1=require("./et2_core_widget");require("../egw_action/egw_action.js");var et2_DOMWidget=function(_super){function et2_DOMWidget(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_DOMWidget._attributes,_child||{}))||this;return _this.parentNode=null,_this.disabled=!1,_this._attachSet={node:null,parent:null},_this._surroundingsMgr=null,_this}return __extends(et2_DOMWidget,_super),et2_DOMWidget.prototype.destroy=function(){if(this.detachFromDOM(),this.parentNode=null,this._attachSet={},this._actionManager){var app_om=egw_getObjectManager(this.egw().getAppName(),!1,1);if(app_om){var om=app_om.getObjectById(this.id);om&&om.remove()}this._actionManager.remove(),this._actionManager=null}this._surroundingsMgr&&(this._surroundingsMgr.destroy(),this._surroundingsMgr=null),_super.prototype.destroy.call(this)},et2_DOMWidget.prototype.doLoadingFinished=function(){return this.getParent()&&this.getParent().implements(et2_IDOMNode)&&(this.options.parent_node?this.set_parent_node(this.options.parent_node):this.setParentDOMNode(this.getParent().getDOMNode(this))),!0},et2_DOMWidget.prototype.detachFromDOM=function(){if(this._attachSet&&this._attachSet.node&&this._attachSet.parent){try{this._attachSet.parent.removeChild(this._attachSet.node)}catch(e){}return this._attachSet={node:null,parent:null},!0}return!1},et2_DOMWidget.prototype.attachToDOM=function(){var node=this.getDOMNode(this);if(node&&this.parentNode&&(!this._attachSet||this._attachSet&&node!=this._attachSet.node||this.parentNode!=this._attachSet.parent)){this._surroundingsMgr&&(node=this._surroundingsMgr.getDOMNode(node));var idx=this.getDOMIndex();return idx<0||idx>=this.parentNode.childNodes.length-1?this.parentNode.appendChild(node):this.parentNode.insertBefore(node,this.parentNode.childNodes[idx]),this._attachSet={node:node,parent:this.parentNode},!0}return!1},et2_DOMWidget.prototype.insertChild=function(_node,_idx){if(_super.prototype.insertChild.call(this,_node,_idx),_node.instanceOf(et2_DOMWidget)&&(_node.hasOwnProperty("parentNode"),1)&&this.getDOMNode(this))try{_node.setParentDOMNode(this.getDOMNode(_node))}catch(_a){}},et2_DOMWidget.prototype.isAttached=function(){return null!=this.parentNode},et2_DOMWidget.prototype.getSurroundings=function(){return this._surroundingsMgr||(this._surroundingsMgr=new et2_surroundingsMgr(this)),this._surroundingsMgr},et2_DOMWidget.prototype.get_tab_info=function(){var parent=this;do{parent=parent.getParent()}while(parent!==this.getRoot()&&"tabbox"!==parent.getType());if(parent===this.getRoot())return null;for(var tabbox=parent,i=0;i<tabbox.tabData.length;i++)if(tabbox.tabData[i].contentDiv.has(this.div).length)return tabbox.tabData[i];var template=this;do{template=template.getParent()}while(template!==tabbox&&"template"!==template.getType());for(i=tabbox.tabData.length-1;i>=0;i--)if(template&&template.id&&template.id===tabbox.tabData[i].id)return tabbox.tabData[i];var fallback=this.getParent();return"function"==typeof fallback.get_tab_info?fallback.get_tab_info():null},et2_DOMWidget.prototype.set_parent_node=function(_node){if("string"==typeof _node){var parent=jQuery("#"+_node);0===parent.length&&window.parent&&(parent=jQuery("#"+_node,window.parent.document)),0===parent.length?this.egw().debug("warn",'Unable to find DOM parent node with ID "%s" for widget %o.',_node,this):this.setParentDOMNode(parent.get(0))}else this.setParentDOMNode(_node)},et2_DOMWidget.prototype.setParentDOMNode=function(_node){_node!=this.parentNode&&(this.detachFromDOM(),this.parentNode=_node,this.attachToDOM())},et2_DOMWidget.prototype.getParentDOMNode=function(){return this.parentNode},et2_DOMWidget.prototype.getDOMIndex=function(){if(this.getParent()){var idx=0,children=this.getParent().getChildren();if(children&&children.indexOf)return children.indexOf(this);egw.debug("warn","No Array.indexOf(), falling back to looping. ");for(var i=0;i<children.length;i++){if(children[i]==this)return idx;children[i].isInTree()&&idx++}}return-1},et2_DOMWidget.prototype.set_id=function(_value){this.id=_value,this.dom_id=_value?this.getInstanceManager().uniqueId+"_"+_value.replace(/\./g,"-"):_value;var node=this.getDOMNode(this);node&&(""!=_value?node.setAttribute("id",this.dom_id):node.removeAttribute("id"))},et2_DOMWidget.prototype.set_disabled=function(_value){var node=null!=this._surroundingsMgr?this._surroundingsMgr.getDOMNode(this.getDOMNode(this)):this.getDOMNode(this);node&&this.disabled!=_value&&(this.disabled=_value,_value?jQuery(node).hide():jQuery(node).show())},et2_DOMWidget.prototype.set_width=function(_value){this.width=_value;var node=this.getDOMNode(this);node&&jQuery(node).css("width",_value)},et2_DOMWidget.prototype.set_height=function(_value){this.height=_value;var node=this.getDOMNode(this);node&&jQuery(node).css("height",_value)},et2_DOMWidget.prototype.set_class=function(_value){var node=this.getDOMNode(this);node&&(this.class&&jQuery(node).removeClass(this.class),jQuery(node).addClass(_value)),this.class=_value},et2_DOMWidget.prototype.set_overflow=function(_value){this.overflow=_value;var node=this.getDOMNode(this);node&&jQuery(node).css("overflow",_value)},et2_DOMWidget.prototype.set_data=function(_value){var node=this.getDOMNode(this);if(node&&_value)for(var pairs=_value.split(/,/g),i=0;i<pairs.length;++i){var name_value=pairs[i].split(":");jQuery(node).attr("data-"+name_value[0],name_value[1])}},et2_DOMWidget.prototype.set_background=function(_value){var node=this.getDOMNode(this),values="";_value&&node&&(values=_value.split(","),jQuery(node).css({"background-image":'url("'+values[0]+'")',"background-position-x":values[1],"background-position-y":values[2],"background-scale":values[3]}))},et2_DOMWidget.prototype.set_actions=function(actions){if(""!=this.id&&void 0!==this.id){var gam=window.egw_getActionManager(this.egw().appName,!0,1);"object"!=typeof this._actionManager&&(null!==gam.getActionById(this.getInstanceManager().uniqueId,1)&&(gam=gam.getActionById(this.getInstanceManager().uniqueId,1)),null!=gam.getActionById(this.id,1)?this._actionManager=gam.getActionById(this.id,1):this._actionManager=gam.addAction("actionManager",this.id)),this._actionManager.updateActions(actions,this.egw().appName),this.options.default_execute&&this._actionManager.setDefaultExecute(this.options.default_execute),this._actionManager.data={widget:this},this._link_actions(actions)}else this.egw().debug("warn","Widget should have an ID if you want actions",this)},et2_DOMWidget.prototype.set_default_execute=function(_default_execute){this.options.default_execute=_default_execute,this._actionManager&&this._actionManager.setDefaultExecute(null,_default_execute)},et2_DOMWidget.prototype._get_action_links=function(actions){var action_links=[];for(var i in actions){var action=actions[i];action_links.push(void 0!==action.id?action.id:i)}return action_links},et2_DOMWidget.prototype._link_actions=function(actions){var objectManager=egw_getAppObjectManager(!0),widget_object=objectManager.getObjectById(this.id);null==widget_object?widget_object=objectManager.insertObject(!1,new egwActionObject(this.id,objectManager,new et2_action_object_impl(this).getAOI(),this._actionManager||objectManager.manager.getActionById(this.id)||objectManager.manager)):widget_object.setAOI(new et2_action_object_impl(this,this.getDOMNode()).getAOI()),widget_object.clear(),widget_object.unregisterActions();var action_links=this._get_action_links(actions);widget_object.updateActionLinks(action_links)},et2_DOMWidget._attributes={disabled:{name:"Disabled",type:"boolean",description:"Defines whether this widget is visible.  Not to be confused with an input widget's HTML attribute 'disabled'.",default:!1},width:{name:"Width",type:"dimension",default:et2_no_init,description:"Width of the element in pixels, percentage or 'auto'"},height:{name:"Height",type:"dimension",default:et2_no_init,description:"Height of the element in pixels, percentage or 'auto'"},class:{name:"CSS Class",type:"string",default:et2_no_init,description:"CSS Class which is applied to the dom element of this node"},overflow:{name:"Overflow",type:"string",default:et2_no_init,description:"If set, the css-overflow attribute is set to that value"},parent_node:{name:"DOM parent",type:"string",default:et2_no_init,description:"Insert into the target DOM node instead of the normal location"},actions:{name:"Actions list",type:"any",default:et2_no_init,description:"List of egw actions that can be done on the widget.  This includes context menu, drag and drop.  TODO: Link to action documentation"},default_execute:{name:"Default onExecute for actions",type:"js",default:et2_no_init,description:"Set default onExecute javascript method for action not specifying their own"},resize_ratio:{name:"Resize height of the widget on callback resize",type:"string",default:"",description:"Allow Resize height of the widget based on exess height and given ratio"},data:{name:"comma-separated name:value pairs set as data attributes on DOM node",type:"string",default:"",description:'data="mime:${row}[mime]" would generate data-mime="..." in DOM, eg. to use it in CSS on a parent'},background:{name:"Add background image",type:"string",default:"",description:"Sets background image, left, right and scale on DOM"}},et2_DOMWidget}(et2_core_widget_1.et2_widget);exports.et2_DOMWidget=et2_DOMWidget;var et2_surroundingsMgr=function(_super){function et2_surroundingsMgr(_widget){var _this=_super.call(this)||this;return _this._widgetContainer=null,_this._widgetSurroundings=[],_this._widgetPlaceholder=null,_this._widgetNode=null,_this._ownPlaceholder=!0,_this._surroundingsUpdated=!1,_this.widget=_widget,_this}return __extends(et2_surroundingsMgr,_super),et2_surroundingsMgr.prototype.destroy=function(){this._widgetContainer=null,this._widgetSurroundings=null,this._widgetPlaceholder=null,this._widgetNode=null},et2_surroundingsMgr.prototype.prependDOMNode=function(_node){this._widgetSurroundings.unshift(_node),this._surroundingsUpdated=!0},et2_surroundingsMgr.prototype.appendDOMNode=function(_node){this._ownPlaceholder&&null==this._widgetPlaceholder&&(this._widgetPlaceholder=document.createElement("span"),this._widgetSurroundings.push(this._widgetPlaceholder)),this._widgetSurroundings.push(_node),this._surroundingsUpdated=!0},et2_surroundingsMgr.prototype.insertDOMNode=function(_node){if(this._ownPlaceholder&&null!=this._widgetPlaceholder){var idx=this._widgetSurroundings.indexOf(this._widgetPlaceholder);this._widgetSurroundings.splice(idx,1,_node),this._widgetPlaceholder=null,this._ownPlaceholder=!1}else this.appendDOMNode(_node)},et2_surroundingsMgr.prototype.removeDOMNode=function(_node){for(var i=0;this._widgetSurroundings&&i<this._widgetSurroundings.length;i++)if(this._widgetSurroundings[i]==_node){this._widgetSurroundings.splice(i,1),this._surroundingsUpdated=!0;break}},et2_surroundingsMgr.prototype.setWidgetPlaceholder=function(_node){if(_node!=this._widgetPlaceholder){if(null!=_node&&this._ownPlaceholder&&null!=this._widgetPlaceholder){var idx=this._widgetSurroundings.indexOf(this._widgetPlaceholder);this._widgetSurroundings.splice(idx,1),this._widgetPlaceholder=null,this._ownPlaceholder=!1}this._ownPlaceholder=null==_node,this._widgetPlaceholder=_node,this._surroundingsUpdated=!0}},et2_surroundingsMgr.prototype._rebuildContainer=function(){if(!this._surroundingsUpdated)return!1;if(this._widgetSurroundings.length>0)if(et2_hasChild(this._widgetSurroundings,this._widgetPlaceholder)||(this._widgetPlaceholder=document.createElement("span"),this._widgetSurroundings.push(this._widgetPlaceholder),this._ownPlaceholder=!0),1==this._widgetSurroundings.length)this._widgetSurroundings[0]==this._widgetPlaceholder?this._widgetContainer=null:this._widgetContainer=this._widgetSurroundings[0];else{this._widgetContainer=document.createElement("span");for(var i=0;i<this._widgetSurroundings.length;i++)this._widgetContainer.appendChild(this._widgetSurroundings[i])}else this._widgetContainer=null,this._widgetPlaceholder=null;return this._surroundingsUpdated=!1,!0},et2_surroundingsMgr.prototype.update=function(){this._surroundingsUpdated&&(!!this.widget&&this.widget.isAttached()&&this.widget&&(this.widget.detachFromDOM(),this.widget.attachToDOM()))},et2_surroundingsMgr.prototype.getDOMNode=function(_widgetNode){null!=this._widgetNode&&this._widgetNode!=_widgetNode&&(this._surroundingsUpdated=!0),this._widgetNode=_widgetNode;var updated=this._rebuildContainer();return null==this._widgetContainer?_widgetNode:(updated&&(this._widgetPlaceholder.parentNode.replaceChild(_widgetNode,this._widgetPlaceholder),this._ownPlaceholder||(this._widgetPlaceholder=_widgetNode)),this._widgetContainer)},et2_surroundingsMgr.prototype.getWidgetSurroundings=function(){return this._widgetSurroundings},et2_surroundingsMgr}(et2_core_inheritance_1.ClassWithAttributes),et2_action_object_impl=function(){function et2_action_object_impl(_widget,_node){var widget=_widget,objectNode=_node;this.aoi=new egwActionObjectInterface,this.aoi.getWidget=function(){return widget},this.aoi.doGetDOMNode=function(){return objectNode||widget.getDOMNode()},this.aoi.doSetState=function(_state,_outerCall){},this.aoi.doTriggerEvent=function(_event,_data){switch(_event){case EGW_AI_DRAG_OVER:jQuery(this.node).addClass("ui-state-active");break;case EGW_AI_DRAG_OUT:jQuery(this.node).removeClass("ui-state-active")}}}return et2_action_object_impl.prototype.getAOI=function(){return this.aoi},et2_action_object_impl}();exports.et2_action_object_impl=et2_action_object_impl;
/**
 * EGroupware eTemplate2 - JS Template base class
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0}),require("./et2_core_interfaces"),require("./et2_core_common");var et2_core_DOMWidget_1=require("./et2_core_DOMWidget"),etemplate2_1=(et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget"),require("./etemplate2")),et2_template=function(_super){function et2_template(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_template._attributes,_child||{}))||this;if(_attrs.content&&(_this.content=_attrs.content),_this.div=document.createElement("div"),_this.loading=jQuery.Deferred(),_attrs.template&&(_this.id=_attrs.template,_this.transformAttributes(_attrs),_this.options=et2_cloneObject(_attrs),_attrs={}),""!=_this.id||_this.options.template){var parts=(_this.options.template||_this.id).split("?"),cache_buster=parts.length>1?parts.pop():null,template_name=parts.pop(),xml=null,templates=etemplate2_1.etemplate2.templates;if(!(xml=templates[template_name])){if(template_name.indexOf(".")<0){var root=_parent?_parent.getRoot():null,top_name=root&&root._inst?root._inst.name:null;top_name&&template_name.indexOf(".")<0&&(template_name=top_name+"."+template_name)}if(!(xml=templates[template_name])){var url=_this.options.url;if(!_this.options.url){var splitted=template_name.split("."),app=splitted.shift();url=_this.getRoot()._inst.template_base_url+app+"/templates/default/"+splitted.join(".")+".xet"+(cache_buster?"?download="+cache_buster:"")}if(-1==url.indexOf("?")&&(url+="?download="+(new Date).valueOf()),_this.options.url||splitted.length){var fetch_url_callback=function(_xmldoc){for(var i=0;i<_xmldoc.childNodes.length;i++){var template=_xmldoc.childNodes[i];"template"==template.nodeName.toLowerCase()&&(templates[template.getAttribute("id")]=template)}void 0!==templates[template_name]&&this.loadFromXML(templates[template_name]),this.loading.resolve()};et2_loadXMLFromURL(url,fetch_url_callback,_this,(function(error){et2_loadXMLFromURL(url=egw.link("/"+app+"/templates/default/"+splitted.join(".")+".xet",{download:cache_buster||(new Date).valueOf()}),fetch_url_callback,this)}))}return _this}}null!=xml?(_this.egw().debug("log","Loading template from XML: ",template_name),_this.loadFromXML(xml),_this.loading.resolve()):(_this.egw().debug("warn","Unable to find XML for ",template_name),_this.loading.reject())}else _this.loading.resolve();return _this}return __extends(et2_template,_super),et2_template.prototype.checkCreateNamespace=function(_attrs){if(_attrs.content){var old_id=_attrs.id;this.id=_attrs.content,_super.prototype.checkCreateNamespace.apply(this,arguments),this.id=old_id}},et2_template.prototype._createNamespace=function(){return!0},et2_template.prototype.getDOMNode=function(){return this.div},et2_template.prototype.attachToDOM=function(){return this.div&&jQuery(this.div).off(".et2_template").bind("load.et2_template",this,(function(e){e.data.load.call(e.data,this)})),_super.prototype.attachToDOM.call(this)},et2_template.prototype.load=function(){if("function"==typeof this.options.onload){var args=Array.prototype.slice.call(arguments);return-1==args.indexOf(this)&&args.push(this),this.options.onload.apply(this,args)}},et2_template.prototype.doLoadingFinished=function(){return _super.prototype.doLoadingFinished.call(this),this.loading.done(jQuery.proxy((function(){jQuery(this).trigger("load")}),this.div)),this.loading.promise()},et2_template._attributes={template:{name:"Template",type:"string",description:"Name / ID of template with optional cache-buster ('?'+filemtime of template on server)",default:et2_no_init},group:{name:"Group",description:"Not implemented",default:et2_no_init},version:{name:"Version",type:"string",description:"Version of the template"},lang:{name:"Language",type:"string",description:"Language the template is written in"},content:{name:"Content index",default:et2_no_init,description:"Used for passing in specific content to the template other than what it would get by ID."},url:{name:"URL of template",type:"string",description:"full URL to load template incl. cache-buster"},onload:{name:"onload",type:"js",default:et2_no_init,description:"JS code which is executed after the template is loaded."}},et2_template}(et2_core_DOMWidget_1.et2_DOMWidget);exports.et2_template=et2_template,et2_core_widget_1.et2_register_widget(et2_template,["template"]);
/**
 * EGroupware eTemplate2 - JS Grid object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0}),require("./et2_core_common"),require("./et2_core_interfaces");et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_DOMWidget_1=require("./et2_core_DOMWidget");require("../egw_action/egw_action.js");var et2_grid=function(_super){function et2_grid(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_grid._attributes,_child||{}))||this;return _this.rowCount=0,_this.columnCount=0,_this.cells=[],_this.rowData=[],_this.colData=[],_this.managementArray=[],_this.template_node=null,_this.wrapper=null,_this.table=jQuery(document.createElement("table")).addClass("et2_grid"),_this.thead=jQuery(document.createElement("thead")).appendTo(_this.table),_this.tfoot=jQuery(document.createElement("tfoot")).appendTo(_this.table),_this.tbody=jQuery(document.createElement("tbody")).appendTo(_this.table),_this}return __extends(et2_grid,_super),et2_grid.prototype._initCells=function(_colData,_rowData){for(var w=_colData.length,h=_rowData.length,cells=new Array(h),y=0;y<h;y++){cells[y]=new Array(w);for(var x=0;x<w;x++){var col_disabled=_colData[x].disabled;cells[y][x]={td:null,widget:null,colData:_colData[x],rowData:_rowData[y],disabled:col_disabled||_rowData[y].disabled,class:_colData[x].class,colSpan:1,autoColSpan:!1,rowSpan:1,autoRowSpan:!1,width:_colData[x].width,x:x,y:y}}}return cells},et2_grid.prototype._getColDataEntry=function(){return{width:"auto",class:"",align:"",span:"1",disabled:!1}},et2_grid.prototype._getRowDataEntry=function(){return{height:"auto",class:"",valign:"top",span:"1",disabled:!1}},et2_grid.prototype._getCell=function(_cells,_x,_y){if(0<=_y&&_y<_cells.length){var row=_cells[_y];if(0<=_x&&_x<row.length)return row[_x]}throw"Error while accessing grid cells, invalid element count or span value!"},et2_grid.prototype._forceNumber=function(_val){if(isNaN(_val))throw _val+" is not a number!";return parseInt(_val)},et2_grid.prototype._fetchRowColData=function(columns,rows,colData,rowData){for(var nm=!1,widget=this;!nm&&widget!=this.getRoot();)nm="nextmatch"==widget.getType(),widget=widget.getParent();et2_filteredNodeIterator(columns,(function(node,nodeName){var colDataEntry=this._getColDataEntry();if(colDataEntry.disabled=nm?et2_readAttrWithDefault(node,"disabled",""):this.getArrayMgr("content").parseBoolExpression(et2_readAttrWithDefault(node,"disabled","")),"column"==nodeName)for(var i in colDataEntry.width=et2_readAttrWithDefault(node,"width","auto"),colDataEntry.class=et2_readAttrWithDefault(node,"class",""),colDataEntry.align=et2_readAttrWithDefault(node,"align",""),colDataEntry.span=et2_readAttrWithDefault(node,"span","1"),node.attributes){var attr=node.attributes[i];2==attr.nodeType&&void 0===colDataEntry[attr.nodeName]&&(colDataEntry[attr.nodeName]=attr.value)}else colDataEntry.span="all";colData.push(colDataEntry)}),this),et2_filteredNodeIterator(rows,(function(node,nodeName){var rowDataEntry=this._getRowDataEntry();if(rowDataEntry.disabled=this.getArrayMgr("content").parseBoolExpression(et2_readAttrWithDefault(node,"disabled","")),"row"==nodeName){this.lastRowNode=node,rowDataEntry.height=et2_readAttrWithDefault(node,"height","auto"),rowDataEntry.class=et2_readAttrWithDefault(node,"class",""),rowDataEntry.valign=et2_readAttrWithDefault(node,"valign",""),rowDataEntry.span=et2_readAttrWithDefault(node,"span","1"),rowDataEntry.part=et2_readAttrWithDefault(node,"part","body");var id=et2_readAttrWithDefault(node,"id","");id&&(rowDataEntry.id=id)}else rowDataEntry.span="all";rowData.push(rowDataEntry)}),this);var rowIndex=1/0;if(this.getArrayMgr("content")){var content_1=this.getArrayMgr("content"),rowDataEntry=rowData[rowData.length-1];rowIndex=rowData.length-1;for(var cont=!0,_loop_1=function(){if(content_1.data[rowIndex])rowData[rowIndex]=jQuery.extend({},rowDataEntry),rowIndex++;else{if(null==this_1.lastRowNode)return"break";if(nm=!1)return"break";var currentPerspective=jQuery.extend({},content_1.perspectiveData),check_1=function(node,nodeName){if("box"==nodeName||"hbox"==nodeName||"vbox"==nodeName)return et2_filteredNodeIterator(node,check_1,this);for(var attr in content_1.perspectiveData.row=rowIndex,node.attributes){var value=et2_readAttrWithDefault(node,node.attributes[attr].name,"");if(value.indexOf("@")>0||value.indexOf("$")>0){var ident=content_1.expandName(value);for("@"!=value[0]&&(ident=content_1.getEntry(ident,!1,!0));null!=ident&&rowIndex<1e3;)rowData[rowIndex]=jQuery.extend({},rowDataEntry),content_1.perspectiveData.row=++rowIndex,ident=content_1.expandName(value),"@"!=value[0]&&(ident=content_1.getEntry(ident,!1,!0));return void(rowIndex>=1e3&&egw.debug("error","Problem in autorepeat fallback: too many rows for '%s'.  Use a nextmatch, or start debugging.",value))}}};et2_filteredNodeIterator(this_1.lastRowNode,check_1,this_1),cont=!1,content_1.perspectiveData=currentPerspective}},this_1=this;cont;){if("break"===_loop_1())break}}rowIndex<=rowData.length-1&&(this.lastRowNode=null)},et2_grid.prototype._fillCells=function(cells,columns,rows){var h=cells.length,w=h>0?cells[0].length:0,currentPerspective=jQuery.extend({},this.getArrayMgr("content").perspectiveData),x=0;et2_filteredNodeIterator(columns,(function(node,nodeName){function _readColNode(node,nodeName){if(y>=h)this.egw().debug("warn","Skipped grid cell in column, '"+nodeName+"'");else{var cell=this._getCell(cells,x,y);node.getAttribute("span")?cell.rowSpan=node.getAttribute("span"):(cell.rowSpan=cell.colData.span,cell.autoRowSpan=!0),"all"==cell.rowSpan&&(cell.rowSpan=cells.length);for(var span=cell.rowSpan=this._forceNumber(cell.rowSpan),widget=this.createElementFromNode(node,nodeName),i=0;i<span&&y<cells.length;i++,y++)this._getCell(cells,x,y).widget=widget}}var y=0;"column"==nodeName?et2_filteredNodeIterator(node,_readColNode,this):_readColNode.call(this,node,nodeName),x++}),this);var readRowNode,y=0;x=0;for(var nm=!1,widget=this;!nm&&widget!=this.getRoot();)nm="nextmatch"==widget.getType(),widget=widget.getParent();for(et2_filteredNodeIterator(rows,(function(node,nodeName){if(readRowNode=function(node,nodeName){if(x>=w)"description"!=nodeName&&this.egw().debug("warn","Skipped grid cell in row, '"+nodeName+"'");else{var cell=this._getCell(cells,x,y);node.getAttribute("span")?cell.colSpan=node.getAttribute("span"):(cell.colSpan=cell.rowData.span,cell.autoColSpan=!0),"all"==cell.colSpan&&(cell.colSpan=cells[y].length);var span=cell.colSpan=this._forceNumber(cell.colSpan);if(node.getAttribute("align")&&(cell.align=node.getAttribute("align")),"nextmatch-"==nodeName.substr(0,10)&&(cell.nm_id=node.getAttribute("id")),node.getAttribute("class")&&(cell.class+=(cell.class?" ":"")+node.getAttribute("class")),!cell.disabled||cell.disabled&&"string"==typeof cell.disabled){if(!nm){var mgrs=this.getArrayMgrs();for(var name_1 in mgrs)this.getArrayMgr(name_1).perspectiveData.row=y;this._getCell(cells,x,y).rowData.id&&(this._getCell(cells,x,y).rowData.id=this.getArrayMgr("content").expandName(this._getCell(cells,x,y).rowData.id)),this._getCell(cells,x,y).rowData.class&&(this._getCell(cells,x,y).rowData.class=this.getArrayMgr("content").expandName(this._getCell(cells,x,y).rowData.class))}if(nm||"string"!=typeof cell.disabled||(cell.disabled=this.getArrayMgr("content").parseBoolExpression(cell.disabled)),nm||!cell.disabled)var widget=this.createElementFromNode(node,nodeName)}for(var i=0;i<span&&x<cells[y].length;i++,x++){if(null!=(cell=this._getCell(cells,x,y)).widget)throw"Grid cell collision, two elements defined for cell ("+x+","+y+")!";cell.widget=widget}}},x=0,!this.lastRowNode||node!=this.lastRowNode){if("row"==nodeName){for(var name in this.getArrayMgrs());var cell=this._getCell(cells,x,y);cell.rowData.id&&this.getArrayMgr("content").expandName(cell.rowData.id);var disabled=!1;"1"==node.getAttribute("disabled")&&(disabled=!0),disabled||et2_filteredNodeIterator(node,readRowNode,this)}else readRowNode.call(this,node,nodeName);y++}}),this);y<h;y++)x=0,et2_filteredNodeIterator(this.lastRowNode,readRowNode,this);for(var name in this.getArrayMgrs())this.getArrayMgr(name).perspectiveData=currentPerspective},et2_grid.prototype._expandLastCells=function(_cells){for(var h=_cells.length,w=h>0?_cells[0].length:0,y=0;y<h;y++)for(var x=w-1;x>=0;x--){if(null!=(cell=_cells[y][x]).widget){cell.autoColSpan&&(cell.colSpan=w-x);break}}for(x=0;x<w;x++)for(y=h-1;y>=0;y--){var cell;if(null!=(cell=_cells[y][x]).widget){cell.autoRowSpan&&(cell.rowSpan=h-y);break}}},et2_grid.prototype._createNamespace=function(){return!0},et2_grid.prototype.loadFromXML=function(_node){this.template_node=_node;var rowsElems=et2_directChildrenByTagName(_node,"rows"),columnsElems=et2_directChildrenByTagName(_node,"columns");if(1!=rowsElems.length||1!=columnsElems.length)throw"Error while parsing grid, none or multiple rows or columns tags!";var columns=columnsElems[0],rows=rowsElems[0],colData=[],rowData=[];this._fetchRowColData(columns,rows,colData,rowData);var cells=this._initCells(colData,rowData);this._fillCells(cells,columns,rows),this._expandLastCells(cells),this.createTableFromCells(cells,colData,rowData)},et2_grid.prototype.createTableFromCells=function(_cells,_colData,_rowData){this.managementArray=[],this.cells=_cells,this.colData=_colData,this.rowData=_rowData;for(var h=this.rowCount=_cells.length,w=this.columnCount=h>0?_cells[0].length:0,y=0;y<h;y++){var parent_1=this.tbody;switch(this.rowData[y].part){case"header":this.tbody.children().length||this.tfoot.children().length||(parent_1=this.thead);break;case"footer":this.tbody.children().length||(parent_1=this.tfoot)}var tr=jQuery(document.createElement("tr")).appendTo(parent_1).addClass(this.rowData[y].class);this.rowData[y].disabled&&tr.hide(),"auto"!=this.rowData[y].height&&tr.height(this.rowData[y].height),this.rowData[y].valign&&tr.attr("valign",this.rowData[y].valign),this.rowData[y].id&&tr.attr("id",this.rowData[y].id);for(var x=0;x<w;){var cell=this._getCell(_cells,x,y);if(null==cell.td&&null!=cell.widget){var td=jQuery(document.createElement("td")).appendTo(tr).addClass(cell.class);cell.disabled&&(td.hide(),cell.widget.options.disabled=cell.disabled),"auto"!=cell.width&&td.width(cell.width),cell.align&&td.attr("align",cell.align),this.managementArray.push({cell:td[0],widget:cell.widget,disabled:cell.disabled});var cs=x==w-1?w-x:Math.min(w-x,cell.colSpan),rs=y==h-1?h-y:Math.min(h-y,cell.rowSpan);cs>1&&td.attr("colspan",cs),rs>1&&td.attr("rowspan",rs);for(var sx=x;sx<x+cs;sx++)for(var sy=y;sy<y+rs;sy++)this._getCell(_cells,sx,sy).td=td;x+=cell.colSpan}else x++}}},et2_grid.prototype.getDOMNode=function(_sender){if(_sender==this||void 0===_sender)return null!=this.wrapper?this.wrapper[0]:this.table[0];for(var i=0;i<this.managementArray.length;i++)if(this.managementArray[i].widget==_sender)return this.managementArray[i].cell;return null},et2_grid.prototype.isInTree=function(_sender){var vis=!0;if(void 0!==_sender&&_sender!=this){vis=!1;for(var i=0;i<this.managementArray.length;i++)if(this.managementArray[i].widget==_sender){vis=!("boolean"==typeof this.managementArray[i].disabled?this.managementArray[i].disabled:this.getArrayMgr("content").parseBoolExpression(this.managementArray[i].disabled));break}}return _super.prototype.isInTree.call(this,this,vis)},et2_grid.prototype.set_overflow=function(_value){var wrapper=this.wrapper||this.table.parent('[id$="_grid_wrapper"]');this.overflow=_value,0==wrapper.length&&_value&&"visible"!==_value&&(this.wrapper=wrapper=this.table.wrap('<div id="'+this.id+'_grid_wrapper"></div>').parent(),this.height&&wrapper.css("height",this.height)),wrapper.css("overflow",_value),!wrapper.length||_value&&"visible"!==_value||this.table.unwrap()},et2_grid.prototype.set_value=function(_value){for(var i=0;i<this.managementArray.length;i++){var cell=this.managementArray[i];cell.widget&&cell.widget.destroy()}for(var key in this.managementArray=[],this.thead.empty(),this.tfoot.empty(),this.tbody.empty(),_value)this.getArrayMgr(key).data=_value[key];this.loadFromXML(this.template_node);this.loadingFinished([])},et2_grid.prototype.set_sortable=function(sortable){if(sortable){jQuery("tr",this.tbody).each((function(index){var $this=jQuery(this);$this.hasClass("th")||$this.attr("id")||$this.attr("id",index)}));var self=this;this.tbody.sortable({items:"tr:not(.th)",distance:15,cancel:this.options.sortable_cancel,placeholder:this.options.sortable_placeholder,containment:this.options.sortable_containment,connectWith:this.options.sortable_connectWith,update:function(event,ui){self.egw().json(sortable,[self.tbody.sortable("toArray"),self.id],null,self,!0).sendRequest()},receive:function(event,ui){"function"==typeof self.options.sortable_recieveCallback&&self.options.sortable_recieveCallback.call(self,event,ui)},start:function(event,ui){"function"==typeof self.options.sortable_startCallback&&self.options.sortable_startCallback.call(self,event,ui)}})}else this.tbody.sortable("destroy")},et2_grid.prototype._link_actions=function(actions){var objectManager=window.egw_getAppObjectManager(!0),widget_object=(objectManager=objectManager.getObjectById(this.getInstanceManager().uniqueId,2)||objectManager).getObjectById(this.id);null==widget_object&&(widget_object=objectManager.insertObject(!1,new egwActionObject(this.id,objectManager,new et2_core_DOMWidget_1.et2_action_object_impl(this).getAOI(),this._actionManager||objectManager.manager.getActionById(this.id)||objectManager.manager))),widget_object.clear();for(var action_links=this._get_action_links(actions),i=0,r=0;i<this.rowData.length;i++)if("body"==this.rowData[i].part){var content=this.getArrayMgr("content").getEntry(i);if(content){var row=jQuery("tr",this.tbody)[r],aoi=new et2_core_DOMWidget_1.et2_action_object_impl(this,row).getAOI(),obj=widget_object.addObject(content.id||"row_"+r,aoi);obj.data=content,obj.updateActionLinks(action_links)}r++}},et2_grid.prototype.getDetachedAttributes=function(_attrs){},et2_grid.prototype.getDetachedNodes=function(){return[this.getDOMNode()]},et2_grid.prototype.setDetachedAttributes=function(_nodes,_values){},et2_grid.prototype._getColumnName=function(){for(var ids=[],r=0;r<this.cells.length;++r)for(var cols=this.cells[r],c=0;c<cols.length;++c)cols[c].nm_id&&ids.push(cols[c].nm_id);return ids.join("_")},et2_grid.prototype.resize=function(_height){void 0!==this.options&&_height&&void 0!==this.options.resize_ratio&&this.options.resize_ratio&&0!=(_height=""!=this.options.resize_ratio?_height*this.options.resize_ratio:_height)&&(this.wrapper?this.wrapper.height(this.wrapper.height()+_height):this.table.height(this.table.height()+_height))},et2_grid.prototype.getRow=function(_sender){if(_sender&&this.cells)for(var r=0;r<this.cells.length;++r)for(var row=this.cells[r],_loop_2=function(){if(!row[c].widget)return"continue";var found=row[c].widget===_sender;if(found||row[c].widget.iterateOver((function(_widget){_widget===_sender&&(found=!0)})),found){for(var row_obj_1=new et2_core_widget_1.et2_widget(this_2,{}),c=0;c<row.length;++c)row[c].widget&&row_obj_1.addChild(row[c].widget);return row_obj_1.isInTree=jQuery.proxy(this_2.isInTree,this_2),row_obj_1.destroy=function(){delete row_obj_1._children},{value:row_obj_1}}},this_2=this,c=0;c<row.length;++c){var state_2=_loop_2();if("object"==typeof state_2)return state_2.value}},et2_grid.prototype.get_align=function(){return""},et2_grid._attributes={border:{ignore:!0},align:{name:"Align",type:"string",default:"left",description:"Position of this element in the parent hbox"},spacing:{ignore:!0},padding:{ignore:!0},sortable:{name:"Sortable callback",type:"string",default:et2_no_init,description:"PHP function called when user sorts the grid.  Setting this enables sorting the grid rows.  The callback will be passed the ID of the grid and the new order of the rows."},sortable_containment:{name:"Sortable bounding area",type:"string",default:"",description:"Defines bounding area for sortable items"},sortable_connectWith:{name:"Sortable connectWith element",type:"string",default:"",description:"Defines other sortable areas that should be connected to sort list"},sortable_placeholder:{name:"Sortable placeholder",type:"string",default:"",description:"Defines sortable placeholder"},sortable_cancel:{name:"Sortable cancel class",type:"string",default:"",description:"Defines sortable cancel which prevents sorting the matching element"},sortable_recieveCallback:{name:"Sortable receive callback",type:"js",default:et2_no_init,description:"Defines sortable receive callback function"},sortable_startCallback:{name:"Sortable start callback",type:"js",default:et2_no_init,description:"Defines sortable start callback function"}},et2_grid}(et2_core_DOMWidget_1.et2_DOMWidget);exports.et2_grid=et2_grid,et2_core_widget_1.et2_register_widget(et2_grid,["grid"]);
/**
 * EGroupware eTemplate2 - JS Widget base class
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0}),require("./et2_core_interfaces"),require("./et2_core_common");et2_core_DOMWidget_1=require("./et2_core_DOMWidget"),et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget");var et2_baseWidget=function(_super){function et2_baseWidget(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_baseWidget._attributes,_child||{}))||this;return _this.align="left",_this.node=null,_this.statustext="",_this._messageDiv=null,_this._tooltipElem=null,_this}return __extends(et2_baseWidget,_super),et2_baseWidget.prototype.destroy=function(){_super.prototype.destroy.call(this),this.node=null,this._messageDiv=null},et2_baseWidget.prototype.showMessage=function(_text,_type,_floating,_prepend){void 0===_type&&(_type="hint"),void 0===_floating&&(_floating=!0),void 0===_prepend&&(_prepend=!1);var surr=this.getSurroundings();this.hideMessage(!1,!0),this._messageDiv=jQuery(document.createElement("div")).addClass("message").addClass(_type).addClass(_floating?"floating":"").text(_text.valueOf()+""),_prepend?surr.prependDOMNode(this._messageDiv[0]):surr.appendDOMNode(this._messageDiv[0]),surr.update()},et2_baseWidget.prototype.hideMessage=function(_fade,_noUpdate){if(void 0===_fade&&(_fade=!0),void 0===_noUpdate&&(_noUpdate=!1),null!=this._messageDiv){var surr=this.getSurroundings(),messageDiv=this._messageDiv;this._messageDiv=null;var _done=function(){surr.removeDOMNode(messageDiv[0]),_noUpdate||surr.update()};_fade?messageDiv.fadeOut("fast",_done):_done()}},et2_baseWidget.prototype.detachFromDOM=function(){return this._tooltipElem&&(this.egw().tooltipUnbind(this._tooltipElem),this._tooltipElem=null),this.node&&jQuery(this.node).unbind("click.et2_baseWidget"),_super.prototype.detachFromDOM.call(this)},et2_baseWidget.prototype.attachToDOM=function(){var ret=_super.prototype.attachToDOM.call(this);return this.node&&(jQuery(this.node).bind("click.et2_baseWidget",this,(function(e){return e.data.click.call(e.data,e,this)})),"function"==typeof this.onclick&&jQuery(this.node).addClass("et2_clickable")),this.set_statustext(this.statustext),ret},et2_baseWidget.prototype.setDOMNode=function(_node){return _node!=this.node&&(this.detachFromDOM(),this.node=_node,this.attachToDOM())},et2_baseWidget.prototype.getDOMNode=function(_sender){return this.node},et2_baseWidget.prototype.getTooltipElement=function(){return this.getDOMNode(this)},et2_baseWidget.prototype.click=function(_ev){if("function"==typeof this.onclick){var args=Array.prototype.slice.call(arguments);return-1==args.indexOf(this)&&args.splice(1,0,this),this.onclick.apply(this,args)}return!0},et2_baseWidget.prototype.set_statustext=function(_value){if(!egwIsMobile()&&(""!=_value||this._tooltipElem)){if(-1!==_value.indexOf("{")){var egw=this.egw();_value=_value.replace(/{([^}]+)}/g,(function(str,p1){return egw.lang(p1)}))}this.statustext=_value;var elem=jQuery(this.getTooltipElement());elem&&(this._tooltipElem&&(this.egw().tooltipUnbind(this._tooltipElem),this._tooltipElem=null),_value&&""!=_value&&(this.egw().tooltipBind(elem,_value,this.options.statustext_html),this._tooltipElem=elem))}},et2_baseWidget.prototype.set_align=function(_value){this.align=_value},et2_baseWidget.prototype.get_align=function(){return this.align},et2_baseWidget._attributes={statustext:{name:"Tooltip",type:"string",description:"Tooltip which is shown for this element",translate:!0},statustext_html:{name:"Tooltip is html",type:"boolean",description:"Flag to allow html content in tooltip",default:!1},align:{name:"Align",type:"string",default:"left",description:"Position of this element in the parent hbox"},onclick:{name:"onclick",type:"js",default:et2_no_init,description:"JS code which is executed when the element is clicked."}},et2_baseWidget}(et2_core_DOMWidget_1.et2_DOMWidget);exports.et2_baseWidget=et2_baseWidget;var et2_container=function(_super){function et2_container(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_container._attributes,_child||{}))||this;return _this.setDOMNode(document.createElement("div")),_this}return __extends(et2_container,_super),et2_container.prototype.destroy=function(){for(var i=this._children.length-1;i>=0;i--)this._children[i].destroy();for(var key in this._mgrs)this._mgrs[key]&&this._mgrs[key].owner==this&&this._mgrs[key].destroy()},et2_container.prototype.getDOMWidgetById=function(_id){var widget=this.getWidgetById(_id);return widget&&widget.instanceOf(et2_core_DOMWidget_1.et2_DOMWidget)?widget:null},et2_container.prototype.getInputWidgetById=function(_id){var widget=this.getWidgetById(_id);return widget&&widget.instanceOf(et2_valueWidget)?widget:null},et2_container.prototype.setValueById=function(id,value){var widget=this.getWidgetById(id);if(!widget)throw"Could not find widget "+id;if("function"!=typeof widget.set_value)throw"Widget "+id+" does not have a set_value() function";return widget.set_value(value)},et2_container.prototype.getValueById=function(id){var widget=this.getWidgetById(id);if(!widget)throw"Could not find widget "+id;if("function"!=typeof widget.get_value)throw"Widget "+id+" does not have a get_value() function";return widget.get_value()},et2_container.prototype.setDisabledById=function(id,value){var widget=this.getWidgetById(id);if(!widget)throw"Could not find widget "+id;if("function"!=typeof widget.set_disabled)throw"Widget "+id+" does not have a set_disabled() function";return widget.set_disabled(value)},et2_container}(et2_baseWidget);exports.et2_container=et2_container,et2_core_widget_1.et2_register_widget(et2_container,[]);var et2_placeholder=function(_super){function et2_placeholder(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_placeholder._attributes,_child||{}))||this;_this.visible=!1,_this.attrNodes={},_this.placeDiv=jQuery(document.createElement("span")).addClass("et2_placeholder");var headerNode=jQuery(document.createElement("span")).text(_this.getType()||"").addClass("et2_caption").appendTo(_this.placeDiv),attrsCntr=jQuery(document.createElement("span")).appendTo(_this.placeDiv).hide();for(var key in headerNode.click(_this,(function(e){e.data.visible=!e.data.visible,e.data.visible?attrsCntr.show():attrsCntr.hide()})),_this.options)void 0!==_this.options[key]&&(void 0===_this.attrNodes[key]&&(_this.attrNodes[key]=jQuery(document.createElement("span")).addClass("et2_attr"),attrsCntr.append(_this.attrNodes[key])),_this.attrNodes[key].text(key+"="+_this.options[key]));return _this.setDOMNode(_this.placeDiv[0]),_this}return __extends(et2_placeholder,_super),et2_placeholder.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value")},et2_placeholder.prototype.getDetachedNodes=function(){return[this.placeDiv[0]]},et2_placeholder.prototype.setDetachedAttributes=function(_nodes,_values){this.placeDiv=jQuery(_nodes[0])},et2_placeholder}(et2_baseWidget);et2_core_widget_1.et2_register_widget(et2_placeholder,[]);
/**
 * EGroupware eTemplate2 - JS Box object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget");var et2_box=function(_super){function et2_box(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,_child)||this;return _this.div=jQuery(document.createElement("div")).addClass("et2_"+_this.getType()).addClass("et2_box_widget"),_this.setDOMNode(_this.div[0]),_this}return __extends(et2_box,_super),et2_box.prototype._createNamespace=function(){return!0},et2_box.prototype.loadFromXML=function(_node){if("box"!=this.getType())return _super.prototype.loadFromXML.call(this,_node);for(var childIndex=0,repeatNode=null,i=0;i<_node.childNodes.length;i++){var node=_node.childNodes[i],widgetType=node.nodeName.toLowerCase();if("#comment"!=widgetType)if("#text"!=widgetType)et2_readAttrWithDefault(node,"id","").indexOf("$")<0||"box"!=widgetType?(this.createElementFromNode(node),childIndex++):repeatNode=node;else node.data.replace(/^\s+|\s+$/g,"")&&this.loadContent(node.data)}if(null!=repeatNode){for(var currentPerspective=this.getArrayMgr("content").perspectiveData;void 0!==this.getArrayMgr("content").data[childIndex]&&this.getArrayMgr("content").data[childIndex];childIndex++){var mgrs=this.getArrayMgrs();for(var name in mgrs)this.getArrayMgr(name).getEntry(childIndex)&&this.getArrayMgr(name).setRow(childIndex);this.createElementFromNode(repeatNode)}for(var name in this.getArrayMgrs())this.getArrayMgr(name).setPerspectiveData(currentPerspective)}},et2_box.prototype.getDetachedAttributes=function(_attrs){_attrs.push("data")},et2_box.prototype.getDetachedNodes=function(){return[this.getDOMNode()]},et2_box.prototype.setDetachedAttributes=function(_nodes,_values){if(_values.data)for(var pairs=_values.data.split(/,/g),i=0;i<pairs.length;++i){var name_value=pairs[i].split(":");jQuery(_nodes[0]).attr("data-"+name_value[0],name_value[1])}},et2_box._attributes={rows:{ignore:!0},cols:{ignore:!0}},et2_box}((et2_core_baseWidget_1=require("./et2_core_baseWidget")).et2_baseWidget);exports.et2_box=et2_box,et2_core_widget_1.et2_register_widget(et2_box,["vbox","box"]);var et2_details=function(_super){function et2_details(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,_child)||this;return _this.div=jQuery(document.createElement("div")).addClass("et2_details"),_this.title=jQuery(document.createElement("span")).addClass("et2_label et2_details_title").appendTo(_this.div),_this.span=jQuery(document.createElement("span")).addClass("et2_details_toggle").appendTo(_this.div),_this.wrapper=jQuery(document.createElement("div")).addClass("et2_details_wrapper").appendTo(_this.div),_this._createWidget(),_this}return __extends(et2_details,_super),et2_details.prototype._toggle=function(){this.div.toggleClass("et2_details_expanded")},et2_details.prototype._createWidget=function(){var self=this;this.span.on("click",(function(e){self._toggle()})),this.options.title&&this.title.click((function(){self._toggle()})).text(this.options.title),"left"===this.options.toggle_align&&this.span.css({float:"left"})},et2_details.prototype.getDOMNode=function(_sender){return _sender&&_sender!==this?this.wrapper[0]:this.div[0]},et2_details._attributes={toggle_align:{name:"Toggle button alignment",description:" Defines where to align the toggle button, default is right alignment",type:"string",default:"right"},title:{name:"title",description:"Set a header title for box and shows it next to toggle button, default is no title",type:"string",default:"",translate:!0}},et2_details}(et2_box);exports.et2_details=et2_details,et2_core_widget_1.et2_register_widget(et2_details,["details"]);
/**
 * EGroupware eTemplate2 - JS HBox object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget");var et2_hbox=function(_super){function et2_hbox(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_hbox._attributes,_child||{}))||this;return _this.alignData={hasAlign:!1,hasLeft:!1,hasCenter:!1,hasRight:!1,lastAlign:"left"},_this.leftDiv=null,_this.rightDiv=null,_this.div=null,_this.leftDiv=null,_this.rightDiv=null,_this.div=jQuery(document.createElement("div")).addClass("et2_"+_super.prototype.getType.call(_this)).addClass("et2_box_widget"),_super.prototype.setDOMNode.call(_this,_this.div[0]),_this}return __extends(et2_hbox,_super),et2_hbox.prototype._createNamespace=function(){return!0},et2_hbox.prototype._buildAlignCells=function(){this.alignData.hasAlign&&(this.alignData.hasLeft&&this.alignData.hasRight||this.alignData.hasLeft&&this.alignData.hasCenter||this.alignData.hasCenter&&this.alignData.hasRight?(this.alignData.hasRight&&(this.rightDiv=jQuery(document.createElement("div")).addClass("et2_hbox_right").appendTo(this.div)),this.alignData.hasCenter&&(this.leftDiv=jQuery(document.createElement("div")).addClass("et2_hbox_left").appendTo(this.div),this.div.addClass("et2_hbox_al_center"))):"left"!=this.alignData.lastAlign&&this.div.addClass("et2_hbox_al_"+this.alignData.lastAlign))},et2_hbox.prototype.loadFromXML=function(_node){et2_filteredNodeIterator(_node,(function(_node){var align=_node.getAttribute("align");switch(align||(align="left"),"left"!=align&&(this.alignData.hasAlign=!0),this.alignData.lastAlign=align,align){case"left":this.alignData.hasLeft=!0;break;case"right":this.alignData.hasRight=!0;break;case"center":this.alignData.hasCenter=!0}}),this),this._buildAlignCells(),_super.prototype.loadFromXML.call(this,_node)},et2_hbox.prototype.assign=function(_obj){this.alignData=et2_cloneObject(_obj.alignData),this._buildAlignCells(),_super.prototype.assign.call(this,_obj)},et2_hbox.prototype.getDOMNode=function(_sender){if(_sender!=this&&this.alignData.hasAlign){var align=_sender.implements(et2_IAligned)?_sender.get_align():"left";if("left"==align&&null!=this.leftDiv)return this.leftDiv[0];if("right"==align&&null!=this.rightDiv)return this.rightDiv[0]}return _super.prototype.getDOMNode.call(this,_sender)},et2_hbox.prototype.addChild=function(child){_super.prototype.addChild.call(this,child),(child.instanceOf&&child.instanceOf(et2_grid)&&this.isAttached()||"et2_grid"==child._type&&this.isAttached())&&jQuery(child.getDOMNode(child)).css("display","inline-table")},et2_hbox}((et2_core_baseWidget_1=require("./et2_core_baseWidget")).et2_baseWidget);et2_core_widget_1.et2_register_widget(et2_hbox,["hbox"]);
/**
 * EGroupware eTemplate2 - JS Groupbox object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2012
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget");var et2_core_baseWidget_1=require("./et2_core_baseWidget"),et2_groupbox=(et2_core_inheritance_1=require("./et2_core_inheritance"),function(_super){function et2_groupbox(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_groupbox._attributes,_child||{}))||this;return _this.setDOMNode(document.createElement("fieldset")),_this}return __extends(et2_groupbox,_super),et2_groupbox}(et2_core_baseWidget_1.et2_baseWidget));et2_core_widget_1.et2_register_widget(et2_groupbox,["groupbox"]);var et2_groupbox_legend=function(_super){function et2_groupbox_legend(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_groupbox_legend._attributes,_child||{}))||this,legend=jQuery(document.createElement("legend")).text(_this.options.label);return _this.setDOMNode(legend[0]),_this}return __extends(et2_groupbox_legend,_super),et2_groupbox_legend._attributes={label:{name:"Label",type:"string",default:"",description:"Label for group box",translate:!0}},et2_groupbox_legend}(et2_core_baseWidget_1.et2_baseWidget);et2_core_widget_1.et2_register_widget(et2_groupbox_legend,["caption"]),function($){var splitterCounter=0;$.fn.splitter=function(args){return args=args||{},this.each((function(){if(!$(this).is(".splitter")){var zombie,vh=(args.splitHorizontal?"h":args.splitVertical?"v":args.type)||"v",opts=$.extend({splitterClass:"splitter ui-widget ui-widget-content",paneClass:"splitter-pane",barClass:"splitter-bar",barNormalClass:"ui-state-default",barHoverClass:"ui-state-hover",barActiveClass:"ui-state-highlight",barLimitClass:"ui-state-error",iframeClass:"splitter-iframe-hide",eventNamespace:".splitter"+ ++splitterCounter,pxPerKey:8,tabIndex:0,accessKey:""},{v:{keyLeft:39,keyRight:37,cursor:"e-resize",barStateClass:"splitter-bar-vertical",barDockedClass:"splitter-bar-vertical-docked"},h:{keyTop:40,keyBottom:38,cursor:"n-resize",barStateClass:"splitter-bar-horizontal",barDockedClass:"splitter-bar-horizontal-docked"}}[vh],args,{v:{type:"v",eventPos:"pageX",origin:"left",split:"width",pxSplit:"offsetWidth",side1:"Left",side2:"Right",fixed:"height",pxFixed:"offsetHeight",side3:"Top",side4:"Bottom"},h:{type:"h",eventPos:"pageY",origin:"top",split:"height",pxSplit:"offsetHeight",side1:"Top",side2:"Bottom",fixed:"width",pxFixed:"offsetWidth",side3:"Left",side4:"Right"}}[vh]);opts.barStateClasses=[opts.barNormalClass,opts.barHoverClass,opts.barActiveClass,opts.barLimitClass].join(" ");var splitter=$(this).css({position:"relative"}).addClass(opts.splitterClass),panes=$(">*",splitter[0]).addClass(opts.paneClass).css({position:"absolute","z-index":"1","-moz-outline-style":"none"}),A=$(panes[0]),B=$(panes[1]);opts.dockPane=opts.dock&&(/right|bottom/.test(opts.dock)?B:A);var focuser=$('<a href="javascript:void(0)"></a>').attr({accessKey:opts.accessKey,tabIndex:opts.tabIndex,title:opts.splitbarClass}).bind("focus"+opts.eventNamespace,(function(){this.focus(),bar.addClass(opts.barActiveClass)})).bind("keydown"+opts.eventNamespace,(function(e){var key=e.which||e.keyCode,dir=key==opts["key"+opts.side1]?1:key==opts["key"+opts.side2]?-1:0;dir&&resplit(A[0][opts.pxSplit]+dir*opts.pxPerKey)})).bind("blur"+opts.eventNamespace,(function(){bar.removeClass(opts.barActiveClass)})),bar=$("<div></div>").insertAfter(A).addClass(opts.barClass).addClass(opts.barStateClass).append(focuser).attr({unselectable:"on"}).css({position:"absolute","user-select":"none","-webkit-user-select":"none","-khtml-user-select":"none","-moz-user-select":"none","z-index":"100"}).bind("mousedown"+opts.eventNamespace,(function(evt){1==evt.which&&(bar.removeClass(opts.barHoverClass),opts.outline&&(zombie=zombie||bar.clone(!1).insertAfter(A),bar.removeClass(opts.barDockedClass)),setBarState(opts.barActiveClass),panes.css("-webkit-user-select","none").find("iframe").andSelf().filter("iframe").addClass(opts.iframeClass),A._posSplit=A[0][opts.pxSplit]-evt[opts.eventPos],$(document).bind("mousemove"+opts.eventNamespace,doSplitMouse).bind("mouseup"+opts.eventNamespace,endSplitMouse))})).bind("mouseover"+opts.eventNamespace,(function(){$(this).addClass(opts.barHoverClass)})).bind("mouseout"+opts.eventNamespace,(function(){$(this).removeClass(opts.barHoverClass)}));/^(auto|default|)$/.test(bar.css("cursor"))&&bar.css("cursor",opts.cursor),bar._DA=bar[0][opts.pxSplit],splitter._PBF=dimSum(splitter,"border"+opts.side3+"Width","border"+opts.side4+"Width"),splitter._PBA=dimSum(splitter,"border"+opts.side1+"Width","border"+opts.side2+"Width"),A._pane=opts.side1,B._pane=opts.side2,$.each([A,B],(function(){this._splitter_style=this.style,this._min=opts["min"+this._pane]||dimSum(this,"min-"+opts.split),this._max=opts["max"+this._pane]||dimSum(this,"max-"+opts.split)||9999,this._init=!0===opts["size"+this._pane]?parseInt($.curCSS(this[0],opts.split),10):opts["size"+this._pane]}));var initPos=A._init;isNaN(B._init)||(initPos=splitter[0][opts.pxSplit]-splitter._PBA-B._init-bar._DA),opts.cookie&&($.cookie||alert("jQuery.splitter(): jQuery cookie plugin required"),initPos=parseInt($.cookie(opts.cookie),10),$(window).bind("unload"+opts.eventNamespace,(function(){var state=String(bar.css(opts.origin));$.cookie(opts.cookie,state,{expires:opts.cookieExpires||365,path:opts.cookiePath||document.location.pathname})}))),isNaN(initPos)&&(initPos=Math.round((splitter[0][opts.pxSplit]-splitter._PBA-bar._DA)/2)),opts.anchorToWindow&&(opts.resizeTo=window),opts.resizeTo?(splitter._hadjust=dimSum(splitter,"borderTopWidth","borderBottomWidth","marginBottom"),splitter._hmin=Math.max(dimSum(splitter,"minHeight"),20),$(window).bind("resize"+opts.eventNamespace,(function(){var top=splitter.offset().top,eh=$(opts.resizeTo).height();splitter.css("height",Math.max(eh-top-splitter._hadjust,splitter._hmin)+"px"),splitter.trigger("resize")})).trigger("resize"+opts.eventNamespace)):opts.resizeToWidth&&$(window).bind("resize"+opts.eventNamespace,(function(){splitter.trigger("resize")})),opts.dock&&(splitter.bind("toggleDock"+opts.eventNamespace,(function(){var pw=opts.dockPane[0][opts.pxSplit];splitter.trigger(pw?"dock":"undock")})).bind("dock"+opts.eventNamespace,(function(){var pw=A[0][opts.pxSplit];if(pw&&!bar.hasClass("splitter-bar-horizontal-docked")&&!bar.hasClass("splitter-bar-vertical-docked")){bar._pos=pw;var x={};x[opts.origin]=opts.dockPane==A?0:splitter[0][opts.pxSplit]-splitter._PBA-bar[0][opts.pxSplit],bar.animate(x,opts.dockSpeed||1,opts.dockEasing,(function(){bar.addClass(opts.barDockedClass),resplit(x[opts.origin]+1)}))}})).bind("undock"+opts.eventNamespace,(function(){if(!opts.dockPane[0][opts.pxSplit]){(null==bar._pos||Math.abs(bar._pos-splitter._DA-bar._DA)<20)&&(bar._pos=splitter._DA/2);var x={};x[opts.origin]=bar._pos+"px",bar.removeClass(opts.barDockedClass).animate(x,opts.undockSpeed||opts.dockSpeed||1,opts.undockEasing||opts.dockEasing,(function(){resplit(bar._pos),bar._pos=null}))}})),opts.dockKey&&$('<a title="'+opts.splitbarClass+' toggle dock" href="javascript:void(0)"></a>').attr({accessKey:opts.dockKey,tabIndex:-1}).appendTo(bar).bind("focus",(function(){splitter.trigger("toggleDock"),this.blur()})),bar.bind("dblclick",(function(){splitter.trigger("toggleDock")}))),splitter.bind("destroy"+opts.eventNamespace,(function(){$([window,document]).unbind(opts.eventNamespace),bar.unbind().remove(),panes.removeClass(opts.paneClass),splitter.removeClass(opts.splitterClass).add(panes).unbind(opts.eventNamespace).attr("style",(function(el){return this._splitter_style||""})),splitter=bar=focuser=panes=A=B=opts=args=null})).bind("resize"+opts.eventNamespace,(function(e,size){e.target==this&&(splitter._DF=splitter[0][opts.pxFixed]-splitter._PBF,splitter._DA=splitter[0][opts.pxSplit]-splitter._PBA,splitter._DF<=0||splitter._DA<=0||(resplit(isNaN(size)?opts.sizeRight||opts.sizeBottom?splitter._DA-B[0][opts.pxSplit]-bar._DA:A[0][opts.pxSplit]:size),setBarState(opts.barNormalClass)))})).trigger("resize",[initPos])}function setBarState(state){bar.removeClass(opts.barStateClasses).addClass(state)}function doSplitMouse(evt){var pos=A._posSplit+evt[opts.eventPos],range=Math.max(0,Math.min(pos,splitter._DA-bar._DA)),limit=Math.max(A._min,splitter._DA-B._max,Math.min(pos,A._max,splitter._DA-bar._DA-B._min));opts.outline?(opts.dockPane==A&&pos<Math.max(A._min,bar._DA)||opts.dockPane==B&&pos>Math.min(pos,A._max,splitter._DA-bar._DA-B._min)?bar.addClass(opts.barDockedClass).css(opts.origin,range):bar.removeClass(opts.barDockedClass).css(opts.origin,limit),bar._DA=bar[0][opts.pxSplit]):resplit(pos),setBarState(pos==limit?opts.barActiveClass:opts.barLimitClass)}function endSplitMouse(evt){setBarState(opts.barNormalClass),bar.addClass(opts.barHoverClass);var pos=A._posSplit+evt[opts.eventPos];opts.outline&&(zombie.remove(),zombie=null,resplit(pos)),panes.css("-webkit-user-select","text").find("iframe").andSelf().filter("iframe").removeClass(opts.iframeClass),$(document).unbind("mousemove"+opts.eventNamespace+" mouseup"+opts.eventNamespace)}function resplit(pos){bar._DA=bar[0][opts.pxSplit],opts.dockPane==A&&pos<Math.max(A._min,bar._DA)||opts.dockPane==B&&pos>Math.min(pos,A._max,splitter._DA-bar._DA-B._min)?(bar.addClass(opts.barDockedClass),bar._DA=bar[0][opts.pxSplit],pos=opts.dockPane==A?0:splitter._DA-bar._DA,null==bar._pos&&(bar._pos=A[0][opts.pxSplit])):(bar.removeClass(opts.barDockedClass),bar._DA=bar[0][opts.pxSplit],bar._pos=null,pos=Math.max(A._min,splitter._DA-B._max,Math.min(pos,A._max,splitter._DA-bar._DA-B._min))),bar.css(opts.origin,pos).css(opts.fixed,splitter._DF),A.css(opts.origin,0).css(opts.split,pos).css(opts.fixed,splitter._DF),B.css(opts.origin,pos+bar._DA).css(opts.split,splitter._DA-bar._DA-pos).css(opts.fixed,splitter._DF),panes.trigger("resize"+opts.eventNamespace)}function dimSum(jq,dims){for(var sum=0,i=1;i<arguments.length;i++)sum+=Math.max(parseInt(jq.css(arguments[i]),10)||0,0);return sum}}))}}(jQuery);
/**
* EGroupware eTemplate2 - Split panel
*
* @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
* @package etemplate
* @subpackage api
* @link http://www.egroupware.org
* @author Nathan Gray
* @copyright Nathan Gray 2013
* @version $Id$
*/
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_DOMWidget_1=require("./et2_core_DOMWidget"),et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_split=function(_super){function et2_split(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_split._attributes,_child||{}))||this;return _this.div=null,_this.dynheight=null,_this.div=jQuery(document.createElement("div")).addClass("et2_split"),_this.dynheight=new et2_dynheight(_this.getParent().getDOMNode()||_this.getInstanceManager().DOMContainer,_this.div,100),_this.left=jQuery("<div>Top / Left</div>").appendTo(_this.div),_this.right=jQuery("<div>Bottom / Right</div>").appendTo(_this.div),_this.loading=jQuery.Deferred(),_this.stop_resize=!1,_this}return __extends(et2_split,_super),et2_split.prototype.destroy=function(){this.left.next().off("mouseup"),this.div.trigger("destroy"),this.dynheight.destroy(),_super.prototype.destroy.call(this),0==this._children.length&&this.div.empty(),this.div.remove()},et2_split.prototype.loadFromXML=function(_node){_super.prototype.loadFromXML.call(this,_node),this._children.length>0&&(this._children[0]&&(this.left.detach(),this.left=jQuery(this._children[0].getDOMNode(this._children[0])).appendTo(this.div)),this._children[1]&&(this.right.detach(),this.right=jQuery(this._children[1].getDOMNode(this._children[1])).appendTo(this.div)));for(var i=0;i<this._children.length;i++)this._children[i].dynheight&&(this._children[i].dynheight.outerNode=0==i?this.left:this.right,this._children[i].dynheight.initialized=!1)},et2_split.prototype.doLoadingFinished=function(){_super.prototype.doLoadingFinished.call(this);var self=this;return window.setTimeout((function(){self._init_splitter()}),1),this.loading.promise()},et2_split.prototype._init_splitter=function(){if(this.isAttached()&&this.div.is(":visible")){var options={type:this.orientation,dock:this.dock_side,splitterClass:"et2_split",outline:!0,eventNamespace:".et2_split."+this.id,sizeTop:this.dynheight.outerNode.height()/2,sizeLeft:this.dynheight.outerNode.width()/2},widget=this,pix2per=function(_size){return("v"==widget.orientation?100*_size/widget.dynheight.outerNode.width():100*_size/widget.dynheight.outerNode.height()).toFixed(2)+"%"};if(this.id){var pref=this.egw().preference("splitter-size-"+this.id,this.egw().getAppName());pref&&("v"==this.orientation&&pref.sizeLeft<this.dynheight.outerNode.width()||"h"==this.orientation&&pref.sizeTop<this.dynheight.outerNode.height())&&(options=jQuery.extend(options,pref),this.prefSize=pref["v"==this.orientation?"sizeLeft":"sizeTop"]),void 0!==this.prefSize&&this.prefSize||(this.prefSize="v"==this.orientation?options.sizeLeft:options.sizeTop)}this.div.hasClass(options.splitterClass)&&this.div.trigger("destroy"),this.div.splitter(options),this.div.trigger("resize",[options.sizeTop||options.sizeLeft||0]),options.dock&&("bottomDock"==options.dock&&Math.abs(options.sizeTop-this.div.height())<et2_split.DOCK_TOLERANCE||"topDock"==options.dock&&0==options.sizeTop||!this.div.is(":visible"))&&this.dock();var icon="ui-icon-grip-"+(this.dock_side?"solid":"dotted")+"-"+("h"==this.orientation?"horizontal":"vertical");if(jQuery(document.createElement("div")).addClass("ui-icon").addClass(icon).appendTo(this.left.next()),this.id&&this.egw().getAppName()){var self_1=this;this.left.on("resize"+options.eventNamespace,(function(e){var display=this.style.display;if(this.style.display="none",this.offsetHeight,this.style.display=display,e.namespace==options.eventNamespace.substr(1)&&!self_1.isDocked()){var size="v"==self_1.orientation?{sizeLeft:self_1.left.width()}:{sizeTop:self_1.left.height()};self_1.prefSize=size["v"==self_1.orientation?"sizeLeft":"sizeTop"];var prefInPercent="v"==self_1.orientation?{sizeLeft:pix2per(size.sizeLeft)}:{sizeTop:pix2per(size.sizeTop)};parseInt("v"==self_1.orientation?prefInPercent.sizeLeft:prefInPercent.sizeTop)<100&&self_1.egw().set_preference(self_1.egw().getAppName(),"splitter-size-"+self_1.id,prefInPercent)}self_1.iterateOver((function(widget){window.setTimeout(jQuery.proxy((function(){this.resize()}),widget),200)}),self_1,et2_IResizeable)}))}this.loading.resolve()}},et2_split.prototype.resize=function(){if(this.div.children().length<=2&&this._init_splitter(),this.dynheight&&!this.stop_resize){var old_1={w:this.div.width(),h:this.div.height()};this.dynheight.update((function(w,h){"v"==this.orientation&&(this.left.height(h),this.right.height(h),(this.left.width()+this.right.width()+this.div.find(".splitter-bar").outerWidth()<this.div.width()||this.left.width()+this.right.width()-this.div.find(".splitter-bar").outerWidth()>this.div.width())&&this.div.trigger("resize.et2_split."+this.id,this.prefSize)),"h"==this.orientation&&(this.left.width(w),this.right.width(w),this.isDocked()&&("topDock"==this.dock_side?(this.right.height(h),this.left.height(0)):(this.left.height(h),this.right.height(0)))),w==old_1.w&&h==old_1.h||this.div.trigger("resize.et2_split."+this.id,this.prefSize)}),this)}},et2_split.prototype.getDOMNode=function(){return this.div[0]},et2_split.prototype.set_orientation=function(orient){this.orientation=orient,this._init_splitter()},et2_split.prototype.set_dock_side=function(dock){this.dock_side=dock,this._init_splitter()},et2_split.prototype.set_outline=function(outline){this.outline=outline,this._init_splitter()},et2_split.prototype.dock=function(){this.isDocked()||this.div.trigger("dock")},et2_split.prototype.undock=function(){this.div.trigger("undock")},et2_split.prototype.isDocked=function(){var bar=jQuery(".splitter-bar",this.div);return bar.hasClass("splitter-bar-horizontal-docked")||bar.hasClass("splitter-bar-vertical-docked")},et2_split.prototype.toggleDock=function(){this.div.trigger("toggleDock")},et2_split.prototype.beforePrint=function(){this.stop_resize=!0,this.div.addClass("print")},et2_split.prototype.afterPrint=function(){this.div.removeClass("print"),this.stop_resize=!1},et2_split._attributes={orientation:{name:"Orientation",description:"Horizontal or vertical (v or h)",default:"v",type:"string"},outline:{name:"Outline",description:"Use a 'ghosted' copy of the splitbar and does not resize the panes until the mouse button is released.  Reduces flickering or unwanted re-layout during resize",default:!1,type:"boolean"},dock_side:{name:"Dock",description:"Allow the user to 'Dock' the splitbar to one side of the splitter, essentially hiding one pane and using the entire splitter area for the other pane.  One of leftDock, rightDock, topDock, bottomDock.",default:et2_no_init,type:"string"},width:{default:"100%"},overflow:{ignore:!0},no_lang:{ignore:!0},rows:{ignore:!0},cols:{ignore:!0}},et2_split.DOCK_TOLERANCE=15,et2_split}(et2_core_DOMWidget_1.et2_DOMWidget);et2_core_widget_1.et2_register_widget(et2_split,["split"]);
/**
 * EGroupware eTemplate2 - JS Button object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0}),require("./et2_core_common");et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget");var et2_button=function(_super){function et2_button(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_button._attributes,_child||{}))||this;return _this.label="",_this.clicked=!1,_this.btn=null,_this.image=null,_this.options.background_image||!_this.options.image&&!_this.options.ro_image?(_this.options.readonly&&!_this.options.ro_image||(_this.btn=jQuery(document.createElement("button")).addClass("et2_button").attr({type:"button"}),_this.setDOMNode(_this.btn[0])),_this.options.image&&_this.set_image(_this.options.image),_this):(_this.image=jQuery(document.createElement("img")).addClass("et2_button et2_button_icon"),_this.options.readonly||_this.image.addClass("et2_clickable"),_this.setDOMNode(_this.image[0]),_this)}return __extends(et2_button,_super),et2_button.prototype.transformAttributes=function(_attrs){if(this.id&&void 0===_attrs.background_image&&!_attrs.image)for(var image in et2_button.default_background_images)if(this.id.match(et2_button.default_background_images[image])){_attrs.image=image,_attrs.background_image=!0;break}for(var name in et2_button.default_classes)if(this.id.match(et2_button.default_classes[name])){_attrs.class=(void 0===_attrs.class?"":_attrs.class+" ")+name;break}_super.prototype.transformAttributes.call(this,_attrs)},et2_button.prototype.set_accesskey=function(key){jQuery(this.node).attr("accesskey",key)},et2_button.prototype.set_image=function(_image){this.options.image=_image,this.update_image()},et2_button.prototype.set_ro_image=function(_image){this.options.ro_image=_image,this.update_image()},et2_button.prototype.update_image=function(_image){if(this.isInTree()&&(this.options.background_image||null!=this.image)){void 0===_image&&(_image=this.options.readonly&&this.options.ro_image||this.options.image),_image.match(/^[0-9]+\%$/)&&(_image="");var found_image=!1;if(""!=_image){var src=this.egw().image(_image);src?found_image=!0:"/"!=_image[0]&&"http"!=_image.substr(0,4)||(src=_image,found_image=!0),found_image&&(null!=this.image?this.image.attr("src",src):this.options.background_image&&this.btn&&(this.btn.css("background-image","url("+src+")"),this.btn.addClass("et2_button_with_image")))}found_image||(this.set_label(this.label),this.btn&&(this.btn.css("background-image",""),this.btn.removeClass("et2_button_with_image")))}},et2_button.prototype.set_readonly=function(_ro){_ro!=this.options.readonly&&(this.options.readonly=_ro,(this.options.image||this.options.ro_image)&&this.update_image(),(this.btn||this.image)&&(this.btn||this.image).toggleClass("et2_clickable",!_ro).toggleClass("et2_button_ro",_ro).css("cursor",_ro?"default":"pointer"))},et2_button.prototype.attachToDOM=function(){var ret=_super.prototype.attachToDOM.call(this);return this.options.readonly&&(this.btn||this.image)&&(this.btn||this.image).removeClass("et2_clickable").addClass("et2_button_ro").css("cursor","default"),ret},et2_button.prototype.getDOMNode=function(){return this.btn?this.btn[0]:this.image?this.image[0]:null},et2_button.prototype.click=function(_ev){var _a,_b;return!this.options.readonly&&(this.clicked=!0,(null===(_a=this.btn)||void 0===_a?void 0:_a.hasClass("et2_button_cancel"))&&this.getInstanceManager().skip_close_prompt(),_super.prototype.click.apply(this,arguments)?("buttononly"!=this.getType()&&this.getInstanceManager().submit(this,!1,this.options.novalidate),this.clicked=!1,null===(_b=this.getInstanceManager())||void 0===_b||_b.skip_close_prompt(!1),!0):(this.clicked=!1,!1))},et2_button.prototype.set_label=function(_value){this.btn&&(this.label=_value,this.btn.text(_value),_value&&!this.image?this.btn.addClass("et2_button_text"):this.btn.removeClass("et2_button_text")),this.image&&(this.image.attr("alt",_value),this.options.statustext||this.image.attr("title",_value))},et2_button.prototype.set_tabindex=function(index){jQuery(this.btn).attr("tabindex",index)},et2_button.prototype.isDirty=function(){return!1},et2_button.prototype.resetDirty=function(){},et2_button.prototype.getValue=function(){return!!this.clicked||null},et2_button.prototype.isValid=function(){return!0},et2_button.prototype.getDetachedAttributes=function(_attrs){_attrs.push("label","value","class","image","ro_image","onclick","background_image")},et2_button.prototype.getDetachedNodes=function(){return[null!=this.btn?this.btn[0]:null,null!=this.image?this.image[0]:null]},et2_button.prototype.setDetachedAttributes=function(_nodes,_values){this.btn="#"!=_nodes[0].nodeName[0]?jQuery(_nodes[0]):null,this.image=jQuery(_nodes[1]),void 0!==_values.id&&this.set_id(_values.id),void 0!==_values.label&&this.set_label(_values.label),_values.value,void 0!==_values.image&&this.set_image(_values.image),void 0!==_values.ro_image&&this.set_ro_image(_values.ro_image),void 0!==_values.class&&this.set_class(_values.class),void 0!==_values.onclick&&(this.options.onclick=_values.onclick);var type=this.getType(),attrs=jQuery.extend(_values,this.options),parent=this.getParent();jQuery(this.getDOMNode()).bind("click.et2_baseWidget",this,(function(e){var widget=et2_core_widget_1.et2_createWidget(type,attrs,parent);return e.data=widget,e.data.set_id(_values.id),e.data.click.call(e.data,e)}))},et2_button._attributes={label:{name:"caption",type:"string",description:"Label of the button",translate:!0},image:{name:"Icon",type:"string",description:"Use an icon instead of label (when available)"},ro_image:{name:"Read-only Icon",type:"string",description:"Use this icon instead of hiding for read-only"},onclick:{description:"JS code which gets executed when the button is clicked",type:"js"},accesskey:{name:"Access Key",type:"string",default:et2_no_init,description:"Alt + <key> activates widget"},tabindex:{name:"Tab index",type:"integer",default:et2_no_init,description:"Specifies the tab order of a widget when the 'tab' button is used for navigating."},background_image:{name:"Add image in front of text",type:"boolean",description:"Adds image in front of text instead of just using an image with text as tooltip",default:et2_no_init},novalidate:{name:"Do NOT validate form",type:"boolean",description:"Do NOT validate form before submitting it",default:!1},needed:{ignore:!0}},et2_button.legacyOptions=["image","ro_image"],et2_button.default_background_images={save:/save(&|\]|$)/,apply:/apply(&|\]|$)/,cancel:/cancel(&|\]|$)/,delete:/delete(&|\]|$)/,discard:/discard(&|\]|$)/,edit:/edit(&|\[\]|$)/,next:/(next|continue)(&|\]|$)/,finish:/finish(&|\]|$)/,back:/(back|previous)(&|\]|$)/,copy:/copy(&|\]|$)/,more:/more(&|\]|$)/,check:/(yes|check)(&|\]|$)/,cancelled:/no(&|\]|$)/,ok:/ok(&|\]|$)/,close:/close(&|\]|$)/,add:/(add(&|\]|$)|create)/},et2_button.default_classes={et2_button_cancel:/cancel(&|\]|$)/,et2_button_question:/(yes|no)(&|\]|$)/,et2_button_delete:/delete(&|\]|$)/},et2_button}((et2_core_baseWidget_1=require("./et2_core_baseWidget")).et2_baseWidget);exports.et2_button=et2_button,et2_core_widget_1.et2_register_widget(et2_button,["button","buttononly"]);
/**
 * EGroupware eTemplate2 - JS widget class with value attribute and auto loading
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_baseWidget_1=require("./et2_core_baseWidget");require("./et2_core_common");et2_core_inheritance_1=require("./et2_core_inheritance");var et2_valueWidget=function(_super){function et2_valueWidget(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_valueWidget._attributes,_child||{}))||this;return _this.label="",_this._labelContainer=null,_this}return __extends(et2_valueWidget,_super),et2_valueWidget.prototype.transformAttributes=function(_attrs){if(_super.prototype.transformAttributes.call(this,_attrs),this.id){var contentMgr=this.getArrayMgr("content");if(null!=contentMgr){var val=contentMgr.getEntry(this.id,!1,!0);null!==val&&(_attrs.value=val)}this._createNamespace()&&this.getArrayMgr("content").perspectiveData.owner==this&&(_attrs.value=this.getArrayMgr("content").data)}},et2_valueWidget.prototype.set_label=function(_value){if(_value!=this.label){if(_value){null==this._labelContainer&&(this._labelContainer=jQuery(document.createElement("label")).addClass("et2_label"),this.getSurroundings().insertDOMNode(this._labelContainer[0])),this._labelContainer.empty();var ph=document.createElement("span");this.getSurroundings().setWidgetPlaceholder(ph);for(var parts=et2_csvSplit(_value,2,"%s"),i=0;i<parts.length;i++)parts[i]&&this._labelContainer.append(document.createTextNode(parts[i])),0==i&&this._labelContainer.append(ph);this._labelContainer.toggleClass("et2_label_empty",!_value||!parts[0])}else this._labelContainer&&this.getSurroundings().removeDOMNode(this._labelContainer[0]),this._labelContainer=null;this.getSurroundings().update(),this.label=_value}},et2_valueWidget._attributes={label:{name:"Label",default:"",type:"string",description:"The label is displayed by default in front (for radiobuttons behind) each widget (if not empty). If you want to specify a different position, use a '%s' in the label, which gets replaced by the widget itself. Eg. '%s Name' to have the label Name behind a checkbox. The label can contain variables, as descript for name. If the label starts with a '@' it is replaced by the value of the content-array at this index (with the '@'-removed and after expanding the variables).",translate:!0},value:{name:"Value",description:"The value of the widget",type:"rawstring",default:et2_no_init}},et2_valueWidget}(et2_core_baseWidget_1.et2_baseWidget);exports.et2_valueWidget=et2_valueWidget;
/**
 * EGroupware eTemplate2 - JS Widget base class
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0}),require("./et2_core_common");et2_core_inheritance_1=require("./et2_core_inheritance");var et2_inputWidget=function(_super){function et2_inputWidget(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_inputWidget._attributes,_child||{}))||this;return _this._oldValue=et2_no_init,_this._labelContainer=null,_this}return __extends(et2_inputWidget,_super),et2_inputWidget.prototype.destroy=function(){var node=this.getInputNode();node&&(jQuery(node).unbind("change.et2_inputWidget"),jQuery(node).unbind("focus")),_super.prototype.destroy.call(this),this._labelContainer=null},et2_inputWidget.prototype.doLoadingFinished=function(){var result=_super.prototype.doLoadingFinished.call(this);return this.resetDirty(),result},et2_inputWidget.prototype.transformAttributes=function(_attrs){if(_super.prototype.transformAttributes.call(this,_attrs),this.id&&this.getArrayMgr("validation_errors")){var val=this.getArrayMgr("validation_errors").getEntry(this.id);val&&(_attrs.validation_error=val)}},et2_inputWidget.prototype.attachToDOM=function(){var node=this.getInputNode();return node&&jQuery(node).off(".et2_inputWidget").bind("change.et2_inputWidget",this,(function(e){e.data.change.call(e.data,this)})).bind("focus.et2_inputWidget",this,(function(e){e.data.focus.call(e.data,this)})),_super.prototype.attachToDOM.call(this)},et2_inputWidget.prototype.detatchFromDOM=function(){_super.prototype.detachFromDOM.call(this)},et2_inputWidget.prototype.change=function(_node,_widget,_value){var messages=[],valid=this.isValid(messages);if(this.set_validation_error(!valid&&messages),valid&&this.onchange){if("function"==typeof this.onchange){var args=Array.prototype.slice.call(arguments);return-1==args.indexOf(this)&&args.push(this),this.onchange.apply(this,args)}return et2_compileLegacyJS(this.options.onchange,this,_node)()}return valid},et2_inputWidget.prototype.focus=function(_node){if("function"==typeof this.options.onfocus){var args=Array.prototype.slice.call(arguments);return-1==args.indexOf(this)&&args.push(this),this.options.onfocus.apply(this,args)}},et2_inputWidget.prototype.set_value=function(_value){var node=this.getInputNode();node&&(jQuery(node).val(_value),this.isAttached()&&this._oldValue!==et2_no_init&&this._oldValue!==_value&&jQuery(node).change()),this._oldValue=_value},et2_inputWidget.prototype.set_id=function(_value){this.id=_value,this.dom_id=_value&&this.getInstanceManager()?this.getInstanceManager().uniqueId+"_"+this.id:_value;var node=this.getInputNode();node&&(""!=_value?(node.setAttribute("id",this.dom_id),node.setAttribute("name",_value)):(node.removeAttribute("id"),node.removeAttribute("name")))},et2_inputWidget.prototype.set_needed=function(_value){var node=this.getInputNode();node&&(_value&&!this.options.readonly?jQuery(node).attr("required","required"):node.removeAttribute("required"))},et2_inputWidget.prototype.set_validation_error=function(_value){var node=this.getInputNode();if(node)if(!1===_value)this.hideMessage(),jQuery(node).removeClass("invalid");else{this.showMessage(_value,"validation_error"),jQuery(node).addClass("invalid");for(var widget=this;widget.getParent()&&"tabbox"!=widget.getType();)widget=widget.getParent();"tabbox"==widget.getType()&&widget.activateTab(this)}},et2_inputWidget.prototype.set_tabindex=function(index){jQuery(this.getInputNode()).attr("tabindex",index)},et2_inputWidget.prototype.getInputNode=function(){return this.node},et2_inputWidget.prototype.get_value=function(){return this.getValue()},et2_inputWidget.prototype.getValue=function(){var node=this.getInputNode();return node?jQuery(node).val():this._oldValue},et2_inputWidget.prototype.isDirty=function(){var value=this.getValue();if(typeof value!=typeof this._oldValue)return!0;if(this._oldValue===value)return!1;switch(typeof this._oldValue){case"object":if(void 0!==this._oldValue.length&&this._oldValue.length!==value.length)return!0;for(var key in this._oldValue)if(this._oldValue[key]!==value[key])return!0;return!1;default:return this._oldValue!=value}},et2_inputWidget.prototype.resetDirty=function(){this._oldValue=this.getValue()},et2_inputWidget.prototype.isValid=function(messages){var ok=!0;return!this.options||!this.options.needed||this.options.readonly||this.disabled||null!=this.getValue()&&""!=this.getValue().valueOf()||(messages.push(this.egw().lang("Field must not be empty !!!")),ok=!1),ok},et2_inputWidget.prototype.submit=function(_values){var messages=[],valid=this.isValid(messages);return this.set_validation_error(!valid&&messages),valid},et2_inputWidget._attributes={needed:{name:"Required",default:!1,type:"boolean",description:"If required, the user must enter a value before the form can be submitted"},onchange:{name:"onchange",type:"js",default:et2_no_init,description:"JS code which is executed when the value changes."},onfocus:{name:"onfocus",type:"js",default:et2_no_init,description:"JS code which get executed when wiget receives focus."},validation_error:{name:"Validation Error",type:"string",default:et2_no_init,description:"Used internally to store the validation error that came from the server."},tabindex:{name:"Tab index",type:"integer",default:et2_no_init,description:"Specifies the tab order of a widget when the 'tab' button is used for navigating."},readonly:{name:"readonly",type:"boolean",default:!1,description:"Does NOT allow user to enter data, just displays existing data"}},et2_inputWidget}((et2_core_valueWidget_1=require("./et2_core_valueWidget")).et2_valueWidget);exports.et2_inputWidget=et2_inputWidget;
/**
 * EGroupware eTemplate2 - JS Color picker object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2012
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget");var et2_core_valueWidget_1=require("./et2_core_valueWidget"),et2_core_inputWidget_1=require("./et2_core_inputWidget"),et2_color=(et2_core_inheritance_1=require("./et2_core_inheritance"),function(_super){function et2_color(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_color._attributes,_child||{}))||this;return _this.cleared=!0,_this.span=jQuery("<span class='et2_color'/>"),_this.image=jQuery("<img src='"+_this.egw().image("non_loaded_bg")+"'/>").appendTo(_this.span).on("click",function(){this.input.trigger("click")}.bind(_this)),_this.input=jQuery("<input type='color'/>").appendTo(_this.span).on("change",function(){this.cleared=!1,this.image.hide()}.bind(_this)),_this.options.readonly||_this.options.needed||(_this.clear=jQuery("<span class='ui-icon clear'/>").appendTo(_this.span).on("click",function(){return this.set_value(""),!1}.bind(_this))),_this.setDOMNode(_this.span[0]),_this}return __extends(et2_color,_super),et2_color.prototype.getValue=function(){var value=this.input.val();return this.cleared||"#FFFFFF"===value||"#ffffff"===value?"":value},et2_color.prototype.set_value=function(color){color||(color=""),this.cleared=!color,this.image.toggle(!color),this.input.val(color)},et2_color}(et2_core_inputWidget_1.et2_inputWidget));exports.et2_color=et2_color,et2_core_widget_1.et2_register_widget(et2_color,["colorpicker"]);var et2_color_ro=function(_super){function et2_color_ro(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,_child||{})||this;return _this.value="",_this.$node=jQuery(document.createElement("div")).addClass("et2_color"),_this.setDOMNode(_this.$node[0]),_this}return __extends(et2_color_ro,_super),et2_color_ro.prototype.set_value=function(_value){this.value=_value,_value||(_value="inherit"),this.$node.css("background-color",_value)},et2_color_ro.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value")},et2_color_ro.prototype.getDetachedNodes=function(){return[this.node]},et2_color_ro.prototype.setDetachedAttributes=function(_nodes,_values){this.$node=jQuery(_nodes[0]),void 0!==_values.value&&this.set_value(_values.value)},et2_color_ro}(et2_core_valueWidget_1.et2_valueWidget);exports.et2_color_ro=et2_color_ro,et2_core_widget_1.et2_register_widget(et2_color_ro,["colorpicker_ro"]);
/**
 * EGroupware eTemplate2 - Countdown timer widget
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Hadi Nategh
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0}),exports.et2_countdown=void 0,require("./et2_core_common");et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget");var et2_countdown=function(_super){function et2_countdown(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_countdown._attributes,_child||{}))||this;return _this.timer=null,_this.container=null,_this.days=null,_this.hours=null,_this.minutes=null,_this.seconds=null,_this.container=jQuery(document.createElement("div")).addClass("et2_countdown"),_this.days=jQuery(document.createElement("span")).addClass("et2_countdown_days").appendTo(_this.container),_this.hours=jQuery(document.createElement("span")).addClass("et2_countdown_hours").appendTo(_this.container),_this.minutes=jQuery(document.createElement("span")).addClass("et2_countdown_minutes").appendTo(_this.container),_this.seconds=jQuery(document.createElement("span")).addClass("et2_countdown_seconds").appendTo(_this.container),_this.time=et2_core_widget_1.et2_createWidget("date-time",{}),_this.setDOMNode(_this.container[0]),_this.offset=(new Date).getTimezoneOffset(),_this}return __extends(et2_countdown,_super),et2_countdown.prototype.set_value=function(_time){if(""!=_time){if(isNaN(_time))this.offset=(new Date).getTimezoneOffset();else{var t=new Date;t.setSeconds(t.getSeconds()+parseInt(_time)),_time=t,this.offset=0}this.time.set_value(_time);var self=this;this.timer=setInterval((function(){self._updateTimer()<=0&&(clearInterval(self.timer),"function"==typeof self.onFinish&&self.onFinish())}),1e3)}},et2_countdown.prototype._updateTimer=function(){var tempDate=new Date,now=new Date(tempDate.getFullYear(),tempDate.getMonth(),tempDate.getDate(),tempDate.getHours(),tempDate.getMinutes()-this.offset,tempDate.getSeconds()),distance=new Date(this.time.getValue()).getTime()-now.getTime();if(distance<0)return 0;this.options.alarm>0&&this.options.alarm==distance/1e3&&"function"==typeof this.onAlarm&&this.onAlarm();var values={days:Math.floor(distance/864e5),hours:Math.floor(distance%864e5/36e5),minutes:Math.floor(distance%36e5/6e4),secounds:Math.floor(distance%6e4/1e3)};if(this.days.text(values.days+this._getIndicator("days")),this.hours.text(values.hours+this._getIndicator("hours")),this.minutes.text(values.minutes+this._getIndicator("minutes")),this.seconds.text(values.secounds+this._getIndicator("seconds")),this.options.hideEmpties&&0==values.days&&(this.days.hide(),0==values.hours&&(this.hours.hide(),0==values.minutes&&(this.minutes.hide(),0==values.secounds&&this.seconds.hide()))),this.options.precision)for(var units=["days","hours","minutes","seconds"],u=0;u<4;++u){if(values[units[u]]){for(var n=u+this.options.precision;n<4;n++)this[units[n]].hide();break}this[units[u]].hide()}return distance},et2_countdown.prototype._getIndicator=function(_v){return"s"==this.options.format?egw.lang(_v).substr(0,1):egw.lang(_v)},et2_countdown._attributes={format:{name:"display format",type:"string",default:"s",description:"Defines display format; s (Initial letter) or l (Complete word) display, default is s."},onFinish:{name:"on finish countdown",type:"js",default:et2_no_init,description:"Callback function to call when the countdown is finished."},hideEmpties:{name:"hide empties",type:"string",default:!0,description:"Only displays none empty values."},precision:{name:"how many counters to show",type:"integer",default:0,description:"Limit number of counters, eg. 2 does not show minutes and seconds, if days are displayed"},alarm:{name:"alarm",type:"any",default:"",description:"Defines an alarm set before the countdown is finished, it should be in seconds"},onAlarm:{name:"alarm callback",type:"js",default:"",description:"Defines a callback to gets called at alarm - timer. This only will work if there's an alarm set."}},et2_countdown}((et2_core_valueWidget_1=require("./et2_core_valueWidget")).et2_valueWidget);exports.et2_countdown=et2_countdown,et2_core_widget_1.et2_register_widget(et2_countdown,["countdown"]),function(){var factory;factory=function($){function Gallery(list,options){return void 0===document.body.style.maxHeight?null:this&&this.options===Gallery.prototype.options?void(list&&list.length?(this.list=list,this.num=list.length,this.initOptions(options),this.initialize()):this.console.log("blueimp Gallery: No or empty list provided as first argument.",list)):new Gallery(list,options)}var element,support,elementTests;return $.extend(Gallery.prototype,{options:{container:"#blueimp-gallery",slidesContainer:"div",titleElement:"h3",displayClass:"blueimp-gallery-display",controlsClass:"blueimp-gallery-controls",singleClass:"blueimp-gallery-single",leftEdgeClass:"blueimp-gallery-left",rightEdgeClass:"blueimp-gallery-right",playingClass:"blueimp-gallery-playing",slideClass:"slide",slideLoadingClass:"slide-loading",slideErrorClass:"slide-error",slideContentClass:"slide-content",toggleClass:"toggle",prevClass:"prev",nextClass:"next",closeClass:"close",playPauseClass:"play-pause",fullscreenClass:"fullscreen",downloadClass:"download",typeProperty:"type",titleProperty:"title",urlProperty:"href",displayTransition:!0,clearSlides:!0,stretchImages:!1,toggleControlsOnReturn:!0,toggleSlideshowOnSpace:!0,toggleFullscreenOnSlideShow:!1,enableKeyboardNavigation:!0,closeOnEscape:!0,hideControlsOnSlideshow:!1,closeOnSlideClick:!0,closeOnSwipeUpOrDown:!0,emulateTouchEvents:!0,stopTouchEventsPropagation:!1,hidePageScrollbars:!0,disableScroll:!0,carousel:!1,continuous:!0,unloadElements:!0,startSlideshow:!1,slideshowInterval:5e3,index:0,preloadRange:2,transitionSpeed:400,slideshowTransitionSpeed:void 0,event:void 0,onopen:void 0,onopened:void 0,onslide:void 0,onslideend:void 0,onslidecomplete:void 0,onclose:void 0,onclosed:void 0},carouselOptions:{hidePageScrollbars:!1,toggleControlsOnReturn:!1,toggleSlideshowOnSpace:!1,enableKeyboardNavigation:!1,closeOnEscape:!1,closeOnSlideClick:!1,closeOnSwipeUpOrDown:!1,disableScroll:!1,startSlideshow:!0},console:window.console&&"function"==typeof window.console.log?window.console:{log:function(){}},support:(element=document.createElement("div"),support={touch:void 0!==window.ontouchstart||window.DocumentTouch&&document instanceof DocumentTouch},elementTests=function(){var prop,translateZ,transition=support.transition;document.body.appendChild(element),transition&&(prop=transition.name.slice(0,-9)+"ransform",void 0!==element.style[prop]&&(element.style[prop]="translateZ(0)",translateZ=window.getComputedStyle(element).getPropertyValue(transition.prefix+"transform"),support.transform={prefix:transition.prefix,name:prop,translate:!0,translateZ:!!translateZ&&"none"!==translateZ})),void 0!==element.style.backgroundSize&&(support.backgroundSize={},element.style.backgroundSize="contain",support.backgroundSize.contain="contain"===window.getComputedStyle(element).getPropertyValue("background-size"),element.style.backgroundSize="cover",support.backgroundSize.cover="cover"===window.getComputedStyle(element).getPropertyValue("background-size")),document.body.removeChild(element)},function(support,transitions){var prop;for(prop in transitions)if(transitions.hasOwnProperty(prop)&&void 0!==element.style[prop]){support.transition=transitions[prop],support.transition.name=prop;break}}(support,{webkitTransition:{end:"webkitTransitionEnd",prefix:"-webkit-"},MozTransition:{end:"transitionend",prefix:"-moz-"},OTransition:{end:"otransitionend",prefix:"-o-"},transition:{end:"transitionend",prefix:""}}),document.body?elementTests():$(document).on("DOMContentLoaded",elementTests),support),requestAnimationFrame:window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame,initialize:function(){if(this.initStartIndex(),!1===this.initWidget())return!1;this.initEventListeners(),this.onslide(this.index),this.ontransitionend(),this.options.startSlideshow&&this.play()},slide:function(to,speed){window.clearTimeout(this.timeout);var direction,naturalDirection,diff,index=this.index;if(index!==to&&1!==this.num){if(speed||(speed=this.options.transitionSpeed),this.support.transform){for(this.options.continuous||(to=this.circle(to)),direction=Math.abs(index-to)/(index-to),this.options.continuous&&(naturalDirection=direction,(direction=-this.positions[this.circle(to)]/this.slideWidth)!==naturalDirection&&(to=-direction*this.num+to)),diff=Math.abs(index-to)-1;diff;)diff-=1,this.move(this.circle((to>index?to:index)-diff-1),this.slideWidth*direction,0);to=this.circle(to),this.move(index,this.slideWidth*direction,speed),this.move(to,0,speed),this.options.continuous&&this.move(this.circle(to-direction),-this.slideWidth*direction,0)}else to=this.circle(to),this.animate(index*-this.slideWidth,to*-this.slideWidth,speed);this.onslide(to)}},getIndex:function(){return this.index},getNumber:function(){return this.num},prev:function(){(this.options.continuous||this.index)&&this.slide(this.index-1)},next:function(){(this.options.continuous||this.index<this.num-1)&&this.slide(this.index+1)},play:function(time){var that=this;this.options.hideControlsOnSlideshow&&this.container.removeClass(this.options.controlsClass),window.clearTimeout(this.timeout),this.interval=time||this.options.slideshowInterval,this.elements[this.index]>1&&(this.timeout=this.setTimeout(!this.requestAnimationFrame&&this.slide||function(to,speed){that.animationFrameId=that.requestAnimationFrame.call(window,(function(){that.slide(to,speed)}))},[this.index+1,this.options.slideshowTransitionSpeed],this.interval)),this.container.addClass(this.options.playingClass)},pause:function(){window.clearTimeout(this.timeout),this.interval=null,this.container.removeClass(this.options.playingClass)},add:function(list){var i;for(list.concat||(list=Array.prototype.slice.call(list)),this.list.concat||(this.list=Array.prototype.slice.call(this.list)),this.list=this.list.concat(list),this.num=this.list.length,this.num>2&&null===this.options.continuous&&(this.options.continuous=!0,this.container.removeClass(this.options.leftEdgeClass)),this.container.removeClass(this.options.rightEdgeClass).removeClass(this.options.singleClass),i=this.num-list.length;i<this.num;i+=1)this.addSlide(i),this.positionSlide(i);this.positions.length=this.num,this.initSlides(!0)},resetSlides:function(){this.slidesContainer.empty(),this.slides=[]},handleClose:function(){var options=this.options;this.destroyEventListeners(),this.pause(),this.container[0].style.display="none",this.container.removeClass(options.displayClass).removeClass(options.singleClass).removeClass(options.leftEdgeClass).removeClass(options.rightEdgeClass),options.hidePageScrollbars&&(document.body.style.overflow=this.bodyOverflowStyle),this.options.clearSlides&&this.resetSlides(),this.options.onclosed&&this.options.onclosed.call(this)},close:function(){var that=this,closeHandler=function(event){event.target===that.container[0]&&(that.container.off(that.support.transition.end,closeHandler),that.handleClose())};this.options.onclose&&this.options.onclose.call(this),this.support.transition&&this.options.displayTransition?(this.container.on(this.support.transition.end,closeHandler),this.container.removeClass(this.options.displayClass)):this.handleClose()},circle:function(index){return(this.num+index%this.num)%this.num},move:function(index,dist,speed){this.translateX(index,dist,speed),this.positions[index]=dist},translate:function(index,x,y,speed){var style=this.slides[index].style,transition=this.support.transition,transform=this.support.transform;style[transition.name+"Duration"]=speed+"ms",style[transform.name]="translate("+x+"px, "+y+"px)"+(transform.translateZ?" translateZ(0)":"")},translateX:function(index,x,speed){this.translate(index,x,0,speed)},translateY:function(index,y,speed){this.translate(index,0,y,speed)},animate:function(from,to,speed){if(speed)var that=this,start=(new Date).getTime(),timer=window.setInterval((function(){var timeElap=(new Date).getTime()-start;if(timeElap>speed)return that.slidesContainer[0].style.left=to+"px",that.ontransitionend(),void window.clearInterval(timer);that.slidesContainer[0].style.left=(to-from)*(Math.floor(timeElap/speed*100)/100)+from+"px"}),4);else this.slidesContainer[0].style.left=to+"px"},preventDefault:function(event){event.preventDefault?event.preventDefault():event.returnValue=!1},stopPropagation:function(event){event.stopPropagation?event.stopPropagation():event.cancelBubble=!0},onresize:function(){this.initSlides(!0)},onmousedown:function(event){event.which&&1===event.which&&"VIDEO"!==event.target.nodeName&&(event.preventDefault(),(event.originalEvent||event).touches=[{pageX:event.pageX,pageY:event.pageY}],this.ontouchstart(event))},onmousemove:function(event){this.touchStart&&((event.originalEvent||event).touches=[{pageX:event.pageX,pageY:event.pageY}],this.ontouchmove(event))},onmouseup:function(event){this.touchStart&&(this.ontouchend(event),delete this.touchStart)},onmouseout:function(event){if(this.touchStart){var target=event.target,related=event.relatedTarget;related&&(related===target||$.contains(target,related))||this.onmouseup(event)}},ontouchstart:function(event){this.options.stopTouchEventsPropagation&&this.stopPropagation(event);var touches=(event.originalEvent||event).touches[0];this.touchStart={x:touches.pageX,y:touches.pageY,time:Date.now()},this.isScrolling=void 0,this.touchDelta={}},ontouchmove:function(event){this.options.stopTouchEventsPropagation&&this.stopPropagation(event);var touchDeltaX,indices,touches=(event.originalEvent||event).touches[0],scale=(event.originalEvent||event).scale,index=this.index;if(!(touches.length>1||scale&&1!==scale))if(this.options.disableScroll&&event.preventDefault(),this.touchDelta={x:touches.pageX-this.touchStart.x,y:touches.pageY-this.touchStart.y},touchDeltaX=this.touchDelta.x,void 0===this.isScrolling&&(this.isScrolling=this.isScrolling||Math.abs(touchDeltaX)<Math.abs(this.touchDelta.y)),this.isScrolling)this.options.closeOnSwipeUpOrDown&&this.translateY(index,this.touchDelta.y+this.positions[index],0);else for(event.preventDefault(),window.clearTimeout(this.timeout),this.options.continuous?indices=[this.circle(index+1),index,this.circle(index-1)]:(this.touchDelta.x=touchDeltaX/=!index&&touchDeltaX>0||index===this.num-1&&touchDeltaX<0?Math.abs(touchDeltaX)/this.slideWidth+1:1,indices=[index],index&&indices.push(index-1),index<this.num-1&&indices.unshift(index+1));indices.length;)index=indices.pop(),this.translateX(index,touchDeltaX+this.positions[index],0)},ontouchend:function(event){this.options.stopTouchEventsPropagation&&this.stopPropagation(event);var direction,indexForward,indexBackward,distanceForward,distanceBackward,index=this.index,speed=this.options.transitionSpeed,slideWidth=this.slideWidth,isShortDuration=Number(Date.now()-this.touchStart.time)<250,isValidSlide=isShortDuration&&Math.abs(this.touchDelta.x)>20||Math.abs(this.touchDelta.x)>slideWidth/2,isPastBounds=!index&&this.touchDelta.x>0||index===this.num-1&&this.touchDelta.x<0,isValidClose=!isValidSlide&&this.options.closeOnSwipeUpOrDown&&(isShortDuration&&Math.abs(this.touchDelta.y)>20||Math.abs(this.touchDelta.y)>this.slideHeight/2);this.options.continuous&&(isPastBounds=!1),direction=this.touchDelta.x<0?-1:1,this.isScrolling?isValidClose?this.close():this.translateY(index,0,speed):isValidSlide&&!isPastBounds?(indexForward=index+direction,indexBackward=index-direction,distanceForward=slideWidth*direction,distanceBackward=-slideWidth*direction,this.options.continuous?(this.move(this.circle(indexForward),distanceForward,0),this.move(this.circle(index-2*direction),distanceBackward,0)):indexForward>=0&&indexForward<this.num&&this.move(indexForward,distanceForward,0),this.move(index,this.positions[index]+distanceForward,speed),this.move(this.circle(indexBackward),this.positions[this.circle(indexBackward)]+distanceForward,speed),index=this.circle(indexBackward),this.onslide(index)):this.options.continuous?(this.move(this.circle(index-1),-slideWidth,speed),this.move(index,0,speed),this.move(this.circle(index+1),slideWidth,speed)):(index&&this.move(index-1,-slideWidth,speed),this.move(index,0,speed),index<this.num-1&&this.move(index+1,slideWidth,speed))},ontouchcancel:function(event){this.touchStart&&(this.ontouchend(event),delete this.touchStart)},ontransitionend:function(event){var slide=this.slides[this.index];event&&slide!==event.target||(this.interval&&this.play(),this.setTimeout(this.options.onslideend,[this.index,slide]))},oncomplete:function(event){var index,target=event.target||event.srcElement,parent=target&&target.parentNode;target&&parent&&(index=this.getNodeIndex(parent),$(parent).removeClass(this.options.slideLoadingClass),"error"===event.type?($(parent).addClass(this.options.slideErrorClass),this.elements[index]=3):this.elements[index]=2,target.clientHeight>this.container[0].clientHeight&&(target.style.maxHeight=this.container[0].clientHeight),this.interval&&this.slides[this.index]===parent&&this.play(),this.setTimeout(this.options.onslidecomplete,[index,parent]))},onload:function(event){this.oncomplete(event)},onerror:function(event){this.oncomplete(event)},onkeydown:function(event){switch(event.which||event.keyCode){case 13:this.options.toggleControlsOnReturn&&(this.preventDefault(event),this.toggleControls());break;case 27:this.options.closeOnEscape&&this.close();break;case 32:this.options.toggleSlideshowOnSpace&&(this.preventDefault(event),this.toggleSlideshow());break;case 37:this.options.enableKeyboardNavigation&&(this.preventDefault(event),this.prev());break;case 39:this.options.enableKeyboardNavigation&&(this.preventDefault(event),this.next())}},handleClick:function(event){var options=this.options,target=event.target||event.srcElement,parent=target.parentNode,isTarget=function(className){return $(target).hasClass(className)||$(parent).hasClass(className)};isTarget(options.toggleClass)?(this.preventDefault(event),this.toggleControls()):isTarget(options.prevClass)?(this.preventDefault(event),this.prev()):isTarget(options.nextClass)?(this.preventDefault(event),this.next()):isTarget(options.closeClass)?(this.preventDefault(event),this.close()):isTarget(options.playPauseClass)?(this.preventDefault(event),this.toggleSlideshow()):isTarget(options.fullscreenClass)?(this.preventDefault(event),this.toggleFullscreen()):isTarget(options.downloadClass)?(this.list[this.getIndex()]&&void 0!==this.list[this.getIndex()].download_href?event.target.href=this.list[this.getIndex()].download_href:event.target.href=this.list[this.getIndex()].href,void 0!==event.target.download&&(event.target.download=this.list[this.getIndex()].title)):parent===this.slidesContainer[0]?(this.preventDefault(event),options.closeOnSlideClick?this.close():this.toggleControls()):parent.parentNode&&parent.parentNode===this.slidesContainer[0]&&(this.preventDefault(event),this.toggleControls())},onclick:function(event){if(!(this.options.emulateTouchEvents&&this.touchDelta&&(Math.abs(this.touchDelta.x)>20||Math.abs(this.touchDelta.y)>20)))return this.handleClick(event);delete this.touchDelta},updateEdgeClasses:function(index){index?this.container.removeClass(this.options.leftEdgeClass):this.container.addClass(this.options.leftEdgeClass),index===this.num-1?this.container.addClass(this.options.rightEdgeClass):this.container.removeClass(this.options.rightEdgeClass)},handleSlide:function(index){this.options.continuous||this.updateEdgeClasses(index),this.loadElements(index),this.options.unloadElements&&this.unloadElements(index),this.setTitle(index)},onslide:function(index){this.index=index,this.handleSlide(index),this.setTimeout(this.options.onslide,[index,this.slides[index]])},setTitle:function(index){var text=this.slides[index].firstChild.title,titleElement=this.titleElement;titleElement.length&&(this.titleElement.empty(),text&&titleElement[0].appendChild(document.createTextNode(text)))},setTimeout:function(func,args,wait){var that=this;return func&&window.setTimeout((function(){func.apply(that,args||[])}),wait||0)},imageFactory:function(obj,callback){var called,element,title,that=this,img=this.imagePrototype.cloneNode(!1),url=obj,backgroundSize=this.options.stretchImages,callbackWrapper=function(event){if(!called){if(event={type:event.type,target:element},!element.parentNode)return that.setTimeout(callbackWrapper,[event]);called=!0,$(img).off("load error",callbackWrapper),backgroundSize&&"load"===event.type&&(element.style.background='url("'+url+'") center no-repeat',element.style.backgroundSize=backgroundSize),callback(event)}};return"string"!=typeof url&&(url=this.getItemProperty(obj,this.options.urlProperty),title=this.getItemProperty(obj,this.options.titleProperty)),!0===backgroundSize&&(backgroundSize="contain"),(backgroundSize=this.support.backgroundSize&&this.support.backgroundSize[backgroundSize]&&backgroundSize)?element=this.elementPrototype.cloneNode(!1):(element=img,img.draggable=!1),title&&(element.title=title),$(img).on("load error",callbackWrapper),img.src=url,element},createElement:function(obj,callback){var type=obj&&this.getItemProperty(obj,this.options.typeProperty),factory=type&&this[type.split("/")[0]+"Factory"]||this.imageFactory,element=obj&&factory.call(this,obj,callback);return element||(element=this.elementPrototype.cloneNode(!1),this.setTimeout(callback,[{type:"error",target:element}])),$(element).addClass(this.options.slideContentClass),element},loadElement:function(index){this.elements[index]||(this.slides[index].firstChild?this.elements[index]=$(this.slides[index]).hasClass(this.options.slideErrorClass)?3:2:(this.elements[index]=1,$(this.slides[index]).addClass(this.options.slideLoadingClass),this.slides[index].appendChild(this.createElement(this.list[index],this.proxyListener))))},loadElements:function(index){var i,limit=Math.min(this.num,2*this.options.preloadRange+1),j=index;for(i=0;i<limit;i+=1)j+=i*(i%2==0?-1:1),j=this.circle(j),this.loadElement(j)},unloadElements:function(index){var i,slide,diff;for(i in this.elements)this.elements.hasOwnProperty(i)&&(diff=Math.abs(index-i))>this.options.preloadRange&&diff+this.options.preloadRange<this.num&&((slide=this.slides[i]).removeChild(slide.firstChild),delete this.elements[i])},addSlide:function(index){var slide=this.slidePrototype.cloneNode(!1);slide.setAttribute("data-index",index),this.slidesContainer[0].appendChild(slide),this.slides.push(slide)},positionSlide:function(index){var slide=this.slides[index];slide.style.width=this.slideWidth+"px",this.support.transform&&(slide.style.left=index*-this.slideWidth+"px",this.move(index,this.index>index?-this.slideWidth:this.index<index?this.slideWidth:0,0))},initSlides:function(reload){var clearSlides,i;for(reload||(this.positions=[],this.positions.length=this.num,this.elements={},this.imagePrototype=document.createElement("img"),this.elementPrototype=document.createElement("div"),this.slidePrototype=document.createElement("div"),$(this.slidePrototype).addClass(this.options.slideClass),this.slides=this.slidesContainer[0].children,clearSlides=this.options.clearSlides||this.slides.length!==this.num),this.slideWidth=this.container[0].offsetWidth,this.slideHeight=this.container[0].offsetHeight,this.slidesContainer[0].style.width=this.num*this.slideWidth+"px",clearSlides&&this.resetSlides(),i=0;i<this.num;i+=1)clearSlides&&this.addSlide(i),this.positionSlide(i);this.options.continuous&&this.support.transform&&(this.move(this.circle(this.index-1),-this.slideWidth,0),this.move(this.circle(this.index+1),this.slideWidth,0)),this.support.transform||(this.slidesContainer[0].style.left=this.index*-this.slideWidth+"px")},toggleControls:function(){var controlsClass=this.options.controlsClass;this.container.hasClass(controlsClass)?this.container.removeClass(controlsClass):this.container.addClass(controlsClass)},toggleSlideshow:function(){this.interval?this.pause():(this.play(),this.options.toggleFullscreenOnSlideShow&&this.requestFullScreen(this.container[0]))},toggleFullscreen:function(){this.getFullScreenElement()?this.exitFullScreen():this.requestFullScreen(this.container[0])},getNodeIndex:function(element){return parseInt(element.getAttribute("data-index"),10)},getNestedProperty:function(obj,property){return property.replace(/\[(?:'([^']+)'|"([^"]+)"|(\d+))\]|(?:(?:^|\.)([^\.\[]+))/g,(function(str,singleQuoteProp,doubleQuoteProp,arrayIndex,dotProp){var prop=dotProp||singleQuoteProp||doubleQuoteProp||arrayIndex&&parseInt(arrayIndex,10);str&&obj&&(obj=obj[prop])})),obj},getDataProperty:function(obj,property){if(obj.getAttribute){var prop=obj.getAttribute("data-"+property.replace(/([A-Z])/g,"-$1").toLowerCase());if("string"==typeof prop){if(/^(true|false|null|-?\d+(\.\d+)?|\{[\s\S]*\}|\[[\s\S]*\])$/.test(prop))try{return $.parseJSON(prop)}catch(ignore){}return prop}}},getItemProperty:function(obj,property){var prop=obj[property];return void 0===prop&&void 0===(prop=this.getDataProperty(obj,property))&&(prop=this.getNestedProperty(obj,property)),prop},initStartIndex:function(){var i,index=this.options.index,urlProperty=this.options.urlProperty;if(index&&"number"!=typeof index)for(i=0;i<this.num;i+=1)if(this.list[i]===index||this.getItemProperty(this.list[i],urlProperty)===this.getItemProperty(index,urlProperty)){index=i;break}this.index=this.circle(parseInt(index,10)||0)},initEventListeners:function(){var that=this,slidesContainer=this.slidesContainer,proxyListener=function(event){var type=that.support.transition&&that.support.transition.end===event.type?"transitionend":event.type;that["on"+type](event)};$(window).on("resize",proxyListener),$(document.body).on("keydown",proxyListener),this.container.on("click",proxyListener),this.support.touch?slidesContainer.on("touchstart touchmove touchend touchcancel",proxyListener):this.options.emulateTouchEvents&&this.support.transition&&slidesContainer.on("mousedown mousemove mouseup mouseout",proxyListener),this.support.transition&&slidesContainer.on(this.support.transition.end,proxyListener),this.proxyListener=proxyListener},destroyEventListeners:function(){var slidesContainer=this.slidesContainer,proxyListener=this.proxyListener;$(window).off("resize",proxyListener),$(document.body).off("keydown",proxyListener),this.container.off("click",proxyListener),this.support.touch?slidesContainer.off("touchstart touchmove touchend touchcancel",proxyListener):this.options.emulateTouchEvents&&this.support.transition&&slidesContainer.off("mousedown mousemove mouseup mouseout",proxyListener),this.support.transition&&slidesContainer.off(this.support.transition.end,proxyListener)},handleOpen:function(){this.options.onopened&&this.options.onopened.call(this)},initWidget:function(){var that=this,openHandler=function(event){event.target===that.container[0]&&(that.container.off(that.support.transition.end,openHandler),that.handleOpen())};return this.container=$(this.options.container),this.container.length?(this.slidesContainer=this.container.find(this.options.slidesContainer).first(),this.slidesContainer.length?(this.titleElement=this.container.find(this.options.titleElement).first(),1===this.num&&this.container.addClass(this.options.singleClass),this.options.onopen&&this.options.onopen.call(this),this.support.transition&&this.options.displayTransition?this.container.on(this.support.transition.end,openHandler):this.handleOpen(),this.options.hidePageScrollbars&&(this.bodyOverflowStyle=document.body.style.overflow,document.body.style.overflow="hidden"),this.container[0].style.display="block",this.initSlides(),void this.container.addClass(this.options.displayClass)):(this.console.log("blueimp Gallery: Slides container not found.",this.options.slidesContainer),!1)):(this.console.log("blueimp Gallery: Widget container not found.",this.options.container),!1)},initOptions:function(options){this.options=$.extend({},this.options),(options&&options.carousel||this.options.carousel&&(!options||!1!==options.carousel))&&$.extend(this.options,this.carouselOptions),$.extend(this.options,options),this.num<3&&(this.options.continuous=!!this.options.continuous&&null),this.support.transition||(this.options.emulateTouchEvents=!1),this.options.event&&this.preventDefault(this.options.event)}}),Gallery},"function"==typeof define&&define.amd?define(["./blueimp-helper"],factory):(window.blueimp=window.blueimp||{},window.blueimp.Gallery=factory(window.blueimp.helper||window.jQuery)),function(factory){"function"==typeof define&&define.amd?define(["./blueimp-helper","./blueimp-gallery"],factory):factory(window.blueimp.helper||window.jQuery,window.blueimp.Gallery)}((function($,Gallery){$.extend(Gallery.prototype.options,{fullScreen:!1});var initialize=Gallery.prototype.initialize,close=Gallery.prototype.close;return $.extend(Gallery.prototype,{getFullScreenElement:function(){return document.fullscreenElement||document.webkitFullscreenElement||document.mozFullScreenElement||document.msFullscreenElement},requestFullScreen:function(element){element.requestFullscreen?element.requestFullscreen():element.webkitRequestFullscreen?element.webkitRequestFullscreen():element.mozRequestFullScreen?element.mozRequestFullScreen():element.msRequestFullscreen&&element.msRequestFullscreen()},exitFullScreen:function(){document.exitFullscreen?document.exitFullscreen():document.webkitCancelFullScreen?document.webkitCancelFullScreen():document.mozCancelFullScreen?document.mozCancelFullScreen():document.msExitFullscreen&&document.msExitFullscreen()},initialize:function(){initialize.call(this),this.options.fullScreen&&!this.getFullScreenElement()&&this.requestFullScreen(this.container[0])},close:function(){this.getFullScreenElement()===this.container[0]&&this.exitFullScreen(),close.call(this)}}),Gallery})),function(factory){"function"==typeof define&&define.amd?define(["./blueimp-helper","./blueimp-gallery"],factory):factory(window.blueimp.helper||window.jQuery,window.blueimp.Gallery)}((function($,Gallery){$.extend(Gallery.prototype.options,{indicatorContainer:"ol",activeIndicatorClass:"active",thumbnailProperty:"thumbnail",thumbnailIndicators:!0,thumbnailsTagIndicators:"li",thumbnailWithImgTag:!1});var initSlides=Gallery.prototype.initSlides,addSlide=Gallery.prototype.addSlide,resetSlides=Gallery.prototype.resetSlides,handleClick=Gallery.prototype.handleClick,handleSlide=Gallery.prototype.handleSlide,handleClose=Gallery.prototype.handleClose;return $.extend(Gallery.prototype,{createIndicator:function(obj){var thumbnailUrl,thumbnail,indicator=this.indicatorPrototype.cloneNode(this.options.thumbnailWithImgTag),title=this.getItemProperty(obj,this.options.titleProperty),thumbnailProperty=this.options.thumbnailProperty;return this.options.thumbnailIndicators&&((thumbnail=obj.getElementsByTagName&&$(obj).find("img")[0])?thumbnailUrl=thumbnail.src:thumbnailProperty&&(thumbnailUrl=this.getItemProperty(obj,thumbnailProperty)),thumbnailUrl&&("img"==this.options.thumbnailsTagIndicators?indicator.src=thumbnailUrl:this.options.thumbnailWithImgTag?indicator.children[0].src=thumbnailUrl:indicator.style.backgroundImage='url("'+thumbnailUrl+'")')),title&&(indicator.title=title),indicator},addIndicator:function(index){if(this.indicatorContainer.length){var indicator=this.createIndicator(this.list[index]);indicator.setAttribute("data-index",index),this.indicatorContainer[0].appendChild(indicator),this.indicators.push(indicator)}},setActiveIndicator:function(index){this.indicators&&(this.activeIndicator&&this.activeIndicator.removeClass(this.options.activeIndicatorClass),this.activeIndicator=$(this.indicators[index]),this.activeIndicator.addClass(this.options.activeIndicatorClass))},initSlides:function(reload){reload||(this.indicatorContainer=this.container.find(this.options.indicatorContainer),this.indicatorContainer.length&&(this.indicatorPrototype=document.createElement(this.options.thumbnailsTagIndicators),this.options.thumbnailWithImgTag&&this.indicatorPrototype.appendChild(document.createElement("img")),this.indicators=this.indicatorContainer[0].children)),initSlides.call(this,reload)},addSlide:function(index){addSlide.call(this,index),this.addIndicator(index)},resetSlides:function(){resetSlides.call(this),this.indicatorContainer.empty(),this.indicators=[]},handleClick:function(event){var target=event.target||event.srcElement,parent=target.parentNode;if(parent===this.indicatorContainer[0])this.preventDefault(event),this.slide(this.getNodeIndex(target));else{if(parent.parentNode!==this.indicatorContainer[0])return handleClick.call(this,event);this.preventDefault(event),this.slide(this.getNodeIndex(parent))}},handleSlide:function(index){handleSlide.call(this,index),this.setActiveIndicator(index)},handleClose:function(){this.activeIndicator&&this.activeIndicator.removeClass(this.options.activeIndicatorClass),handleClose.call(this)}}),Gallery})),function(factory){"function"==typeof define&&define.amd?define(["./blueimp-helper","./blueimp-gallery"],factory):factory(window.blueimp.helper||window.jQuery,window.blueimp.Gallery)}((function($,Gallery){$.extend(Gallery.prototype.options,{videoContentClass:"video-content",videoLoadingClass:"video-loading",videoPlayingClass:"video-playing",videoPosterProperty:"poster",videoSourcesProperty:"sources"});var handleSlide=Gallery.prototype.handleSlide;return $.extend(Gallery.prototype,{handleSlide:function(index){handleSlide.call(this,index),this.playingVideo&&this.playingVideo.pause()},videoFactory:function(obj,callback,videoInterface){var posterImage,source,playMediaControl,isLoading,hasControls,that=this,options=this.options,videoContainerNode=this.elementPrototype.cloneNode(!1),videoContainer=$(videoContainerNode),errorArgs=[{type:"error",target:videoContainerNode}],video=videoInterface||document.createElement("video"),url=this.getItemProperty(obj,options.urlProperty),type=this.getItemProperty(obj,options.typeProperty),title=this.getItemProperty(obj,options.titleProperty),posterUrl=this.getItemProperty(obj,options.videoPosterProperty),sources=this.getItemProperty(obj,options.videoSourcesProperty);if(videoContainer.addClass(options.videoContentClass),title&&(videoContainerNode.title=title),video.canPlayType)if(url&&type&&video.canPlayType(type))video.src=url;else for(;sources&&sources.length;)if(source=sources.shift(),url=this.getItemProperty(source,options.urlProperty),type=this.getItemProperty(source,options.typeProperty),url&&type&&video.canPlayType(type)){video.src=url;break}return posterUrl&&(video.poster=posterUrl,posterImage=this.imagePrototype.cloneNode(!1),$(posterImage).addClass(options.toggleClass),posterImage.src=posterUrl,posterImage.draggable=!1,videoContainerNode.appendChild(posterImage)),(playMediaControl=document.createElement("a")).setAttribute("target","_blank"),videoInterface||playMediaControl.setAttribute("download",title),playMediaControl.href=url,video.src&&(video.controls=!0,(videoInterface||$(video)).on("error",(function(){that.setTimeout(callback,errorArgs)})).on("pause",(function(){isLoading=!1,videoContainer.removeClass(that.options.videoLoadingClass).removeClass(that.options.videoPlayingClass),hasControls&&that.container.addClass(that.options.controlsClass),delete that.playingVideo,that.interval&&that.play()})).on("playing",(function(){isLoading=!1,videoContainer.removeClass(that.options.videoLoadingClass).addClass(that.options.videoPlayingClass),that.container.hasClass(that.options.controlsClass)?(hasControls=!0,that.container.removeClass(that.options.controlsClass)):hasControls=!1})).on("play",(function(){window.clearTimeout(that.timeout),isLoading=!0,videoContainer.addClass(that.options.videoLoadingClass),that.playingVideo=video})),$(playMediaControl).on("click",(function(event){that.preventDefault(event),isLoading?video.pause():video.play()})),videoContainerNode.appendChild(videoInterface&&videoInterface.element||video)),videoContainerNode.appendChild(playMediaControl),this.setTimeout(callback,[{type:"load",target:videoContainerNode}]),videoContainerNode}}),Gallery})),function(factory){"function"==typeof define&&define.amd?define(["./blueimp-helper","./blueimp-gallery-video"],factory):factory(window.blueimp.helper||window.jQuery,window.blueimp.Gallery)}((function($,Gallery){if(!window.postMessage)return Gallery;$.extend(Gallery.prototype.options,{youTubeVideoIdProperty:"youtube",youTubePlayerVars:{wmode:"transparent"},youTubeClickToPlay:!0});var textFactory=Gallery.prototype.textFactory||Gallery.prototype.imageFactory,YouTubePlayer=function(videoId,playerVars,clickToPlay){this.videoId=videoId,this.playerVars=playerVars,this.clickToPlay=clickToPlay,this.element=document.createElement("div"),this.listeners={}};return $.extend(YouTubePlayer.prototype,{canPlayType:function(){return!0},on:function(type,func){return this.listeners[type]=func,this},loadAPI:function(){var scriptTag,that=this,onYouTubeIframeAPIReady=window.onYouTubeIframeAPIReady,apiUrl="//www.youtube.com/iframe_api",scriptTags=document.getElementsByTagName("script"),i=scriptTags.length;for(window.onYouTubeIframeAPIReady=function(){onYouTubeIframeAPIReady&&onYouTubeIframeAPIReady.apply(this),that.playOnReady&&that.play()};i;)if(scriptTags[i-=1].src===apiUrl)return;(scriptTag=document.createElement("script")).src=apiUrl,scriptTags[0].parentNode.insertBefore(scriptTag,scriptTags[0])},onReady:function(){this.ready=!0,this.playOnReady&&this.play()},onPlaying:function(){this.playStatus<2&&(this.listeners.playing(),this.playStatus=2)},onPause:function(){Gallery.prototype.setTimeout.call(this,this.checkSeek,null,2e3)},checkSeek:function(){this.stateChange!==YT.PlayerState.PAUSED&&this.stateChange!==YT.PlayerState.ENDED||(this.listeners.pause(),delete this.playStatus)},onStateChange:function(event){switch(event.data){case YT.PlayerState.PLAYING:this.hasPlayed=!0,this.onPlaying();break;case YT.PlayerState.PAUSED:case YT.PlayerState.ENDED:this.onPause()}this.stateChange=event.data},onError:function(event){this.listeners.error(event)},play:function(){var that=this;this.playStatus||(this.listeners.play(),this.playStatus=1),this.ready?!this.hasPlayed&&(this.clickToPlay||window.navigator&&/iP(hone|od|ad)/.test(window.navigator.platform))?this.onPlaying():this.player.playVideo():(this.playOnReady=!0,window.YT&&YT.Player?this.player||(this.player=new YT.Player(this.element,{videoId:this.videoId,playerVars:this.playerVars,events:{onReady:function(){that.onReady()},onStateChange:function(event){that.onStateChange(event)},onError:function(event){that.onError(event)}}})):this.loadAPI())},pause:function(){this.ready?this.player.pauseVideo():this.playStatus&&(delete this.playOnReady,this.listeners.pause(),delete this.playStatus)}}),$.extend(Gallery.prototype,{YouTubePlayer:YouTubePlayer,textFactory:function(obj,callback){var options=this.options,videoId=this.getItemProperty(obj,options.youTubeVideoIdProperty);return videoId?(void 0===this.getItemProperty(obj,options.urlProperty)&&(obj[options.urlProperty]="//www.youtube.com/watch?v="+videoId),void 0===this.getItemProperty(obj,options.videoPosterProperty)&&(obj[options.videoPosterProperty]="//img.youtube.com/vi/"+videoId+"/maxresdefault.jpg"),this.videoFactory(obj,callback,new YouTubePlayer(videoId,options.youTubePlayerVars,options.youTubeClickToPlay))):textFactory.call(this,obj,callback)}}),Gallery})),function(factory){"function"==typeof define&&define.amd?define(["./blueimp-helper","./blueimp-gallery-video"],factory):factory(window.blueimp.helper||window.jQuery,window.blueimp.Gallery)}((function($,Gallery){if(!window.postMessage)return Gallery;$.extend(Gallery.prototype.options,{vimeoVideoIdProperty:"vimeo",vimeoPlayerUrl:"//player.vimeo.com/video/VIDEO_ID?api=1&player_id=PLAYER_ID",vimeoPlayerIdPrefix:"vimeo-player-",vimeoClickToPlay:!0});var textFactory=Gallery.prototype.textFactory||Gallery.prototype.imageFactory,VimeoPlayer=function(url,videoId,playerId,clickToPlay){this.url=url,this.videoId=videoId,this.playerId=playerId,this.clickToPlay=clickToPlay,this.element=document.createElement("div"),this.listeners={}},counter=0;return $.extend(VimeoPlayer.prototype,{canPlayType:function(){return!0},on:function(type,func){return this.listeners[type]=func,this},loadAPI:function(){for(var scriptTag,called,that=this,apiUrl="//"+("https"===location.protocol?"secure-":"")+"a.vimeocdn.com/js/froogaloop2.min.js",scriptTags=document.getElementsByTagName("script"),i=scriptTags.length,callback=function(){!called&&that.playOnReady&&that.play(),called=!0};i;)if(scriptTags[i-=1].src===apiUrl){scriptTag=scriptTags[i];break}scriptTag||((scriptTag=document.createElement("script")).src=apiUrl),$(scriptTag).on("load",callback),scriptTags[0].parentNode.insertBefore(scriptTag,scriptTags[0]),/loaded|complete/.test(scriptTag.readyState)&&callback()},onReady:function(){var that=this;this.ready=!0,this.player.addEvent("play",(function(){that.hasPlayed=!0,that.onPlaying()})),this.player.addEvent("pause",(function(){that.onPause()})),this.player.addEvent("finish",(function(){that.onPause()})),this.playOnReady&&this.play()},onPlaying:function(){this.playStatus<2&&(this.listeners.playing(),this.playStatus=2)},onPause:function(){this.listeners.pause(),delete this.playStatus},insertIframe:function(){var iframe=document.createElement("iframe");iframe.src=this.url.replace("VIDEO_ID",this.videoId).replace("PLAYER_ID",this.playerId),iframe.id=this.playerId,this.element.parentNode.replaceChild(iframe,this.element),this.element=iframe},play:function(){var that=this;this.playStatus||(this.listeners.play(),this.playStatus=1),this.ready?!this.hasPlayed&&(this.clickToPlay||window.navigator&&/iP(hone|od|ad)/.test(window.navigator.platform))?this.onPlaying():this.player.api("play"):(this.playOnReady=!0,window.$f?this.player||(this.insertIframe(),this.player=$f(this.element),this.player.addEvent("ready",(function(){that.onReady()}))):this.loadAPI())},pause:function(){this.ready?this.player.api("pause"):this.playStatus&&(delete this.playOnReady,this.listeners.pause(),delete this.playStatus)}}),$.extend(Gallery.prototype,{VimeoPlayer:VimeoPlayer,textFactory:function(obj,callback){var options=this.options,videoId=this.getItemProperty(obj,options.vimeoVideoIdProperty);return videoId?(void 0===this.getItemProperty(obj,options.urlProperty)&&(obj[options.urlProperty]="//vimeo.com/"+videoId),counter+=1,this.videoFactory(obj,callback,new VimeoPlayer(options.vimeoPlayerUrl,videoId,options.vimeoPlayerIdPrefix+counter,options.vimeoClickToPlay))):textFactory.call(this,obj,callback)}}),Gallery})),function(){function extend(obj1,obj2){var prop;for(prop in obj2)obj2.hasOwnProperty(prop)&&(obj1[prop]=obj2[prop]);return obj1}function Helper(query){if(!this||this.find!==Helper.prototype.find)return new Helper(query);if(this.length=0,query)if("string"==typeof query&&(query=this.find(query)),query.nodeType||query===query.window)this.length=1,this[0]=query;else{var i=query.length;for(this.length=i;i;)this[i-=1]=query[i]}}Helper.extend=extend,Helper.contains=function(container,element){do{if((element=element.parentNode)===container)return!0}while(element);return!1},Helper.parseJSON=function(string){return window.JSON&&JSON.parse(string)},extend(Helper.prototype,{find:function(query){var container=this[0]||document;return"string"==typeof query&&(query=container.querySelectorAll?container.querySelectorAll(query):"#"===query.charAt(0)?container.getElementById(query.slice(1)):container.getElementsByTagName(query)),new Helper(query)},hasClass:function(className){return!!this[0]&&new RegExp("(^|\\s+)"+className+"(\\s+|$)").test(this[0].className)},addClass:function(className){for(var element,i=this.length;i;){if(!(element=this[i-=1]).className)return element.className=className,this;if(this.hasClass(className))return this;element.className+=" "+className}return this},removeClass:function(className){for(var element,regexp=new RegExp("(^|\\s+)"+className+"(\\s+|$)"),i=this.length;i;)(element=this[i-=1]).className=element.className.replace(regexp," ");return this},on:function(eventName,handler){for(var i,element,eventNames=eventName.split(/\s+/);eventNames.length;)for(eventName=eventNames.shift(),i=this.length;i;)(element=this[i-=1]).addEventListener?element.addEventListener(eventName,handler,!1):element.attachEvent&&element.attachEvent("on"+eventName,handler);return this},off:function(eventName,handler){for(var i,element,eventNames=eventName.split(/\s+/);eventNames.length;)for(eventName=eventNames.shift(),i=this.length;i;)(element=this[i-=1]).removeEventListener?element.removeEventListener(eventName,handler,!1):element.detachEvent&&element.detachEvent("on"+eventName,handler);return this},empty:function(){for(var element,i=this.length;i;)for(element=this[i-=1];element.hasChildNodes();)element.removeChild(element.lastChild);return this},first:function(){return new Helper(this[0])}}),"function"==typeof define&&define.amd?define((function(){return Helper})):(window.blueimp=window.blueimp||{},window.blueimp.helper=Helper)}()}();__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();function expose(Base){var IMAGE_DEFAULT={title:egw.lang("loading"),href:"",type:"image/png",thumbnail:"",loading:!0},MIME_REGEX=navigator.userAgent.match(/(MSIE|Trident)/)?new RegExp(/(video\/mp4)|(image\/:*(?!tif|x-xcf|pdf))/):new RegExp(/(video\/(mp4|ogg|webm))|(image\/:*(?!tif|x-xcf|pdf))/),MIME_ODF_REGEX=new RegExp(/application\/vnd\.oasis\.opendocument\.text/),gallery=null,find_nextmatch=function(widget){for(var current=widget,nextmatch=null;null==nextmatch&&current;)void 0!==(current=current.getParent())&&current.instanceOf(et2_nextmatch)&&(nextmatch=current);return null!=nextmatch&&null!=nextmatch.controller&&nextmatch.dom_id.match(/filemanager/,"ig")?nextmatch:null},read_from_nextmatch=function(nm,images,start_at){start_at||(start_at=0);for(var image_index=start_at,stop=Math.max.apply(null,Object.keys(nm.controller._indexMap)),i=start_at;i<=stop;i++)if(nm.controller._indexMap[i]&&nm.controller._indexMap[i].uid){var uid=nm.controller._indexMap[i].uid;if(uid){var data=egw.dataGetUIDdata(uid);if(data&&data.data&&data.data.mime&&MIME_REGEX.test(data.data.mime)){var media=this.getMedia(data.data);images[image_index++]=jQuery.extend({},data.data,media[0])}}}else images[image_index++]=IMAGE_DEFAULT},set_slide=function(index,image){for(var active=index==gallery.index;index>gallery.getNumber();)gallery.add([jQuery.extend({},IMAGE_DEFAULT)]);if(image.loading)gallery.slidesContainer.find('[data-index="'+index+'"]').hasClass(gallery.options.slideErrorClass)&&jQuery(gallery.slides[index]).addClass(gallery.options.slideLoadingClass).removeClass(gallery.options.slideErrorClass);else{jQuery(gallery.slides[index]).removeClass(gallery.options.slideLoadingClass);var new_index=gallery.num;gallery.add([image]),gallery.list[index]=gallery.list[new_index],gallery.list.splice(new_index,1);var dom_nodes=["indicators","slides"];for(var i in dom_nodes){var var_name=dom_nodes[i];jQuery(gallery[var_name][index]).remove(),gallery[var_name][index]=gallery[var_name][new_index];var node=jQuery(gallery[var_name][index]);node.attr("data-index",index).insertAfter(jQuery("[data-index='"+(index-1)+"']",node.parent())),active&&node.addClass(gallery.options.activeIndicatorClass),gallery[var_name].splice(new_index,1)}active&&(gallery.activeIndicator=jQuery(gallery.indicators[index])),gallery.positions[index]=active?0:index>gallery.index?gallery.slideWidth:-gallery.slideWidth,gallery.positions.splice(new_index,1),gallery.elements[index]&&(delete gallery.elements[index],gallery.loadElement(index)),gallery.num-=1}};return function(_super){function exposable(){for(var args=[],_i=0;_i<arguments.length;_i++)args[_i]=arguments[_i];var _this=_super.apply(this,args)||this;_this.mime_regexp=MIME_REGEX,_this.mime_odf_regex=MIME_ODF_REGEX;var self=_this;_this.expose_options={container:"#blueimp-gallery",slidesContainer:"div",titleElement:"h3",displayClass:"blueimp-gallery-display",controlsClass:"blueimp-gallery-controls",singleClass:"blueimp-gallery-single",leftEdgeClass:"blueimp-gallery-left",rightEdgeClass:"blueimp-gallery-right",playingClass:"blueimp-gallery-playing",slideClass:"slide",slideLoadingClass:"",slideErrorClass:"slide-error",slideContentClass:"slide-content",toggleClass:"toggle",prevClass:"prev",nextClass:"next",closeClass:"close",playPauseClass:"play-pause",fullscreenClass:"fullscreen",typeProperty:"type",titleProperty:"title",urlProperty:"href",displayTransition:!0,clearSlides:!0,stretchImages:!0,toggleControlsOnReturn:!0,toggleSlideshowOnSpace:!0,enableKeyboardNavigation:!0,closeOnEscape:!0,closeOnSlideClick:!1,closeOnSwipeUpOrDown:!0,emulateTouchEvents:!0,stopTouchEventsPropagation:!1,hidePageScrollbars:!0,disableScroll:!0,carousel:!0,continuous:!1,unloadElements:!0,startSlideshow:!1,slideshowInterval:3e3,index:0,preloadRange:2,transitionSpeed:400,hideControlsOnSlideshow:!0,toggleFullscreenOnSlideShow:!0,slideshowTransitionSpeed:void 0,indicatorContainer:"ol",activeIndicatorClass:"active",thumbnailProperty:"thumbnail",thumbnailIndicators:!0,thumbnailWithImgTag:!0,onopen:jQuery.proxy(_this.expose_onopen,_this),onopened:jQuery.proxy(_this.expose_onopened,_this),onslide:function(index,slide){self.expose_onslide.apply(self,[this,index,slide])},onslideend:function(index,slide){self.expose_onslideend.apply(self,[this,index,slide])},onslidecomplete:function(index,slide){self.expose_onslidecomplete.apply(self,[this,index,slide])},onclose:jQuery.proxy(_this.expose_onclose,_this),onclosed:jQuery.proxy(_this.expose_onclosed,_this)};var $body=jQuery("body");if(0==$body.find("#blueimp-gallery").length){var $expose_node=jQuery(document.createElement("div")).attr({id:"blueimp-gallery",class:"blueimp-gallery"});$expose_node.append('<div class="slides"></div><h3 class="title"></h3><a class="prev">‹</a><a class="next">›</a><a title="'+egw().lang("Close")+'" class="close">×</a><a title="'+egw().lang("Play/Pause")+'"  class="play-pause"></a><a title="'+egw().lang("Fullscreen")+'" class="fullscreen"></a><a title="'+egw().lang("Save")+'" class="download"></a><ol class="indicator"></ol>'),$body.append($expose_node)}return _this}return __extends(exposable,_super),exposable.prototype.set_value=function(_value){if(_super.prototype.set_value.call(this,_value),this.options.expose_view){var fe=egw_get_file_editor_prefered_mimes(),self=this;_value&&"string"==typeof _value.mime&&(_value.mime.match(MIME_REGEX,"ig")||fe&&(!fe.mime||fe.mime[_value.mime]))&&void 0!==_value.download_url&&void 0!==this.options.expose_view&&this.options.expose_view&&jQuery(this.node).on("click",(function(event){event.altKey||event.ctrlKey||event.shiftKey||event.metaKey||(_value.mime.match(MIME_REGEX,"ig")?self._init_blueimp_gallery(event,_value):fe&&fe.mime&&fe.edit&&fe.mime[_value.mime]&&egw.open_link(egw.link("/index.php",{menuaction:fe.edit.menuaction,path:_value.path,cd:"no"}),"",fe.edit_popup)),event.stopImmediatePropagation()})).addClass("et2_clickable")}},exposable.prototype._init_blueimp_gallery=function(event,_value){var mediaContent=[],nm=find_nextmatch(this),current_index=0;if(nm&&!this._is_target_indepth(nm,event.target)){var current_entry=nm.controller.getRowByNode(event.target);read_from_nextmatch.call(this,nm,mediaContent);for(var i=0;i<mediaContent.length;i++)if("filemanager::"+mediaContent[i].path==current_entry.uid){current_index=i;break}window.setTimeout((function(){nm.applyFilters({col_filter:{mime:"/"+MIME_REGEX.source+"/"}})}),1)}else mediaContent=this.getMedia(_value),this.expose_options.thumbnailIndicators=!1;this.expose_options.index=current_index,gallery=blueimp.Gallery(mediaContent,this.expose_options)},exposable.prototype._is_target_indepth=function(nm,target){var res=!1;if(nm){if(!target)this.getDOMNode();var entry=nm.controller.getRowByNode(target);entry&&entry.controller.getDepth()>0&&(res=!0)}return res},exposable.prototype.expose_onopen=function(event){},exposable.prototype.expose_onopened=function(){var nm=find_nextmatch(this),self=this;if(nm&&nm.controller._grid.getTotalCount()>=gallery.num){var $indicator=gallery.container.find(".indicator");$indicator.off().addClass("paginating").swipe((function(event,direction,distance){if(direction==jQuery.fn.swipe.directions.LEFT)distance*=-1;else if(direction!=jQuery.fn.swipe.directions.RIGHT)return;jQuery(this).css("left",min(0,parseInt(jQuery(this).css("left"))-30*distance)+"px")})),$indicator.bind("mousewheel DOMMousewheel",(function(event,_delta){var delta=_delta||event.originalEvent.wheelDelta/120;if(!(delta>0&&parseInt(jQuery(this).css("left"))>gallery.container.width()/2))if(delta<0&&jQuery(this).width()+parseInt(jQuery(this).css("left"))<gallery.container.width()){var nextIndex=gallery.indicatorContainer.find('[title="loading"]')[0];nextIndex&&self.expose_onslideend(gallery,nextIndex.dataset.index-1)}else jQuery(this).css("left",parseInt(jQuery(this).css("left"))- -delta*gallery.activeIndicator.width()*5+"px"),event.preventDefault()}))}},exposable.prototype.expose_onslide=function(gallery,index,slide){if(_super.prototype.expose_onslide.call(this,gallery,index,slide),find_nextmatch(this)){var indicator=gallery.container.find(".indicator"),current=jQuery(".active",indicator).position();current&&indicator.animate({left:gallery.container.width()/2-current.left},10)}},exposable.prototype.expose_onslideend=function(gallery,index){var nm=find_nextmatch(this);if(nm){var total_count=nm.controller._grid.getTotalCount();if(index==total_count-1||0==index)return;var direction=1;for(var i in gallery.elements)if(1==gallery.elements[i]||3==gallery.elements[i]||gallery.list[i].loading){direction=i>=index?1:-1;break}if(!gallery.list[index+direction]||gallery.list[index+direction].loading||total_count>gallery.getNumber()&&index+ET2_DATAVIEW_STEPSIZE>gallery.getNumber()){var start=Math.max(0,direction>0?index:index-ET2_DATAVIEW_STEPSIZE),end=Math.min(total_count-1,start+ET2_DATAVIEW_STEPSIZE);nm.controller._gridCallback(start,end);var images=[];for(var i in read_from_nextmatch.call(this,nm,images,start),images)set_slide(i,images[i])}}},exposable.prototype.expose_onslidecomplete=function(){},exposable.prototype.expose_onclose=function(){var nm=find_nextmatch(this);nm&&!this._is_target_indepth(nm)&&(gallery.container.find(".indicator").removeClass("paginating").off("mousewheel").off("swipe"),nm.applyFilters({col_filter:{mime:""}}))},exposable.prototype.expose_onclosed=function(){},exposable}(Base)}
/**
 * EGroupware eTemplate2 - JS Description object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0}),require("./et2_core_common");et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget");var et2_description=function(_super){function et2_description(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(et2_description,_super),et2_description}(expose(((_a=function(_super){function et2_description(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_description._attributes,_child||{}))||this;return _this._labelContainer=null,_this.span=jQuery(document.createElement(_this.options.for?"label":"span")).addClass("et2_label"),et2_insertLinkText(_this._parseText(_this.options.value),_this.span[0],_this.options.href?_this.options.extra_link_target:"_blank"),_this.setDOMNode(_this.span[0]),_this}return __extends(et2_description,_super),et2_description.prototype.transformAttributes=function(_attrs){if(_super.prototype.transformAttributes.call(this,_attrs),this.id){var val=this.getArrayMgr("content").getEntry(this.id);val&&(_attrs.value=val)}},et2_description.prototype.doLoadingFinished=function(){_super.prototype.doLoadingFinished.call(this);var for_widget=null;if(this.options.for&&((for_widget=this.getParent().getWidgetById(this.options.for))||(for_widget=this.getRoot().getWidgetById(this.options.for)))&&for_widget&&for_widget.id){if(!for_widget.dom_id){var tab_deferred=jQuery.Deferred();return window.setTimeout(function(){this.span.attr("for",for_widget.dom_id),tab_deferred.resolve()}.bind(this),0),tab_deferred.promise()}this.span.attr("for",for_widget.dom_id)}return!0},et2_description.prototype.set_label=function(_value){if(_value!=this.label){if(_value){null==this._labelContainer&&(this._labelContainer=jQuery(document.createElement("label")).addClass("et2_label"),this.getSurroundings().insertDOMNode(this._labelContainer[0])),this._labelContainer.empty();var ph=document.createElement("span");this.getSurroundings().setWidgetPlaceholder(ph);for(var parts=et2_csvSplit(_value,2,"%s"),i=0;i<parts.length;i++)parts[i]&&this._labelContainer.append(document.createTextNode(parts[i])),0==i&&this._labelContainer.append(ph);this._labelContainer.toggleClass("et2_label_empty",!_value||!parts[0])}else this._labelContainer&&this.getSurroundings().removeDOMNode(this._labelContainer[0]),this._labelContainer=null;this.getSurroundings().update(),this.label=_value}},et2_description.prototype.getMedia=function(_value){var base_url=egw.webserverUrl.match(new RegExp(/^\//,"ig"))?egw(window).window.location.origin:"",mediaContent=[];return _value&&(mediaContent=[{title:this.options.label,href:base_url+_value,type:this.options.type+"/*",thumbnail:base_url+_value}],_value.match(/\/webdav.php/,"ig")&&(mediaContent[0].download_href=base_url+_value+"?download")),mediaContent},et2_description.prototype.set_value=function(_value){if(_value||(_value=""),this.options.no_lang||(_value=this.egw().lang(_value)),this.options.value&&-1!=(this.options.value+"").indexOf("%s")&&(_value=this.options.value.replace(/%s/g,_value)),et2_insertLinkText(this._parseText(_value),this.span[0],this.options.href?this.options.extra_link_target:"_blank"),this.options.hover_action&&this._build_hover_action(),this.options.extra_link_popup||this.options.mime){var href=this.options.href,mime_data=this.options.mime_data,self=this;(this.options.mime_data?jQuery(this.span):jQuery("a",this.span)).click((function(e){return self.options.expose_view&&void 0!==self.options.mime&&self.options.mime.match(self.mime_regexp,"ig")?self._init_blueimp_gallery(e,href):egw(window).open_link(mime_data||href,self.options.extra_link_target,self.options.extra_link_popup,null,null,self.options.mime),e.preventDefault(),!1}))}},et2_description.prototype._parseText=function(_value){if(this.options.href){var href=this.options.href;return-1==href.indexOf("/")&&href.split(".").length>=3&&-1==href.indexOf("mailto:")&&-1==href.indexOf("://")&&-1==href.indexOf("javascript:")&&(href="/index.php?menuaction="+href),"/"==href.charAt(0)&&(href=egw.link(href)),[{href:href,text:_value}]}return this.options.activate_links?et2_activateLinks(_value):[_value]},et2_description.prototype.set_font_style=function(_value){this.font_style=_value,this.span.toggleClass("et2_bold",_value.indexOf("b")>=0),this.span.toggleClass("et2_italic",_value.indexOf("i")>=0)},et2_description.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value","class","href")},et2_description.prototype.getDetachedNodes=function(){return[this.span[0]]},et2_description.prototype.setDetachedAttributes=function(_nodes,_values,_data){var updateLink=!1;void 0!==_values.href&&(updateLink=!0,this.options.href=_values.href),(void 0!==_values.value||updateLink&&(_values.value||this.options.value))&&(this.span=jQuery(_nodes[0]),this.set_value(_values.value)),void 0!==_values.class&&_nodes[0].setAttribute("class",_values.class),this.options.hover_action&&this._build_hover_action(_data)},et2_description.prototype._build_hover_action=function(_data){var content=_data&&_data.content?_data.content:void 0,widget=this;this.span.off().on("mouseenter",jQuery.proxy((function(event){event.stopImmediatePropagation();var self=this;this.span.tooltip({items:"span.et2_label",position:{my:"right top",at:"left top",collision:"flipfit"},tooltipClass:"et2_email_popup",content:function(){return jQuery('<a href="#" class= "et2_url_email_contactPlus" title="'+widget.egw().lang(widget.options.hover_action_title)+'"><img src="'+egw.image("edit")+'"/></a>').on("click",(function(){widget.options.hover_action.call(self,self.widget,content)}))},close:function(event,ui){ui.tooltip.hover((function(){jQuery(this).stop(!0).fadeTo(400,1)}),(function(){jQuery(this).fadeOut("400",(function(){jQuery(this).remove()}))}))}}).tooltip("open")}),{widget:this,span:this.span}))},et2_description}((et2_core_baseWidget_1=require("./et2_core_baseWidget")).et2_baseWidget))._attributes={label:{name:"Label",default:"",type:"string",description:"The label is displayed by default in front (for radiobuttons behind) each widget (if not empty). If you want to specify a different position, use a '%s' in the label, which gets replaced by the widget itself. Eg. '%s Name' to have the label Name behind a checkbox. The label can contain variables, as descript for name. If the label starts with a '@' it is replaced by the value of the content-array at this index (with the '@'-removed and after expanding the variables).",translate:!0},value:{name:"Value",type:"string",description:"Displayed text",translate:"!no_lang",default:""},font_style:{name:"Font Style",type:"string",description:'Style may be a compositum of "b" and "i" which  renders the text bold and/or italic.'},href:{name:"Link URL",type:"string",description:"Link URL, empty if you don't wan't to display a link."},activate_links:{name:"Replace URLs",type:"boolean",default:!1,description:"If set, URLs in the text are automatically replaced by links"},for:{name:"Label for widget",type:"string",description:"Marks the text as label for the given widget."},extra_link_target:{name:"Link target",type:"string",default:"_browser",description:"Link target for href attribute"},extra_link_popup:{name:"Popup",type:"string",description:"widthxheight, if popup should be used, eg. 640x480"},expose_view:{name:"Expose view",type:"boolean",default:!1,description:"Clicking on description with href value would popup an expose view, and will show content referenced by href."},mime:{name:"Mime type",type:"string",default:"",description:"Mime type of the registered link"},mime_data:{name:"Mime data",type:"string",default:"",description:"hash for data stored on service-side with egw_link::(get|set)_data()"},hover_action:{name:"hover action",type:"js",default:et2_no_init,description:"JS code which is executed when clicking on action button. This action is explicitly for attached nodes, like in nm."},hover_action_title:{name:"hover action title",type:"string",default:"Edit",description:"Text to show as tooltip of defined action"}},_a.legacyOptions=["font_style","href","activate_links","for","extra_link_target","extra_link_popup","statustext"],_a)));exports.et2_description=et2_description,et2_core_widget_1.et2_register_widget(et2_description,["description","label"]);
/*
 * Egroupware etemplate2 JS Entry widget
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_valueWidget_1=require("./et2_core_valueWidget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_entry=function(_super){function et2_entry(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_entry._attributes,_child||{}))||this;_this.widget=null,_attrs.id&&_attrs.id.indexOf(et2_entry.prefix)<0&&(_attrs.id=et2_entry.prefix+_attrs.id);var value=_attrs.value;return _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_entry._attributes,_child||{}))||this,value&&(_this.options.value=value),_this.widget=null,_this.setDOMNode(document.createElement("span")),_this}return __extends(et2_entry,_super),et2_entry.prototype.loadFromXML=function(_node){_super.prototype.loadFromXML.call(this,_node),this.loadField()},et2_entry.prototype.loadField=function(){var attrs={id:this.id+(this.options.field?"["+this.options.field+"]":""),type:"label",readonly:this.options.readonly},modifications=this.getArrayMgr("modifications");modifications&&this.options.field&&jQuery.extend(attrs,modifications.getEntry(attrs.id)),"template"==attrs.type&&this.options.label&&(this.egw().debug("log","Surpressed label on <"+this.getType()+' label="'+this.options.label+'" id="'+this.id+'"...>'),this.options.label="");var widget=et2_createWidget(attrs.type,attrs,this);if("string"==typeof this.options.value?widget.options.value=this.getArrayMgr("content").getEntry(this.id+"["+this.options.field+"]")||this.getRoot().getArrayMgr("content").getEntry(et2_entry.prefix+this.options.value+"["+this.options.field+"]"):this.options.field&&this.options.value&&this.options.value[this.options.field]&&(widget.options.value=this.options.value[this.options.field]),this.options.compare&&(widget.options.value=widget.options.value==this.options.compare?"X":""),this.options.alternate_fields){for(var sum=0,fields=this.options.alternate_fields.split(":"),i=0;i<fields.length;i++){var negate="-"==fields[i][0],value=this.getArrayMgr("content").getEntry(fields[i].replace("-",""));if(sum+=void 0===value?0:parseFloat(value)*(negate?-1:1),value&&"sum"!==this.options.field){widget.options.value=value;break}}"sum"==this.options.field&&(this.options.precision&&jQuery.isNumeric(sum)&&(sum=parseFloat(sum).toFixed(this.options.precision)),widget.options.value=sum)}},et2_entry._attributes={field:{name:"Fields",description:'Which entry field to display, or "sum" to add up the alternate_fields',type:"string"},compare:{name:"Compare",description:"if given, the selected field is compared with its value and an X is printed on equality, nothing otherwise",default:et2_no_init,type:"string"},alternate_fields:{name:"Alternate fields",description:"colon (:) separated list of alternative fields.  The first non-empty one is used if the selected field is empty, (-) used for subtraction",type:"string",default:et2_no_init},precision:{name:"Decimals to be shown",description:"Specifies the number of decimals for sum of alternates, the default is 2",type:"string",default:"2"},regex:{name:"Regular expression pattern",description:"Only used server-side in a preg_replace with regex_replace to modify the value",default:et2_no_init,type:"string"},regex_replace:{name:"Regular expression replacement pattern",description:"Only used server-side in a preg_replace with regex to modify the value",default:et2_no_init,type:"string"},value:{type:"any"},readonly:{default:!0}},et2_entry.legacyOptions=["field","compare","alternate_fields"],et2_entry.prefix="~",et2_entry}(et2_core_valueWidget_1.et2_valueWidget);et2_core_widget_1.et2_register_widget(et2_entry,["entry","contact-value","contact-account","contact-template","infolog-value","tracker-value","records-value"]);
/**
 * EGroupware eTemplate2 - JS Textbox object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0}),require("./et2_core_common");et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget"),et2_core_valueWidget_1=require("./et2_core_valueWidget");var et2_textbox=function(_super){function et2_textbox(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_textbox._attributes,_child||{}))||this;return _this.input=null,_this.input=null,_this.createInputWidget(),_this}return __extends(et2_textbox,_super),et2_textbox.prototype.createInputWidget=function(){if(this.options.multiline||this.options.rows>1||this.options.cols>1)this.input=jQuery(document.createElement("textarea")),this.options.rows>0&&this.input.attr("rows",this.options.rows),this.options.cols>0&&this.input.attr("cols",this.options.cols);else{switch(this.input=jQuery(document.createElement("input")),this.options.type){case"hidden":this.input.attr("type","hidden")}this.options.autocomplete&&this.input.attr("autocomplete",this.options.autocomplete)}if(this.options.size&&this.set_size(this.options.size),this.options.blur&&this.set_blur(this.options.blur),this.options.readonly&&this.set_readonly(!0),this.input.addClass("et2_textbox"),this.setDOMNode(this.input[0]),this.options.value&&this.set_value(this.options.value),this.options.onkeypress&&"function"==typeof this.options.onkeypress){var self=this;this.input.keypress((function(_ev){return self.options.onkeypress.call(this,_ev,self)}))}},et2_textbox.prototype.destroy=function(){var node=this.getInputNode();node&&jQuery(node).unbind("keypress"),_super.prototype.destroy.call(this)},et2_textbox.prototype.getValue=function(){return this.options&&this.options.blur&&!this.input[0].placeholder&&this.input.val()==this.options.blur?"":_super.prototype.getValue.call(this)},et2_textbox.prototype.isValid=function(_messages){var ok=!0;if(this.options&&this.options.validator&&!this.options.readonly&&!this.disabled){if("string"==typeof this.options.validator){var parts=this.options.validator.split("/"),flags=parts.pop();if(parts.length<2||""!==parts[0])return _messages.push(this.egw().lang("'%1' has an invalid format !!!",this.options.validator)),!1;parts.shift(),this.options.validator=new RegExp(parts.join("/"),flags)}var value=this.getValue();(ok=this.options.validator.test(value))||_messages.push(this.egw().lang("'%1' has an invalid format !!!",value))}return _super.prototype.isValid.call(this,_messages)&&ok},et2_textbox.prototype.set_size=function(_size){this.options.multiline||this.options.rows>1||this.options.cols>1?this.input.css("width",_size+"em"):void 0!==_size&&_size!=parseInt(this.input.attr("size"))&&(this.size=_size,this.input.attr("size",this.size))},et2_textbox.prototype.set_maxlength=function(_size){void 0!==_size&&_size!=parseInt(this.input.attr("maxlength"))&&(this.maxLength=_size,this.input.attr("maxLength",this.maxLength))},et2_textbox.prototype.set_readonly=function(_readonly){this.input.attr("readonly",_readonly),this.input.toggleClass("et2_textbox_ro",_readonly)},et2_textbox.prototype.set_blur=function(_value){_value?(this.input.attr("placeholder",this.egw().lang(_value)+""),this.input[0].placeholder||(""==this.input.val()&&this.input.val(this.egw().lang(this.options.blur)),this.input.focus(this,(function(e){e.data.input.val()==e.data.egw().lang(e.data.options.blur)&&e.data.input.val("")})).blur(this,(function(e){""==e.data.input.val()&&e.data.input.val(e.data.egw().lang(e.data.options.blur))})))):(this.getValue()||this.input.val(""),this.input.removeAttr("placeholder")),this.options.blur=_value},et2_textbox.prototype.set_autocomplete=function(_value){this.options.autocomplete=_value,this.input.attr("autocomplete",_value)},et2_textbox.prototype.resize=function(_height){_height&&this.options.multiline&&0!=(_height=""!=this.options.resize_ratio?_height*this.options.resize_ratio:_height)&&(this.input.height(this.input.height()+_height),this.input.parent().height(this.input.parent().height()+_height))},et2_textbox._attributes={multiline:{name:"multiline",type:"boolean",default:!1,description:"If true, the textbox is a multiline edit field."},size:{name:"Size",type:"integer",default:et2_no_init,description:"Field width"},maxlength:{name:"Maximum length",type:"integer",default:et2_no_init,description:"Maximum number of characters allowed"},blur:{name:"Placeholder",type:"string",default:"",description:"This text get displayed if an input-field is empty and does not have the input-focus (blur). It can be used to show a default value or a kind of help-text."},rows:{name:"Rows",type:"integer",default:-1,description:"Multiline field height - better to use CSS"},cols:{name:"Size",type:"integer",default:-1,description:"Multiline field width - better to use CSS"},validator:{name:"Validator",type:"string",default:et2_no_init,description:"Perl regular expression eg. '/^[0-9][a-f]{4}$/i'"},onkeypress:{name:"onKeypress",type:"js",default:et2_no_init,description:"JS code or app.$app.$method called when key is pressed, return false cancels it."}},et2_textbox.legacyOptions=["size","maxlength","validator"],et2_textbox}((et2_core_inputWidget_1=require("./et2_core_inputWidget")).et2_inputWidget);exports.et2_textbox=et2_textbox,et2_core_widget_1.et2_register_widget(et2_textbox,["textbox","hidden"]);var et2_textbox_ro=function(_super){function et2_textbox_ro(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_textbox_ro._attributes,_child||{}))||this;return _this.value="",_this.span=jQuery(document.createElement("label")).addClass("et2_label"),_this.value_span=jQuery(document.createElement("span")).addClass("et2_textbox_ro").appendTo(_this.span),_this.setDOMNode(_this.span[0]),_this}return __extends(et2_textbox_ro,_super),et2_textbox_ro.prototype.set_label=function(label){this.span.contents().filter((function(){return 3==this.nodeType})).remove();var parts=et2_csvSplit(label,2,"%s");this.span.prepend(parts[0]),this.span.append(parts[1]),this.label=label,this.span.toggleClass("et2_label_empty",!label||!parts[0])},et2_textbox_ro.prototype.set_value=function(_value){this.value=_value,_value||(_value=""),""!=this.label?this.span.removeClass("et2_label_empty"):this.span.addClass("et2_label_empty"),this.value_span.text(_value)},et2_textbox_ro.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value","label")},et2_textbox_ro.prototype.getDetachedNodes=function(){return[this.span[0],this.value_span[0]]},et2_textbox_ro.prototype.setDetachedAttributes=function(_nodes,_values){this.span=jQuery(_nodes[0]),this.value_span=jQuery(_nodes[1]),void 0!==_values.label&&this.set_label(_values.label),void 0!==_values.value&&this.set_value(_values.value)},et2_textbox_ro._attributes={multiline:{ignore:!0},maxlength:{ignore:!0},onchange:{ignore:!0},rows:{ignore:!0},cols:{ignore:!0},size:{ignore:!0},needed:{ignore:!0}},et2_textbox_ro}(et2_core_valueWidget_1.et2_valueWidget);exports.et2_textbox_ro=et2_textbox_ro,et2_core_widget_1.et2_register_widget(et2_textbox_ro,["textbox_ro"]);var et2_searchbox=function(_super){function et2_searchbox(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_searchbox._attributes,_child||{}))||this;return _this.value="",_this}return __extends(et2_searchbox,_super),et2_searchbox.prototype.createInputWidget=function(){var self=this;this.div=jQuery(document.createElement("div")).addClass("et2_searchbox"),this.flex=jQuery(document.createElement("div")).addClass("flex").appendTo(this.div),this.setDOMNode(this.div[0]),this.options.overlay&&this.flex.addClass("overlay"),this.options.fix||(this.button=jQuery(document.createElement("button")).css({"background-image":egw.image("search")}).click((function(){self._show_hide(jQuery(self.flex).hasClass("hide")),self.search.input.focus()})).addClass("et2_button"),this.div.prepend(this.button)),this.search=et2_core_widget_1.et2_createWidget("textbox",{blur:egw.lang("search"),onkeypress:function(event){13==event.which&&(event.preventDefault(),self.getInstanceManager().autocomplete_fixer(),window.setTimeout((function(){self.set_value(self.search.input.val()),self.change()}),0))}},this),this.search.input.attr("name",this.id||"searchbox"),this.search.input.on({keyup:function(event){self.clear.toggle(""!=self.get_value()||!self.options.fix),27==event.which&&self.set_value("")},blur:function(event){egwIsMobile()||(event.relatedTarget&&jQuery(event.relatedTarget.parentNode).hasClass("et2_searchbox")||self._show_hide(!self.options.overlay&&self.get_value()),void 0!==self.oldValue&&self._oldValue!=self.get_value()&&self.change())},mousedown:function(event){"span"==event.target.tagName&&event.stopImmediatePropagation()}}),this.clear=jQuery(document.createElement("span")).addClass("ui-icon clear").toggle(!this.options.fix||""!=this._oldValue&&!jQuery.isEmptyObject(this._oldValue)).on("mousedown",(function(event){event.preventDefault()})).on("click",(function(event){self.get_value()?(self.search.input.val(""),self.search.input.focus(),self._show_hide(!0),self._oldValue&&self.change()):self._show_hide(!1),self.options.fix&&self.clear.hide()})).appendTo(this.flex)},et2_searchbox.prototype._show_hide=function(_stat){this.options.fix||(jQuery(this.flex).toggleClass("hide",!_stat),jQuery(this.getDOMNode(this)).toggleClass("expanded",_stat))},et2_searchbox.prototype._searchToggleState=function(){this.options.fix||egwIsMobile()||(this.get_value()?(jQuery(this.button.getDOMNode()).addClass("toolbar_toggled"),this.button.set_statustext(egw.lang("search for '%1'",this.get_value()))):(jQuery(this.button.getDOMNode()).removeClass("toolbar_toggled"),this.button.set_statustext("")))},et2_searchbox.prototype.change=function(){this._searchToggleState(),_super.prototype.change.apply(this,arguments)},et2_searchbox.prototype.get_value=function(){return this.search.input.val()},et2_searchbox.prototype.set_value=function(_value){_super.prototype.set_value.call(this,_value),this.search&&(this.search.input.val(_value),this.clear.toggle(""!=_value))},et2_searchbox.prototype.set_readonly=function(_readonly){this.search.set_readonly(_readonly)},et2_searchbox.prototype.set_blur=function(_value){this.search.set_blur(_value)},et2_searchbox.prototype.doLoadingFinished=function(){return _super.prototype.doLoadingFinished.call(this),this.get_value()?(this._show_hide(!this.options.overlay),this._searchToggleState()):this._show_hide(!1),!0},et2_searchbox.prototype.getDOMNode=function(asker){return asker&&asker.getParent()==this?this.flex[0]:_super.prototype.getDOMNode.call(this,asker)},et2_searchbox.prototype.attachToDOM=function(){var ret=_super.prototype.attachToDOM.call(this),node=this.getInputNode();return node&&jQuery(node).off(".et2_inputWidget"),ret},et2_searchbox._attributes={overlay:{name:"Overlay searchbox",type:"boolean",default:!1,description:"Define wheter the searchbox overlays while it's open (true) or stay as solid box infront of the search button (false). Default is false."},fix:{name:"Fix searchbox",type:"boolean",default:!0,description:"Define whether the searchbox should be a fix input field or flexible search button. Default is true (fix)."}},et2_searchbox}(et2_textbox);et2_core_widget_1.et2_register_widget(et2_searchbox,["searchbox"]);
/**
 * EGroupware eTemplate2 - JS Number object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});var et2_widget_textbox_1=require("./et2_widget_textbox"),et2_number=(et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance"),function(_super){function et2_number(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_number._attributes,_child||{}))||this;return _this.min=null,_this.max=null,_this.step=null,_this}return __extends(et2_number,_super),et2_number.prototype.transformAttributes=function(_attrs){_super.prototype.transformAttributes.call(this,_attrs),void 0===_attrs.validator&&(_attrs.validator="float"==_attrs.type?"/^-?[0-9]*[,.]?[0-9]*$/":"/^-?[0-9]*$/")},et2_number.prototype.isValid=function(_messages){var ok=!0;return this.input&&this.input[0]&&this.input[0].validationMessage&&!this.input[0].validity.stepMismatch&&(_messages.push(this.input[0].validationMessage),ok=!1),_super.prototype.isValid.call(this,_messages)&&ok},et2_number.prototype.createInputWidget=function(){if(this.input=jQuery(document.createElement("input")),this.input.attr("type","number"),this.input.addClass("et2_textbox"),this.input.on("invalid",jQuery.proxy(this.change,this)),this.options.onkeypress&&"function"==typeof this.options.onkeypress){var self=this;this.input.keypress((function(_ev){return self.options.onkeypress.call(this,_ev,self)}))}this.setDOMNode(this.input[0])},et2_number.prototype.set_size=function(_size){void 0!==_size&&_size!=this.input.attr("size")&&(this.size=_size,this.input.attr("size",this.size),void 0!==this.options.class&&-1!=this.options.class.search("et2_fullWidth")||this.input.css("width",_size+"em"))},et2_number.prototype.set_min=function(_value){this.min=_value,null==this.min?this.input.removeAttr("min"):this.input.attr("min",this.min)},et2_number.prototype.set_max=function(_value){this.max=_value,null==this.max?this.input.removeAttr("max"):this.input.attr("max",this.max)},et2_number.prototype.set_step=function(_value){this.step=_value,null==this.step?this.input.removeAttr("step"):this.input.attr("step",this.step)},et2_number._attributes={value:{type:"float"},size:{default:5},min:{name:"Minimum",type:"integer",default:et2_no_init,description:"Minimum allowed value"},max:{name:"Maximum",type:"integer",default:et2_no_init,description:"Maximum allowed value"},step:{name:"step value",type:"integer",default:et2_no_init,description:"Step attribute specifies the interval between legal numbers"},precision:{name:"Precision",type:"integer",default:et2_no_init,description:"Allowed precision - # of decimal places",ignore:!0}},et2_number}(et2_widget_textbox_1.et2_textbox));exports.et2_number=et2_number,et2_core_widget_1.et2_register_widget(et2_number,["int","integer","float"]);var et2_number_ro=function(_super){function et2_number_ro(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(et2_number_ro,_super),et2_number_ro.prototype.set_value=function(_value){void 0!==this.options.precision&&""+_value!=""&&(_value=parseFloat(_value).toFixed(this.options.precision)),_super.prototype.set_value.call(this,_value)},et2_number_ro._attributes={min:{ignore:!0},max:{ignore:!0},precision:{name:"Precision",type:"integer",default:et2_no_init,description:"Allowed precision - # of decimal places",ignore:!0},value:{type:"float"}},et2_number_ro}(et2_textbox_ro);et2_core_widget_1.et2_register_widget(et2_number_ro,["int_ro","integer_ro","float_ro"]);
/**
 * EGroupware eTemplate2 - JS Textbox object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0}),require("./et2_core_common");et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget"),et2_widget_textbox_1=require("./et2_widget_textbox");var et2_widget_dialog_1=require("./et2_widget_dialog"),et2_password=function(_super){function et2_password(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_password._attributes,_child||{}))||this;return _this.encrypted=!0,_this.options.plaintext&&(_this.encrypted=!1),_this}return __extends(et2_password,_super),et2_password.prototype.createInputWidget=function(){if(this.wrapper=jQuery(document.createElement("div")).addClass("et2_password"),this.input=jQuery(document.createElement("input")),this.input.attr("type","password"),""!==this.options.autocomplete&&"off"!=this.options.autocomplete||(this.options.autocomplete="new-password"),this.options.size&&this.set_size(this.options.size),this.options.blur&&this.set_blur(this.options.blur),this.options.readonly&&this.set_readonly(!0),this.input.addClass("et2_textbox").appendTo(this.wrapper),this.setDOMNode(this.wrapper[0]),this.options.value&&this.set_value(this.options.value),this.options.onkeypress&&"function"==typeof this.options.onkeypress){var self=this;this.input.on("keypress",(function(_ev){return self.options.onkeypress.call(this,_ev,self)}))}this.input.on("change",function(){this.encrypted=!1}.bind(this));var attrs={class:"show_hide",image:"visibility",onclick:this.toggle_visibility.bind(this),statustext:this.egw().lang("Show password")};this.options.viewable&&(this.show_button=et2_core_widget_1.et2_createWidget("button",attrs,this))},et2_password.prototype.getInputNode=function(){return this.input[0]},et2_password.prototype.set_id=function(_value){_super.prototype.set_id.call(this,_value),"off"===this.options.autocomplete&&this.input.removeAttr("name")},et2_password.prototype.set_viewable=function(viewable){this.options.viewable=viewable,viewable?jQuery(".show_hide",this.wrapper).show():jQuery(".show_hide",this.wrapper).hide()},et2_password.prototype.set_suggest=function(length){if("number"!=typeof length&&(length="string"==typeof length?parseInt(length):length?et2_password.DEFAULT_LENGTH:0),this.options.suggest=length,length&&!this.suggest_button){var attrs={class:"generate_password",image:"generate_password",onclick:this.suggest_password.bind(this),statustext:this.egw().lang("Suggest password")};this.suggest_button=et2_core_widget_1.et2_createWidget("button",attrs,this),this.parentNode&&this.suggest_button.loadingFinished()}length?jQuery(".generate_password",this.wrapper).show():jQuery(".generate_password",this.wrapper).hide()},et2_password.prototype.toggle_visibility=function(on){if("boolean"!=typeof on&&(on="password"==this.input.attr("type")),this.options.viewable)if(this.show_button&&this.show_button.set_image(this.egw().image(on?"visibility_off":"visibility")),this.encrypted&&on){var callback=function(button,user_password){if(button==et2_widget_dialog_1.et2_dialog.CANCEL_BUTTON)return this.toggle_visibility(!1);egw.json("EGroupware\\Api\\Etemplate\\Widget\\Password::ajax_decrypt",[user_password,this.options.value],(function(decrypted){decrypted?(this.encrypted=!1,this.input.val(decrypted),this.input.attr("type","textbox")):(this.set_validation_error(this.egw().lang("invalid password")),window.setTimeout(function(){this.set_validation_error(!1)}.bind(this),2e3))}),this,!0,this).sendRequest()}.bind(this),prompt=et2_widget_dialog_1.et2_dialog.show_prompt(callback,this.egw().lang("Enter your password"),this.egw().lang("Authenticate"));prompt.div.on("load",(function(){jQuery(prompt.template.widgetContainer.getWidgetById("value").getInputNode()).attr("type","password")}))}else this.input.attr("type",on?"textbox":"password");else this.input.attr("type","password")},et2_password.prototype.suggest_password=function(){this.encrypted=!1,this.options.viewable=!0,this.toggle_visibility(!0);egw.json("EGroupware\\Api\\Etemplate\\Widget\\Password::ajax_suggest",[this.options.suggest],(function(suggestion){this.encrypted=!1,this.input.val(suggestion),this.input.trigger("change");var two=this.getParent().getWidgetById(this.id+"_2");two&&two.getType()==this.getType()&&(two.options.viewable=!0,two.toggle_visibility(!0),two.set_value(suggestion))}),this,!0,this).sendRequest()},et2_password.prototype.destroy=function(){_super.prototype.destroy.call(this)},et2_password.prototype.getValue=function(){return this.input.val()},et2_password._attributes={autocomplete:{name:"Autocomplete",type:"string",default:"off",description:"Whether or not browser should autocomplete that field: 'on', 'off', 'default' (use attribute from form). Default value is set to off."},viewable:{name:"Viewable",type:"boolean",default:!1,description:"Allow password to be shown"},plaintext:{name:"Plaintext",type:"boolean",default:!0,description:"Password is plaintext"},suggest:{name:"Suggest password",type:"integer",default:0,description:"Suggest password length (0 for off)"}},et2_password.DEFAULT_LENGTH=16,et2_password}(et2_widget_textbox_1.et2_textbox);exports.et2_password=et2_password,et2_core_widget_1.et2_register_widget(et2_password,["passwd"]);var et2_password_ro=function(_super){function et2_password_ro(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(et2_password_ro,_super),et2_password_ro.prototype.set_value=function(value){this.value_span.text(value?"********":"")},et2_password_ro}(et2_widget_textbox_1.et2_textbox_ro);exports.et2_password_ro=et2_password_ro,et2_core_widget_1.et2_register_widget(et2_password_ro,["passwd_ro"]),
/**
	 * jQuery BASE64 functions
	 * 
	 * 	<code>
	 * 		Encodes the given data with base64. 
	 * 		String $.base64Encode ( String str )
	 *		<br />
	 * 		Decodes a base64 encoded data.
	 * 		String $.base64Decode ( String str )
	 * 	</code>
	 * 
	 * Encodes and Decodes the given data in base64.
	 * This encoding is designed to make binary data survive transport through transport layers that are not 8-bit clean, such as mail bodies.
	 * Base64-encoded data takes about 33% more space than the original data. 
	 * This javascript code is used to encode / decode data using base64 (this encoding is designed to make binary data survive transport through transport layers that are not 8-bit clean). Script is fully compatible with UTF-8 encoding. You can use base64 encoded data as simple encryption mechanism.
	 * If you plan using UTF-8 encoding in your project don't forget to set the page encoding to UTF-8 (Content-Type meta tag). 
	 * This function orginally get from the WebToolkit and rewrite for using as the jQuery plugin.
	 * 
	 * Example
	 * 	Code
	 * 		<code>
	 * 			$.base64Encode("I'm Persian."); 
	 * 		</code>
	 * 	Result
	 * 		<code>
	 * 			"SSdtIFBlcnNpYW4u"
	 * 		</code>
	 * 	Code
	 * 		<code>
	 * 			$.base64Decode("SSdtIFBlcnNpYW4u");
	 * 		</code>
	 * 	Result
	 * 		<code>
	 * 			"I'm Persian."
	 * 		</code>
	 * 
	 * @alias Muhammad Hussein Fattahizadeh < muhammad [AT] semnanweb [DOT] com >
	 * @link http://www.semnanweb.com/jquery-plugin/base64.html
	 * @see http://www.webtoolkit.info/
	 * @license http://www.gnu.org/licenses/gpl.html [GNU General Public License]
	 * @param {jQuery} {base64Encode:function(input))
	 * @param {jQuery} {base64Decode:function(input))
	 * @return string
	 */
function($){var keyString="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";$.extend({base64Encode:function(input){var chr1,chr2,chr3,enc1,enc2,enc3,enc4,output="",i=0;for(input=function(string){string=string.replace(/\x0d\x0a/g,"\n");for(var output="",n=0;n<string.length;n++){var c=string.charCodeAt(n);c<128?output+=String.fromCharCode(c):c>127&&c<2048?(output+=String.fromCharCode(c>>6|192),output+=String.fromCharCode(63&c|128)):(output+=String.fromCharCode(c>>12|224),output+=String.fromCharCode(c>>6&63|128),output+=String.fromCharCode(63&c|128))}return output}(input);i<input.length;)enc1=(chr1=input.charCodeAt(i++))>>2,enc2=(3&chr1)<<4|(chr2=input.charCodeAt(i++))>>4,enc3=(15&chr2)<<2|(chr3=input.charCodeAt(i++))>>6,enc4=63&chr3,isNaN(chr2)?enc3=enc4=64:isNaN(chr3)&&(enc4=64),output=output+keyString.charAt(enc1)+keyString.charAt(enc2)+keyString.charAt(enc3)+keyString.charAt(enc4);return output},base64Decode:function(input){var chr1,chr2,chr3,enc2,enc3,enc4,output="",i=0;for(input=input.replace(/[^A-Za-z0-9\+\/\=]/g,"");i<input.length;)chr1=keyString.indexOf(input.charAt(i++))<<2|(enc2=keyString.indexOf(input.charAt(i++)))>>4,chr2=(15&enc2)<<4|(enc3=keyString.indexOf(input.charAt(i++)))>>2,chr3=(3&enc3)<<6|(enc4=keyString.indexOf(input.charAt(i++))),output+=String.fromCharCode(chr1),64!=enc3&&(output+=String.fromCharCode(chr2)),64!=enc4&&(output+=String.fromCharCode(chr3));return output=function(input){for(var string="",i=0,c=c1=c2=0;i<input.length;)(c=input.charCodeAt(i))<128?(string+=String.fromCharCode(c),i++):c>191&&c<224?(c2=input.charCodeAt(i+1),string+=String.fromCharCode((31&c)<<6|63&c2),i+=2):(c2=input.charCodeAt(i+1),c3=input.charCodeAt(i+2),string+=String.fromCharCode((15&c)<<12|(63&c2)<<6|63&c3),i+=3);return string}(output)}})}(jQuery);
/**
 * EGroupware eTemplate2 - JS URL object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2011
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_widget_textbox_1=require("./et2_widget_textbox"),et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_valueWidget_1=require("./et2_core_valueWidget");var et2_url=function(_super_1){function et2_url(){var _this=null!==_super_1&&_super_1.apply(this,arguments)||this;return _this._button=null,_this.value="",_this}return __extends(et2_url,_super_1),et2_url.prototype.createInputWidget=function(){this.input=jQuery(document.createElement("input")).blur(this,this.validate).blur(this,(function(e){e.data.set_value(e.data.getValue())})),this._button=null,this.size&&this.set_size(this.size),this.setDOMNode(this.input[0])},et2_url.prototype.destroy=function(){this.input&&this.input.unbind(),this._button=null,_super_1.prototype.destroy.call(this)},et2_url.prototype.set_value=function(_value){this.update_button(_value),_super_1.prototype.set_value.call(this,_value)},et2_url.prototype.update_button=function(_value){if(this.value!=_value)if(_value)switch(null==this._button&&(this._button=jQuery(document.createElement("a")).addClass("et2_url"),this.getSurroundings().insertDOMNode(this._button[0]),this.getSurroundings().update()),this._button.removeClass("url phone email").removeAttr("href"),_value=this.get_link(this.getType(),_value),this.getType()){case"url":this._button.attr("href",_value).attr("target","_blank").addClass("url");break;case"url-phone":case"url-fax":_value?"function"==typeof _value?this._button.click(this,_value).addClass("phone").show():this._button.attr("href",_value).addClass("phone").show():!1===_value&&this._button.hide();break;case"url-email":"function"==typeof _value?this._button.click(this,_value).addClass("email"):this._button.attr("href",_value).addClass("email")}else this._button&&this._button.hide(),this._button&&this.getSurroundings&&this.getSurroundings().removeDOMNode&&this.getSurroundings().removeDOMNode(this._button[0]),this._button=null},et2_url.prototype.get_link=function(type,value){if(!value)return!1;switch("url-fax"===type&&this.egw().config("fax_email")&&(value=value.replace("&#9829;","").replace("(0)","").replace(/[^0-9+]/g,""))&&(value=value.replace(new RegExp(this.egw().config("fax_email_regexp")||"(.*)"),this.egw().config("fax_email")),type="url-email"),type){case"url":-1==value.indexOf("://")&&(value="http://"+value);break;case"url-phone":case"url-fax":if(value=(value=(value=(value=value.replace("&#9829;","").replace("(0)","")).replace(/[abc]/gi,2).replace(/[def]/gi,3).replace(/[ghi]/gi,4).replace(/[jkl]/gi,5).replace(/[mno]/gi,6)).replace(/[pqrs]/gi,7).replace(/[tuv]/gi,8).replace(/[wxyz]/gi,9)).replace(/[^0-9+]/g,""),-1===navigator.userAgent.indexOf("AppleWebKit")||-1===navigator.userAgent.indexOf("iPhone")&&-1===navigator.userAgent.indexOf("Android")||-1!=value.indexOf("tel:")){if(!this.egw().config("call_link"))return!1;var link=this.egw().config("call_link").replace("%1","tel:"==this.egw().config("call_link").substr(0,4)?value:encodeURIComponent(value)).replace("%u",this.egw().user("account_lid")).replace("%t",this.egw().user("account_phone")),popup=this.egw().config("call_popup");value=function(ev){if((!popup||"_self"===popup)&&link.match(/^https?:/))return(egw.window?egw.window.jQuery:jQuery).ajax({url:link,async:!0,dataType:"json",type:"GET"}),ev.preventDefault(),!1;egw.open_link(link,"_phonecall",popup)}}else value="tel:"+value;break;case"url-email":if(-1==value.indexOf("mailto:")&&(value="mailto:"+value),(this.egw().user("apps").mail||this.egw().user("apps").felamimail)&&"1"!=this.egw().preference("force_mailto","addressbook"))return function(){egw.open_link(value)}}return value},et2_url.prototype.validate=function(e){e.data.hideMessage(),e.data._super&&e.data._super.apply(this,arguments);var value=jQuery.trim(e.data.getValue());if(""!=value)switch(e.data._type){case"url":-1!=value.indexOf("://")||e.data.options.allow_path?e.data.options.allow_path&&"/"!==value[0]&&e.data.showMessage(e.data.egw().lang("Path must start with '/'"),"hint",!0):(e.data.set_value("http://"+value),e.data.showMessage(e.data.egw().lang("Protocol is required"),"hint",!0)),!0===e.data.options.trailing_slash&&"/"!==value[value.length-1]?e.data.set_value(value+"/"):!1===e.data.options.trailing_slash&&"/"===value[value.length-1]&&e.data.set_value(value.substr(0,value.length-1));break;case"url-email":(!et2_url.EMAIL_PREG.test(value)||value.indexOf("<")>0&&value.indexOf(">")!=value.length-1||value.indexOf(">")>0&&value.indexOf("<")<0)&&e.data.showMessage("Invalid email","validation_error",!0)}},et2_url.prototype.attachToDOM=function(){var res=_super_1.prototype.attachToDOM.call(this);return this.input[0].parentNode&&jQuery(this.input[0].parentNode).addClass("et2_url_span"),res},et2_url._attributes={multiline:{ignore:!0},allow_path:{type:"boolean",name:"Allow path",description:"Allow a path instead of a URL, path must start with /",default:!1},trailing_slash:{type:"boolean",name:"Trailing slash",description:"Require (or forbid) that the path ends with a /",default:et2_no_init}},et2_url.EMAIL_PREG=new RegExp(/^(([^\042',<][^,<]+|\042[^\042]+\042|\'[^\']+\'|"(?:[^"\\]|\\.)*")\s?<)?[^\x00-\x20()\xe2\x80\x8b<>@,;:\042\[\]\x80-\xff]+@([a-z0-9ÄÖÜäöüß](|[a-z0-9ÄÖÜäöüß_-]*[a-z0-9ÄÖÜäöüß])\.)+[a-z]{2,}>?$/i),et2_url}(et2_widget_textbox_1.et2_textbox);et2_core_widget_1.et2_register_widget(et2_url,["url","url-email","url-phone","url-fax"]);var et2_url_ro=function(_super_1){function et2_url_ro(_parent,_attrs,_child){var _this=_super_1.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_url_ro._attributes,_child||{}))||this;return _this.value="",_this.span=null,_this.value="",_this.span=jQuery(document.createElement("a")).addClass("et2_textbox readonly"),egw.config("call_link")||"url-phone"!=_this.getType()||egwIsMobile()||(_this.span=jQuery(document.createElement("span")).addClass("et2_textbox readonly")),"url-email"==_this.getType()&&_this.span.addClass("et2_email"),_this.setDOMNode(_this.span[0]),_this}return __extends(et2_url_ro,_super_1),et2_url_ro.prototype.set_value=function(_value){this.value=_value;var link=et2_url.prototype.get_link(this.getType(),_value);if(!link)return this.span.text(_value),void this.span.removeAttr("href");switch(this.span.text(_value),this.getType()){case"url":this.span.attr("href",link).attr("target","_blank");break;case"url-phone":case"url-fax":"function"==typeof link?(this.span.off("click.et2_url"),this.span.on("click.et2_url",link),this.span.attr("href","#")):link&&this.span.attr("href",link);break;case"url-email":if("function"==typeof link?(this.span.off("click.et2_url"),this.span.on("click.et2_url",link),this.span.removeAttr("href")):(this.span.attr("href",link),this.span.attr("target")||this.span.attr("target","_blank")),this.span.text()&&this.span.text().split("<")&&this.options.full_email){var val=this.span.text().split("<");val=""!=val[0]?val[0]:val[2],this.span.attr("title",_value),this.span.text(val.replace(/"/g,"")),this.span.append("<span class='noemail'>"+_value.replace(val,"").replace(/</g,"&lt;").replace(/>/g,"&gt;")+"</span>")}if(this.options.contact_plus){if(!egw.app("addressbook"))return;this.span.on("mouseenter",jQuery.proxy((function(event){event.stopImmediatePropagation(),this.widget._add_contact_tooltip.call(this,et2_url_ro.email_cache[this.value]),void 0===et2_url_ro.email_cache[this.value]&&this.widget.egw().jsonq("EGroupware\\Api\\Etemplate\\Widget\\Url::ajax_contact",this.value,this.widget._add_contact_tooltip,this)}),{widget:this,span:this.span,value:this.value}))}}},et2_url_ro.prototype._add_contact_tooltip=function(email_exists){var value=this.value||this.widget.value||null;et2_url_ro.email_cache[value]=email_exists,jQuery(".et2_email").each((function(){jQuery(this).tooltip("instance")&&jQuery(this).tooltip("close")})),!email_exists&&this.span.is(":hover")&&(this.span.tooltip({items:"a.et2_email",position:{my:"right top",at:"left top",collision:"flipfit"},tooltipClass:"et2_email_popup",content:function(){var extra={"presets[email]":jQuery(this).attr("title")?jQuery(this).attr("title"):jQuery(this).text()};return jQuery('<a href="#" class= "et2_url_email_contactPlus" title="'+egw.lang("Add a new contact")+'"><img src="'+(void 0===email_exists?egw.image("loading"):egw.image("new"))+'"/></a>').on("click",(function(){egw.open("","addressbook","add",extra)}))},close:function(event,ui){ui.tooltip.hover((function(){jQuery(this).stop(!0).fadeTo(400,1)}),(function(){jQuery(this).fadeOut("400",(function(){jQuery(this).remove()}))}))}}).tooltip("open"),jQuery(".egwGridView_scrollarea").one("scroll",jQuery.proxy((function(){this.tooltip("instance")&&this.tooltip("destroy")}),this.span)))},et2_url_ro.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value","class","statustext")},et2_url_ro.prototype.getDetachedNodes=function(){return[this.span[0]]},et2_url_ro.prototype.setDetachedAttributes=function(_nodes,_values){this.span=jQuery(_nodes[0]),void 0!==_values.value&&this.set_value(_values.value),void 0!==_values.class&&_nodes[0].setAttribute("class",_values.class),this.span.attr("title",_values.statustext?_values.statustext:this.options.statustext)},et2_url_ro._attributes={contact_plus:{name:"Add contact button",type:"boolean",default:!1,description:"Allow to add email as contact to addressbook"},full_email:{name:"Show full email address",type:"boolean",default:!0,description:"Allow to show full email address if ture otherwise show only name"}},et2_url_ro.email_cache=[],et2_url_ro}(et2_core_valueWidget_1.et2_valueWidget);et2_core_widget_1.et2_register_widget(et2_url_ro,["url_ro","url-email_ro","url-phone_ro","url-fax_ro"]);
/**
 * EGroupware eTemplate2 - JS Selectbox object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @author Andreas Stöckel
 * @copyright Nathan Gray 2011
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0}),exports.et2_menulist=exports.et2_selectbox_ro=exports.et2_selectbox=void 0,require("./et2_core_common");et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget"),et2_core_inputWidget_1=require("./et2_core_inputWidget"),et2_core_DOMWidget_1=require("./et2_core_DOMWidget");var et2_selectbox=function(_super){function et2_selectbox(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_selectbox._attributes,_child||{}))||this;return _this.input=null,_this.value="",_this.selected_first=!0,_this._is_multiple_regexp=/^[,0-9A-Za-z/_ -]+$/,_this._escape_value_replace=/\\/g,_this._escape_value_with="\\\\",_this.input=null,_this.value="",_this.supportedWidgetClasses=[],"string"==typeof _this.options.rows&&(isNaN(_this.options.rows)?(_this.options.empty_label=_this.egw().lang(_this.options.rows),_this.options.rows=1):_this.options.rows=parseInt(_this.options.rows)),_this.options.rows>1?(_this.options.multiple=!0,_this.options.tags?_this.createInputWidget():_this.createMultiSelect()):_this.createInputWidget(),_this.options.empty_label||_this.options.readonly||!_this.options.multiple||(_this.options.empty_label=_this.egw().lang("Select some options")),_this}return __extends(et2_selectbox,_super),et2_selectbox.prototype.destroy=function(){null!=this.input&&this.input.unchosen(),this.expand_button&&(this.expand_button.off(),this.expand_button.remove(),this.expand_button=null),_super.prototype.destroy.call(this),this.input=null},et2_selectbox.prototype.transformAttributes=function(_attrs){if(_super.prototype.transformAttributes.call(this,_attrs),!(this.options&&this.options.select_options&&!jQuery.isEmptyObject(this.options.select_options)||_attrs.select_options&&!jQuery.isEmptyObject(_attrs.select_options)||void 0===_attrs.select_options||null===_attrs.select_options)||(!this.getParent()||"rowWidget"==this.getParent().getType())&&_attrs.id&&"0"==_attrs.id[0]){var sel_options=et2_selectbox.find_select_options(this,_attrs.select_options,_attrs);jQuery.isEmptyObject(sel_options)||(_attrs.select_options=sel_options)}},et2_selectbox.prototype.set_multiple=function(_multiple,_size){this.options.multiple=_multiple,this.input&&(_multiple?(this.input.attr("size",_size||3),this.input.prop("multiple",!0),this.input.attr("name",this.id+"[]"),this.input[0].options.length&&""===this.input[0].options[0].value&&(this.input[0].options[0]=null)):(this.input.prop("multiple",!1),this.input.removeAttr("size"),this.input.attr("name",this.id),this.options.empty_label&&""!==this.input[0].options[0].value&&this._appendOptionElement("",this.options.empty_label)),this.expand_button&&(_multiple?this.expand_button.addClass("ui-icon-minus").removeClass("ui-icon-plus"):this.expand_button.removeClass("ui-icon-minus").addClass("ui-icon-plus")))},et2_selectbox.prototype.change=function(_node,_widget,_value){var valid=_super.prototype.change.apply(this,arguments);if(!this.input)return valid;var selected=this.input.siblings().find("a.chzn-single"),val=_value&&_value.selected?_value.selected:this.input.val();switch(this.getType()){case"select-country":selected&&1==selected.length&&val?(selected.removeClass((function(index,className){return(className.match(/(^|\s)flag-\S+/g)||[]).join(" ")})),selected.find("span.img").remove(),selected.prepend('<span class="img"></span>'),selected.addClass("et2_country-select flag-"+val.toLowerCase())):selected&&selected.removeClass("et2_country-select")}return valid},et2_selectbox.prototype._appendOptionElement=function(_value,_label,_title,dom_element,_class){if(""!=_value||null!=_label&&""!=_label){if(null==this.input)return this._appendMultiOption(_value,_label,_title,dom_element);var option=jQuery(document.createElement("option")).attr("value",_value).text(_label+"");if(option.addClass(_class),this.options.tags){switch(this.getType()){case"select-cat":option.addClass("cat_"+_value);break;case"select-country":option.addClass("et2_country-select flag-"+_value.toLowerCase())}""!=this.options.value_class&&option.addClass(this.options.value_class+_value)}void 0!==_title&&_title&&option.attr("title",_title),_label==this.options.empty_label||""==this.options.empty_label&&""===_value?option.prependTo(this.input):option.appendTo(dom_element||this.input)}},et2_selectbox.prototype._appendMultiOption=function(_value,_label,_title,dom_element){var option_data=null;if("object"==typeof _label&&(_label=(option_data=_label).label),_label!=this.options.empty_label){var opt_id=this.dom_id+"_opt_"+_value,label=jQuery(document.createElement("label")).attr("for",opt_id).hover((function(){jQuery(this).addClass("ui-state-hover")}),(function(){jQuery(this).removeClass("ui-state-hover")})),option=jQuery(document.createElement("input")).attr("type","checkbox").attr("id",opt_id).attr("value",_value).appendTo(label);if(void 0!==_title&&option.attr("title",_title),option_data){if(option_data.icon){var img=this.egw().image(option_data.icon);jQuery(document.createElement(img?"img":"div")).attr("src",img).addClass("cat_icon cat_"+_value).appendTo(label)}option_data.color&&label.css("background-color",option_data.color).addClass("cat_"+_value)}void 0===_title&&(_title=_label),label.append(jQuery("<span title='"+_title+"'>"+_label+"</span>"));var li=jQuery(document.createElement("li")).append(label);""!=this.options.value_class&&li.addClass(this.options.value_class+_value),li.appendTo(dom_element||this.multiOptions)}},et2_selectbox.prototype.createInputWidget=function(){this.input=jQuery(document.createElement("select")).addClass("et2_selectbox").attr("size",this.options.rows),this.setDOMNode(this.input[0]),this.options.empty_label&&this._appendOptionElement("",this.options.empty_label),this.options.multiple&&this.input.attr("multiple","multiple")},et2_selectbox.prototype.createMultiSelect=function(){var node=jQuery(document.createElement("div")).addClass("et2_selectbox"),header=jQuery(document.createElement("div")).addClass("ui-widget-header ui-helper-clearfix").appendTo(node),controls=jQuery(document.createElement("ul")).addClass("ui-helper-reset").appendTo(header);jQuery(document.createElement("span")).text(this.options.empty_label).addClass("ui-multiselect-header").appendTo(header);var options=this.multiOptions=jQuery(document.createElement("ul"));if(this.multiOptions.addClass("ui-multiselect-checkboxes ui-helper-reset").css("height",1.9*this.options.rows+"em").appendTo(node),this.options.rows>=5){var header_controls={check:{icon_class:"ui-icon-check",label:this.egw().lang("Check all"),click:function(e){var all_off=!1;jQuery("input[type='checkbox']",e.data).each((function(){jQuery(this).prop("checked")||(all_off=!0)})),jQuery("input[type='checkbox']",e.data).prop("checked",all_off)}}};for(var key in header_controls)jQuery(document.createElement("li")).addClass("et2_clickable").click(options,header_controls[key].click).attr("title",header_controls[key].label).append('<span class="ui-icon '+header_controls[key].icon_class+'"/>').appendTo(controls)}this.setDOMNode(node[0])},et2_selectbox.prototype.doLoadingFinished=function(){return _super.prototype.doLoadingFinished.call(this),this.set_tags(this.options.tags,this.options.width),this.resetDirty(),!0},et2_selectbox.prototype.loadFromXML=function(_node){var legacy;(legacy=_node.getAttribute("options"))&&((legacy=legacy.split(",")).length&&isNaN(legacy[0])&&(this.options.empty_label=legacy[0]));var options=et2_directChildrenByTagName(_node,"option");options.length&&(this.options.select_options=jQuery.extend([],this.options.select_options));for(var egw=this.egw(),i=0;i<options.length;i++)this.options.select_options.push({value:et2_readAttrWithDefault(options[i],"value",options[i].textContent),label:options[i].textContent.replace(/{([^}]+)}/g,(function(str,p1){return egw.lang(p1)})),title:et2_readAttrWithDefault(options[i],"title","")});this.set_select_options(this.options.select_options)},et2_selectbox.prototype.find_option=function(_value){return jQuery("option[value='"+("string"==typeof _value?_value.replace(this._escape_value_replace,this._escape_value_with):_value)+"']",this.input)},et2_selectbox.prototype.set_value=function(_value,_dont_try_set_options){if("number"==typeof _value&&(_value=""+_value),"string"==typeof _value&&(this.options.multiple||this.options.expand_multiple_rows)&&null!==_value.match(this._is_multiple_regexp)&&(_value=_value.split(",")),null!==this.input&&this.options.select_options&&(!jQuery.isEmptyObject(this.options.select_options)||this.options.select_options.length>0)&&0==this.input.children().length&&this.set_select_options(this.options.select_options),("select-cat"==this.getType()||this.options.value_class)&&this.options.tags){var chosen=this.input.next(),prefix_c=this.options.value_class?this.options.value_class:"cat_";this.input.removeClass(prefix_c+this._oldValue),this.input.addClass(prefix_c+this.value),chosen.length>0&&(chosen.removeClass(prefix_c+this._oldValue),chosen.addClass(prefix_c+this.value))}if("select-country"==this.getType()&&this.options.tags){var selected=this.input.siblings().find("a.chzn-single");selected&&1==selected.length&&_value&&(selected.removeClass((function(index,className){return(className.match(/(^|\s)flag-\S+/g)||[]).join(" ")})),selected.find("span.img").remove(),selected.prepend('<span class="img"></span>'),selected.addClass("et2_country-select flag-"+_value.toLowerCase()))}if("select-bitwise"==this.getType()&&_value&&!isNaN(_value)&&this.options.select_options){var new_value=[];for(var index in this.options.select_options){var right=this.options.select_options[index].value;_value&right&&new_value.push(right)}_value=new_value}if(this._oldValue=this.value,null===this.input||!this.options.tags&&!this.options.search){if(null==this.input)return this.set_multi_value(_value);if(this.options.expand_multiple_rows&&!this.options.multiple&&jQuery.isArray(_value)&&_value.length>1&&this.set_multiple(!0,this.options.expand_multiple_rows),jQuery("option",this.input).prop("selected",!1),"object"==typeof _value)for(var i in _value)this.find_option(_value[i]).prop("selected",!0);else if(_value&&0==this.find_option(_value).prop("selected",!0).length){if(this.options.select_options[_value]||this.options.select_options.filter&&this.options.select_options.filter((function(value){return value==_value}))&&!_dont_try_set_options)return this.set_select_options(this.options.select_options);if(_dont_try_set_options)this.value="";else if(jQuery.isEmptyObject(this.options.select_options))this.egw().debug("warn","Can't set value to '%s', widget has no options set",_value,this),this.value=null;else{var debug_value=_value;this.egw().debug("warn","Tried to set value '%s' that isn't an option",debug_value,this)}return}this.value=_value,this.isAttached()&&this._oldValue!==et2_no_init&&this._oldValue!==_value&&this.input.change()}else{this.input.val("object"==typeof _value&&null!=_value?jQuery.map(_value,(function(value,index){return[value]})):_value),this.input.trigger("liszt:updated");var self=this;"listbox"==this.getType()&&""!=this.options.value_class&&(chosen=this.input.next()).find(".search-choice-close").each((function(i,v){jQuery(v).parent().addClass(self.options.value_class+self.options.select_options[v.rel].value)})),this.value=_value}},et2_selectbox.prototype.find_multi_option=function(_value){return jQuery("input[value='"+("string"==typeof _value?_value.replace(this._escape_value_replace,this._escape_value_with):_value)+"']",this.multiOptions)},et2_selectbox.prototype.set_multi_value=function(_value){if(jQuery("input",this.multiOptions).prop("checked",!1),"object"==typeof _value)for(var i in _value)this.find_multi_option(_value[i]).prop("checked",!0);else if(0==this.find_multi_option(_value).prop("checked",!0).length){var debug_value=_value;this.egw().debug("warn","Tried to set value '%s' that isn't an option",debug_value,this)}this.selected_first&&this.multiOptions.find("li:has(input:checked)").prependTo(this.multiOptions),this.value=_value},et2_selectbox.prototype.select_all_toggle=function(){var all=jQuery("input",this.multiOptions);all.prop("checked",jQuery("input:checked",this.multiOptions).length!=all.length)},et2_selectbox.prototype.set_expand_multiple_rows=function(_rows){this.options.expand_multiple_rows=_rows;var surroundings=this.getSurroundings();if(_rows<=1&&this.expand_button)surroundings.removeDOMNode(this.expand_button.get(0));else{if(!this.expand_button){var button_id=this.getInstanceManager().uniqueId+"_"+this.id.replace(/\./g,"-")+"_expand";this.expand_button=jQuery("<button class='et2_button et2_button_icon et2_selectbox_expand ui-icon' id='"+button_id+"'/>").addClass(this.options.multiple?"ui-icon-minus":"ui-icon-plus").on("click",jQuery.proxy((function(e){void 0!==this.input.attr("size")&&1!=this.input.attr("size")?(this.set_multiple(!1,1),this.expand_button.removeClass("ui-icon-minus").addClass("ui-icon-plus")):(this.set_multiple(!0,this.options.expand_multiple_rows),this.expand_button.addClass("ui-icon-minus").removeClass("ui-icon-plus"))}),this))}surroundings.appendDOMNode(this.expand_button.get(0))}surroundings.update()},et2_selectbox.prototype.set_tags=function(_tags,_width){if(this.options.tags=_tags,this.isAttached())if(null==this.input||this.options.tags||this.options.search){if(null!=this.input&&(this.options.search||this.options.tags)&&!this.options.disabled){if(this.options.empty_label&&(this.input.attr("data-placeholder",this.options.empty_label),this.options.multiple&&this.input.children('[value=""]').remove()),this.input.hasClass("chzn-done"))return;var size=egw.getHiddenDimensions(this.input);if("listbox"==this.getType()&&""!=this.options.value_class){var self=this;this.input.find("option").each((function(i,v){jQuery(v).addClass(self.options.value_class+v.value)}))}if(this.input.chosen({inherit_select_classes:!0,search_contains:!0,width:_width||size.w+"px",allow_single_deselect:this.options.allow_single_deselect,no_results_text:this.egw().lang("No results match")}),this.input.siblings().find(".chzn-search input").attr("autocomplete","new-password"),"select-country"==this.getType()){var selected=this.input.siblings().find("a.chzn-single");selected&&1==selected.length&&this.getValue()&&(selected.removeClass((function(index,className){return(className.match(/(^|\s)flag-\S+/g)||[]).join(" ")})),selected.find("span.img").remove(),selected.prepend('<span class="img"></span>'),selected.addClass("et2_country-select flag-"+this.getValue().toLowerCase()))}if(this.options.onchange){jQuery(this.input).unbind("change.et2_inputWidget");self=this;this.input.chosen().change((function(_ev,_change){self.change.call(self,self.input,self,_change)}))}if(this.options.multiple&&1==this.options.rows&&this.options.height){var $chosen_div=jQuery(this.input.siblings()),_update_item_counter=(self=this,function(){$chosen_div.find("ul.chzn-choices").attr("data-after",self.getValue().length)});_update_item_counter(),$chosen_div.toggleClass("et2_selectbox_single_row",!0),$chosen_div.on("mouseleave mouseup",(function(e){jQuery(this).toggleClass("et2_selectbox_multi_row",!1),jQuery(this).toggleClass("et2_selectbox_single_row",!0),_update_item_counter()})),$chosen_div.on("mouseenter",(function(e){jQuery(this).toggleClass("et2_selectbox_multi_row",!0),jQuery(this).toggleClass("et2_selectbox_single_row",!1)}))}}}else this.input.unchosen().css("width","")},et2_selectbox.prototype.set_select_options=function(_options){for(var key in this.input?this.input.empty():this.multiOptions&&this.multiOptions.empty(),!this.options.empty_label||this.options.tags||this.options.search||this._appendOptionElement("",this.egw().lang(this.options.empty_label)),_options)if(this.options.no_lang||("object"==typeof _options[key]&&null!==_options[key]?(_options[key].label&&(_options[key].label=this.egw().lang(_options[key].label)),_options[key].title&&(_options[key].title=this.egw().lang(_options[key].title))):(Array.isArray(_options)&&_options.length>0||"object"==typeof _options)&&(_options[key]=this.egw().lang(_options[key]))),"object"==typeof _options[key]&&null!==_options[key])if(void 0===_options[key].label&&void 0===_options[key].title){var label=isNaN(key)?key:_options[key].value,group=jQuery(document.createElement("optgroup")).attr("label",this.options.no_lang?label:this.egw().lang(label)).appendTo(this.input);for(var sub in null==this.input&&(group=jQuery(document.createElement("ul")).append('<li class="ui-widget-header"><span>'+key+"</span></li>").appendTo(this.multiOptions)),_options[key])"value"!=sub&&("object"==typeof _options[key][sub]&&null!==_options[key][sub]?this._appendOptionElement(sub,_options[key][sub].label?_options[key][sub].label:"",_options[key][sub].title?_options[key][sub].title:"",group):this._appendOptionElement(sub,_options[key][sub],void 0,group))}else null==this.input?(_options[key].label=_options[key].label?_options[key].label:"",this._appendMultiOption(void 0!==_options[key].value?_options[key].value:key,_options[key],_options[key].title)):this._appendOptionElement(void 0!==_options[key].value?_options[key].value:key,_options[key].label?_options[key].label:"",_options[key].title?_options[key].title:"","",_options[key].class?_options[key].class:"");else this._appendOptionElement(key,_options[key]);this.options.empty_label&&this.options.tags&&this.options.allow_single_deselect&&!this.options.multiple&&jQuery(document.createElement("option")).attr("value","").prependTo(this.input);this.options.select_options=_options,(this.options.tags||this.options.search)&&this.input.trigger("liszt:updated"),null===this.value&&this.options.value?this.set_value(this.options.value,!0):(this.value||this.options.empty_label&&!this.options.multiple||""===this.value&&this.input&&1===this.input.children('[value=""]').length)&&this.set_value(this.value,!0)},et2_selectbox.prototype.getValue=function(){var value=[];return null==this.input?jQuery("input:checked",this.multiOptions).each((function(){value.push(this.value)})):null===(value=_super.prototype.getValue.call(this))&&(value=this.options.multiple?[]:""),value},et2_selectbox.prototype.isDirty=function(){if(null==this.input){var value=this.getValue();return!(0==jQuery(this._oldValue).not(value).length&&0==jQuery(value).not(this._oldValue).length)}return _super.prototype.isDirty.call(this)},et2_selectbox.prototype.set_disabled=function(_disable){_super.prototype.set_disabled.call(this,_disable),this.options.tags&&(this.input&&this.input.hide(),_disable?jQuery(this.node.nextElementSibling).hide():jQuery(this.node.nextElementSibling).show())},et2_selectbox.find_select_options=function(widget,attr_options,attrs){var name_parts=widget.id.replace(/&#x5B;/g,"[").replace(/]|&#x5D;/g,"").split("["),type_options={},content_options={},type=widget._type,type_function=type.replace("select-","").replace("taglist-","").replace("_ro","")+"_options";if("function"==typeof this[type_function]){var old_type=widget._type;widget._type=type.replace("taglist-","select-"),"string"==typeof attrs.other&&(attrs.other=attrs.other.split(",")),type_options=this[type_function].call(this,widget,attrs);try{type_options=JSON.parse(JSON.stringify(type_options))}catch(e){egw.debug(e)}widget._type=old_type}if(widget.getArrayMgr("sel_options")){if((content_options=widget.getArrayMgr("sel_options").getEntry(widget.id))&&(1==content_options.length&&"string"==typeof content_options[0]&&""==content_options[0].trim()||void 0!==content_options.value&&void 0!==content_options.label&&widget.id.match(/\[\d+\]$/))&&(content_options=null),content_options&&!isNaN(name_parts[name_parts.length-1])&&content_options.label&&content_options.title&&(name_parts.pop(),delete(content_options=widget.getArrayMgr("sel_options").getEntry(name_parts.join("["))).$row),content_options&&0!=content_options.length||(content_options=widget.getArrayMgr("sel_options").getRoot().getEntry(name_parts[name_parts.length-1])),content_options&&0!=content_options.length||(content_options=widget.getArrayMgr("sel_options").getEntry(name_parts[name_parts.length-1])),name_parts.length>1&&(!content_options||0==content_options.length))for(var pop_that=jQuery.extend([],name_parts);pop_that.length>0&&(!content_options||0==content_options.length);){var last=pop_that.pop();if((content_options=widget.getArrayMgr("sel_options").getEntry(pop_that.join("[")))&&!jQuery.isArray(content_options)&&void 0!==content_options[last]&&content_options[last])content_options=content_options[last];else if(content_options)for(var key in content_options)if(!(isNaN(key)&&"string"==typeof content_options[key]||!isNaN(key)&&"object"==typeof content_options[key]&&void 0!==content_options[key].value)){content_options=void 0;break}}for(var row_stuck=["${row}","{$row}"],i=0;i<row_stuck.length&&(!content_options||0==content_options.length);i++)if(widget.getArrayMgr("sel_options").perspectiveData.row||widget.getArrayMgr("sel_options").data[row_stuck[i]]){var row_id=widget.id.replace(/[0-9]+/,row_stuck[i]);(content_options=widget.getArrayMgr("sel_options").getEntry(row_id))&&0!=content_options.length||(content_options=widget.getArrayMgr("sel_options").getEntry(row_stuck[i]+"["+widget.id+"]"))}attr_options&&!jQuery.isEmptyObject(attr_options)&&content_options&&(content_options=jQuery.extend(!0,{},attr_options,content_options))}if(jQuery.isEmptyObject(content_options)&&null!=widget.getArrayMgr("content")){content_options&&(attr_options=content_options);var content_mgr=widget.getArrayMgr("content");content_mgr&&(content_options||(content_options=content_mgr.getEntry("options-"+widget.id)),content_options||(content_options=content_mgr.getRoot().getEntry("options-"+name_parts[name_parts.length-1])))}if(null==content_options&&(content_options={}),type_options.length||!jQuery.isEmptyObject(type_options)){for(var i in content_options){var value="object"==typeof content_options[i]&&void 0!==content_options[i].value?content_options[i].value:i,added=!1;for(var j in type_options)if(""+type_options[j].value==""+value){added=!0,type_options[j]=content_options[i];break}added||type_options.splice(i,0,content_options[i])}content_options=type_options}return content_options},et2_selectbox.priority_options=function(widget){return[{value:1,label:"low"},{value:2,label:"normal"},{value:3,label:"high"},{value:0,label:"undefined"}]},et2_selectbox.bool_options=function(widget){return[{value:0,label:"no"},{value:1,label:"yes"}]},et2_selectbox.month_options=function(widget){return[{value:1,label:"January"},{value:2,label:"February"},{value:3,label:"March"},{value:4,label:"April"},{value:5,label:"May"},{value:6,label:"June"},{value:7,label:"July"},{value:8,label:"August"},{value:9,label:"September"},{value:10,label:"October"},{value:11,label:"November"},{value:12,label:"December"}]},et2_selectbox.number_options=function(widget,attrs){"object"!=typeof attrs.other&&(attrs.other=[]);var options=[],min=void 0===attrs.other[0]?1:parseInt(attrs.other[0]),max=void 0===attrs.other[1]?10:parseInt(attrs.other[1]),interval=void 0===attrs.other[2]?1:parseInt(attrs.other[2]),format="%d";attrs.other[2]&&"0"==attrs.other[2][0]&&(format="%0"+(""+interval).length+"d"),attrs.other[3]&&(format+=widget.egw().lang(attrs.other[3])),min<=max!=interval>0&&(interval=-interval);for(var i=0,n=min;n<=max&&i<=100;n+=interval,++i)options.push({value:n,label:sprintf(format,n)});return options},et2_selectbox.percent_options=function(widget,attrs){return"object"!=typeof attrs.other&&(attrs.other=[]),attrs.other[0]=0,attrs.other[1]=100,attrs.other[2]=void 0===attrs.other[2]?10:parseInt(attrs.other[2]),attrs.other[3]="%%",this.number_options(widget,attrs)},et2_selectbox.year_options=function(widget,attrs){"object"!=typeof attrs.other&&(attrs.other=[]);var t=new Date;return attrs.other[0]=t.getFullYear()-(void 0===attrs.other[0]?3:parseInt(attrs.other[0])),attrs.other[1]=t.getFullYear()+(void 0===attrs.other[1]?2:parseInt(attrs.other[1])),attrs.other[2]=void 0===attrs.other[2]?1:parseInt(attrs.other[2]),this.number_options(widget,attrs)},et2_selectbox.day_options=function(widget,attrs){return attrs.other=[1,31,1],this.number_options(widget,attrs)},et2_selectbox.hour_options=function(widget,attrs){for(var options=[],timeformat=egw.preference("common","timeformat"),h=0;h<=23;++h)options.push({value:h,label:12==timeformat?h%12+" "+(h<12?egw.lang("am"):egw.lang("pm")):sprintf("%02d",h)});return options},et2_selectbox.app_options=function(widget,attrs){var options=","+(attrs.other||[]).join(",");return this.cached_server_side_options(widget,options,attrs)},et2_selectbox.cat_options=function(widget,attrs){void 0===attrs.other&&(attrs.other=new Array(4)),void 0===attrs.other[3]&&(attrs.other[3]=attrs.application||widget.getInstanceManager().app);var options=(attrs.other||[]).join(",");return this.cached_server_side_options(widget,options,attrs)},et2_selectbox.country_options=function(widget,attrs){return this.cached_server_side_options(widget,",",attrs)},et2_selectbox.state_options=function(widget,attrs){var options=attrs.country_code?attrs.country_code:"de";return this.cached_server_side_options(widget,options,attrs)},et2_selectbox.dow_options=function(widget,attrs){var options=","+(attrs.other||[]).join(",");return this.cached_server_side_options(widget,options,attrs)},et2_selectbox.lang_options=function(widget,attrs){var options=","+(attrs.other||[]).join(",");return this.cached_server_side_options(widget,options,attrs)},et2_selectbox.timezone_options=function(widget,attrs){var options=","+(attrs.other||[]).join(",");return this.cached_server_side_options(widget,options,attrs)},et2_selectbox.cached_server_side_options=function(widget,options_string,attrs){options_string=options_string.replace(/,+$/,"");var cache_id=widget._type+"_"+options_string,cache_owner=(egw.window.et2_selectbox?egw.window.et2_selectbox:egw(window).window.et2_selectbox).type_cache,cache=cache_owner[cache_id],in_nextmatch=!1;if(void 0===cache||void 0===cache.length)for(var parent=widget._parent;parent&&!in_nextmatch;)in_nextmatch=parent&&parent._type&&"nextmatch"===parent._type,parent=parent._parent;if(void 0===cache||in_nextmatch){var req=egw.json("EGroupware\\Api\\Etemplate\\Widget\\Select::ajax_get_options",[widget._type,options_string,attrs.value]).sendRequest(!in_nextmatch);void 0===cache&&(cache_owner[cache_id]=req),cache=req}if("function"==typeof cache.done)return cache.done(jQuery.proxy((function(response){cache=cache_owner[cache_id]=response.response[0].data||void 0,attrs.select_options=cache,egw.window.setTimeout(jQuery.proxy((function(){this.widget&&void 0!==this.widget.id&&this.widget.set_select_options(et2_selectbox.find_select_options(this.widget,{},this.widget.options))}),this),1)}),{widget:widget,cache_id:cache_id})),[];if(attrs.value&&""!=attrs.value&&"0"!=attrs.value&&"select-timezone"==attrs.type){for(var missing_option=!0,i=0;i<cache.length&&missing_option;i++)cache[i].value==attrs.value&&(missing_option=!1);if(missing_option)return delete cache_owner[cache_id],this.cached_server_side_options(widget,options_string,attrs);attrs.value&&widget&&widget.get_value()!==attrs.value&&egw.window.setTimeout(jQuery.proxy((function(){this.widget&&void 0!==this.widget.id&&this.widget.set_value(this.widget.options.value)}),{widget:widget}),1)}return cache},et2_selectbox._attributes={multiple:{name:"multiple",type:"boolean",default:!1,description:"Allow selecting multiple options"},expand_multiple_rows:{name:"Expand multiple",type:"integer",default:et2_no_init,description:"Shows single select widget, with a button.  If the user clicks the button, the input will toggle to a multiselect,with this many rows.  "},rows:{name:"Rows",type:"any",default:1,description:"Number of rows to display"},empty_label:{name:"Empty label",type:"string",default:"",description:"Textual label for first row, eg: 'All' or 'None'.  ID will be ''",translate:!0},select_options:{type:"any",name:"Select options",default:{},description:"Internaly used to hold the select options."},selected_first:{name:"Selected options first",type:"boolean",default:!0,description:"For multi-selects, put the selected options at the top of the list when first loaded"},search:{name:"Search",type:"boolean",default:!1,description:"For single selects, add a search box to the drop-down list"},tags:{name:"Tag style",type:"boolean",default:!1,description:"For multi-selects, displays selected as a list of tags instead of a big list"},allow_single_deselect:{name:"Allow Single Deselect",type:"boolean",default:!0,description:"Allow user to unset current selected value"},value:{type:"any"},other:{ignore:!0,type:"any"},value_class:{name:"Value class",type:"string",default:"",description:"Allow to set a custom css class combined with selected value. (e.g. cat_23)"}},et2_selectbox.legacyOptions=["rows","other"],et2_selectbox.type_cache={},et2_selectbox}(et2_core_inputWidget_1.et2_inputWidget);exports.et2_selectbox=et2_selectbox,et2_core_widget_1.et2_register_widget(et2_selectbox,["menupopup","listbox","select","select-cat","select-percent","select-priority","select-country","select-state","select-year","select-month","select-day","select-dow","select-hour","select-number","select-app","select-lang","select-bool","select-timezone","select-bitwise"]);var et2_selectbox_ro=function(_super){function et2_selectbox_ro(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_selectbox_ro._attributes,_child||{}))||this;return _this.optionValues={},_this.supportedWidgetClasses=[],_this.optionValues={},_this.options.select_options&&_this.set_select_options(_this.options.select_options),_this}return __extends(et2_selectbox_ro,_super),et2_selectbox_ro.prototype.createInputWidget=function(){this.span=jQuery(document.createElement("span")).addClass("et2_selectbox readonly").text(this.options.empty_label),this.setDOMNode(this.span[0])},et2_selectbox_ro.prototype.createMultiSelect=function(){this.span=jQuery(document.createElement("ul")).addClass("et2_selectbox readonly"),this.setDOMNode(this.span[0])},et2_selectbox_ro.prototype.loadFromXML=function(_node){for(var options=et2_directChildrenByTagName(_node,"options"),i=0;i<options.length;i++)this.optionValues[et2_readAttrWithDefault(options[i],"value",0)]={label:options[i].textContent,title:et2_readAttrWithDefault(options[i],"title","")}},et2_selectbox_ro.prototype.set_select_options=function(_options){for(var key in _options)this.options.no_lang||("object"==typeof _options[key]&&null!=_options[key]?(_options[key].label&&(_options[key].label=this.egw().lang(_options[key].label)),_options[key].title&&(_options[key].title=this.egw().lang(_options[key].title))):_options[key]=this.egw().lang(_options[key]));this.optionValues=_options},et2_selectbox_ro.prototype.set_value=function(_value){if(this.value=_value,"select-bitwise"==this.getType()&&_value&&!isNaN(_value)&&this.options.select_options){var new_value=[];for(var index in this.options.select_options){var right=(option=this.options.select_options[index])&&option.value?option.value:index;_value&right&&new_value.push(right)}_value=new_value}if("string"==typeof _value?_value=null!==_value.match(this._is_multiple_regexp)?_value.split(","):[_value]:"number"==typeof _value&&(_value=[_value]),this.span.empty(),_value)for(var i=0;i<_value.length;i++)for(var o in this.optionValues){var option;if(("object"==typeof(option=this.optionValues[o])&&null!=option&&void 0!==option.value?option.value:o)==_value[i]){var label="object"==typeof option?option.label:option;if(1==_value.length){this.span.text(label),"object"==typeof option&&option.title&&this.set_statustext(option.title);break}jQuery("<li>").text(label).attr("data-value",_value[i]).appendTo(this.span);break}}else this.options.empty_label&&this.span.text(this.options.empty_label)},et2_selectbox_ro.prototype.getValue=function(){return null},et2_selectbox_ro.prototype.isDirty=function(){return!1},et2_selectbox_ro.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value","select_options")},et2_selectbox_ro.prototype.getDetachedNodes=function(){return[this.span[0]]},et2_selectbox_ro.prototype.setDetachedAttributes=function(_nodes,_values){this.span=jQuery(_nodes[0]),void 0!==_values.select_options&&this.set_select_options(_values.select_options),this.set_value(_values.value)},et2_selectbox_ro}(et2_selectbox);exports.et2_selectbox_ro=et2_selectbox_ro,et2_core_widget_1.et2_register_widget(et2_selectbox_ro,["menupopup_ro","listbox_ro","select_ro","select-cat_ro","select-percent_ro","select-priority_ro","select-access_ro","select-country_ro","select-state_ro","select-year_ro","select-month_ro","select-day_ro","select-dow_ro","select-hour_ro","select-number_ro","select-app_ro","select-lang_ro","select-bool_ro","select-timezone_ro","select-bitwise_ro"]);var et2_menulist=function(_super){function et2_menulist(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_menulist._attributes,_child||{}))||this;return _this.supportedWidgetClasses=[et2_selectbox,et2_selectbox_ro],_this}return __extends(et2_menulist,_super),et2_menulist.prototype.getDOMNode=function(_sender){return _sender!=this?this.getParent().getDOMNode(this):null},et2_menulist.prototype.getChildren=function(){return this.getParent().getChildren()},et2_menulist._attributes={},et2_menulist}(et2_core_DOMWidget_1.et2_DOMWidget);exports.et2_menulist=et2_menulist,et2_core_widget_1.et2_register_widget(et2_menulist,["menulist"]);
/**
 * EGroupware eTemplate2 - JS Checkbox object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2011
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_inputWidget_1=require("./et2_core_inputWidget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_checkbox=function(_super){function et2_checkbox(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_checkbox._attributes,_child||{}))||this;return _this.input=null,_this.toggle=null,_this.input=null,_this.createInputWidget(),_this}return __extends(et2_checkbox,_super),et2_checkbox.prototype.createInputWidget=function(){if(this.input=jQuery(document.createElement("input")).attr("type","checkbox"),this.input.addClass("et2_checkbox"),this.options.toggle_on||this.options.toggle_off){var self_1=this;this.toggle=jQuery(document.createElement("span")).addClass("et2_checkbox_slideSwitch").append(this.input),this.input.change((function(){return self_1.getValue(),!0}));var area=jQuery(document.createElement("span")).addClass("slideSwitch_container").appendTo(this.toggle),on=jQuery(document.createElement("span")).addClass("on").appendTo(area),off=jQuery(document.createElement("span")).addClass("off").appendTo(area);on.text(this.options.toggle_on),off.text(this.options.toggle_off),jQuery(document.createElement("a")).appendTo(area),this.setDOMNode(this.toggle[0])}else this.setDOMNode(this.input[0])},et2_checkbox.prototype.set_label=function(label){label.length&&label.indexOf("%s")<0&&(label="%s"+label),_super.prototype.set_label.call(this,label),jQuery(this.getSurroundings().getWidgetSurroundings()).addClass("et2_checkbox_label")},et2_checkbox.prototype.set_value=function(_value){"0"===_value&&"0"!=this.options.selected_value&&(_value=!1),_value!=this.value&&(_value==this.options.selected_value||_value&&this.options.selected_value==this.attributes.selected_value.default&&_value!=this.options.unselected_value?((this.options.toggle_on||this.options.toggle_off)&&this.toggle.addClass("switchOn"),this.input.prop("checked",!0)):(this.input.prop("checked",!1),(this.options.toggle_on||this.options.toggle_off)&&this.toggle.removeClass("switchOn")))},et2_checkbox.prototype.set_readonly=function(_ro){jQuery(this.getDOMNode()).attr("disabled",_ro),this.input.prop("disabled",_ro)},et2_checkbox.prototype.getValue=function(){return this.input.prop("checked")?((this.options.toggle_on||this.options.toggle_off)&&this.toggle.addClass("switchOn"),this.options.selected_value):((this.options.toggle_on||this.options.toggle_off)&&this.toggle.removeClass("switchOn"),this.options.unselected_value)},et2_checkbox.prototype.set_disabled=function(_value){var parentNode=jQuery(this.getDOMNode()).parent();parentNode[0]&&"label"==parentNode[0].nodeName&&parentNode.hasClass(".et2_checkbox_label")&&(_value?parentNode.hide():parentNode.show()),_super.prototype.set_disabled.call(this,_value)},et2_checkbox._attributes={selected_value:{name:"Set value",type:"string",default:"true",description:"Value when checked"},unselected_value:{name:"Unset value",type:"string",default:"",description:"Value when not checked"},ro_true:{name:"Read only selected",type:"string",default:"X ",description:"What should be displayed when readonly and selected"},ro_false:{name:"Read only unselected",type:"string",default:"",description:"What should be displayed when readonly and not selected"},value:{type:"any"},toggle_on:{name:"Toggle on caption",type:"string",default:"",description:"String caption to show for ON status",translate:!0},toggle_off:{name:"Toggle off caption",type:"string",default:"",description:"String caption to show OFF status",translate:!0}},et2_checkbox.legacyOptions=["selected_value","unselected_value","ro_true","ro_false"],et2_checkbox}(et2_core_inputWidget_1.et2_inputWidget);exports.et2_checkbox=et2_checkbox,et2_core_widget_1.et2_register_widget(et2_checkbox,["checkbox"]);var et2_checkbox_ro=function(_super){function et2_checkbox_ro(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_checkbox_ro._attributes,_child||{}))||this;return _this.span=null,_this.value="",_this.span=jQuery(document.createElement("span")).addClass("et2_checkbox_ro"),_this.setDOMNode(_this.span[0]),_this}return __extends(et2_checkbox_ro,_super),et2_checkbox_ro.prototype.set_value=function(_value){_value==this.options.selected_value||_value&&this.options.selected_value==this.attributes.selected_value.default&&_value!=this.options.unselected_value?(this.span.text(this.options.ro_true),this.value=_value):this.span.text(this.options.ro_false)},et2_checkbox_ro.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value","class")},et2_checkbox_ro.prototype.getDetachedNodes=function(){return[this.span[0]]},et2_checkbox_ro.prototype.setDetachedAttributes=function(_nodes,_values){void 0!==_values.value&&(this.span=jQuery(_nodes[0]),this.set_value(_values.value)),void 0!==_values.class&&_nodes[0].setAttribute("class",_values.class)},et2_checkbox_ro._attributes={unselected_value:{ignore:!0}},et2_checkbox_ro}(et2_checkbox);et2_core_widget_1.et2_register_widget(et2_checkbox_ro,["checkbox_ro"]);
/**
 * EGroupware eTemplate2 - JS Radiobox object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2011
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_inputWidget_1=require("./et2_core_inputWidget"),et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget"),et2_core_valueWidget_1=require("./et2_core_valueWidget");var et2_radiobox=function(_super){function et2_radiobox(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_radiobox._attributes,_child||{}))||this;return _this.input=null,_this.id="",_this.createInputWidget(),_this}return __extends(et2_radiobox,_super),et2_radiobox.prototype.transformAttributes=function(_attrs){_super.prototype.transformAttributes.call(this,_attrs);var readonly=this.getArrayMgr("readonlys").getEntry(this.id);readonly&&readonly.hasOwnProperty(_attrs.set_value)&&(_attrs.readonly=readonly[_attrs.set_value])},et2_radiobox.prototype.createInputWidget=function(){this.input=jQuery(document.createElement("input")).val(this.options.set_value).attr("type","radio").attr("disabled",this.options.readonly),this.input.addClass("et2_radiobox"),this.setDOMNode(this.input[0])},et2_radiobox.prototype.set_id=function(_id){_super.prototype.set_id.call(this,_id),this.dom_id=this.dom_id.replace("[]","")+"-"+this.options.set_value,this.input&&this.input.attr("id",this.dom_id)},et2_radiobox.prototype.set_label=function(_label){_label.length>0&&-1==_label.indexOf("%s")&&(_label="%s"+_label),_super.prototype.set_label.call(this,_label)},et2_radiobox.prototype.set_value=function(_value){this.getRoot().iterateOver((function(radio){radio.id==this.id&&radio.input.prop("checked",_value==radio.options.set_value)}),this,et2_radiobox)},et2_radiobox.prototype.getValue=function(){var val=this.options.value,values=[];return this.getRoot().iterateOver((function(radio){values.push(radio.options.set_value),radio.id==this.id&&radio.input&&radio.input.prop("checked")&&(val=radio.options.set_value)}),this,et2_radiobox),val&&val.indexOf(values)?val:null},et2_radiobox.prototype.isValid=function(messages){var ok=!0;return!this.options||!this.options.needed||this.options.readonly||this.disabled||null!=this.getValue()&&""!=this.getValue().valueOf()||jQuery.isEmptyObject(this.getInstanceManager().getValues(this.getInstanceManager().widgetContainer)[this.id.replace("[]","")])&&(messages.push(this.egw().lang("Field must not be empty !!!")),ok=!1),ok},et2_radiobox.prototype.set_readonly=function(_readonly){this.options.readonly=_readonly,this.getRoot().iterateOver((function(radio){radio.id==this.id&&radio.input.prop("disabled",_readonly)}),this,et2_radiobox)},et2_radiobox._attributes={set_value:{name:"Set value",type:"string",default:"true",description:"Value when selected"},ro_true:{name:"Read only selected",type:"string",default:"x",description:"What should be displayed when readonly and selected"},ro_false:{name:"Read only unselected",type:"string",default:"",description:"What should be displayed when readonly and not selected"}},et2_radiobox.legacyOptions=["set_value","ro_true","ro_false"],et2_radiobox}(et2_core_inputWidget_1.et2_inputWidget);exports.et2_radiobox=et2_radiobox,et2_core_widget_1.et2_register_widget(et2_radiobox,["radio"]);var et2_radiobox_ro=function(_super){function et2_radiobox_ro(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_radiobox_ro._attributes,_child||{}))||this;return _this.value="",_this.span=null,_this.span=jQuery(document.createElement("span")).addClass("et2_radiobox"),_this.setDOMNode(_this.span[0]),_this}return __extends(et2_radiobox_ro,_super),et2_radiobox_ro.prototype.set_value=function(_value){this.value=_value,_value==this.options.set_value?this.span.text(this.options.ro_true):this.span.text(this.options.ro_false)},et2_radiobox_ro.prototype.set_label=function(_label){},et2_radiobox_ro.prototype.getDetachedAttributes=function(_attrs){this.options.ro_true=this.options.label,_attrs.push("value")},et2_radiobox_ro.prototype.getDetachedNodes=function(){return[this.span[0]]},et2_radiobox_ro.prototype.setDetachedAttributes=function(_nodes,_values){this.span=jQuery(_nodes[0]),this.set_value(_values.value)},et2_radiobox_ro._attributes={set_value:{name:"Set value",type:"string",default:"true",description:"Value when selected"},ro_true:{name:"Read only selected",type:"string",default:"x",description:"What should be displayed when readonly and selected"},ro_false:{name:"Read only unselected",type:"string",default:"",description:"What should be displayed when readonly and not selected"},label:{name:"Label",default:"",type:"string"}},et2_radiobox_ro.legacyOptions=["set_value","ro_true","ro_false"],et2_radiobox_ro}(et2_core_valueWidget_1.et2_valueWidget);et2_core_widget_1.et2_register_widget(et2_radiobox_ro,["radio_ro"]);var et2_radioGroup=function(_super){function et2_radioGroup(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_radioGroup._attributes,_child||{}))||this;return _this.node=null,_this.value=null,_this.node=jQuery(document.createElement("div")).addClass("et2_vbox").addClass("et2_box_widget"),_this.options.needed&&_this.node.attr("required","required"),_this.setDOMNode(_this.node[0]),_this.supportedWidgetClasses=[et2_radiobox,et2_radiobox_ro],_this}return __extends(et2_radioGroup,_super),et2_radioGroup.prototype.set_value=function(_value){this.value=_value;for(var i=0;i<this._children.length;i++){this._children[i].set_value(_value)}},et2_radioGroup.prototype.getValue=function(){return jQuery("input:checked",this.getDOMNode()).val()},et2_radioGroup.prototype.set_options=function(_options){for(var i=this._children.length-1;i>=0;i--)this._children[i].destroy();for(var key in this._children=[],_options){var attrs={id:this.options.readonly?this.id:this.id+"[]",set_value:key,label:_options[key],ro_true:this.options.ro_true,ro_false:this.options.ro_false,readonly:this.options.readonly};"object"==typeof _options[key]&&_options[key].label&&(attrs.set_value=_options[key].value,attrs.label=_options[key].label),!1===attrs.readonly&&(attrs.needed=this.options.needed),et2_createWidget("radio",attrs,this)}this.set_value(this.value)},et2_radioGroup.prototype.set_label=function(_value){if(_value!=this.label)if(_value){null==this._labelContainer&&(this._labelContainer=jQuery(document.createElement("label")),this.getSurroundings().insertDOMNode(this._labelContainer[0])),this._labelContainer.empty();var ph=document.createElement("span");this.getSurroundings().setWidgetPlaceholder(ph),this._labelContainer.append(document.createTextNode(_value)).append(ph)}else this._labelContainer&&this.getSurroundings().removeDOMNode(this._labelContainer[0]),this._labelContainer=null},et2_radioGroup.prototype.getDetachedAttributes=function(_attrs){},et2_radioGroup.prototype.getDetachedNodes=function(){return[this.getDOMNode()]},et2_radioGroup.prototype.setDetachedAttributes=function(_nodes,_values){},et2_radioGroup._attributes={label:{name:"Label",default:"",type:"string",description:"The label is displayed above the list of radio buttons. The label can contain variables, as descript for name. If the label starts with a '@' it is replaced by the value of the content-array at this index (with the '@'-removed and after expanding the variables).",translate:!0},value:{name:"Value",type:"string",default:"true",description:"Value for each radio button"},ro_true:{name:"Read only selected",type:"string",default:"x",description:"What should be displayed when readonly and selected"},ro_false:{name:"Read only unselected",type:"string",default:"",description:"What should be displayed when readonly and not selected"},options:{name:"Radio options",type:"any",default:{},description:"Options for radio buttons.  Should be {value: label, ...}"},needed:{name:"Required",default:!1,type:"boolean",description:"If required, the user must select one of the options before the form can be submitted"}},et2_radioGroup}(et2_core_valueWidget_1.et2_valueWidget);function date(format,timestamp){var jsdate,f,formatChrCb,formatChr=/\\?([a-z])/gi,_pad=function(n,c){return(n+="").length<c?new Array(++c-n.length).join("0")+n:n},txt_words=["Sun","Mon","Tues","Wednes","Thurs","Fri","Satur","January","February","March","April","May","June","July","August","September","October","November","December"];return formatChrCb=function(t,s){return f[t]?f[t]():s},f={d:function(){return _pad(f.j(),2)},D:function(){return f.l().slice(0,3)},j:function(){return jsdate.getDate()},l:function(){return egw&&egw.lang?egw.lang(txt_words[f.w()]+"day"):txt_words[f.w()]+"day"},N:function(){return f.w()||7},S:function(){var j=f.j();return j>4||j<21?"th":{1:"st",2:"nd",3:"rd"}[j%10]||"th"},w:function(){return jsdate.getDay()},z:function(){var a=new Date(f.Y(),f.n()-1,f.j()),b=new Date(f.Y(),0,1);return Math.round((a-b)/864e5)+1},W:function(){var a=new Date(f.Y(),f.n()-1,f.j()-f.N()+3),b=new Date(a.getFullYear(),0,4);return _pad(1+Math.round((a-b)/864e5/7),2)},F:function(){return egw&&egw.lang?egw.lang(txt_words[6+f.n()]):txt_words[6+f.n()]},m:function(){return _pad(f.n(),2)},M:function(){return f.F().slice(0,3)},n:function(){return jsdate.getMonth()+1},t:function(){return new Date(f.Y(),f.n(),0).getDate()},L:function(){return 1===new Date(f.Y(),1,29).getMonth()|0},o:function(){var n=f.n(),W=f.W();return f.Y()+(12===n&&W<9?-1:1===n&&W>9)},Y:function(){return jsdate.getFullYear()},y:function(){return(f.Y()+"").slice(-2)},a:function(){return jsdate.getHours()>11?"pm":"am"},A:function(){return f.a().toUpperCase()},B:function(){var H=3600*jsdate.getUTCHours(),i=60*jsdate.getUTCMinutes(),s=jsdate.getUTCSeconds();return _pad(Math.floor((H+i+s+3600)/86.4)%1e3,3)},g:function(){return f.G()%12||12},G:function(){return jsdate.getHours()},h:function(){return _pad(f.g(),2)},H:function(){return _pad(f.G(),2)},i:function(){return _pad(jsdate.getMinutes(),2)},s:function(){return _pad(jsdate.getSeconds(),2)},u:function(){return _pad(1e3*jsdate.getMilliseconds(),6)},e:function(){throw"Not supported (see source code of date() for timezone on how to add support)"},I:function(){return 0+(new Date(f.Y(),0)-Date.UTC(f.Y(),0)!=new Date(f.Y(),6)-Date.UTC(f.Y(),6))},O:function(){var a=jsdate.getTimezoneOffset();return(a>0?"-":"+")+_pad(Math.abs(a/60*100),4)},P:function(){var O=f.O();return O.substr(0,3)+":"+O.substr(3,2)},T:function(){return"UTC"},Z:function(){return 60*-jsdate.getTimezoneOffset()},c:function(){return"Y-m-d\\Th:i:sP".replace(formatChr,formatChrCb)},r:function(){return"D, d M Y H:i:s O".replace(formatChr,formatChrCb)},U:function(){return jsdate.getTime()/1e3|0}},this.date=function(format,timestamp){return this,jsdate=void 0===timestamp||isNaN(timestamp.valueOf())?new Date:timestamp instanceof Date?new Date(timestamp):new Date(1e3*timestamp),format.replace(formatChr,formatChrCb)},this.date(format,timestamp)}et2_core_widget_1.et2_register_widget(et2_radioGroup,["radiogroup"]);
/**
 * EGroupware eTemplate2 - JS Date object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2011
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0}),require("./et2_core_common");et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget"),et2_core_valueWidget_1=require("./et2_core_valueWidget"),et2_core_inputWidget_1=require("./et2_core_inputWidget"),et2_core_DOMWidget_1=require("./et2_core_DOMWidget");var et2_date=function(_super){function et2_date(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_date._attributes,_child||{}))||this;return _this.input_date=null,_this.is_mobile=!1,_this.date=new Date,_this.date.setUTCHours(0),_this.date.setMinutes(0),_this.date.setSeconds(0),_this.createInputWidget(),_this}return __extends(et2_date,_super),et2_date.prototype.createInputWidget=function(){if(this.span=jQuery(document.createElement(this.options.inline?"div":"span")).addClass("et2_date"),this.input_date=jQuery(document.createElement(this.options.inline?"div":"input")),this.options.blur&&this.input_date.attr("placeholder",this.egw().lang(this.options.blur)),this.input_date.addClass("et2_date").attr("type","text").attr("size",7).appendTo(this.span),this.setDOMNode(this.span[0]),this.is_mobile=egwIsMobile()&&!this.options.inline,this.is_mobile)switch(this.dateFormat="yy-mm-dd",this.timeFormat="HH:mm",this.getType()){case"date":this.input_date.attr("type","date");break;case"date-time":this.input_date.attr("type","datetime-local");break;case"date-timeonly":this.input_date.addClass("et2_time"),this.input_date.attr("type","time")}else{this.dateFormat=this.egw().dateTimeFormat(this.egw().preference("dateformat")),this.timeFormat=12==this.egw().preference("timeformat")?"h:mmtt":"HH:mm","date-timeonly"!=this.getType()?this.egw().calendar(this.input_date,"date-time"==this.getType()):(this.input_date.addClass("et2_time"),this.egw().time(this.input_date));var widget=this;this.input_date.datepicker("option","beforeShow",(function(input,inst){var cal=inst.dpDiv;setTimeout((function(){var inputOffset=jQuery(input).offset();cal.height()+inputOffset.top>window.innerHeight&&cal.position({my:"left center",at:"right bottom",collision:"flip fit",of:input}),jQuery('[data-handler="today"]',cal).attr("title","date"==widget.getType()?egw.lang("Today"):egw.lang("Now"))}),0)})).datepicker("option","onClose",(function(dateText,inst){inst.input.blur()}))}var self=this;this.input_date.bind("change",(function(e){return self.set_value(this.value),!1})),null==this.options.value&&this.set_value(null)},et2_date.prototype.set_type=function(_type){_type!=this.getType()&&(_super.prototype.setType.call(this,_type),this.createInputWidget())},et2_date.prototype.set_readonly=function(_ro){this.input_date&&!this.input_date.attr("disabled")!=!_ro&&this.input_date.prop("disabled",!!_ro).datepicker("option","disabled",!!_ro)},et2_date.prototype.set_year=function(_value){this.date.setUTCFullYear(_value),this.set_value(this.date)},et2_date.prototype.set_month=function(_value){this.date.setUTCMonth(_value-1),this.set_value(this.date)},et2_date.prototype.set_date=function(_value){this.date.setUTCDate(_value),this.set_value(this.date)},et2_date.prototype.set_hours=function(_value){this.date.setUTCHours(_value),this.set_value(this.date)},et2_date.prototype.set_minutes=function(_value){this.date.setUTCMinutes(_value),this.set_value(this.date)},et2_date.prototype.get_year=function(){return""==this.input_date.val()?null:this.date.getUTCFullYear()},et2_date.prototype.get_month=function(){return""==this.input_date.val()?null:this.date.getUTCMonth()+1},et2_date.prototype.get_date=function(){return""==this.input_date.val()?null:this.date.getUTCDate()},et2_date.prototype.get_hours=function(){return""==this.input_date.val()?null:this.date.getUTCHours()},et2_date.prototype.get_minutes=function(){return""==this.input_date.val()?null:this.date.getUTCMinutes()},et2_date.prototype.get_time=function(){return""==this.input_date.val()?null:this.date.getTime()},et2_date.prototype.set_year_range=function(_value){this.input_date&&"date"==this.getType()&&!this.is_mobile&&this.input_date.datepicker("option","yearRange",_value),this.options.year_range=_value},et2_date.prototype.set_min=function(_value){if(this.input_date)if(this.is_mobile)this.input_date.attr("min",this._relativeDate(_value));else{if("string"==typeof _value&&_value.match(/(\d{4})-(\d{2})-(\d{2})T(\d{2})\:(\d{2})\:(\d{2})(?:\.\d{3})?(?:Z|[+-](\d{2})\:(\d{2}))/)){_value=new Date(_value);var formatDate=new Date(_value.valueOf()+60*this.date.getTimezoneOffset()*1e3);"date"==this.getType()&&(_value=jQuery.datepicker.formatDate(this.dateFormat,formatDate))}this.input_date.datepicker("option","minDate",_value)}this.options.min=_value},et2_date.prototype._relativeDate=function(_value){return"string"==typeof _value&&_value.match(/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}/)?_value:jQuery.datepicker._determineDate(jQuery.datepicker,_value,this.date).toJSON()},et2_date.prototype.set_max=function(_value){if(this.input_date)if(this.is_mobile)this.input_date.attr("max",this._relativeDate(_value));else{if("string"==typeof _value&&_value.match(/(\d{4})-(\d{2})-(\d{2})T(\d{2})\:(\d{2})\:(\d{2})(?:\.\d{3})?(?:Z|[+-](\d{2})\:(\d{2}))/)){_value=new Date(_value);var formatDate=new Date(_value.valueOf()+60*this.date.getTimezoneOffset()*1e3);"date"==this.getType()&&(_value=jQuery.datepicker.formatDate(this.dateFormat,formatDate))}this.input_date.datepicker("option","maxDate",_value)}this.options.max=_value},et2_date.prototype.set_value=function(_value){var old_value=this._oldValue;if(null===_value||""===_value||void 0===_value||0==_value&&("date-time"==this.getType()||"date"==this.getType()))return this.input_date&&this.input_date.val(""),this._oldValue!==et2_no_init&&old_value!==_value&&this.change(this.input_date),void(this._oldValue=_value);if(("number"==typeof _value||"string"==typeof _value&&!isNaN(_value)&&"+"!=_value[0]&&"-"!=_value[0])&&(_value=date("Y-m-d\\TH:i:s\\Z",_value)),"string"==typeof _value&&_value.match(/^(\d{4})-(\d{2})-(\d{2})T(\d{2})\:(\d{2})\:(\d{2})(?:\.\d{3})?(?:Z|[+-](\d{2})\:(\d{2})|)$/)&&(_value=new Date(_value)),"string"==typeof _value&&isNaN(_value))try{var fix_reg=new RegExp(("date-timeonly"==this.getType()?"^":" ")+"([0-9]+)(:[0-9]*)?( ?(a|p)m?)?$","i"),matches=_value.match(fix_reg);if(matches&&(matches[1].length<2||void 0===matches[2]||matches[2].length<3||matches[3]&&"am"!=matches[3]&&"pm"!=matches[3])){for(matches[1].length<2&&!matches[3]&&(matches[1]="0"+matches[1]),void 0===matches[2]&&(matches[2]=":00");matches[2].length<3;)matches[2]=":0"+matches[2].substr(1);_value=_value.replace(fix_reg,("date-timeonly"==this.getType()?"":" ")+matches[1]+matches[2]+matches[3]),void 0!==matches[4]&&(matches[3]="a"==matches[4].toLowerCase()?"am":"pm")}switch(this.getType()){case"date-timeonly":return(parsed=jQuery.datepicker.parseTime(this.timeFormat,_value))?(this.set_validation_error(!1),this.date.setDate(1),this.date.setMonth(0),this.date.setFullYear(1970),this.date.setUTCHours(parsed.hour),this.date.setMinutes(parsed.minute),this.input_date.val()!=_value&&(this.input_date.val(_value),this.input_date.timepicker("setTime",_value),this._oldValue!==et2_no_init&&this.change(this.input_date)),void(this._oldValue=this.date.toJSON())):void this.set_validation_error(this.egw().lang("'%1' has an invalid format !!!",_value));default:if(this.id.match(/^#/g)&&this.options.value==_value||this.options.data_format&&this.options.value==_value)switch(this.getType()){case"date":var parsed=jQuery.datepicker.parseDate(this.egw().dateTimeFormat(this.options.data_format),_value);break;case"date-time":var DTformat=this.options.data_format.split(" "),parsed=jQuery.datepicker.parseDateTime(this.egw().dateTimeFormat(DTformat[0]),this.egw().dateTimeFormat(DTformat[1]),_value)}else if(!(parsed=jQuery.datepicker.parseDateTime(this.dateFormat,this.timeFormat,_value.replace("T"," "))))return void this.set_validation_error(this.egw().lang("%1' han an invalid format !!!",_value));parsed&&(this.date=new Date(parsed.valueOf()-6e4*parsed.getTimezoneOffset())),this.set_validation_error(!1)}}catch(e){return this.set_value(null)}else"object"==typeof _value&&_value.date?this.date=_value.date:"object"==typeof _value&&_value.valueOf?this.date=_value:this.date.setTime(this.date.getTime()+1e3*parseInt(_value));_value="";var formatDate=new Date(this.date.valueOf()+60*this.date.getTimezoneOffset()*1e3);"date-timeonly"!=this.getType()&&(_value=jQuery.datepicker.formatDate(this.dateFormat,formatDate)),"date"!=this.getType()&&("date-timeonly"!=this.getType()&&(_value+=this.is_mobile?"T":" "),_value+=jQuery.datepicker.formatTime(this.timeFormat,{hour:formatDate.getHours(),minute:formatDate.getMinutes(),seconds:0,timezone:0})),this.options.inline?this.input_date.datepicker("setDate",formatDate):this.input_date.val(_value),this._oldValue!==et2_no_init&&old_value!=this.getValue()&&this.change(this.input_date),this._oldValue=_value},et2_date.prototype.getValue=function(){return""==this.input_date.val()?null:("date-timeonly"==this.getType()?(this.date.setUTCDate(1),this.date.setUTCMonth(0),this.date.setUTCFullYear(1970)):"date"==this.getType()&&(this.date.setUTCHours(0),this.date.setUTCMinutes(0)),this.date.setSeconds(0,0),this.date&&void 0!==this.date.toJSON&&this.date.toJSON()?this.date.toJSON().replace(/\.\d{3}Z$/,"Z"):this.date)},et2_date._attributes={value:{type:"any"},type:{ignore:!1},blur:{name:"Placeholder",type:"string",default:"",description:"This text get displayed if an input-field is empty and does not have the input-focus (blur). It can be used to show a default value or a kind of help-text."},data_format:{ignore:!0,description:"Date/Time format. Can be set as an options to date widget",default:""},year_range:{name:"Year range",type:"string",default:"c-10:c+10",description:'The range of years displayed in the year drop-down: either relative to today\'s year ("-nn:+nn"), relative to the currently selected year ("c-nn:c+nn"), absolute ("nnnn:nnnn"), or combinations of these formats ("nnnn:-nn"). Note that this option only affects what appears in the drop-down, to restrict which dates may be selected use the min and/or max options.'},min:{name:"Minimum",type:"any",default:et2_no_init,description:'Minimum allowed date.  Multiple types supported:Date: A date object containing the minimum date.Number: A number of days from today. For example 2 represents two days from today and -1 represents yesterday.String: A string in the user\'s date format, or a relative date. Relative dates must contain value and period pairs; valid periods are "y" for years, "m" for months, "w" for weeks, and "d" for days. For example, "+1m +7d" represents one month and seven days from today.'},max:{name:"Maximum",type:"any",default:et2_no_init,description:'Maximum allowed date.   Multiple types supported:Date: A date object containing the maximum date.Number: A number of days from today. For example 2 represents two days from today and -1 represents yesterday.String: A string in the user\'s date format, or a relative date. Relative dates must contain value and period pairs; valid periods are "y" for years, "m" for months, "w" for weeks, and "d" for days. For example, "+1m +7d" represents one month and seven days from today.'},inline:{name:"Inline",type:"boolean",default:!1,description:"Instead of an input field with a popup calendar, the calendar is displayed inline, with no input field"}},et2_date.legacyOptions=["data_format"],et2_date}(et2_core_inputWidget_1.et2_inputWidget);exports.et2_date=et2_date,et2_core_widget_1.et2_register_widget(et2_date,["date","date-time","date-timeonly"]);var et2_date_duration=function(_super){function et2_date_duration(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_date_duration._attributes,_child||{}))||this;return _this.format=null,-1!=_this.options.display_format.indexOf("%")&&(_this.options.percent_allowed=!0,_this.options.display_format=_this.options.display_format.replace("%","")),_this.options.display_format=_this.options.display_format.replace(/[^dhm]/,""),_this.options.display_format||(_this.options.display_format=_this.attributes.display_format.default),_this.time_formats={d:_this.options.short_labels?_this.egw().lang("d"):_this.egw().lang("Days"),h:_this.options.short_labels?_this.egw().lang("h"):_this.egw().lang("Hours"),m:_this.options.short_labels?_this.egw().lang("m"):_this.egw().lang("Minutes")},_this.createInputWidget(),_this}return __extends(et2_date_duration,_super),et2_date_duration.prototype.createInputWidget=function(){this.node=jQuery(document.createElement("span")).addClass("et2_date_duration"),this.duration=jQuery(document.createElement("input")).addClass("et2_date_duration").attr({type:"number",size:3,step:this.options.step,lang:","===this.egw().preference("number_format")[0]?"en-150":"en-001"}),this.node.append(this.duration);var self=this;this.duration.on("focusout",(function(){if(!self.duration[0].checkValidity())return self.duration.change()}))},et2_date_duration.prototype.isValid=function(_messages){var ok=!0;return this.duration&&this.duration[0]&&this.duration[0].validationMessage&&!this.duration[0].validity.stepMismatch&&(_messages.push(this.duration[0].validationMessage),ok=!1),_super.prototype.isValid.call(this,_messages)&&ok},et2_date_duration.prototype.attachToDOM=function(){var node=this.getInputNode();return node&&jQuery(node).bind("change.et2_inputWidget",this,(function(e){e.data.change(this)})),et2_core_DOMWidget_1.et2_DOMWidget.prototype.attachToDOM.apply(this,arguments)},et2_date_duration.prototype.getDOMNode=function(){return this.node[0]},et2_date_duration.prototype.getInputNode=function(){return this.duration[0]},et2_date_duration.prototype.set_id=function(_value){this.id=_value;var node=this.getDOMNode();node&&(""!=_value?node.setAttribute("id",this.getInstanceManager().uniqueId+"_"+this.id):node.removeAttribute("id"))},et2_date_duration.prototype.set_value=function(_value){this.options.value=_value;var display=this._convert_to_display(parseFloat(_value));"INPUT"==this.duration[0].nodeName?this.duration.val(display.value):this.duration.text(display.value+" "),display.unit&&display.unit!=this.options.display_format&&(this.format&&this.format.children().length>1?jQuery("option[value='"+display.unit+"']",this.format).attr("selected","selected"):this.format.text(display.unit?this.time_formats[display.unit]:""))},et2_date_duration.prototype.set_display_format=function(format){if(format.length<1&&(this.node.remove("select.et2_date_duration"),this.format.remove(),this.format=null),this.options.display_format=format,(null==this.format||this.format.is("select"))&&(this.options.display_format.length<=1||this.options.readonly)&&(this.format&&this.format.remove(),this.format=jQuery(document.createElement("span")).appendTo(this.node)),this.options.display_format.length>1&&!this.options.readonly){this.format&&!this.format.is("select")&&(this.format.remove(),this.format=null),this.format||(this.format=jQuery(document.createElement("select")).addClass("et2_date_duration"),this.node.append(this.format)),this.format.empty();for(var i=0;i<this.options.display_format.length;i++)this.format.append("<option value='"+this.options.display_format[i]+"'>"+this.time_formats[this.options.display_format[i]]+"</option>")}else this.time_formats[this.options.display_format]?this.format.text(this.time_formats[this.options.display_format]):this.format.text(this.time_formats.m)},et2_date_duration.prototype._convert_to_display=function(_value){if(_value)switch(this.options.data_format){case"d":_value*=this.options.hours_per_day;case"h":_value*=60}var _unit="d"==this.options.display_format?"d":"h";this.options.display_format.indexOf("m")>-1&&_value&&_value<60?_unit="m":this.options.display_format.indexOf("d")>-1&&_value>=60*this.options.hours_per_day&&(_unit="d"),""===(_value=this.options.empty_not_0&&""===_value||!this.options.empty_not_0&&!_value?"":"m"==_unit?parseInt(_value):Math.round(_value/60/("d"==_unit?this.options.hours_per_day:1)*100)/100)&&(_unit="");var format=this.egw().preference("number_format"),sep=format?format[0]:".";return"string"==typeof _value&&format&&sep&&"."!=sep&&(_value=_value.replace(".",sep)),{value:_value,unit:_unit}},et2_date_duration.prototype.getValue=function(){var value=this.duration.val().replace(",",".");if(""===value)return this.options.empty_not_0?"":0;switch(this.format&&this.format.val()?this.format.val():this.options.display_format){case"d":value*=this.options.hours_per_day;case"h":value*=60}switch(value=Math.round(value),this.options.data_format){case"d":value/=this.options.hours_per_day;case"h":value/=60}return value},et2_date_duration._attributes={data_format:{name:"Data format",default:"m",type:"string",description:"Units to read/store the data.  'd' = days (float), 'h' = hours (float), 'm' = minutes (int)."},display_format:{name:"Display format",default:"dhm",type:"string",description:"Permitted units for displaying the data.  'd' = days, 'h' = hours, 'm' = minutes.  Use combinations to give a choice.  Default is 'dh' = days or hours with selectbox."},percent_allowed:{name:"Percent allowed",default:!1,type:"boolean",description:"Allows to enter a percentage."},hours_per_day:{name:"Hours per day",default:8,type:"integer",description:"Number of hours in a day, for converting between hours and (working) days."},empty_not_0:{name:"0 or empty",default:!1,type:"boolean",description:"Should the widget differ between 0 and empty, which get then returned as NULL"},short_labels:{name:"Short labels",default:!1,type:"boolean",description:"use d/h/m instead of day/hour/minute"},step:{name:"Step limit",default:"any",type:"string",description:"Works with the min and max attributes to limit the increments at which a numeric or date-time value can be set."}},et2_date_duration.legacyOptions=["data_format","display_format","hours_per_day","empty_not_0","short_labels"],et2_date_duration}(et2_date);exports.et2_date_duration=et2_date_duration,et2_core_widget_1.et2_register_widget(et2_date_duration,["date-duration"]);var et2_date_duration_ro=function(_super){function et2_date_duration_ro(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(et2_date_duration_ro,_super),et2_date_duration_ro.prototype.createInputWidget=function(){this.node=jQuery(document.createElement("span")),this.duration=jQuery(document.createElement("span")).appendTo(this.node),this.format=jQuery(document.createElement("span")).appendTo(this.node)},et2_date_duration_ro.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value")},et2_date_duration_ro.prototype.getDetachedNodes=function(){return[this.duration[0],this.format[0]]},et2_date_duration_ro.prototype.setDetachedAttributes=function(_nodes,_values){for(var i=0;i<_nodes.length;i++)for(var j=_nodes[i].childNodes.length-1;j>=0;j--)_nodes[i].removeChild(_nodes[i].childNodes[j]);if(void 0!==_values.value&&(_values.value=parseFloat(_values.value)),_values.value){var display=this._convert_to_display(_values.value);_nodes[0].appendChild(document.createTextNode(display.value)),_nodes[1].appendChild(document.createTextNode(display.unit))}},et2_date_duration_ro}(et2_date_duration);exports.et2_date_duration_ro=et2_date_duration_ro,et2_core_widget_1.et2_register_widget(et2_date_duration_ro,["date-duration_ro"]);var et2_date_ro=function(_super){function et2_date_ro(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_date_ro._attributes,_child||{}))||this;return _this.date=new Date,_this.value="",_this._labelContainer=jQuery(document.createElement("label")).addClass("et2_label"),_this.span=jQuery(document.createElement("date-since"==_this.getType()||"date-time_today"==_this.getType()?"span":"time")).addClass("et2_date_ro et2_label").appendTo(_this._labelContainer),_this.setDOMNode(_this._labelContainer[0]),_this}return __extends(et2_date_ro,_super),et2_date_ro.prototype.set_value=function(_value){if(void 0===_value&&(_value=0),this.value=_value,0!=_value&&null!=_value){if("string"==typeof _value&&_value.match(/(\d{4})-(\d{2})-(\d{2})T(\d{2})\:(\d{2})\:(\d{2})(?:\.\d{3})?(?:Z|[+-](\d{2})\:(\d{2}))/))this.date=new Date(_value),this.date=new Date(this.date.valueOf()+60*this.date.getTimezoneOffset()*1e3);else if("string"==typeof _value&&(isNaN(_value)||this.options.data_format&&"Ymd"===this.options.data_format.substr(0,3))){try{switch(this.options.data_format){case"Ymd":case"YmdHi":case"YmdHis":_value=_value.substr(0,4)+"-"+_value.substr(4,2)+"-"+_value.substr(6,2)+" "+(_value.substr(8,2)||"00")+":"+(_value.substr(10,2)||"00")+":"+(_value.substr(12,2)||"00")}var parsed=void 0!==jQuery.datepicker.parseDateTime("yy-mm-dd","hh:mm:ss",_value)?jQuery.datepicker.parseDateTime("yy-mm-dd","hh:mm:ss",_value):jQuery.datepicker.parseDateTime(this.egw().preference("dateformat"),"24"==this.egw().preference("timeformat")?"H:i":"g:i a",_value)}catch(e){return void this.span.attr("datetime","").text("")}var text=new Date(parsed);parsed&&(this.date=new Date(text.valueOf()-60*text.getTimezoneOffset()*1e3)),this.date.setTime(text.valueOf())}else this.date=_value;var display=this.date.toString();switch(this.getType()){case"time_or_date":case"date-time_today":display=date("Y-m-d",this.date)==date("Y-m-d")?date("24"==this.egw().preference("timeformat")?"H:i":"g:i a",this.date):"time_or_date"===this.getType()?date(this.egw().preference("dateformat"),this.date):date(this.egw().preference("dateformat")+" "+("24"==this.egw().preference("timeformat")?"H:i":"g:i a"),this.date);break;case"date":display=date(this.egw().preference("dateformat"),this.date);break;case"date-timeonly":display=date("24"==this.egw().preference("timeformat")?"H:i":"g:i a",this.date);break;case"date-time":display=date(this.egw().preference("dateformat")+" "+("24"==this.egw().preference("timeformat")?"H:i":"g:i a"),this.date);break;case"date-since":var unit2label={Y:"years",m:"month",d:"days",H:"hours",i:"minutes",s:"seconds"},unit2s={Y:31536e3,m:2628e3,d:86400,H:3600,i:60,s:1},d=new Date,diff=Math.round(d.valueOf()/1e3)-Math.round(this.date.valueOf()/1e3);for(var unit in display="",unit2s){var unit_s=unit2s[unit];if(diff>=unit_s||"s"==unit){display=Math.round(diff/unit_s)+" "+this.egw().lang(unit2label[unit]);break}}}this.span.attr("datetime",date("Y-m-d H:i:s",this.date)).text(display)}else this.span.attr("datetime","").text("")},et2_date_ro.prototype.set_label=function(label){this._labelContainer.contents().filter((function(){return 3==this.nodeType})).remove();var parts=et2_csvSplit(label,2,"%s");this._labelContainer.prepend(parts[0]),this._labelContainer.append(parts[1]),this.label=label,this._labelContainer.toggleClass("et2_label_empty",!label||!parts[0])},et2_date_ro.prototype.getDetachedAttributes=function(_attrs){_attrs.push("label","value","class")},et2_date_ro.prototype.getDetachedNodes=function(){return[this._labelContainer[0],this.span[0]]},et2_date_ro.prototype.setDetachedAttributes=function(_nodes,_values){this._labelContainer=jQuery(_nodes[0]),this.span=jQuery(_nodes[1]),this.set_value(_values.value),_values.label&&this.set_label(_values.label),_values.class&&this.span.addClass(_values.class)},et2_date_ro._attributes={value:{type:"string"},type:{ignore:!1},data_format:{ignore:!0,description:"Format data is in.  This is not used client-side because it's always a timestamp client side."},min:{ignore:!0},max:{ignore:!0},year_range:{ignore:!0}},et2_date_ro}(et2_core_valueWidget_1.et2_valueWidget);exports.et2_date_ro=et2_date_ro,et2_core_widget_1.et2_register_widget(et2_date_ro,["date_ro","date-time_ro","date-since","date-time_today","time_or_date","date-timeonly_ro"]);var et2_date_range=function(_super){function et2_date_range(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_date_range._attributes,_child||{}))||this;return _this.div=jQuery(document.createElement("div")).attr({class:"et2_date_range"}),_this.from=null,_this.to=null,_this.select=null,_this.set_id(_this.id),_this.setDOMNode(_this.div[0]),_this._createWidget(),_this.set_relative(_this.options.relative||!1),_this}return __extends(et2_date_range,_super),et2_date_range.prototype._createWidget=function(){var widget=this;this.from=et2_core_widget_1.et2_createWidget("date",{id:this.id+"[from]",blur:egw.lang("From"),onchange:function(){widget.to.set_min(widget.from.getValue())}},this),this.to=et2_core_widget_1.et2_createWidget("date",{id:this.id+"[to]",blur:egw.lang("To"),onchange:function(){widget.from.set_max(widget.to.getValue())}},this),this.select=et2_core_widget_1.et2_createWidget("select",{id:this.id+"[relative]",select_options:et2_date_range.relative_dates,empty_label:this.options.blur||"All"},this),this.select.loadingFinished()},et2_date_range.prototype.iterateOver=function(_callback,_context,_type){void 0===_type&&(_type=et2_core_widget_1.et2_widget),this.isInTree()&&this.instanceOf(_type)&&_callback.call(_context,this)},et2_date_range.prototype.set_relative=function(_value){this.options.relative=_value,this.options.relative?(jQuery(this.from.getDOMNode()).hide(),jQuery(this.to.getDOMNode()).hide()):jQuery(this.select.getDOMNode()).hide()},et2_date_range.prototype.set_value=function(value){value&&"null"!=typeof value||(this.select.set_value(""),this.from.set_value(null),this.to.set_value(null)),value&&"string"==typeof value?this._set_relative_value(value):value&&void 0===value.from&&value[0]?value={from:value[0],to:value[1]||(new Date).valueOf()/1e3}:value&&value.from&&value.to&&(this.from.set_value(value.from),this.to.set_value(value.to))},et2_date_range.prototype.getValue=function(){return this.options.relative?this.select.getValue():{from:this.from.getValue(),to:this.to.getValue()}},et2_date_range.prototype._set_relative_value=function(_value){this.options.relative&&jQuery(this.select.getDOMNode()).show(),this.select.set_value(_value);var tempDate=new Date,today=new Date(tempDate.getFullYear(),tempDate.getMonth(),tempDate.getDate(),0,-tempDate.getTimezoneOffset(),0);this.from.set_value(today.toJSON()),this.to.set_value(today.toJSON());var relative=null;for(var index in et2_date_range.relative_dates)if(et2_date_range.relative_dates[index].value===_value){relative=et2_date_range.relative_dates[index];break}if(relative)for(var dates=["from","to"],value=today.toJSON(),i=0;i<dates.length;i++){var date=dates[i];value="function"==typeof relative[date]?relative[date](new Date(value)):this[date]._relativeDate(relative[date]),this[date].set_value(value)}},et2_date_range._attributes={value:{type:"any",description:"An object with keys 'from' and 'to' for absolute ranges, or a relative range string"},relative:{name:"Relative",type:"boolean",description:"Is the date range relative (this week) or absolute (2016-02-15 - 2016-02-21).  This will affect the value returned."}},et2_date_range.relative_dates=[{value:"Today",label:egw.lang("Today"),from:function(date){return date},to:function(date){return date}},{label:egw.lang("Yesterday"),value:"Yesterday",from:function(date){return date.setUTCDate(date.getUTCDate()-1),date},to:""},{label:egw.lang("This week"),value:"This week",from:function(date){return egw.week_start(date)},to:function(date){return date.setUTCDate(date.getUTCDate()+6),date}},{label:egw.lang("Last week"),value:"Last week",from:function(date){var d=egw.week_start(date);return d.setUTCDate(d.getUTCDate()-7),d},to:function(date){return date.setUTCDate(date.getUTCDate()+6),date}},{label:egw.lang("This month"),value:"This month",from:function(date){return date.setUTCDate(1),date},to:function(date){return date.setUTCMonth(date.getUTCMonth()+1),date.setUTCDate(0),date}},{label:egw.lang("Last month"),value:"Last month",from:function(date){return date.setUTCMonth(date.getUTCMonth()-1),date.setUTCDate(1),date},to:function(date){return date.setUTCMonth(date.getUTCMonth()+1),date.setUTCDate(0),date}},{label:egw.lang("Last 3 months"),value:"Last 3 months",from:function(date){return date.setUTCMonth(date.getUTCMonth()-2),date.setUTCDate(1),date},to:function(date){return date.setUTCMonth(date.getUTCMonth()+3),date.setUTCDate(0),date}},{label:egw.lang("This year"),value:"This year",from:function(d){return d.setUTCMonth(0),d.setUTCDate(1),d},to:function(d){return d.setUTCMonth(11),d.setUTCDate(31),d}},{label:egw.lang("Last year"),value:"Last year",from:function(d){return d.setUTCMonth(0),d.setUTCDate(1),d.setUTCYear(d.getUTCYear()-1),d},to:function(d){return d.setUTCMonth(11),d.setUTCDate(31),d.setUTCYear(d.getUTCYear()-1),d}}],et2_date_range}(et2_core_inputWidget_1.et2_inputWidget);exports.et2_date_range=et2_date_range,et2_core_widget_1.et2_register_widget(et2_date_range,["date-range"]);
/**
 * EGroupware eTemplate2 - JS Dialog Widget class
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2013
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget");var et2_core_widget_2=require("./et2_core_widget"),et2_widget_button_1=require("./et2_widget_button"),et2_dialog=(et2_core_inheritance_1=require("./et2_core_inheritance"),etemplate2_1=require("./etemplate2"),function(_super){function et2_dialog(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_dialog._attributes,_child||{}))||this;_this._dialog_types=["","dialog_info","dialog_help","dialog_warning","dialog_error"],_this._buttons=[[{button_id:1,text:"ok",id:"dialog[ok]",image:"check",default:!0}],[{button_id:1,text:"ok",id:"dialog[ok]",image:"check",default:!0},{button_id:0,text:"cancel",id:"dialog[cancel]",image:"cancel"}],[{button_id:2,text:"yes",id:"dialog[yes]",image:"check",default:!0},{button_id:3,text:"no",id:"dialog[no]",image:"cancelled"}],[{button_id:2,text:"yes",id:"dialog[yes]",image:"check",default:!0},{button_id:3,text:"no",id:"dialog[no]",image:"cancelled"},{button_id:0,text:"cancel",id:"dialog[cancel]",image:"cancel"}]],_this.div=null,_this.template=null,null!=_this.getParent()&&_this.getParent().removeChild(_this);for(var self=_this,i=0;i<_this._buttons.length;i++)for(var j=0;j<_this._buttons[i].length;j++)_this._buttons[i][j].click=function(id){return function(event){self.click(event.target,id)}}(_this._buttons[i][j].button_id),_this._buttons[i][j].text=egw.lang(_this._buttons[i][j].text);return _this.div=jQuery(document.createElement("div")),_this._createDialog(),_this}return __extends(et2_dialog,_super),et2_dialog.prototype.destroy=function(){null!=this.div&&(this.div.dialog("destroy"),this.template&&(this.template.clear(),this.template=null),this.div=null),_super.prototype.destroy.call(this)},et2_dialog.prototype.click=function(target,button_id){this.options.callback&&!1===this.options.callback.call(this,button_id,this.get_value())||this.div.dialog("close")},et2_dialog.prototype.get_value=function(){var value=this.options.value;return this.template&&(value=this.template.getValues(this.template.widgetContainer)),value},et2_dialog.prototype.set_message=function(message){this.options.message=message,this.div.empty().append("<img class='dialog_icon' />").append(jQuery("<div/>").text(message))},et2_dialog.prototype.set_dialog_type=function(type){this.options.dialog_type!=type&&"string"==typeof this._dialog_types[type]&&(this.options.dialog_type=type),this.set_icon(this._dialog_types[type]?egw.image(this._dialog_types[type]):"")},et2_dialog.prototype.set_icon=function(icon_url){""==icon_url?jQuery("img.dialog_icon",this.div).hide():jQuery("img.dialog_icon",this.div).show().attr("src",icon_url)},et2_dialog.prototype.set_buttons=function(buttons){if(this.options.buttons=buttons,buttons instanceof Array)for(var i=0;i<buttons.length;i++){var button=buttons[i];if(button.click||(button.click=jQuery.proxy(this.click,this,null,button.id)),button.id&&void 0===button.class)for(var name in et2_widget_button_1.et2_button.default_classes)if(button.id.match(et2_widget_button_1.et2_button.default_classes[name])){button.class=(void 0===button.class?"":button.class+" ")+name;break}if(button.id&&void 0===button.image&&void 0===button.style)for(var name in et2_widget_button_1.et2_button.default_background_images)if(button.id.match(et2_widget_button_1.et2_button.default_background_images[name])){button.image=name;break}button.image&&(button.style="background-image: url("+this.egw().image(button.image,"api")+")",delete button.image)}this.div.data("ui-dialog")&&(this.div.dialog("option","buttons",buttons),jQuery(".ui-dialog-buttonpane button[default]",this.div.parent()).focus())},et2_dialog.prototype.set_title=function(title){this.options.title=title,this.div.dialog("option","title",title)},et2_dialog.prototype.set_modal=function(modal){this.options.modal=modal,this.div.dialog("option","modal",modal)},et2_dialog.prototype.set_template=function(template){if(this.template&&this.options.template!=template&&this.template.clear(),this.template=new etemplate2_1.etemplate2(this.div[0],!1),template.indexOf(".xet")>0?this.template.load("",template,this.options.value||{content:{}},jQuery.proxy((function(){jQuery("input",this.div).first().focus()}),this)):this.template.load(template,"",this.options.value||{},void 0,void 0,!0),this.template.etemplate_exec_id&&this.template.app)for(var _i=0,_a=etemplate2_1.etemplate2.getByApplication(this.template.app);_i<_a.length;_i++){var et=_a[_i];if(et!==this.template&&et.etemplate_exec_id===this.template.etemplate_exec_id){this.template.unbind_unload();break}}this.div.children().attr("id",template.replace(/^(.*\/)?([^/]+)(\.xet)?$/,"$2").replace(/\./g,"-"))},et2_dialog.prototype._createDialog=function(){this.options.template?this.set_template(this.options.template):(this.set_message(this.options.message),this.set_dialog_type(this.options.dialog_type)),this.set_buttons("number"==typeof this.options.buttons?this._buttons[this.options.buttons]:this.options.buttons);var position_my,position_at="";if(this.options.position){var positions=this.options.position.split(",");position_my=positions[0]?positions[0].trim():"center",position_at=positions[1]?positions[1].trim():position_my}var options={buttons:this.options.buttons,modal:this.options.modal,resizable:this.options.resizable,minWidth:this.options.minWidth,minHeight:this.options.minHeight,maxWidth:640,height:this.options.height,title:this.options.title,open:function(){jQuery(this).parents(".ui-dialog-buttonpane button[default]").focus(),window.setTimeout(function(){jQuery(this).dialog("option","position",{my:position_my,at:position_at,of:window})}.bind(this),0)},close:jQuery.proxy((function(){this.destroy()}),this),beforeClose:this.options.beforeClose,closeText:this.egw().lang("close"),position:{my:"center",at:"center",of:window},appendTo:this.options.appendTo,draggable:this.options.draggable,closeOnEscape:this.options.closeOnEscape,dialogClass:this.options.dialogClass};this.options.width&&(options.width=this.options.width),this.div.dialog(options);var title_width=20+10*this.options.title.length;this.div.width()<title_width&&this.options.title.trim()&&this.div.dialog("option","width",title_width)},et2_dialog._create_parent=function(_egw_or_appname){void 0===_egw_or_appname&&(_egw_or_appname=egw_appName);var parent=new et2_core_widget_2.et2_widget;return"string"!=typeof _egw_or_appname?parent.setApiInstance(_egw_or_appname):(parent.setApiInstance(egw(_egw_or_appname)),parent.egw().langRequireApp(parent.egw().window,_egw_or_appname)),parent},et2_dialog.show_dialog=function(_callback,_message,_title,_value,_buttons,_type,_icon,_egw_or_appname){var parent=et2_dialog._create_parent(_egw_or_appname);return et2_createWidget("dialog",{callback:_callback||function(){},message:_message,title:_title||parent.egw().lang("Confirmation required"),buttons:void 0!==_buttons?_buttons:et2_dialog.BUTTONS_YES_NO,dialog_type:void 0!==_type?_type:et2_dialog.QUESTION_MESSAGE,icon:_icon,value:_value,width:"auto"},parent)},et2_dialog.alert=function(_message,_title,_type){var parent=et2_dialog._create_parent(et2_dialog._create_parent().egw());et2_createWidget("dialog",{callback:function(){},message:_message,title:_title,buttons:et2_dialog.BUTTONS_OK,dialog_type:_type||et2_dialog.INFORMATION_MESSAGE},parent)},et2_dialog.show_prompt=function(_callback,_message,_title,_value,_buttons,_egw_or_appname){var callback=_callback;return et2_createWidget("dialog",{callback:function(_button_id,_value){"function"==typeof callback&&callback.call(this,_button_id,_value.value)},title:_title||egw.lang("Input required"),buttons:_buttons||et2_dialog.BUTTONS_OK_CANCEL,value:{content:{value:_value,message:_message}},template:egw.webserverUrl+"/api/templates/default/prompt.xet",class:"et2_prompt"},et2_dialog._create_parent(_egw_or_appname))},et2_dialog.confirm=function(_senders,_dialogMsg,_titleMsg,_postSubmit){var senders=_senders,buttonId=_senders.id,dialogMsg=void 0!==_dialogMsg?_dialogMsg:"",titleMsg=void 0!==_titleMsg?_titleMsg:"",egw=_senders instanceof et2_core_widget_2.et2_widget?_senders.egw():et2_dialog._create_parent().egw();et2_dialog.show_dialog((function(button_id){button_id==et2_dialog.YES_BUTTON&&(_postSubmit?senders.getRoot().getInstanceManager().postSubmit(buttonId):senders.getRoot().getInstanceManager().submit(buttonId))}),egw.lang(dialogMsg),egw.lang(titleMsg),{},et2_dialog.BUTTONS_YES_NO,et2_dialog.WARNING_MESSAGE,void 0,egw)},et2_dialog.long_task=function(_callback,_message,_title,_menuaction,_list,_egw_or_appname){var parent=et2_dialog._create_parent(_egw_or_appname),egw=parent.egw(),buttons=[{button_id:et2_dialog.OK_BUTTON,text:egw.lang("ok"),default:!0,disabled:!0},{button_id:et2_dialog.CANCEL_BUTTON,text:egw.lang("cancel"),click:function(){cancel=!0,jQuery("button[button_id="+et2_dialog.CANCEL_BUTTON+"]",dialog.div.parent()).button("disable"),update.call(_list.length,"")}}],dialog=et2_createWidget("dialog",{template:egw.webserverUrl+"/api/templates/default/long_task.xet",value:{content:{message:_message}},callback:function(_button_id,_value){_button_id==et2_dialog.CANCEL_BUTTON&&(cancel=!0),"function"==typeof _callback&&_callback.call(this,_button_id,_value.value)},title:_title||egw.lang("please wait..."),buttons:buttons},parent);jQuery("button[button_id="+et2_dialog.OK_BUTTON+"]",dialog.div.parent()).button("disable");var log=null,progressbar=null,cancel=!1,totals={success:0,skipped:0,failed:0,widget:null},update=function(response){var index=this||0;switch(progressbar.set_value(index/_list.length*100),progressbar.set_label(index+" / "+_list.length),response.type){case"error":return jQuery("<div class='message error'></div>").text(response.data).appendTo(log),totals.failed++,void et2_createWidget("dialog",{callback:function(button){switch(button){case"dialog[cancel]":return cancel=!0,update.call(index,"");case"dialog[skip]":return totals.skipped++,update.call(index,"");default:return update.call(index-1,"")}},message:response.data,title:"",buttons:[{text:egw.lang("Abort"),id:"dialog[cancel]"},{text:egw.lang("Retry"),id:"dialog[retry]"},{text:egw.lang("Skip"),id:"dialog[skip]",class:"ui-priority-primary",default:!0}],dialog_type:et2_dialog.ERROR_MESSAGE},parent);default:response&&"string"==typeof response?(totals.success++,jQuery("<div class='message'></div>").text(response).appendTo(log)):jQuery("<div class='message error'></div>").text(JSON.stringify(response)).appendTo(log)}var height=log[0].scrollHeight;if(log.scrollTop(height),totals.widget.set_value(egw.lang("Total: %1 Successful: %2 Failed: %3 Skipped: %4",_list.length,totals.success,totals.failed,totals.skipped)),!cancel&&index<_list.length){var parameters=_list[index];"object"!=typeof parameters&&(parameters=[parameters]),egw.json(_menuaction,parameters,update,index+1,!0,index+1).sendRequest()}else cancel||progressbar.set_value(100),jQuery("button[button_id="+et2_dialog.CANCEL_BUTTON+"]",dialog.div.parent()).button("disable"),jQuery("button[button_id="+et2_dialog.OK_BUTTON+"]",dialog.div.parent()).button("enable"),cancel||"function"!=typeof _callback||_callback.call(dialog,!0,response)};return jQuery(dialog.template.DOMContainer).on("load",(function(){log=jQuery(dialog.template.widgetContainer.getWidgetById("log").getDOMNode()),(progressbar=dialog.template.widgetContainer.getWidgetById("progressbar")).set_label("0 / "+_list.length),totals.widget=dialog.template.widgetContainer.getWidgetById("totals"),window.setTimeout((function(){update.call(0,"")}),0)})),dialog},et2_dialog._attributes={callback:{name:"Callback",type:"js",description:"Callback function is called with the value when the dialog is closed",default:function(button_id){egw.debug("log","Button ID: %d",button_id)}},beforeClose:{name:"before close callback",type:"js",description:"Callback function before dialog is closed, return false to prevent that",default:function(){}},message:{name:"Message",type:"string",description:"Dialog message (plain text, no html)",default:"Somebody forgot to set this..."},dialog_type:{name:"Dialog type",type:"integer",description:"To use a pre-defined dialog style, use et2_dialog.ERROR_MESSAGE, INFORMATION_MESSAGE,WARNING_MESSAGE,QUESTION_MESSAGE,PLAIN_MESSAGE constants.  Default is et2_dialog.PLAIN_MESSAGE",default:0},buttons:{name:"Buttons",type:"any",default:0,description:"Buttons that appear at the bottom of the dialog.  You can use the constants et2_dialog.BUTTONS_OK, BUTTONS_YES_NO, BUTTONS_YES_NO_CANCEL, BUTTONS_OK_CANCEL, or pass in an array for full control"},icon:{name:"Icon",type:"string",description:"URL of an icon for the dialog.  If omitted, an icon based on dialog_type will be used.",default:""},title:{name:"Title",type:"string",description:"Title for the dialog box (plain text, no html)",default:""},modal:{name:"Modal",type:"boolean",description:"Prevent the user from interacting with the page",default:!0},resizable:{name:"Resizable",type:"boolean",description:"Allow the user to resize the dialog",default:!0},value:{name:"Value",description:"The (default) value of the dialog.  Use with template.",type:"any",default:et2_no_init},template:{name:"Template",description:"Instead of displaying a simple message, a full template can be loaded instead.  Set defaults with value.",type:"string",default:et2_no_init},minWidth:{name:"minimum width",type:"integer",description:"Define minimum width of dialog",default:0},minHeight:{name:"minimum height",type:"integer",description:"Define minimum height of dialog",default:0},width:{name:"width",type:"string",description:"Define width of dialog, the default is auto",default:et2_no_init},height:{name:"height",type:"string",description:"Define width of dialog, the default is auto",default:"auto"},position:{name:"position",type:"string",description:"Define position of dialog in the main window",default:"center"},appendTo:{name:"appendTo",type:"string",description:"Defines the dialog parent context",default:""},draggable:{name:"Draggable",type:"boolean",description:"Allow the user to drag the dialog",default:!0},closeOnEscape:{name:"close on escape",type:"boolean",description:"Allow the user to close the dialog by hiting escape",default:!0},dialogClass:{name:"dialog class",type:"string",description:"Add css classed into dialog container",default:""}},et2_dialog.PLAIN_MESSAGE=0,et2_dialog.INFORMATION_MESSAGE=1,et2_dialog.QUESTION_MESSAGE=2,et2_dialog.WARNING_MESSAGE=3,et2_dialog.ERROR_MESSAGE=4,et2_dialog.BUTTONS_OK=0,et2_dialog.BUTTONS_OK_CANCEL=1,et2_dialog.BUTTONS_YES_NO=2,et2_dialog.BUTTONS_YES_NO_CANCEL=3,et2_dialog.CANCEL_BUTTON=0,et2_dialog.OK_BUTTON=1,et2_dialog.YES_BUTTON=2,et2_dialog.NO_BUTTON=3,et2_dialog}(et2_core_widget_2.et2_widget));exports.et2_dialog=et2_dialog,et2_core_widget_1.et2_register_widget(et2_dialog,["dialog"]),function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,(function(r){return o(e[i][1][r]||r)}),p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}({1:[function(require,module,exports){},{}],2:[function(require,module,exports){var global,factory;global=this,factory=function(exports){function Diff(){}function buildValues(diff,components,newString,oldString,useLongestToken){for(var componentPos=0,componentLen=components.length,newPos=0,oldPos=0;componentPos<componentLen;componentPos++){var component=components[componentPos];if(component.removed){if(component.value=diff.join(oldString.slice(oldPos,oldPos+component.count)),oldPos+=component.count,componentPos&&components[componentPos-1].added){var tmp=components[componentPos-1];components[componentPos-1]=components[componentPos],components[componentPos]=tmp}}else{if(!component.added&&useLongestToken){var value=newString.slice(newPos,newPos+component.count);value=value.map((function(value,i){var oldValue=oldString[oldPos+i];return oldValue.length>value.length?oldValue:value})),component.value=diff.join(value)}else component.value=diff.join(newString.slice(newPos,newPos+component.count));newPos+=component.count,component.added||(oldPos+=component.count)}}var lastComponent=components[componentLen-1];return 1<componentLen&&"string"==typeof lastComponent.value&&(lastComponent.added||lastComponent.removed)&&diff.equals("",lastComponent.value)&&(components[componentLen-2].value+=lastComponent.value,components.pop()),components}Diff.prototype={diff:function(oldString,newString){var options=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{},callback=options.callback;"function"==typeof options&&(callback=options,options={}),this.options=options;var self=this;function done(value){return callback?(setTimeout((function(){callback(void 0,value)}),0),!0):value}oldString=this.castInput(oldString),newString=this.castInput(newString),oldString=this.removeEmpty(this.tokenize(oldString));var newLen=(newString=this.removeEmpty(this.tokenize(newString))).length,oldLen=oldString.length,editLength=1,maxEditLength=newLen+oldLen,bestPath=[{newPos:-1,components:[]}],oldPos=this.extractCommon(bestPath[0],newString,oldString,0);if(bestPath[0].newPos+1>=newLen&&oldLen<=oldPos+1)return done([{value:this.join(newString),count:newString.length}]);function execEditLength(){for(var diagonalPath=-1*editLength;diagonalPath<=editLength;diagonalPath+=2){var basePath=void 0,addPath=bestPath[diagonalPath-1],removePath=bestPath[diagonalPath+1],_oldPos=(removePath?removePath.newPos:0)-diagonalPath;addPath&&(bestPath[diagonalPath-1]=void 0);var canAdd=addPath&&addPath.newPos+1<newLen,canRemove=removePath&&0<=_oldPos&&_oldPos<oldLen;if(canAdd||canRemove){if(!canAdd||canRemove&&addPath.newPos<removePath.newPos?(basePath={newPos:(path=removePath).newPos,components:path.components.slice(0)},self.pushComponent(basePath.components,void 0,!0)):((basePath=addPath).newPos++,self.pushComponent(basePath.components,!0,void 0)),_oldPos=self.extractCommon(basePath,newString,oldString,diagonalPath),basePath.newPos+1>=newLen&&oldLen<=_oldPos+1)return done(buildValues(self,basePath.components,newString,oldString,self.useLongestToken));bestPath[diagonalPath]=basePath}else bestPath[diagonalPath]=void 0}var path;editLength++}if(callback)!function exec(){setTimeout((function(){if(maxEditLength<editLength)return callback();execEditLength()||exec()}),0)}();else for(;editLength<=maxEditLength;){var ret=execEditLength();if(ret)return ret}},pushComponent:function(components,added,removed){var last=components[components.length-1];last&&last.added===added&&last.removed===removed?components[components.length-1]={count:last.count+1,added:added,removed:removed}:components.push({count:1,added:added,removed:removed})},extractCommon:function(basePath,newString,oldString,diagonalPath){for(var newLen=newString.length,oldLen=oldString.length,newPos=basePath.newPos,oldPos=newPos-diagonalPath,commonCount=0;newPos+1<newLen&&oldPos+1<oldLen&&this.equals(newString[newPos+1],oldString[oldPos+1]);)newPos++,oldPos++,commonCount++;return commonCount&&basePath.components.push({count:commonCount}),basePath.newPos=newPos,oldPos},equals:function(left,right){return this.options.comparator?this.options.comparator(left,right):left===right||this.options.ignoreCase&&left.toLowerCase()===right.toLowerCase()},removeEmpty:function(array){for(var ret=[],i=0;i<array.length;i++)array[i]&&ret.push(array[i]);return ret},castInput:function(value){return value},tokenize:function(value){return value.split("")},join:function(chars){return chars.join("")}};var characterDiff=new Diff;function generateOptions(options,defaults){if("function"==typeof options)defaults.callback=options;else if(options)for(var name in options)options.hasOwnProperty(name)&&(defaults[name]=options[name]);return defaults}var extendedWordChars=/^[A-Za-z\xC0-\u02C6\u02C8-\u02D7\u02DE-\u02FF\u1E00-\u1EFF]+$/,reWhitespace=/\S/,wordDiff=new Diff;wordDiff.equals=function(left,right){return this.options.ignoreCase&&(left=left.toLowerCase(),right=right.toLowerCase()),left===right||this.options.ignoreWhitespace&&!reWhitespace.test(left)&&!reWhitespace.test(right)},wordDiff.tokenize=function(value){for(var tokens=value.split(/(\s+|[()[\]{}'"]|\b)/),i=0;i<tokens.length-1;i++)!tokens[i+1]&&tokens[i+2]&&extendedWordChars.test(tokens[i])&&extendedWordChars.test(tokens[i+2])&&(tokens[i]+=tokens[i+2],tokens.splice(i+1,2),i--);return tokens};var lineDiff=new Diff;function diffLines(oldStr,newStr,callback){return lineDiff.diff(oldStr,newStr,callback)}lineDiff.tokenize=function(value){var retLines=[],linesAndNewlines=value.split(/(\n|\r\n)/);linesAndNewlines[linesAndNewlines.length-1]||linesAndNewlines.pop();for(var i=0;i<linesAndNewlines.length;i++){var line=linesAndNewlines[i];i%2&&!this.options.newlineIsToken?retLines[retLines.length-1]+=line:(this.options.ignoreWhitespace&&(line=line.trim()),retLines.push(line))}return retLines};var sentenceDiff=new Diff;sentenceDiff.tokenize=function(value){return value.split(/(\S.+?[.!?])(?=\s+|$)/)};var cssDiff=new Diff;function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}function _toConsumableArray(arr){return function(arr){if(Array.isArray(arr)){for(var i=0,arr2=new Array(arr.length);i<arr.length;i++)arr2[i]=arr[i];return arr2}}(arr)||function(iter){if(Symbol.iterator in Object(iter)||"[object Arguments]"===Object.prototype.toString.call(iter))return Array.from(iter)}(arr)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance")}()}cssDiff.tokenize=function(value){return value.split(/([{}:;,]|\s+)/)};var objectPrototypeToString=Object.prototype.toString,jsonDiff=new Diff;function canonicalize(obj,stack,replacementStack,replacer,key){var i,canonicalizedObj;for(stack=stack||[],replacementStack=replacementStack||[],replacer&&(obj=replacer(key,obj)),i=0;i<stack.length;i+=1)if(stack[i]===obj)return replacementStack[i];if("[object Array]"===objectPrototypeToString.call(obj)){for(stack.push(obj),canonicalizedObj=new Array(obj.length),replacementStack.push(canonicalizedObj),i=0;i<obj.length;i+=1)canonicalizedObj[i]=canonicalize(obj[i],stack,replacementStack,replacer,key);return stack.pop(),replacementStack.pop(),canonicalizedObj}if(obj&&obj.toJSON&&(obj=obj.toJSON()),"object"===_typeof(obj)&&null!==obj){stack.push(obj),canonicalizedObj={},replacementStack.push(canonicalizedObj);var _key,sortedKeys=[];for(_key in obj)obj.hasOwnProperty(_key)&&sortedKeys.push(_key);for(sortedKeys.sort(),i=0;i<sortedKeys.length;i+=1)canonicalizedObj[_key=sortedKeys[i]]=canonicalize(obj[_key],stack,replacementStack,replacer,_key);stack.pop(),replacementStack.pop()}else canonicalizedObj=obj;return canonicalizedObj}jsonDiff.useLongestToken=!0,jsonDiff.tokenize=lineDiff.tokenize,jsonDiff.castInput=function(value){var _this$options=this.options,undefinedReplacement=_this$options.undefinedReplacement,_this$options$stringi=_this$options.stringifyReplacer,stringifyReplacer=void 0===_this$options$stringi?function(k,v){return void 0===v?undefinedReplacement:v}:_this$options$stringi;return"string"==typeof value?value:JSON.stringify(canonicalize(value,null,null,stringifyReplacer),stringifyReplacer,"  ")},jsonDiff.equals=function(left,right){return Diff.prototype.equals.call(jsonDiff,left.replace(/,([\r\n])/g,"$1"),right.replace(/,([\r\n])/g,"$1"))};var arrayDiff=new Diff;function parsePatch(uniDiff){var options=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},diffstr=uniDiff.split(/\r\n|[\n\v\f\r\x85]/),delimiters=uniDiff.match(/\r\n|[\n\v\f\r\x85]/g)||[],list=[],i=0;function parseIndex(){var index={};for(list.push(index);i<diffstr.length;){var line=diffstr[i];if(/^(\-\-\-|\+\+\+|@@)\s/.test(line))break;var header=/^(?:Index:|diff(?: -r \w+)+)\s+(.+?)\s*$/.exec(line);header&&(index.index=header[1]),i++}for(parseFileHeader(index),parseFileHeader(index),index.hunks=[];i<diffstr.length;){var _line=diffstr[i];if(/^(Index:|diff|\-\-\-|\+\+\+)\s/.test(_line))break;if(/^@@/.test(_line))index.hunks.push(parseHunk());else{if(_line&&options.strict)throw new Error("Unknown line "+(i+1)+" "+JSON.stringify(_line));i++}}}function parseFileHeader(index){var fileHeader=/^(---|\+\+\+)\s+(.*)$/.exec(diffstr[i]);if(fileHeader){var keyPrefix="---"===fileHeader[1]?"old":"new",data=fileHeader[2].split("\t",2),fileName=data[0].replace(/\\\\/g,"\\");/^".*"$/.test(fileName)&&(fileName=fileName.substr(1,fileName.length-2)),index[keyPrefix+"FileName"]=fileName,index[keyPrefix+"Header"]=(data[1]||"").trim(),i++}}function parseHunk(){for(var chunkHeaderIndex=i,chunkHeader=diffstr[i++].split(/@@ -(\d+)(?:,(\d+))? \+(\d+)(?:,(\d+))? @@/),hunk={oldStart:+chunkHeader[1],oldLines:+chunkHeader[2]||1,newStart:+chunkHeader[3],newLines:+chunkHeader[4]||1,lines:[],linedelimiters:[]},addCount=0,removeCount=0;i<diffstr.length&&!(0===diffstr[i].indexOf("--- ")&&i+2<diffstr.length&&0===diffstr[i+1].indexOf("+++ ")&&0===diffstr[i+2].indexOf("@@"));i++){var operation=0==diffstr[i].length&&i!=diffstr.length-1?" ":diffstr[i][0];if("+"!==operation&&"-"!==operation&&" "!==operation&&"\\"!==operation)break;hunk.lines.push(diffstr[i]),hunk.linedelimiters.push(delimiters[i]||"\n"),"+"===operation?addCount++:"-"===operation?removeCount++:" "===operation&&(addCount++,removeCount++)}if(addCount||1!==hunk.newLines||(hunk.newLines=0),removeCount||1!==hunk.oldLines||(hunk.oldLines=0),options.strict){if(addCount!==hunk.newLines)throw new Error("Added line count did not match for hunk at line "+(chunkHeaderIndex+1));if(removeCount!==hunk.oldLines)throw new Error("Removed line count did not match for hunk at line "+(chunkHeaderIndex+1))}return hunk}for(;i<diffstr.length;)parseIndex();return list}function distanceIterator(start,minLine,maxLine){var wantForward=!0,backwardExhausted=!1,forwardExhausted=!1,localOffset=1;return function iterator(){if(wantForward&&!forwardExhausted){if(backwardExhausted?localOffset++:wantForward=!1,start+localOffset<=maxLine)return localOffset;forwardExhausted=!0}if(!backwardExhausted)return forwardExhausted||(wantForward=!0),minLine<=start-localOffset?-localOffset++:(backwardExhausted=!0,iterator())}}function applyPatch(source,uniDiff){var options=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{};if("string"==typeof uniDiff&&(uniDiff=parsePatch(uniDiff)),Array.isArray(uniDiff)){if(1<uniDiff.length)throw new Error("applyPatch only works with a single input.");uniDiff=uniDiff[0]}var removeEOFNL,addEOFNL,lines=source.split(/\r\n|[\n\v\f\r\x85]/),delimiters=source.match(/\r\n|[\n\v\f\r\x85]/g)||[],hunks=uniDiff.hunks,compareLine=options.compareLine||function(lineNumber,line,operation,patchContent){return line===patchContent},errorCount=0,fuzzFactor=options.fuzzFactor||0,minLine=0,offset=0;function hunkFits(hunk,toPos){for(var j=0;j<hunk.lines.length;j++){var line=hunk.lines[j],operation=0<line.length?line[0]:" ",content=0<line.length?line.substr(1):line;if(" "===operation||"-"===operation){if(!compareLine(toPos+1,lines[toPos],operation,content)&&fuzzFactor<++errorCount)return!1;toPos++}}return!0}for(var i=0;i<hunks.length;i++){for(var hunk=hunks[i],maxLine=lines.length-hunk.oldLines,localOffset=0,toPos=offset+hunk.oldStart-1,iterator=distanceIterator(toPos,minLine,maxLine);void 0!==localOffset;localOffset=iterator())if(hunkFits(hunk,toPos+localOffset)){hunk.offset=offset+=localOffset;break}if(void 0===localOffset)return!1;minLine=hunk.offset+hunk.oldStart+hunk.oldLines}for(var diffOffset=0,_i=0;_i<hunks.length;_i++){var _hunk=hunks[_i],_toPos=_hunk.oldStart+_hunk.offset+diffOffset-1;diffOffset+=_hunk.newLines-_hunk.oldLines,_toPos<0&&(_toPos=0);for(var j=0;j<_hunk.lines.length;j++){var line=_hunk.lines[j],operation=0<line.length?line[0]:" ",content=0<line.length?line.substr(1):line,delimiter=_hunk.linedelimiters[j];if(" "===operation)_toPos++;else if("-"===operation)lines.splice(_toPos,1),delimiters.splice(_toPos,1);else if("+"===operation)lines.splice(_toPos,0,content),delimiters.splice(_toPos,0,delimiter),_toPos++;else if("\\"===operation){var previousOperation=_hunk.lines[j-1]?_hunk.lines[j-1][0]:null;"+"===previousOperation?removeEOFNL=!0:"-"===previousOperation&&(addEOFNL=!0)}}}if(removeEOFNL)for(;!lines[lines.length-1];)lines.pop(),delimiters.pop();else addEOFNL&&(lines.push(""),delimiters.push("\n"));for(var _k=0;_k<lines.length-1;_k++)lines[_k]=lines[_k]+delimiters[_k];return lines.join("")}function structuredPatch(oldFileName,newFileName,oldStr,newStr,oldHeader,newHeader,options){options||(options={}),void 0===options.context&&(options.context=4);var diff=diffLines(oldStr,newStr,options);function contextLines(lines){return lines.map((function(entry){return" "+entry}))}diff.push({value:"",lines:[]});for(var hunks=[],oldRangeStart=0,newRangeStart=0,curRange=[],oldLine=1,newLine=1,_loop=function(i){var current=diff[i],lines=current.lines||current.value.replace(/\n$/,"").split("\n");if(current.lines=lines,current.added||current.removed){var _curRange;if(!oldRangeStart){var prev=diff[i-1];oldRangeStart=oldLine,newRangeStart=newLine,prev&&(curRange=0<options.context?contextLines(prev.lines.slice(-options.context)):[],oldRangeStart-=curRange.length,newRangeStart-=curRange.length)}(_curRange=curRange).push.apply(_curRange,_toConsumableArray(lines.map((function(entry){return(current.added?"+":"-")+entry})))),current.added?newLine+=lines.length:oldLine+=lines.length}else{if(oldRangeStart)if(lines.length<=2*options.context&&i<diff.length-2){var _curRange2;(_curRange2=curRange).push.apply(_curRange2,_toConsumableArray(contextLines(lines)))}else{var _curRange3,contextSize=Math.min(lines.length,options.context);(_curRange3=curRange).push.apply(_curRange3,_toConsumableArray(contextLines(lines.slice(0,contextSize))));var hunk={oldStart:oldRangeStart,oldLines:oldLine-oldRangeStart+contextSize,newStart:newRangeStart,newLines:newLine-newRangeStart+contextSize,lines:curRange};if(i>=diff.length-2&&lines.length<=options.context){var oldEOFNewline=/\n$/.test(oldStr),newEOFNewline=/\n$/.test(newStr),noNlBeforeAdds=0==lines.length&&curRange.length>hunk.oldLines;!oldEOFNewline&&noNlBeforeAdds&&curRange.splice(hunk.oldLines,0,"\\ No newline at end of file"),(oldEOFNewline||noNlBeforeAdds)&&newEOFNewline||curRange.push("\\ No newline at end of file")}hunks.push(hunk),newRangeStart=oldRangeStart=0,curRange=[]}oldLine+=lines.length,newLine+=lines.length}},i=0;i<diff.length;i++)_loop(i);return{oldFileName:oldFileName,newFileName:newFileName,oldHeader:oldHeader,newHeader:newHeader,hunks:hunks}}function createTwoFilesPatch(oldFileName,newFileName,oldStr,newStr,oldHeader,newHeader,options){var diff=structuredPatch(oldFileName,newFileName,oldStr,newStr,oldHeader,newHeader,options),ret=[];oldFileName==newFileName&&ret.push("Index: "+oldFileName),ret.push("==================================================================="),ret.push("--- "+diff.oldFileName+(void 0===diff.oldHeader?"":"\t"+diff.oldHeader)),ret.push("+++ "+diff.newFileName+(void 0===diff.newHeader?"":"\t"+diff.newHeader));for(var i=0;i<diff.hunks.length;i++){var hunk=diff.hunks[i];ret.push("@@ -"+hunk.oldStart+","+hunk.oldLines+" +"+hunk.newStart+","+hunk.newLines+" @@"),ret.push.apply(ret,hunk.lines)}return ret.join("\n")+"\n"}function arrayStartsWith(array,start){if(start.length>array.length)return!1;for(var i=0;i<start.length;i++)if(start[i]!==array[i])return!1;return!0}function loadPatch(param,base){if("string"!=typeof param)return param;if(/^@@/m.test(param)||/^Index:/m.test(param))return parsePatch(param)[0];if(!base)throw new Error("Must provide a base reference or pass in a patch");return structuredPatch(void 0,void 0,base,param)}function fileNameChanged(patch){return patch.newFileName&&patch.newFileName!==patch.oldFileName}function selectField(index,mine,theirs){return mine===theirs?mine:(index.conflict=!0,{mine:mine,theirs:theirs})}function hunkBefore(test,check){return test.oldStart<check.oldStart&&test.oldStart+test.oldLines<check.oldStart}function cloneHunk(hunk,offset){return{oldStart:hunk.oldStart,oldLines:hunk.oldLines,newStart:hunk.newStart+offset,newLines:hunk.newLines,lines:hunk.lines}}function mergeLines(hunk,mineOffset,mineLines,theirOffset,theirLines){var mine={offset:mineOffset,lines:mineLines,index:0},their={offset:theirOffset,lines:theirLines,index:0};for(insertLeading(hunk,mine,their),insertLeading(hunk,their,mine);mine.index<mine.lines.length&&their.index<their.lines.length;){var mineCurrent=mine.lines[mine.index],theirCurrent=their.lines[their.index];if("-"!==mineCurrent[0]&&"+"!==mineCurrent[0]||"-"!==theirCurrent[0]&&"+"!==theirCurrent[0])if("+"===mineCurrent[0]&&" "===theirCurrent[0]){var _hunk$lines;(_hunk$lines=hunk.lines).push.apply(_hunk$lines,_toConsumableArray(collectChange(mine)))}else if("+"===theirCurrent[0]&&" "===mineCurrent[0]){var _hunk$lines2;(_hunk$lines2=hunk.lines).push.apply(_hunk$lines2,_toConsumableArray(collectChange(their)))}else"-"===mineCurrent[0]&&" "===theirCurrent[0]?removal(hunk,mine,their):"-"===theirCurrent[0]&&" "===mineCurrent[0]?removal(hunk,their,mine,!0):mineCurrent===theirCurrent?(hunk.lines.push(mineCurrent),mine.index++,their.index++):conflict(hunk,collectChange(mine),collectChange(their));else mutualChange(hunk,mine,their)}insertTrailing(hunk,mine),insertTrailing(hunk,their),function(hunk){var _calcOldNewLineCount=function calcOldNewLineCount(lines){var oldLines=0,newLines=0;return lines.forEach((function(line){if("string"!=typeof line){var myCount=calcOldNewLineCount(line.mine),theirCount=calcOldNewLineCount(line.theirs);void 0!==oldLines&&(myCount.oldLines===theirCount.oldLines?oldLines+=myCount.oldLines:oldLines=void 0),void 0!==newLines&&(myCount.newLines===theirCount.newLines?newLines+=myCount.newLines:newLines=void 0)}else void 0===newLines||"+"!==line[0]&&" "!==line[0]||newLines++,void 0===oldLines||"-"!==line[0]&&" "!==line[0]||oldLines++})),{oldLines:oldLines,newLines:newLines}}(hunk.lines),oldLines=_calcOldNewLineCount.oldLines,newLines=_calcOldNewLineCount.newLines;void 0!==oldLines?hunk.oldLines=oldLines:delete hunk.oldLines,void 0!==newLines?hunk.newLines=newLines:delete hunk.newLines}(hunk)}function mutualChange(hunk,mine,their){var a,b,myChanges=collectChange(mine),theirChanges=collectChange(their);if(allRemoves(myChanges)&&allRemoves(theirChanges)){var _hunk$lines3,_hunk$lines4;if(arrayStartsWith(myChanges,theirChanges)&&skipRemoveSuperset(their,myChanges,myChanges.length-theirChanges.length))return void(_hunk$lines3=hunk.lines).push.apply(_hunk$lines3,_toConsumableArray(myChanges));if(arrayStartsWith(theirChanges,myChanges)&&skipRemoveSuperset(mine,theirChanges,theirChanges.length-myChanges.length))return void(_hunk$lines4=hunk.lines).push.apply(_hunk$lines4,_toConsumableArray(theirChanges))}else if(b=theirChanges,(a=myChanges).length===b.length&&arrayStartsWith(a,b)){var _hunk$lines5;return void(_hunk$lines5=hunk.lines).push.apply(_hunk$lines5,_toConsumableArray(myChanges))}conflict(hunk,myChanges,theirChanges)}function removal(hunk,mine,their,swap){var _hunk$lines6,myChanges=collectChange(mine),theirChanges=function(state,matchChanges){for(var changes=[],merged=[],matchIndex=0,contextChanges=!1,conflicted=!1;matchIndex<matchChanges.length&&state.index<state.lines.length;){var change=state.lines[state.index],match=matchChanges[matchIndex];if("+"===match[0])break;if(contextChanges=contextChanges||" "!==change[0],merged.push(match),matchIndex++,"+"===change[0])for(conflicted=!0;"+"===change[0];)changes.push(change),change=state.lines[++state.index];match.substr(1)===change.substr(1)?(changes.push(change),state.index++):conflicted=!0}if("+"===(matchChanges[matchIndex]||"")[0]&&contextChanges&&(conflicted=!0),conflicted)return changes;for(;matchIndex<matchChanges.length;)merged.push(matchChanges[matchIndex++]);return{merged:merged,changes:changes}}(their,myChanges);theirChanges.merged?(_hunk$lines6=hunk.lines).push.apply(_hunk$lines6,_toConsumableArray(theirChanges.merged)):conflict(hunk,swap?theirChanges:myChanges,swap?myChanges:theirChanges)}function conflict(hunk,mine,their){hunk.conflict=!0,hunk.lines.push({conflict:!0,mine:mine,theirs:their})}function insertLeading(hunk,insert,their){for(;insert.offset<their.offset&&insert.index<insert.lines.length;){var line=insert.lines[insert.index++];hunk.lines.push(line),insert.offset++}}function insertTrailing(hunk,insert){for(;insert.index<insert.lines.length;){var line=insert.lines[insert.index++];hunk.lines.push(line)}}function collectChange(state){for(var ret=[],operation=state.lines[state.index][0];state.index<state.lines.length;){var line=state.lines[state.index];if("-"===operation&&"+"===line[0]&&(operation="+"),operation!==line[0])break;ret.push(line),state.index++}return ret}function allRemoves(changes){return changes.reduce((function(prev,change){return prev&&"-"===change[0]}),!0)}function skipRemoveSuperset(state,removeChanges,delta){for(var i=0;i<delta;i++){var changeContent=removeChanges[removeChanges.length-delta+i].substr(1);if(state.lines[state.index+i]!==" "+changeContent)return!1}return state.index+=delta,!0}arrayDiff.tokenize=function(value){return value.slice()},arrayDiff.join=arrayDiff.removeEmpty=function(value){return value},exports.Diff=Diff,exports.diffChars=function(oldStr,newStr,options){return characterDiff.diff(oldStr,newStr,options)},exports.diffWords=function(oldStr,newStr,options){return options=generateOptions(options,{ignoreWhitespace:!0}),wordDiff.diff(oldStr,newStr,options)},exports.diffWordsWithSpace=function(oldStr,newStr,options){return wordDiff.diff(oldStr,newStr,options)},exports.diffLines=diffLines,exports.diffTrimmedLines=function(oldStr,newStr,callback){var options=generateOptions(callback,{ignoreWhitespace:!0});return lineDiff.diff(oldStr,newStr,options)},exports.diffSentences=function(oldStr,newStr,callback){return sentenceDiff.diff(oldStr,newStr,callback)},exports.diffCss=function(oldStr,newStr,callback){return cssDiff.diff(oldStr,newStr,callback)},exports.diffJson=function(oldObj,newObj,options){return jsonDiff.diff(oldObj,newObj,options)},exports.diffArrays=function(oldArr,newArr,callback){return arrayDiff.diff(oldArr,newArr,callback)},exports.structuredPatch=structuredPatch,exports.createTwoFilesPatch=createTwoFilesPatch,exports.createPatch=function(fileName,oldStr,newStr,oldHeader,newHeader,options){return createTwoFilesPatch(fileName,fileName,oldStr,newStr,oldHeader,newHeader,options)},exports.applyPatch=applyPatch,exports.applyPatches=function(uniDiff,options){"string"==typeof uniDiff&&(uniDiff=parsePatch(uniDiff));var currentIndex=0;!function processIndex(){var index=uniDiff[currentIndex++];if(!index)return options.complete();options.loadFile(index,(function(err,data){if(err)return options.complete(err);var updatedContent=applyPatch(data,index,options);options.patched(index,updatedContent,(function(err){if(err)return options.complete(err);processIndex()}))}))}()},exports.parsePatch=parsePatch,exports.merge=function(mine,theirs,base){mine=loadPatch(mine,base),theirs=loadPatch(theirs,base);var ret={};(mine.index||theirs.index)&&(ret.index=mine.index||theirs.index),(mine.newFileName||theirs.newFileName)&&(fileNameChanged(mine)?fileNameChanged(theirs)?(ret.oldFileName=selectField(ret,mine.oldFileName,theirs.oldFileName),ret.newFileName=selectField(ret,mine.newFileName,theirs.newFileName),ret.oldHeader=selectField(ret,mine.oldHeader,theirs.oldHeader),ret.newHeader=selectField(ret,mine.newHeader,theirs.newHeader)):(ret.oldFileName=mine.oldFileName,ret.newFileName=mine.newFileName,ret.oldHeader=mine.oldHeader,ret.newHeader=mine.newHeader):(ret.oldFileName=theirs.oldFileName||mine.oldFileName,ret.newFileName=theirs.newFileName||mine.newFileName,ret.oldHeader=theirs.oldHeader||mine.oldHeader,ret.newHeader=theirs.newHeader||mine.newHeader)),ret.hunks=[];for(var mineIndex=0,theirsIndex=0,mineOffset=0,theirsOffset=0;mineIndex<mine.hunks.length||theirsIndex<theirs.hunks.length;){var mineCurrent=mine.hunks[mineIndex]||{oldStart:1/0},theirsCurrent=theirs.hunks[theirsIndex]||{oldStart:1/0};if(hunkBefore(mineCurrent,theirsCurrent))ret.hunks.push(cloneHunk(mineCurrent,mineOffset)),mineIndex++,theirsOffset+=mineCurrent.newLines-mineCurrent.oldLines;else if(hunkBefore(theirsCurrent,mineCurrent))ret.hunks.push(cloneHunk(theirsCurrent,theirsOffset)),theirsIndex++,mineOffset+=theirsCurrent.newLines-theirsCurrent.oldLines;else{var mergedHunk={oldStart:Math.min(mineCurrent.oldStart,theirsCurrent.oldStart),oldLines:0,newStart:Math.min(mineCurrent.newStart+mineOffset,theirsCurrent.oldStart+theirsOffset),newLines:0,lines:[]};mergeLines(mergedHunk,mineCurrent.oldStart,mineCurrent.lines,theirsCurrent.oldStart,theirsCurrent.lines),theirsIndex++,mineIndex++,ret.hunks.push(mergedHunk)}}return ret},exports.convertChangesToDMP=function(changes){for(var change,operation,ret=[],i=0;i<changes.length;i++)operation=(change=changes[i]).added?1:change.removed?-1:0,ret.push([operation,change.value]);return ret},exports.convertChangesToXML=function(changes){for(var ret=[],i=0;i<changes.length;i++){var change=changes[i];change.added?ret.push("<ins>"):change.removed&&ret.push("<del>"),ret.push(change.value.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;")),change.added?ret.push("</ins>"):change.removed&&ret.push("</del>")}return ret.join("")},exports.canonicalize=canonicalize,Object.defineProperty(exports,"__esModule",{value:!0})},"object"==typeof exports&&void 0!==module?factory(exports):"function"==typeof define&&define.amd?define(["exports"],factory):factory((global=global||self).Diff={})},{}],3:[function(require,module,exports){!function(Hogan){var rIsWhitespace=/\S/,rQuot=/\"/g,rNewline=/\n/g,rCr=/\r/g,rSlash=/\\/g,rLineSep=/\u2028/,rParagraphSep=/\u2029/;function trim(s){return s.trim?s.trim():s.replace(/^\s*|\s*$/g,"")}function tagChange(tag,text,index){if(text.charAt(index)!=tag.charAt(0))return!1;for(var i=1,l=tag.length;i<l;i++)if(text.charAt(index+i)!=tag.charAt(i))return!1;return!0}Hogan.tags={"#":1,"^":2,"<":3,$:4,"/":5,"!":6,">":7,"=":8,_v:9,"{":10,"&":11,_t:12},Hogan.scan=function(text,delimiters){var token,len=text.length,state=0,tagType=null,tag=null,buf="",tokens=[],seenTag=!1,i=0,lineStart=0,otag="{{",ctag="}}";function addBuf(){0<buf.length&&(tokens.push({tag:"_t",text:new String(buf)}),buf="")}function filterLine(haveSeenTag,noNewLine){if(addBuf(),haveSeenTag&&function(){for(var isAllWhitespace=!0,j=lineStart;j<tokens.length;j++)if(!(isAllWhitespace=Hogan.tags[tokens[j].tag]<Hogan.tags._v||"_t"==tokens[j].tag&&null===tokens[j].text.match(rIsWhitespace)))return!1;return isAllWhitespace}())for(var next,j=lineStart;j<tokens.length;j++)tokens[j].text&&((next=tokens[j+1])&&">"==next.tag&&(next.indent=tokens[j].text.toString()),tokens.splice(j,1));else noNewLine||tokens.push({tag:"\n"});seenTag=!1,lineStart=tokens.length}function changeDelimiters(text,index){var close="="+ctag,closeIndex=text.indexOf(close,index),delimiters=trim(text.substring(text.indexOf("=",index)+1,closeIndex)).split(" ");return otag=delimiters[0],ctag=delimiters[delimiters.length-1],closeIndex+close.length-1}for(delimiters&&(delimiters=delimiters.split(" "),otag=delimiters[0],ctag=delimiters[1]),i=0;i<len;i++)0==state?tagChange(otag,text,i)?(--i,addBuf(),state=1):"\n"==text.charAt(i)?filterLine(seenTag):buf+=text.charAt(i):1==state?(i+=otag.length-1,state="="==(tagType=(tag=Hogan.tags[text.charAt(i+1)])?text.charAt(i+1):"_v")?(i=changeDelimiters(text,i),0):(tag&&i++,2),seenTag=i):tagChange(ctag,text,i)?(tokens.push({tag:tagType,n:trim(buf),otag:otag,ctag:ctag,i:"/"==tagType?seenTag-otag.length:i+ctag.length}),buf="",i+=ctag.length-1,state=0,"{"==tagType&&("}}"==ctag?i++:"}"===(token=tokens[tokens.length-1]).n.substr(token.n.length-1)&&(token.n=token.n.substring(0,token.n.length-1)))):buf+=text.charAt(i);return filterLine(seenTag,!0),tokens};var allowedInSuper={_t:!0,"\n":!0,$:!0,"/":!0};function isOpener(token,tags){for(var i=0,l=tags.length;i<l;i++)if(tags[i].o==token.n)return token.tag="#",!0}function isCloser(close,open,tags){for(var i=0,l=tags.length;i<l;i++)if(tags[i].c==close&&tags[i].o==open)return!0}Hogan.stringify=function(codeObj,text,options){return"{code: function (c,p,i) { "+Hogan.wrapMain(codeObj.code)+" },"+function stringifyPartials(codeObj){var partials=[];for(var key in codeObj.partials)partials.push('"'+esc(key)+'":{name:"'+esc(codeObj.partials[key].name)+'", '+stringifyPartials(codeObj.partials[key])+"}");return"partials: {"+partials.join(",")+"}, subs: "+function(obj){var items=[];for(var key in obj)items.push('"'+esc(key)+'": function(c,p,t,i) {'+obj[key]+"}");return"{ "+items.join(",")+" }"}(codeObj.subs)}(codeObj)+"}"};var serialNo=0;function esc(s){return s.replace(rSlash,"\\\\").replace(rQuot,'\\"').replace(rNewline,"\\n").replace(rCr,"\\r").replace(rLineSep,"\\u2028").replace(rParagraphSep,"\\u2029")}function chooseMethod(s){return~s.indexOf(".")?"d":"f"}function createPartial(node,context){var sym="<"+(context.prefix||"")+node.n+serialNo++;return context.partials[sym]={name:node.n,partials:{}},context.code+='t.b(t.rp("'+esc(sym)+'",c,p,"'+(node.indent||"")+'"));',sym}function tripleStache(node,context){context.code+="t.b(t.t(t."+chooseMethod(node.n)+'("'+esc(node.n)+'",c,p,0)));'}function write(s){return"t.b("+s+");"}Hogan.generate=function(tree,text,options){serialNo=0;var context={code:"",subs:{},partials:{}};return Hogan.walk(tree,context),options.asString?this.stringify(context,text,options):this.makeTemplate(context,text,options)},Hogan.wrapMain=function(code){return'var t=this;t.b(i=i||"");'+code+"return t.fl();"},Hogan.template=Hogan.Template,Hogan.makeTemplate=function(codeObj,text,options){var template=this.makePartials(codeObj);return template.code=new Function("c","p","i",this.wrapMain(codeObj.code)),new this.template(template,text,this,options)},Hogan.makePartials=function(codeObj){var key,template={subs:{},partials:codeObj.partials,name:codeObj.name};for(key in template.partials)template.partials[key]=this.makePartials(template.partials[key]);for(key in codeObj.subs)template.subs[key]=new Function("c","p","t","i",codeObj.subs[key]);return template},Hogan.codegen={"#":function(node,context){context.code+="if(t.s(t."+chooseMethod(node.n)+'("'+esc(node.n)+'",c,p,1),c,p,0,'+node.i+","+node.end+',"'+node.otag+" "+node.ctag+'")){t.rs(c,p,function(c,p,t){',Hogan.walk(node.nodes,context),context.code+="});c.pop();}"},"^":function(node,context){context.code+="if(!t.s(t."+chooseMethod(node.n)+'("'+esc(node.n)+'",c,p,1),c,p,1,0,0,"")){',Hogan.walk(node.nodes,context),context.code+="};"},">":createPartial,"<":function(node,context){var ctx={partials:{},code:"",subs:{},inPartial:!0};Hogan.walk(node.nodes,ctx);var template=context.partials[createPartial(node,context)];template.subs=ctx.subs,template.partials=ctx.partials},$:function(node,context){var ctx={subs:{},code:"",partials:context.partials,prefix:node.n};Hogan.walk(node.nodes,ctx),context.subs[node.n]=ctx.code,context.inPartial||(context.code+='t.sub("'+esc(node.n)+'",c,p,i);')},"\n":function(node,context){context.code+=write('"\\n"'+(node.last?"":" + i"))},_v:function(node,context){context.code+="t.b(t.v(t."+chooseMethod(node.n)+'("'+esc(node.n)+'",c,p,0)));'},_t:function(node,context){context.code+=write('"'+esc(node.text)+'"')},"{":tripleStache,"&":tripleStache},Hogan.walk=function(nodelist,context){for(var func,i=0,l=nodelist.length;i<l;i++)(func=Hogan.codegen[nodelist[i].tag])&&func(nodelist[i],context);return context},Hogan.parse=function(tokens,text,options){return function buildTree(tokens,kind,stack,customTags){var tail,instructions=[],opener=null,token=null;for(tail=stack[stack.length-1];0<tokens.length;){if(token=tokens.shift(),tail&&"<"==tail.tag&&!(token.tag in allowedInSuper))throw new Error("Illegal content in < super tag.");if(Hogan.tags[token.tag]<=Hogan.tags.$||isOpener(token,customTags))stack.push(token),token.nodes=buildTree(tokens,token.tag,stack,customTags);else{if("/"==token.tag){if(0===stack.length)throw new Error("Closing tag without opener: /"+token.n);if(opener=stack.pop(),token.n!=opener.n&&!isCloser(token.n,opener.n,customTags))throw new Error("Nesting error: "+opener.n+" vs. "+token.n);return opener.end=token.i,instructions}"\n"==token.tag&&(token.last=0==tokens.length||"\n"==tokens[0].tag)}instructions.push(token)}if(0<stack.length)throw new Error("missing closing tag: "+stack.pop().n);return instructions}(tokens,0,[],(options=options||{}).sectionTags||[])},Hogan.cache={},Hogan.cacheKey=function(text,options){return[text,!!options.asString,!!options.disableLambda,options.delimiters,!!options.modelGet].join("||")},Hogan.compile=function(text,options){options=options||{};var key=Hogan.cacheKey(text,options),template=this.cache[key];if(template){var partials=template.partials;for(var name in partials)delete partials[name].instance;return template}return template=this.generate(this.parse(this.scan(text,options.delimiters),text,options),text,options),this.cache[key]=template}}(void 0!==exports?exports:Hogan)},{}],4:[function(require,module,exports){var Hogan=require("./compiler");Hogan.Template=require("./template").Template,Hogan.template=Hogan.Template,module.exports=Hogan},{"./compiler":3,"./template":5}],5:[function(require,module,exports){!function(Hogan){function findInScope(key,scope,doModelGet){var val;return scope&&"object"==typeof scope&&(void 0!==scope[key]?val=scope[key]:doModelGet&&scope.get&&"function"==typeof scope.get&&(val=scope.get(key))),val}Hogan.Template=function(codeObj,text,compiler,options){codeObj=codeObj||{},this.r=codeObj.code||this.r,this.c=compiler,this.options=options||{},this.text=text||"",this.partials=codeObj.partials||{},this.subs=codeObj.subs||{},this.buf=""},Hogan.Template.prototype={r:function(context,partials,indent){return""},v:function(str){return str=coerceToString(str),hChars.test(str)?str.replace(rAmp,"&amp;").replace(rLt,"&lt;").replace(rGt,"&gt;").replace(rApos,"&#39;").replace(rQuot,"&quot;"):str},t:coerceToString,render:function(context,partials,indent){return this.ri([context],partials||{},indent)},ri:function(context,partials,indent){return this.r(context,partials,indent)},ep:function(symbol,partials){var partial=this.partials[symbol],template=partials[partial.name];if(partial.instance&&partial.base==template)return partial.instance;if("string"==typeof template){if(!this.c)throw new Error("No compiler available.");template=this.c.compile(template,this.options)}if(!template)return null;if(this.partials[symbol].base=template,partial.subs){for(key in partials.stackText||(partials.stackText={}),partial.subs)partials.stackText[key]||(partials.stackText[key]=void 0!==this.activeSub&&partials.stackText[this.activeSub]?partials.stackText[this.activeSub]:this.text);template=function(instance,subs,partials,stackSubs,stackPartials,stackText){function PartialTemplate(){}function Substitutions(){}var key;Substitutions.prototype=(PartialTemplate.prototype=instance).subs;var partial=new PartialTemplate;for(key in partial.subs=new Substitutions,partial.subsText={},partial.buf="",stackSubs=stackSubs||{},partial.stackSubs=stackSubs,partial.subsText=stackText,subs)stackSubs[key]||(stackSubs[key]=subs[key]);for(key in stackSubs)partial.subs[key]=stackSubs[key];for(key in stackPartials=stackPartials||{},partial.stackPartials=stackPartials,partials)stackPartials[key]||(stackPartials[key]=partials[key]);for(key in stackPartials)partial.partials[key]=stackPartials[key];return partial}(template,partial.subs,partial.partials,this.stackSubs,this.stackPartials,partials.stackText)}return this.partials[symbol].instance=template},rp:function(symbol,context,partials,indent){var partial=this.ep(symbol,partials);return partial?partial.ri(context,partials,indent):""},rs:function(context,partials,section){var tail=context[context.length-1];if(isArray(tail))for(var i=0;i<tail.length;i++)context.push(tail[i]),section(context,partials,this),context.pop();else section(context,partials,this)},s:function(val,ctx,partials,inverted,start,end,tags){var pass;return(!isArray(val)||0!==val.length)&&("function"==typeof val&&(val=this.ms(val,ctx,partials,inverted,start,end,tags)),pass=!!val,!inverted&&pass&&ctx&&ctx.push("object"==typeof val?val:ctx[ctx.length-1]),pass)},d:function(key,ctx,partials,returnFound){var found,names=key.split("."),val=this.f(names[0],ctx,partials,returnFound),doModelGet=this.options.modelGet,cx=null;if("."===key&&isArray(ctx[ctx.length-2]))val=ctx[ctx.length-1];else for(var i=1;i<names.length;i++)val=void 0!==(found=findInScope(names[i],val,doModelGet))?(cx=val,found):"";return!(returnFound&&!val)&&(returnFound||"function"!=typeof val||(ctx.push(cx),val=this.mv(val,ctx,partials),ctx.pop()),val)},f:function(key,ctx,partials,returnFound){for(var val=!1,found=!1,doModelGet=this.options.modelGet,i=ctx.length-1;0<=i;i--)if(void 0!==(val=findInScope(key,ctx[i],doModelGet))){found=!0;break}return found?(returnFound||"function"!=typeof val||(val=this.mv(val,ctx,partials)),val):!returnFound&&""},ls:function(func,cx,partials,text,tags){var oldTags=this.options.delimiters;return this.options.delimiters=tags,this.b(this.ct(coerceToString(func.call(cx,text)),cx,partials)),this.options.delimiters=oldTags,!1},ct:function(text,cx,partials){if(this.options.disableLambda)throw new Error("Lambda features disabled.");return this.c.compile(text,this.options).render(cx,partials)},b:function(s){this.buf+=s},fl:function(){var r=this.buf;return this.buf="",r},ms:function(func,ctx,partials,inverted,start,end,tags){var textSource,cx=ctx[ctx.length-1],result=func.call(cx);return"function"==typeof result?!!inverted||(textSource=this.activeSub&&this.subsText&&this.subsText[this.activeSub]?this.subsText[this.activeSub]:this.text,this.ls(result,cx,partials,textSource.substring(start,end),tags)):result},mv:function(func,ctx,partials){var cx=ctx[ctx.length-1],result=func.call(cx);return"function"==typeof result?this.ct(coerceToString(result.call(cx)),cx,partials):result},sub:function(name,context,partials,indent){var f=this.subs[name];f&&(this.activeSub=name,f(context,partials,this,indent),this.activeSub=!1)}};var rAmp=/&/g,rLt=/</g,rGt=/>/g,rApos=/\'/g,rQuot=/\"/g,hChars=/[&<>\"\']/;function coerceToString(val){return String(null==val?"":val)}var isArray=Array.isArray||function(a){return"[object Array]"===Object.prototype.toString.call(a)}}(void 0!==exports?exports:{})},{}],6:[function(require,module,exports){function merge_recursive(base,extend){if("object"!==typeOf(base))return extend;for(var key in extend)"object"===typeOf(base[key])&&"object"===typeOf(extend[key])?base[key]=merge_recursive(base[key],extend[key]):base[key]=extend[key];return base}function merge(clone,recursive,argv){var result=argv[0],size=argv.length;!clone&&"object"===typeOf(result)||(result={});for(var index=0;index<size;++index){var item=argv[index];if("object"===typeOf(item))for(var key in item)if("__proto__"!==key){var sitem=clone?Public.clone(item[key]):item[key];result[key]=recursive?merge_recursive(result[key],sitem):sitem}}return result}function typeOf(input){return{}.toString.call(input).slice(8,-1).toLowerCase()}var isNode,Public;isNode="object"==typeof module&&module&&"object"==typeof module.exports&&module.exports,(Public=function(clone){return merge(!0===clone,!1,arguments)}).recursive=function(clone){return merge(!0===clone,!0,arguments)},Public.clone=function(input){var index,size,output=input,type=typeOf(input);if("array"===type)for(output=[],size=input.length,index=0;index<size;++index)output[index]=Public.clone(input[index]);else if("object"===type)for(index in output={},input)output[index]=Public.clone(input[index]);return output},isNode?module.exports=Public:window.merge=Public},{}],7:[function(require,module,exports){(function(process){function normalizeArray(parts,allowAboveRoot){for(var up=0,i=parts.length-1;0<=i;i--){var last=parts[i];"."===last?parts.splice(i,1):".."===last?(parts.splice(i,1),up++):up&&(parts.splice(i,1),up--)}if(allowAboveRoot)for(;up--;up)parts.unshift("..");return parts}function filter(xs,f){if(xs.filter)return xs.filter(f);for(var res=[],i=0;i<xs.length;i++)f(xs[i],i,xs)&&res.push(xs[i]);return res}exports.resolve=function(){for(var resolvedPath="",resolvedAbsolute=!1,i=arguments.length-1;-1<=i&&!resolvedAbsolute;i--){var path=0<=i?arguments[i]:process.cwd();if("string"!=typeof path)throw new TypeError("Arguments to path.resolve must be strings");path&&(resolvedPath=path+"/"+resolvedPath,resolvedAbsolute="/"===path.charAt(0))}return(resolvedAbsolute?"/":"")+(resolvedPath=normalizeArray(filter(resolvedPath.split("/"),(function(p){return!!p})),!resolvedAbsolute).join("/"))||"."},exports.normalize=function(path){var isAbsolute=exports.isAbsolute(path),trailingSlash="/"===substr(path,-1);return(path=normalizeArray(filter(path.split("/"),(function(p){return!!p})),!isAbsolute).join("/"))||isAbsolute||(path="."),path&&trailingSlash&&(path+="/"),(isAbsolute?"/":"")+path},exports.isAbsolute=function(path){return"/"===path.charAt(0)},exports.join=function(){var paths=Array.prototype.slice.call(arguments,0);return exports.normalize(filter(paths,(function(p,index){if("string"!=typeof p)throw new TypeError("Arguments to path.join must be strings");return p})).join("/"))},exports.relative=function(from,to){function trim(arr){for(var start=0;start<arr.length&&""===arr[start];start++);for(var end=arr.length-1;0<=end&&""===arr[end];end--);return end<start?[]:arr.slice(start,end-start+1)}from=exports.resolve(from).substr(1),to=exports.resolve(to).substr(1);for(var fromParts=trim(from.split("/")),toParts=trim(to.split("/")),length=Math.min(fromParts.length,toParts.length),samePartsLength=length,i=0;i<length;i++)if(fromParts[i]!==toParts[i]){samePartsLength=i;break}var outputParts=[];for(i=samePartsLength;i<fromParts.length;i++)outputParts.push("..");return(outputParts=outputParts.concat(toParts.slice(samePartsLength))).join("/")},exports.sep="/",exports.delimiter=":",exports.dirname=function(path){if("string"!=typeof path&&(path+=""),0===path.length)return".";for(var code=path.charCodeAt(0),hasRoot=47===code,end=-1,matchedSlash=!0,i=path.length-1;1<=i;--i)if(47===(code=path.charCodeAt(i))){if(!matchedSlash){end=i;break}}else matchedSlash=!1;return-1===end?hasRoot?"/":".":hasRoot&&1===end?"/":path.slice(0,end)},exports.basename=function(path,ext){var f=function(path){"string"!=typeof path&&(path+="");var i,start=0,end=-1,matchedSlash=!0;for(i=path.length-1;0<=i;--i)if(47===path.charCodeAt(i)){if(!matchedSlash){start=i+1;break}}else-1===end&&(matchedSlash=!1,end=i+1);return-1===end?"":path.slice(start,end)}(path);return ext&&f.substr(-1*ext.length)===ext&&(f=f.substr(0,f.length-ext.length)),f},exports.extname=function(path){"string"!=typeof path&&(path+="");for(var startDot=-1,startPart=0,end=-1,matchedSlash=!0,preDotState=0,i=path.length-1;0<=i;--i){var code=path.charCodeAt(i);if(47===code){if(matchedSlash)continue;startPart=i+1;break}-1===end&&(matchedSlash=!1,end=i+1),46===code?-1===startDot?startDot=i:1!==preDotState&&(preDotState=1):-1!==startDot&&(preDotState=-1)}return-1===startDot||-1===end||0===preDotState||1===preDotState&&startDot===end-1&&startDot===startPart+1?"":path.slice(startDot,end)};var substr="b"==="ab".substr(-1)?function(str,start,len){return str.substr(start,len)}:function(str,start,len){return start<0&&(start=str.length+start),str.substr(start,len)}}).call(this,require("_process"))},{_process:8}],8:[function(require,module,exports){var cachedSetTimeout,cachedClearTimeout,process=module.exports={};function defaultSetTimout(){throw new Error("setTimeout has not been defined")}function defaultClearTimeout(){throw new Error("clearTimeout has not been defined")}function runTimeout(fun){if(cachedSetTimeout===setTimeout)return setTimeout(fun,0);if((cachedSetTimeout===defaultSetTimout||!cachedSetTimeout)&&setTimeout)return cachedSetTimeout=setTimeout,setTimeout(fun,0);try{return cachedSetTimeout(fun,0)}catch(e){try{return cachedSetTimeout.call(null,fun,0)}catch(e){return cachedSetTimeout.call(this,fun,0)}}}!function(){try{cachedSetTimeout="function"==typeof setTimeout?setTimeout:defaultSetTimout}catch(e){cachedSetTimeout=defaultSetTimout}try{cachedClearTimeout="function"==typeof clearTimeout?clearTimeout:defaultClearTimeout}catch(e){cachedClearTimeout=defaultClearTimeout}}();var currentQueue,queue=[],draining=!1,queueIndex=-1;function cleanUpNextTick(){draining&&currentQueue&&(draining=!1,currentQueue.length?queue=currentQueue.concat(queue):queueIndex=-1,queue.length&&drainQueue())}function drainQueue(){if(!draining){var timeout=runTimeout(cleanUpNextTick);draining=!0;for(var len=queue.length;len;){for(currentQueue=queue,queue=[];++queueIndex<len;)currentQueue&&currentQueue[queueIndex].run();queueIndex=-1,len=queue.length}currentQueue=null,draining=!1,function(marker){if(cachedClearTimeout===clearTimeout)return clearTimeout(marker);if((cachedClearTimeout===defaultClearTimeout||!cachedClearTimeout)&&clearTimeout)return cachedClearTimeout=clearTimeout,clearTimeout(marker);try{cachedClearTimeout(marker)}catch(e){try{return cachedClearTimeout.call(null,marker)}catch(e){return cachedClearTimeout.call(this,marker)}}}(timeout)}}function Item(fun,array){this.fun=fun,this.array=array}function noop(){}process.nextTick=function(fun){var args=new Array(arguments.length-1);if(1<arguments.length)for(var i=1;i<arguments.length;i++)args[i-1]=arguments[i];queue.push(new Item(fun,args)),1!==queue.length||draining||runTimeout(drainQueue)},Item.prototype.run=function(){this.fun.apply(null,this.array)},process.title="browser",process.browser=!0,process.env={},process.argv=[],process.version="",process.versions={},process.on=noop,process.addListener=noop,process.once=noop,process.off=noop,process.removeListener=noop,process.removeAllListeners=noop,process.emit=noop,process.prependListener=noop,process.prependOnceListener=noop,process.listeners=function(name){return[]},process.binding=function(name){throw new Error("process.binding is not supported")},process.cwd=function(){return"/"},process.chdir=function(dir){throw new Error("process.chdir is not supported")},process.umask=function(){return 0}},{}],9:[function(require,module,exports){function DiffParser(){}function getExtension(filename,language){var nameSplit=filename.split(".");return 1<nameSplit.length?nameSplit[nameSplit.length-1]:language}function _getFilename(linePrefix,line,extraPrefix){var filename,prefixes=["a/","b/","i/","w/","c/","o/"];extraPrefix&&prefixes.push(extraPrefix);var values=(linePrefix?new RegExp("^"+linePrefix+' "?(.+?)"?$'):new RegExp('^"?(.+?)"?$')).exec(line);if(values&&values[1]){filename=values[1];var matchingPrefixes=prefixes.filter((function(p){return 0===filename.indexOf(p)}));matchingPrefixes[0]&&(filename=filename.slice(matchingPrefixes[0].length)),filename=filename.replace(/\s+\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}(?:\.\d+)? [-+]\d{4}.*$/,"")}return filename}var utils,LINE_TYPE;utils=require("./utils.js").Utils,DiffParser.prototype.LINE_TYPE=LINE_TYPE={INSERTS:"d2h-ins",DELETES:"d2h-del",INSERT_CHANGES:"d2h-ins d2h-change",DELETE_CHANGES:"d2h-del d2h-change",CONTEXT:"d2h-cntx",INFO:"d2h-info"},DiffParser.prototype.generateDiffJson=function(diffInput,configuration){var possibleOldName,possibleNewName,config=configuration||{},files=[],currentFile=null,currentBlock=null,oldLine=null,oldLine2=null,newLine=null;function saveBlock(){currentBlock&&(currentFile.blocks.push(currentBlock),currentBlock=null)}function saveFile(){currentFile&&(currentFile.oldName||(currentFile.oldName=possibleOldName),currentFile.newName||(currentFile.newName=possibleNewName),currentFile.newName&&(files.push(currentFile),currentFile=null)),possibleNewName=possibleOldName=void 0}function startFile(){saveBlock(),saveFile(),currentFile={blocks:[],deletedLines:0,addedLines:0}}function startBlock(line){var values;saveBlock(),(values=/^@@ -(\d+)(?:,\d+)? \+(\d+)(?:,\d+)? @@.*/.exec(line))?(currentFile.isCombined=!1,oldLine=values[1],newLine=values[2]):(values=/^@@@ -(\d+)(?:,\d+)? -(\d+)(?:,\d+)? \+(\d+)(?:,\d+)? @@@.*/.exec(line))?(currentFile.isCombined=!0,oldLine=values[1],oldLine2=values[2],newLine=values[3]):(utils.startsWith(line,"@@")&&console.error("Failed to parse lines, starting in 0!"),newLine=oldLine=0,currentFile.isCombined=!1),(currentBlock={lines:[]}).oldStartLine=oldLine,currentBlock.oldStartLine2=oldLine2,currentBlock.newStartLine=newLine,currentBlock.header=line}var diffLines=diffInput.replace(/\\ No newline at end of file/g,"").replace(/\r\n?/g,"\n").split("\n"),oldMode=/^old mode (\d{6})/,newMode=/^new mode (\d{6})/,deletedFileMode=/^deleted file mode (\d{6})/,newFileMode=/^new file mode (\d{6})/,copyFrom=/^copy from "?(.+)"?/,copyTo=/^copy to "?(.+)"?/,renameFrom=/^rename from "?(.+)"?/,renameTo=/^rename to "?(.+)"?/,similarityIndex=/^similarity index (\d+)%/,dissimilarityIndex=/^dissimilarity index (\d+)%/,index=/^index ([0-9a-z]+)\.\.([0-9a-z]+)\s*(\d{6})?/,binaryFiles=/^Binary files (.*) and (.*) differ/,binaryDiff=/^GIT binary patch/,combinedIndex=/^index ([0-9a-z]+),([0-9a-z]+)\.\.([0-9a-z]+)/,combinedMode=/^mode (\d{6}),(\d{6})\.\.(\d{6})/,combinedNewFile=/^new file mode (\d{6})/,combinedDeletedFile=/^deleted file mode (\d{6}),(\d{6})/;return diffLines.forEach((function(line,lineIndex){if(line&&!utils.startsWith(line,"*")){var values,prevLine=diffLines[lineIndex-1],nxtLine=diffLines[lineIndex+1],afterNxtLine=diffLines[lineIndex+2];if(utils.startsWith(line,"diff"))return startFile(),(values=/^diff --git "?(.+)"? "?(.+)"?/.exec(line))&&(possibleOldName=_getFilename(null,values[1],config.dstPrefix),possibleNewName=_getFilename(null,values[2],config.srcPrefix)),void(currentFile.isGitDiff=!0);if((!currentFile||!currentFile.isGitDiff&&currentFile&&utils.startsWith(line,"--- ")&&utils.startsWith(nxtLine,"+++ ")&&utils.startsWith(afterNxtLine,"@@"))&&startFile(),utils.startsWith(line,"--- ")&&utils.startsWith(nxtLine,"+++ ")||utils.startsWith(line,"+++ ")&&utils.startsWith(prevLine,"--- ")){if(currentFile&&!currentFile.oldName&&utils.startsWith(line,"--- ")&&(values=function(line,cfg){return _getFilename("---",line,cfg.srcPrefix)}(line,config)))return currentFile.oldName=values,void(currentFile.language=getExtension(currentFile.oldName,currentFile.language));if(currentFile&&!currentFile.newName&&utils.startsWith(line,"+++ ")&&(values=function(line,cfg){return _getFilename("\\+\\+\\+",line,cfg.dstPrefix)}(line,config)))return currentFile.newName=values,void(currentFile.language=getExtension(currentFile.newName,currentFile.language))}if(currentFile&&utils.startsWith(line,"@@")||currentFile.isGitDiff&&currentFile&&currentFile.oldName&&currentFile.newName&&!currentBlock)startBlock(line);else if(currentBlock&&(utils.startsWith(line,"+")||utils.startsWith(line,"-")||utils.startsWith(line," ")))!function(line){var currentLine={};currentLine.content=line;var newLinePrefixes=currentFile.isCombined?["+"," +"]:["+"],delLinePrefixes=currentFile.isCombined?["-"," -"]:["-"];utils.startsWith(line,newLinePrefixes)?(currentFile.addedLines++,currentLine.type=LINE_TYPE.INSERTS,currentLine.oldNumber=null,currentLine.newNumber=newLine++):utils.startsWith(line,delLinePrefixes)?(currentFile.deletedLines++,currentLine.type=LINE_TYPE.DELETES,currentLine.oldNumber=oldLine++,currentLine.newNumber=null):(currentLine.type=LINE_TYPE.CONTEXT,currentLine.oldNumber=oldLine++,currentLine.newNumber=newLine++),currentBlock.lines.push(currentLine)}(line);else{var doesNotExistHunkHeader=!function(line,lineIdx){for(var idx=lineIdx;idx<diffLines.length-3;){if(utils.startsWith(line,"diff"))return!1;if(utils.startsWith(diffLines[idx],"--- ")&&utils.startsWith(diffLines[idx+1],"+++ ")&&utils.startsWith(diffLines[idx+2],"@@"))return!0;idx++}return!1}(line,lineIndex);(values=oldMode.exec(line))?currentFile.oldMode=values[1]:(values=newMode.exec(line))?currentFile.newMode=values[1]:(values=deletedFileMode.exec(line))?(currentFile.deletedFileMode=values[1],currentFile.isDeleted=!0):(values=newFileMode.exec(line))?(currentFile.newFileMode=values[1],currentFile.isNew=!0):(values=copyFrom.exec(line))?(doesNotExistHunkHeader&&(currentFile.oldName=values[1]),currentFile.isCopy=!0):(values=copyTo.exec(line))?(doesNotExistHunkHeader&&(currentFile.newName=values[1]),currentFile.isCopy=!0):(values=renameFrom.exec(line))?(doesNotExistHunkHeader&&(currentFile.oldName=values[1]),currentFile.isRename=!0):(values=renameTo.exec(line))?(doesNotExistHunkHeader&&(currentFile.newName=values[1]),currentFile.isRename=!0):(values=binaryFiles.exec(line))?(currentFile.isBinary=!0,currentFile.oldName=_getFilename(null,values[1],config.srcPrefix),currentFile.newName=_getFilename(null,values[2],config.dstPrefix),startBlock("Binary file")):(values=binaryDiff.exec(line))?(currentFile.isBinary=!0,startBlock(line)):(values=similarityIndex.exec(line))?currentFile.unchangedPercentage=values[1]:(values=dissimilarityIndex.exec(line))?currentFile.changedPercentage=values[1]:(values=index.exec(line))?(currentFile.checksumBefore=values[1],currentFile.checksumAfter=values[2],values[3]&&(currentFile.mode=values[3])):(values=combinedIndex.exec(line))?(currentFile.checksumBefore=[values[2],values[3]],currentFile.checksumAfter=values[1]):(values=combinedMode.exec(line))?(currentFile.oldMode=[values[2],values[3]],currentFile.newMode=values[1]):(values=combinedNewFile.exec(line))?(currentFile.newFileMode=values[1],currentFile.isNew=!0):(values=combinedDeletedFile.exec(line))&&(currentFile.deletedFileMode=values[1],currentFile.isDeleted=!0)}}})),saveBlock(),saveFile(),files},module.exports.DiffParser=new DiffParser},{"./utils.js":19}],10:[function(require,module,exports){(function(global){!function(){var diffParser=require("./diff-parser.js").DiffParser,htmlPrinter=require("./html-printer.js").HtmlPrinter,utils=require("./utils.js").Utils;function Diff2Html(){}var defaultConfig={wordByWord:!0,outputFormat:"line-by-line",matching:"none",matchWordsThreshold:.25,matchingMaxComparisons:2500,maxLineLengthHighlight:1e4,renderNothingWhenEmpty:!1};Diff2Html.prototype.getJsonFromDiff=function(diffInput,config){var cfg=utils.safeConfig(config,defaultConfig);return diffParser.generateDiffJson(diffInput,cfg)},Diff2Html.prototype.getPrettyHtml=function(diffInput,config){var cfg=utils.safeConfig(config,defaultConfig),diffJson=diffInput;cfg.inputFormat&&"diff"!==cfg.inputFormat||(diffJson=diffParser.generateDiffJson(diffInput,cfg));var fileList="";return!0===cfg.showFiles&&(fileList=htmlPrinter.generateFileListSummary(diffJson,cfg)),fileList+("side-by-side"===cfg.outputFormat?htmlPrinter.generateSideBySideJsonHtml(diffJson,cfg):htmlPrinter.generateLineByLineJsonHtml(diffJson,cfg))},Diff2Html.prototype.getPrettyHtmlFromDiff=function(diffInput,config){var cfg=utils.safeConfig(config,defaultConfig);return cfg.inputFormat="diff",cfg.outputFormat="line-by-line",this.getPrettyHtml(diffInput,cfg)},Diff2Html.prototype.getPrettyHtmlFromJson=function(diffJson,config){var cfg=utils.safeConfig(config,defaultConfig);return cfg.inputFormat="json",cfg.outputFormat="line-by-line",this.getPrettyHtml(diffJson,cfg)},Diff2Html.prototype.getPrettySideBySideHtmlFromDiff=function(diffInput,config){var cfg=utils.safeConfig(config,defaultConfig);return cfg.inputFormat="diff",cfg.outputFormat="side-by-side",this.getPrettyHtml(diffInput,cfg)},Diff2Html.prototype.getPrettySideBySideHtmlFromJson=function(diffJson,config){var cfg=utils.safeConfig(config,defaultConfig);return cfg.inputFormat="json",cfg.outputFormat="side-by-side",this.getPrettyHtml(diffJson,cfg)};var diffObject=new Diff2Html;module.exports.Diff2Html=diffObject,global.Diff2Html=diffObject}()}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"./diff-parser.js":9,"./html-printer.js":13,"./utils.js":19}],11:[function(require,module,exports){function FileListPrinter(config){this.config=config;var HoganJsUtils=require("./hoganjs-utils.js").HoganJsUtils;hoganUtils=new HoganJsUtils(config)}var hoganUtils,printerUtils;printerUtils=require("./printer-utils.js").PrinterUtils,FileListPrinter.prototype.generateFileList=function(diffFiles){var lineTemplate=hoganUtils.template("file-summary","line"),files=diffFiles.map((function(file){var fileTypeName=printerUtils.getFileTypeIcon(file),iconTemplate=hoganUtils.template("icon",fileTypeName);return lineTemplate.render({fileHtmlId:printerUtils.getHtmlId(file),fileName:printerUtils.getDiffName(file),deletedLines:"-"+file.deletedLines,addedLines:"+"+file.addedLines},{fileIcon:iconTemplate})})).join("\n");return hoganUtils.render("file-summary","wrapper",{filesNumber:diffFiles.length,files:files})},module.exports.FileListPrinter=FileListPrinter},{"./hoganjs-utils.js":12,"./printer-utils.js":15}],12:[function(require,module,exports){(function(__dirname){function HoganJsUtils(configuration){this.config=configuration||{},extraTemplates=this.config.templates||{};var rawTemplates=this.config.rawTemplates||{};for(var templateName in rawTemplates)rawTemplates.hasOwnProperty(templateName)&&(extraTemplates[templateName]||(extraTemplates[templateName]=this.compile(rawTemplates[templateName])))}var extraTemplates,fs,path,hogan,hoganTemplates;fs=require("fs"),path=require("path"),hogan=require("hogan.js"),hoganTemplates=require("./templates/diff2html-templates.js"),HoganJsUtils.prototype.render=function(namespace,view,params){var template=this.template(namespace,view);return template?template.render(params):null},HoganJsUtils.prototype.template=function(namespace,view){var templateKey=this._templateKey(namespace,view);return this._getTemplate(templateKey)},HoganJsUtils.prototype._getTemplate=function(templateKey){var template;return this.config.noCache||(template=this._readFromCache(templateKey)),template||(template=this._loadTemplate(templateKey)),template},HoganJsUtils.prototype._loadTemplate=function(templateKey){var template;try{if(fs.readFileSync){var templatesPath=path.resolve(__dirname,"templates"),templatePath=path.join(templatesPath,templateKey),templateContent=fs.readFileSync(templatePath+".mustache","utf8");template=hogan.compile(templateContent),hoganTemplates[templateKey]=template}}catch(e){console.error("Failed to read (template: "+templateKey+") from fs: "+e.message)}return template},HoganJsUtils.prototype._readFromCache=function(templateKey){return extraTemplates[templateKey]||hoganTemplates[templateKey]},HoganJsUtils.prototype._templateKey=function(namespace,view){return namespace+"-"+view},HoganJsUtils.prototype.compile=function(templateStr){return hogan.compile(templateStr)},module.exports.HoganJsUtils=HoganJsUtils}).call(this,"/src")},{"./templates/diff2html-templates.js":18,fs:1,"hogan.js":4,path:7}],13:[function(require,module,exports){function HtmlPrinter(){}var LineByLinePrinter,SideBySidePrinter,FileListPrinter;LineByLinePrinter=require("./line-by-line-printer.js").LineByLinePrinter,SideBySidePrinter=require("./side-by-side-printer.js").SideBySidePrinter,FileListPrinter=require("./file-list-printer.js").FileListPrinter,HtmlPrinter.prototype.generateLineByLineJsonHtml=function(diffFiles,config){return new LineByLinePrinter(config).generateLineByLineJsonHtml(diffFiles)},HtmlPrinter.prototype.generateSideBySideJsonHtml=function(diffFiles,config){return new SideBySidePrinter(config).generateSideBySideJsonHtml(diffFiles)},HtmlPrinter.prototype.generateFileListSummary=function(diffJson,config){return new FileListPrinter(config).generateFileList(diffJson)},module.exports.HtmlPrinter=new HtmlPrinter},{"./file-list-printer.js":11,"./line-by-line-printer.js":14,"./side-by-side-printer.js":17}],14:[function(require,module,exports){!function(){var hoganUtils,diffParser=require("./diff-parser.js").DiffParser,printerUtils=require("./printer-utils.js").PrinterUtils,utils=require("./utils.js").Utils,Rematch=require("./rematch.js").Rematch;function LineByLinePrinter(config){this.config=config;var HoganJsUtils=require("./hoganjs-utils.js").HoganJsUtils;hoganUtils=new HoganJsUtils(config)}LineByLinePrinter.prototype.makeFileDiffHtml=function(file,diffs){if(this.config.renderNothingWhenEmpty&&file.blocks&&!file.blocks.length)return"";var fileDiffTemplate=hoganUtils.template("line-by-line","file-diff"),filePathTemplate=hoganUtils.template("generic","file-path"),fileIconTemplate=hoganUtils.template("icon","file"),fileTagTemplate=hoganUtils.template("tag",printerUtils.getFileTypeIcon(file));return fileDiffTemplate.render({file:file,fileHtmlId:printerUtils.getHtmlId(file),diffs:diffs,filePath:filePathTemplate.render({fileDiffName:printerUtils.getDiffName(file)},{fileIcon:fileIconTemplate,fileTag:fileTagTemplate})})},LineByLinePrinter.prototype.makeLineByLineHtmlWrapper=function(content){return hoganUtils.render("generic","wrapper",{content:content})},LineByLinePrinter.prototype.generateLineByLineJsonHtml=function(diffFiles){var that=this,htmlDiffs=diffFiles.map((function(file){var diffs;return diffs=file.blocks.length?that._generateFileHtml(file):that._generateEmptyDiff(),that.makeFileDiffHtml(file,diffs)}));return this.makeLineByLineHtmlWrapper(htmlDiffs.join("\n"))};var matcher=Rematch.rematch((function(a,b){var amod=a.content.substr(1),bmod=b.content.substr(1);return Rematch.distance(amod,bmod)}));LineByLinePrinter.prototype.makeColumnLineNumberHtml=function(block){return hoganUtils.render("generic","column-line-number",{diffParser:diffParser,blockHeader:utils.escape(block.header),lineClass:"d2h-code-linenumber",contentClass:"d2h-code-line"})},LineByLinePrinter.prototype._generateFileHtml=function(file){var that=this;return file.blocks.map((function(block){var lines=that.makeColumnLineNumberHtml(block),oldLines=[],newLines=[];function processChangeBlock(){var matches,insertType,deleteType,doMatching=oldLines.length*newLines.length<(that.config.matchingMaxComparisons||2500)&&("lines"===that.config.matching||"words"===that.config.matching);deleteType=doMatching?(matches=matcher(oldLines,newLines),insertType=diffParser.LINE_TYPE.INSERT_CHANGES,diffParser.LINE_TYPE.DELETE_CHANGES):(matches=[[oldLines,newLines]],insertType=diffParser.LINE_TYPE.INSERTS,diffParser.LINE_TYPE.DELETES),matches.forEach((function(match){oldLines=match[0],newLines=match[1];for(var oldLine,newLine,processedOldLines=[],processedNewLines=[],common=Math.min(oldLines.length,newLines.length),j=0;j<common;j++){oldLine=oldLines[j],newLine=newLines[j],that.config.isCombined=file.isCombined;var diff=printerUtils.diffHighlight(oldLine.content,newLine.content,that.config);processedOldLines+=that.makeLineHtml(file.isCombined,deleteType,oldLine.oldNumber,oldLine.newNumber,diff.first.line,diff.first.prefix),processedNewLines+=that.makeLineHtml(file.isCombined,insertType,newLine.oldNumber,newLine.newNumber,diff.second.line,diff.second.prefix)}lines+=processedOldLines+processedNewLines,lines+=that._processLines(file.isCombined,oldLines.slice(common),newLines.slice(common))})),oldLines=[],newLines=[]}for(var i=0;i<block.lines.length;i++){var line=block.lines[i],escapedLine=utils.escape(line.content);line.type!==diffParser.LINE_TYPE.INSERTS&&(0<newLines.length||line.type!==diffParser.LINE_TYPE.DELETES&&0<oldLines.length)&&processChangeBlock(),line.type===diffParser.LINE_TYPE.CONTEXT?lines+=that.makeLineHtml(file.isCombined,line.type,line.oldNumber,line.newNumber,escapedLine):line.type!==diffParser.LINE_TYPE.INSERTS||oldLines.length?line.type===diffParser.LINE_TYPE.DELETES?oldLines.push(line):line.type===diffParser.LINE_TYPE.INSERTS&&Boolean(oldLines.length)?newLines.push(line):(console.error("Unknown state in html line-by-line generator"),processChangeBlock()):lines+=that.makeLineHtml(file.isCombined,line.type,line.oldNumber,line.newNumber,escapedLine)}return processChangeBlock(),lines})).join("\n")},LineByLinePrinter.prototype._processLines=function(isCombined,oldLines,newLines){for(var lines="",i=0;i<oldLines.length;i++){var oldLine=oldLines[i],oldEscapedLine=utils.escape(oldLine.content);lines+=this.makeLineHtml(isCombined,oldLine.type,oldLine.oldNumber,oldLine.newNumber,oldEscapedLine)}for(var j=0;j<newLines.length;j++){var newLine=newLines[j],newEscapedLine=utils.escape(newLine.content);lines+=this.makeLineHtml(isCombined,newLine.type,newLine.oldNumber,newLine.newNumber,newEscapedLine)}return lines},LineByLinePrinter.prototype.makeLineHtml=function(isCombined,type,oldNumber,newNumber,content,possiblePrefix){var lineNumberTemplate=hoganUtils.render("line-by-line","numbers",{oldNumber:utils.valueOrEmpty(oldNumber),newNumber:utils.valueOrEmpty(newNumber)}),lineWithoutPrefix=content,prefix=possiblePrefix;if(!prefix){var lineWithPrefix=printerUtils.separatePrefix(isCombined,content);prefix=lineWithPrefix.prefix,lineWithoutPrefix=lineWithPrefix.line}return hoganUtils.render("generic","line",{type:type,lineClass:"d2h-code-linenumber",contentClass:"d2h-code-line",prefix:prefix,content:lineWithoutPrefix,lineNumber:lineNumberTemplate})},LineByLinePrinter.prototype._generateEmptyDiff=function(){return hoganUtils.render("generic","empty-diff",{contentClass:"d2h-code-line",diffParser:diffParser})},module.exports.LineByLinePrinter=LineByLinePrinter}()},{"./diff-parser.js":9,"./hoganjs-utils.js":12,"./printer-utils.js":15,"./rematch.js":16,"./utils.js":19}],15:[function(require,module,exports){function PrinterUtils(){}function unifyPath(path){return path?path.replace("\\","/"):path}function isDevNullName(name){return-1!==name.indexOf("dev/null")}var jsDiff,utils,Rematch;jsDiff=require("diff"),utils=require("./utils.js").Utils,Rematch=require("./rematch.js").Rematch,PrinterUtils.prototype.separatePrefix=function(isCombined,line){var prefix,lineWithoutPrefix;return lineWithoutPrefix=isCombined?(prefix=line.substring(0,2),line.substring(2)):(prefix=line.substring(0,1),line.substring(1)),{prefix:prefix,line:lineWithoutPrefix}},PrinterUtils.prototype.getHtmlId=function(file){return"d2h-"+function(text){var i,len,hash=0;for(i=0,len=text.length;i<len;i++)hash=(hash<<5)-hash+text.charCodeAt(i),hash|=0;return hash}(this.getDiffName(file)).toString().slice(-6)},PrinterUtils.prototype.getDiffName=function(file){var oldFilename=unifyPath(file.oldName),newFilename=unifyPath(file.newName);if(!oldFilename||!newFilename||oldFilename===newFilename||isDevNullName(oldFilename)||isDevNullName(newFilename))return newFilename&&!isDevNullName(newFilename)?newFilename:oldFilename||"unknown/file/path";for(var prefixPaths=[],suffixPaths=[],oldFilenameParts=oldFilename.split("/"),newFilenameParts=newFilename.split("/"),i=0,j=oldFilenameParts.length-1,k=newFilenameParts.length-1;i<j&&i<k&&oldFilenameParts[i]===newFilenameParts[i];)prefixPaths.push(newFilenameParts[i]),i+=1;for(;i<j&&i<k&&oldFilenameParts[j]===newFilenameParts[k];)suffixPaths.unshift(newFilenameParts[k]),j-=1,k-=1;var finalPrefix=prefixPaths.join("/"),finalSuffix=suffixPaths.join("/"),oldRemainingPath=oldFilenameParts.slice(i,j+1).join("/"),newRemainingPath=newFilenameParts.slice(i,k+1).join("/");return finalPrefix.length&&finalSuffix.length?finalPrefix+"/{"+oldRemainingPath+" → "+newRemainingPath+"}/"+finalSuffix:finalPrefix.length?finalPrefix+"/{"+oldRemainingPath+" → "+newRemainingPath+"}":finalSuffix.length?"{"+oldRemainingPath+" → "+newRemainingPath+"}/"+finalSuffix:oldFilename+" → "+newFilename},PrinterUtils.prototype.getFileTypeIcon=function(file){var templateName="file-changed";return file.isRename||file.isCopy?templateName="file-renamed":file.isNew?templateName="file-added":file.isDeleted?templateName="file-deleted":file.newName!==file.oldName&&(templateName="file-renamed"),templateName},PrinterUtils.prototype.diffHighlight=function(diffLine1,diffLine2,config){var linePrefix1,linePrefix2,unprefixedLine1,unprefixedLine2,diff,prefixSize=1;if(config.isCombined&&(prefixSize=2),linePrefix1=diffLine1.substr(0,prefixSize),linePrefix2=diffLine2.substr(0,prefixSize),unprefixedLine1=diffLine1.substr(prefixSize),unprefixedLine2=diffLine2.substr(prefixSize),unprefixedLine1.length>config.maxLineLengthHighlight||unprefixedLine2.length>config.maxLineLengthHighlight)return{first:{prefix:linePrefix1,line:utils.escape(unprefixedLine1)},second:{prefix:linePrefix2,line:utils.escape(unprefixedLine2)}};diff=config.charByChar?jsDiff.diffChars(unprefixedLine1,unprefixedLine2):jsDiff.diffWordsWithSpace(unprefixedLine1,unprefixedLine2);var line,highlightedLine="",changedWords=[];if(!config.charByChar&&"words"===config.matching){var treshold=.25;void 0!==config.matchWordsThreshold&&(treshold=config.matchWordsThreshold);var matcher=Rematch.rematch((function(a,b){var amod=a.value,bmod=b.value;return Rematch.distance(amod,bmod)})),removed=diff.filter((function(element){return element.removed}));matcher(diff.filter((function(element){return element.added})),removed).forEach((function(chunk){1===chunk[0].length&&1===chunk[1].length&&Rematch.distance(chunk[0][0].value,chunk[1][0].value)<treshold&&(changedWords.push(chunk[0][0]),changedWords.push(chunk[1][0]))}))}return diff.forEach((function(part){var addClass=-1<changedWords.indexOf(part)?' class="d2h-change"':"",elemType=part.added?"ins":part.removed?"del":null,escapedValue=utils.escape(part.value);highlightedLine+=null!==elemType?"<"+elemType+addClass+">"+escapedValue+"</"+elemType+">":escapedValue})),{first:{prefix:linePrefix1,line:(line=highlightedLine,line.replace(/(<ins[^>]*>((.|\n)*?)<\/ins>)/g,""))},second:{prefix:linePrefix2,line:function(line){return line.replace(/(<del[^>]*>((.|\n)*?)<\/del>)/g,"")}(highlightedLine)}}},module.exports.PrinterUtils=new PrinterUtils},{"./rematch.js":16,"./utils.js":19,diff:2}],16:[function(require,module,exports){function levenshtein(a,b){if(0===a.length)return b.length;if(0===b.length)return a.length;var i,j,matrix=[];for(i=0;i<=b.length;i++)matrix[i]=[i];for(j=0;j<=a.length;j++)matrix[0][j]=j;for(i=1;i<=b.length;i++)for(j=1;j<=a.length;j++)b.charAt(i-1)===a.charAt(j-1)?matrix[i][j]=matrix[i-1][j-1]:matrix[i][j]=Math.min(matrix[i-1][j-1]+1,Math.min(matrix[i][j-1]+1,matrix[i-1][j]+1));return matrix[b.length][a.length]}var Rematch;(Rematch={}).levenshtein=levenshtein,Rematch.distance=function(x,y){return levenshtein(x=x.trim(),y=y.trim())/(x.length+y.length)},Rematch.rematch=function(distanceFunction){return function group(a,b,level,cache){void 0===cache&&(cache={});var bm=function(a,b,cache){for(var bestMatch,bestMatchDist=1/0,i=0;i<a.length;++i)for(var j=0;j<b.length;++j){var md,cacheKey=JSON.stringify([a[i],b[j]]);cache.hasOwnProperty(cacheKey)?md=cache[cacheKey]:(md=distanceFunction(a[i],b[j]),cache[cacheKey]=md),md<bestMatchDist&&(bestMatch={indexA:i,indexB:j,score:bestMatchDist=md})}return bestMatch}(a,b,cache);if(level||(level=0),!bm||a.length+b.length<3)return[[a,b]];var a1=a.slice(0,bm.indexA),b1=b.slice(0,bm.indexB),aMatch=[a[bm.indexA]],bMatch=[b[bm.indexB]],tailA=bm.indexA+1,tailB=bm.indexB+1,a2=a.slice(tailA),b2=b.slice(tailB),group1=group(a1,b1,level+1,cache),groupMatch=group(aMatch,bMatch,level+1,cache),group2=group(a2,b2,level+1,cache),result=groupMatch;return(0<bm.indexA||0<bm.indexB)&&(result=group1.concat(result)),(a.length>tailA||b.length>tailB)&&(result=result.concat(group2)),result}},module.exports.Rematch=Rematch},{}],17:[function(require,module,exports){function SideBySidePrinter(config){this.config=config;var HoganJsUtils=require("./hoganjs-utils.js").HoganJsUtils;hoganUtils=new HoganJsUtils(config)}var hoganUtils,diffParser,printerUtils,utils,Rematch,matcher;diffParser=require("./diff-parser.js").DiffParser,printerUtils=require("./printer-utils.js").PrinterUtils,utils=require("./utils.js").Utils,Rematch=require("./rematch.js").Rematch,matcher=Rematch.rematch((function(a,b){var amod=a.content.substr(1),bmod=b.content.substr(1);return Rematch.distance(amod,bmod)})),SideBySidePrinter.prototype.makeDiffHtml=function(file,diffs){var fileDiffTemplate=hoganUtils.template("side-by-side","file-diff"),filePathTemplate=hoganUtils.template("generic","file-path"),fileIconTemplate=hoganUtils.template("icon","file"),fileTagTemplate=hoganUtils.template("tag",printerUtils.getFileTypeIcon(file));return fileDiffTemplate.render({file:file,fileHtmlId:printerUtils.getHtmlId(file),diffs:diffs,filePath:filePathTemplate.render({fileDiffName:printerUtils.getDiffName(file)},{fileIcon:fileIconTemplate,fileTag:fileTagTemplate})})},SideBySidePrinter.prototype.generateSideBySideJsonHtml=function(diffFiles){var that=this,content=diffFiles.map((function(file){var diffs;return diffs=file.blocks.length?that.generateSideBySideFileHtml(file):that.generateEmptyDiff(),that.makeDiffHtml(file,diffs)})).join("\n");return hoganUtils.render("generic","wrapper",{content:content})},SideBySidePrinter.prototype.makeSideHtml=function(blockHeader){return hoganUtils.render("generic","column-line-number",{diffParser:diffParser,blockHeader:utils.escape(blockHeader),lineClass:"d2h-code-side-linenumber",contentClass:"d2h-code-side-line"})},SideBySidePrinter.prototype.generateSideBySideFileHtml=function(file){var that=this,fileHtml={left:"",right:""};return file.blocks.forEach((function(block){fileHtml.left+=that.makeSideHtml(block.header),fileHtml.right+=that.makeSideHtml("");var oldLines=[],newLines=[];function processChangeBlock(){var matches,insertType,deleteType,doMatching=oldLines.length*newLines.length<(that.config.matchingMaxComparisons||2500)&&("lines"===that.config.matching||"words"===that.config.matching);deleteType=doMatching?(matches=matcher(oldLines,newLines),insertType=diffParser.LINE_TYPE.INSERT_CHANGES,diffParser.LINE_TYPE.DELETE_CHANGES):(matches=[[oldLines,newLines]],insertType=diffParser.LINE_TYPE.INSERTS,diffParser.LINE_TYPE.DELETES),matches.forEach((function(match){oldLines=match[0],newLines=match[1];for(var common=Math.min(oldLines.length,newLines.length),max=Math.max(oldLines.length,newLines.length),j=0;j<common;j++){var oldLine=oldLines[j],newLine=newLines[j];that.config.isCombined=file.isCombined;var diff=printerUtils.diffHighlight(oldLine.content,newLine.content,that.config);fileHtml.left+=that.generateSingleLineHtml(file.isCombined,deleteType,oldLine.oldNumber,diff.first.line,diff.first.prefix),fileHtml.right+=that.generateSingleLineHtml(file.isCombined,insertType,newLine.newNumber,diff.second.line,diff.second.prefix)}if(common<max){var oldSlice=oldLines.slice(common),newSlice=newLines.slice(common),tmpHtml=that.processLines(file.isCombined,oldSlice,newSlice);fileHtml.left+=tmpHtml.left,fileHtml.right+=tmpHtml.right}})),oldLines=[],newLines=[]}for(var i=0;i<block.lines.length;i++){var line=block.lines[i],prefix=line.content[0],escapedLine=utils.escape(line.content.substr(1));line.type!==diffParser.LINE_TYPE.INSERTS&&(0<newLines.length||line.type!==diffParser.LINE_TYPE.DELETES&&0<oldLines.length)&&processChangeBlock(),line.type===diffParser.LINE_TYPE.CONTEXT?(fileHtml.left+=that.generateSingleLineHtml(file.isCombined,line.type,line.oldNumber,escapedLine,prefix),fileHtml.right+=that.generateSingleLineHtml(file.isCombined,line.type,line.newNumber,escapedLine,prefix)):line.type!==diffParser.LINE_TYPE.INSERTS||oldLines.length?line.type===diffParser.LINE_TYPE.DELETES?oldLines.push(line):line.type===diffParser.LINE_TYPE.INSERTS&&Boolean(oldLines.length)?newLines.push(line):(console.error("unknown state in html side-by-side generator"),processChangeBlock()):(fileHtml.left+=that.generateSingleLineHtml(file.isCombined,diffParser.LINE_TYPE.CONTEXT,"","",""),fileHtml.right+=that.generateSingleLineHtml(file.isCombined,line.type,line.newNumber,escapedLine,prefix))}processChangeBlock()})),fileHtml},SideBySidePrinter.prototype.processLines=function(isCombined,oldLines,newLines){for(var fileHtml={left:"",right:""},maxLinesNumber=Math.max(oldLines.length,newLines.length),i=0;i<maxLinesNumber;i++){var oldContent,newContent,oldPrefix,newPrefix,oldLine=oldLines[i],newLine=newLines[i];oldLine&&(oldContent=utils.escape(oldLine.content.substr(1)),oldPrefix=oldLine.content[0]),newLine&&(newContent=utils.escape(newLine.content.substr(1)),newPrefix=newLine.content[0]),oldLine&&newLine?(fileHtml.left+=this.generateSingleLineHtml(isCombined,oldLine.type,oldLine.oldNumber,oldContent,oldPrefix),fileHtml.right+=this.generateSingleLineHtml(isCombined,newLine.type,newLine.newNumber,newContent,newPrefix)):oldLine?(fileHtml.left+=this.generateSingleLineHtml(isCombined,oldLine.type,oldLine.oldNumber,oldContent,oldPrefix),fileHtml.right+=this.generateSingleLineHtml(isCombined,diffParser.LINE_TYPE.CONTEXT,"","","")):newLine?(fileHtml.left+=this.generateSingleLineHtml(isCombined,diffParser.LINE_TYPE.CONTEXT,"","",""),fileHtml.right+=this.generateSingleLineHtml(isCombined,newLine.type,newLine.newNumber,newContent,newPrefix)):console.error("How did it get here?")}return fileHtml},SideBySidePrinter.prototype.generateSingleLineHtml=function(isCombined,type,number,content,possiblePrefix){var lineWithoutPrefix=content,prefix=possiblePrefix,lineClass="d2h-code-side-linenumber",contentClass="d2h-code-side-line";if(number||content||(lineClass+=" d2h-code-side-emptyplaceholder",contentClass+=" d2h-code-side-emptyplaceholder",type+=" d2h-emptyplaceholder"),!prefix){var lineWithPrefix=printerUtils.separatePrefix(isCombined,content);prefix=lineWithPrefix.prefix,lineWithoutPrefix=lineWithPrefix.line}return hoganUtils.render("generic","line",{type:type,lineClass:lineClass,contentClass:contentClass,prefix:prefix,content:lineWithoutPrefix,lineNumber:number})},SideBySidePrinter.prototype.generateEmptyDiff=function(){var fileHtml={right:""};return fileHtml.left=hoganUtils.render("generic","empty-diff",{contentClass:"d2h-code-side-line",diffParser:diffParser}),fileHtml},module.exports.SideBySidePrinter=SideBySidePrinter},{"./diff-parser.js":9,"./hoganjs-utils.js":12,"./printer-utils.js":15,"./rematch.js":16,"./utils.js":19}],18:[function(require,module,exports){(function(global){!function(){global.browserTemplates||(global.browserTemplates={});var Hogan=require("hogan.js");global.browserTemplates["file-summary-line"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<li class="d2h-file-list-line">'),t.b("\n"+i),t.b('    <span class="d2h-file-name-wrapper">'),t.b("\n"+i),t.b(t.rp("<fileIcon0",c,p,"      ")),t.b('      <a href="#'),t.b(t.v(t.f("fileHtmlId",c,p,0))),t.b('" class="d2h-file-name">'),t.b(t.v(t.f("fileName",c,p,0))),t.b("</a>"),t.b("\n"+i),t.b('      <span class="d2h-file-stats">'),t.b("\n"+i),t.b('          <span class="d2h-lines-added">'),t.b(t.v(t.f("addedLines",c,p,0))),t.b("</span>"),t.b("\n"+i),t.b('          <span class="d2h-lines-deleted">'),t.b(t.v(t.f("deletedLines",c,p,0))),t.b("</span>"),t.b("\n"+i),t.b("      </span>"),t.b("\n"+i),t.b("    </span>"),t.b("\n"+i),t.b("</li>"),t.fl()},partials:{"<fileIcon0":{name:"fileIcon",partials:{},subs:{}}},subs:{}}),global.browserTemplates["file-summary-wrapper"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<div class="d2h-file-list-wrapper">'),t.b("\n"+i),t.b('    <div class="d2h-file-list-header">'),t.b("\n"+i),t.b('        <span class="d2h-file-list-title">Files changed ('),t.b(t.v(t.f("filesNumber",c,p,0))),t.b(")</span>"),t.b("\n"+i),t.b('        <a class="d2h-file-switch d2h-hide">hide</a>'),t.b("\n"+i),t.b('        <a class="d2h-file-switch d2h-show">show</a>'),t.b("\n"+i),t.b("    </div>"),t.b("\n"+i),t.b('    <ol class="d2h-file-list">'),t.b("\n"+i),t.b("    "),t.b(t.t(t.f("files",c,p,0))),t.b("\n"+i),t.b("    </ol>"),t.b("\n"+i),t.b("</div>"),t.fl()},partials:{},subs:{}}),global.browserTemplates["generic-column-line-number"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b("<tr>"),t.b("\n"+i),t.b('    <td class="'),t.b(t.v(t.f("lineClass",c,p,0))),t.b(" "),t.b(t.v(t.d("diffParser.LINE_TYPE.INFO",c,p,0))),t.b('"></td>'),t.b("\n"+i),t.b('    <td class="'),t.b(t.v(t.d("diffParser.LINE_TYPE.INFO",c,p,0))),t.b('">'),t.b("\n"+i),t.b('        <div class="'),t.b(t.v(t.f("contentClass",c,p,0))),t.b(" "),t.b(t.v(t.d("diffParser.LINE_TYPE.INFO",c,p,0))),t.b('">'),t.b(t.t(t.f("blockHeader",c,p,0))),t.b("</div>"),t.b("\n"+i),t.b("    </td>"),t.b("\n"+i),t.b("</tr>"),t.fl()},partials:{},subs:{}}),global.browserTemplates["generic-empty-diff"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b("<tr>"),t.b("\n"+i),t.b('    <td class="'),t.b(t.v(t.d("diffParser.LINE_TYPE.INFO",c,p,0))),t.b('">'),t.b("\n"+i),t.b('        <div class="'),t.b(t.v(t.f("contentClass",c,p,0))),t.b(" "),t.b(t.v(t.d("diffParser.LINE_TYPE.INFO",c,p,0))),t.b('">'),t.b("\n"+i),t.b("            File without changes"),t.b("\n"+i),t.b("        </div>"),t.b("\n"+i),t.b("    </td>"),t.b("\n"+i),t.b("</tr>"),t.fl()},partials:{},subs:{}}),global.browserTemplates["generic-file-path"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<span class="d2h-file-name-wrapper">'),t.b("\n"+i),t.b(t.rp("<fileIcon0",c,p,"    ")),t.b('    <span class="d2h-file-name">'),t.b(t.v(t.f("fileDiffName",c,p,0))),t.b("</span>"),t.b("\n"+i),t.b(t.rp("<fileTag1",c,p,"    ")),t.b("</span>"),t.fl()},partials:{"<fileIcon0":{name:"fileIcon",partials:{},subs:{}},"<fileTag1":{name:"fileTag",partials:{},subs:{}}},subs:{}}),global.browserTemplates["generic-line"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b("<tr>"),t.b("\n"+i),t.b('    <td class="'),t.b(t.v(t.f("lineClass",c,p,0))),t.b(" "),t.b(t.v(t.f("type",c,p,0))),t.b('">'),t.b("\n"+i),t.b("      "),t.b(t.t(t.f("lineNumber",c,p,0))),t.b("\n"+i),t.b("    </td>"),t.b("\n"+i),t.b('    <td class="'),t.b(t.v(t.f("type",c,p,0))),t.b('">'),t.b("\n"+i),t.b('        <div class="'),t.b(t.v(t.f("contentClass",c,p,0))),t.b(" "),t.b(t.v(t.f("type",c,p,0))),t.b('">'),t.b("\n"+i),t.s(t.f("prefix",c,p,1),c,p,0,171,247,"{{ }}")&&(t.rs(c,p,(function(c,p,t){t.b('            <span class="d2h-code-line-prefix">'),t.b(t.t(t.f("prefix",c,p,0))),t.b("</span>"),t.b("\n"+i)})),c.pop()),t.s(t.f("content",c,p,1),c,p,0,279,353,"{{ }}")&&(t.rs(c,p,(function(c,p,t){t.b('            <span class="d2h-code-line-ctn">'),t.b(t.t(t.f("content",c,p,0))),t.b("</span>"),t.b("\n"+i)})),c.pop()),t.b("        </div>"),t.b("\n"+i),t.b("    </td>"),t.b("\n"+i),t.b("</tr>"),t.fl()},partials:{},subs:{}}),global.browserTemplates["generic-wrapper"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<div class="d2h-wrapper">'),t.b("\n"+i),t.b("    "),t.b(t.t(t.f("content",c,p,0))),t.b("\n"+i),t.b("</div>"),t.fl()},partials:{},subs:{}}),global.browserTemplates["icon-file-added"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<svg aria-hidden="true" class="d2h-icon d2h-added" height="16" title="added" version="1.1" viewBox="0 0 14 16"'),t.b("\n"+i),t.b('     width="14">'),t.b("\n"+i),t.b('    <path d="M13 1H1C0.45 1 0 1.45 0 2v12c0 0.55 0.45 1 1 1h12c0.55 0 1-0.45 1-1V2c0-0.55-0.45-1-1-1z m0 13H1V2h12v12zM6 9H3V7h3V4h2v3h3v2H8v3H6V9z"></path>'),t.b("\n"+i),t.b("</svg>"),t.fl()},partials:{},subs:{}}),global.browserTemplates["icon-file-changed"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<svg aria-hidden="true" class="d2h-icon d2h-changed" height="16" title="modified" version="1.1"'),t.b("\n"+i),t.b('     viewBox="0 0 14 16" width="14">'),t.b("\n"+i),t.b('    <path d="M13 1H1C0.45 1 0 1.45 0 2v12c0 0.55 0.45 1 1 1h12c0.55 0 1-0.45 1-1V2c0-0.55-0.45-1-1-1z m0 13H1V2h12v12zM4 8c0-1.66 1.34-3 3-3s3 1.34 3 3-1.34 3-3 3-3-1.34-3-3z"></path>'),t.b("\n"+i),t.b("</svg>"),t.fl()},partials:{},subs:{}}),global.browserTemplates["icon-file-deleted"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<svg aria-hidden="true" class="d2h-icon d2h-deleted" height="16" title="removed" version="1.1"'),t.b("\n"+i),t.b('     viewBox="0 0 14 16" width="14">'),t.b("\n"+i),t.b('    <path d="M13 1H1C0.45 1 0 1.45 0 2v12c0 0.55 0.45 1 1 1h12c0.55 0 1-0.45 1-1V2c0-0.55-0.45-1-1-1z m0 13H1V2h12v12zM11 9H3V7h8v2z"></path>'),t.b("\n"+i),t.b("</svg>"),t.fl()},partials:{},subs:{}}),global.browserTemplates["icon-file-renamed"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<svg aria-hidden="true" class="d2h-icon d2h-moved" height="16" title="renamed" version="1.1"'),t.b("\n"+i),t.b('     viewBox="0 0 14 16" width="14">'),t.b("\n"+i),t.b('    <path d="M6 9H3V7h3V4l5 4-5 4V9z m8-7v12c0 0.55-0.45 1-1 1H1c-0.55 0-1-0.45-1-1V2c0-0.55 0.45-1 1-1h12c0.55 0 1 0.45 1 1z m-1 0H1v12h12V2z"></path>'),t.b("\n"+i),t.b("</svg>"),t.fl()},partials:{},subs:{}}),global.browserTemplates["icon-file"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<svg aria-hidden="true" class="d2h-icon" height="16" version="1.1" viewBox="0 0 12 16" width="12">'),t.b("\n"+i),t.b('    <path d="M6 5H2v-1h4v1zM2 8h7v-1H2v1z m0 2h7v-1H2v1z m0 2h7v-1H2v1z m10-7.5v9.5c0 0.55-0.45 1-1 1H1c-0.55 0-1-0.45-1-1V2c0-0.55 0.45-1 1-1h7.5l3.5 3.5z m-1 0.5L8 2H1v12h10V5z"></path>'),t.b("\n"+i),t.b("</svg>"),t.fl()},partials:{},subs:{}}),global.browserTemplates["line-by-line-file-diff"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<div id="'),t.b(t.v(t.f("fileHtmlId",c,p,0))),t.b('" class="d2h-file-wrapper" data-lang="'),t.b(t.v(t.d("file.language",c,p,0))),t.b('">'),t.b("\n"+i),t.b('    <div class="d2h-file-header">'),t.b("\n"+i),t.b("    "),t.b(t.t(t.f("filePath",c,p,0))),t.b("\n"+i),t.b("    </div>"),t.b("\n"+i),t.b('    <div class="d2h-file-diff">'),t.b("\n"+i),t.b('        <div class="d2h-code-wrapper">'),t.b("\n"+i),t.b('            <table class="d2h-diff-table">'),t.b("\n"+i),t.b('                <tbody class="d2h-diff-tbody">'),t.b("\n"+i),t.b("                "),t.b(t.t(t.f("diffs",c,p,0))),t.b("\n"+i),t.b("                </tbody>"),t.b("\n"+i),t.b("            </table>"),t.b("\n"+i),t.b("        </div>"),t.b("\n"+i),t.b("    </div>"),t.b("\n"+i),t.b("</div>"),t.fl()},partials:{},subs:{}}),global.browserTemplates["line-by-line-numbers"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<div class="line-num1">'),t.b(t.v(t.f("oldNumber",c,p,0))),t.b("</div>"),t.b("\n"+i),t.b('<div class="line-num2">'),t.b(t.v(t.f("newNumber",c,p,0))),t.b("</div>"),t.fl()},partials:{},subs:{}}),global.browserTemplates["side-by-side-file-diff"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<div id="'),t.b(t.v(t.f("fileHtmlId",c,p,0))),t.b('" class="d2h-file-wrapper" data-lang="'),t.b(t.v(t.d("file.language",c,p,0))),t.b('">'),t.b("\n"+i),t.b('    <div class="d2h-file-header">'),t.b("\n"+i),t.b("      "),t.b(t.t(t.f("filePath",c,p,0))),t.b("\n"+i),t.b("    </div>"),t.b("\n"+i),t.b('    <div class="d2h-files-diff">'),t.b("\n"+i),t.b('        <div class="d2h-file-side-diff">'),t.b("\n"+i),t.b('            <div class="d2h-code-wrapper">'),t.b("\n"+i),t.b('                <table class="d2h-diff-table">'),t.b("\n"+i),t.b('                    <tbody class="d2h-diff-tbody">'),t.b("\n"+i),t.b("                    "),t.b(t.t(t.d("diffs.left",c,p,0))),t.b("\n"+i),t.b("                    </tbody>"),t.b("\n"+i),t.b("                </table>"),t.b("\n"+i),t.b("            </div>"),t.b("\n"+i),t.b("        </div>"),t.b("\n"+i),t.b('        <div class="d2h-file-side-diff">'),t.b("\n"+i),t.b('            <div class="d2h-code-wrapper">'),t.b("\n"+i),t.b('                <table class="d2h-diff-table">'),t.b("\n"+i),t.b('                    <tbody class="d2h-diff-tbody">'),t.b("\n"+i),t.b("                    "),t.b(t.t(t.d("diffs.right",c,p,0))),t.b("\n"+i),t.b("                    </tbody>"),t.b("\n"+i),t.b("                </table>"),t.b("\n"+i),t.b("            </div>"),t.b("\n"+i),t.b("        </div>"),t.b("\n"+i),t.b("    </div>"),t.b("\n"+i),t.b("</div>"),t.fl()},partials:{},subs:{}}),global.browserTemplates["tag-file-added"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<span class="d2h-tag d2h-added d2h-added-tag">ADDED</span>'),t.fl()},partials:{},subs:{}}),global.browserTemplates["tag-file-changed"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<span class="d2h-tag d2h-changed d2h-changed-tag">CHANGED</span>'),t.fl()},partials:{},subs:{}}),global.browserTemplates["tag-file-deleted"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<span class="d2h-tag d2h-deleted d2h-deleted-tag">DELETED</span>'),t.fl()},partials:{},subs:{}}),global.browserTemplates["tag-file-renamed"]=new Hogan.Template({code:function(c,p,i){var t=this;return t.b(i=i||""),t.b('<span class="d2h-tag d2h-moved d2h-moved-tag">RENAMED</span>'),t.fl()},partials:{},subs:{}}),module.exports=global.browserTemplates}()}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"hogan.js":4}],19:[function(require,module,exports){function Utils(){}var merge;merge=require("merge"),Utils.prototype.escape=function(str){return str.slice(0).replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#x27;").replace(/\//g,"&#x2F;")},Utils.prototype.startsWith=function(str,start){if("object"!=typeof start)return str&&0===str.indexOf(start);var result=!1;return start.forEach((function(s){0===str.indexOf(s)&&(result=!0)})),result},Utils.prototype.valueOrEmpty=function(value){return value||""},Utils.prototype.safeConfig=function(cfg,defaultConfig){return merge.recursive(!0,defaultConfig,cfg)},module.exports.Utils=new Utils},{merge:6}]},{},[10]);
/**
 * EGroupware eTemplate2 - JS Diff object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2012
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_diff=function(_super){function et2_diff(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_diff._attributes,_child||{}))||this;return _this.mini=!0,_this.div=document.createElement("div"),jQuery(_this.div).addClass("et2_diff"),_this}return __extends(et2_diff,_super),et2_diff.prototype.set_value=function(value){if(jQuery(this.div).empty(),"string"==typeof value){0!==value.indexOf("---")&&(value="--- diff\n+++ diff\n"+value);var diff=Diff2Html.getPrettyHtml(value,this.diff_options);jQuery(this.div).append(diff)}else"object"!=typeof value&&jQuery(this.div).append(value);this.check_mini()},et2_diff.prototype.check_mini=function(){if(!this.mini)return!1;var view=jQuery(this.div).children();this.minify(view);var self=this;jQuery('<span class="ui-icon ui-icon-circle-plus">&nbsp;</span>').appendTo(self.div).css("cursor","pointer").click({diff:view,div:self.div,label:self.options.label},(function(e){var diff=e.data.diff,div=e.data.div;self.un_minify(diff);var dialog_div=jQuery("<div>").append(diff);dialog_div.dialog({title:e.data.label,width:"auto",modal:!0,buttons:[{text:self.egw().lang("ok"),click:function(){jQuery(this).dialog("close")}}],open:function(){jQuery(this).parent().height()>jQuery(window).height()&&jQuery(this).height(.7*jQuery(window).height()),jQuery(this).addClass("et2_diff").dialog({position:"center"})},close:function(event,ui){dialog_div.dialog("destroy"),self.minify(this),diff.prependTo(div)}})}))},et2_diff.prototype.set_label=function(_label){this.options.label=_label},et2_diff.prototype.minify=function(view){view=jQuery(view).addClass("mini").width("100%").css("height","inherit").show(),jQuery("th",view).hide(),jQuery("td.equal",view).hide().prevAll().hide()},et2_diff.prototype.un_minify=function(view){jQuery(view).removeClass("mini").show(),jQuery("th",view).show(),jQuery("td.equal",view).show()},et2_diff.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value","label")},et2_diff.prototype.getDetachedNodes=function(){return[this.div]},et2_diff.prototype.setDetachedAttributes=function(_nodes,_values){this.div=_nodes[0],void 0!==_values.label&&this.set_label(_values.label),void 0!==_values.value&&this.set_value(_values.value)},et2_diff._attributes={value:{type:"any"}},et2_diff}((et2_core_valueWidget_1=require("./et2_core_valueWidget")).et2_valueWidget);exports.et2_diff=et2_diff,et2_core_widget_1.et2_register_widget(et2_diff,["diff"]);
/**
 * EGroupware eTemplate2 - JS Dropdown Button object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2013
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_inputWidget_1=require("./et2_core_inputWidget"),et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_dropdown_button=function(_super){function et2_dropdown_button(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_dropdown_button._attributes,_child||{}))||this;_this.internal_ids={div:"",button:"",menu:""},_this.div=null,_this.buttons=null,_this.button=null,_this.arrow=null,_this.menu=null,_this.image=null,_this.clicked=!1,_this.label_updates=!0,_this.value=null,_this.default_menu='<ul> <li data-id="opt_1.1"><a href="#">Option-1.1</a></li><li data-id="opt_1.2"><a href="#">Option-1.2</a></li><li data-id="opt_1.3"><a href="#">Option-1.3</a></li><li data-id="opt_1.4"><a href="#">Option-1.4<br>\t<small>with second line</small></a></li><li data-id="opt_1.5"><a href="#">Option-1.5</a></li></ul>',_this.clicked=!1;var self=_this;return _this.menu=jQuery(_this.default_menu).attr("id",_this.internal_ids.menu).hide().menu({select:function(event,ui){self.onselect.call(self,event,ui.item)}}),_this.buttons=jQuery(document.createElement("div")).addClass("et2_dropdown"),_this.div=jQuery(document.createElement("div")).attr("id",_this.internal_ids.div).append(_this.buttons).append(_this.menu),_this.button=jQuery(document.createElement("button")).attr("id",_this.internal_ids.button).attr("type","button").addClass("ui-widget ui-corner-left").removeClass("ui-corner-all").appendTo(_this.buttons),_this.arrow=jQuery(document.createElement("button")).addClass("ui-widget ui-corner-right").removeClass("ui-corner-all").attr("type","button").click((function(){if(self.options.readonly)return!1;if(self.menu.is(":visible"))return self.menu.hide(),!1;var menu=self.menu.show().position({my:"left top",at:"left bottom",of:self.buttons});return jQuery(document).one("click",(function(){menu.hide()})),!1})).append("<div class='ui-icon ui-icon-triangle-1-s'/>").appendTo(_this.buttons),_this.buttons.children("button").addClass("ui-state-default").hover((function(){jQuery(this).addClass("ui-state-hover")}),(function(){jQuery(this).removeClass("ui-state-hover")})),_this.image=jQuery(document.createElement("img")),_this.setDOMNode(_this.div[0]),_this}return __extends(et2_dropdown_button,_super),et2_dropdown_button.prototype.destroy=function(){this.menu&&this.menu.data("ui-menu")&&this.menu.menu("destroy"),this.image=null,this.button=null,this.arrow=null,this.buttons=null,this.menu=null,this.div.empty().remove()},et2_dropdown_button.prototype.set_id=function(_id){for(var key in _super.prototype.set_id.call(this,_id),this.internal_ids={div:this.dom_id+"_wrapper",button:this.dom_id,menu:this.dom_id+"_menu"},this.internal_ids)null!=this[key]&&this[key].attr("id",this.internal_ids[key])},et2_dropdown_button.prototype.set_label_updates=function(updates){this.label_updates=updates},et2_dropdown_button.prototype.set_accesskey=function(key){jQuery(this.node).attr("accesskey",key)},et2_dropdown_button.prototype.set_ro_image=function(_image){this.options.readonly&&this.set_image(_image)},et2_dropdown_button.prototype.set_image=function(_image){if(this.isInTree()&&null!=this.image){_image.trim()?this.image.show():this.image.hide();var src=this.egw().image(_image);src?this.image.attr("src",src):"/"==_image[0]||"http"==_image.substr(0,4)?this.image.attr("src",_image):this.image.hide()}},et2_dropdown_button.prototype.click=function(_ev){return!this.options.readonly&&(this.clicked=!0,_super.prototype.click.call(this,_ev)?(this.clicked=!1,!0):(this.clicked=!1,!1))},et2_dropdown_button.prototype.onselect=function(event,selected_node){this.set_value(selected_node.attr("data-id")),this.change(selected_node)},et2_dropdown_button.prototype.attachToDOM=function(){var res=_super.prototype.attachToDOM.call(this);return jQuery(this.node).unbind("click.et2_baseWidget"),this.button.off().bind("click.et2_baseWidget",this,(function(e){return e.data.click.call(e.data,this)})),res},et2_dropdown_button.prototype.set_label=function(_value){this.button&&(this.label=_value,this.button.text(_value).prepend(this.image))},et2_dropdown_button.prototype.set_select_options=function(options){if(this.menu.first().empty(),"string"==typeof options)this.menu.append(options);else{var add_complex_1=function(node,options){for(var key in options){var item=void 0;"string"==typeof options[key]?item=jQuery("<li data-id='"+key+"'><a href='#'>"+options[key]+"</a></li>"):options[key].label?item=jQuery("<li data-id='"+key+"'><a href='#'>"+options[key].label+"</a></li>"):(item=jQuery("<li><a href='#'>"+key+"</a></li>"),add_complex_1(node.append("<ul>"),options[key])),node.append(item),item&&options[key].icon&&jQuery("a",item).prepend('<img class="et2_button_icon" src="'+(options[key].icon.match(/^(http|https|\/)/)?options[key].icon:egw.image(options[key].icon))+'"/>')}};add_complex_1(this.menu.first(),options)}this.menu.menu("refresh")},et2_dropdown_button.prototype.set_tabindex=function(index){jQuery(this.button).attr("tabindex",index)},et2_dropdown_button.prototype.set_value=function(new_value){var menu_item=jQuery("[data-id='"+new_value+"']",this.menu);menu_item.length?(this.value=new_value,this.label_updates&&this.set_label(menu_item.text())):(this.value=null,this.label_updates&&this.set_label(this.options.label))},et2_dropdown_button.prototype.getValue=function(){return this.value},et2_dropdown_button.prototype.set_readonly=function(_ro){_ro!=this.options.readonly&&(this.options.readonly=_ro,this.buttons&&this.buttons.find("button").toggleClass("et2_clickable",!_ro).toggleClass("et2_button_ro",_ro).css("cursor",_ro?"default":"pointer"))},et2_dropdown_button.attributes={label:{name:"caption",type:"string",description:"Label of the button",translate:!0,default:"Select..."},label_updates:{name:"Label updates",type:"boolean",description:"Button label updates when an option is selected from the menu",default:!0},image:{name:"Icon",type:"string",description:"Add an icon"},ro_image:{name:"Read-only Icon",type:"string",description:"Use this icon instead of hiding for read-only"},onclick:{description:"JS code which gets executed when the button is clicked"},select_options:{type:"any",name:"Select options",default:{},description:"Select options for dropdown.  Can be a simple key => value list, or value can be full HTML",ignore:!0},accesskey:{name:"Access Key",type:"string",default:et2_no_init,description:"Alt + <key> activates widget"},tabindex:{name:"Tab index",type:"integer",default:et2_no_init,description:"Specifies the tab order of a widget when the 'tab' button is used for navigating."},required:{ignore:!0}},et2_dropdown_button}(et2_core_inputWidget_1.et2_inputWidget);exports.et2_dropdown_button=et2_dropdown_button,et2_core_widget_1.et2_register_widget(et2_dropdown_button,["dropdown_button"]);
/**
 * EGroupware eTemplate2 - JS widget class containing styles
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_styles=function(_super){function et2_styles(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_styles._attributes,_child||{}))||this;return _this.supportedWidgetClasses=[],_this.styleNode=document.createElement("style"),_this.styleNode.setAttribute("type","text/css"),_this.head=_this.egw().window.document.getElementsByTagName("head")[0],_this.head.appendChild(_this.styleNode),_this}return __extends(et2_styles,_super),et2_styles.prototype.destroy=function(){this.head.removeChild(this.styleNode),_super.prototype.destroy.call(this)},et2_styles.prototype.loadContent=function(_content){this.styleNode.styleSheet?this.styleNode.styleSheet.cssText+=_content:this.styleNode.appendChild(document.createTextNode(_content))},et2_styles.prototype.set_id=function(_value){this.id=_value,this.dom_id=_value?this.getInstanceManager().uniqueId+"_"+_value.replace(/\./g,"-"):_value,this.styleNode&&(""!=_value?this.styleNode.setAttribute("id",this.dom_id):this.styleNode.removeAttribute("id"))},et2_styles}(et2_core_widget_1.et2_widget);exports.et2_styles=et2_styles,et2_core_widget_1.et2_register_widget(et2_styles,["styles"]);
/**
 * EGroupware eTemplate2 - JS Link object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright 2011 Nathan Gray
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_valueWidget_1=require("./et2_core_valueWidget"),et2_core_inputWidget_1=require("./et2_core_inputWidget");var et2_widget_selectbox_1=require("./et2_widget_selectbox"),et2_link_to=(et2_widget_dialog_1=require("./et2_widget_dialog"),function(_super){function et2_link_to(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_link_to._attributes,_child||{}))||this;return _this.div=jQuery(document.createElement("div")).addClass("et2_link_to et2_toolbar"),_this.link_button=null,_this.status_span=null,_this.link_entry=null,_this.file_upload=null,_this.createInputWidget(),_this}return __extends(et2_link_to,_super),et2_link_to.prototype.destroy=function(){this.link_button=null,this.status_span=null,this.link_entry&&(this.link_entry.destroy(),this.link_entry=null),this.file_upload&&(this.file_upload.destroy(),this.file_upload=null),this.div=null,_super.prototype.destroy.apply(this,arguments)},et2_link_to.prototype.getDOMNode=function(_sender){return _sender==this?this.div[0]:"link-entry"==_sender._type?this.link_div[0]:"file"==_sender._type?this.file_div[0]:"vfs-select"==_sender._type?this.filemanager_button[0]:void 0},et2_link_to.prototype.createInputWidget=function(){this.file_div=jQuery(document.createElement("div")).css({display:"inline-block"}).appendTo(this.div),this.filemanager_button=jQuery(document.createElement("div")).css({display:"inline-block"}).appendTo(this.div),this.link_div=jQuery(document.createElement("div")).addClass("div_link").appendTo(this.div),this.options.readonly||(this.link_button=jQuery(document.createElement("button")).text(this.egw().lang(this.options.link_label)).appendTo(this.div).hide().addClass("link").click(this,this.createLink),this.status_span=jQuery(document.createElement("span")).appendTo(this.div).addClass("status").hide()),this.setDOMNode(this.div[0])},et2_link_to.prototype.doLoadingFinished=function(){_super.prototype.doLoadingFinished.apply(this,arguments);var self=this;if(this.link_entry&&this.vfs_select&&this.file_upload)return!1;var link_entry_attrs={id:this.id+"_link_entry",only_app:this.options.only_app,application_list:this.options.application_list,blur:this.options.search_label?this.options.search_label:this.egw().lang("Search..."),query:function(){return self.link_button.hide(),!0},select:function(){return self.link_button.show(),!0},readonly:this.options.readonly};this.link_entry=et2_core_widget_1.et2_createWidget("link-entry",link_entry_attrs,this);var select_attrs={button_label:egw.lang("Link"),button_caption:"",button_icon:"link",readonly:this.options.readonly,dialog_title:egw.lang("Link"),extra_buttons:[{text:egw.lang("copy"),id:"copy",image:"copy"},{text:egw.lang("move"),id:"move",image:"move"}],onchange:function(){var values=!0;if(!self.options.value.to_id||"object"==typeof self.options.value.to_id){values=self.options.value.to_id||{};var files=self.vfs_select.getValue();if(void 0!==files)for(var i=0;i<files.length;i++)values["link:"+files[i]]={app:"link",id:files[i],type:"unknown",icon:"link",remark:"",title:files[i]}}self._link_result(values)}};self.options.value&&self.options.value.to_id&&"object"!=typeof self.options.value.to_id&&(select_attrs.method="EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link_existing",select_attrs.method_id=self.options.value.to_app+":"+self.options.value.to_id),this.vfs_select=et2_core_widget_1.et2_createWidget("vfs-select",select_attrs,this),this.vfs_select.set_readonly(this.options.readonly);var file_attrs={multiple:!0,id:this.id+"_file",label:"",drop_target:this.getInstanceManager().DOMContainer.getAttribute("id"),readonly:this.options.readonly,onStart:function(event,file_count){var tabs=self;do{tabs=tabs.getParent()}while(tabs!=self.getRoot()&&"tabbox"!=tabs.getType());return tabs!=self.getRoot()&&tabs.activateTab(self),!0},onFinish:function(event,file_count){event.data=self,self.filesUploaded(event),self.createLink(event)}};return this.file_upload=et2_core_widget_1.et2_createWidget("file",file_attrs,this),this.file_upload.set_readonly(this.options.readonly),!0},et2_link_to.prototype.getValue=function(){return this.options.value},et2_link_to.prototype.filesUploaded=function(event){this.link_button.show()},et2_link_to.prototype.createLink=function(event){event.data.link_button.attr("disabled",!0);var values=event.data.options.value,self=event.data,links=[];if(event.data=self.link_entry,self.link_entry.createLink(event,links),!self.options.no_files)for(var file in self.file_upload.options.value)links.push({app:"file",id:file,name:self.file_upload.options.value[file].name,type:self.file_upload.options.value[file].type,remark:jQuery("li[file='"+self.file_upload.options.value[file].name.replace(/'/g,"&quot")+"'] > input",self.file_upload.progress).filter((function(){return jQuery(this).attr("placeholder")!=jQuery(this).val()})).val()});0!=links.length&&egw.json("EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link",[values.to_app,values.to_id,links],self._link_result,self,!0,self).sendRequest()},et2_link_to.prototype._link_result=function(success){if(success){for(var file in this.link_button.hide().attr("disabled",!1),this.status_span.removeClass("error").addClass("success"),this.status_span.fadeIn().delay(1e3).fadeOut(),delete this.options.value.app,delete this.options.value.id,this.file_upload.options.value)delete this.file_upload.options.value[file];if(this.file_upload.progress.empty(),"object"==typeof success)for(var link in"object"!=typeof this.options.value&&(this.options.value={}),this.options.value.to_id=success,success)void 0===success[link].icon&&(success[link].icon=egw.link_get_registry(success[link].app,"icon"),0==success[link].icon&&success[link].id.type&&(success[link].type=success[link].id.type,success[link].icon=!0)),"file"==success[link].app&&void 0===success[link].title&&(success[link].title=success[link].id.name||"");var self=this,list_widget=null;if(this.getRoot().iterateOver((function(widget){widget.id==self.id&&(list_widget=widget,!0===success&&widget._get_links())}),this,et2_link_list),list_widget&&success){list_widget.set_value(null);var _loop_1=function(){var link=success[link_id];void 0===link.title?egw.link_title(link.app,link.id,(function(title){link.title=title,list_widget._add_link(link)})):list_widget._add_link(link)};for(var link_id in success)_loop_1()}}else this.status_span.removeClass("success").addClass("error").fadeIn();this.div.trigger("link.et2_link_to",success)},et2_link_to.prototype.set_no_files=function(no_files){this.options.readonly||(no_files?(this.file_div.hide(),this.filemanager_button.hide()):(this.file_div.show(),this.filemanager_button.show()),this.options.no_files=no_files)},et2_link_to._attributes={only_app:{name:"Application",type:"string",default:"",description:"Limit to just this one application - hides app selection"},application_list:{name:"Application list",type:"any",default:"",description:"Limit to the listed application or applications (comma seperated)"},blur:{name:"Placeholder",type:"string",default:"",description:"This text get displayed if an input-field is empty and does not have the input-focus (blur). It can be used to show a default value or a kind of help-text.",translate:!0},no_files:{name:"No files",type:"boolean",default:!1,description:"Suppress attach-files"},search_label:{name:"Search label",type:"string",default:"",description:"Label to use for search"},link_label:{name:"Link label",type:"string",default:"Link",description:"Label for the link button"},value:{type:"any"}},et2_link_to}(et2_core_inputWidget_1.et2_inputWidget));exports.et2_link_to=et2_link_to,et2_core_widget_1.et2_register_widget(et2_link_to,["link-to"]);var et2_link_apps=function(_super){function et2_link_apps(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_link_apps._attributes,_child||{}))||this;if(null!=_this.options.select_options){_this.options.value||_this.set_value(egw.preference("link_app",_this.egw().getAppName()));var self=_this;_this.input.bind("click",(function(){if(void 0!==self.options.value)var appname=self.options.value.to_app;egw.set_preference(appname||self.egw().getAppName(),"link_app",self.getValue())}))}return _this}return __extends(et2_link_apps,_super),et2_link_apps.prototype.transformAttributes=function(_attrs){var select_options={};_attrs.only_app?select_options[_attrs.only_app]=this.egw().lang(_attrs.only_app):_attrs.application_list?select_options=_attrs.application_list:void 0!==(select_options=egw.link_app_list("query"))["addressbook-email"]&&delete select_options["addressbook-email"],_attrs.select_options=select_options,_super.prototype.transformAttributes.call(this,_attrs)},et2_link_apps._attributes={only_app:{name:"Application",type:"string",default:"",description:"Limit to just this one application - hides app selection"},application_list:{name:"Application list",type:"any",default:"",description:"Limit to the listed application or applications (comma seperated)"}},et2_link_apps}(et2_widget_selectbox_1.et2_selectbox);exports.et2_link_apps=et2_link_apps,et2_core_widget_1.et2_register_widget(et2_link_apps,["link-apps"]);var et2_link_entry=function(_super){function et2_link_entry(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_link_entry._attributes,_child||{}))||this;_this.cache={},_this.processing=!1,_this.search=null,_this.clear=null,_this.app_select=null,_this._oldValue={id:null,app:_this.options.value&&_this.options.value.app?_this.options.value.app:_this.options.only_app},void 0!==_this.options.value&&null!=_this.options.value||(_this.options.value={}),_this.cache={},_this.request=null,_this.createInputWidget();var self=_this;return jQuery(_this.getInstanceManager().DOMContainer).on("clear",(function(){jQuery(self.getDOMNode()).off()})),_this}return __extends(et2_link_entry,_super),et2_link_entry.prototype.destroy=function(){_super.prototype.destroy.apply(this,arguments),this.div=null,this.search.data("ui-autocomplete")&&this.search.autocomplete("destroy"),this.search=null,this.clear=null,this.app_select=null,this.request=null},et2_link_entry.prototype.createInputWidget=function(){var self=this;this.div=jQuery(document.createElement("div")).addClass("et2_link_entry"),jQuery.widget("custom.iconselectmenu",jQuery.ui.selectmenu,{_setText:function(element,value){element===this.buttonText?this._setButtonText(value):this._superApply(element,value)},_setButtonText:function(value){var _value=this.focusIndex;void 0===this.focusIndex?_value=this.element.find("option:selected").val():_value=(this.items[_value]||{}).value;var url=self.egw().image("navbar",_value),buttonItem=jQuery("<span>",{class:"ui-selectmenu-text",title:value});jQuery(".ui-selectmenu-text",this.button).replaceWith(buttonItem),buttonItem.css("background-image","url("+url+")")},_renderItem:function(ul,item){var li=jQuery("<li>",{class:"et2_link_entry_app_option"}),wrapper=jQuery("<div>",{text:item.label});item.disabled&&li.addClass("ui-state-disabled"),ul.addClass(self.div.attr("class"));var url=self.egw().image("navbar",item.value);return jQuery("<span>",{style:'background-image: url("'+url+'");',class:"ui-icon "+item.element.attr("data-class"),title:item.label}).appendTo(wrapper),li.append(wrapper).appendTo(ul)}}),this.app_select=jQuery(document.createElement("select")).appendTo(this.div).change((function(e){self.cache={},egw.set_preference(self.options.value.to_app||self.egw().getAppName(),"link_app",self.app_select.val()),"object"!=typeof self.options.value&&(self.options.value={}),self.options.value.app=self.app_select.val()}));for(var key in this.options.select_options){jQuery(document.createElement("option")).attr("value",key).text(this.options.select_options[key]).appendTo(this.app_select)}this.options.only_app?(this.app_select.val(this.options.only_app),this.app_select.hide(),this.options.app_icons&&this.app_select.iconselectmenu("instance")&&this.app_select.iconselectmenu("widget").hide(),this.div.addClass("no_app")):(this.app_select.val(this.options.value.app||""),this.app_select.iconselectmenu("instance")&&this.app_select.iconselectmenu("update")),this.search=jQuery(document.createElement("input")).focus((function(){self.options.only_app||(self.div.removeClass("no_app"),self.options.app_icons?self.app_select.iconselectmenu("widget").show():self.app_select.show())})).blur((function(e){self.div.has(e.relatedTarget).length||(self.options.app_icons?(self.div.addClass("no_app"),self.app_select.iconselectmenu("widget").hide()):self.search.val()&&self.options.only_app&&self.div.addClass("no_app"))})).appendTo(this.div),this.set_blur(this.options.blur?this.options.blur:this.egw().lang("search"),this.search),this.search.autocomplete({source:function(request,response){return self.query(request,response)},select:function(event,item){return event.data=self,item.item.value&&(item.item.value=(""+item.item.value).trim()),self.select(event,item),!1},focus:function(event,item){return event.stopPropagation(),self.search.val(item.item.label),!1},minLength:et2_link_entry.minimum_characters,delay:et2_link_entry.search_timeout,disabled:self.options.disabled,appendTo:self.div}),this.search.data("uiAutocomplete")._renderItem=function(ul,item){var li=jQuery(document.createElement("li")).data("item.autocomplete",item),extra={};if("object"==typeof item.label&&(extra=item.label,item.label=extra.label?extra.label:extra,(extra["style.backgroundColor"]||extra.color)&&li.css({"border-left":"5px solid "+(extra.color?extra.color:extra["style.backgroundColor"])}),extra.icon)){var img=self.egw().image(extra.icon);img&&jQuery(document.createElement("img")).attr("src",img).css("float","right").appendTo(li)}return li.append(jQuery("<a></a>").text(item.label)).appendTo(ul),window.setTimeout((function(){ul.css("max-width",jQuery(".et2_container").width()-ul.offset().left)}),300),li},this.search.keydown((function(e){if(13==(e.keyCode?e.keyCode:e.which)&&!self.processing)return self.search.autocomplete("option","minLength",0),self.search.autocomplete("search"),self.search.autocomplete("option","minLength",self.minimum_characters),!1})),this.clear=jQuery(document.createElement("span")).addClass("ui-icon ui-icon-close").click((function(e){self.search&&(self.last_search&&self.last_search!=self.search.val()?(self.search.val(self.last_search),self.last_search="",self.search.autocomplete("search")):(self.search.autocomplete("close"),self.set_value(null),self.search.val(""),window.setTimeout((function(){self.search.trigger("change")}),0)),self.search.focus())})).appendTo(this.div).hide(),this.setDOMNode(this.div[0])},et2_link_entry.prototype.getDOMNode=function(){return this.div?this.div[0]:null},et2_link_entry.prototype.transformAttributes=function(_attrs){if(_super.prototype.transformAttributes.apply(this,arguments),_attrs.select_options={},_attrs.application_list)for(var apps="string"==typeof _attrs.application_list?et2_csvSplit(_attrs.application_list,null,","):_attrs.application_list,i=0;i<apps.length;i++)_attrs.select_options[apps[i]]=this.egw().lang(apps[i]);else _attrs.select_options=this.egw().link_app_list("query"),void 0!==_attrs.select_options["addressbook-email"]&&delete _attrs.select_options["addressbook-email"];null==_attrs.select_options&&(_attrs.select_options=this.getArrayMgr("content").getEntry("options-"+this.id)),null==_attrs.select_options&&(_attrs.select_options={})},et2_link_entry.prototype.doLoadingFinished=function(){if("object"!=typeof this.options.value||this.options.value.app||(this.options.value.app=egw.preference("link_app",this.options.value.to_app||this.egw().getAppName()),void 0!==this.options.value.app&&this.options.value.app||(this.options.value.app=Object.keys(this.options.select_options)[0]),this.app_select.val(this.options.value.app)),this.options.app_icons){var self=this;this.div.addClass("app_icons"),this.app_select.iconselectmenu({width:50,change:function(){window.setTimeout((function(){self.app_select.trigger("change")}),0)}}).iconselectmenu("menuWidget"),this.app_select.iconselectmenu("widget").hide()}return _super.prototype.doLoadingFinished.apply(this,arguments)},et2_link_entry.prototype.getValue=function(){var value=this.options&&this.options.only_app?this.options.value.id:this.options?this.options.value:null;return this.options&&!this.options.only_app&&this.search&&(value.search=this.search.val()),value},et2_link_entry.prototype.set_value=function(_value){if("string"==typeof _value||"number"==typeof _value)if("string"==typeof _value&&_value.indexOf(",")>0&&(_value=_value.replace(",",":")),"string"==typeof _value&&_value.indexOf(":")>=0){var split=_value.split(":");_value={app:split.shift(),id:1==split.length?split[0]:split}}else _value&&this.options.only_app&&(_value={app:this.options.only_app,id:_value});if(this._oldValue=this.options.value,_value&&0!=_value.length&&null!=_value&&!jQuery.isEmptyObject(_value)||(this.search.val(""),this.clear.hide(),this.options.value=_value={id:null}),_value.app||(_value.app=this.options.only_app||this.app_select.val()),_value.id)if(this.clear.css("display",""),"object"==typeof _value&&(_value.app||_value.id)){if(!_value.title)if(null!=(title=this.egw().link_title(_value.app,_value.id)))_value.title=title;else{var title=this.egw().link_title(_value.app,_value.id,(function(title){this.search.removeClass("loading").val(title+""),this.clear.css("display","")}),this);this.search.addClass("loading")}_value.title&&this.search.val(_value.title+""),this.options.value=_value,jQuery("option[value='"+_value.app+"']",this.app_select).prop("selected",!0),this.app_select.hide(),this.options.app_icons&&this.app_select.iconselectmenu("instance")&&this.app_select.iconselectmenu("widget").hide(),this.div.addClass("no_app")}else console.warn("Bad value for link widget.  Need an object with keys 'app', 'id', and optionally 'title'",_value);else this.clear.hide()},et2_link_entry.prototype.set_blur=function(_value,input){void 0===input&&(input=this.search),_value?(input.attr("placeholder",_value),input[0].placeholder||(""==input.val()&&input.val(_value),input.focus(input,(function(e){var placeholder=_value;e.data.val()==placeholder&&e.data.val("")})).blur(input,(function(e){var placeholder=_value;""==e.data.val()&&e.data.val(placeholder)})),""==input.val()&&input.val(_value))):this.search.removeAttr("placeholder")},et2_link_entry.prototype.set_query=function(f){this.options.query=f},et2_link_entry.prototype.set_select=function(f){this.options.select=f},et2_link_entry.prototype.query=function(request,response){return this.request&&(this.request.abort(),this.request=null),this.last_search=this.search.val(),!(this.options.query&&"function"==typeof this.options.query&&!this.options.query(request,this))&&(void 0===request.no_cache&&!request.no_cache&&request.term in this.cache?response(this.cache[request.term]):(this.response=response,this.search.addClass("loading"),this.clear.css("display",""),void(this.request=egw.json("EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link_search",[this.app_select.val(),"",request.term,request.options],this._results,this,!0,this).sendRequest())))},et2_link_entry.prototype.select=function(event,selected){if(null!==selected.item.value&&"string"==typeof selected.item.value&&(selected.item.value=selected.item.value.trim()),this.options.select&&"function"==typeof this.options.select&&!this.options.select(event,selected))return!1;"object"==typeof event.data.options.value&&null!=event.data.options.value||(event.data.options.value={}),event.data.options.value.id=selected.item.value,event.data.processing=!0,this.clear.css("display",""),event.data.search.val(selected.item.label),this.search.change(),window.setTimeout(jQuery.proxy((function(){delete this.processing}),event.data))},et2_link_entry.prototype._results=function(data){this.request&&(this.request=null),this.search.removeClass("loading");var result=[];for(var id in data)result.push({value:id,label:data[id]});this.cache[this.search.val()]=result,this.response(result)},et2_link_entry.prototype.createLink=function(event,_links){var values=event.data.options.value,self=event.data,links=[];(links=void 0===_links?[]:_links,values.id&&(links.push({app:values.app,id:values.id}),self.search.val("")),void 0===_links)&&egw.json("EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link",[values.to_app,values.to_id,links],self._link_result,this,!0).sendRequest()},et2_link_entry.prototype._link_result=function(success){success&&(this.status_span.fadeIn().delay(1e3).fadeOut(),delete this.options.value.app,delete this.options.value.id)},et2_link_entry._attributes={value:{type:"any",default:{}},only_app:{name:"Application",type:"string",default:"",description:"Limit to just this one application - hides app selection"},application_list:{name:"Application list",type:"any",default:"",description:"Limit to the listed applications (comma seperated)"},app_icons:{name:"Application icons",type:"boolean",default:!1,description:"Show application icons instead of names"},blur:{name:"Placeholder",type:"string",default:et2_no_init,description:"This text get displayed if an input-field is empty and does not have the input-focus (blur). It can be used to show a default value or a kind of help-text.",translate:!0},query:{name:"Query callback",type:"js",default:et2_no_init,description:"Callback before query to server.  It will be passed the request & et2_link_entry objects.  Must return true, or false to abort query."},select:{name:"Select callback",type:"js",default:et2_no_init,description:"Callback when user selects an option.  Must return true, or false to abort normal action."}},et2_link_entry.legacyOptions=["only_app","application_list"],et2_link_entry.search_timeout=500,et2_link_entry.minimum_characters=4,et2_link_entry}(et2_core_inputWidget_1.et2_inputWidget);exports.et2_link_entry=et2_link_entry,et2_core_widget_1.et2_register_widget(et2_link_entry,["link-entry"]);var et2_link=function(_super){function et2_link(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_link._attributes,_child||{}))||this;return _this.label_span=jQuery(document.createElement("label")).addClass("et2_label"),_this.link=jQuery(document.createElement("span")).addClass("et2_link").appendTo(_this.label_span),_this.options.class&&_this.label_span.addClass(_this.options.class),_this.setDOMNode(_this.label_span[0]),_this}return __extends(et2_link,_super),et2_link.prototype.destroy=function(){this.link&&this.link.unbind(),this.link=null,_super.prototype.destroy.apply(this,arguments)},et2_link.prototype.set_label=function(label){this.label_span.contents().filter((function(){return 3==this.nodeType})).remove();var parts=et2_csvSplit(label,2,"%s");this.label_span.prepend(parts[0]),this.label_span.append(parts[1]),this.label=label,this.label_span.toggleClass("et2_label_empty",!label||!parts[0])},et2_link.prototype.set_value=function(_value){if("object"!=typeof _value&&_value&&!this.options.only_app){if(!(_value.indexOf(":")>=0))return void console.warn("Bad value for link widget.  Need an object with keys 'app', 'id', and optionally 'title'",_value);var app=_value.split(":",1),id=_value.substr(app[0].length+1);_value={app:app[0],id:id}}else"object"!=typeof _value&&(_value={app:this.options.only_app,id:_value});if(_value&&!jQuery.isEmptyObject(_value)){var self=this;if(this.link.unbind(),_value.id&&_value.app?(this.link.addClass("et2_link"),this.link.click((function(e){_value.title||(_value.title=self.egw().link_title(_value.app,_value.id)),self.options.target_app||(self.options.target_app=_value.app);var target=self.options.extra_link_target||_value.app;self.egw().open(_value,"",self.options.link_hook,_value.extra_args,target,self.options.target_app),e.stopImmediatePropagation()}))):this.link.removeClass("et2_link"),!_value.title){self=this;var node=this.link[0];if(_value.app&&_value.id){var title=this.egw().link_title(_value.app,_value.id,(function(title){self.set_title(node,title)}),this);if(null==title)return;_value.title=title}else _value.title=""}this.set_title(this.link,_value.title)}else this.link.text("").unbind()},et2_link.prototype.set_title=function(node,_value){!1!==_value&&null!==_value||(_value=""),jQuery(node).text(_value+"")},et2_link.prototype.getDetachedAttributes=function(_attrs){_attrs.push("label","value")},et2_link.prototype.getDetachedNodes=function(){return[this.node,this.link[0]]},et2_link.prototype.setDetachedAttributes=function(_nodes,_values){this.node=_nodes[0],this.label_span=jQuery(_nodes[0]),this.link=jQuery(_nodes[1]),void 0!==_values.id&&this.set_id(_values.id),void 0!==_values.label&&this.set_label(_values.label),void 0!==_values.value&&this.set_value(_values.value)},et2_link._attributes={only_app:{name:"Application",type:"string",default:"",description:"Use the given application, so you can pass just the ID for value"},value:{description:"Array with keys app, id, and optionally title",type:"any"},needed:{ignore:!0},link_hook:{name:"Type",type:"string",default:"view",description:"Hook used for displaying link (view/edit/add)"},target_app:{name:"Target application",type:"string",default:"",description:"Optional parameter to be passed to egw().open in order to open links in specified application"},extra_link_target:{name:"Link target",type:"string",default:null,description:"Optional parameter to be passed to egw().open in order to open links in specified target eg. _blank"}},et2_link.legacyOptions=["only_app"],et2_link}(et2_core_valueWidget_1.et2_valueWidget);exports.et2_link=et2_link,et2_core_widget_1.et2_register_widget(et2_link,["link","link-entry_ro"]);var et2_link_string=function(_super){function et2_link_string(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(et2_link_string,_super),et2_link_string}(expose(((_a=function(_super){function et2_link_string(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_link_string._attributes,_child||{}))||this;return _this.list=jQuery(document.createElement("ul")).addClass("et2_link_string"),_this.options.class&&_this.list.addClass(_this.options.class),_this.setDOMNode(_this.list[0]),_this}return __extends(et2_link_string,_super),et2_link_string.prototype.destroy=function(){_super.prototype.destroy.apply(this,arguments),null!=this.node&&jQuery(this.node).children().unbind()},et2_link_string.prototype.set_value=function(_value){if(_value&&null!=_value&&this.list){if("string"==typeof _value&&_value.indexOf(",")>0&&(_value=_value.split(",")),!_value.to_app&&"object"==typeof _value&&this.options.application&&(_value.to_app=this.options.application),"object"==typeof _value&&_value.to_app&&_value.to_id)return this.value=_value,void this._get_links();if(this.list.empty(),"object"==typeof _value&&_value.length>0)for(var i=0;i<_value.length;i++)(!this.options.only_app||this.options.only_app&&_value[i].app==this.options.only_app)&&this._add_link(_value[i].id?_value[i]:{id:_value[i],app:_value.to_app});else this.options.application&&this._add_link({id:_value,app:this.options.application})}else this.list&&this.list.empty()},et2_link_string.prototype._get_links=function(){var _value=this.value;this.options.only_app&&(_value.only_app=this.options.only_app),this.egw().jsonq("EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link_list",[_value],this.set_value,this)},et2_link_string.prototype.getMedia=function(_value){var base_url=egw.webserverUrl.match(/^\//,"ig")?egw(window).window.location.origin+egw.webserverUrl:egw.webserverUrl,mediaContent=[];return _value&&void 0!==_value.type&&_value.type.match(/video\//,"ig")?mediaContent=[{title:_value.id,type:_value.type,poster:"",href:base_url+egw().mime_open(_value),download_href:base_url+egw().mime_open(_value)+"?download"}]:_value&&(mediaContent=[{title:_value.id,href:base_url+egw().mime_open(_value).url,download_href:base_url+egw().mime_open(_value).url+"?download",type:_value.type}]),mediaContent[0].href&&mediaContent[0].href.match(/\/webdav.php/,"ig")&&(mediaContent[0].download_href=mediaContent[0].href+"?download"),mediaContent},et2_link_string.prototype._add_link=function(_link_data){var self=this,link=jQuery(document.createElement("li")).appendTo(this.list).addClass("et2_link loading").click((function(e){var fe=egw_get_file_editor_prefered_mimes(_link_data.type);self.options.expose_view&&void 0!==_link_data.type&&_link_data.type.match(self.mime_regexp,"ig")?self._init_blueimp_gallery(e,_link_data):void 0!==_link_data.type&&fe&&fe.mime&&fe.mime[_link_data.type]?egw.open_link(egw.link("/index.php",{menuaction:fe.edit.menuaction,path:egw().mime_open(_link_data).url.replace("/webdav.php","")}),"",fe.edit_popup):self.egw().open(_link_data,"","view",null,_link_data.app,_link_data.app),e.stopImmediatePropagation()}));_link_data.title&&link.text(_link_data.title),_link_data.title||this.egw().link_title(_link_data.app,_link_data.id,(function(title){title?this.removeClass("loading").text(title):this.remove()}),link)},et2_link_string.prototype.getDetachedAttributes=function(_attrs){null==this._labelContainer&&(this._labelContainer=jQuery(document.createElement("label")).addClass("et2_label"),this.getSurroundings().insertDOMNode(this._labelContainer[0]),this.getSurroundings().update()),_attrs.push("value","label")},et2_link_string.prototype.getDetachedNodes=function(){return null==this._labelContainer&&(this._labelContainer=jQuery(document.createElement("label")).addClass("et2_label"),this.getSurroundings().insertDOMNode(this._labelContainer[0])),[this.list[0],this._labelContainer[0]]},et2_link_string.prototype.setDetachedAttributes=function(_nodes,_values){this.list=jQuery(_nodes[0]),this.set_value(_values.value),this._labelContainer=_nodes.length>1?jQuery(_nodes[1]):null,_values.label?this.set_label(_values.label):this._labelContainer&&this._labelContainer.contents().not(this.list).remove()},et2_link_string}(et2_core_valueWidget_1.et2_valueWidget))._attributes={application:{name:"Application",type:"string",default:"",description:"Use the given application, so you can pass just the ID for value"},value:{description:"Either an array of link information (see egw_link::link()) or array with keys to_app and to_id",type:"any"},only_app:{name:"Application filter",type:"string",default:"",description:"Appname, eg. 'projectmananager' to list only linked projects"},link_type:{name:"Type filter",type:"string",default:"",description:"Sub-type key to list only entries of that type"},expose_view:{name:"Expose view",type:"boolean",default:!0,description:"Clicking on description with href value would popup an expose view, and will show content referenced by href."}},_a)));exports.et2_link_string=et2_link_string,et2_core_widget_1.et2_register_widget(et2_link_string,["link-string"]);var et2_link_list=function(_super){function et2_link_list(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_link_list._attributes,_child||{}))||this;_this.list=jQuery(document.createElement("table")).addClass("et2_link_list"),_this.options.class&&_this.list.addClass(_this.options.class),_this.setDOMNode(_this.list[0]);var self=_this;return _this.context=new egwMenu,_this.context.addItem("comment",_this.egw().lang("Comment"),"",(function(){var link_id="number"==typeof self.context.data.link_id?self.context.data.link_id:self.context.data.link_id.replace(/[:\.]/g,"_");et2_widget_dialog_1.et2_dialog.show_prompt((function(button,comment){if(button==et2_widget_dialog_1.et2_dialog.OK_BUTTON){var remark=jQuery("#link_"+(self.context.data.dom_id?self.context.data.dom_id:link_id),self.list).children(".remark");if(isNaN(self.context.data.link_id)){if(remark.text(comment),self.context.data.link_id){var _widget=link_id.widget||null;self.getRoot().iterateOver((function(widget){widget.id==self.id&&(_widget=widget)}),self,et2_link_to);var value=null!=_widget&&_widget.getValue();_widget&&value&&value.to_id&&(value.to_id[self.context.data.link_id].remark=comment)}}else{remark.addClass("loading");egw.json("EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link_comment",[link_id,comment],(function(){remark&&(remark.removeClass("loading").text(comment+""),self.context.data.remark=comment+"")}),this,!0).sendRequest()}}}),"",self.egw().lang("Comment"),self.context.data.remark||"")})),_this.context.addItem("file_info",_this.egw().lang("File information"),_this.egw().image("edit"),(function(menu_item){var link_data=self.context.data;if("file"==link_data.app){var url="/apps/"+link_data.app2+"/"+link_data.id2+"/"+decodeURIComponent(link_data.id);"string"==typeof url&&url.indexOf("webdav.php")&&(url=url.replace("/webdav.php","")),self.egw().open(url,"filemanager","edit")}})),_this.context.addItem("-","-"),_this.context.addItem("save",_this.egw().lang("Save as"),_this.egw().image("save"),(function(menu_item){var link_data=self.context.data;if(link_data.download_url){var url=link_data.download_url;"/"==url[0]&&(url=egw.link(url));var a=document.createElement("a");if(void 0===a.download)return window.location.href=url+"?download",!1;a=jQuery(a).prop("href",url).prop("download",link_data.title||"").appendTo(self.getInstanceManager().DOMContainer);var evt=document.createEvent("MouseEvent");return evt.initMouseEvent("click",!0,!0,window,1,0,0,0,0,!1,!1,!1,!1,0,null),a[0].dispatchEvent(evt),a.remove(),!1}self.egw().open(link_data,"","view","download",link_data.target?link_data.target:link_data.app,link_data.app)})),_this.context.addItem("zip",_this.egw().lang("Save as Zip"),_this.egw().image("save_zip"),(function(menu_item){jQuery('[id^="link_-"]',this.list).effect("highlight",{},2e3),window.location=self.egw().link("/index.php",{menuaction:"api.EGroupware\\Api\\Etemplate\\Widget\\Link.download_zip",app:self.value.to_app,id:self.value.to_id})})),self.options.value&&self.options.value.to_id&&"object"!=typeof self.options.value.to_id&&_this.context.addItem("copy_to",_this.egw().lang("Copy to"),_this.egw().image("copy"),(function(menu_item){jQuery('[id="link_'+self.context.data.link_id+"]",this.list).effect("highlight",{},2e3);var select_attrs={mode:"select-dir",button_caption:"",button_icon:"copy",button_label:egw.lang("copy"),dialog_title:egw.lang("Copy to"),method:"EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_copy_to",method_id:self.context.data},vfs_select=et2_core_widget_1.et2_createWidget("vfs-select",select_attrs,self);vfs_select.button.hide(),vfs_select.click(null)})),_this.context.addItem("-","-"),_this.context.addItem("delete",_this.egw().lang("Delete link"),_this.egw().image("delete"),(function(menu_item){var link_id=isNaN(self.context.data.link_id)?self.context.data:self.context.data.link_id,row=jQuery("#link_"+(self.context.data.dom_id?self.context.data.dom_id:self.context.data.link_id),self.list);et2_widget_dialog_1.et2_dialog.show_dialog((function(button){button==et2_widget_dialog_1.et2_dialog.YES_BUTTON&&self._delete_link(link_id,row)}),egw.lang("Delete link?"))})),jQuery.event.props.push("dataTransfer"),_this}return __extends(et2_link_list,_super),et2_link_list.prototype.destroy=function(){_super.prototype.destroy.apply(this,arguments),this.context&&(this.context.clear(),delete this.context)},et2_link_list.prototype.set_value=function(_value){if(this.list.empty(),_value&&"object"==typeof _value){var list=[];if(_value.to_id&&"object"==typeof _value.to_id?list=_value.to_id:_value.length&&(list=_value),list.length>0)for(var id in list){var link=list[id];link.app&&(link.link_id&&"number"!=typeof link.link_id&&(link.dom_id="temp_"+egw.uid()),link.icon||(link.icon=egw.link_get_registry(link.app,"icon"),0==link.icon&&link.id.type&&(link.type=link.id.type,link.icon=!0)),"object"!=typeof link.id||link.title||(link.title=link.id.name||""),this._add_link(link))}else _super.prototype.set_value.call(this,_value)}},et2_link_list.prototype._add_link=function(_link_data){var row=jQuery(document.createElement("tr")).attr("id","link_"+(_link_data.dom_id?_link_data.dom_id:"string"==typeof _link_data.link_id?_link_data.link_id.replace(/[:\.]/g,"_"):_link_data.link_id||_link_data.id)).attr("draggable","file"==_link_data.app?"true":"").appendTo(this.list);if(!_link_data.link_id)for(var k in _link_data)row[0].dataset[k]=_link_data[k];var icon=jQuery(document.createElement("td")).appendTo(row).addClass("icon");if(_link_data.icon){var icon_widget=et2_core_widget_1.et2_createWidget("image",{}),src="";if(_link_data.type){var vfs_widget=et2_core_widget_1.et2_createWidget("vfs-mime",{});vfs_widget.set_value({download_url:_link_data.download_url,name:_link_data.title,mime:_link_data.type,path:_link_data.icon}),icon.append(vfs_widget.getDOMNode())}else(src=this.egw().image(_link_data.icon))&&icon_widget.set_src(src),icon.append(icon_widget.getDOMNode())}for(var columns=["title","remark"],self=this,i=0;i<columns.length;i++){var $td=jQuery(document.createElement("td")).appendTo(row).addClass(columns[i]).text(_link_data[columns[i]]?_link_data[columns[i]]+"":""),dirs=_link_data[columns[i]]?_link_data[columns[i]].split("/"):[];"title"==columns[i]&&_link_data.type&&dirs.length>1&&this._format_vfs($td,dirs,_link_data),!_link_data||void 0===_link_data.download_url&&"egw-data"==_link_data.app||$td.click((function(){var fe_mime=egw_get_file_editor_prefered_mimes(_link_data.type);if(void 0!==_link_data.type&&(_link_data.type.match(self.mime_regexp,"ig")||fe_mime&&fe_mime.mime[_link_data.type])){var $vfs_img_node=jQuery(this).parent().find(".vfsMimeIcon");$vfs_img_node.length>0&&$vfs_img_node.click()}else self.options.target_app||(self.options.target_app=_link_data.app),self.egw().open(_link_data,"","view",null,_link_data.target?_link_data.target:_link_data.app,self.options.target_app)}))}if(void 0===_link_data.title){jQuery("td.title",row).addClass("loading");this.egw().link_title(_link_data.app,_link_data.id,(function(title){jQuery("td.title",this).removeClass("loading").text(title+"")}),row)}if(!this.options.readonly){var delete_button=jQuery(document.createElement("td")).appendTo(row);jQuery("<div />").appendTo(delete_button).addClass("delete icon").bind("click",(function(){et2_widget_dialog_1.et2_dialog.show_dialog((function(button){button==et2_widget_dialog_1.et2_dialog.YES_BUTTON&&self._delete_link(self.value&&"object"!=typeof self.value.to_id&&_link_data.link_id?_link_data.link_id:_link_data,row)}),egw.lang("Delete link?"))}))}row.bind("contextmenu",(function(e){self.context.getItem("comment").set_enabled(void 0!==_link_data.link_id&&!self.options.readonly),self.context.getItem("file_info").set_enabled("object"!=typeof _link_data.id&&"file"==_link_data.app),self.context.getItem("save").set_enabled("object"!=typeof _link_data.id&&"file"==_link_data.app),self.context.getItem("zip").set_enabled(jQuery('[id^="link_-"]',this.list).length>=2),self.context.getItem("delete").set_enabled(!self.options.readonly),self.context.data=_link_data,self.context.showAt(e.pageX,e.pageY,!0),e.preventDefault()})),navigator&&navigator.userAgent.indexOf("Chrome")>=0&&row.on("dragstart",_link_data,(function(event){if(null!=event.dataTransfer){var data=event.data||{};if(data&&data.type&&data.download_url){event.dataTransfer.dropEffect="copy",event.dataTransfer.effectAllowed="copy";var url=data.download_url;"/"==url[0]&&(url=egw.link(url)),"/"==url[0]&&(url=window.location.origin+url),navigator&&navigator.userAgent.indexOf("Chrome")&&event.dataTransfer.setData("DownloadURL",data.type+":"+data.title+":"+url),event.dataTransfer.setData("text/uri-list",url)}if(0!=event.dataTransfer.types.length){var div=jQuery(document.createElement("div")).attr("id","drag_helper").css({position:"absolute",top:"0px",left:"0px",width:"300px"});div.append(event.target.cloneNode(!0)),self.list.append(div),event.dataTransfer.setDragImage(div.get(0),0,0)}else event.preventDefault()}})).on("drag",(function(){jQuery("#drag_helper",self.list).remove()}))},et2_link_list.prototype._delete_link=function(link_id,row){row&&(jQuery(".delete",row).removeClass("delete").addClass("loading"),row.off());if(this.onchange&&this.onchange(this,link_id,row),"object"!=typeof link_id)egw.json("EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_delete",[link_id],(function(data){data&&row.slideUp(row.remove)})).sendRequest();else if(row&&(row.slideUp(row.remove),link_id.link_id)){var self=this,_widget=link_id.widget||null;this.getRoot().iterateOver((function(widget){widget.id==self.id&&(_widget=widget)}),this,et2_link_to);var value=null!=_widget&&_widget.getValue();_widget&&value&&value.to_id&&(delete value.to_id[link_id.link_id],_widget.set_value(value))}},et2_link_list.prototype._format_vfs=function($td,dirs,_link_data){$td.attr("data-title",_link_data.title);var reformat=!1,span_size=1,prev=jQuery("td.title",$td.parent().prev("tr"));if(1===prev.length){var prev_dirs=(prev.attr("data-title")||"").split("/");if(prev_dirs.length>1&&prev_dirs.length==dirs.length)for(var i=0;i<dirs.length&&dirs[i]===prev_dirs[i];i++)reformat=!0,span_size+=dirs[i].length+1,dirs[i]=""}var filename=dirs.pop();reformat&&dirs.length-i==0?$td.html('<span style="display: inline-block; width:'+span_size+'ex;"></span> - '+filename):(span_size+=dirs.join("/").length+1,$td.html('<span style="display: inline-block; text-align: right; width:'+span_size+'ex;">'+dirs.join("/")+":</span> - "+filename))},et2_link_list._attributes={show_deleted:{name:"Show deleted",type:"boolean",default:!1,description:"Show links that are marked as deleted, being held for purge"},onchange:{name:"onchange",type:"js",default:et2_no_init,description:"JS code which is executed when the links change."},readonly:{name:"readonly",type:"boolean",default:!1,description:"Does NOT allow user to enter data, just displays existing data"},target_app:{name:"Target application",type:"string",default:"",description:"Optional parameter to be passed to egw().open in order to open links in specified application "}},et2_link_list}(et2_link_string);exports.et2_link_list=et2_link_list,et2_core_widget_1.et2_register_widget(et2_link_list,["link-list"]);var et2_link_add=function(_super){function et2_link_add(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_link_add._attributes,_child||{}))||this;return _this.span=jQuery(document.createElement("span")).text(_this.egw().lang("Add new")).addClass("et2_link_add_span"),_this.div=jQuery(document.createElement("div")).append(_this.span),_this.setDOMNode(_this.div[0]),_this}return __extends(et2_link_add,_super),et2_link_add.prototype.doLoadingFinished=function(){if(_super.prototype.doLoadingFinished.apply(this,arguments),this.app_select&&this.button)return!1;this.app_select=et2_core_widget_1.et2_createWidget("link-apps",jQuery.extend({},this.options,{id:this.options.id+"app",value:this.options.application?this.options.application:this.options.value&&this.options.value.add_app?this.options.value.add_app:null,application_list:this.options.application?this.options.application:null}),this),this.div.append(this.app_select.getDOMNode()),this.button=et2_core_widget_1.et2_createWidget("button",{id:this.options.id+"_add",label:this.egw().lang("add")},this),this.button.set_label(this.egw().lang("add"));var self=this;return this.button.click=function(){return self.egw().open(self.options.value.to_app+":"+self.options.value.to_id,self.app_select.get_value(),"add"),!1},this.div.append(this.button.getDOMNode()),!0},et2_link_add.prototype.getValue=function(){return null},et2_link_add._attributes={value:{description:"Either an array of link information (see egw_link::link()) or array with keys to_app and to_id",type:"any"},application:{name:"Application",type:"string",default:"",description:"Limit to the listed application or applications (comma seperated)"}},et2_link_add}(et2_core_inputWidget_1.et2_inputWidget);exports.et2_link_add=et2_link_add,et2_core_widget_1.et2_register_widget(et2_link_add,["link-add"]);
/**
 * EGroupware eTemplate2 - JS Select account widget
 *
 * Selecting accounts needs special UI, and displaying needs special consideration
 * to avoid sending the entire user list to the client.
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2012
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_widget_selectbox_1=require("./et2_widget_selectbox"),et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_widget_link_1=require("./et2_widget_link"),et2_selectAccount=(et2_widget_dialog_1=require("./et2_widget_dialog"),function(_super){function et2_selectAccount(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_selectAccount._attributes,_child||{}))||this;return et2_selectAccount.account_types.indexOf(_this.options.empty_label)>=0&&(et2_selectAccount.account_types.indexOf(_this.options.account_type)<0||_this.options.account_type==et2_selectAccount._attributes.account_type.default)&&(_this.options.account_type=_attrs.empty_label,_this.options.empty_label=""),jQuery.inArray(_attrs.account_type,et2_selectAccount.account_types)<0&&_this.egw().debug("warn","Invalid account_type: %s Valid options:",_attrs.account_type,et2_selectAccount.account_types),_this.search=null,_this.dialog=null,_this.widgets=null,_this.options.empty_label||_this.options.readonly||!_this.options.multiple||(_this.options.empty_label=_this.egw().lang("Select user or group")),_this.supportedWidgetClasses=[et2_widget_link_1.et2_link_entry],_this}return __extends(et2_selectAccount,_super),et2_selectAccount.prototype.destroy=function(){_super.prototype.destroy.apply(this,arguments)},et2_selectAccount.prototype.createInputWidget=function(){var type=this.egw().preference("account_selection","common");switch(type){case"none":if(void 0===egw.user("apps").admin){this.options.select_options={};break}case"selectbox":case"groupmembers":default:this.options.select_options=this._get_accounts()}if(_super.prototype.createInputWidget.call(this),"primary_group"==type){var button=jQuery(document.createElement("span")).addClass("et2_clickable").click(this,jQuery.proxy((function(e){this.options.expand_multiple_rows&&!this.options.multiple&&this.set_multiple(!0,this.options.expand_multiple_rows),this.options.multiple?this._open_multi_search(e):this._open_search(e)}),this)).attr("title",egw.lang("popup with search")).append('<span class="ui-icon ui-icon-search" style="display:inline-block"/>');this.getSurroundings().insertDOMNode(button[0])}},et2_selectAccount.prototype.createMultiSelect=function(){if(("none"!=(type=this.egw().preference("account_selection","common"))||void 0!==egw.user("apps").admin)&&(_super.prototype.createMultiSelect.call(this),this.options.select_options=this._get_accounts(),"primary_group"==type)){this.supportedWidgetClasses=[et2_widget_link_1.et2_link_entry],this.options.multiple=!1,this._create_search();var old_select=this.search_widget.select,self=this;this.search_widget.select=function(e,selected){var current=self.getValue();selected.item.value=parseInt(selected.item.value),old_select.apply(this,arguments),current.push(selected.item.value),this.search.val(""),self.set_value(current)},this.search_widget.search.on("autocompleteopen",jQuery.proxy((function(){this.search_widget.search.data("ui-autocomplete").menu.element.appendTo(this.node).position({my:"left top",at:"left bottom",of:this.multiOptions.prev()})}),this)),this.search=jQuery(document.createElement("li")).appendTo(this.multiOptions.prev().find("ul")),this.options.multiple=!0;var button=jQuery(document.createElement("li")).addClass("et2_clickable").click(this,this._open_multi_search).attr("title",egw.lang("popup with search")).append('<span class="ui-icon ui-icon-search"/>'),type=this.egw().preference("account_selection","common");this.multiOptions.prev().find("ul").append(button)}},et2_selectAccount.prototype.set_value=function(_value){if("string"==typeof _value&&this.options.multiple&&null!==_value.match(this._is_multiple_regexp)&&(_value=_value.split(",")),_value){var search=_value;jQuery.isArray(search)||(search=[_value]);for(var update_options=!1,num_calls=0,current_call=0,j=0;j<search.length;j++){var found=!1;if(search[j]&&"0"!==search[j]){for(var i=0;!found&&i<this.options.select_options.length;i++)"object"==typeof this.options.select_options[i]?this.options.select_options[i].value==search[j]&&(found=!0):egw.debug("warn",this.id+" wrong option "+i+" this.options.select_options=",this.options.select_options);if(!found&&!isNaN(search[j])){var name=this.egw().link_title("api-accounts",search[j]);name?(update_options=!0,this.options.select_options.push({value:search[j],label:name})):(++num_calls,this._appendOptionElement(search[j],search[j]),this.egw().link_title("api-accounts",search[j],(function(name){if(++current_call>=num_calls){for(var i=0;i<this.widget.options.select_options.length;i++){var opt=this.widget.options.select_options[i];if(opt&&opt.value&&opt.value==this.unknown&&opt.label==this.unknown){opt.label=name,this.widget.set_select_options(this.widget.options.select_options);break}}this.widget.set_value(_value)}}),{widget:this,unknown:search[j]}))}}}update_options&&this.set_select_options(this.options.select_options)}_super.prototype.set_value.call(this,_value)},et2_selectAccount.prototype._get_accounts=function(){if(!jQuery.isArray(this.options.select_options)){var options=jQuery.extend({},this.options.select_options);for(var key in this.options.select_options=[],options)"object"==typeof options[key]?(void 0===options[key].key&&(options[key].value=key),this.options.select_options.push(options[key])):this.options.select_options.push({value:key,label:options[key]})}var accounts=[];return"primary_group"==this.egw().preference("account_selection","common")&&"accounts"!=this.options.account_type?("both"==this.options.account_type&&(accounts=this.egw().accounts("accounts")),accounts=accounts.concat(this.egw().accounts("owngroups"))):accounts=this.egw().accounts(this.options.account_type),this.options.select_options.concat(accounts)},et2_selectAccount.prototype._open_search=function(e){var widget=e.data,search=widget._create_search();widget._create_dialog(search,(function(){widget.set_value([]),widget.input&&widget.input.trigger("change"),jQuery(this).dialog("close")}))},et2_selectAccount.prototype._open_multi_search=function(e){var widget=e&&e.data?e.data:this,table=widget.search=jQuery('<table><tbody><tr valign="top"><td id="search_col"/><td id="selection_col"/></tr></tbody></table>');table.css("width","100%").css("height","100%");var search_col=jQuery("#search_col",table),select_col=jQuery("#selection_col",table);search_col.append(widget._create_search()),select_col.append(widget._create_selected());var container=jQuery(document.createElement("div")).append(table);return widget._create_dialog(container,(function(){jQuery(this).dialog("close");var ids=[];jQuery("#"+widget.getInstanceManager().uniqueId+"_selected li",select_col).each((function(){var id=jQuery(this).attr("data-id");ids.push(id),widget.options.multiple&&0==jQuery('input[id$="_opt_'+id+'"]',widget.multiOptions).length?widget._appendMultiOption(id,jQuery("label",this).text()):widget.options.multiple||0!=jQuery('option[value="'+id+'"]',widget.node).length||widget._appendOptionElement(id,jQuery("label",this).text())})),widget.set_value(ids),widget.input&&widget.input.trigger("change")}))},et2_selectAccount.prototype._create_dialog=function(widgets,update_function){return this.widgets=widgets,this.dialog=et2_widget_dialog_1.et2_dialog.show_dialog(!1,"",this.options.label?this.options.label:this.egw().lang("Select"),{},[{text:this.egw().lang("ok"),image:"check",click:update_function},{text:this.egw().lang("cancel"),image:"cancel"}]),this.dialog.set_dialog_type(""),this.dialog.div.dialog({width:"500",height:"370"}),this.dialog.div.append(widgets.width("100%")),widgets},et2_selectAccount.prototype._create_search=function(){var self=this,search=this.search=jQuery(document.createElement("div")),search_widget=this.search_widget=et2_createWidget("link-entry",{only_app:"api-accounts",query:function(request,response){return request.options||search.find("#search_results").empty(),request.options&&request.options.filter||(request.options={account_type:self.options.account_type}),!0},select:function(e,selected){var already_there=!1,last_key=null;for(last_key in self.options.select_options){var option=self.options.select_options[last_key];already_there=already_there||void 0!==option.value&&option.value==selected.item.value}return already_there||(self.options.select_options[parseInt(last_key)+1]=selected.item,self._appendOptionElement(selected.item.value,selected.item.label)),self.set_value(selected.item.value),self.dialog&&self.dialog.div&&self.dialog.div.dialog("close"),self.input&&self.input.trigger("change"),!0}},this);if(search.append(search_widget.getDOMNode()),!this.options.multiple)return search;var results=jQuery(document.createElement("ul")).attr("id","search_results").css("height","230px").addClass("ui-multiselect-checkboxes ui-helper-reset");return jQuery(document.createElement("div")).addClass("et2_selectbox").css("height","100%").append(results).appendTo(search),search_widget.search.data("ui-autocomplete")._suggest=function(items){jQuery.each(items,(function(index,item){item.value=parseInt(item.value),self._add_search_result(results,item)}))},search},et2_selectAccount.prototype._add_search_result=function(list,item){var node=null,self=this;item.value&&(item.value=parseInt(item.value));var selected=jQuery("#"+this.getInstanceManager().uniqueId+"_selected",this.widgets);item.value&&item.value<0?(node=jQuery(document.createElement("ul")),"groups"!=this.options.account_type&&jQuery('<span class="ui-icon ui-icon-circlesmall-plus et2_clickable"/>').css("float","left").appendTo(node).click((function(){if(jQuery(this).hasClass("ui-icon-circlesmall-plus")){jQuery(this).removeClass("ui-icon-circlesmall-plus").addClass("ui-icon-circlesmall-minus"),0==(group=jQuery(this).parent().addClass("expanded")).children("li").length?self.search_widget.query({term:"",options:{filter:{group:item.value}},no_cache:!0},(function(items){jQuery(items).each((function(index,item){self._add_search_result(node,item)}))})):group.children("li").each((function(index,item){var j=jQuery(item);0==jQuery('[data-id="'+j.attr("data-id")+'"]',selected).length&&j.show()}))}else{jQuery(this).addClass("ui-icon-circlesmall-plus").removeClass("ui-icon-circlesmall-minus");var group=jQuery(this).parent().children("li").hide()}}))):item.value&&(node=jQuery(document.createElement("li"))),node.attr("data-id",item.value),jQuery('<span class="ui-icon ui-icon-arrow-1-e et2_clickable"/>').css("float","right").appendTo(node).click((function(){var button=jQuery(this);self._add_selected(selected,button.parent().attr("data-id")),button.parent().is("li")?button.parent().hide():button.hide()})),0!=jQuery('[data-id="'+item.value+'"]',selected).length&&node.hide();var label=jQuery(document.createElement("label")).addClass("loading").appendTo(node);this.egw().link_title("api-accounts",item.value,(function(name){label.text(name).removeClass("loading")}),label),node.appendTo(list)},et2_selectAccount.prototype._create_selected=function(){var node=jQuery(document.createElement("div")).addClass("et2_selectbox"),header=jQuery(document.createElement("div")).addClass("ui-widget-header ui-helper-clearfix").appendTo(node),selected=jQuery(document.createElement("ul")).addClass("ui-multiselect-checkboxes ui-helper-reset").attr("id",this.getInstanceManager().uniqueId+"_selected").css("height","230px").appendTo(node);jQuery(document.createElement("span")).text(this.egw().lang("Selection")).addClass("ui-multiselect-header").appendTo(header);var controls=jQuery(document.createElement("ul")).addClass("ui-helper-reset").appendTo(header);if(jQuery(document.createElement("li")).addClass("et2_clickable").click(selected,(function(e){jQuery("li",e.data).remove()})).append('<span class="ui-icon ui-icon-closethick"/>').appendTo(controls),this.getValue())for(var value=this.getValue(),i=0;i<value.length;i++)this._add_selected(selected,value[i]);return node},et2_selectAccount.prototype._add_selected=function(list,value){var there=jQuery('[data-id="'+value+'"]',list);if(there.length)there.show();else{var option=jQuery(document.createElement("li")).attr("data-id",value).appendTo(list);jQuery('<div class="ui-icon ui-icon-close et2_clickable"/>').css("float","right").appendTo(option).click((function(){var id=jQuery(this).parent().attr("data-id");jQuery(this).parent().remove(),list.parents("tr").find("[data-id='"+id+"']").show().children("span").show()}));var label=jQuery(document.createElement("label")).addClass("loading").appendTo(option);this.egw().link_title("api-accounts",value,(function(name){this.text(name).removeClass("loading")}),label)}},et2_selectAccount.prototype.attachToDOM=function(){var result=_super.prototype.attachToDOM.call(this);return"primary_group"==this.egw().preference("account_selection","common")&&(jQuery(this.node).removeClass("chzn-done"),this.set_tags(this.options.tags,this.options.width)),result},et2_selectAccount._attributes={account_type:{name:"Account type",default:"accounts",type:"string",description:"Limit type of accounts.  One of {accounts,groups,both,owngroups}."}},et2_selectAccount.legacyOptions=["empty_label","account_type"],et2_selectAccount.account_types=["accounts","groups","both","owngroups"],et2_selectAccount}(et2_widget_selectbox_1.et2_selectbox));exports.et2_selectAccount=et2_selectAccount,et2_core_widget_1.et2_register_widget(et2_selectAccount,["select-account"]);var et2_selectAccount_ro=function(_super){function et2_selectAccount_ro(_parent,_attrs,_child){var _this=this;_parent.supportedWidgetClasses.indexOf(et2_selectAccount_ro)<0&&_parent.supportedWidgetClasses.push(et2_selectAccount_ro),_this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_selectAccount_ro._attributes,_child||{}))||this,_parent.supportedWidgetClasses.indexOf(et2_selectAccount_ro)>0&&_parent.addChild(_this),"string"==typeof _this.options.empty_label&&isNaN(_this.options.empty_label)&&(_this.options.empty_label=_this.egw().lang(_this.options.empty_label)),_this.options.application="api-accounts";var options=et2_widget_selectbox_1.et2_selectbox.find_select_options(_this,_attrs.select_options,_this.options);return jQuery.isEmptyObject(options)||(_this.options.select_options=options),_this.list.removeClass("et2_link_string").addClass("et2_selectbox"),_this}return __extends(et2_selectAccount_ro,_super),et2_selectAccount_ro.prototype.transformAttributes=function(_attrs){et2_widget_selectbox_1.et2_selectbox.prototype.transformAttributes.apply(this,arguments)},et2_selectAccount_ro.prototype.set_value=function(_value){if("string"==typeof _value&&_value.indexOf(",")>0&&(_value=_value.split(",")),"object"==typeof _value)return _super.prototype.set_value.call(this,_value),void jQuery("li",this.list).removeClass("et2_link et2_link_string").off();jQuery("li",this.list).remove();var found=!1;if(this.options.select_options&&!jQuery.isEmptyObject(this.options.select_options)||this.options.empty_label)if(_value)if("object"==typeof _value)for(var i=0;i<_value.length;i++){if(!_value[i]||!parseInt(_value[i]))return void this.list.append("<li>"+this.options.empty_label+"</li>");this.options.select_options[_value]&&(this.list.append("<li>"+this.options.select_options[_value]+"</li>"),found=!0)}else{var search=_value;jQuery.isArray(search)||(search=[_value]);for(var j=0;j<search.length;j++)if(search[j])for(var i in this.options.select_options)if(this.options.select_options[i].value==search[j]){this.list.append("<li>"+this.options.select_options[i].label+"</li>"),found=!0;break}}else this.list.append("<li>"+this.options.empty_label+"</li>"),found=!0;return found||isNaN(_value)?void 0:(_super.prototype.set_value.call(this,_value),void jQuery("li",this.list).removeClass("et2_link et2_link_string").off())},et2_selectAccount_ro._attributes={empty_label:{name:"Empty label",type:"string",default:"",description:"Textual label for first row, eg: 'All' or 'None'.  ID will be ''",translate:!0}},et2_selectAccount_ro.legacyOptions=["empty_label"],et2_selectAccount_ro}(et2_widget_link_1.et2_link_string);exports.et2_selectAccount_ro=et2_selectAccount_ro,et2_core_widget_1.et2_register_widget(et2_selectAccount_ro,["select-account_ro"]),function($){var MagicSuggest=function(element,options){var ms=this,conf=$.extend({},options),cfg=$.extend(!0,{},{allowFreeEntries:!0,allowDuplicates:!1,ajaxConfig:{},autoSelect:!0,selectFirst:!1,queryParam:"query",beforeSend:function(){},cls:"",data:null,dataUrlParams:{},disabled:!1,disabledField:null,displayField:"name",editable:!0,editModeEnabled:!1,expanded:!1,expandOnFocus:!1,groupBy:null,hideTrigger:!1,highlight:!0,id:null,infoMsgCls:"",inputCfg:{},invalidCls:"ms-inv",matchCase:!1,maxDropHeight:290,maxEntryLength:null,maxEntryRenderer:function(v){return"Please reduce your entry by "+v+" character"+(v>1?"s":"")},maxSuggestions:null,maxSelection:10,maxSelectionRenderer:function(v){return"You cannot choose more than "+v+" item"+(v>1?"s":"")},method:"POST",minChars:0,minCharsRenderer:function(v){return"Please type "+v+" more character"+(v>1?"s":"")},mode:"local",name:null,noSuggestionText:"No suggestions",placeholder:"Type or click here",renderer:null,required:!1,resultAsString:!1,resultAsStringDelimiter:",",resultsField:"results",selectionCls:"",selectionContainer:null,selectionPosition:"inner",selectionRenderer:null,selectionStacked:!1,sortDir:"asc",sortOrder:null,strictSuggest:!1,style:"",toggleOnClick:!1,typeDelay:400,useTabKey:!1,useCommaKey:!0,useZebraStyle:!1,value:null,valueField:"id",vregex:null,vtype:null},conf);this.addToSelection=function(items,isSilent){if(!cfg.maxSelection||_selection.length<cfg.maxSelection){$.isArray(items)||(items=[items]);var valuechanged=!1;$.each(items,(function(index,json){(cfg.allowDuplicates||-1===$.inArray(json[cfg.valueField],ms.getValue()))&&(_selection.push(json),valuechanged=!0)})),!0===valuechanged&&(self._renderSelection(),this.empty(),!0!==isSilent&&$(this).trigger("selectionchange",[this,this.getSelection()]))}this.input.attr("placeholder","inner"===cfg.selectionPosition&&this.getValue().length>0?"":cfg.placeholder)},this.clear=function(isSilent){this.removeFromSelection(_selection.slice(0),isSilent)},this.collapse=function(){!0===cfg.expanded&&(this.combobox.detach(),cfg.expanded=!1,$(this).trigger("collapse",[this]))},this.disable=function(){this.container.addClass("ms-ctn-disabled"),cfg.disabled=!0,ms.input.attr("disabled",!0)},this.empty=function(){this.input.val("")},this.enable=function(){this.container.removeClass("ms-ctn-disabled"),cfg.disabled=!1,ms.input.attr("disabled",!1)},this.expand=function(){!cfg.expanded&&(this.input.val().length>=cfg.minChars||this.combobox.children().length>0)&&(this.combobox.appendTo(this.container),self._processSuggestions(),cfg.expanded=!0,$(this).trigger("expand",[this]))},this.isDisabled=function(){return cfg.disabled},this.isValid=function(){var valid=!1===cfg.required||_selection.length>0;return(cfg.vtype||cfg.vregex)&&$.each(_selection,(function(index,item){valid=valid&&self._validateSingleItem(item[cfg.valueField])})),valid},this.getDataUrlParams=function(){return cfg.dataUrlParams},this.getName=function(){return cfg.name},this.getSelection=function(){return _selection},this.getRawValue=function(){return ms.input.val()},this.getValue=function(){return $.map(_selection,(function(o){return o[cfg.valueField]}))},this.removeFromSelection=function(items,isSilent){$.isArray(items)||(items=[items]);var valuechanged=!1;$.each(items,(function(index,json){var i=$.inArray(json[cfg.valueField],ms.getValue());i>-1&&(_selection.splice(i,1),valuechanged=!0)})),!0===valuechanged&&(self._renderSelection(),!0!==isSilent&&$(this).trigger("selectionchange",[this,this.getSelection()]),cfg.expandOnFocus&&ms.expand(),cfg.expanded&&self._processSuggestions()),this.input.attr("placeholder","inner"===cfg.selectionPosition&&this.getValue().length>0?"":cfg.placeholder)},this.getData=function(){return _cbData},this.setData=function(data){cfg.data=data,self._processSuggestions()},this.setMaxSelection=function(max){cfg.maxSelection=max},this.setName=function(name){cfg.name=name,name&&(cfg.name+=name.indexOf("[]")>0?"":"[]"),ms._valueContainer&&$.each(ms._valueContainer.children(),(function(i,el){el.name=cfg.name}))},this.setSelection=function(items){this.clear(),this.addToSelection(items)},this.setValue=function(values){var items=[];$.each(values,(function(index,value){var found=!1;if($.each(_cbData,(function(i,item){if(item[cfg.valueField]==value)return items.push(item),found=!0,!1})),!found)if("object"==typeof value)items.push(value);else{var json={};json[cfg.valueField]=value,json[cfg.displayField]=value,items.push(json)}})),items.length>0&&this.addToSelection(items)},this.setDataUrlParams=function(params){cfg.dataUrlParams=$.extend({},params)};var _timer,_selection=[],_comboItemHeight=0,_hasFocus=!1,_groups=null,_cbData=[],_ctrlDown=!1,_cntInMf=!1,KEYCODES_BACKSPACE=8,KEYCODES_TAB=9,KEYCODES_ENTER=13,KEYCODES_CTRL=17,KEYCODES_ESC=27,KEYCODES_SPACE=32,KEYCODES_UPARROW=38,KEYCODES_DOWNARROW=40,KEYCODES_COMMA=188,self={_displaySuggestions:function(data){ms.combobox.show(),ms.combobox.empty();var resHeight=0,nbGroups=0;if(null===_groups)self._renderComboItems(data),resHeight=_comboItemHeight*data.length;else{for(var grpName in _groups)nbGroups+=1,$("<div/>",{class:"ms-res-group",html:grpName}).appendTo(ms.combobox),self._renderComboItems(_groups[grpName].items,!0);var _groupItemHeight=ms.combobox.find(".ms-res-group").outerHeight();if(null!==_groupItemHeight){var tmpResHeight=nbGroups*_groupItemHeight;resHeight=_comboItemHeight*data.length+tmpResHeight}else resHeight=_comboItemHeight*(data.length+nbGroups)}if(resHeight<ms.combobox.height()||resHeight<=cfg.maxDropHeight?ms.combobox.height(resHeight):resHeight>=ms.combobox.height()&&resHeight>cfg.maxDropHeight&&ms.combobox.height(cfg.maxDropHeight),1===data.length&&!0===cfg.autoSelect&&ms.combobox.children().filter(":not(.ms-res-item-disabled):last").addClass("ms-res-item-active"),!0===cfg.selectFirst&&ms.combobox.children().filter(":not(.ms-res-item-disabled):first").addClass("ms-res-item-active"),0===data.length&&""!==ms.getRawValue()){var noSuggestionText=cfg.noSuggestionText.replace(/\{\{.*\}\}/,ms.input.val());self._updateHelper(noSuggestionText),ms.collapse()}!1===cfg.allowFreeEntries&&(0===data.length?($(ms.input).addClass(cfg.invalidCls),ms.combobox.hide()):$(ms.input).removeClass(cfg.invalidCls))},_getEntriesFromStringArray:function(data){var json=[];return $.each(data,(function(index,s){var entry={};entry[cfg.displayField]=entry[cfg.valueField]=$.trim(s),json.push(entry)})),json},_highlightSuggestion:function(html){var q=ms.input.val();if($.each(["^","$","*","+","?",".","(",")",":","!","|","{","}","[","]"],(function(index,value){q=q.replace(value,"\\"+value)})),0===q.length)return html;var glob=!0===cfg.matchCase?"g":"gi";return html.replace(new RegExp("("+q+")(?!([^<]+)?>)",glob),"<em>$1</em>")},_moveSelectedRow:function(dir){var list,start,active,scrollPos;cfg.expanded||ms.expand(),list=ms.combobox.find(".ms-res-item:not(.ms-res-item-disabled)"),start="down"===dir?list.eq(0):list.filter(":last"),(active=ms.combobox.find(".ms-res-item-active:not(.ms-res-item-disabled):first")).length>0&&("down"===dir?(0===(start=active.nextAll(".ms-res-item:not(.ms-res-item-disabled)").first()).length&&(start=list.eq(0)),scrollPos=ms.combobox.scrollTop(),ms.combobox.scrollTop(0),start[0].offsetTop+start.outerHeight()>ms.combobox.height()&&ms.combobox.scrollTop(scrollPos+_comboItemHeight)):(0===(start=active.prevAll(".ms-res-item:not(.ms-res-item-disabled)").first()).length&&(start=list.filter(":last"),ms.combobox.scrollTop(_comboItemHeight*list.length)),start[0].offsetTop<ms.combobox.scrollTop()&&ms.combobox.scrollTop(ms.combobox.scrollTop()-_comboItemHeight))),list.removeClass("ms-res-item-active"),start.addClass("ms-res-item-active")},_processSuggestions:function(source){var json=null,data=source||cfg.data;if(null!==data){if("function"==typeof data&&(data=data.call(ms,ms.getRawValue(),cfg)),"string"==typeof data){$(ms).trigger("beforeload",[ms]);var queryParams={};queryParams[cfg.queryParam]=ms.input.val();var params=$.extend(queryParams,cfg.dataUrlParams);return void $.ajax($.extend({type:cfg.method,url:data,data:params,beforeSend:cfg.beforeSend,success:function(asyncData){json="string"==typeof asyncData?JSON.parse(asyncData):asyncData,self._processSuggestions(json),$(ms).trigger("load",[ms,json]),self._asyncValues&&(ms.setValue("string"==typeof self._asyncValues?JSON.parse(self._asyncValues):self._asyncValues),self._renderSelection(),delete self._asyncValues)},error:function(){throw"Could not reach server"}},cfg.ajaxConfig))}_cbData=data.length>0&&"string"==typeof data[0]?self._getEntriesFromStringArray(data):data[cfg.resultsField]||data;var sortedData="remote"===cfg.mode?_cbData:self._sortAndTrim(_cbData);self._displaySuggestions(self._group(sortedData))}},_render:function(el){if(ms.setName(cfg.name),ms.container=$("<div/>",{class:"ms-ctn form-control "+(cfg.resultAsString?"ms-as-string ":"")+cfg.cls+($(el).hasClass("input-lg")?" input-lg":"")+($(el).hasClass("input-sm")?" input-sm":"")+(!0===cfg.disabled?" ms-ctn-disabled":"")+(!0===cfg.editable?"":" ms-ctn-readonly")+(!1===cfg.hideTrigger?"":" ms-no-trigger"),style:cfg.style,id:cfg.id}),ms.container.on("focus",$.proxy(handlers._onFocus,this)),ms.container.on("blur",$.proxy(handlers._onBlur,this)),ms.container.on("keydown",$.proxy(handlers._onKeyDown,this)),ms.container.on("keyup",$.proxy(handlers._onKeyUp,this)),ms.input=$("<input/>",$.extend({type:"text",class:!0===cfg.editable?"":" ms-input-readonly",readonly:!cfg.editable,placeholder:cfg.placeholder,disabled:cfg.disabled},cfg.inputCfg)),ms.input.on("focus",$.proxy(handlers._onInputFocus,this)),ms.input.on("click",$.proxy(handlers._onInputClick,this)),ms.combobox=$("<div/>",{class:"ms-res-ctn dropdown-menu"}).height(cfg.maxDropHeight),ms.combobox.on("click","div.ms-res-item",$.proxy(handlers._onComboItemSelected,this)),ms.combobox.on("mouseover","div.ms-res-item",$.proxy(handlers._onComboItemMouseOver,this)),cfg.selectionContainer?(ms.selectionContainer=cfg.selectionContainer,$(ms.selectionContainer).addClass("ms-sel-ctn")):ms.selectionContainer=$("<div/>",{class:"ms-sel-ctn"}),ms.selectionContainer.on("click",$.proxy(handlers._onFocus,this)),"inner"!==cfg.selectionPosition||cfg.selectionContainer?ms.container.append(ms.input):ms.selectionContainer.append(ms.input),ms.helper=$("<span/>",{class:"ms-helper "+cfg.infoMsgCls}),self._updateHelper(),ms.container.append(ms.helper),$(el).replaceWith(ms.container),!cfg.selectionContainer)switch(cfg.selectionPosition){case"bottom":ms.selectionContainer.insertAfter(ms.container),!0===cfg.selectionStacked&&(ms.selectionContainer.width(ms.container.width()),ms.selectionContainer.addClass("ms-stacked"));break;case"right":ms.selectionContainer.insertAfter(ms.container),ms.container.css("float","left");break;default:ms.container.append(ms.selectionContainer)}!1===cfg.hideTrigger&&(ms.trigger=$("<div/>",{class:"ms-trigger",html:'<div class="ms-trigger-ico"></div>'}),ms.trigger.on("click",$.proxy(handlers._onTriggerClick,this)),ms.container.append(ms.trigger)),$(window).on("resize",$.proxy(handlers._onWindowResized,this)),null===cfg.value&&null===cfg.data||!ms.container.is(":visible")||("string"==typeof cfg.data?(self._asyncValues=cfg.value,self._processSuggestions()):(self._processSuggestions(),null!==cfg.value&&(ms.setValue(cfg.value),self._renderSelection()))),$("body").on("click",(function(e){ms.container.hasClass("ms-ctn-focus")&&0===ms.container.has(e.target).length&&e.target.className.indexOf("ms-res-item")<0&&e.target.className.indexOf("ms-close-btn")<0&&ms.container[0]!==e.target&&handlers._onBlur()})),!0===cfg.expanded&&(cfg.expanded=!1,ms.expand())},_renderComboItems:function(items,isGrouped){var ref=this,html="";$.each(items,(function(index,value){var displayed=null!==cfg.renderer?cfg.renderer.call(ref,value):value[cfg.displayField],disabled=null!==cfg.disabledField&&!0===value[cfg.disabledField],resultItemEl=$("<div/>",{class:"ms-res-item "+(isGrouped?"ms-res-item-grouped ":"")+(disabled?"ms-res-item-disabled ":"")+(index%2==1&&!0===cfg.useZebraStyle?"ms-res-odd":""),html:!0===cfg.highlight?self._highlightSuggestion(displayed):displayed,"data-json":JSON.stringify(value)});html+=$("<div/>").append(resultItemEl).html()})),ms.combobox.append(html),_comboItemHeight=ms.combobox.find(".ms-res-item:first").outerHeight()},_renderSelection:function(){var ref=this,w=0,inputOffset=0,items=[],asText=!0===cfg.resultAsString&&!_hasFocus;if(ms.selectionContainer.find(".ms-sel-item").remove(),void 0!==ms._valueContainer&&ms._valueContainer.remove(),$.each(_selection,(function(index,value){var selectedItemEl,selectedItemHtml=null!==cfg.selectionRenderer?cfg.selectionRenderer.call(ref,value):value[cfg.displayField],validCls=self._validateSingleItem(value[cfg.displayField])?"":" ms-sel-invalid";!0===asText?selectedItemEl=$("<div/>",{class:"ms-sel-item ms-sel-text "+cfg.selectionCls+validCls,html:selectedItemHtml+(index===_selection.length-1?"":cfg.resultAsStringDelimiter)}).data("json",value):(selectedItemEl=$("<div/>",{class:"ms-sel-item "+cfg.selectionCls+validCls,html:selectedItemHtml}).data("json",value),!1===cfg.disabled&&($("<span/>",{class:"ms-close-btn"}).data("json",value).appendTo(selectedItemEl).on("click",$.proxy(handlers._onTagTriggerClick,ref)),!0!==cfg.allowFreeEntries||!0!==cfg.editModeEnabled||Number.isInteger(parseInt(value.id))||$("<span/>",{class:"ms-edit-btn"}).data("json",value).prependTo(selectedItemEl).on("click",$.proxy(handlers._onTagEditTriggerClick,ref)))),items.push(selectedItemEl)})),ms.selectionContainer.prepend(items),ms._valueContainer=$("<div/>",{style:"display: none;"}),$.each(ms.getValue(),(function(i,val){$("<input/>",{type:"hidden",name:cfg.name,value:val}).appendTo(ms._valueContainer)})),ms._valueContainer.appendTo(ms.selectionContainer),"inner"===cfg.selectionPosition&&!cfg.selectionContainer&&(ms.container.is(":visible")||ms.getValue().length>0)){var inputPadding=ms.input.outerWidth(!0)-ms.input.width();ms.input.width(0),inputOffset=Math.max(0,ms.input.offset().left-ms.selectionContainer.offset().left),w=ms.container.width()-inputOffset-(cfg.hideTrigger?inputPadding:42),ms.input.width(w)}_selection.length===cfg.maxSelection?self._updateHelper(cfg.maxSelectionRenderer.call(this,_selection.length)):ms.helper.hide()},_selectItem:function(item){1===cfg.maxSelection&&(_selection=[]),ms.addToSelection(item.data("json")),item.removeClass("ms-res-item-active"),!1!==cfg.expandOnFocus&&_selection.length!==cfg.maxSelection||ms.collapse(),_hasFocus?_hasFocus&&(cfg.expandOnFocus||_ctrlDown)&&(self._processSuggestions(),_ctrlDown&&ms.expand()):ms.input.trigger("focus")},_sortAndTrim:function(data){var q=ms.getRawValue(),filtered=[],newSuggestions=[],selectedValues=ms.getValue();return q.length>0?$.each(data,(function(index,obj){var name=obj[cfg.displayField];(!0===cfg.matchCase&&name.indexOf(q)>-1||!1===cfg.matchCase&&name.toLowerCase().indexOf(q.toLowerCase())>-1)&&(!1!==cfg.strictSuggest&&0!==name.toLowerCase().indexOf(q.toLowerCase())||filtered.push(obj))})):filtered=data,$.each(filtered,(function(index,obj){(cfg.allowDuplicates||-1===$.inArray(obj[cfg.valueField],selectedValues))&&newSuggestions.push(obj)})),null!==cfg.sortOrder&&newSuggestions.sort((function(a,b){return a[cfg.sortOrder]<b[cfg.sortOrder]?"asc"===cfg.sortDir?-1:1:a[cfg.sortOrder]>b[cfg.sortOrder]?"asc"===cfg.sortDir?1:-1:0})),cfg.maxSuggestions&&cfg.maxSuggestions>0&&(newSuggestions=newSuggestions.slice(0,cfg.maxSuggestions)),newSuggestions},_group:function(data){return null!==cfg.groupBy&&(_groups={},$.each(data,(function(index,value){var props=cfg.groupBy.indexOf(".")>-1?cfg.groupBy.split("."):cfg.groupBy,prop=value[cfg.groupBy];if("string"!=typeof props)for(prop=value;props.length>0;)prop=prop[props.shift()];void 0===_groups[prop]?_groups[prop]={title:prop,items:[value]}:_groups[prop].items.push(value)}))),data},_updateHelper:function(html){ms.helper.html(html),ms.helper.is(":visible")||ms.helper.fadeIn()},_validateSingleItem:function(value){if(null!==cfg.vregex&&cfg.vregex instanceof RegExp)return cfg.vregex.test(value);if(null!==cfg.vtype)switch(cfg.vtype){case"alpha":return/^[a-zA-Z_]+$/.test(value);case"alphanum":return/^[a-zA-Z0-9_]+$/.test(value);case"email":return/^(\w+)([\-+.][\w]+)*@(\w[\-\w]*\.){1,5}([A-Za-z]){2,6}$/.test(value);case"url":return/(((^https?)|(^ftp)):\/\/([\-\w]+\.)+\w{2,3}(\/[%\-\w]+(\.\w{2,})?)*(([\w\-\.\?\\\/+@&#;`~=%!]*)(\.\w{2,})?)*\/?)/i.test(value);case"ipaddress":return/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/.test(value)}return!0}},handlers={_onBlur:function(){if(ms.container.removeClass("ms-ctn-focus"),ms.collapse(),_cntInMf=!1,_hasFocus=!1,""!==ms.getRawValue()&&!0===cfg.allowFreeEntries){var obj={};obj[cfg.displayField]=obj[cfg.valueField]=$.trim(ms.getRawValue()),ms.addToSelection(obj)}self._renderSelection(),!1===ms.isValid()?ms.container.addClass(cfg.invalidCls):""!==ms.input.val()&&!1===cfg.allowFreeEntries&&(ms.empty(),self._updateHelper("")),$(ms).trigger("blur",[ms])},_onComboItemMouseOver:function(e){var target=$(e.currentTarget);target.hasClass("ms-res-item-disabled")||(ms.combobox.children().removeClass("ms-res-item-active"),target.addClass("ms-res-item-active"))},_onComboItemSelected:function(e){$(e.currentTarget).hasClass("ms-res-item-disabled")||self._selectItem($(e.currentTarget))},_onFocus:function(){_cntInMf||ms.input.trigger("focus")},_onInputClick:function(){!1===ms.isDisabled()&&_hasFocus&&!_cntInMf&&!0===cfg.toggleOnClick&&(cfg.expanded?ms.collapse():ms.expand())},_onInputFocus:function(){if(!1===ms.isDisabled()&&!_hasFocus&&!_cntInMf){_hasFocus=!0,ms.container.addClass("ms-ctn-focus"),ms.container.removeClass(cfg.invalidCls);var curLength=ms.getRawValue().length;!0===cfg.expandOnFocus&&ms.expand(),_selection.length===cfg.maxSelection?self._updateHelper(cfg.maxSelectionRenderer.call(this,_selection.length)):curLength<cfg.minChars&&self._updateHelper(cfg.minCharsRenderer.call(this,cfg.minChars-curLength)),setTimeout((function(){self._renderSelection()}),400),$(ms).trigger("focus",[ms])}},_onKeyDown:function(e){if(!_cntInMf){var active=ms.combobox.find(".ms-res-item-active:not(.ms-res-item-disabled):first"),freeInput=ms.input.val();if($(ms).trigger("keydown",[ms,e]),e.keyCode!==KEYCODES_TAB||!1!==cfg.useTabKey&&(!0!==cfg.useTabKey||0!==active.length||0!==ms.input.val().length))switch(e.keyCode){case KEYCODES_BACKSPACE:0===freeInput.length&&ms.getSelection().length>0&&"inner"===cfg.selectionPosition&&(_selection.pop(),self._renderSelection(),$(ms).trigger("selectionchange",[ms,ms.getSelection()]),ms.input.attr("placeholder","inner"===cfg.selectionPosition&&ms.getValue().length>0?"":cfg.placeholder),ms.input.trigger("focus"),e.preventDefault());break;case KEYCODES_TAB:case KEYCODES_ESC:e.preventDefault();break;case KEYCODES_ENTER:(""!==freeInput||cfg.expanded)&&e.preventDefault();break;case KEYCODES_COMMA:!0===cfg.useCommaKey&&e.preventDefault();break;case KEYCODES_CTRL:_ctrlDown=!0;break;case KEYCODES_DOWNARROW:e.preventDefault(),self._moveSelectedRow("down");break;case KEYCODES_UPARROW:e.preventDefault(),self._moveSelectedRow("up");break;default:_selection.length===cfg.maxSelection&&e.preventDefault()}else handlers._onBlur()}},_onKeyUp:function(e){if(!_cntInMf){var selected,freeInput=ms.getRawValue(),inputValid=$.trim(ms.input.val()).length>0&&(!cfg.maxEntryLength||$.trim(ms.input.val()).length<=cfg.maxEntryLength),obj={};if($(ms).trigger("keyup",[ms,e]),clearTimeout(_timer),e.keyCode===KEYCODES_ESC&&cfg.expanded&&ms.combobox.hide(),e.keyCode===KEYCODES_TAB&&!1===cfg.useTabKey||e.keyCode>KEYCODES_ENTER&&e.keyCode<KEYCODES_SPACE)e.keyCode===KEYCODES_CTRL&&(_ctrlDown=!1);else switch(e.keyCode){case KEYCODES_UPARROW:case KEYCODES_DOWNARROW:e.preventDefault();break;case KEYCODES_ENTER:case KEYCODES_TAB:case KEYCODES_COMMA:if(e.keyCode!==KEYCODES_COMMA||!0===cfg.useCommaKey){if(e.preventDefault(),!0===cfg.expanded&&(selected=ms.combobox.find(".ms-res-item-active:not(.ms-res-item-disabled):first")).length>0)return void self._selectItem(selected);!0===inputValid&&!0===cfg.allowFreeEntries&&(obj[cfg.displayField]=obj[cfg.valueField]=$.trim(freeInput),ms.addToSelection(obj),ms.collapse(),ms.input.trigger("focus"));break}default:_selection.length===cfg.maxSelection?self._updateHelper(cfg.maxSelectionRenderer.call(this,_selection.length)):freeInput.length<cfg.minChars?(self._updateHelper(cfg.minCharsRenderer.call(this,cfg.minChars-freeInput.length)),!0===cfg.expanded&&ms.collapse()):cfg.maxEntryLength&&freeInput.length>cfg.maxEntryLength?(self._updateHelper(cfg.maxEntryRenderer.call(this,freeInput.length-cfg.maxEntryLength)),!0===cfg.expanded&&ms.collapse()):(ms.helper.hide(),cfg.minChars<=freeInput.length&&(_timer=setTimeout((function(){!0===cfg.expanded?self._processSuggestions():ms.expand()}),cfg.typeDelay)))}}},_onTagTriggerClick:function(e){ms.removeFromSelection($(e.currentTarget).data("json"))},_onTagEditTriggerClick:function(e){var itemData=$(e.currentTarget).data("json");if(e.stopImmediatePropagation(),""===ms.input.val()){var index=$.inArray(itemData.id,ms.getValue()),el=$(ms.selectionContainer.children().get(index)),deltaW=el.width()-(el.find(".ms-close-btn").width()+el.find(".ms-edit-btn").width());el.off(),el.children().hide();var __onConfirmCallback=function(){var values=ms.getValue().slice(),selection=ms.getSelection().slice(),scrollTop=ms.selectionContainer[0].scrollTop;values[index]=selection[index].id=selection[index].label=input.val(),ms.setValue(values),ms.setSelection(selection),ms.selectionContainer.scrollTop(scrollTop),_cntInMf=!1},__onCancelCallback=function(e){_cntInMf=!1,handlers._onBlur(),e.stopImmediatePropagation()},editor=$('<div class="ms-editor-wrap">').appendTo(el),input=$('<input type="text">').val(itemData.id).select().on("focus",(function(){_cntInMf=!0})).on("keydown",(function(e){switch(e.stopImmediatePropagation(),e.keyCode){case KEYCODES_TAB:case KEYCODES_ENTER:e.preventDefault(),__onConfirmCallback();break;case KEYCODES_ESC:__onCancelCallback()}})).appendTo(editor);$('<span class="ms-check-btn"/>').on("click",$.proxy(__onConfirmCallback,this)).appendTo(editor),$('<span class="ms-close-btn"/>').on("click",$.proxy(__onCancelCallback,this)).appendTo(editor);input.width(deltaW),input.height(el.children().height()),$(ms).trigger("editorClicked",[ms,e]),_cntInMf=!0}},_onTriggerClick:function(){if(!1===ms.isDisabled()&&(!0!==cfg.expandOnFocus||_selection.length!==cfg.maxSelection))if($(ms).trigger("triggerclick",[ms]),!0===cfg.expanded)ms.collapse();else{var curLength=ms.getRawValue().length;curLength>=cfg.minChars?(ms.input.trigger("focus"),ms.expand()):self._updateHelper(cfg.minCharsRenderer.call(this,cfg.minChars-curLength))}},_onWindowResized:function(){self._renderSelection()}};null!==element&&self._render(element)};$.fn.magicSuggest=function(options){var obj=$(this);return 1===obj.length&&obj.data("magicSuggest")?obj.data("magicSuggest"):(obj.each((function(i){var cntr=$(this);if(!cntr.data("magicSuggest")){"select"===this.nodeName.toLowerCase()&&(options.data=[],options.value=[],$.each(this.children,(function(index,child){child.nodeName&&"option"===child.nodeName.toLowerCase()&&(options.data.push({id:child.value,name:child.text}),$(child).attr("selected")&&options.value.push(child.value))})));var def={};$.each(this.attributes,(function(i,att){def[att.name]="value"===att.name&&""!==att.value?JSON.parse(att.value):att.value}));var field=new MagicSuggest(this,$.extend([],$.fn.magicSuggest.defaults,options,def));cntr.data("magicSuggest",field),field.container.data("magicSuggest",field)}})),1===obj.length?obj.data("magicSuggest"):obj)},$.fn.magicSuggest.defaults={}}(jQuery);
/**
 * EGroupware eTemplate2 - JS Tag list object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link: https://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2013
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_widget_selectbox_1=require("./et2_widget_selectbox"),et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_taglist=function(_super){function et2_taglist(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_taglist._attributes,_child||{}))||this;return _this.lib_options={},_this.div=null,_this.multiple_toggle=null,_this._multiple=!1,_this.taglist=null,_this.$taglist=null,_this.options.multiple=_attrs.multiple,_this.div=jQuery("<div></div>").addClass("et2_taglist"),_this.multiple_toggle=jQuery("<div></div>").addClass("toggle").on("click",jQuery.proxy((function(){this._set_multiple(!this._multiple)}),_this)).appendTo(_this.div),_this._multiple=!1,_this.taglist=null,_this.setDOMNode(_this.div[0]),_this}return __extends(et2_taglist,_super),et2_taglist.prototype.destroy=function(){this.div,this._hide_timeout&&window.clearTimeout(this._hide_timeout),_super.prototype.destroy.apply(this,arguments)},et2_taglist.prototype.transformAttributes=function(_attrs){if(_super.prototype.transformAttributes.apply(this,arguments),"string"==typeof _attrs.autocomplete_params)try{_attrs.autocomplete_params=JSON.parse(_attrs.autocomplete_params)}catch(e){this.egw().debug("warn","Invalid autocomplete_params: "+_attrs.autocomplete_params)}"toggle"!==_attrs.multiple&&(_attrs.multiple=et2_evalBool(_attrs.multiple))},et2_taglist.prototype.doLoadingFinished=function(){_super.prototype.doLoadingFinished.call(this);var widget=this;if(null==this.taglist)return null!==this.options.select_options||this.options.autocomplete_url||this.set_select_options(this.getArrayMgr("sel_options").getEntry(this.id)),this.taglist=jQuery("<div/>").appendTo(this.div),this.taglist_options=jQuery.extend({data:this.options.autocomplete_url?this.options.autocomplete_url:this.options.select_options||{},dataUrlParams:this.options.autocomplete_params,method:"GET",displayField:"label",invalidCls:"invalid ui-state-error",placeholder:this.options.empty_label,hideTrigger:!0===this.options.multiple,noSuggestionText:this.egw().lang("No suggestions"),required:this.options.required,allowFreeEntries:this.options.allowFreeEntries,useTabKey:!0,useCommaKey:this.options.useCommaKey,disabled:this.options.disabled||this.options.readonly,editable:!(this.options.disabled||this.options.readonly),toggleOnClick:!jQuery.isEmptyObject(this.options.select_options),selectionRenderer:jQuery.proxy(this.options.tagRenderer||this.selectionRenderer,this),renderer:jQuery.proxy(this.options.listRenderer||this.selectionRenderer,this),maxSelection:this.options.multiple?this.options.maxSelection:1,maxSelectionRenderer:jQuery.proxy((function(v){this.egw().lang("You can not choose more then %1 item(s)!",v)}),this),minCharsRenderer:jQuery.proxy((function(v){this.egw().lang(1==v?"Please type 1 more character":"Please type %1 more characters",v)}),this),width:this.options.width,highlight:!1,selectFirst:!0,groupBy:this.options.groupBy&&"string"==typeof this.options.groupBy?this.options.groupBy:null,minChars:parseInt(this.options.minChars)?parseInt(this.options.minChars):0,editModeEnabled:this.options.editModeEnabled},this.lib_options),this.options.height&&(this.div.css("height",""),this.taglist_options.maxDropHeight=parseInt(this.options.height)),!0!==this.options.multiple&&(this.taglist_options.minChars=0),this.taglist=this.taglist.magicSuggest(this.taglist_options),this.$taglist=jQuery(this.taglist),this.options.value&&this.taglist.addToSelection(this.options.value,!0),this._set_multiple(this.options.multiple),this.options.autocomplete_url&&!jQuery.isEmptyObject(this.options.select_options)&&this.taglist.setData((function(query,cfg){return widget._data.call(widget,query,cfg)})),this.$taglist.on("beforeload",(function(){this.container.prepend('<div class="ui-icon loading"/>')})).on("load",(function(){jQuery(".loading",this.container).remove()})).on("selectionchange",(function(){(document.activeElement===document.body||widget.div.has(document.activeElement).length>0)&&jQuery("input",this.container).focus(),widget.resize()})).on("keyup.start_search",jQuery.proxy(this._keyup,this)).on("blur",jQuery.proxy((function(){this.div&&(this.div.removeClass("ui-state-active"),this.resize())}),this)).on("focus",(function(){jQuery(".egw_tooltip").hide(),widget.div.addClass("ui-state-active")})).on("load expand",(function(){widget.taglist&&widget.taglist_options.groupBy&&window.setTimeout((function(){widget&&widget.taglist.combobox&&widget.taglist.combobox.find(".ms-res-group.ms-res-item-active").removeClass("ms-res-item-active")}),1)})).on("expand",jQuery.proxy((function(){var taglist=this.taglist;this.div.addClass("expanded");var background=this.taglist.combobox.css("background"),wrapper=jQuery(document.createElement("div")).addClass(this.div.attr("class")).css({position:"absolute",width:"auto"}).appendTo("body").position({my:"left top",at:"left bottom",of:this.taglist.container});this.taglist.combobox.width(this.taglist.container.innerWidth()).appendTo(wrapper).css("background",background);var bottom=wrapper.offset().top+this.taglist.combobox.outerHeight(!0);bottom>jQuery(window).height()&&this.taglist.combobox.height(this.taglist.combobox.height()-(bottom-jQuery(window).height())-5),window.setTimeout((function(){jQuery(".egw_fw_ui_scrollarea").one("scroll mousewheel",(function(){taglist.collapse()})),jQuery("body").one("click",(function(){taglist.collapse(),document.activeElement===document.body||widget.div.has(document.activeElement).length>0?(widget.options.allowFreeEntries&&taglist.container.blur(),taglist.input.focus()):widget.options.allowFreeEntries&&taglist.container.blur()}))}),100),this.$taglist.one("collapse",(function(){wrapper.remove()}))}),this)).on("collapse",(function(){widget.div.removeClass("expanded")})),jQuery(".ms-trigger",this.div).on("click",(function(e){e.stopPropagation()})),jQuery(this.getDOMNode()).unbind("change.et2_inputWidget"),this.options.onchange&&"function"==typeof this.onchange&&this.$taglist.on("selectionchange",jQuery.proxy(this.change,this)),"function"==typeof this.onclick&&this.div.unbind("click.et2_baseWidget").on("click.et2_baseWidget",".ms-sel-item",jQuery.proxy((function(event){this.click(jQuery(event.target).parent().data("json"))}),this)),"function"==typeof this.onfocus&&this.$taglist.focus((function(e){widget.onfocus.call(widget.taglist,e,widget)})),this.resize(),this.div.on("blur","input",(function(){jQuery(".ms-ctn-focus",widget.div).removeClass("ms-ctn-focus")})),this.resetDirty(),!0},et2_taglist.prototype._options2data=function(_options){var options=jQuery.isArray(_options)?jQuery.extend({},_options):_options,data=[];for(var id in options){var option={id:id};"object"==typeof options[id]?(jQuery.extend(option,options[id]),option.value&&(option.id=option.value),option.label=this.options.no_lang?option.label:this.egw().lang(option.label)):option.label=this.options.no_lang?options[id]:this.egw().lang(options[id]),data.push(option)}return data},et2_taglist.prototype._data=function(query,cfg){var return_value=this.options.select_options||{};if(!jQuery.isEmptyObject(this.options.select_options)&&!this._query_server||query.trim().length<this.taglist_options.minChars||!this.options.autocomplete_url){var filtered_1=[],selected_1=this.taglist.getSelection();jQuery.each(this.options.select_options,(function(index,obj){var name=obj.label;selected_1.indexOf(obj)<0&&name.toLowerCase().indexOf(query.toLowerCase())>-1&&filtered_1.push(obj)})),return_value=filtered_1.length>0?filtered_1:this.options.autocomplete_url}else(query.trim().length>=this.taglist_options.minChars||this._query_server)&&(return_value=this.options.autocomplete_url);return this._query_server=!1,return_value!=this.options.autocomplete_url||return_value||(return_value=[]),cfg.mode="string"==typeof return_value?"remote":"local",return_value},et2_taglist.prototype._keyup=function(e,taglist,event){if(event.which===jQuery.ui.keyCode.ENTER&&0==taglist.combobox.find(".ms-res-item.ms-res-item-active").length&&"taglist-email"!==this.getType())return event.keyCode=jQuery.ui.keyCode.DOWN,this._query_server=!0,this.taglist.collapse(),this.taglist.expand(),this._query_server=!1,this.div.find(".ms-res-item-active").removeClass("ms-res-item-active"),event.preventDefault(),!1},et2_taglist.prototype.select_all=function(){var all=[];for(var id in this.options.select_options)all.push(id);this.set_value(all)},et2_taglist.prototype.selectionRenderer=function(item){var label=jQuery("<span>").text(item.label);if(void 0!==item.title&&label.attr("title",item.title),void 0!==item.icon){var wrapper=jQuery("<div>").addClass("et2_taglist_tags_icon_wrapper");return jQuery("<span/>").addClass("et2_taglist_tags_icon").css({"background-image":"url("+(item.icon&&item.icon.match(/^(http|https|\/)/)?item.icon:egw.image(item.icon?item.icon:"no-image-shown",item.app))+")"}).appendTo(wrapper),label.appendTo(wrapper),wrapper}return label},et2_taglist.prototype.set_autocomplete_url=function(source){if(source&&"/"!=source[0]&&0!=source.indexOf("http")&&(source=this.egw().ajaxUrl(source)),this.options.autocomplete_url!=source){if(this.options.autocomplete_url=source,null==this.taglist||!source)return;var widget_1=this;this.taglist.setData((function(query,cfg){return widget_1._data.call(widget_1,query,cfg)}))}},et2_taglist.prototype.set_autocomplete_params=function(_params){this.options.autocomplete_params!=_params&&(this.options.autocomplete_params=_params,this.taglist&&this.taglist.setDataUrlParams(_params))},et2_taglist.prototype.set_select_options=function(_options){if(this.options.select_options=this._options2data(_options),null!=this.taglist){var widget=this;this.taglist.setData((function(query,cfg){return widget._data.call(widget,query,cfg)}))}},et2_taglist.prototype.set_disabled=function(disabled){this.options.disabled=disabled,null!=this.taglist&&(disabled?this.taglist.disable():this.taglist.enable())},et2_taglist.prototype.set_width=function(_width){this.div.width(_width),this.options.width=_width},et2_taglist.prototype.set_rows=function(_rows){var css={"max-height":"",height:"auto"};if(_rows=parseInt(_rows)){var max=25*_rows+_rows+(null!==this.taglist?this.div.outerHeight(!0)-this.taglist.container.innerHeight():0);css["max-height"]=max+"px",this._multiple&&(css.height=max+"px"),this.div.addClass("et2_taglist_small")}this.div.css(css),this.options.rows!=_rows&&(null!==this.taglist&&this.resize(),this.options.rows=_rows)},et2_taglist.prototype.set_multiple=function(multiple){multiple!=this.options.multiple&&(this.options.multiple=multiple,this._multiple=!0===multiple,null!==this.taglist&&this._set_multiple(multiple))},et2_taglist.prototype._set_multiple=function(multiple){this._multiple=!0===multiple,this.div.toggleClass("et2_taglist_single",!this._multiple).toggleClass("et2_taglist_toggle","toggle"===this.options.multiple).removeClass("ui-state-hover").off("click.single"),0==this._multiple&&this.div.on("click.single",jQuery.proxy((function(){this.taglist.expand()}),this)),this.taglist.setMaxSelection(this._multiple?this.options.maxSelection:1),!this._multiple&&this.taglist.getValue().length>1&&this.set_value(multiple?this.taglist.getValue():this.taglist.getValue()[0]),this.set_rows(this.options.rows),this.resize()},et2_taglist.prototype._setup_small=function(){this.div.addClass("et2_taglist_small");var value_count=this.taglist.getValue().length;value_count?this.div.attr("data-content",value_count>1?egw.lang("%1 selected",value_count):"..."):this.div.attr("data-content",""),this.div.on("mouseenter.small_size",jQuery.proxy((function(){this.div.addClass("ui-state-hover"),this._hide_timeout&&window.clearTimeout(this._hide_timeout),jQuery(".egw_tooltip").hide()}),this)).on("mouseleave.small_size",jQuery.proxy((function(event){event.toElement&&jQuery(event.toElement).hasClass("egw_tooltip")||(this._hide_timeout&&window.clearTimeout(this._hide_timeout),this._hide_timeout=window.setTimeout(jQuery.proxy((function(){this.div.removeClass("ui-state-hover"),this.taglist.container[0].scrollIntoView(),this.set_statustext(this.options.statustext),this._hide_timeout=null}),this),500))}),this)),this.$taglist.on("blur.small_size",jQuery.proxy((function(){this.div.trigger("mouseleave"),this.taglist.container[0].scrollIntoView()}),this)).on("focus.small_size",jQuery.proxy((function(){this.div.addClass("ui-state-active"),this._hide_timeout&&window.clearTimeout(this._hide_timeout)}),this)),this.taglist.container[0].scrollIntoView()},et2_taglist.prototype.set_value=function(value){""===value||null===value?value=[]:"string"==typeof value&&this.options.multiple&&(value=value.split(","));var values=jQuery.isArray(value)?jQuery.extend([],value):[value];if(value||!this.taglist){for(var result=[],_loop_1=function(i){var v=values[i];v&&"object"==typeof v&&void 0!==v.id&&void 0!==v.label||(this_1.options.select_options&&(result=jQuery.grep(this_1.options.select_options,(function(e){return e.id==v})))&&result.length?(null==this_1.options.select_options&&(this_1.options.select_options=[]),values[i]=result[0]?result[0]:{id:v,label:v}):this_1.taglist&&(result=jQuery.grep(this_1.taglist.getSelection(),(function(e){return e.id==v})))&&result.length?values[i]=result[0]?result[0]:{id:v,label:v}:void 0===values[i].id&&(values[i]={id:v,label:v}))},this_1=this,i=0;i<values.length;++i)_loop_1(i);if(this.options.value=values,null!=this.taglist){if(!0!==this.options.multiple){var multiple=!!this.options.multiple&&values.length>1;multiple!==this._multiple&&this._set_multiple(multiple)}this.taglist.clear(!0),this.taglist.addToSelection(values,!0)}}else this.taglist.clear(!0)},et2_taglist.prototype.getValue=function(){return null==this.taglist?null:(jQuery(this.taglist.container).trigger("blur"),this.taglist.getValue())},et2_taglist.prototype.resize=function(){this.div.off(".small_size"),this.div.removeClass("et2_taglist_small");var min_width=jQuery(".ms-sel-item",this.div).first().outerWidth()||this.div.children().first().width();null!==min_width&&this.taglist&&(min_width+="toggle"===this.options.multiple?jQuery(".toggle",this.div).outerWidth():0,min_width+=this.taglist.trigger?this.taglist.trigger.outerWidth(!0):0,this.options.multiple&&(min_width>this.div.width()||this.taglist.container.width()>this.div.width()||this.taglist.container.height()>this.div.height())&&this._setup_small())},et2_taglist._attributes={empty_label:{name:"Empty label",type:"string",default:"",description:"Textual label for when nothing is selected",translate:!0},select_options:{type:"any",name:"Select options",default:{},description:"Internaly used to hold the select options."},value:{type:"any"},autocomplete_url:{name:"Autocomplete source",type:"string",default:"EGroupware\\Api\\Etemplate\\Widget\\Taglist::ajax_search",description:"Menuaction (app.class.function) for autocomplete data source.  Must return actual JSON, and nothing more."},autocomplete_params:{name:"Autocomplete parameters",type:"any",default:{app:"addressbook"},description:"Extra parameters passed to autocomplete URL.  It should be a stringified JSON object."},allowFreeEntries:{name:"Allow free entries",type:"boolean",default:!0,description:"Restricts or allows the user to type in arbitrary entries"},onchange:{description:"Callback when tags are changed.  Argument is the new selection.",type:"js"},onclick:{description:"Callback when a tag is clicked.  The clicked tag is passed.",type:"js"},tagRenderer:{name:"Tag renderer",type:"js",default:et2_no_init,description:"Callback to provide a custom renderer for what's _inside_ each tag.  Function parameter is the select_option data for that ID."},listRenderer:{name:"List renderer",type:"js",default:et2_no_init,description:"Callback to provide a custom renderer for each suggested item.  Function parameter is the select_option data for that ID."},width:{default:"100%"},height:{description:"Maximum allowed height of the result list in pixels"},maxSelection:{name:"max Selection",type:"integer",default:null,description:"The maximum number of items the user can select if multiple selection is allowed."},multiple:{type:"any",default:!0,description:"True, false or 'toggle'"},rows:{name:"Rows",type:"integer",default:et2_no_init,description:"Number of rows to display"},tags:{ignore:!0},useCommaKey:{name:"comma will start validation",type:"boolean",default:!0,description:"Set to false to allow comma in entered content"},groupBy:{name:"group results",type:"string",default:null,description:"group results by given JSON attribute"},minChars:{name:"chars to start query",type:"integer",default:3,description:"minimum number of characters before expanding the combo"},editModeEnabled:{name:"Enable edit mode for tags",type:"boolean",default:!0,description:"Allow to modify a tag by clicking on edit icon. It only can be enabled if only allowFreeEntries is true."}},et2_taglist}(et2_widget_selectbox_1.et2_selectbox);exports.et2_taglist=et2_taglist,et2_core_widget_1.et2_register_widget(et2_taglist,["taglist"]);var et2_taglist_account=function(_super){function et2_taglist_account(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_taglist_account._attributes,_child||{}))||this;return _this.lib_options={minChars:2},_this.int_reg_exp=/^-?[0-9]+$/,_this.deferred_loading=0,_this.deferred_loading=0,_this.options.autocomplete_params.type="account",_this}return __extends(et2_taglist_account,_super),et2_taglist_account.prototype.set_account_type=function(value){value!=this.options.account_type&&(this.options.select_options=[]),this.options.autocomplete_params.account_type=this.options.account_type=value,this.set_select_options(this._get_accounts())},et2_taglist_account.prototype._get_accounts=function(){var existing=[];if(jQuery.isArray(this.options.select_options))for(var i=0;i<this.options.select_options.length;i++)existing.push(this.options.select_options[i].value);else{var options=jQuery.extend({},this.options.select_options);for(var key in this.options.select_options=[],options)"object"==typeof options[key]?(void 0===options[key].key&&(options[key].value=key),this.options.select_options.push(options[key])):this.options.select_options.push({value:key,label:options[key]}),existing.push(key)}var accounts=[];"primary_group"==this.egw().preference("account_selection","common")&&"accounts"!=this.options.account_type?("both"==this.options.account_type&&(accounts=this.egw().accounts("accounts")),accounts=accounts.concat(this.egw().accounts("owngroups"))):accounts=this.egw().accounts(this.options.account_type);for(i=0;i<accounts.length;i++)-1===existing.indexOf(accounts[i].value)&&this.options.select_options.push(accounts[i]);return this.options.select_options},et2_taglist_account.prototype.set_value=function(value){if(!value)return _super.prototype.set_value.call(this,value||[]);for(var values=jQuery.isArray(value)?jQuery.extend([],value):[value],_loop_2=function(i){var v=values[i],result=[];if("object"==typeof v&&v.id===v.label&&(v=v.id),this_2.options.select_options&&((result=jQuery.grep(this_2.options.select_options,(function(e){return e.id==v})))&&result.length||this_2.taglist&&(result=jQuery.grep(this_2.taglist.getSelection(),(function(e){return e.id==v})))&&result.length))null==this_2.options.select_options&&(this_2.options.select_options=[]),values[i]=result[0]?result[0]:{id:v,label:v};else if("object"!=typeof v&&!isNaN(v)&&("string"!=typeof v||v.match(this_2.int_reg_exp))){v=parseInt(v);var label=this_2.egw().link_title("api-accounts",v);label?values[i]={id:v,label:label||"#"+v}:(delete this_2.options.value,this_2.deferred_loading++,this_2.egw().link_title("api-accounts",v,jQuery.proxy((function(idx,id,label){this.deferred_loading--,values[idx]={id:id,label:label||"#"+id},this.deferred_loading||(this.options.maxSelection&&this.taglist.setMaxSelection(null),this.taglist.setValue([{id:id,label:label||"#"+id}]),this.set_value(values),this.taglist.setMaxSelection(this.options.maxSelection))}),this_2,i,v)))}},this_2=this,i=0;i<values.length;++i)_loop_2(i);this.deferred_loading<=0&&_super.prototype.set_value.call(this,values)},et2_taglist_account._attributes={autocomplete_url:{default:"EGroupware\\Api\\Etemplate\\Widget\\Taglist::ajax_search"},allowFreeEntries:{default:!1,ignore:!0},account_type:{name:"Account type",default:"accounts",type:"string",description:"Limit type of accounts.  One of {accounts,groups,both,owngroups}."}},et2_taglist_account}(et2_taglist);et2_core_widget_1.et2_register_widget(et2_taglist_account,["taglist-account"]);var et2_taglist_email=function(_super){function et2_taglist_email(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_taglist_email._attributes,_child||{}))||this;return _this.lib_options={minChars:3},_this.options.include_lists&&(_this.options.autocomplete_params.include_lists=!0),_this.options.domainOptional&&(et2_taglist_email.EMAIL_PREG=new RegExp(/^(([^\042',<][^,<]+|\042[^\042]+\042|\'[^\']+\'|)\s?<)?[^\x00-\x20()\xe2\x80\x8b<>@,;:\042\[\]\x80-\xff]+(@([a-z0-9ÄÖÜäöüß](|[a-z0-9ÄÖÜäöüß_-]*[a-z0-9ÄÖÜäöüß])\.)+[a-z]{2,})?>?$/i)),_this}return __extends(et2_taglist_email,_super),et2_taglist_email.prototype.selectionRenderer=function(item){"string"==typeof item.id&&(item.id=item.id.trim()),"string"==typeof item.label&&(item.label=item.label.trim());var valid=item.id!=item.label||et2_taglist_email.EMAIL_PREG.test(item.id||"");if(!valid&&item.id){var matches=item.id.match(/^(.*) ?<(.*)>$/);if(matches&&et2_taglist_email.EMAIL_PREG.test('"'+matches[1].trim()+'" <'+matches[2].trim()+">")&&(item.id=item.label='"'+matches[1].trim()+'" <'+matches[2].trim()+">",valid=!0),!valid){var parts=item.id.split(/, */),items_1=[],errors=[];if(parts.length>1){for(var i=0;i<parts.length;++i)parts[i]=parts[i].trim(),et2_taglist_email.EMAIL_PREG.test(parts[i])?items_1.push({id:parts[i],label:parts[i]}):errors.push(parts[i]);if(item.id=item.label=errors.length?errors.join(", "):items_1.shift().id,valid=!errors.length,items_1.length)if(valid){var taglist=this.taglist;window.setTimeout((function(){taglist.addToSelection(items_1)}),10)}else this.taglist.addToSelection(items_1)}}}var label=jQuery("<span>").text(item.label);if(item.class&&label.addClass(item.class),void 0!==item.title&&label.attr("title",item.title),void 0!==item.data&&label.attr("data",item.data),!valid)return label.addClass("ui-state-error"),window.setTimeout(jQuery.proxy((function(){this.taglist.removeFromSelection(item),this.set_validation_error(egw.lang("'%1' has an invalid format",item.label)),this.taglist.input.val(item.label).focus()}),this),1),null;if(void 0!==item.icon&&item.icon){var wrapper=jQuery("<div>").addClass("et2_taglist_tags_icon_wrapper");return jQuery("<span/>").addClass("et2_taglist_tags_icon").css({"background-image":"url("+(item.icon.match(/^(http|https|\/)/)?item.icon:egw.image(item.icon,item.app))+")"}).appendTo(wrapper),label.appendTo(wrapper),wrapper}return label},et2_taglist_email._attributes={autocomplete_url:{default:"EGroupware\\Api\\Etemplate\\Widget\\Taglist::ajax_email"},autocomplete_params:{default:{}},allowFreeEntries:{default:!0,ignore:!0},include_lists:{name:"Include lists",description:"Include mailing lists in search results",default:!1,type:"boolean"},useCommaKey:{name:"comma will start validation",type:"boolean",default:!1,description:"Set to false to allow comma in entered content"},domainOptional:{name:"Domain optional",description:"Allows domain part of an email address to be optional",default:!1,type:"boolean"}},et2_taglist_email.EMAIL_PREG=et2_url.EMAIL_PREG,et2_taglist_email}(et2_taglist);et2_core_widget_1.et2_register_widget(et2_taglist_email,["taglist-email"]);var et2_taglist_category=function(_super){function et2_taglist_category(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_taglist_email._attributes,_child||{}))||this;return _this.lib_options={},_this.div.addClass("et2_taglist_category"),_this}return __extends(et2_taglist_category,_super),et2_taglist_category.prototype.transformAttributes=function(_attrs){var type=this.getType();this.setType("select-cat"),_super.prototype.transformAttributes.call(this,_attrs),this.setType(type)},et2_taglist_category.prototype._options2data=function(_options){var options=jQuery.isArray(_options)?jQuery.extend({},_options):_options,data=[];for(var id in options){var option={};"object"==typeof options[id]?(jQuery.extend(option,options[id]),option.value&&(option.id=option.value)):option.label=options[id],data.push(option)}return data},et2_taglist_category.prototype.selectionRenderer=function(item){var label=jQuery("<span>").text(item.label);return item.class&&label.addClass(item.class),jQuery('<span class="cat_'+item.id+'"/>').prependTo(label),void 0!==item.title&&label.attr("title",item.title),void 0!==item.data&&label.attr("data",item.data),label},et2_taglist_category._attributes={minChars:{default:0},autocomplete_url:{default:""},autocomplete_params:{default:{}},allowFreeEntries:{default:!1,ignore:!0}},et2_taglist_category}(et2_taglist);et2_core_widget_1.et2_register_widget(et2_taglist_category,["taglist-cat"]);var et2_taglist_thumbnail=function(_super){function et2_taglist_thumbnail(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_taglist_thumbnail._attributes,_child||{}))||this;return _this.div.addClass("et2_taglist_thumbnail"),_this}return __extends(et2_taglist_thumbnail,_super),et2_taglist_thumbnail.prototype.selectionRenderer=function(item){var tag=jQuery("<span>").attr("title",item.label);return jQuery('<img class="et2_taglist_thumbnail_img"/>').attr("src",item.label).prependTo(tag),tag},et2_taglist_thumbnail._attributes={minChars:{default:0},autocomplete_url:{default:""},autocomplete_params:{default:{}}},et2_taglist_thumbnail}(et2_taglist);et2_core_widget_1.et2_register_widget(et2_taglist_thumbnail,["taglist-thumbnail"]);var et2_taglist_state=function(_super){function et2_taglist_state(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_taglist_state._attributes,_child||{}))||this;return _this.div.addClass("et2_taglist_state"),_this}return __extends(et2_taglist_state,_super),et2_taglist_state.prototype.transformAttributes=function(_attrs){var type=this.getType();this.setType("select-state"),_super.prototype.transformAttributes.call(this,_attrs),this.setType(type)},et2_taglist_state.prototype._options2data=function(_options){var options=jQuery.isArray(_options)?jQuery.extend({},_options):_options,data=[];for(var id in options){var option={};"object"==typeof options[id]?(jQuery.extend(option,options[id]),option.value&&(option.id=option.value)):option.label=options[id],data.push(option)}return data},et2_taglist_state.prototype.set_country_code=function(_country_code){var country_code=_country_code||"",old_code=this.options.country_code;if(this.country_code=country_code,this.options.country_code=country_code,this.options.country_code!==old_code&&this.isInTree()){var sel_options=et2_widget_selectbox_1.et2_selectbox.find_select_options(this,{},this.options);this.set_select_options(sel_options)}},et2_taglist_state._attributes={minChars:{default:0},autocomplete_url:{default:""},autocomplete_params:{default:{}},country_code:{name:"country code to fetch states for",default:"de",type:"string",description:"Defines country code to fetch list of states for it"}},et2_taglist_state}(et2_taglist);et2_core_widget_1.et2_register_widget(et2_taglist_state,["taglist-state"]);var et2_taglist_ro=function(_super){function et2_taglist_ro(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_taglist_ro._attributes,_child||{}))||this;return _this.span=jQuery("<div><ul /></div>").addClass("et2_taglist_ro"),_this.setDOMNode(_this.span[0]),_this.span=jQuery("ul",_this.span).addClass("ms-sel-ctn"),_this}return __extends(et2_taglist_ro,_super),et2_taglist_ro.prototype.set_value=function(_value){_super.prototype.set_value.apply(this,arguments),jQuery("li",this.span).addClass("ms-sel-item")},et2_taglist_ro}(et2_selectbox_ro);et2_core_widget_1.et2_register_widget(et2_taglist_ro,["taglist_ro","taglist_email_ro","taglist_account_ro"]);
/**
 * EGroupware eTemplate2 - JS Custom fields object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2011
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_customfields_list=function(_super){function et2_customfields_list(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_customfields_list._attributes,_child||{}))||this;if(_this.rows={},_this.widgets={},_this.detachedNodes=[],_this.id||(_this.id=_attrs.id=et2_customfields_list.DEFAULT_ID,_this.transformAttributes(_attrs),_this.options=et2_cloneObject(_attrs)),_this.tbody=jQuery(document.createElement("tbody")),_this.table=jQuery(document.createElement("table")).addClass("et2_grid et2_customfield_list"),_this.table.append(_this.tbody),_this.options.fields||(_this.options.fields={}),"string"==typeof _this.options.fields){var fields=_this.options.fields.split(",");_this.options.fields={};for(var i=0;i<fields.length;i++)_this.options.fields[fields[i]]=!0}if(_this.options.type_filter&&"string"==typeof _this.options.type_filter&&(_this.options.type_filter=_this.options.type_filter.split(",")),_this.options.type_filter){var already_filtered=!jQuery.isEmptyObject(_this.options.fields);for(var field_name in _this.options.customfields)if(!already_filtered||_this.options.fields[field_name])if(_this.options.customfields[field_name].type2&&0!=_this.options.customfields[field_name].type2.length&&"0"!=_this.options.customfields[field_name].type2){var types="string"==typeof _this.options.customfields[field_name].type2?_this.options.customfields[field_name].type2.split(","):_this.options.customfields[field_name].type2;_this.options.fields[field_name]=!1;for(i=0;i<types.length;i++)jQuery.inArray(types[i],_this.options.type_filter)>-1&&(_this.options.fields[field_name]=!0)}else _this.options.fields[field_name]=!0}return _this.setDOMNode(_this.table[0]),_this}return __extends(et2_customfields_list,_super),et2_customfields_list.prototype.destroy=function(){_super.prototype.destroy.call(this),this.rows={},this.widgets={},this.detachedNodes=[],this.tbody=null},et2_customfields_list.prototype.assign=function(_obj){this.loadFields()},et2_customfields_list.prototype.getDOMNode=function(_sender){return this.rows&&_sender.id&&this.rows[_sender.id]?this.rows[_sender.id]:_super.prototype.getDOMNode.call(this,_sender)},et2_customfields_list.prototype.loadFields=function(){if(this.options&&this.options.customfields&&("customfields-list"!=this.getType()||this.isInTree())&&jQuery.isEmptyObject(this.widgets)){var global_data=this.getArrayMgr("modifications").getRoot().getEntry("~custom_fields~");global_data&&global_data.fields&&!this.options.fields&&(this.options.fields=global_data.fields);var apps=this.egw().link_app_list();for(var field_name in this.options.customfields)if("customfields-list"==this.getType()||jQuery.isEmptyObject(this.options.fields)||this.options.fields[field_name]){var field=this.options.customfields[field_name],id=this.options.prefix+field_name;if("$row"==this.id?id="{"+this.id+"}["+this.options.prefix+field_name+"]":this.id!=et2_customfields_list.DEFAULT_ID&&(id=this.id+"["+id+"]"),!this.rows[id]){var row=jQuery(document.createElement("tr")).appendTo(this.tbody).addClass(this.id+"_"+id),cf=jQuery(document.createElement("td")).appendTo(row);field.type||(field.type='text";');var setup_function="_setup_"+(apps[field.type]?"link_entry":field.type.replace("-","_")),attrs=jQuery.extend({},this.options[field_name]?this.options[field_name]:{},{id:id,statustext:field.help,needed:field.needed,readonly:this.getArrayMgr("readonlys").isReadOnly(id,null,this.options.readonly),value:this.options.value[this.options.prefix+field_name]});if(!0===attrs.readonly&&delete attrs.needed,this.options.onchange&&(attrs.onchange=this.options.onchange),this[setup_function])if(!this[setup_function].call(this,field_name,field,attrs))continue;if("customfields-list"==this.getType()?(attrs.readonly=!0,row.attr("title",field.label),row.attr("data-label",field.label),row.attr("data-field",field_name),row.attr("data-help",field.help),this.detachedNodes.push(row[0])):(cf.text(field.label+""),cf=jQuery(document.createElement("td")).appendTo(row)),this.rows[id]=cf[0],-1==["select","radio","radiogroup","checkbox","button"].indexOf(field.type)&&!jQuery.isEmptyObject(field.values)){var w=et2_registry[attrs.type?attrs.type:field.type];for(var attr_name in field.values)void 0!==w._attributes[attr_name]&&(attrs[attr_name]=field.values[attr_name])}this.widgets[field_name]=et2_createWidget(attrs.type?attrs.type:field.type,attrs,this)}!this.options.fields||jQuery.isEmptyObject(this.options.fields)||1==this.options.fields[field_name]?jQuery(this.rows[field_name]).show():jQuery(this.rows[field_name]).hide()}}},et2_customfields_list.prototype.transformAttributes=function(_attrs){_super.prototype.transformAttributes.call(this,_attrs);var data=this.getArrayMgr("modifications").getEntry(this.id),global_data=this.getArrayMgr("modifications").getRoot().getEntry("~custom_fields~",!0);if(global_data)for(var key_1 in data)global_data[key_1]&&"fields"!==key_1&&(data[key_1]=jQuery.extend(!0,{},data[key_1],global_data[key_1]));for(var key in data)_attrs[key]=data[key];for(var key_2 in global_data)void 0===global_data[key_2]||_attrs[key_2]||(_attrs[key_2]=global_data[key_2]);if(this.id){var contentMgr=this.getArrayMgr("content");if(null!=contentMgr){var val=contentMgr.getEntry(this.id);_attrs.value={};var prefix=_attrs.prefix||et2_customfields_list.PREFIX;if(null!==val)if(0===this.id.indexOf(prefix)&&void 0!==data.fields&&!0===data.fields[this.id.replace(prefix,"")])_attrs.value[this.id]=val;else for(var key_3 in val)0===key_3.indexOf(prefix)&&(_attrs.value[key_3]=val[key_3]);else for(var key in _attrs.customfields)_attrs.value[prefix+key]=contentMgr.getEntry(prefix+key)}}},et2_customfields_list.prototype.loadFromXML=function(_node){this.loadFields(),_super.prototype.loadFromXML.call(this,_node)},et2_customfields_list.prototype.set_value=function(_value){if(this.options.customfields)for(var field_name in this.options.customfields)if((jQuery.isEmptyObject(this.options.fields)||this.options.fields[field_name])&&this.widgets[field_name]&&this.widgets[field_name].set_value){var value=_value[this.options.prefix+field_name]?_value[et2_customfields_list.PREFIX+field_name]:null;switch(null==value&&this.id==et2_customfields_list.DEFAULT_ID&&this.getArrayMgr("content").getEntry(this.options.prefix+field_name)&&(value=this.getArrayMgr("content").getEntry(this.options.prefix+field_name)),this.options.customfields[field_name].type){case"date":value&&isNaN(value)&&(value=jQuery.datepicker.parseDate("yy-mm-dd",value))}this.widgets[field_name].set_value(value)}},et2_customfields_list.prototype.getValue=function(){if(this.id!=et2_customfields_list.DEFAULT_ID)return null;var value={};for(var field_name in this.widgets)this.widgets[field_name].getValue&&!this.widgets[field_name].options.readonly&&(value[this.options.prefix+field_name]=this.widgets[field_name].getValue());return value},et2_customfields_list.prototype.isDirty=function(){var dirty=!1;for(var field_name in this.widgets)this.widgets[field_name].isDirty&&(dirty=dirty||this.widgets[field_name].isDirty());return dirty},et2_customfields_list.prototype.resetDirty=function(){for(var field_name in this.widgets)this.widgets[field_name].resetDirty&&this.widgets[field_name].resetDirty()},et2_customfields_list.prototype.isValid=function(){return!0},et2_customfields_list.prototype._setup_text=function(field_name,field,attrs){return delete attrs.label,field.type="textbox",attrs.rows=field.rows>1?field.rows:null,field.len&&(attrs.size=field.len,1==field.rows&&(attrs.maxlength=field.len)),!0},et2_customfields_list.prototype._setup_passwd=function(field_name,field,attrs){delete attrs.label;for(var defaults={viewable:!0,plaintext:!1,suggest:16},_i=0,_a=Object.keys(defaults);_i<_a.length;_i++){var key=_a[_i];attrs[key]=field.values&&void 0!==field.values[key]?field.values[key]:defaults[key]}return!0},et2_customfields_list.prototype._setup_ajax_select=function(field_name,field,attrs){var attributes=["get_rows","get_title","id_field","template"];if(field.values)for(var i=0;i<attributes.length;i++)void 0!==field.values[attributes[i]]&&(attrs[attributes[i]]=field.values[attributes[i]]);return!0},et2_customfields_list.prototype._setup_float=function(field_name,field,attrs){return delete attrs.label,field.type="float",field.len&&(attrs.size=field.len),!0},et2_customfields_list.prototype._setup_select=function(field_name,field,attrs){return delete attrs.label,attrs.rows=field.rows,attrs.tags=field.tags,!0},et2_customfields_list.prototype._setup_select_account=function(field_name,field,attrs){return attrs.empty_label=egw.lang("Select"),field.account_type&&(attrs.account_type=field.account_type),this._setup_select(field_name,field,attrs)},et2_customfields_list.prototype._setup_date=function(field_name,field,attrs){return attrs.data_format=field.values&&field.values.format?field.values.format:"Y-m-d",!0},et2_customfields_list.prototype._setup_date_time=function(field_name,field,attrs){return attrs.data_format=field.values&&field.values.format?field.values.format:"Y-m-d H:i:s",!0},et2_customfields_list.prototype._setup_htmlarea=function(field_name,field,attrs){attrs.config=field.config?field.config:{},attrs.config.toolbarStartupExpanded=!1,field.len&&(attrs.config.width=field.len+"px"),attrs.config.height=16*(field.rows>0&&"undefined"!=field.rows?field.rows:5)+"px";var data=this.getArrayMgr("modifications").getEntry(this.options.prefix+field_name);return data&&jQuery.extend(data.config,attrs.config),!0},et2_customfields_list.prototype._setup_radio=function(field_name,field,attrs){return delete attrs.label,field.values&&field.values[""]&&(attrs.label=field.values[""],delete field.values[""]),field.type="radiogroup",attrs.options=field.values,!0},et2_customfields_list.prototype._setup_checkbox=function(field_name,field,attrs){return attrs.readonly&&(attrs.ro_true=field.label),!0},et2_customfields_list.prototype._setup_button=function(field_name,field,attrs){if(delete attrs.label,attrs.label=field.label,"customfields-list"==this.getType())return!1;if(field.values&&"object"==typeof field.values&&1!=Object.keys(field.values).length){var row=jQuery("tr",this.tbody).last(),cf=jQuery("td",row);for(var key in cf.text(field.label+""),cf=jQuery(document.createElement("td")).appendTo(row),field.values){var button_attrs=jQuery.extend({},attrs);button_attrs.label=key,button_attrs.onclick=field.values[key],button_attrs.id=attrs.id+"_"+key,this.rows[button_attrs.id]=cf[0],et2_createWidget(attrs.type?attrs.type:field.type,button_attrs,this)}return!1}for(var key_4 in field.values)attrs.label=key_4,attrs.onclick=field.values[key_4];return attrs.label||(attrs.label='No "label=onclick" in values!',attrs.onclick=function(){return!1}),!attrs.readonly},et2_customfields_list.prototype._setup_link_entry=function(field_name,field,attrs){return"filemanager"===field.type?this._setup_filemanager(field_name,field,attrs):(delete attrs.label,attrs.type="link-entry",attrs.only_app=void 0===field.only_app?field.type:field.only_app,!0)},et2_customfields_list.prototype._setup_filemanager=function(field_name,field,attrs){if(attrs.type="vfs-upload",delete attrs.label,"customfields-list"==this.getType())return!0;var row=jQuery("tr",this.tbody).last(),cf=jQuery("td",row);cf.text(field.label+""),cf=jQuery(document.createElement("td")).appendTo(row);var widget=this.widgets[field_name]=et2_createWidget(attrs.type?attrs.type:field.type,attrs,this);this.rows[attrs.id]=cf[0],jQuery(widget.getDOMNode(widget)).css("vertical-align","top");var select_attrs=jQuery.extend({},attrs,{label:"",mode:widget.options.multiple?"open-multiple":"open",method:"EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link_existing",method_id:attrs.path,button_label:egw.lang("Link")},{type:"vfs-select"});return select_attrs.id=attrs.id+"_vfs_select",this.rows[select_attrs.id]=cf[0],widget=et2_createWidget(select_attrs.type,select_attrs,this),jQuery(widget.getDOMNode(widget)).css("vertical-align","top").prependTo(cf),!1},et2_customfields_list.prototype.set_visible=function(_fields){for(var name_1 in _fields)this.rows[this.options.prefix+name_1]&&(_fields[name_1]?jQuery(this.rows[this.options.prefix+name_1]).show():jQuery(this.rows[this.options.prefix+name_1]).hide()),this.options.fields[name_1]=_fields[name_1]},et2_customfields_list.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value","class")},et2_customfields_list.prototype.getDetachedNodes=function(){return this.detachedNodes?this.detachedNodes:[]},et2_customfields_list.prototype.setDetachedAttributes=function(_nodes,_values){for(var i=0;i<_nodes.length;i++){var key=_nodes[i].getAttribute("data-field");jQuery(_nodes[i]).toggle(!(!_values.fields[key]||!_values.value[this.options.prefix+key]))}},et2_customfields_list._attributes={customfields:{name:"Custom fields",description:"Auto filled",type:"any"},fields:{name:"Custom fields",description:"Auto filled",type:"any"},value:{name:"Custom fields",description:"Auto filled",type:"any"},type_filter:{name:"Field filter",default:"",type:"any",description:"Filter displayed custom fields by their 'type2' attribute"},private:{ignore:!0,type:"boolean"},sub_app:{name:"sub app name",type:"string",description:"Name of sub application"},onchange:{name:"onchange",type:"string",default:et2_no_init,description:"JS code which is executed when the value changes."},prefix:{name:"prefix",type:"string",default:"#",description:"Custom prefix for custom fields.  Default #"}},et2_customfields_list.legacyOptions=["type_filter","private","fields"],et2_customfields_list.PREFIX="#",et2_customfields_list.DEFAULT_ID="custom_fields",et2_customfields_list}((et2_core_valueWidget_1=require("./et2_core_valueWidget")).et2_valueWidget);exports.et2_customfields_list=et2_customfields_list,et2_core_widget_1.et2_register_widget(et2_customfields_list,["customfields","customfields-list"]),
/**
 * EGroupware eTemplate2 - Class which contains a factory method for rows
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 */
Object.defineProperty(exports,"__esModule",{value:!0});var et2_dataview_rowProvider=function(){function et2_dataview_rowProvider(_outerId,_columnIds){this._outerId=_outerId,this._columnIds=_columnIds,this._prototypes={},this._template=null,this._mgrs=null,this._rootWidget=null,this._createFullRowPrototype(),this._createDefaultPrototype(),this._createEmptyPrototype(),this._createLoadingPrototype()}return et2_dataview_rowProvider.prototype.destroy=function(){this._template=null,this._mgrs=null,this._rootWidget=null,this._prototypes={},this._columnIds=[]},et2_dataview_rowProvider.prototype.getColumnCount=function(){return this._columnIds.length},et2_dataview_rowProvider.prototype.getPrototype=function(_name,_generator,_context){if(void 0===this._prototypes[_name]){if(void 0===_generator)return null;this._prototypes[_name]=_generator.call(_context,this._outerId,this._columnIds)}return this._prototypes[_name].clone()},et2_dataview_rowProvider.prototype._createFullRowPrototype=function(){var tr=jQuery(document.createElement("tr")),td=jQuery(document.createElement("td")).addClass(this._outerId+"_td_fullRow").attr("colspan",this._columnIds.length).appendTo(tr);jQuery(document.createElement("div")).addClass(this._outerId+"_div_fullRow").appendTo(td);this._prototypes.fullRow=tr},et2_dataview_rowProvider.prototype._createDefaultPrototype=function(){for(var tr=jQuery(document.createElement("tr")),_i=0,_a=this._columnIds;_i<_a.length;_i++){var column=_a[_i];if(column){var td=jQuery(document.createElement("td")).addClass(this._outerId+"_td_"+column).appendTo(tr);jQuery(document.createElement("div")).addClass(this._outerId+"_div_"+column).addClass("innerContainer").appendTo(td)}}this._prototypes.default=tr},et2_dataview_rowProvider.prototype._createEmptyPrototype=function(){this._prototypes.empty=jQuery(document.createElement("tr"))},et2_dataview_rowProvider.prototype._createLoadingPrototype=function(){var fullRow=this.getPrototype("fullRow");jQuery("div",fullRow).addClass("loading"),this._prototypes.loading=fullRow},et2_dataview_rowProvider}();exports.et2_dataview_rowProvider=et2_dataview_rowProvider;
/**
 * EGroupware eTemplate2 - Class which contains a factory method for rows
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2012
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_arrayMgr_1=require("./et2_core_arrayMgr");var et2_nextmatch_rowProvider=function(){function et2_nextmatch_rowProvider(_rowProvider,_subgridCallback,_context){this.cat_regexp=/(^| |,|cat_)([0-9]+)/g,this.cat_cleanup=/[^0-9]/g,this._rowProvider=_rowProvider,this._subgridCallback=_subgridCallback,this._context=_context,this._createEmptyPrototype()}return et2_nextmatch_rowProvider.prototype.destroy=function(){this._rowProvider.destroy(),this._subgridCallback=null,this._context=null,this._dataRow=null},et2_nextmatch_rowProvider.prototype.setDataRowTemplate=function(_widgets,_rowData,_rootWidget){this._rootWidget=_rootWidget;var row=this._rowProvider.getPrototype("default"),rowTemplate={row:row[0],rowData:_rowData,widgets:_widgets,root:_rootWidget,seperated:null,mgrs:_rootWidget.getArrayMgrs()},rowWidget=new et2_nextmatch_rowWidget(rowTemplate.mgrs,row[0]);rowWidget._parent=_rootWidget,rowWidget.createWidgets(_widgets);var variableAttributes=this._getVariableAttributeSet(rowWidget);rowTemplate.seperated=this._seperateWidgets(variableAttributes);this._stripTemplateRow(rowTemplate),this._buildNodeAccessFuncs(rowTemplate);var tmpl=document.createDocumentFragment();row.children().each((function(){tmpl.appendChild(this)})),this._dataRow=tmpl,this._template=rowTemplate},et2_nextmatch_rowProvider.prototype.getDataRow=function(_data,_row,_idx,_controller){var row=this._dataRow.cloneNode(!0),mgrs=et2_core_arrayMgr_1.et2_arrayMgrs_expand(rowWidget,this._template.mgrs,_data,_idx),rowWidget=null;if(this._template.seperated.remaining.length>0){for(var i=0;i<this._template.seperated.remaining.length;i++)for(var entry=this._template.seperated.remaining[i],j=0;j<entry.data.length;j++){var set=entry.data[j];entry.widget.options[set.attribute]=mgrs.content.expandName(set.expression)}(rowWidget=new et2_nextmatch_rowTemplateWidget(this._rootWidget,row)).createWidgets(mgrs,this._template.placeholders)}for(i=0;i<this._template.seperated.detachable.length;i++){entry=this._template.seperated.detachable[i];var data={};for(j=0;j<entry.data.length;j++){data[(set=entry.data[j]).attribute]=mgrs.content.expandName(set.expression)}var nodes=new Array(entry.nodeFuncs.length);for(j=0;j<nodes.length;j++)try{nodes[j]=entry.nodeFuncs[j](row)}catch(e){continue}entry.widget._mgrs=mgrs,void 0!==data.id&&(entry.widget.id=data.id),entry.widget.transformAttributes.call(entry.widget,data),entry.widget.setDetachedAttributes(nodes,data,_data)}var tr=_row.getDOMNode();if(tr.appendChild(row),void 0!==_data.content.is_parent&&_data.content.is_parent){_row.makeExpandable(!0,(function(){return this._subgridCallback.call(this._context,_row,_data,_controller)}),this);for(var top_controller=_controller;null!=top_controller._parentController;)top_controller=top_controller._parentController;var expansion_index=top_controller.kept_expansion.indexOf(top_controller.dataStorePrefix+"::"+_data.content[this._context.settings.row_id]);top_controller.kept_expansion&&expansion_index>=0&&(top_controller.kept_expansion.splice(expansion_index,1),window.setTimeout((function(){_row.expansionButton.trigger("click")}),et2_dataview_grid.ET2_GRID_INVALIDATE_TIMEOUT))}return this._setRowData(this._template.rowData,tr,mgrs),rowWidget},et2_nextmatch_rowProvider.prototype._createEmptyPrototype=function(){var label=this._context&&this._context.options&&this._context.options.settings.placeholder,placeholder=jQuery(document.createElement("td")).attr("colspan",this._rowProvider.getColumnCount()).css("height","19px").text(void 0!==label&&label?label:egw().lang("No matches found"));this._rowProvider._prototypes.empty=jQuery(document.createElement("tr")).addClass("egwGridView_empty").append(placeholder)},et2_nextmatch_rowProvider.prototype._getVariableAttributeSet=function(_widget){for(var variableAttributes=[],process=function(_widget){var hasAttr=!1,widgetData={widget:_widget,data:[]};for(var key in _widget.attributes)if(!_widget.attributes[key].ignore&&void 0!==_widget.options[key]){var val=_widget.options[key];"string"==typeof val&&val.indexOf("$")>=0&&(hasAttr=!0,widgetData.data.push({attribute:key,expression:val}))}hasAttr&&variableAttributes.push(widgetData)},columns=_widget._widgets,i=0;i<columns.length;i++)void 0===columns[i]||this._context&&this._context.columns&&this._context.columns[i]&&!this._context.columns[i].visible||columns[i].iterateOver(process,this);return variableAttributes},et2_nextmatch_rowProvider.prototype._seperateWidgets=function(_varAttrs){for(var detachable=[],remaining=[],i=0;i<_varAttrs.length;i++){var widget=_varAttrs[i].widget,insertWidget=!0,checkWidget=function(_widget){if(null!=_widget.parent){for(var i=0;i<remaining.length;i++)if(remaining[i].widget==_widget.parent)return void(insertWidget=!1);checkWidget(_widget.parent)}};if(checkWidget(widget),insertWidget){var isDetachable=!1;if(widget.implements(et2_IDetachedDOM)){var supportedAttrs=[];widget.getDetachedAttributes(supportedAttrs),supportedAttrs.push("id"),isDetachable=!0;for(var j=0;j<_varAttrs[i].data.length;j++){var data=_varAttrs[i].data[j],supportsAttr=-1!=supportedAttrs.indexOf(data.attribute);supportsAttr||egw.debug("warn","et2_IDetachedDOM widget "+widget._type+" does not support "+data.attribute),isDetachable=isDetachable&&supportsAttr}}isDetachable?detachable.push(_varAttrs[i]):remaining.push(_varAttrs[i])}}return{detachable:detachable,remaining:remaining}},et2_nextmatch_rowProvider.prototype._stripTemplateRow=function(_rowTemplate){_rowTemplate.placeholders=[];for(var i=0;i<_rowTemplate.seperated.remaining.length;i++){var entry=_rowTemplate.seperated.remaining[i];if(egw.debug("warn","Non-clonable widget '"+entry.widget._type+"' in dataview row - this might be slow",entry),entry.placeholder=null,entry.widget.implements(et2_IDOMNode)){var node=entry.widget.getDOMNode(entry.widget);node&&node.parentNode&&(entry.placeholder=document.createElement("span"),node.parentNode.replaceChild(entry.placeholder,node),_rowTemplate.placeholders.push({widget:entry.widget,func:this._compileDOMAccessFunc(_rowTemplate.row,entry.placeholder)}))}}},et2_nextmatch_rowProvider.prototype._nodeIndex=function(_node){if(null==_node.parentNode)return 0;for(var i=0;i<_node.parentNode.childNodes.length;i++)if(_node.parentNode.childNodes[i]==_node)return i;return-1},et2_nextmatch_rowProvider.prototype._compileDOMAccessFunc=function(_root,_target){return new Function("_node",function recordPath(_root,_target,_path){if(void 0===_path&&(_path=[]),_root!=_target&&_target){var idx=this._nodeIndex(_target);if(idx>=0)return _path.unshift("childNodes["+idx+"]"),recordPath.call(this,_root,_target.parentNode,_path);throw"Internal error while compiling DOM access function."}return _path.unshift("_node"),"return "+_path.join(".")+";"}.call(this,_root,_target))},et2_nextmatch_rowProvider.prototype._buildNodeAccessFuncs=function(_rowTemplate){for(var i=0;i<_rowTemplate.seperated.detachable.length;i++)for(var entry=_rowTemplate.seperated.detachable[i],nodes=entry.widget.getDetachedNodes(),nodeFuncs=entry.nodeFuncs=new Array(nodes.length),j=0;j<nodes.length;j++)nodeFuncs[j]=this._compileDOMAccessFunc(_rowTemplate.row,nodes[j])},et2_nextmatch_rowProvider.prototype._setRowData=function(_data,_tr,_mgrs){if(_data.class){var classes=_mgrs.content.expandName(_data.class),cats=[];if(-1!==_data.class.indexOf("cat")||classes.match(/[0-9]+/)){var category_location=_data.class.match(/(cat(_id|egory)?)/);category_location&&(category_location=category_location[0]),cats=classes.match(this.cat_regexp)||[],classes=classes.replace(this.cat_regexp,"");for(var i=0;i<cats.length;i++){classes+=" "+("cat_"+cats[i].replace(this.cat_cleanup,""))}classes+=" row_category"}classes+=" row",_tr.setAttribute("class",classes)}if(_data.valign){var align=_mgrs.content.expandName(_data.valign);_tr.setAttribute("valign",align)}},et2_nextmatch_rowProvider}();exports.et2_nextmatch_rowProvider=et2_nextmatch_rowProvider;var et2_nextmatch_rowWidget=function(_super){function et2_nextmatch_rowWidget(_mgrs,_row){var _this=_super.call(this,null,{id:"",type:"rowWidget"})||this;return _this._widgets=[],_this._mgrs=_mgrs,_this._row=_row,_this}return __extends(et2_nextmatch_rowWidget,_super),et2_nextmatch_rowWidget.prototype.createWidgets=function(_widgets){this._widgets=[];for(var row_id=0,i=0;i<_widgets.length;i++)_widgets[i]&&(this._widgets[i]=_widgets[i].clone(this),this._widgets[i].loadingFinished(),this._widgets[i].align&&this._row.childNodes[row_id]&&(this._row.childNodes[row_id].align=this._widgets[i].align),row_id++)},et2_nextmatch_rowWidget.prototype.getDOMNode=function(_sender){for(var row_id=0,i=0;i<this._widgets.length;i++)if(this._widgets[i]){if(this._widgets[i]==_sender&&this._row.childNodes[row_id])return this._row.childNodes[row_id].childNodes[0];row_id++}return null},et2_nextmatch_rowWidget}(et2_core_widget_1.et2_widget),et2_nextmatch_rowTemplateWidget=function(_super){function et2_nextmatch_rowTemplateWidget(_root,_row){var _this=_super.call(this,null,{id:"",type:"rowTemplateWidget"})||this;return _this._root=_root,_this._mgrs={},_this._row=_row,_this._parent=_root,_this._widgets=[],_this}return __extends(et2_nextmatch_rowTemplateWidget,_super),et2_nextmatch_rowTemplateWidget.prototype.createWidgets=function(_mgrs,_widgets){this._mgrs=_mgrs,this._widgets=new Array(_widgets.length);for(var i=0;i<_widgets.length;i++)this._row.childNodes[0].childNodes[0],this._widgets[i]={widget:_widgets[i].widget.clone(this),node:_widgets[i].func(this._row)},this._widgets[i].widget.loadingFinished()},et2_nextmatch_rowTemplateWidget.prototype.getDOMNode=function(_sender){for(var i=0;i<this._widgets.length;i++)if(this._widgets[i].widget==_sender)return this._widgets[i].node;return null},et2_nextmatch_rowTemplateWidget}(et2_core_widget_1.et2_widget);
/**
 * EGroupware eTemplate2 - dataview code
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2012
 * @version $Id$
 */
Object.defineProperty(exports,"__esModule",{value:!0});var et2_dataview_container=function(){function et2_dataview_container(_parent){this._parent=_parent,this._nodes=[],this._inTree=!1,this._attachData={node:null,prepend:!1},this._destroyCallback=null,this._destroyContext=null,this._height=-1,this._index=0,this._top=0}return et2_dataview_container.prototype.destroy=function(){this.removeFromTree(),this._destroyCallback&&this._destroyCallback.call(this._destroyContext,this)},et2_dataview_container.prototype.setDestroyCallback=function(_callback,_context){this._destroyCallback=_callback,this._destroyContext=_context},et2_dataview_container.prototype.insertIntoTree=function(_node,_prepend){if(!this._inTree&&null!=_node&&this._nodes.length>0){this._attachData={node:_node,prepend:_prepend},this._inTree=!0;for(var i=0;i<this._nodes.length;i++)0==i?_prepend?_node.before(this._nodes[0]):_node.after(this._nodes[0]):this._nodes[i-1].after(this._nodes[i]);this.invalidate()}},et2_dataview_container.prototype.removeFromTree=function(){if(this._inTree){for(var i=0;i<this._nodes.length;i++)this._nodes[i].remove();this._inTree=!1,this._attachData={node:null,prepend:!1}}},et2_dataview_container.prototype.appendNode=function(_node){this._nodes.push(_node),this._inTree&&(1===this._nodes.length?this._attachData.prepend?this._attachData.node.before(_node):this._attachData.node.after(_node):this._nodes[this._nodes.length-2].after(_node),this.invalidate())},et2_dataview_container.prototype.removeNode=function(_node){var idx=this._nodes.indexOf(_node);idx>=0&&(this._inTree&&_node.parentNode.removeChild(_node),this._nodes.splice(idx,1))},et2_dataview_container.prototype.getLastNode=function(){return this._nodes.length>0?this._nodes[this._nodes.length-1]:null},et2_dataview_container.prototype.getFirstNode=function(){return this._nodes.length>0?this._nodes[0]:null},et2_dataview_container.prototype.getHeight=function(){if(-1===this._height&&this._inTree){this._height=0,this.tr.css("display","block");for(var i=0;i<this._nodes.length;i++)et2_dataview_container._isVisible(this._nodes[i][0])&&(this._height+=et2_dataview_container._nodeHeight(this._nodes[i][0]));this.tr.css("display","")}return-1===this._height?0:this._height},et2_dataview_container.prototype.getAvgHeightData=function(){return{avgHeight:this.getHeight(),avgCount:1}},et2_dataview_container.prototype.getTop=function(){return this._top},et2_dataview_container.prototype.getBottom=function(){return this._top+this.getHeight()},et2_dataview_container.prototype.getRange=function(){return et2_bounds(this.getTop(),this.getBottom())},et2_dataview_container.prototype.getIndex=function(){return this._index},et2_dataview_container.prototype.getCount=function(){return 1},et2_dataview_container.prototype.setTop=function(_value){this._top=_value},et2_dataview_container.prototype.setIndex=function(_value){this._index=_value},et2_dataview_container.prototype.invalidate=function(){-1!==this._height&&(this._height=-1,this._parent.invalidate())},et2_dataview_container._isVisible=function(_obj){if(_obj.style&&("none"===_obj.style.display||"none"===_obj.style.visibility))return!1;var style=window.getComputedStyle?window.getComputedStyle(_obj,null):_obj.currentStyle;return"none"!==style.display&&"none"!==style.visibility},et2_dataview_container._nodeHeight=function(_node){return _node.offsetHeight},et2_dataview_container}();exports.et2_dataview_container=et2_dataview_container;
/**
 * EGroupware eTemplate2 - dataview
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011-2012
 * @version $Id$
 *

/*egw:uses
    egw_action.egw_action;

    et2_dataview_view_container;
*/
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});var et2_dataview_row=function(_super){function et2_dataview_row(_parent){var _this=_super.call(this,_parent)||this;return _this.tr=jQuery(document.createElement("tr")),_this.appendNode(_this.tr),_this.expansionContainer=null,_this.expansionVisible=!1,_this.expansionButton=null,_this}return __extends(et2_dataview_row,_super),et2_dataview_row.prototype.destroy=function(){null!=this.expansionContainer&&this.expansionContainer.destroy(),_super.prototype.destroy.call(this)},et2_dataview_row.prototype.clear=function(){this.tr.empty()},et2_dataview_row.prototype.makeExpandable=function(_expandable,_callback,_context){if(_expandable){this.expansionButton||(this.expansionButton=jQuery(document.createElement("span")),this.expansionButton.addClass("arrow closed"));var self=this;this.expansionButton.off("click").on("click",(function(e){self._handleExpansionButtonClick(_callback,_context),e.stopImmediatePropagation()})),jQuery("td:first",this.tr).prepend(this.expansionButton)}else this.expansionButton&&this.expansionButton.remove(),this.expansionContainer&&this.expansionContainer.destroy(),this.expansionButton=null,this.expansionContainer=null},et2_dataview_row.prototype.removeFromTree=function(){this.expansionContainer&&this.expansionContainer.removeFromTree(),this.expansionContainer=null,this.expansionButton=null,_super.prototype.removeFromTree.call(this)},et2_dataview_row.prototype.getDOMNode=function(){return this.tr[0]},et2_dataview_row.prototype.getJNode=function(){return this.tr},et2_dataview_row.prototype.getHeight=function(){var h=_super.prototype.getHeight.call(this);return this.expansionContainer&&this.expansionVisible&&(h+=this.expansionContainer.getHeight()),h},et2_dataview_row.prototype.getAvgHeightData=function(){this.expansionVisible=!1;var res={avgHeight:this.getHeight(),avgCount:1};return this.expansionVisible=!0,res},et2_dataview_row.prototype._handleExpansionButtonClick=function(_callback,_context){this.expansionContainer||(this.expansionContainer=_callback.call(_context),this.expansionContainer.insertIntoTree(this.tr),this.expansionVisible=!1),this.expansionVisible=!this.expansionVisible,jQuery(this.expansionContainer._nodes[0]).toggle(this.expansionVisible),this.expansionVisible?(this.expansionButton.addClass("opened"),this.expansionButton.removeClass("closed")):(this.expansionButton.addClass("closed"),this.expansionButton.removeClass("opened")),this.invalidate()},et2_dataview_row.prototype.setViewRange=function(_range){if(this.expansionContainer&&this.expansionVisible&&implements_et2_dataview_IViewRange(this.expansionContainer)){var oh=jQuery(this._nodes[0]).height();_range.top-=oh,this.expansionContainer.setViewRange(_range)}},et2_dataview_row}(et2_dataview_container);exports.et2_dataview_row=et2_dataview_row,
/**
 * EGroupware eTemplate2 - Contains interfaces used inside the dataview
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 */
Object.defineProperty(exports,"__esModule",{value:!0});var et2_dataviewIInvalidatable="et2_dataview_IInvalidatable";function implements_et2_dataview_IInvalidatable(obj){return implements_methods(obj,["invalidate"])}var et2_dataview_IViewRange="et2_dataview_IViewRange";function implements_et2_dataview_IViewRange(obj){return implements_methods(obj,["setViewRange"])}var et2_IDataProvider="et2_IDataProvider";function implements_et2_IDataProvider(obj){return implements_methods(obj,["dataFetch","dataRegisterUID","dataUnregisterUID"])}
/*!
 * @fileOverview TouchSwipe - jQuery Plugin
 * @version 1.6.18
 *
 * @author Matt Bryson http://www.github.com/mattbryson
 * @see https://github.com/mattbryson/TouchSwipe-Jquery-Plugin
 * @see http://labs.rampinteractive.co.uk/touchSwipe/
 * @see http://plugins.jquery.com/project/touchSwipe
 * @license
 * Copyright (c) 2010-2015 Matt Bryson
 * Dual licensed under the MIT or GPL Version 2 licenses.
 *
 */
!function(factory){"function"==typeof define&&define.amd&&define.amd.jQuery?define(["jquery"],factory):"undefined"!=typeof module&&module.exports?factory(require("jquery")):factory(jQuery)}((function($){var LEFT="left",UP="up",SUPPORTS_TOUCH="ontouchstart"in window,SUPPORTS_POINTER_IE10=window.navigator.msPointerEnabled&&!window.PointerEvent&&!SUPPORTS_TOUCH,SUPPORTS_POINTER=(window.PointerEvent||window.navigator.msPointerEnabled)&&!SUPPORTS_TOUCH;function init(options){return!options||void 0!==options.allowPageScroll||void 0===options.swipe&&void 0===options.swipeStatus||(options.allowPageScroll="none"),void 0!==options.click&&void 0===options.tap&&(options.tap=options.click),options||(options={}),options=$.extend({},$.fn.swipe.defaults,options),this.each((function(){var $this=$(this),plugin=$this.data("TouchSwipe");plugin||(plugin=new TouchSwipe(this,options),$this.data("TouchSwipe",plugin))}))}function TouchSwipe(element,options){options=$.extend({},options);var useTouchEvents=SUPPORTS_TOUCH||SUPPORTS_POINTER||!options.fallbackToMouseEvents,START_EV=useTouchEvents?SUPPORTS_POINTER?SUPPORTS_POINTER_IE10?"MSPointerDown":"pointerdown":"touchstart":"mousedown",MOVE_EV=useTouchEvents?SUPPORTS_POINTER?SUPPORTS_POINTER_IE10?"MSPointerMove":"pointermove":"touchmove":"mousemove",END_EV=useTouchEvents?SUPPORTS_POINTER?SUPPORTS_POINTER_IE10?"MSPointerUp":"pointerup":"touchend":"mouseup",LEAVE_EV=useTouchEvents?SUPPORTS_POINTER?"mouseleave":null:"mouseleave",CANCEL_EV=SUPPORTS_POINTER?SUPPORTS_POINTER_IE10?"MSPointerCancel":"pointercancel":"touchcancel",distance=0,direction=null,currentDirection=null,duration=0,startTouchesDistance=0,endTouchesDistance=0,pinchZoom=1,pinchDistance=0,pinchDirection=0,maximumsMap=null,$element=$(element),phase="start",fingerCount=0,fingerData={},startTime=0,endTime=0,previousTouchEndTime=0,fingerCountAtRelease=0,doubleTapStartTime=0,singleTapTimeout=null,holdTimeout=null;try{$element.on(START_EV,touchStart),$element.on(CANCEL_EV,touchCancel)}catch(e){$.error("events not supported "+START_EV+","+CANCEL_EV+" on jQuery.swipe")}function touchStart(jqEvent){if(!0!==$element.data("TouchSwipe_intouch")&&!($(jqEvent.target).closest(options.excludedElements,$element).length>0)){var event=jqEvent.originalEvent?jqEvent.originalEvent:jqEvent;if(!event.pointerType||"mouse"!=event.pointerType||0!=options.fallbackToMouseEvents){var ret,maxData,touches=event.touches,evt=touches?touches[0]:event;return phase="start",touches?fingerCount=touches.length:!1!==options.preventDefaultEvents&&jqEvent.preventDefault(),distance=0,direction=null,currentDirection=null,pinchDirection=null,duration=0,startTouchesDistance=0,endTouchesDistance=0,pinchZoom=1,pinchDistance=0,(maxData={})[LEFT]=createMaximumVO(LEFT),maxData.right=createMaximumVO("right"),maxData.up=createMaximumVO(UP),maxData.down=createMaximumVO("down"),maximumsMap=maxData,cancelMultiFingerRelease(),createFingerData(0,evt),!touches||fingerCount===options.fingers||"all"===options.fingers||hasPinches()?(startTime=getTimeStamp(),2==fingerCount&&(createFingerData(1,touches[1]),startTouchesDistance=endTouchesDistance=calculateTouchesDistance(fingerData[0].start,fingerData[1].start)),(options.swipeStatus||options.pinchStatus)&&(ret=triggerHandler(event,phase))):ret=!1,!1===ret?(triggerHandler(event,phase="cancel"),ret):(options.hold&&(holdTimeout=setTimeout($.proxy((function(){$element.trigger("hold",[event.target]),options.hold&&(ret=options.hold.call($element,event,event.target))}),this),options.longTapThreshold)),setTouchInProgress(!0),null)}}}function touchMove(jqEvent){var event=jqEvent.originalEvent?jqEvent.originalEvent:jqEvent;if("end"!==phase&&"cancel"!==phase&&!inMultiFingerRelease()){var ret,el,offset,startPoint,endPoint,touches=event.touches,currentFinger=updateFingerData(touches?touches[0]:event);if(endTime=getTimeStamp(),touches&&(fingerCount=touches.length),options.hold&&clearTimeout(holdTimeout),phase="move",2==fingerCount&&(0==startTouchesDistance?(createFingerData(1,touches[1]),startTouchesDistance=endTouchesDistance=calculateTouchesDistance(fingerData[0].start,fingerData[1].start)):(updateFingerData(touches[1]),endTouchesDistance=calculateTouchesDistance(fingerData[0].end,fingerData[1].end),fingerData[0].end,fingerData[1].end,pinchDirection=pinchZoom<1?"out":"in"),pinchZoom=(endTouchesDistance/startTouchesDistance*1).toFixed(2),pinchDistance=Math.abs(startTouchesDistance-endTouchesDistance)),fingerCount===options.fingers||"all"===options.fingers||!touches||hasPinches()){if(direction=calculateDirection(currentFinger.start,currentFinger.end),function(jqEvent,direction){if(!1===options.preventDefaultEvents)return;if("none"===options.allowPageScroll)jqEvent.preventDefault();else{var auto="auto"===options.allowPageScroll;switch(direction){case LEFT:(options.swipeLeft&&auto||!auto&&"horizontal"!=options.allowPageScroll)&&jqEvent.preventDefault();break;case"right":(options.swipeRight&&auto||!auto&&"horizontal"!=options.allowPageScroll)&&jqEvent.preventDefault();break;case UP:(options.swipeUp&&auto||!auto&&"vertical"!=options.allowPageScroll)&&jqEvent.preventDefault();break;case"down":(options.swipeDown&&auto||!auto&&"vertical"!=options.allowPageScroll)&&jqEvent.preventDefault()}}}(jqEvent,currentDirection=calculateDirection(currentFinger.last,currentFinger.end)),startPoint=currentFinger.start,endPoint=currentFinger.end,distance=Math.round(Math.sqrt(Math.pow(endPoint.x-startPoint.x,2)+Math.pow(endPoint.y-startPoint.y,2))),duration=calculateDuration(),function(direction,distance){if("none"==direction)return;distance=Math.max(distance,getMaxDistance(direction)),maximumsMap[direction].distance=distance}(direction,distance),ret=triggerHandler(event,phase),!options.triggerOnTouchEnd||options.triggerOnTouchLeave){var inBounds=!0;if(options.triggerOnTouchLeave){var bounds={left:(offset=(el=$(el=this)).offset()).left,right:offset.left+el.outerWidth(),top:offset.top,bottom:offset.top+el.outerHeight()};inBounds=function(point,bounds){return point.x>bounds.left&&point.x<bounds.right&&point.y>bounds.top&&point.y<bounds.bottom}(currentFinger.end,bounds)}!options.triggerOnTouchEnd&&inBounds?phase=getNextPhase("move"):options.triggerOnTouchLeave&&!inBounds&&(phase=getNextPhase("end")),"cancel"!=phase&&"end"!=phase||triggerHandler(event,phase)}}else triggerHandler(event,phase="cancel");!1===ret&&triggerHandler(event,phase="cancel")}}function touchEnd(jqEvent){var event=jqEvent.originalEvent?jqEvent.originalEvent:jqEvent,touches=event.touches;if(touches){if(touches.length&&!inMultiFingerRelease())return function(event){previousTouchEndTime=getTimeStamp(),fingerCountAtRelease=event.touches.length+1}(event),!0;if(touches.length&&inMultiFingerRelease())return!0}return inMultiFingerRelease()&&(fingerCount=fingerCountAtRelease),endTime=getTimeStamp(),duration=calculateDuration(),didSwipeBackToCancel()||!validateSwipeDistance()?triggerHandler(event,phase="cancel"):options.triggerOnTouchEnd||!1===options.triggerOnTouchEnd&&"move"===phase?(!1!==options.preventDefaultEvents&&!1!==jqEvent.cancelable&&jqEvent.preventDefault(),triggerHandler(event,phase="end")):!options.triggerOnTouchEnd&&hasTap()?triggerHandlerForGesture(event,phase="end","tap"):"move"===phase&&triggerHandler(event,phase="cancel"),setTouchInProgress(!1),null}function touchCancel(){fingerCount=0,endTime=0,startTime=0,startTouchesDistance=0,endTouchesDistance=0,pinchZoom=1,cancelMultiFingerRelease(),setTouchInProgress(!1)}function touchLeave(jqEvent){var event=jqEvent.originalEvent?jqEvent.originalEvent:jqEvent;options.triggerOnTouchLeave&&triggerHandler(event,phase=getNextPhase("end"))}function removeListeners(){$element.off(START_EV,touchStart),$element.off(CANCEL_EV,touchCancel),$element.off(MOVE_EV,touchMove),$element.off(END_EV,touchEnd),LEAVE_EV&&$element.off(LEAVE_EV,touchLeave),setTouchInProgress(!1)}function getNextPhase(currentPhase){var nextPhase=currentPhase,validTime=validateSwipeTime(),validDistance=validateSwipeDistance(),didCancel=didSwipeBackToCancel();return!validTime||didCancel?nextPhase="cancel":!validDistance||"move"!=currentPhase||options.triggerOnTouchEnd&&!options.triggerOnTouchLeave?!validDistance&&"end"==currentPhase&&options.triggerOnTouchLeave&&(nextPhase="cancel"):nextPhase="end",nextPhase}function triggerHandler(event,phase){var ret,touches=event.touches;return(validateSwipe()&&hasSwipes()||hasSwipes())&&(ret=triggerHandlerForGesture(event,phase,"swipe")),(validatePinch()&&hasPinches()||hasPinches())&&!1!==ret&&(ret=triggerHandlerForGesture(event,phase,"pinch")),validateDoubleTap()&&hasDoubleTap()&&!1!==ret?ret=triggerHandlerForGesture(event,phase,"doubletap"):duration>options.longTapThreshold&&distance<10&&options.longTap&&!1!==ret?ret=triggerHandlerForGesture(event,phase,"longtap"):1!==fingerCount&&SUPPORTS_TOUCH||!(isNaN(distance)||distance<options.threshold)||!hasTap()||!1===ret||(ret=triggerHandlerForGesture(event,phase,"tap")),"cancel"===phase&&touchCancel(),"end"===phase&&(touches&&touches.length||touchCancel()),ret}function triggerHandlerForGesture(event,phase,gesture){var ret;if("swipe"==gesture){if($element.trigger("swipeStatus",[phase,direction||null,distance||0,duration||0,fingerCount,fingerData,currentDirection]),options.swipeStatus&&!1===(ret=options.swipeStatus.call($element,event,phase,direction||null,distance||0,duration||0,fingerCount,fingerData,currentDirection)))return!1;if("end"==phase&&validateSwipe()){if(clearTimeout(singleTapTimeout),clearTimeout(holdTimeout),$element.trigger("swipe",[direction,distance,duration,fingerCount,fingerData,currentDirection]),options.swipe&&!1===(ret=options.swipe.call($element,event,direction,distance,duration,fingerCount,fingerData,currentDirection)))return!1;switch(direction){case LEFT:$element.trigger("swipeLeft",[direction,distance,duration,fingerCount,fingerData,currentDirection]),options.swipeLeft&&(ret=options.swipeLeft.call($element,event,direction,distance,duration,fingerCount,fingerData,currentDirection));break;case"right":$element.trigger("swipeRight",[direction,distance,duration,fingerCount,fingerData,currentDirection]),options.swipeRight&&(ret=options.swipeRight.call($element,event,direction,distance,duration,fingerCount,fingerData,currentDirection));break;case UP:$element.trigger("swipeUp",[direction,distance,duration,fingerCount,fingerData,currentDirection]),options.swipeUp&&(ret=options.swipeUp.call($element,event,direction,distance,duration,fingerCount,fingerData,currentDirection));break;case"down":$element.trigger("swipeDown",[direction,distance,duration,fingerCount,fingerData,currentDirection]),options.swipeDown&&(ret=options.swipeDown.call($element,event,direction,distance,duration,fingerCount,fingerData,currentDirection))}}}if("pinch"==gesture){if($element.trigger("pinchStatus",[phase,pinchDirection||null,pinchDistance||0,duration||0,fingerCount,pinchZoom,fingerData]),options.pinchStatus&&!1===(ret=options.pinchStatus.call($element,event,phase,pinchDirection||null,pinchDistance||0,duration||0,fingerCount,pinchZoom,fingerData)))return!1;if("end"==phase&&validatePinch())switch(pinchDirection){case"in":$element.trigger("pinchIn",[pinchDirection||null,pinchDistance||0,duration||0,fingerCount,pinchZoom,fingerData]),options.pinchIn&&(ret=options.pinchIn.call($element,event,pinchDirection||null,pinchDistance||0,duration||0,fingerCount,pinchZoom,fingerData));break;case"out":$element.trigger("pinchOut",[pinchDirection||null,pinchDistance||0,duration||0,fingerCount,pinchZoom,fingerData]),options.pinchOut&&(ret=options.pinchOut.call($element,event,pinchDirection||null,pinchDistance||0,duration||0,fingerCount,pinchZoom,fingerData))}}return"tap"==gesture?"cancel"!==phase&&"end"!==phase||(clearTimeout(singleTapTimeout),clearTimeout(holdTimeout),hasDoubleTap()&&!validateDoubleTap()?(doubleTapStartTime=getTimeStamp(),singleTapTimeout=setTimeout($.proxy((function(){doubleTapStartTime=null,$element.trigger("tap",[event.target]),options.tap&&(ret=options.tap.call($element,event,event.target))}),this),options.doubleTapThreshold)):(doubleTapStartTime=null,$element.trigger("tap",[event.target]),options.tap&&(ret=options.tap.call($element,event,event.target)))):"doubletap"==gesture?"cancel"!==phase&&"end"!==phase||(clearTimeout(singleTapTimeout),clearTimeout(holdTimeout),doubleTapStartTime=null,$element.trigger("doubletap",[event.target]),options.doubleTap&&(ret=options.doubleTap.call($element,event,event.target))):"longtap"==gesture&&("cancel"!==phase&&"end"!==phase||(clearTimeout(singleTapTimeout),doubleTapStartTime=null,$element.trigger("longtap",[event.target]),options.longTap&&(ret=options.longTap.call($element,event,event.target)))),ret}function validateSwipeDistance(){var valid=!0;return null!==options.threshold&&(valid=distance>=options.threshold),valid}function didSwipeBackToCancel(){var cancelled=!1;return null!==options.cancelThreshold&&null!==direction&&(cancelled=getMaxDistance(direction)-distance>=options.cancelThreshold),cancelled}function validateSwipeTime(){return!options.maxTimeThreshold||!(duration>=options.maxTimeThreshold)}function validatePinch(){var hasCorrectFingerCount=validateFingers(),hasEndPoint=validateEndPoint(),hasCorrectDistance=null===options.pinchThreshold||pinchDistance>=options.pinchThreshold;return hasCorrectFingerCount&&hasEndPoint&&hasCorrectDistance}function hasPinches(){return!!(options.pinchStatus||options.pinchIn||options.pinchOut)}function validateSwipe(){var hasValidTime=validateSwipeTime(),hasValidDistance=validateSwipeDistance(),hasCorrectFingerCount=validateFingers(),hasEndPoint=validateEndPoint();return!didSwipeBackToCancel()&&hasEndPoint&&hasCorrectFingerCount&&hasValidDistance&&hasValidTime}function hasSwipes(){return!!(options.swipe||options.swipeStatus||options.swipeLeft||options.swipeRight||options.swipeUp||options.swipeDown)}function validateFingers(){return fingerCount===options.fingers||"all"===options.fingers||!SUPPORTS_TOUCH}function validateEndPoint(){return 0!==fingerData[0].end.x}function hasTap(){return!!options.tap}function hasDoubleTap(){return!!options.doubleTap}function validateDoubleTap(){if(null==doubleTapStartTime)return!1;var now=getTimeStamp();return hasDoubleTap()&&now-doubleTapStartTime<=options.doubleTapThreshold}function cancelMultiFingerRelease(){previousTouchEndTime=0,fingerCountAtRelease=0}function inMultiFingerRelease(){var withinThreshold=!1;previousTouchEndTime&&(getTimeStamp()-previousTouchEndTime<=options.fingerReleaseThreshold&&(withinThreshold=!0));return withinThreshold}function setTouchInProgress(val){$element&&(!0===val?($element.on(MOVE_EV,touchMove),$element.on(END_EV,touchEnd),LEAVE_EV&&$element.on(LEAVE_EV,touchLeave)):($element.off(MOVE_EV,touchMove,!1),$element.off(END_EV,touchEnd,!1),LEAVE_EV&&$element.off(LEAVE_EV,touchLeave,!1)),$element.data("TouchSwipe_intouch",!0===val))}function createFingerData(id,evt){var f={start:{x:0,y:0},last:{x:0,y:0},end:{x:0,y:0}};return f.start.x=f.last.x=f.end.x=evt.pageX||evt.clientX,f.start.y=f.last.y=f.end.y=evt.pageY||evt.clientY,fingerData[id]=f,f}function updateFingerData(evt){var id=void 0!==evt.identifier?evt.identifier:0,f=function(id){return fingerData[id]||null}(id);return null===f&&(f=createFingerData(id,evt)),f.last.x=f.end.x,f.last.y=f.end.y,f.end.x=evt.pageX||evt.clientX,f.end.y=evt.pageY||evt.clientY,f}function getMaxDistance(direction){if(maximumsMap[direction])return maximumsMap[direction].distance}function createMaximumVO(dir){return{direction:dir,distance:0}}function calculateDuration(){return endTime-startTime}function calculateTouchesDistance(startPoint,endPoint){var diffX=Math.abs(startPoint.x-endPoint.x),diffY=Math.abs(startPoint.y-endPoint.y);return Math.round(Math.sqrt(diffX*diffX+diffY*diffY))}function calculateDirection(startPoint,endPoint){if(pointB=endPoint,(pointA=startPoint).x==pointB.x&&pointA.y==pointB.y)return"none";var pointA,pointB,angle=function(startPoint,endPoint){var x=startPoint.x-endPoint.x,y=endPoint.y-startPoint.y,r=Math.atan2(y,x),angle=Math.round(180*r/Math.PI);return angle<0&&(angle=360-Math.abs(angle)),angle}(startPoint,endPoint);return angle<=45&&angle>=0||angle<=360&&angle>=315?LEFT:angle>=135&&angle<=225?"right":angle>45&&angle<135?"down":UP}function getTimeStamp(){return(new Date).getTime()}this.enable=function(){return this.disable(),$element.on(START_EV,touchStart),$element.on(CANCEL_EV,touchCancel),$element},this.disable=function(){return removeListeners(),$element},this.destroy=function(){removeListeners(),$element.data("TouchSwipe",null),$element=null},this.option=function(property,value){if("object"==typeof property)options=$.extend(options,property);else if(void 0!==options[property]){if(void 0===value)return options[property];options[property]=value}else{if(!property)return options;$.error("Option "+property+" does not exist on jQuery.swipe.options")}return null}}$.fn.swipe=function(method){var $this=$(this),plugin=$this.data("TouchSwipe");if(plugin&&"string"==typeof method){if(plugin[method])return plugin[method].apply(plugin,Array.prototype.slice.call(arguments,1));$.error("Method "+method+" does not exist on jQuery.swipe")}else if(plugin&&"object"==typeof method)plugin.option.apply(plugin,arguments);else if(!(plugin||"object"!=typeof method&&method))return init.apply(this,arguments);return $this},$.fn.swipe.version="1.6.18",$.fn.swipe.defaults={fingers:1,threshold:75,cancelThreshold:null,pinchThreshold:20,maxTimeThreshold:null,fingerReleaseThreshold:250,longTapThreshold:500,doubleTapThreshold:200,swipe:null,swipeLeft:null,swipeRight:null,swipeUp:null,swipeDown:null,swipeStatus:null,pinchIn:null,pinchOut:null,pinchStatus:null,click:null,tap:null,doubleTap:null,longTap:null,hold:null,triggerOnTouchEnd:!0,triggerOnTouchLeave:!1,allowPageScroll:"auto",fallbackToMouseEvents:!0,excludedElements:".noSwipe",preventDefaultEvents:!0},$.fn.swipe.phases={PHASE_START:"start",PHASE_MOVE:"move",PHASE_END:"end",PHASE_CANCEL:"cancel"},$.fn.swipe.directions={LEFT:LEFT,RIGHT:"right",UP:UP,DOWN:"down",IN:"in",OUT:"out"},$.fn.swipe.pageScroll={NONE:"none",HORIZONTAL:"horizontal",VERTICAL:"vertical",AUTO:"auto"},$.fn.swipe.fingers={ONE:1,TWO:2,THREE:3,FOUR:4,FIVE:5,ALL:"all"}}));
/**
 * EGroupware eTemplate2 - Contains interfaces used inside the dataview
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2012
 * @version $Id$
 */
var EGW_SELECTMODE_DEFAULT=0,EGW_SELECTMODE_TOGGLE=1;function et2_dataview_rowAOI(_node){var aoi=new egwActionObjectInterface;aoi.node=_node,aoi.selectMode=EGW_SELECTMODE_DEFAULT,aoi.checkBox=null,aoi.doGetDOMNode=function(){return aoi.node},jQuery(_node).mousedown(egwPreventSelect);var selectHandler=function(e,_params){if(egwUnfocus(),_node.onselectstart=null,e.target!=aoi.checkBox){var selected=egwBitIsSet(aoi.getState(),EGW_AO_STATE_SELECTED),state=egwGetShiftState(e);if(_params&&egwIsMobile())switch(_params.swip){case"left":case"right":state=1,_egw_active_menu&&_egw_active_menu.hide();break;case"up":case"down":return}switch(aoi.selectMode){case EGW_SELECTMODE_DEFAULT:aoi.updateState(EGW_AO_STATE_SELECTED,!egwBitIsSet(state,EGW_AO_SHIFT_STATE_MULTI)||!selected,state);break;case EGW_SELECTMODE_TOGGLE:aoi.updateState(EGW_AO_STATE_SELECTED,!selected,egwSetBit(state,EGW_AO_SHIFT_STATE_MULTI,!0))}}};return egwIsMobile()?jQuery(_node).swipe({allowPageScroll:"vertical",longTapThreshold:10,swipe:function(event,direction,distance){distance>100&&selectHandler(event,{swip:direction})},tap:function(event,duration){selectHandler(event)},longTap:function(event){}}):jQuery(_node).click(selectHandler),jQuery(aoi.checkBox).change((function(){aoi.updateState(EGW_AO_STATE_SELECTED,this.checked,EGW_AO_SHIFT_STATE_MULTI)})),aoi.doSetState=function(_state){var selected=egwBitIsSet(_state,EGW_AO_STATE_SELECTED);this.checkBox&&(this.checkBox.checked=selected),jQuery(this.node).toggleClass("focused",egwBitIsSet(_state,EGW_AO_STATE_FOCUSED)),jQuery(this.node).toggleClass("selected",selected)},aoi}
/**
 * EGroupware eTemplate2
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011-2012
 *

/*egw:uses
    et2_dataview_view_aoi;

    egw_action.egw_keymanager;
*/
Object.defineProperty(exports,"__esModule",{value:!0}),exports.et2_dataview_selectionManager=void 0;var et2_dataview_selectionManager=function(){function et2_dataview_selectionManager(_parent,_indexMap,_actionObjectManager,_queryRangeCallback,_makeVisibleCallback,_context){this._parent=_parent,this._indexMap=_indexMap,this._actionObjectManager=_actionObjectManager,this._queryRangeCallback=_queryRangeCallback,this._makeVisibleCallback=_makeVisibleCallback,this._context=_context,this._parent&&this._parent._children.push(this),_actionObjectManager&&(this._actionObjectManager.getAllSelected=jQuery.proxy(this.getAllSelected,this)),this._registeredRows={},this._focusedEntry=null,this._invertSelection=!1,this._selectAll=!1,this._inUpdate=!1,this._total=0,this._children=[],this.select_callback=null}return et2_dataview_selectionManager.prototype.destroy=function(){if(this._parent){var idx=this._parent._children.indexOf(this);this._parent._children.splice(idx,1)}for(var i=this._children.length-1;i>=0;i--)this._children[i].destroy();for(var key in this._registeredRows)this.unregisterRow(key,this._registeredRows[key].tr);this.select_callback=null},et2_dataview_selectionManager.prototype.clear=function(){for(var key in this._registeredRows)this.unregisterRow(key,this._registeredRows[key].tr),delete this._registeredRows[key];for(key in this._actionObjectManager&&this._actionObjectManager.clear(),this._indexMap)delete this._indexMap[key];this._total=0,this._focusedEntry=null,this._invertSelection=!1,this._selectAll=!1,this._inUpdate=!1},et2_dataview_selectionManager.prototype.setIndexMap=function(_indexMap){this._indexMap=_indexMap},et2_dataview_selectionManager.prototype.setTotalCount=function(_total){this._total=_total},et2_dataview_selectionManager.prototype.registerRow=function(_uid,_idx,_tr,_links){var entry=this._getRegisteredRowsEntry(_uid);entry.tr&&entry.tr!==_tr&&this.unregisterRow(_uid,entry.tr,!0),!entry.tr&&_links&&(this._attachActionObjectInterface(entry,_tr,_uid),this._attachActionObject(entry,_tr,_uid,_links,_idx)),entry.ao&&entry.ao._index,entry.idx=_idx,entry.tr=_tr,this._updateEntryState(entry,entry.state)},et2_dataview_selectionManager.prototype.unregisterRow=function(_uid,_tr,_noDelete){_noDelete=!!_noDelete,void 0!==this._registeredRows[_uid]&&this._registeredRows[_uid].tr===_tr&&(this._inUpdate=!0,null!==this._focusedEntry&&this._focusedEntry.uid==_uid&&this.setFocused(_uid,!1),this._registeredRows[_uid].tr=null,this._registeredRows[_uid].aoi=null,this._registeredRows[_uid].ao&&(this._registeredRows[_uid].ao.remove(),this._registeredRows[_uid].ao=null),_noDelete||this._registeredRows[_uid].state!==EGW_AO_STATE_NORMAL||delete this._registeredRows[_uid],this._inUpdate=!1)},et2_dataview_selectionManager.prototype.resetSelection=function(){for(var key in this._invertSelection=!1,this._selectAll=!1,this._actionObjectManager.setAllSelected(!1),this._registeredRows)this.setSelected(key,!1);for(var i=0;i<this._children.length;i++)this._children[i].resetSelection()},et2_dataview_selectionManager.prototype.setSelected=function(_uid,_selected){this._selectAll=!1;var entry=this._getRegisteredRowsEntry(_uid);this._updateEntryState(entry,egwSetBit(entry.state,EGW_AO_STATE_SELECTED,_selected))},et2_dataview_selectionManager.prototype.getAllSelected=function(){var selected=this.getSelected();return selected.all||selected.ids.length===this._total},et2_dataview_selectionManager.prototype.setFocused=function(_uid,_focused){if(this._focusedEntry&&(this._updateEntryState(this._focusedEntry,egwSetBit(this._focusedEntry.state,EGW_AO_STATE_FOCUSED,!1)),this._focusedEntry=null),_focused){var entry=this._focusedEntry=this._getRegisteredRowsEntry(_uid);this._updateEntryState(entry,egwSetBit(entry.state,EGW_AO_STATE_FOCUSED,!0))}},et2_dataview_selectionManager.prototype.selectAll=function(){for(var key in this.resetSelection(),this._selectAll=!0,egw.dataKnownUIDs(this._context._dataProvider.dataStorePrefix).length!==this._total&&this._total<=et2_dataview_selectionManager.MAX_SELECTION&&this._selectRange(0,this._total),this._actionObjectManager.setAllSelected(!0),this._registeredRows){var entry=this._registeredRows[key];this._updateEntryState(entry,entry.state)}this._selectAll=!0},et2_dataview_selectionManager.prototype.getSelected=function(){var ids=[];for(var key in this._registeredRows)egwBitIsSet(this._registeredRows[key].state,EGW_AO_STATE_SELECTED)&&ids.push(key);for(var i=0;i<this._children.length;i++)ids=ids.concat(this._children[i].getSelected().ids);return{all:this._selectAll,ids:ids}},et2_dataview_selectionManager.prototype._attachActionObjectInterface=function(_entry,_tr,_uid){_entry.aoi=new et2_dataview_rowAOI(_tr),_entry.aoi.setStateChangeCallback((function(_newState,_changedBit,_shiftState){_changedBit===EGW_AO_STATE_SELECTED&&this._handleSelect(_uid,_entry,egwBitIsSet(_shiftState,EGW_AO_SHIFT_STATE_BLOCK),egwBitIsSet(_shiftState,EGW_AO_SHIFT_STATE_MULTI))}),this)},et2_dataview_selectionManager.prototype._getDummyAOI=function(_entry,_tr,_uid,_idx){var dummyAOI=new egwActionObjectInterface,self=this;return dummyAOI.doSetState=function(_state){self._inUpdate||(self.setFocused(_uid,egwBitIsSet(_state,EGW_AO_STATE_FOCUSED)),self._updateState(_uid,_state))},dummyAOI.doMakeVisible=function(){self._makeVisibleCallback.call(self._context,_idx)},dummyAOI.doTriggerEvent=_entry.aoi.doTriggerEvent,dummyAOI.getDOMNode=function(){return _tr},dummyAOI},et2_dataview_selectionManager.prototype._attachActionObject=function(_entry,_tr,_uid,_links,_idx){var dummyAOI=this._getDummyAOI(_entry,_tr,_uid,_idx);if(this._actionObjectManager){if(this._actionObjectManager.getObjectById(_uid)){var state=_entry.state;this._actionObjectManager.getObjectById(_uid).remove(),_entry.state=state}_entry.ao=this._actionObjectManager.addObject(_uid,dummyAOI)}_entry.ao._context=this._context,_entry.ao.updateActionLinks(_links),_entry.ao._index=_idx;var self=this;function getIndexAO(_idx){return void 0!==self._indexMap[_idx]&&self._indexMap[_idx].uid?self._getRegisteredRowsEntry(self._indexMap[_idx].uid).ao:null}function getElementRelatively(_step){self._total||Object.keys(self._indexMap).length;for(var max_index=Math.max.apply(Math,Object.keys(self._indexMap)),count=Math.max(1,Math.min(self._total,50)),element=null,idx=_entry.idx;null==element&&count>0&&max_index>0;)count--,element=getIndexAO(Math.max(0,Math.min(max_index,idx+=_step)));return element}_entry.ao.getPrevious=function(_step){return getElementRelatively(-_step)},_entry.ao.getNext=function(_step){return getElementRelatively(_step)},_entry.ao.traversePath=function(_obj){for(var s=Math.min(this._index,_obj._index),e=Math.max(this._index,_obj._index),result=[],i=s;i<e;i++){var ao=getIndexAO(i);ao&&result.push(ao)}return result}},et2_dataview_selectionManager.prototype._updateState=function(_uid,_state){var entry=this._getRegisteredRowsEntry(_uid);return this._updateEntryState(entry,_state),entry},et2_dataview_selectionManager.prototype._updateEntryState=function(_entry,_state){if(this._selectAll?_state|=EGW_AO_STATE_SELECTED:this._invertSelection&&(_state^=EGW_AO_STATE_SELECTED),!_entry.ao&&_entry.uid&&this._actionObjectManager){var _links=[];for(var key in this._registeredRows)if(this._registeredRows[key].ao&&this._registeredRows[key].ao.actionLinks){_links=this._registeredRows[key].ao.actionLinks;break}_links.length&&(this._attachActionObjectInterface(_entry,null,_entry.uid),this._attachActionObject(_entry,null,_entry.uid,_links,_entry.idx))}(_entry.aoi&&_entry.aoi.getState()!==_state||_entry.state!=_state)&&(this._inUpdate=!0,_entry.ao&&(_entry.ao.setSelected(egwBitIsSet(_state,EGW_AO_STATE_SELECTED)),_entry.ao.setFocused(egwBitIsSet(_state,EGW_AO_STATE_FOCUSED))),this._inUpdate=!1,_state!==EGW_AO_STATE_NORMAL||_entry.tr||delete this._registeredRows[_entry.uid]),_entry.aoi&&_entry.aoi.doSetState&&_entry.aoi.doSetState(_state),_entry.state=_state},et2_dataview_selectionManager.prototype._getRegisteredRowsEntry=function(_uid){return void 0===this._registeredRows[_uid]&&(this._registeredRows[_uid]={uid:_uid,idx:null,state:EGW_AO_STATE_NORMAL,tr:null,aoi:null,ao:null}),this._registeredRows[_uid]},et2_dataview_selectionManager.prototype._handleSelect=function(_uid,_entry,_shift,_ctrl){if(!_ctrl){for(var top=this;null!==top._parent;)top=top._parent;top.resetSelection(),this._actionObjectManager.setAllSelected(!1)}var entry=this._getRegisteredRowsEntry(_uid);this.setSelected(_uid,!_ctrl||!egwBitIsSet(entry.state,EGW_AO_STATE_SELECTED)),_shift?this._focusedEntry&&this._selectRange(this._focusedEntry.idx,_entry.idx):this.setFocused(_uid,!0),this.select_callback&&"function"==typeof this.select_callback&&this.select_callback.apply(this._context,arguments)},et2_dataview_selectionManager.prototype._selectRange=function(_start,_stop){for(var queryRanges=[],naStart=!1,s=Math.min(_start,_stop),e=Math.max(_stop,_start),range_break=s+50,i=s;i<=e;i++)if(void 0!==this._indexMap[i]&&this._indexMap[i].uid&&egw.dataGetUIDdata(this._indexMap[i].uid)){!1!==naStart&&(queryRanges.push(et2_bounds(naStart,i-1)),naStart=!1,range_break+=50);var data=egw.dataGetUIDdata(this._indexMap[i].uid);data&&data.data&&!data.data.no_actions&&this.setSelected(this._indexMap[i].uid,!0)}else!1===naStart?range_break=(naStart=i)+50:i>=range_break&&(queryRanges.push(et2_bounds(naStart||s,i-1)),naStart=i,range_break+=50);!1!==naStart&&(queryRanges.push(et2_bounds(naStart,i-1)),naStart=!1),queryRanges.length>0&&this._query_ranges(queryRanges)},et2_dataview_selectionManager.prototype._query_ranges=function(queryRanges){var progressbar,that=this,record_count=0,range_index=0,range_count=queryRanges.length,cont=!0,fetchPromise=new Promise((function(resolve){resolve()})),parent=et2_dialog._create_parent(),dialog=et2_createWidget("dialog",{callback:function(){cont=!1},template:egw.webserverUrl+"/api/templates/default/long_task.xet",message:egw.lang("Loading"),title:egw.lang("please wait..."),buttons:[{button_id:et2_dialog.CANCEL_BUTTON,text:egw.lang("cancel"),id:"dialog[cancel]",image:"cancel"}],width:300},parent);jQuery(dialog.template.DOMContainer).on("load",(function(){progressbar=dialog.template.widgetContainer.getWidgetById("progressbar")}));for(var i=0;i<queryRanges.length;i++){if(record_count+(queryRanges[i].bottom-queryRanges[i].top+1)>that.MAX_SELECTION){egw.message(egw.lang("Too many rows selected.<br />Select all, or less than %1 rows",that.MAX_SELECTION));break}record_count+=queryRanges[i].bottom-queryRanges[i].top+1,fetchPromise=fetchPromise.then(function(){if(cont)return new Promise(function(resolve){that._queryRangeCallback.call(that._context,this,(function(_order){for(var j=0;j<_order.length;j++){var data=egw.dataGetUIDdata(_order[j]);if(!data||data&&data.data&&!data.data.no_actions){var entry=this._getRegisteredRowsEntry(_order[j]);this._updateEntryState(entry,egwSetBit(entry.state,EGW_AO_STATE_SELECTED,!0))}}progressbar.set_value(++range_index/range_count*100),resolve()}),that)}.bind(this))}.bind(queryRanges[i]))}fetchPromise.finally((function(){dialog.destroy()}))},et2_dataview_selectionManager.MAX_SELECTION=1e3,et2_dataview_selectionManager}();exports.et2_dataview_selectionManager=et2_dataview_selectionManager;
/**
 * EGroupware eTemplate2 - dataview code
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2014
 * @version $Id: et2_dataview_view_container_1.js 46338 2014-03-20 09:40:37Z ralfbecker $
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});var et2_dataview_tile=function(_super){function et2_dataview_tile(_parent){var _this=_super.call(this,_parent)||this;return _this.columns=4,_this.tr.addClass("tile"),_this}return __extends(et2_dataview_tile,_super),et2_dataview_tile.prototype.makeExpandable=function(_expandable,_callback,_context){},et2_dataview_tile.prototype.getAvgHeightData=function(){return{avgHeight:this.getHeight()/this.columns,avgCount:this.columns}},et2_dataview_tile.prototype.getHeight=function(){return this._index%this.columns==0?_super.prototype.getHeight.call(this):0},et2_dataview_tile.prototype.invalidate=function(){if(this._inTree&&this.tr){var template_width=jQuery(".innerContainer",this.tr).children().outerWidth(!0);template_width&&this.tr.css("width",template_width+(this.tr.outerWidth(!0)-this.tr.width()))}this._recalculate_columns(),_super.prototype.invalidate.call(this)},et2_dataview_tile.prototype._recalculate_columns=function(){this._inTree&&this.tr&&this.tr.parent()&&(this.columns=Math.max(1,parseInt(this.tr.parent().innerWidth()/this.tr.outerWidth(!0))))},et2_dataview_tile}(et2_dataview_row);exports.et2_dataview_tile=et2_dataview_tile,
/**
 * EGroupware eTemplate2
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011-2012

/*egw:uses
    et2_core_common;
    et2_core_inheritance;

    et2_dataview_interfaces;
    et2_dataview_controller_selection;
    et2_dataview_view_row;
    et2_dataview_view_tile;

    egw_action.egw_action;
*/
Object.defineProperty(exports,"__esModule",{value:!0});var et2_dataview_controller_selection_1=require("./et2_dataview_controller_selection"),et2_dataview_view_row_1=require("./et2_dataview_view_row"),ET2_DATAVIEW_FETCH_TIMEOUT=50,ET2_DATAVIEW_STEPSIZE=50,et2_dataview_controller=function(){function et2_dataview_controller(_parentController,_grid){this._indexMap={},this._parentController=_parentController,this._grid=_grid,this._children=[],this._indexMap={},this._queueTimer=null,this._queue={},this._request_queue=[],this._grid.setDataCallback(this._gridCallback,this),null!=this._parentController&&this._parentController._children.push(this)}return et2_dataview_controller.prototype.destroy=function(){if(this._selectionMgr.destroy(),this._clearTimer(),null!=this._parentController){var idx=this._parentController._children.indexOf(this);idx>=0&&(this._parentController._children.splice(idx,1),this._parentController=null)}this._grid=null},et2_dataview_controller.prototype.setDataProvider=function(value){this._dataProvider=value},et2_dataview_controller.prototype.setRowCallback=function(value){this._rowCallback=value},et2_dataview_controller.prototype.setLinkCallback=function(value){this._linkCallback=value},et2_dataview_controller.prototype.setContext=function(value){this._context=value},et2_dataview_controller.prototype.setActionObjectManager=function(_actionObjectManager){this._selectionMgr&&this._selectionMgr.destroy(),this._selectionMgr=new et2_dataview_controller_selection_1.et2_dataview_selectionManager(this._parentController?this._parentController._selectionMgr:null,this._indexMap,_actionObjectManager,this._selectionFetchRange,this._makeIndexVisible,this)},et2_dataview_controller.prototype.update=function(clear){if(this._grid){this._grid.doInvalidate=!1,clear&&(this._grid.makeIndexVisible(0),this._grid.clear(),this._selectionMgr.clear(),this._objectManager.clear(),this._indexMap={},this._selectionMgr.setIndexMap(this._indexMap),this._queue={},this._lastModification=0),this._grid.cleanup();var range=this._grid.getIndexRange();!1===range.top&&(range.top=range.bottom=0),this._request_queue=[],this._queueFetch(et2_bounds(range.top,clear?0:range.bottom+1),0,!0)}},et2_dataview_controller.prototype.reset=function(){this._indexMap={},this._selectionMgr.setIndexMap(this._indexMap),this._grid.clear(),this._queue={},this._request_queue=[],this.update()},et2_dataview_controller.prototype.loadInitialOrder=function(order){for(var i=0;i<order.length;i++)this._getIndexEntry(i).uid=order[i]},et2_dataview_controller.prototype.loadInitialData=function(uid_prefix,uid_key,data){var idx=0;for(var key in data)if("object"==typeof data[key]&&null!=data[key]&&void 0!==data[key][uid_key]){var entry=this._getIndexEntry(idx++);entry.uid=data[key][uid_key]+"",entry.uid.indexOf(uid_prefix)<0&&(entry.uid=uid_prefix+"::"+entry.uid),egw.dataStoreUID(entry.uid,data[key])}0==idx&&(this._selectionMgr.clear(),this._emptyRow(0==this._grid._total))},et2_dataview_controller.prototype.getDepth=function(){return this._parentController?this._parentController.getDepth()+1:0},et2_dataview_controller.prototype.setPrefix=function(prefix){this.dataStorePrefix=prefix},et2_dataview_controller.prototype.getRowByNode=function(node){var row_node=jQuery(node).closest("tr"),row=null,indexed=this._getIndexEntry(row_node.index());if(indexed&&indexed.row&&indexed.row.getDOMNode()==row_node[0])row=indexed;else for(var index in this._indexMap)if((indexed=this._indexMap[index])&&indexed.row&&indexed.row.getDOMNode()==row_node[0]){row=indexed;break}for(var i=0;!row&&i<this._children.length;i++){var child_row=this._children[i].getRowByNode(node);!1!==child_row&&(row=child_row)}return row&&!row.controller&&(row.controller=this),row},et2_dataview_controller.prototype.getTotalCount=function(){return this._grid.getTotalCount()},et2_dataview_controller.prototype._getIndexEntry=function(_idx){return void 0===this._indexMap[_idx]&&(this._indexMap[_idx]={row:null,uid:null}),this._indexMap[_idx].idx=_idx,this._indexMap[_idx]},et2_dataview_controller.prototype._insertDataRow=function(_entry,_update){var _this=this;if(_entry.row&&!_update)return!0;var ctx={self:this,entry:_entry},createdRow=!1;if(_entry.row||(createdRow=!0,_entry.row=this._createRow(ctx),_entry.row.setDestroyCallback(this._destroyCallback,ctx)),this.hasData=!1,_entry.uid&&this._dataProvider.dataRegisterUID(_entry.uid,this._dataCallback,ctx),!this.hasData){var avg=Math.round(this._grid.getAverageHeight()-5)+"px",prototype=this._grid.getRowProvider().getPrototype("loading");jQuery("div",prototype).css("height",avg);var node=_entry.row.getJNode();node.empty(),node.append(prototype.children())}if(createdRow&&_entry.row&&this._grid.insertRow(_entry.idx,_entry.row),jQuery(".egwGridView_empty",this._grid.innerTbody).remove().length&&this._selectionMgr.unregisterRow("",0),this._indexMap[_entry.idx]&&this._indexMap[_entry.idx].uid!==_entry.uid)for(var idx=parseInt(Object.keys(this._indexMap).reduce((function(a,b){return _this._indexMap[a]>_this._indexMap[b]?a:b})));idx>=_entry.idx;idx--){var entry=this._indexMap[idx];this._indexMap[idx].idx=idx+1,this._indexMap[this._indexMap[idx].idx]=this._indexMap[idx],this._selectionMgr&&this._selectionMgr._registeredRows[entry.uid]&&(this._selectionMgr._registeredRows[entry.uid].idx=entry.idx)}return this._indexMap[_entry.idx]=_entry,this.hasData},et2_dataview_controller.prototype._createRow=function(ctx){return new et2_dataview_view_row_1.et2_dataview_row(this._grid)},et2_dataview_controller.prototype._gridCallback=function(_idxStart,_idxEnd){for(var needsData=!1,i=_idxStart;i<=_idxEnd;i++){var entry=this._getIndexEntry(i);this._insertDataRow(entry,!1)||!1!==needsData||(needsData=i)}!1!==needsData&&this._queueFetch(et2_bounds(needsData,_idxEnd+1),needsData==_idxStart?0:needsData>_idxStart?1:-1,!1)},et2_dataview_controller.prototype._queueFetch=function(_range,_direction,_isUpdate){_isUpdate=_isUpdate||!1;for(var start=Math.max(0,_range.top),end=Math.min(this._grid.getTotalCount(),_range.bottom),i=start;i<end;i++)void 0===this._queue[i]&&(this._queue[i]=_direction);if(null===this._queueTimer&&!_isUpdate){var self=this;egw.debug("log","Dataview queue: ",_range),this._queueTimer=window.setTimeout((function(){self._flushQueue(!1)}),ET2_DATAVIEW_FETCH_TIMEOUT)}_isUpdate&&this._flushQueue(!0)},et2_dataview_controller.prototype._flushQueue=function(_isUpdate){this._clearTimer();var marked={},r=_isUpdate?0:Math.floor(ET2_DATAVIEW_STEPSIZE/2),total=this._grid.getTotalCount();for(var key in this._queue)if(!(this._queue[key]>1)){key=parseInt(key);for(var b=Math.max(0,key-r+r*this._queue[key]),t=Math.min(key+r+r*this._queue[key],total-1),c=0,i=b;i<=t&&c<ET2_DATAVIEW_STEPSIZE;i++)(void 0===this._queue[i]||this._queue[i]<=1)&&(this._queue[i]=2,marked[i]=!0,c++)}var fetchList=[],entry=null,last=0,arr=et2_arrayIntKeys(marked).sort((function(a,b){return a>b?1:a==b?0:-1}));for(i=0;i<arr.length;i++)0==i||arr[i]-last>1?(entry&&fetchList.push(entry),entry={start:arr[i],count:1}):entry.count++,last=arr[i];entry&&fetchList.push(entry),0===fetchList.length&&_isUpdate&&(fetchList.push({start:0,count:0}),this._grid.doInvalidate=!1),egw.debug("log","Dataview flush",fetchList);for(i=0;i<fetchList.length;i++){var query={start:fetchList[i].start,num_rows:fetchList[i].count,refresh:!1},ctx={self:this,start:query.start,count:query.num_rows,lastModification:this._lastModification};this.dataStorePrefix&&(ctx.prefix=this.dataStorePrefix),this._queueRequest(query,ctx)}},et2_dataview_controller.prototype._queueRequest=function(query,ctx){this._request_queue.push({query:query,context:ctx,status:0}),this._fetchQueuedRequest()},et2_dataview_controller.prototype._fetchQueuedRequest=function(){for(var count=0,i=0;i<this._request_queue.length;i++)this._request_queue[i].status>0&&count++;if(!(count>=et2_dataview_controller.CONCURRENT_REQUESTS||0===this._request_queue.length)){var keep=1,request=null;for(i=this._request_queue.length-1;i>=0;i--)0==this._request_queue[i].status&&(null==request?request=this._request_queue[i]:keep>0?keep--:keep<=0&&this._request_queue.splice(i,1));null!=request&&(request.status=1,this._dataProvider.dataFetch(request.query,this._fetchCallback,request.context))}},et2_dataview_controller.prototype._clearTimer=function(){this._queueTimer&&(window.clearTimeout(this._queueTimer),this._queueTimer=null)},et2_dataview_controller.prototype._dataCallback=function(_data){if(this.self.hasData=!0,this.self._rowCallback){if(this.entry.row.clear(),void 0===_data||null==_data)return void this.self._destroyCallback.call(this,this.entry.row);this.self._rowCallback.call(this.self._context,_data,this.entry.row,this.entry.idx,this.entry);var tr=this.entry.row.getDOMNode(),d=this.self.getDepth();if(d>0&&(jQuery(tr).addClass("subentry"),jQuery("td:first",tr).children("div").last().addClass("level_"+d+" indentation"),0==this.entry.idx)){var indent=jQuery("<span class='indentation'/>").appendTo("body");egw.css(".subentry td div.innerContainer.level_"+d,"margin-right:"+parseInt(indent.css("margin-right"))*d+"px"),indent.remove()}var links=null;_data.no_actions?this.entry.no_actions=!0:(this.self._linkCallback&&(links=this.self._linkCallback.call(this.self._context,_data,this.entry.idx,this.entry.uid)),this.self._selectionMgr.registerRow(this.entry.uid,this.entry.idx,tr,links)),this.entry.row.invalidate()}},et2_dataview_controller.prototype._destroyCallback=function(_row){var selection=this.self._selectionMgr._getRegisteredRowsEntry(this.entry.uid);if(this.entry.row&&selection&&!egwBitIsSet(selection.state,EGW_AO_STATE_SELECTED)){var tr=this.entry.row.getDOMNode();this.self._selectionMgr._updateState(this.entry.uid,EGW_AO_STATE_NORMAL),this.self._selectionMgr.unregisterRow(this.entry.uid,tr)}this.entry.row=null,this.self._dataProvider.dataUnregisterUID(this.entry.uid,this.self._dataCallback,this)},et2_dataview_controller.prototype._getIndexMapping=function(_start,_count){for(var result=[],i=_start;i<_start+_count;i++)result.push(this._getIndexEntry(i));return result},et2_dataview_controller.prototype._updateOrder=function(_start,_count,_idxMap,_order){for(var result=[],mapIdx=0,idx=_start,i=0;i<_order.length;i++,idx++){var current=_idxMap[mapIdx];if(current.row&&current.uid)if(current.uid!==_order[i]){var entry={idx:idx,uid:_order[i],row:null};this._insertDataRow(entry,!0),result.push(entry)}else current.idx=idx,mapIdx++;else current.uid=_order[i],current.idx=idx,current.row&&this._insertDataRow(current,!0),mapIdx++}for(i=mapIdx;i<_idxMap.length;i++)void 0!==_idxMap[i]&&(_idxMap[i].uid=null);return result},et2_dataview_controller.prototype._mergeResult=function(_newEntries,_invalidStartIdx,_diff,_total){if(_newEntries.length>0||_diff>0){for(var newMap={},i=0;i<_newEntries.length;i++)newMap[_newEntries[i].idx]=_newEntries[i];for(var key in this._indexMap){var entry=this._indexMap[key],newIdx=entry.idx>=_invalidStartIdx?entry.idx-_diff:entry.idx;newIdx>=0&&newIdx<_total&&void 0===newMap[newIdx]?(entry.idx=newIdx,newMap[newIdx]=entry):newMap[newIdx]!==this._indexMap[key]&&(entry.idx=null,entry.row=null)}this._indexMap=newMap,this._selectionMgr.setIndexMap(newMap)}},et2_dataview_controller.prototype._fetchCallback=function(_response){for(var i=0;i<this.self._request_queue.length;i++)if(this.self._request_queue[i].context==this){this.self._request_queue[i],this.self._request_queue.splice(i,1);break}if(this.self._lastModification=_response.lastModification,_response.order){var order=0!=this.count?_response.order.splice(0,this.count):_response.order;if(_response.total<this.count)this.self._queue={};else for(i=this.start;i<this.start+order.length;i++)delete this.self._queue[i];var idxMap=this.self._getIndexMapping(this.start,order.length),res=this.self._updateOrder(this.start,this.count,idxMap,order);if(this.self._mergeResult(res,this.start+order.length,idxMap.length-order.length,_response.total),0==_response.total)this.self._emptyRow(!0);else{var row=jQuery(".egwGridView_empty",this.self._grid.innerTbody).remove();this.self._selectionMgr.unregisterRow("",0,row.get(0))}this.self._grid.doInvalidate=!0,this.self._grid.setTotalCount(_response.total),this.self._selectionMgr.setTotalCount(_response.total),this.self._grid.invalidate(),this.self._fetchQueuedRequest()}},et2_dataview_controller.prototype._emptyRow=function(_noRows){var noRows=!!_noRows;if(jQuery(".egwGridView_empty",this._grid.innerTbody).remove(),void 0!==this._grid._rowProvider&&this._grid._rowProvider.getPrototype("empty")){var placeholder=this._grid._rowProvider.getPrototype("empty");if(1==jQuery("td",placeholder).length&&jQuery("td",placeholder).css("width",this._grid.outerCell.width()+"px"),placeholder.appendTo(this._grid.innerTbody),noRows){var links=null;this._linkCallback&&(links=this._linkCallback.call(this._context,{},0,"")),this._selectionMgr.registerRow("",0,placeholder.get(0),links)}}},et2_dataview_controller.prototype._selectionFetchRange=function(_range,_callback,_context){this._dataProvider.dataFetch({start:_range.top,num_rows:_range.bottom-_range.top+1,no_data:!0},(function(_response){_callback.call(_context,_response.order)}),_context)},et2_dataview_controller.prototype._makeIndexVisible=function(_idx){this._grid.makeIndexVisible(_idx)},et2_dataview_controller.CONCURRENT_REQUESTS=5,et2_dataview_controller}();
/**
 * EGroupware eTemplate2 - JS Nextmatch object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @author Ralf Becker <RalfBecker@outdoor-training.de>
 * @copyright Stylite AG 2012-14
 * @version $Id$
 */
function nm_action(_action,_senders,_target,_ids){if(!_action.checkbox||_action.data&&void 0!==_action.data.nm_action){if(void 0!==_action.data&&_action.data||(_action.data={}),void 0===_action.data.nm_action&&"popup"==_action.type&&(_action.data.nm_action="submit"),void 0===_ids){for(var nm=null,action=_action;null==nm&&null!=action;)null!=action.data&&action.data.nextmatch&&(nm=action.data.nextmatch),action=action.parent;nm&&(_ids=nm.getSelection(),_action.data.nextmatch=nm)}for(var row_ids="",i=0;i<_ids.ids.length;i++){var row_id=_ids.ids[i];row_ids+=(row_id.indexOf(",")>=0?'"'+row_id.replace(/"/g,'""')+'"':row_id)+(i<_ids.ids.length-1?",":"")}var idsArr=_ids.ids;for(i=0;i<idsArr.length;i++)idsArr[i]?idsArr[i]=idsArr[i].split("::").pop():idsArr.splice(i,1);var ids="";for(i=0;i<idsArr.length;i++){var id=idsArr[i];ids+=(id.indexOf(",")>=0?'"'+id.replace(/"/g,'""')+'"':id)+(i<idsArr.length-1?",":"")}var mgr=_action.getManager(),url="#";void 0!==_action.data.url&&(url=_action.data.url.replace(/(\$|%24)id/,encodeURIComponent(ids)).replace(/(\$|%24)select_all/,_ids.all).replace(/(\$|%24)row_id/,encodeURIComponent(row_ids)));var target=null;switch(void 0!==_action.data.target&&(target=_action.data.target),_action.data.nm_action){case"alert":alert(_action.caption+" ('"+_action.id+"') executed on rows: "+ids);break;case"location":void 0!==_action.data.targetapp?egw.top.egw_appWindowOpen(_action.data.targetapp,url):target?egw.open_link(url,target,!!_action.data.width&&_action.data.width+"x"+_action.data.height):window.location.href=url;break;case"popup":if(url.length>2083){var $tmpForm=jQuery(document.createElement("form")),$tmpSubmitInput=jQuery(document.createElement("input")).attr({type:"submit"}),params=url.split("&");url=params[0];for(i=1;i<params.length;i++){var values=params[i].split("=");switch(values[0]){case"cd":case"tz":case"menuaction":case"hasupdate":url=url+"&"+values.join("=")}$tmpForm.append(jQuery(document.createElement("input")).attr({name:values[0],type:"text",value:values[1]}))}var postRequest=!0}var popup_window=egw.open_link(url,target,_action.data.width+"x"+_action.data.height);postRequest&&(popup_window.name=popup_window.name?popup_window.name:"postRequest",$tmpForm.attr({target:popup_window.name,action:url,method:"post"}).append($tmpSubmitInput).appendTo("body"),$tmpForm.submit(),$tmpForm.remove());break;case"long_task":if(doLongTask(idsArr,_ids.all,_action,mgr.data.nextmatch))break;case"egw_open":params=_action.data.egw_open.split("-");var egw_open_id=idsArr[0],type=params.shift(),app=params.shift();void 0!==params[2]&&(egw_open_id.indexOf(":")>=0?egw_open_id=egw_open_id.split(":")[params.shift(params[2])]:params.length>1&&""==params[0]&&-1!=params[1].indexOf("from=merge")?params.shift():params.shift(params[2])),params.length>1&&""==params[0]&&-1!=params[1].indexOf("from=merge")&&params.shift();var extra=params.join("-");egw(app,window).open(egw_open_id,app,type,extra,target);break;case"open_popup":if(null==nm_popup_action){nm_open_popup(_action,_ids.ids);break}case"submit":var checkboxes=mgr.getActionsByAttr("checkbox",!0),checkbox_values={};if(checkboxes)for(var i in checkboxes)checkbox_values[checkboxes[i].id]=checkboxes[i].checked;var nextmatch=_action.data.nextmatch;if(!nextmatch&&_senders.length&&(nextmatch=_senders[0]._context._widget),nextmatch){var old_value=nextmatch.getValue,value=nextmatch.getValue();jQuery.extend(value,_action.data,this.activeFilters,{selected:idsArr,select_all:_ids.all,checkboxes:checkbox_values}),delete value.id,value[nextmatch.options.settings.action_var]=_action.id,delete value.nextmatch,nextmatch.getValue=function(){return value},_action.data.postSubmit?nextmatch.getInstanceManager().postSubmit():nextmatch.getInstanceManager().submit(),"open_popup"==_action.data.nm_action&&(nextmatch.refresh(idsArr),nextmatch.getValue=old_value)}else egw().debug("error","Missing nextmatch widget, could not submit",_action)}}}function fetchAll(ids,nextmatch,callback){if(!nextmatch||!nextmatch.controller)return!1;if(!nextmatch.getSelection().all)return!1;if(nextmatch.controller._grid&&nextmatch.controller._grid.getTotalCount()>ids.length){var idsArr=[],count=idsArr.length,total=nextmatch.controller._grid.getTotalCount(),cancel=!1,dialog=et2_dialog.show_dialog((function(){count=total,cancel=!0}),egw.lang("Loading"),egw.lang("please wait..."),{},[{button_id:et2_dialog.CANCEL_BUTTON,text:egw.lang("cancel"),id:"dialog[cancel]",image:"cancel"}]);do{nextmatch.controller.dataFetch({start:count,num_rows:200},(function(data){if(data&&data.order)for(var i=0;i<data.order.length;i++)idsArr.push(data.order[i].split("::").pop());data&&data.total&&(total=data.total),idsArr.length>=total&&(dialog.destroy(),cancel||callback.call(this,idsArr))}),this),count+=200}while(count<total);return!0}return!1}function doLongTask(idsArr,all,_action,nextmatch){if(all||idsArr.length>1||void 0===_action.data.egw_open){if(all)if(fetchAll(idsArr,nextmatch,(function(idsArr){et2_dialog.long_task(null,_action.data.message||_action.caption,_action.data.title,_action.data.menuaction,idsArr)})))return!0;return et2_dialog.long_task(null,_action.data.message||_action.caption,_action.data.title,_action.data.menuaction,idsArr),!0}return!1}function nm_compare_field(_action,_senders,_target){var value=!1,field=document.getElementById(_action.data.fieldId);if(field)value=jQuery(field).val();else{var nextmatch=_action.data.nextmatch;if(!nextmatch&&_senders.length&&(nextmatch=_senders[0]._context._widget),!nextmatch)return!1;value=(field=nextmatch.getWidgetById(_action.data.fieldId)).getValue()}return!!field&&("!"==_action.data.fieldValue.substr(0,1)?value!=_action.data.fieldValue.substr(1):value==_action.data.fieldValue)}exports.et2_dataview_controller=et2_dataview_controller;var nm_popup_action,nm_popup_ids=null;function nm_open_popup(_action,_selected){var uid;void 0!==_action.data.nextmatch?uid=_action.data.nextmatch.getInstanceManager().uniqueId:void 0!==_selected[0]&&(uid=_selected[0].manager.data.nextmatch.getInstanceManager().uniqueId);var popup=jQuery("#"+(uid||"")+"_"+_action.id+"_popup").first()||jQuery("[id*='"+_action.id+"_popup']").first();if(popup){nm_popup_action=_action,_selected.length&&"object"==typeof _selected[0]?(_action.data.nextmatch=_selected[0]._context._widget,nm_popup_ids=_selected):(egw().debug("warn","Not proper format for IDs, should be array of egwActionObject",_selected),nm_popup_ids=_selected);var dialog=jQuery(".action_popup-content",popup);if(0==dialog.length&&(dialog=jQuery(document.createElement("div")).addClass("action_popup-content"),1==popup.children().length?dialog.append(popup.children().children().slice(1,popup.children().children().length-1)):dialog.append(popup.children().slice(1,popup.children().length-1)),dialog.appendTo(popup)),1==dialog.length){var dialog_parent=dialog.parent(),d_buttons=[],action=_action;let selected=_selected;popup.show();var close_function=function(){dialog_parent.append(dialog)};jQuery("button:visible",popup).each((function(index){var but=jQuery(this);if(but.attr("id"))var widget_id=but.attr("id").replace(_action.data.nextmatch.getInstanceManager().uniqueId+"_",""),button=nm_popup_action.data.nextmatch.getRoot().getWidgetById(widget_id);var button_data={text:but.text(),id:widget_id,click:button&&button.onclick?function(e){jQuery(this).dialog("close"),nm_popup_action=action,nm_popup_ids=selected,button.onclick.apply(button,e.currentTarget),close_function()}:function(e){jQuery(this).dialog("close"),nm_popup_action=null,close_function()}};button&&button.options&&button.options.image&&(button_data.image=button.options.image),d_buttons.push(button_data)})),popup.hide();var _dialog=et2_dialog.show_dialog(close_function,"",jQuery(".promptheader",popup).text(),{},d_buttons);_dialog.set_dialog_type(""),_dialog.div.append(dialog).css("overflow","initial")}nm_popup_action=null,nm_popup_ids=null}}function nm_submit_popup(button){if(nm_popup_action.data.nextmatch){var widget_id=jQuery(button).attr("id").replace(nm_popup_action.data.nextmatch.getInstanceManager().uniqueId+"_","");nm_popup_action.data.nextmatch.getRoot().getWidgetById(widget_id).clicked=!0}if(nm_popup_ids.length&&"object"!=typeof nm_popup_ids[0]){var ids={ids:[]};for(var i in nm_popup_ids)nm_popup_ids[i]&&ids.ids.push(nm_popup_ids[i])}nm_action(nm_popup_action,nm_popup_ids,button,ids),nm_hide_popup(button,null),nm_popup_ids=null}function nm_hide_popup(element,div_id){var prefix=element.id.substring(0,element.id.indexOf("[")),popup=div_id?document.getElementById(div_id):jQuery("#"+prefix+"_popup").get(0)||jQuery("[id*='"+prefix+"_popup']").get(0);return popup&&(popup.style.display="none"),nm_popup_action=null,nm_popup_ids=null,!1}function nm_activate_link(_action,_senders){jQuery(_senders[0].iface.getDOMNode()).find(".et2_clickable:first").trigger("click")}
/**
 * EGroupware eTemplate2 - Class which contains a the data model for nextmatch widgets
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2012
 * @version $Id$
 *

/*egw:uses
    et2_core_common;
    et2_core_inheritance;

    et2_dataview_view_row;
    et2_dataview_controller;
    et2_dataview_interfaces;
    et2_dataview_view_tile;

    et2_extension_nextmatch_actions; // Contains nm_action

    egw_data;
*/
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_dataview_view_row_1=require("./et2_dataview_view_row");var et2_dataview_view_tile_1=require("./et2_dataview_view_tile"),et2_dataview_controller_1=require("./et2_dataview_controller"),et2_dataview_model_columns_1=require("./et2_dataview_model_columns"),et2_nextmatch_controller=function(_super){function et2_nextmatch_controller(_parentController,_egw,_execId,_widget,_parentId,_grid,_rowProvider,_actionLinks,_objectManager,_actions){var _this=_super.call(this,_parentController,_grid)||this;_this.setDataProvider(_this),_this.setRowCallback(_this._rowCallback),_this.setLinkCallback(_this._linkCallback),_this.setContext(_this),_this.egw=_egw,_this._widget=_widget,_this._actionLinks=_actionLinks,_this._execId=_execId;var id=_widget.getArrayMgr("content").getPath();"string"==typeof id?_this._widgetId=id:1===id.length?_this._widgetId=id[0]:_this._widgetId=id.shift()+"["+id.join("][")+"]",_this._parentId=_parentId,_this._rowProvider=_rowProvider,_objectManager?(_this._actionManager=null,_this._objectManager=_objectManager):_this._initActions(_actions),_this.setActionObjectManager(_this._objectManager);var self=_this;return _this._objectManager.setSelectedCallback=function(){self._selectCallback.apply(self,[this,arguments])},_this._filters={},_this.kept_selection=null,_this.kept_focus=null,_this.kept_expansion=[],_this.dataUnregisterUID=_egw.dataUnregisterUID,_this._view=et2_nextmatch_controller.VIEW_ROW,_this}return __extends(et2_nextmatch_controller,_super),et2_nextmatch_controller.prototype.destroy=function(){this._actionManager&&(this._objectManager.remove(),this._actionManager.remove()),this._widget=null,_super.prototype.destroy.call(this)},et2_nextmatch_controller.prototype.setFilters=function(_filters){this._filters=_filters},et2_nextmatch_controller.prototype.keepSelection=function(){this.kept_selection=this._selectionMgr?this._selectionMgr.getSelected():null,this.kept_focus=this._selectionMgr&&this._selectionMgr._focusedEntry&&this._selectionMgr._focusedEntry.uid||null;this._widget;var controller=this;jQuery(".arrow.opened",this._widget.getDOMNode(this._widget)).each((function(){var entry=controller.getRowByNode(this);entry&&entry.uid&&controller.kept_expansion.push(entry.uid)}))},et2_nextmatch_controller.prototype.getObjectManager=function(){return this._objectManager},et2_nextmatch_controller.prototype.deleteRow=function(uid){var entry=Object.values(this._indexMap).find((function(entry){return entry.uid==uid}));if(this._selectionMgr.setSelected(uid,!1),entry&&null!==entry.idx){this._selectionMgr.unregisterRow(uid,entry.tr),this._grid.deleteRow(entry.idx),delete this._indexMap[entry.idx];for(var mapIndex=entry.idx+1;void 0!==this._indexMap[mapIndex];mapIndex++){if((entry=this._indexMap[mapIndex]).idx=mapIndex-1,this._indexMap[mapIndex-1]=entry,entry.uid&&void 0!==this._selectionMgr._registeredRows[entry.uid]){var reg=this._selectionMgr._getRegisteredRowsEntry(entry.uid);reg.idx=entry.idx,reg.ao&&reg.ao._index&&(reg.ao._index=entry.idx),this._selectionMgr._registeredRows[entry.uid].idx=reg.idx}}delete this._indexMap[mapIndex-1]}for(var _i=0,_a=this._children;_i<_a.length;_i++){_a[_i].deleteRow(uid)}},et2_nextmatch_controller.prototype._createRow=function(ctx){switch(this._view){case et2_nextmatch_controller.VIEW_TILE:var row=new et2_dataview_view_tile_1.et2_dataview_tile(this._grid);return window.setTimeout((function(){row.tr&&(row.tr.css("float","none"),window.setTimeout((function(){row.tr&&row.tr.css("float","left")}),50))}),100),row;case et2_nextmatch_controller.VIEW_ROW:default:return new et2_dataview_view_row_1.et2_dataview_row(this._grid)}},et2_nextmatch_controller.prototype._initActions=function(_actions){var uid=this._widget.id||this.egw.uid();null==_actions&&(_actions=[]);var gam=egw_getActionManager(this.egw.appName,!0,1);null==this._actionManager&&(this._actionManager=gam.addAction("actionManager",uid));var data=this._actionManager.data;"undefined"!=data&&data||(data={}),data.nextmatch=this._widget,data.context=this._widget.getInstanceManager().app_obj,this._actionManager.set_data(data),this._actionManager.updateActions(_actions,this.egw.appName);var self=this;this._actionManager.setDefaultExecute((function(_action,_senders,_target){var ids=self._selectionMgr.getSelected();void 0!==_action.data&&_action.data||(_action.data={}),_action.data.nextmatch=self._widget,nm_action(_action,_senders,_target,ids)}));var select_all=this._actionManager.getActionById("select_all");select_all&&select_all.set_onExecute(jQuery.proxy((function(action,selected){this._selectionMgr.selectAll()}),this));var gom=egw_getObjectManager(this.egw.appName,!0,1);if(null==this._objectManager&&(this._objectManager=gom.addObject(new egwActionObjectManager(uid,this._actionManager)),this._objectManager.handleKeyPress=function(_keyCode,_shift,_ctrl,_alt){for(var i=0;i<self._actionManager.children.length;i++)if("object"==typeof self._actionManager.children[i].shortcut&&self._actionManager.children[i].shortcut&&_keyCode==self._actionManager.children[i].shortcut.keyCode)return this.executeActionImplementation({keyEvent:{keyCode:_keyCode,shift:_shift,ctrl:_ctrl,alt:_alt}},"popup",EGW_AO_EXEC_SELECTED);return egwActionObject.prototype.handleKeyPress.call(this,_keyCode,_shift,_ctrl,_alt)}),this._objectManager.flags=this._objectManager.flags|EGW_AO_FLAG_DEFAULT_FOCUS|EGW_AO_FLAG_IS_CONTAINER,this._init_links_dnd(),this._selectionMgr)for(var uid in this._selectionMgr._registeredRows){var entry=this._selectionMgr._getRegisteredRowsEntry(uid);entry.ao&&entry.ao.updateActionLinks(this._actionLinks)}},et2_nextmatch_controller.prototype._init_links_dnd=function(){var mgr=this._actionManager,self=this,drop_action=mgr.getActionById("egw_link_drop"),drag_action=mgr.getActionById("egw_link_drag"),drop_cancel=mgr.getActionById("egw_cancel_drop");if(this._actionLinks||(this._actionLinks=[]),drop_cancel||((drop_cancel=mgr.addAction("drop","egw_cancel_drop",this.egw.lang("Cancel"),egw.image("cancel"),(function(){}),!0)).set_group("99"),drop_cancel.acceptedTypes=drop_cancel.acceptedTypes.concat(Object.keys(egw.user("apps")).concat(["link","file"])),this._actionLinks.push(drop_cancel.id)),!egw.link_get_registry(this.dataStorePrefix||this.egw.appName,"query")||egw.link_get_registry(this.dataStorePrefix||this.egw.appName,"title"))return drop_action&&(drop_action.remove(),this._actionLinks.indexOf(drop_action.id)>=0&&this._actionLinks.splice(this._actionLinks.indexOf(drop_action.id),1)),void(drag_action&&(drag_action.remove(),this._actionLinks.indexOf(drag_action.id)>=0&&this._actionLinks.splice(this._actionLinks.indexOf(drag_action.id),1)));null==drop_action&&(drop_action=mgr.addAction("drop","egw_link_drop",this.egw.lang("Create link"),egw.image("link"),(function(action,source,dropped){for(var links=[],id="",i=0;i<source.length;i++)source[i].id&&(id=source[i].id.split("::"),links.push({app:"filemanager"==id[0]?"link":id[0],id:id[1]}));links.length&&self.egw.json("EGroupware\\Api\\Etemplate\\Widget\\Link::ajax_link",dropped.id.split("::").concat([links]),(function(result){if(result){for(var i=0;i<this._objectManager.selectedChildren.length;i++)this._widget.refresh(this._objectManager.selectedChildren[i].id,"update");this._widget.egw().message("Linked"),this._widget.refresh(dropped.id,"update")}}),self,!0,self).sendRequest()}),!0)),this._actionLinks.indexOf(drop_action.id)<0&&this._actionLinks.push(drop_action.id),-1==drop_action.acceptedTypes.indexOf("link")&&drop_action.acceptedTypes.push("link"),null==drag_action&&(drag_action=mgr.addAction("drag","egw_link_drag",this.egw.lang("link"),"link",(function(action,selected){for(var helper=jQuery(document.createElement("div")),i=0;i<selected.length&&i<10;i++){var id=selected[i].id.split("::"),span=jQuery(document.createElement("span")).appendTo(helper);self.egw.link_title(id[0],id[1],(function(title){this.append(title),this.append("<br />")}),span)}return null}),!0)),this._actionLinks.indexOf(drag_action.id)<0&&this._actionLinks.push(drag_action.id),drag_action.set_dragType("link")},et2_nextmatch_controller.prototype.setPrefix=function(prefix){_super.prototype.setPrefix.call(this,prefix),this._init_links_dnd()},et2_nextmatch_controller.prototype._destroyCallback=function(_row){this.entry.widget&&(this.entry.widget.destroy(),this.entry.widget=null),_super.prototype._destroyCallback.call(this,_row)},et2_nextmatch_controller.prototype._rowCallback=function(_data,_tr,_idx,_entry){_entry.widget=this._rowProvider.getDataRow({content:_data},_tr,_idx,this)},et2_nextmatch_controller.prototype._linkCallback=function(_data,_idx,_uid){if(""!=_uid.trim())return this._actionLinks;var links=[];try{links=void 0!==this._widget.options.settings.placeholder_actions?this._widget.options.settings.placeholder_actions:this._widget.options.add?["add"]:[];links=links.filter((function(current){if(void 0!==this._widget.options.actions[current])return!0;for(var action in this._widget.options.actions)if((action=this._widget.options.actions[action]).children&&action.children[current])return!0;return!1}),this)}catch(e){}return links},et2_nextmatch_controller.prototype._fetchCallback=function(_response){var nm=this.self._widget;if(nm){for(var i in _response.rows)if(!jQuery.isNumeric(i))if("sel_options"==i){var mgr=nm.getArrayMgr(i);for(var id in _response.rows.sel_options){mgr.data[id]=_response.rows.sel_options[id];var select=nm.getWidgetById(id);select&&select.set_select_options&&select.set_select_options(_response.rows.sel_options[id]),"cat_id"==id&&(this.self._rowProvider.categories=null),nm.getParent().getArrayMgr("sel_options").data[id]=_response.rows.sel_options[id]}}else if("order"===i)nm.sortBy(_response.rows[i],void 0,!1);else{(mgr=nm.getArrayMgr("content")).data[i]=_response.rows[i];var widget=nm.getWidgetById(i);widget&&widget.set_value&&widget.set_value(mgr.getEntry(i))}for(var col_refresh=!1,column_index=0;column_index<nm.columns.length;column_index++)"string"==typeof nm.columns[column_index].disabled&&"@"===nm.columns[column_index].disabled[0]&&(col_refresh=!0,nm.dataview.columnMgr.getColumnById("col_"+column_index).set_visibility(nm.getArrayMgr("content").parseBoolExpression(nm.columns[column_index].disabled)?et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_DISABLED:nm.columns[column_index].visible));if(col_refresh&&(nm.dataview.columnMgr.updated(),nm.dataview._updateColumns()),this.self&&null==this.self.kept_selection&&!this.refresh&&this.self._grid.getTotalCount()>_response.total&&this.self.keepSelection(),_super.prototype._fetchCallback.apply(this,arguments),this.self&&this.self.kept_selection&&this.self._selectionMgr){this.self.kept_selection.all&&this.self._selectionMgr.selectAll();for(i=(this.self.kept_selection.ids.length||1)-1;i>=0;i--)_response.order.indexOf(this.self.kept_selection.ids[i])>=0?(this.self._selectionMgr.setSelected(this.self.kept_selection.ids[i],!0),this.self.kept_selection.ids.splice(i,1)):this.self.kept_selection.ids.splice(i,1);this.self.kept_focus&&_response.order.indexOf(this.self.kept_focus)>=0&&this.self._selectionMgr.setFocused(this.self.kept_focus,!0),null!=this.self.kept_selection&&void 0!==this.self.kept_selection.ids&&0==this.self.kept_selection.ids.length&&(this.self.kept_selection=null),this.self.kept_focus=null}}},et2_nextmatch_controller.prototype._selectCallback=function(action,senders){void 0===senders&&(senders=[]),this._widget&&(egwIsMobile()&&framework.nm_onselect_ctrl(this._widget,action,senders),this._widget.onselect.call(this._widget,action,senders))},et2_nextmatch_controller.prototype.dataFetch=function(_queriedRange,_callback,_context){null!==this._parentId&&(_queriedRange.parent_id=this._parentId);for(var obj=this;(void 0===obj._filters||jQuery.isEmptyObject(obj._filters))&&obj._parentController;)obj=obj._parentController;this.egw.dataFetch(this._widget.getInstanceManager().etemplate_exec_id||this._execId,_queriedRange,obj._filters,this._widgetId,_callback,_context)},et2_nextmatch_controller.prototype.dataRegisterUID=function(_uid,_callback,_context){this._widget&&this._widget._get_appname()!=this.egw.getAppName()&&(_context.prefix=_uid.split("::")[0]),this.egw.dataRegisterUID(_uid,_callback,_context,this._widget.getInstanceManager().etemplate_exec_id||this._execId,this._widgetId)},et2_nextmatch_controller.prototype.dataUnregisterUID=function(){},et2_nextmatch_controller.VIEW_ROW="row",et2_nextmatch_controller.VIEW_TILE="tile",et2_nextmatch_controller}(et2_dataview_controller_1.et2_dataview_controller);exports.et2_nextmatch_controller=et2_nextmatch_controller,
/**
 * EGroupware eTemplate2 - JS Dynheight object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 */
Object.defineProperty(exports,"__esModule",{value:!0});var et2_dynheight=function(){function et2_dynheight(_outerNode,_innerNode,_minHeight){this.initialized=!1,this.minHeight=0,this.bottomNodes=[],this.innerMargin=0,this.outerMargin=0,this.outerNode=jQuery(_outerNode),this.innerNode=jQuery(_innerNode),this.minHeight=_minHeight}return et2_dynheight.prototype.destroy=function(){this.outerNode=null,this.innerNode=null,this.bottomNodes=[]},et2_dynheight.prototype.update=function(_callback,_context){if(this.innerNode.is(":visible")){this._initialize();for(var oh=this.outerNode.height(),ot=this.outerNode.offset()?this.outerNode.offset().top:0,it=this.innerNode.offset().top,bminTop=this.bottomNodes.length?1/0:0,bmaxBot=0,i=0;i<this.bottomNodes.length;i++)if(this.bottomNodes[i].find(".action_popup").length)egw.debug("warn","Had to skip a hidden popup - it should be removed",this.bottomNodes[i].find(".action_popup"));else if(this.bottomNodes[i].is(":visible")){var bh_1=this.bottomNodes[i].outerHeight(!0),bt=this.bottomNodes[i].offset().top,bb=bh_1+bt;(0==i||bminTop>bt)&&(bminTop=bt),(0==i||bmaxBot<bb)&&(bmaxBot=bb)}var bh=Math.max(0,bmaxBot-bminTop),h=Math.max(this.minHeight,oh+ot-it-bh-this.innerMargin-this.outerMargin);this.innerNode.height(h);var w=this.outerNode.width();w>jQuery(window).width()&&(w=jQuery(window).width()-50),w!=this.innerNode.outerWidth()&&this.innerNode.width(w),void 0!==_callback&&_callback.call(_context,w,h)}},et2_dynheight.prototype._collectBottomNodes=function(_node,_bottom){if(void 0===_bottom&&(_bottom=this.innerNode.offset().top+this.innerNode.height()),_node){var node=jQuery(_node),ooh=node.outerHeight(!0),oh=node.height();this.outerMargin+=(ooh-oh)/2;var self_1=this;jQuery(_node).children().each((function(){var $this=jQuery(this),top=$this.offset().top;this!=self_1.innerNode[0]&&top>=_bottom&&self_1.bottomNodes.push($this)})),_node!=this.outerNode[0]&&_node!=jQuery("body")[0]&&this._collectBottomNodes(_node.parentNode,_bottom)}},et2_dynheight.prototype._initialize=function(){if(!this.initialized){this.bottomNodes=[],this.outerMargin=0,this._collectBottomNodes(this.innerNode[0].parentNode);var ioh=this.innerNode.outerHeight(!0),ih=this.innerNode.height();this.innerMargin=ioh-ih,this.initialized=!0}},et2_dynheight}();exports.et2_dynheight=et2_dynheight,
/**
 * EGroupware eTemplate2 - Class which contains a the columns model
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 */
Object.defineProperty(exports,"__esModule",{value:!0});var et2_dataview_column=function(){function et2_dataview_column(_attrs){this.visibility=et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE,this.caption="",this.type=et2_dataview_column.ET2_COL_TYPE_DEFAULT,this.width=80,this.maxWidth=0,this.minWidth=20,this.id=_attrs.id,void 0!==_attrs.visibility&&(this.visibility=_attrs.visibility),this.caption=_attrs.caption,void 0!==_attrs.type&&(this.type=_attrs.type),void 0!==_attrs.width&&this.set_width(_attrs.width),void 0!==_attrs.maxWidth&&(this.maxWidth=_attrs.maxWidth),void 0!==_attrs.minWidth&&(this.minWidth=_attrs.minWidth)}return et2_dataview_column.prototype.set_width=function(_value){this.relativeWidth=!1,this.fixedWidth=!1;var w=_value;"number"==typeof w?this.relativeWidth=parseFloat(w.toFixed(3)):"%"!=w.charAt(w.length-1)||isNaN(w.substr(0,w.length-1))?"px"!=w.substr(w.length-2,2)||isNaN(w.substr(0,w.length-2))?"string"!=typeof w||isNaN(parseFloat(w))||(this.fixedWidth=parseInt(w)):this.fixedWidth=parseInt(w.substr(0,w.length-2)):(this.relativeWidth=parseInt(w.substr(0,w.length-1))/100,this.relativeWidth>1&&(this.relativeWidth=!1))},et2_dataview_column.prototype.set_visibility=function(_value){this.visibility!=et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS&&this.visibility!=et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT&&(!0===_value?this.visibility=et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE:!1===_value?this.visibility=et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE:"number"==typeof _value?this.visibility=_value:egw().debug("warn","Invalid visibility option for column: ",_value))},et2_dataview_column.ET2_COL_TYPE_DEFAULT=0,et2_dataview_column.ET2_COL_TYPE_NAME_ICON_FIXED=1,et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS=0,et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE=1,et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE=2,et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT=3,et2_dataview_column.ET2_COL_VISIBILITY_DISABLED=4,et2_dataview_column._attributes={id:{name:"ID",type:"string",description:"Unique identifier for this column. It is used to store changed column widths or visibilities."},visibility:{name:"Visibility",type:"integer",default:et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE,description:"Defines the visibility state of this column."},caption:{name:"Caption",type:"string",description:"Caption of the column as it is displayed in the select columns popup."},type:{name:"Column type",type:"integer",default:et2_dataview_column.ET2_COL_TYPE_DEFAULT,description:"Type of the column"},width:{name:"Width",type:"dimension",default:"80px",description:"Width of the column."},minWidth:{name:"Minimum width",type:"integer",default:20,description:"Minimum width of the column, in pixels.  Values below this are rejected."},maxWidth:{name:"Maximum width",type:"integer",default:0,description:"Maximum width of the column"}},et2_dataview_column}();exports.et2_dataview_column=et2_dataview_column;var et2_dataview_columns=function(){function et2_dataview_columns(_columnData){this._totalWidth=0,this._totalFixed=0,this.columnWidths=[],this.columns=new Array(_columnData.length);for(var i=0;i<_columnData.length;i++)this.columns[i]=new et2_dataview_column(_columnData[i]);this._updated=!0}return et2_dataview_columns.prototype.destroy=function(){for(var i=0;i<this.columns.length;i++)this.columns[i]=null},et2_dataview_columns.prototype.updated=function(){this._updated=!0},et2_dataview_columns.prototype.columnCount=function(){return this.columns.length},Object.defineProperty(et2_dataview_columns.prototype,"totalWidth",{get:function(){return this._totalWidth},enumerable:!0,configurable:!0}),Object.defineProperty(et2_dataview_columns.prototype,"totalFixed",{get:function(){return this._totalFixed?this._totalFixed:0},enumerable:!0,configurable:!0}),et2_dataview_columns.prototype.setTotalWidth=function(_width){_width!=this._totalWidth&&_width>0&&(this._totalWidth=_width,this._updated=!0)},et2_dataview_columns.prototype.getColumnIndexById=function(_id){for(var i=0;i<this.columns.length;i++)if(this.columns[i].id==_id)return i;return-1},et2_dataview_columns.prototype.getColumnById=function(_id){var idx=this.getColumnIndexById(_id);return-1==idx?null:this.columns[idx]},et2_dataview_columns.prototype.getColumnWidth=function(_idx){return this._totalWidth>0&&_idx>=0&&_idx<this.columns.length?(this._updated&&(this._calculateWidths(),this._updated=!1),this.columnWidths[_idx]):0},et2_dataview_columns.prototype.getColumnData=function(){for(var result=[],i=0;i<this.columns.length;i++)result.push({id:this.columns[i].id,width:this.getColumnWidth(i),visible:this.columns[i].visibility!==et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE&&this.columns[i].visibility!==et2_dataview_column.ET2_COL_VISIBILITY_DISABLED});return result},et2_dataview_columns.prototype.getColumnVisibilitySet=function(){for(var result={},i=0;i<this.columns.length;i++)this.columns[i].visibility!=et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT&&(result[this.columns[i].id]={caption:this.columns[i].caption,enabled:this.columns[i].visibility!=et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS&&this.columns[i].visibility!=et2_dataview_column.ET2_COL_VISIBILITY_DISABLED&&this.columns[i].type!=et2_dataview_column.ET2_COL_TYPE_NAME_ICON_FIXED,visible:this.columns[i].visibility!=et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE});return result},et2_dataview_columns.prototype.setColumnVisibilitySet=function(_set){for(var k in _set){var col=this.getColumnById(k);col&&col.set_visibility(_set[k].visible?et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE:et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE)}this._updated=!0},et2_dataview_columns.prototype._calculateWidths=function(){for(var _larger=Array(this.columns.length),i=0;i<this.columns.length;i++)_larger[i]=!1;var tw=this._totalWidth,totalRelative=0,fixedCount=0;this._totalFixed=0;for(i=0;i<this.columns.length;i++){(col=this.columns[i]).visibility!==et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE&&col.visibility!==et2_dataview_column.ET2_COL_VISIBILITY_DISABLED&&(col.fixedWidth>tw||col.fixedWidth<0?col.fixedWidth=!1:(col.relativeWidth>1||col.relativeWidth<0)&&(col.relativeWidth=!1),col.relativeWidth?totalRelative+=col.relativeWidth:col.fixedWidth&&(this._totalFixed+=col.fixedWidth,fixedCount++))}var usedTotal=0;this.columnWidths=[];for(i=0;i<this.columns.length;i++){var w=0;(col=this.columns[i]).visibility!=et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE&&col.visibility!==et2_dataview_column.ET2_COL_VISIBILITY_DISABLED&&(_larger[i]?w=col.maxWidth:col.fixedWidth?w=col.fixedWidth:col.relativeWidth&&(col.relativeWidth=col.relativeWidth/totalRelative,w=Math.round((tw-this._totalFixed)*col.relativeWidth)),(w>tw||col.maxWidth&&w>col.maxWidth)&&(w=Math.min(tw-usedTotal,col.maxWidth)),(w<0||w<col.minWidth)&&(w=Math.max(0,col.minWidth))),this.columnWidths.push(w),usedTotal+=w}if(usedTotal!=tw){var column,columnIndex,remaining_width=usedTotal-tw;for(columnIndex=0;columnIndex<this.columns.length;columnIndex++)if(!(this.columns[columnIndex].visibility===et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE||this.columns[columnIndex].visibility===et2_dataview_column.ET2_COL_VISIBILITY_DISABLED||this.columnWidths[columnIndex]<=0||remaining_width>0&&this.columnWidths[columnIndex]<=this.columns[columnIndex].minWidth)){if((col=this.columns[columnIndex]).relativeWidth||!col.fixedWidth){column=col;break}col.fixedWidth||(column=col)}if(column)this.columnWidths[columnIndex]=Math.max(column.minWidth,this.columnWidths[columnIndex]-remaining_width);else{var diff=Math.round(remaining_width/fixedCount);for(i=0;i<this.columns.length;i++){var col=this.columns[i],col_diff=diff<0?Math.max(remaining_width,diff):Math.min(remaining_width,diff);if(col.fixedWidth){var new_width=this.columnWidths[i]-col_diff;remaining_width-=col_diff,this.columnWidths[i]=Math.max(0,Math.min(new_width,tw))}}}}},et2_dataview_columns}();exports.et2_dataview_columns=et2_dataview_columns;
/**
 * EGroupware eTemplate2 - Class which contains the spacer container
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});var et2_dataview_spacer=function(_super){function et2_dataview_spacer(_parent,_rowProvider){var _this=_super.call(this,_parent)||this;return _this._count=0,_this._rowHeight=19,_this._avgSum=0,_this._avgCount=0,_this.spacerNode=_rowProvider.getPrototype("spacer",_this._createSpacerPrototype,_this),_this._phDiv=jQuery("td",_this.spacerNode),_this.appendNode(_this.spacerNode),_this}return __extends(et2_dataview_spacer,_super),et2_dataview_spacer.prototype.setCount=function(_count,_rowHeight){this._count=_count,void 0!==_rowHeight&&(this._rowHeight=_rowHeight),this._phDiv.height(this._count*this._rowHeight),this.invalidate()},et2_dataview_spacer.prototype.getCount=function(){return this._count},et2_dataview_spacer.prototype.getHeight=function(){return this._height=this._count*this._rowHeight,this._height},et2_dataview_spacer.prototype.getAvgHeightData=function(){return this._avgCount>0?{avgHeight:this._avgSum/this._avgCount,avgCount:this._avgCount}:null},et2_dataview_spacer.prototype.addAvgHeight=function(_height){this._avgSum+=_height,this._avgCount++},et2_dataview_spacer.prototype._createSpacerPrototype=function(_outerId,_columnIds){var tr=jQuery(document.createElement("tr"));jQuery(document.createElement("td")).addClass("egwGridView_spacer").addClass(_outerId+"_spacer_fullRow").attr("colspan",_columnIds.length).appendTo(tr);return tr},et2_dataview_spacer}(et2_dataview_container);exports.et2_dataview_spacer=et2_dataview_spacer;
/**
 * EGroupware eTemplate2 - Class which contains the "grid" base class
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 *

/*egw:uses
    /vendor/bower-asset/jquery/dist/jquery.js;
    et2_core_common;

    et2_dataview_interfaces;
    et2_dataview_view_container;
    et2_dataview_view_spacer;
*/
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});var et2_dataview_view_container_1=require("./et2_dataview_view_container"),et2_dataview_view_spacer_1=require("./et2_dataview_view_spacer"),et2_dataview_grid=function(_super_1){function et2_dataview_grid(_parent,_parentGrid,_egw,_rowProvider,_avgHeight){var _this=_super_1.call(this,_parent)||this;return null!=_parentGrid?(_this.egw=_parent.egw,_this._orgAvgHeight=!1,_this._rowProvider=_parentGrid._rowProvider):(_this.egw=_egw,_this._orgAvgHeight=_avgHeight,_this._rowProvider=_rowProvider,_this._scrollHeight=0,_this._scrollTimeout=null),_this._parentGrid=_parentGrid,_this._scrollTimeout=null,_this._invalidateTimeout=null,_this._invalidateCallback=null,_this._invalidateContext=null,_this.doInvalidate=!0,_this._map=[],_this._viewRange=et2_range(0,0),_this._total=0,_this._avgHeight=!1,_this._avgCount=-1,_this._createNodes(),_this}return __extends(et2_dataview_grid,_super_1),et2_dataview_grid.prototype.destroy=function(){this.setTotalCount(0),this._scrollTimeout&&window.clearTimeout(this._scrollTimeout),this._invalidateTimeout&&window.clearTimeout(this._invalidateTimeout),_super_1.prototype.destroy.call(this)},et2_dataview_grid.prototype.clear=function(){var oldTotalCount=this._total;this._orgAvgHeight=this.getAverageHeight(),this.setTotalCount(0),this.setTotalCount(oldTotalCount)},et2_dataview_grid.prototype.cleanup=function(){this._recalculateElementPosition();var mapVis=this._calculateVisibleMappingIndices();this._cleanupOutOfRangeElements(mapVis,0)},et2_dataview_grid.prototype.insertRow=function(_index,_container){var idx=this._calculateMapIndex(_index);if(!1!==idx){_container instanceof et2_dataview_view_container_1.et2_dataview_container&&(_container=[_container]);for(var avg=this.getAverageHeight(),i=0;i<_container.length;i++)this._doInsertContainer(_index,idx,_container[i],avg);this.invalidate()}},et2_dataview_grid.prototype.deleteRow=function(_index){var idx=this._calculateMapIndex(_index);!1!==idx&&(this._doDeleteContainer(idx,!1),this.invalidate())},et2_dataview_grid.prototype.setInvalidateCallback=function(_callback,_context){this._invalidateCallback=_callback,this._invalidateContext=_context},et2_dataview_grid.prototype.setDataCallback=function(_callback,_context){this._callback=_callback,this._context=_context},et2_dataview_grid.prototype.setTotalCount=function(_count){if(_count!==this._total){var delta=Math.max(0,_count)-this._total;delta>0?this._appendEmptyRows(delta):this._decreaseTotal(-delta),this._total=Math.max(0,_count),this.invalidate()}},et2_dataview_grid.prototype.getTotalCount=function(){return this._total},et2_dataview_grid.prototype.setViewRange=function(_range){this._viewRange=_range,this._doInvalidate()},et2_dataview_grid.prototype.getVisibleIndexRange=function(_viewRange){function getElemIdx(_elem,_px){return _elem instanceof et2_dataview_view_spacer_1.et2_dataview_spacer?_elem.getIndex()+Math.floor((_px-_elem.getTop())/this.getAverageHeight()):_elem.getIndex()}var vr,idxTop=0,idxBottom=0;vr=_viewRange||et2_bounds(this._viewRange.top+et2_dataview_grid.ET2_GRID_VIEW_EXT,this._viewRange.bottom-et2_dataview_grid.ET2_GRID_VIEW_EXT);for(var topElem=null,botElem=null,i=0;i<this._map.length;i++)if(!topElem&&this._map[i].getBottom()>vr.top&&(topElem=this._map[i]),this._map[i].getTop()>vr.bottom){botElem=this._map[i];break}return botElem||(botElem=this._map[this._map.length-1]),topElem&&(idxTop=getElemIdx.call(this,topElem,vr.top),idxBottom=getElemIdx.call(this,botElem,vr.bottom)),et2_bounds(idxTop,idxBottom)},et2_dataview_grid.prototype.getIndexRange=function(){for(var idxTop=!1,idxBottom=!1,i=0;i<this._map.length;i++)if(!(this._map[i]instanceof et2_dataview_view_spacer_1.et2_dataview_spacer)){var idx=this._map[i].getIndex();!1===idxTop&&(idxTop=idx),idxBottom=idx}return et2_bounds(idxTop,idxBottom)},et2_dataview_grid.prototype.setScrollHeight=function(_height){this._scrollHeight=_height,this.scrollarea&&this.scrollarea.height(_height),this.setViewRange(et2_range(this._viewRange.top,this._scrollHeight))},et2_dataview_grid.prototype.getAvgHeightData=function(){if(!1===this._avgHeight){for(var avgCount=0,avgSum=0,i=0;i<this._map.length;i++){var data=this._map[i].getAvgHeightData();null!==data&&(avgSum+=data.avgHeight*data.avgCount,avgCount+=data.avgCount)}avgCount>0&&avgSum>0&&(this._avgHeight=avgSum/avgCount,this._avgCount=avgCount)}return!1!==this._avgHeight?{avgCount:this._avgCount,avgHeight:this._avgHeight}:this._parent?this._parent.getAvgHeightData():!1!==this._orgAvgHeight?{avgCount:1,avgHeight:this._orgAvgHeight}:null},et2_dataview_grid.prototype.getAverageHeight=function(){var data=this.getAvgHeightData();return data?data.avgHeight:19},et2_dataview_grid.prototype.getRowProvider=function(){return this._rowProvider},et2_dataview_grid.prototype.invalidate=function(){if(this._invalidateTimeout&&window.clearTimeout(this._invalidateTimeout),this.doInvalidate){var self=this,_super=_super_1.prototype.invalidate.call(this);this._invalidateTimeout=window.setTimeout((function(){egw.debug("log","Dataview grid timed invalidate"),self._avgHeight=!1,self._avgCount=-1,self._invalidateTimeout=null,self._doInvalidate(_super)}),et2_dataview_grid.ET2_GRID_INVALIDATE_TIMEOUT)}},et2_dataview_grid.prototype.makeIndexVisible=function(_idx){var elemRange=this._getElementRange(_idx);if(!elemRange)return!1;var visibleRange=et2_bounds(this._viewRange.top+et2_dataview_grid.ET2_GRID_VIEW_EXT,this._viewRange.bottom-et2_dataview_grid.ET2_GRID_VIEW_EXT);if(visibleRange.top<elemRange.top&&visibleRange.bottom>elemRange.bottom)return!0;if(elemRange.top<visibleRange.top)this.scrollarea.scrollTop(elemRange.top);else{var h=elemRange.bottom-elemRange.top;this.scrollarea.scrollTop(elemRange.top-this._scrollHeight+h)}},et2_dataview_grid.prototype._getElementRange=function(_idx){this._recalculateElementPosition();var mapIdx=this._calculateMapIndex(_idx);if(!1===mapIdx)return!1;var elem=this._map[mapIdx];if(elem instanceof et2_dataview_view_spacer_1.et2_dataview_spacer){var avg=this.getAverageHeight();return et2_range(elem.getTop()+avg*(elem.getIndex()-_idx),avg)}return elem.getRange()},et2_dataview_grid.prototype._recalculateElementPosition=function(){for(var i=0;i<this._map.length;i++)0==i?this._map[i].setTop(0):this._map[i].setTop(this._map[i-1].getBottom())},et2_dataview_grid.prototype._calculateVisibleMappingIndices=function(){for(var mapVis={top:-1,bottom:-1},i=0;i<this._map.length;i++)if(-1===mapVis.top&&this._map[i].getBottom()>this._viewRange.top&&(mapVis.top=i),-1===mapVis.bottom&&this._map[i].getTop()>this._viewRange.bottom){mapVis.bottom=i;break}return mapVis},et2_dataview_grid.prototype._cleanupOutOfRangeElements=function(_mapVis,_holdCount){function searchElements(_arr,_start,_stop,_dir){for(var dist=0,i_1=_start;_dir>0?i_1<=_stop:i_1>=_stop;i_1+=_dir)dist>_holdCount?_arr.push(i_1):dist+=this._map[i_1].getCount()}_holdCount=void 0===_holdCount?et2_dataview_grid.ET2_GRID_HOLD_COUNT:_holdCount;var deleteTop=[],deleteBottom=[];-1!==_mapVis.top&&searchElements.call(this,deleteTop,_mapVis.top,0,-1),-1!==_mapVis.bottom&&searchElements.call(this,deleteBottom,_mapVis.bottom,this._map.length-1,1);for(var offs=0,i=deleteTop.length-1;i>=0;i--){var mapLength=this._map.length;this._doDeleteContainer(deleteTop[i]-offs,!0),offs+=mapLength-this._map.length}for(i=deleteBottom.length-1;i>=0;i--)this._doDeleteContainer(deleteBottom[i]-offs,!0);return deleteBottom.length+deleteTop.length>0},et2_dataview_grid.prototype._updateContainers=function(){for(var _loop_1=function(i){var container=this_1._map[i],isSpacer=container instanceof et2_dataview_view_spacer_1.et2_dataview_spacer,hasIViewRange=!isSpacer&&implements_et2_dataview_IViewRange(container);if(isSpacer||hasIViewRange){var elemRange=container.getRange();if(!et2_rangeIntersect(this_1._viewRange,elemRange))return"continue";if(hasIViewRange)container.setViewRange(et2_bounds(this_1._viewRange.top-elemRange.top,this_1._viewRange.bottom-elemRange.top));else{var avg=container._rowHeight,vcr_top=Math.max(this_1._viewRange.top,elemRange.top),vcr_bot=Math.min(this_1._viewRange.bottom,elemRange.bottom),cidx=container.getIndex(),ccnt=container.getCount(),vtop=Math.max(0,vcr_top),idxStart_1=Math.floor(Math.min(cidx+ccnt-1,cidx+(vtop-elemRange.top)/avg,this_1._total)),vbot=Math.max(0,vcr_bot),idxEnd_1=Math.ceil(Math.min(cidx+ccnt-1,cidx+(vbot-elemRange.top)/avg,this_1._total));if(isNaN(idxStart_1)&&isSpacer&&(idxStart_1=cidx-1),isNaN(idxEnd_1)&&isSpacer&&this_1._scrollHeight>0&&0==elemRange.bottom&&(idxEnd_1=Math.min(ccnt,cidx+Math.ceil((this_1._viewRange.bottom-container._top)/(this_1._orgAvgHeight||0)))),this_1._callback){var self_1=this_1;egw.debug("log","Dataview grid flag for update: ",{start:idxStart_1,end:idxEnd_1}),window.setTimeout((function(){void 0!==self_1._callback&&self_1._callback.call(self_1._context,idxStart_1,idxEnd_1)}),0)}}}},this_1=this,i=0;i<this._map.length;i++)_loop_1(i)},et2_dataview_grid.prototype._doInvalidate=function(_super){if(this.doInvalidate&&0!=jQuery(":visible",this.outerCell).length){if(this._recalculateElementPosition(),this._invalidateCallback){var range=this.getVisibleIndexRange(et2_range(this.scrollarea.scrollTop(),this._scrollHeight));this._invalidateCallback.call(this._invalidateContext,range)}var mapVis=this._calculateVisibleMappingIndices();this._cleanupOutOfRangeElements(mapVis)&&this._recalculateElementPosition(),this._updateContainers(),this._parent&&_super&&_super._doInvalidate()}},et2_dataview_grid.prototype._calculateMapIndex=function(_index){for(var top=0,bot=this._map.length-1;top<=bot;){var idx=Math.floor((top+bot)/2),elem=this._map[idx],realIdx=elem.getIndex(),realCnt=elem.getCount();if(_index>=realIdx&&_index<realIdx+realCnt)return idx;_index<realIdx?bot=idx-1:top=idx+1}return!1},et2_dataview_grid.prototype._insertContainerAtSpacer=function(_index,_mapIndex,_mapElem,_container,_avg){_container.setIndex(_index);var splitIdx=_index-_mapElem.getIndex(),cntTop=splitIdx,cntBottom=_mapElem.getCount()-splitIdx-1;if(cntTop>0&&cntBottom>0){_mapElem.setCount(cntTop),_container.insertIntoTree(_mapElem.getLastNode());var newSpacer=new et2_dataview_view_spacer_1.et2_dataview_spacer(this,this._rowProvider);newSpacer.setCount(cntBottom,_avg),newSpacer.setIndex(_index+1),newSpacer.insertIntoTree(_container.getLastNode()),this._map.splice(_mapIndex+1,0,_container,newSpacer)}else 0===cntTop&&cntBottom>0?(_container.insertIntoTree(_mapElem.getFirstNode(),!0),_mapElem.setIndex(_index+1),_mapElem.setCount(cntBottom,_avg),this._map.splice(_mapIndex,0,_container)):cntTop>0&&0===cntBottom?(_container.insertIntoTree(_mapElem.getLastNode()),_mapElem.setCount(cntTop),this._map.splice(_mapIndex+1,0,_container)):(_container.insertIntoTree(_mapElem.getLastNode()),_mapElem.destroy(),this._map.splice(_mapIndex,1,_container))},et2_dataview_grid.prototype._insertContainerAtElement=function(_index,_mapIndex,_mapElem,_container,_avg){_container.setIndex(_index),_container.insertIntoTree(_mapElem.getFirstNode(),!0),this._map.splice(_mapIndex,0,_container);for(var _newIndex=_index+1,i=_mapIndex+1;i<this._map.length;i++)if(this._map[i].setIndex(_newIndex++),this._map[i]instanceof et2_dataview_view_spacer_1.et2_dataview_spacer)return void this._decrementSpacerCount(i,_avg);this._map.pop().destroy()},et2_dataview_grid.prototype._doInsertContainer=function(_index,_mapIndex,_container,_avg){var mapElem=this._map[_mapIndex];mapElem instanceof et2_dataview_view_spacer_1.et2_dataview_spacer?this._insertContainerAtSpacer(_index,_mapIndex,mapElem,_container,_avg):this._insertContainerAtElement(_index,_mapIndex,mapElem,_container,_avg)},et2_dataview_grid.prototype._replaceContainerWithSpacer=function(_mapIndex,_mapElem){var newAvg,spacer,totalCount,spacerAbove=null,spacerBelow=null;_mapIndex>0&&this._map[_mapIndex-1]instanceof et2_dataview_view_spacer_1.et2_dataview_spacer&&(spacerAbove=this._map[_mapIndex-1]),_mapIndex<this._map.length-1&&this._map[_mapIndex+1]instanceof et2_dataview_view_spacer_1.et2_dataview_spacer&&(spacerBelow=this._map[_mapIndex+1]),spacerAbove||spacerBelow?spacerAbove&&spacerBelow?(newAvg=(spacerAbove.getHeight()+spacerBelow.getHeight()+_mapElem.getHeight())/(totalCount=spacerAbove.getCount()+spacerBelow.getCount()+1),spacerAbove.addAvgHeight(_mapElem.getHeight()),spacerAbove.setCount(totalCount,newAvg),spacerBelow.destroy(),this._map.splice(_mapIndex+1,1)):(totalCount=(spacer=spacerAbove||spacerBelow).getCount()+1,newAvg=(spacer.getHeight()+_mapElem.getHeight())/totalCount,spacer.setIndex(Math.min(spacer.getIndex(),_mapElem.getIndex())),spacer.addAvgHeight(_mapElem.getHeight()),spacer.setCount(totalCount,newAvg)):((spacer=new et2_dataview_view_spacer_1.et2_dataview_spacer(this,this._rowProvider)).setIndex(_mapElem.getIndex()),spacer.addAvgHeight(_mapElem.getHeight()),spacer.setCount(1,_mapElem.getHeight()),spacer.insertIntoTree(_mapElem.getLastNode()),this._map.splice(_mapIndex+1,0,spacer))},et2_dataview_grid.prototype._consolidateSpacers=function(_mapIndex){if(_mapIndex<this._map.length-1&&this._map[_mapIndex]instanceof et2_dataview_view_spacer_1.et2_dataview_spacer&&this._map[_mapIndex+1]instanceof et2_dataview_view_spacer_1.et2_dataview_spacer){var spacerAbove=this._map[_mapIndex],spacerBelow=this._map[_mapIndex+1],totalHeight=spacerAbove.getHeight()+spacerBelow.getHeight(),totalCount=spacerAbove.getCount()+spacerBelow.getCount(),newAvg=totalCount/totalHeight;spacerAbove.setCount(totalCount,newAvg),spacerBelow.destroy(),this._map.splice(_mapIndex+1,1)}},et2_dataview_grid.prototype._decrementSpacerCount=function(_mapIndex,_avg){var cnt=this._map[_mapIndex].getCount()-1;cnt>0?this._map[_mapIndex].setCount(cnt,_avg):(this._map[_mapIndex].destroy(),this._map.splice(_mapIndex,1))},et2_dataview_grid.prototype._doDeleteContainer=function(_mapIndex,_replaceWithSpacer){_replaceWithSpacer=_replaceWithSpacer||!1;var mapElem=this._map[_mapIndex],removedElement=!1;if(mapElem instanceof et2_dataview_view_spacer_1.et2_dataview_spacer?_replaceWithSpacer||(this._decrementSpacerCount(_mapIndex),removedElement=!0):(_replaceWithSpacer?this._replaceContainerWithSpacer(_mapIndex,mapElem):removedElement=!0,this._map[_mapIndex].destroy(),this._map.splice(_mapIndex,1),_mapIndex--,this._consolidateSpacers(_mapIndex)),removedElement){for(var i=_mapIndex+1;i<this._map.length;i++)this._map[i].setIndex(this._map[i].getIndex()-1);this._appendEmptyRows(1)}},et2_dataview_grid.prototype._appendEmptyRows=function(_count){var spacer=null,lastIndex=this._map.length-1;if(0!==this._map.length&&this._map[lastIndex]instanceof et2_dataview_view_spacer_1.et2_dataview_spacer)spacer=this._map[lastIndex];else{if(spacer=new et2_dataview_view_spacer_1.et2_dataview_spacer(this,this._rowProvider),0===this._map.length){var dummy=jQuery(document.createElement("tr"));this.innerTbody.append(dummy),spacer.setIndex(0),spacer.insertIntoTree(dummy,!1),dummy.remove()}else spacer.setIndex(this._map[lastIndex].getIndex()+1),spacer.insertIntoTree(this._map[lastIndex].getLastNode());this._map.push(spacer)}spacer.setCount(_count+spacer.getCount(),this.getAverageHeight())},et2_dataview_grid.prototype._decreaseTotal=function(_delta){for(;_delta>0&&this._map.length>0;){var cont=this._map[this._map.length-1];if(cont instanceof et2_dataview_view_spacer_1.et2_dataview_spacer){var diff=cont.getCount()-_delta;if(diff>0){_delta=0,cont.setCount(diff,this.getAverageHeight());break}_delta-=diff+_delta}else _delta-=1;cont.destroy(),this._map.pop()}_delta>0&&this.egw.debug("error","Error while decreasing the total count - requested to remove more rows than available.")},et2_dataview_grid.prototype._createNodes=function(){this.tr=jQuery(document.createElement("tr")),this.outerCell=jQuery(document.createElement("td")).addClass("frame").attr("colspan",this._rowProvider.getColumnCount()+(this._parentGrid?0:1)).appendTo(this.tr),this.scrollarea=null,null==this._parentGrid&&(this.scrollarea=jQuery(document.createElement("div")).addClass("egwGridView_scrollarea").scroll(this,(function(e){e.data._scrollTimeout&&window.clearTimeout(e.data._scrollTimeout),e.data._invalidateTimeout&&(window.clearTimeout(e.data._invalidateTimeout),e.data._invalidateTimeout=null),e.data._scrollTimeout=window.setTimeout(jQuery.proxy((function(){var newRange=et2_range(this.scrollarea.scrollTop()-et2_dataview_grid.ET2_GRID_VIEW_EXT,this._scrollHeight+2*et2_dataview_grid.ET2_GRID_VIEW_EXT);et2_rangeEqual(newRange,this._viewRange)||this.setViewRange(newRange)}),e.data),et2_dataview_grid.ET2_GRID_SCROLL_TIMEOUT)})).height(this._scrollHeight).appendTo(this.outerCell));var table=jQuery(document.createElement("table")).addClass("egwGridView_grid").appendTo(this.scrollarea?this.scrollarea:this.outerCell);this.innerTbody=jQuery(document.createElement("tbody")).appendTo(table),this.appendNode(jQuery(this.tr[0]))},et2_dataview_grid.ET2_GRID_VIEW_EXT=50,et2_dataview_grid.ET2_GRID_SCROLL_TIMEOUT=50,et2_dataview_grid.ET2_GRID_INVALIDATE_TIMEOUT=25,et2_dataview_grid.ET2_GRID_HOLD_COUNT=50,et2_dataview_grid}(et2_dataview_view_container_1.et2_dataview_container);exports.et2_dataview_grid=et2_dataview_grid,
/**
 * EGroupware eTemplate2 - Functions which allow resizing of table headers
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 */
Object.defineProperty(exports,"__esModule",{value:!0});var et2_dataview_view_resizable=function(){function et2_dataview_view_resizable(){}return et2_dataview_view_resizable.inResizeRegion=function(_x,_elem){return _x-_elem.offset().left>_elem.outerWidth(!0)-et2_dataview_view_resizable.RESIZE_BORDER},et2_dataview_view_resizable.startResize=function(_outerElem,_elem,_callback,_column){if(null==this.overlay||null==this.helper){void 0!==_elem[0].style.MozUserSelect?_elem[0].style.MozUserSelect="none":_elem[0].onselectstart=function(){return!1},jQuery(_outerElem).addClass("egwResizing"),this.didResize=!1;var left=_elem.offset().left;this.helper=jQuery(document.createElement("div")).addClass("egwResizeHelper").appendTo("body").css("top",_elem.offset().top+"px").css("left",left+"px").css("height",_outerElem.outerHeight(!0)+"px"),this.overlay=jQuery(document.createElement("div")).addClass("egwResizeOverlay").bind("mousemove",function(e){this.didResize=!0,this.resizeWidth=Math.max(e.pageX-left+et2_dataview_view_resizable.RESIZE_ADD,_column&&_column.minWidth?_column.minWidth:et2_dataview_view_resizable.RESIZE_MIN_WIDTH),this.helper.css("width",this.resizeWidth+"px")}.bind(this)).bind("mouseup",function(){this.stopResize(_outerElem),_elem[0].onselectstart=null,this.didResize&&_callback(this.resizeWidth)}.bind(this)).appendTo("body")}},et2_dataview_view_resizable.stopResize=function(_outerElem){jQuery(_outerElem).removeClass("egwResizing"),null!=this.helper&&(this.helper.remove(),this.helper=null),null!=this.overlay&&(this.overlay.remove(),this.overlay=null)},et2_dataview_view_resizable.RESIZE_BORDER=12,et2_dataview_view_resizable.RESIZE_MIN_WIDTH=25,et2_dataview_view_resizable.RESIZE_ADD=2,et2_dataview_view_resizable.helper=null,et2_dataview_view_resizable.overlay=null,et2_dataview_view_resizable.didResize=!1,et2_dataview_view_resizable.resizeWidth=0,et2_dataview_view_resizable.makeResizeable=function(_elem,_callback,_context){var outerTable=_elem.closest("table");_elem.bind("mousemove.resize",(function(e){var stopResize=!1;e.target.clientHeight<e.target.scrollHeight&&e.target.offsetWidth-e.offsetX<=8&&(stopResize=!0),_elem.css("cursor",et2_dataview_view_resizable.inResizeRegion(e.pageX,_elem)&&!stopResize?"ew-resize":"auto")})),_elem.bind("mousedown.resize",(function(e){var stopResize=!1;e.target.clientHeight<e.target.scrollHeight&&e.target.offsetWidth-e.offsetX<=8&&(stopResize=!0),et2_dataview_view_resizable.inResizeRegion(e.pageX,_elem)&&"SELECT"!=e.target.tagName&&!stopResize&&et2_dataview_view_resizable.startResize(outerTable,_elem,(function(_w){_callback.call(_context,_w)}),_context)})),_elem.dblclick((function(e){if(_context&&_context.relativeWidth)return egw.message(egw.lang("You tried to automatically size a flex column, which always takes the rest of the space","info"));for(var col_class="",i=0;i<this.classList.length;i++)if(0===this.classList[i].indexOf("gridCont")){col_class=this.classList[i];break}var column=jQuery(this);column.children().css("width","auto");var max_width=column.children().children().innerWidth(),padding=column.outerWidth(!0)-max_width,resize=jQuery(this).closest(".egwGridView_outer").find("tbody td."+col_class+"> div:first-child").add(column.children()).css("width","auto");resize.children().css({"white-space":"nowrap"}).each((function(){var col=jQuery(this),children=col.find("span:visible, time:visible, label:visible").css({"white-space":"nowrap"});this.offsetWidth,children.each((function(){var child=jQuery(this);this.offsetWidth,child.outerWidth()>max_width&&(max_width=child.outerWidth()),window.getComputedStyle(this).width})),this.offsetWidth,col.innerWidth()>max_width&&(max_width=col.innerWidth()),children.css("white-space",""),children.css("display","")})).css({"white-space":""}),column.children().css("width",""),resize.css("width",""),_callback.call(_context,max_width+padding)}))},et2_dataview_view_resizable.et2_dataview_resetResizeable=function(_elem){_elem.unbind(".resize")},et2_dataview_view_resizable}();exports.et2_dataview_view_resizable=et2_dataview_view_resizable,
/**
 * EGroupware eTemplate2 - dataview code
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage dataview
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011-2012
 * @version $Id$
 *

/*egw:uses
    /vendor/bower-asset/jquery/dist/jquery.js;
    et2_core_common;

    et2_dataview_model_columns;
    et2_dataview_view_grid;
    et2_dataview_view_rowProvider;
    et2_dataview_view_resizeable;
*/
Object.defineProperty(exports,"__esModule",{value:!0});et2_dataview_model_columns_1=require("./et2_dataview_model_columns");var et2_dataview_view_resizeable_1=require("./et2_dataview_view_resizeable"),et2_dataview_view_grid_1=require("./et2_dataview_view_grid"),et2_dataview_view_rowProvider_1=require("./et2_dataview_view_rowProvider"),et2_dataview=function(){function et2_dataview(_parentNode,_egw){this.parentNode=jQuery(_parentNode),this.egw=_egw,this.columnNodes=[],this.columns=[],this.columnMgr=null,this.rowProvider=null,this.width=0,this.height=0,this.uniqueId="gridCont_"+this.egw.uid(),this._createElements(),this._getDepVars()}return et2_dataview.prototype.destroy=function(){this._clearHeader(),this.grid&&this.grid.destroy(),this.rowProvider&&this.rowProvider.destroy(),this.table.remove()},et2_dataview.prototype.clear=function(){this.grid&&this.grid.clear()},et2_dataview.prototype.getHeaderContainerNode=function(_columnIdx){return void 0!==this.columnNodes[_columnIdx]?this.columnNodes[_columnIdx].container[0]:null},et2_dataview.prototype.setColumns=function(_columnData){this._clearHeader(),this.columnMgr=new et2_dataview_model_columns_1.et2_dataview_columns(_columnData),this.updateColumns(),this._buildHeader(),this._buildGrid()},et2_dataview.prototype.resize=function(_w,_h){this.columnMgr&&(this.width!=_w&&(this.width=_w,_w-=this.table.outerWidth(!0)-this.table.innerWidth(),_w-=this.thead.find("tr").outerWidth()-this.thead.find("tr").innerWidth(),this.columnMgr.setTotalWidth(_w-this.scrollbarWidth),this._updateColumns()),this.height!=_h&&(this.height=_h,this.grid&&this.grid.setScrollHeight(this.height-this.headTr.outerHeight(!0))))},et2_dataview.prototype.getColumnMgr=function(){return this.columnMgr},et2_dataview.prototype.updateColumns=function(setDefault){void 0===setDefault&&(setDefault=!1),this.columnMgr&&this._updateColumns(),this.onUpdateColumns&&this.onUpdateColumns(setDefault)},et2_dataview.prototype._createElements=function(){this.containerTr=jQuery(document.createElement("tr")),this.headTr=jQuery(document.createElement("tr")),this.thead=jQuery(document.createElement("thead")).append(this.headTr),this.tbody=jQuery(document.createElement("tbody")).append(this.containerTr),this.table=jQuery(document.createElement("table")).addClass("egwGridView_outer").append(this.thead,this.tbody).appendTo(this.parentNode)},et2_dataview.prototype._clearHeader=function(){this.columnMgr&&(this.columnMgr.destroy(),this.columnMgr=null);for(var i=0;i<this.columns.length;i++)this.columns[i].tdClass&&this.egw.css("."+this.columns[i].tdClass),this.columns[i].divClass&&(this.egw.css("."+this.columns[i].divClass),this.egw.css(".egwGridView_outer ."+this.columns[i].divClass),this.egw.css(".egwGridView_grid ."+this.columns[i].divClass));this.egw.css(".egwGridView_grid ."+this.uniqueId+"_div_fullRow"),this.egw.css(".egwGridView_outer ."+this.uniqueId+"_td_fullRow"),this.egw.css(".egwGridView_outer ."+this.uniqueId+"_spacer_fullRow"),this.columnNodes=[],this.columns=[],this.headTr.empty()},et2_dataview.prototype._updateColumns=function(){this.columns=this.columnMgr.getColumnData();for(var total_cnt=0,i=0;i<this.columns.length;i++)this.columns[i].visible&&total_cnt++;var vis_col=this.visibleColumnCount=0,totalWidth=0;for(i=0;i<this.columns.length;i++){var col=this.columns[i];if(col.tdClass=this.uniqueId+"_td_"+col.id,col.divClass=this.uniqueId+"_div_"+col.id,col.visible){vis_col++,this.visibleColumnCount++,this.egw.css("."+col.tdClass,"display: table-cell; !important;");var subBorder=0;vis_col==total_cnt&&(subBorder+=1);var headerWidth=Math.max(0,col.width-this.headerBorderWidth-0);this.egw.css(".egwGridView_outer ."+col.divClass,"width: "+headerWidth+"px;");var columnWidth=Math.max(0,col.width-this.columnBorderWidth-subBorder);this.egw.css(".egwGridView_grid ."+col.divClass,"width: "+columnWidth+"px;"),totalWidth+=col.width,!1}else this.egw.css("."+col.tdClass,"display: none;")}this.egw.css(".egwGridView_grid ."+this.uniqueId+"_div_fullRow","width: "+(totalWidth-this.columnBorderWidth-2)+"px; border-right-width: 0 !important;"),this.egw.css(".egwGridView_outer ."+this.uniqueId+"_td_fullRow","border-right-width: 0 !important;"),this.egw.css(".egwGridView_outer ."+this.uniqueId+"_spacer_fullRow","width: "+(totalWidth-1)+"px; border-right-width: 0 !important;")},et2_dataview.prototype._buildHeader=function(){for(var self=this,i=0;i<this.columns.length;i++){var col=this.columns[i],cont=jQuery(document.createElement("div")).addClass("innerContainer").addClass(col.divClass),column=jQuery(document.createElement("th")).addClass(col.tdClass).attr("align","left").append(cont).appendTo(this.headTr);this.columnMgr&&this.columnMgr.getColumnById(i)&&(column.addClass(this.columnMgr.getColumnById(i).fixedWidth?"fixedWidth":"relativeWidth"),this.columnMgr.getColumnById(i).visibility===et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT&&column.addClass("noResize"));var enc_column=self.columnMgr.getColumnById(col.id);enc_column.visibility!==et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT&&et2_dataview_view_resizeable_1.et2_dataview_view_resizable.makeResizeable(column,(function(_w){if(this.relativeWidth){this.set_width(_w+"px"),self.columnMgr.updated(),self.columnMgr.getColumnWidth(0);var relative=self.columnMgr.totalWidth-self.columnMgr.totalFixed+_w;this.set_width(_w/relative);for(var i=0;i<self.columnMgr.columnCount();i++){var col=self.columnMgr.getColumnById("col_"+i);col&&col!=this&&!col.fixedWidth&&col.set_width(self.columnMgr.getColumnWidth(i)/relative)}self.updateColumns()}else this.set_width(this.relativeWidth?_w/self.columnMgr.totalWidth:_w+"px"),self.columnMgr.updated(),self.updateColumns()}),enc_column),this.columnNodes.push({column:column,container:cont})}this._buildSelectCol()},et2_dataview.prototype._buildSelectCol=function(){this.selectColIcon=jQuery(document.createElement("span")).addClass("selectcols").css("display","inline-block"),this.selectCol=jQuery(document.createElement("th")).addClass("optcol").append(this.selectColIcon).click(this,(function(e){e.data.selectColumnsClick&&e.data.selectColumnsClick(e)})).appendTo(this.headTr),this.selectCol.css("width",this.scrollbarWidth-this.selectCol.outerWidth()+this.selectCol.width()+1)},et2_dataview.prototype._buildGrid=function(){for(var colIds=[],i=0;i<this.columns.length;i++)this.columns[i].visible&&(colIds[i]=this.columns[i].id);this.rowProvider&&this.rowProvider.destroy(),this.rowProvider=new et2_dataview_view_rowProvider_1.et2_dataview_rowProvider(this.uniqueId,colIds),this.grid=new et2_dataview_view_grid_1.et2_dataview_grid(null,null,this.egw,this.rowProvider,19);var tr=jQuery(this.grid.getFirstNode());this.containerTr.replaceWith(tr),this.containerTr=tr},et2_dataview.prototype._getDepVars=function(){if(void 0===this.scrollbarWidth){var clone=this.table.clone();jQuery(egw.top.document.getElementsByTagName("body")[0]).append(clone),this.scrollbarWidth=this.constructor.prototype.scrollbarWidth=this._getScrollbarWidth(clone),this.headerBorderWidth=this.constructor.prototype.headerBorderWidth=this._getHeaderBorderWidth(clone),this.columnBorderWidth=this.constructor.prototype.columnBorderWidth=this._getColumnBorderWidth(clone),clone.remove()}},et2_dataview.prototype._getScrollbarWidth=function(_table){var div_inner=jQuery(document.createElement("div")).css("height","1000px"),div_outer=jQuery(document.createElement("div")).css("height","100px").css("width","100px").css("overflow","auto").append(div_inner),td=jQuery(document.createElement("td")).append(div_outer);jQuery("tbody tr",_table).append(td);var width=Math.max(10,div_outer.outerWidth()-div_inner.outerWidth());return div_outer.remove(),width},et2_dataview.prototype._getHeaderBorderWidth=function(_table){var cont=jQuery(document.createElement("div")).addClass("innerContainer"),th=jQuery(document.createElement("th")).append(cont);jQuery("thead tr",_table).append(th);var width=th.outerWidth(!0)-cont.width();return th.remove(),width},et2_dataview.prototype._getColumnBorderWidth=function(_table){var cont=jQuery(document.createElement("div")).addClass("innerContainer"),td=jQuery(document.createElement("td")).append(cont);jQuery("tbody tr",_table).append(td),_table.addClass("egwGridView_grid");var width=td.outerWidth(!0)-cont.width();return td.remove(),width},et2_dataview}();exports.et2_dataview=et2_dataview;
/**
 * EGroupware eTemplate2 - JS Nextmatch object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 *

/*egw:uses

    // Include the action system
    egw_action.egw_action;
    egw_action.egw_action_popup;
    egw_action.egw_action_dragdrop;
    egw_action.egw_menu_dhtmlx;

    // Include some core classes
    et2_core_widget;
    et2_core_interfaces;
    et2_core_DOMWidget;

    // Include all widgets the nextmatch extension will create
    et2_widget_template;
    et2_widget_grid;
    et2_widget_selectbox;
    et2_widget_selectAccount;
    et2_widget_taglist;
    et2_extension_customfields;

    // Include all nextmatch subclasses
    et2_extension_nextmatch_rowProvider;
    et2_extension_nextmatch_controller;
    et2_widget_dynheight;

    // Include the grid classes
    et2_dataview;

*/
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0}),require("./et2_core_common"),require("./et2_core_interfaces");et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget"),et2_core_DOMWidget_1=require("./et2_core_DOMWidget"),et2_core_baseWidget_1=require("./et2_core_baseWidget"),et2_core_inputWidget_1=require("./et2_core_inputWidget"),et2_widget_selectbox_1=require("./et2_widget_selectbox");var et2_extension_nextmatch_rowProvider_1=require("./et2_extension_nextmatch_rowProvider"),et2_extension_nextmatch_controller_1=require("./et2_extension_nextmatch_controller"),et2_dataview_1=require("./et2_dataview"),et2_extension_customfields_1=(et2_dataview_model_columns_1=require("./et2_dataview_model_columns"),require("./et2_extension_customfields")),et2_widget_grid_1=(et2_widget_link_1=require("./et2_widget_link"),et2_widget_dialog_1=require("./et2_widget_dialog"),require("./et2_widget_grid")),et2_widget_taglist_1=(et2_dataview_view_grid_1=require("./et2_dataview_view_grid"),require("./et2_widget_taglist")),et2_widget_selectAccount_1=require("./et2_widget_selectAccount"),et2_widget_dynheight_1=require("./et2_widget_dynheight"),et2_INextmatchHeader=(et2_core_arrayMgr_1=require("./et2_core_arrayMgr"),"et2_INextmatchHeader");function implements_et2_INextmatchHeader(obj){return implements_methods(obj,["setNextmatch"])}var et2_INextmatchSortable="et2_INextmatchSortable";function implements_et2_INextmatchSortable(obj){return implements_methods(obj,["setSortmode"])}var et2_nextmatch=function(_super){function et2_nextmatch(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_nextmatch._attributes,_child||{}))||this;_this._queued_refreshes=[],_this.print={old_height:0,row_selector:"",orientation_style:null},_this.activeFilters={col_filter:{}},_this.columns=[],_this.sortedColumnsList=[],jQuery.extend(_this.activeFilters.col_filter,_this.options.settings.col_filter);for(var prefs=_this._getPreferences(),cfs={},i=0;i<prefs.visible.length;i++)0==prefs.visible[i].indexOf(et2_nextmatch_customfields.PREFIX)&&(cfs[prefs.visible[i].substr(1)]=!prefs.negated);var global_data=_this.getArrayMgr("modifications").getRoot().getEntry("~custom_fields~");return"object"==typeof global_data&&null!=global_data&&(global_data.fields=cfs),_this.div=jQuery(document.createElement("div")).addClass("et2_nextmatch"),_this.header=et2_core_widget_1.et2_createWidget("nextmatch_header_bar",{},_this),_this.innerDiv=jQuery(document.createElement("div")).appendTo(_this.div),_this.dynheight=_this._getDynheight(),_this.dataview=new et2_dataview_1.et2_dataview(_this.innerDiv,_this.egw()),_this.blank=jQuery(document.createElement("div")).appendTo(_this.dataview.table),_this.controller=null,_this.rowProvider=null,_this}return __extends(et2_nextmatch,_super),et2_nextmatch.prototype.destroy=function(){this._autorefresh_timer&&(window.clearInterval(this._autorefresh_timer),this._autorefresh_timer=null),jQuery(this.getInstanceManager().DOMContainer.parentNode).off("show.et2_nextmatch"),jQuery(this.getInstanceManager().DOMContainer.parentNode).off("hide.et2_nextmatch"),this.dataview.destroy(),this.rowProvider&&this.rowProvider.destroy(),this.controller&&this.controller.destroy(),this.dynheight.destroy(),_super.prototype.destroy.call(this)},et2_nextmatch.prototype.getController=function(){return this.controller},et2_nextmatch.prototype.transformAttributes=function(_attrs){if(_super.prototype.transformAttributes.call(this,_attrs),this.id){var entry=this.getArrayMgr("content").data;if(_attrs.settings={},entry)for(var attr in _attrs.settings=entry,_attrs.settings.actions&&!_attrs.settings.action_var&&(_attrs.settings.action_var="action"),this.attributes)_attrs.settings[attr]&&(_attrs[attr]=_attrs.settings[attr],delete _attrs.settings[attr])}},et2_nextmatch.prototype.doLoadingFinished=function(){if(_super.prototype.doLoadingFinished.call(this),this.dynheight||(this.dynheight=this._getDynheight()),this.options.settings.row_id){var appname=this.options.template.split(".")[0];if(this.egw().link_get_registry(appname)){var self_1=this;jQuery(this.div).on("dragenter",".egwGridView_grid tr",(function(e){var row=self_1.controller.getRowByNode(this);return!(!row||!row.uid)&&(e.stopPropagation(),e.preventDefault(),row.controller&&row.controller._selectionMgr&&row.controller._selectionMgr.setFocused(row.uid,!0),!1)})).on("dragexit",".egwGridView_grid tr",(function(){self_1.controller._selectionMgr.setFocused()})).on("dragover",".egwGridView_grid tr",!1).attr("dropzone","copy").on("drop",".egwGridView_grid tr",(function(e){return self_1.handle_drop(e,this),!1}))}}return jQuery(this.getInstanceManager().DOMContainer.parentNode).on("hide.et2_nextmatch",jQuery.proxy((function(){this.controller&&this.controller._grid&&(this.controller._grid.doInvalidate=!1)}),this)),jQuery(this.getInstanceManager().DOMContainer.parentNode).on("show.et2_nextmatch",jQuery.proxy((function(){this.controller&&this.controller._grid&&(this.controller._grid.doInvalidate=!0)}),this)),!0},et2_nextmatch.prototype.resize=function(){this.dynheight&&this.dynheight.update((function(_w,_h){this.dataview.resize(_w,_h)}),this)},et2_nextmatch.prototype.sortBy=function(_id,_asc,_update){void 0===_update&&(_update=!0),void 0===this.activeFilters.sort&&(this.activeFilters.sort={id:null,asc:!0}),void 0===_asc&&(_asc=!0,this.activeFilters.sort.id==_id&&(_asc=!this.activeFilters.sort.asc)),this.iterateOver((function(_widget){_widget.setSortmode(_widget.id==_id?_asc?"asc":"desc":"none")}),this,et2_INextmatchSortable),_update?this.applyFilters({sort:{id:_id,asc:_asc}}):this.activeFilters.sort={id:_id,asc:_asc}},et2_nextmatch.prototype.resetSort=function(){void 0!==this.activeFilters.sort&&(this.iterateOver((function(_widget){_widget.setSortmode("none")}),this,et2_INextmatchSortable),this.applyFilters({sort:void 0}))},et2_nextmatch.prototype.applyFilters=function(_set){var changed=!1,keep_selection=!1;if(!this.update_in_progress){if(this.update_in_progress=!0,void 0!==_set&&jQuery.isEmptyObject(_set)&&(changed=!0,this.activeFilters={col_filter:{}}),void 0===this.activeFilters&&(this.activeFilters={col_filter:{}}),void 0===this.activeFilters.col_filter&&(this.activeFilters.col_filter={}),"object"==typeof _set)for(var s in _set)if("col_filter"==s)if(void 0===_set.col_filter||null===_set.col_filter)this.activeFilters.col_filter={},changed=!0;else for(var c in _set.col_filter)this.activeFilters.col_filter[c]!==_set.col_filter[c]&&(_set.col_filter[c]?this.activeFilters.col_filter[c]=_set.col_filter[c]:delete this.activeFilters.col_filter[c],changed=!0);else if("selected"===s){for(var i in changed=!0,keep_selection=!0,this.controller._selectionMgr.resetSelection(),this.controller._objectManager.clear(),_set.selected)this.controller._selectionMgr.setSelected(_set.selected[i].indexOf("::")>0?_set.selected[i]:this.controller.dataStorePrefix+"::"+_set.selected[i],!0);delete _set.selected}else this.activeFilters[s]!==_set[s]&&(this.activeFilters[s]=_set[s],changed=!0);if(this.egw().debug("info","Changing nextmatch filters to ",this.activeFilters),!changed||keep_selection||(this.controller._selectionMgr.resetSelection(),this.controller._objectManager.clear()),this.controller.keepSelection(),this.controller.setFilters(this.activeFilters),this.header.setFilters(this.activeFilters),this.iterateOver((function(column){void 0!==column.id&&0==column.id.indexOf("favorite")||(void 0!==column.set_value&&column.id&&column.set_value(void 0===this[column.id]||null==this[column.id]?"":this[column.id]),column.id&&"function"==typeof column.get_value&&(this[column.id]=column.get_value()))}),this.activeFilters.col_filter,et2_INextmatchHeader),this.controller.update(!0),changed&&this.getInstanceManager().app){var appname=this.getInstanceManager().app;app[appname]&&app[appname].highlight_favorite&&app[appname].highlight_favorite()}this.update_in_progress=!1}},et2_nextmatch.prototype.refresh=function(_row_ids,_type){if(null!==this.controller&&this.div){"string"!=typeof _row_ids&&"number"!=typeof _row_ids||(_row_ids=[_row_ids]);var update_pref=egw.preference("lazy-update")||"lazy";if(_type!=et2_nextmatch.UPDATE||this.is_sorted_by_modified()?"exact"!=update_pref||_type!=et2_nextmatch.ADD||this.is_sorted_by_modified()||(_type=et2_nextmatch.EDIT):_type="lazy"==update_pref?et2_nextmatch.UPDATE_IN_PLACE:et2_nextmatch.EDIT,_type!=et2_nextmatch.ADD||"lazy"==update_pref||"exact"==update_pref&&this.is_sorted_by_modified()||(_type=et2_nextmatch.EDIT),void 0===_type&&(_type=et2_nextmatch.EDIT),!this.div.is(":visible"))return this._queue_refresh(_row_ids,_type);if(null==_row_ids)return this.applyFilters(),void jQuery(this).triggerHandler("refresh",[this]);if(_row_ids=_row_ids.map(function(id){if(-1==id.toString().indexOf(this.controller.dataStorePrefix))return id;var parts=id.split("::");return parts.shift(),parts.join("::")}.bind(this)),_type==et2_nextmatch.DELETE){var uid=0==_row_ids[0].toString().indexOf(this.controller.dataStorePrefix)?_row_ids[0]:this.controller.dataStorePrefix+"::"+_row_ids[0],entry=this.controller._selectionMgr._getRegisteredRowsEntry(uid);if(entry&&null!==entry.idx){var next=entry.ao?entry.ao.getNext(_row_ids.length):null;null!=next&&next.id&&next.id!=uid||(next=entry.ao?entry.ao.getPrevious(1):null),this.dataview.grid.doInvalidate=!1;for(var i=0;i<_row_ids.length;i++)uid=0==_row_ids[i].toString().indexOf(this.controller.dataStorePrefix)?_row_ids[i]:this.controller.dataStorePrefix+"::"+_row_ids[i],this.controller.deleteRow(uid);next&&next.id&&!this.options.disable_selection_advance&&(this.controller._selectionMgr.setSelected(next.id,!0),this.controller._selectionMgr.setFocused(next.id,!0));var total=this.dataview.grid._total-_row_ids.length;this.dataview.grid.setTotalCount(total),this.controller._selectionMgr.setTotalCount(total),this.dataview.grid.doInvalidate=!0,this.dataview.grid.invalidate()}}var _loop_1=function(){var uid_1=0==_row_ids[i].toString().indexOf(this_1.controller.dataStorePrefix)?_row_ids[i]:this_1.controller.dataStorePrefix+"::"+_row_ids[i],known=Object.values(this_1.controller._indexMap).filter((function(row){return row.uid==uid_1}));if(_type!=et2_nextmatch.UPDATE&&_type!=et2_nextmatch.UPDATE_IN_PLACE||known&&0!=known.length||(_type=et2_nextmatch.ADD,"exact"!=update_pref||this_1.is_sorted_by_modified()||(_type=et2_nextmatch.EDIT)),-1!==[et2_nextmatch.ADD,et2_nextmatch.UPDATE].indexOf(_type))return this_1.egw().dataFetch(this_1.getInstanceManager().etemplate_exec_id,{refresh:_row_ids},this_1.controller._filters,this_1.id,(function(data){this.nm.getParent()&&(data.total>=1?this.type==et2_nextmatch.ADD?this.nm.refresh_add(this.uid,this.type):this.nm.refresh_update(this.uid):this.type==et2_nextmatch.UPDATE&&(this.nm.controller.deleteRow(this.uid),this.nm.controller._grid.setTotalCount(this.nm.controller._grid._total-_row_ids.length),this.nm.controller._selectionMgr.setTotalCount(this.nm.controller._grid._total)))}),{type:_type,nm:this_1,uid:uid_1,prefix:this_1.controller.dataStorePrefix},[_row_ids]),{value:void 0};switch(_type){case et2_nextmatch.UPDATE_IN_PLACE:this_1.egw().dataRefreshUID(uid_1);break;case et2_nextmatch.UPDATE:case et2_nextmatch.DELETE:case et2_nextmatch.ADD:break;case et2_nextmatch.EDIT:default:return this_1.applyFilters(),"break-id_loop"}},this_1=this;id_loop:for(i=0;i<_row_ids.length;i++){var state_1=_loop_1();if("object"==typeof state_1)return state_1.value;switch(state_1){case"break-id_loop":break id_loop}}jQuery(this).triggerHandler("refresh",[this,_row_ids,_type])}},et2_nextmatch.prototype.refresh_update=function(uid){var entry=this.controller._selectionMgr._getRegisteredRowsEntry(uid);if(this.controller.deleteRow(uid),!this.refresh_add(uid,et2_nextmatch.UPDATE)){var callback_1=function(data){data.class+=" new_entry",this.egw().dataUnregisterUID(uid,callback_1,this)};this.egw().dataRegisterUID(uid,callback_1,this,this.getInstanceManager().etemplate_exec_id,this.id),this.controller._insertDataRow(entry,!0)}return this.controller._grid.setTotalCount(this.controller._grid.getTotalCount()-1),this.controller._selectionMgr.setTotalCount(this.controller._grid.getTotalCount()),!0},et2_nextmatch.prototype.refresh_add=function(uid,type){void 0===type&&(type=et2_nextmatch.ADD);var index=("exact"!==egw.preference("lazy-update")||!!this.is_sorted_by_modified())&&0;if(!1===index)return!1;(new Date).valueOf();return this.egw().dataRegisterUID(uid,this._push_add_callback,{nm:this,uid:uid,index:index},this.getInstanceManager().etemplate_exec_id,this.id),!0},et2_nextmatch.prototype._push_add_callback=function(data){if(data&&this.nm&&this.nm.getParent()){data.class&&(data.class+=" new_entry");egw.dataGetUIDdata(this.uid);this.nm.controller._grid.setTotalCount(this.nm.controller._grid.getTotalCount()+1),this.nm.controller._selectionMgr.setTotalCount(this.nm.controller._grid.getTotalCount());var entry=this.nm.controller._selectionMgr._getRegisteredRowsEntry(this.uid);entry.idx="number"==typeof this.index?this.index:0,this.nm.controller._insertDataRow(entry,!0)}else this.nm&&this.nm.getParent()&&(this.nm.controller.deleteRow(this.uid),this.nm.controller._grid.setTotalCount(this.nm.controller._grid.getTotalCount()-1),this.nm.controller._selectionMgr.setTotalCount(this.nm.controller._grid.getTotalCount()));this.nm.egw().dataUnregisterUID(this.uid,this.nm._push_add_callback,this)},et2_nextmatch.prototype._queue_refresh=function(_row_ids,_type){if(null!==this._queued_refreshes){jQuery(this.getInstanceManager().DOMContainer.parentNode).off("show.et2_nextmatch").one("show.et2_nextmatch",this._queue_refresh_callback.bind(this));this._queued_refreshes.length>=50||_type==et2_nextmatch.EDIT||!_type?this._queued_refreshes=null:this._queued_refreshes.some((function(queue){return queue.ids.length===_row_ids.length&&queue.ids.every((function(value,index){return value===_row_ids[index]}))}))||this._queued_refreshes.push({ids:_row_ids,type:_type})}},et2_nextmatch.prototype._queue_refresh_callback=function(){if(null===this._queued_refreshes)return this._queued_refreshes=[],this.applyFilters();var types={};types[et2_nextmatch.ADD]=[],types[et2_nextmatch.UPDATE]=[],types[et2_nextmatch.UPDATE_IN_PLACE]=[],types[et2_nextmatch.DELETE]=[];for(var _i=0,_a=this._queued_refreshes;_i<_a.length;_i++){var refresh=_a[_i];types[refresh.type]=types[refresh.type].concat(refresh.ids)}for(var type in this._queued_refreshes=[],types)types[type].length>0&&this.refresh(types[type].filter((function(v,i,a){return a.indexOf(v)===i})),type)},et2_nextmatch.prototype.is_sorted_by_modified=function(){var _a,sort=(null===(_a=this.getValue())||void 0===_a?void 0:_a.sort)||{};return sort&&sort.id&&sort.id==this.settings.add_on_top_sort_field&&0==sort.asc},et2_nextmatch.prototype._get_appname=function(){var list=[];return list=et2_csvSplit(this.options.settings.columnselection_pref,2,"."),0==this.options.settings.columnselection_pref.indexOf("nextmatch")?list[0].substring("nextmatch".length+1):list[0]},et2_nextmatch.prototype.getSelection=function(){var selected=this.controller&&this.controller._selectionMgr?this.controller._selectionMgr.getSelected():null;return"object"==typeof selected&&null!=selected?selected:{ids:[],all:!1}},et2_nextmatch.prototype.spillYourGuts=function(){var guts=function(controller){if(console.log("Controller:",controller),console.log("Controller indexMap:",controller._indexMap),console.log("Grid:",controller._grid),console.log("Selection Manager:",controller._selectionMgr),console.log("Selection registered rows:",controller._selectionMgr._registeredRows),controller&&controller._children.length>0){console.groupCollapsed("Sub-grids");for(var child_index=0,_i=0,_a=controller._children;_i<_a.length;_i++){var child=_a[_i];console.groupCollapsed("Child "+ ++child_index),guts(child),console.groupEnd()}console.groupEnd()}};console.group("Nextmatch internals"),guts(this.controller),console.groupEnd()},et2_nextmatch.prototype.onselect=function(action,senders){if("function"==typeof this.options.onselect)return this.options.onselect.call(this,this.getSelection().ids,this)},et2_nextmatch.prototype._createNamespace=function(){return!0},et2_nextmatch.prototype._getDynheight=function(){var tab=this.get_tab_info();return tab?!(!tab||!tab.contentDiv)&&new et2_widget_dynheight_1.et2_dynheight(tab.contentDiv,this.innerDiv,100):new et2_widget_dynheight_1.et2_dynheight(this.getInstanceManager().DOMContainer,this.innerDiv,100)},et2_nextmatch.prototype._genColumnCaption=function(_widget){var result=null;if("function"==typeof _widget._genColumnCaption)return _widget._genColumnCaption();var self=this;return _widget.iterateOver((function(_widget){var label=self.egw().lang(_widget.options.label||_widget.options.empty_label||"");label&&(result?result+=", "+label:result=label)}),this,et2_INextmatchHeader),result},et2_nextmatch.prototype._getColumnName=function(_widget){if("function"==typeof _widget._getColumnName)return _widget._getColumnName();for(var name=_widget.id,child_names=[],children=_widget.getChildren(),i=0;i<children.length;i++)children[i].id&&child_names.push(children[i].id);var colName=name+(""!=name&&child_names.length>0?"_":"")+child_names.join("_");return""==colName&&this.egw().debug("info","Unable to generate nm column name for ",_widget),colName},et2_nextmatch.prototype._getPreferences=function(){var negated=!1,columnPreference="";this.options.settings.default_cols&&(columnPreference=(negated="!"==this.options.settings.default_cols[0])?this.options.settings.default_cols.substring(1):this.options.settings.default_cols),this.options.settings.selectcols&&this.options.settings.selectcols.length&&(columnPreference=this.options.settings.selectcols,negated=!1),this.options.settings.columnselection_pref||(this.options.settings.columnselection_pref=this.options.template);var app="",list=[];if(this.options.settings.columnselection_pref){var pref={};list=et2_csvSplit(this.options.settings.columnselection_pref,2,"."),0==this.options.settings.columnselection_pref.indexOf("nextmatch")?(app=list[0].substring("nextmatch".length+1),pref=egw.preference(this.options.settings.columnselection_pref,app)):(app=list[0],pref=egw.preference("nextmatch-"+this.options.settings.columnselection_pref,app)),pref&&(columnPreference=(negated="!"==pref[0])?pref.substring(1):pref)}var columnDisplay=[];"string"==typeof columnPreference&&0==columnPreference.length&&(columnDisplay=[],negated=!0),columnDisplay="string"==typeof columnPreference?et2_csvSplit(columnPreference,null,","):columnPreference;var size={};if(this.options.settings.columnselection_pref&&app){var size_pref=this.options.settings.columnselection_pref+"-size";-1==size_pref.indexOf("nextmatch")&&(size_pref="nextmatch-"+size_pref),size=this.egw().preference(size_pref,app)}size||(size={});for(var order={},i=0;i<columnDisplay.length;i++)order[columnDisplay[i]]=i;return{visible:columnDisplay,visible_negated:negated,negated:negated,size:size,order:order}},et2_nextmatch.prototype._applyUserPreferences=function(_row,_colData){var prefs=this._getPreferences(),columnDisplay=prefs.visible,size=prefs.size,negated=prefs.visible_negated,order=prefs.order,colName="";if(columnDisplay&&columnDisplay.length>0)for(var i=0;i<_row.length;i++)if(colName="",!0!==_row[i].disabled){if(_row[i].widget.instanceOf(et2_nextmatch_customfields)){for(var j=0;j<columnDisplay.length;j++)if(0==columnDisplay[j].indexOf(_row[i].widget.id)){_row[i].widget.options.fields={};for(var k=j;k<columnDisplay.length;k++)0==columnDisplay[k].indexOf(_row[i].widget.prefix)&&(_row[i].widget.options.fields[columnDisplay[k].substr(1)]=!0);_row[i].widget._getColumnName(),_colData[i].visible=!(negated||jQuery.isEmptyObject(_row[i].widget.options.fields));break}if(jQuery.isEmptyObject(_row[i].widget.customfields)){_colData[i].visible=!1;continue}colName=_row[i].widget.id}else colName=this._getColumnName(_row[i].widget);if(negated||(_colData[i].order=void 0===order[colName]?i:order[colName]),colName){_colData[i].visible=negated;var stop_1=!1;for(j=0;j<columnDisplay.length&&!stop_1;j++)columnDisplay[j]==colName&&(_colData[i].visible=!negated,stop_1=!0);size[colName]&&("%"==_colData[i].width.charAt(_colData[i].width.length-1)?_colData[i].width="string"==typeof size[colName]&&"%"==size[colName].charAt(size[colName].length-1)?size[colName]:_colData[i].width:_colData[i].width=parseInt(size[colName])+"px")}}else _colData[i].visible=!1;_colData.sort((function(a,b){return a.order-b.order})),_row.sort((function(a,b){return void 0!==a.colData&&void 0!==b.colData?a.colData.order-b.colData.order:void 0!==a.order&&void 0!==b.order?a.order-b.order:void 0}))},et2_nextmatch.prototype._updateUserPreferences=function(){var colMgr=this.dataview.getColumnMgr(),app="";this.options.settings.columnselection_pref||(this.options.settings.columnselection_pref=this.options.template);for(var visibility=colMgr.getColumnVisibilitySet(),colDisplay=[],colSize={},custom_fields=[],i=0;i<colMgr.columns.length;i++){var widget=this.columns[i].widget,colName=this._getColumnName(widget);if(colName){if(widget.instanceOf(et2_nextmatch_customfields))for(var name_1 in colName=widget.id,widget.options.fields)widget.options.fields[name_1]&&custom_fields.push(et2_nextmatch_customfields.PREFIX+name_1);visibility[colMgr.columns[i].id].visible&&colDisplay.push(colName),colMgr.columns[i].relativeWidth?colSize[colName]=100*colMgr.columns[i].relativeWidth+"%":colMgr.columns[i].fixedWidth&&(colSize[colName]=colMgr.columns[i].fixedWidth)}else(colMgr.columns[i].fixedWidth||colMgr.columns[i].relativeWidth)&&this.egw().debug("info","Could not save column width - no name",colMgr.columns[i].id)}var list=et2_csvSplit(this.options.settings.columnselection_pref,2,"."),pref=this.options.settings.columnselection_pref;0==pref.indexOf("nextmatch")?app=list[0].substring("nextmatch".length+1):(app=list[0],pref="nextmatch-"+this.options.settings.columnselection_pref),jQuery.merge(colDisplay,custom_fields);var oldCols=this.activeFilters.selectcols?this.activeFilters.selectcols:[];this.activeFilters.selectcols=this.sortedColumnsList.length>0?this.sortedColumnsList:colDisplay;var changed=[];ColLoop:for(i=0;i<colDisplay.length;i++){for(var j=0;j<oldCols.length;j++)if(colDisplay[i]==oldCols[j])continue ColLoop;changed.push(colDisplay[i])}var cf_added=jQuery(changed).filter(jQuery(custom_fields)).length>0;jQuery.isEmptyObject(this.activeFilters.selectcols)||(this.egw().set_preference(app,pref,this.activeFilters.selectcols.join(","),cf_added?jQuery.proxy((function(){this.controller&&this.controller.update(!0)}),this):null),this.egw().set_preference(app,pref+"-size",colSize),this.egw().message(this.egw().lang("Saved column sizes to preferences."))),this.egw().set_preference(app,pref+"-size",colSize),!changed.length&&!custom_fields.length||cf_added||this.applyFilters()},et2_nextmatch.prototype._parseHeaderRow=function(_row,_colData){for(var x=0;x<_row.length;x++)_row[x].widget||(_row[x].widget=et2_core_widget_1.et2_createWidget("label",{}));this._applyUserPreferences(_row,_colData),this.columns=new Array(_row.length);var columnData=new Array(_row.length),remove_action_index=null;for(x=0;x<_row.length;x++){this.columns[x]=jQuery.extend({order:_colData[x]&&void 0!==_colData[x].order?_colData[x].order:x,widget:_row[x].widget},_colData[x]);var visibility=!_colData[x]||_colData[x].visible?et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE:et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE;_colData[x].disabled&&""!==_colData[x].disabled&&this.getArrayMgr("content").parseBoolExpression(_colData[x].disabled)&&(visibility=et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_DISABLED,this.columns[x].visible=!1),columnData[x]={id:"col_"+x,order:this.columns[x].order,caption:this._genColumnCaption(_row[x].widget),visibility:visibility,width:_colData[x]?_colData[x].width:0},"auto"===_colData[x].width&&(columnData[x].width="100%"),_colData[x].minWidth&&(columnData[x].minWidth=_colData[x].minWidth),_colData[x].maxWidth&&(columnData[x].maxWidth=_colData[x].maxWidth);var colName=this._getColumnName(_row[x].widget);"actions"==colName||"legacy_actions"==colName||"legacy_actions_check_all"==colName?remove_action_index=x:colName||(columnData[x].visibility=et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT,this.columns[x].visible=!0)}null!=remove_action_index&&(this.columns.splice(remove_action_index,remove_action_index),columnData.splice(remove_action_index,remove_action_index),_colData.splice(remove_action_index,remove_action_index)),this.dataview.setColumns(columnData);for(x=0;x<_row.length;x++)this.addChild(_row[x].widget);this.rowProvider=new et2_extension_nextmatch_rowProvider_1.et2_nextmatch_rowProvider(this.dataview.rowProvider,this._getSubgrid,this);var self=this;this.dataview.onUpdateColumns=function(){self._updateUserPreferences.apply(self),self.iterateOver((function(widget){widget.resize()}),self,et2_IResizeable)},this.selectPopup&&(this.selectPopup.remove(),this.selectPopup=null),this.options.settings.no_columnselection?(this.dataview.selectColumnsClick=function(){return!1},jQuery("span.selectcols",this.dataview.headTr).hide()):(jQuery("span.selectcols",this.dataview.headTr).show(),this.dataview.selectColumnsClick=function(event){self._selectColumnsClick(event)})},et2_nextmatch.prototype._parseDataRow=function(_row,_rowData,_colData){var columnWidgets=[];_row.sort((function(a,b){return a.colData.order-b.colData.order}));for(var x=0;x<this.columns.length;x++)this.columns[x].visible&&(void 0!==_row[x]&&_row[x].widget?(columnWidgets[x]=_row[x].widget,this.addChild(_row[x].widget)):columnWidgets[x]=_row[x].widget,_row[x].align&&columnWidgets[x]&&(columnWidgets[x].align=_row[x].align));if(this.rowProvider.setDataRowTemplate(columnWidgets,_rowData,this),this.controller=new et2_extension_nextmatch_controller_1.et2_nextmatch_controller(null,this.egw(),this.getInstanceManager().etemplate_exec_id,this,null,this.dataview.grid,this.rowProvider,this.options.settings.action_links,null,this.options.actions),0==total&&this.controller._emptyRow(),!this.options.settings.dataStorePrefix&&this.options.settings.get_rows){var list=this.options.settings.get_rows.split(".",2);list.length<2&&(list=this.options.settings.get_rows.split("_")),this.options.settings.dataStorePrefix=list[0]}this.controller.setPrefix(this.options.settings.dataStorePrefix),this.controller._view=this.view;var total=void 0!==this.options.settings.total?this.options.settings.total:0;this.dataview.grid.setTotalCount(total),this.options.settings.rows&&this.options.settings.num_rows&&(this.controller.loadInitialData(this.options.settings.dataStorePrefix,this.options.settings.row_id,this.options.settings.rows),delete this.options.settings.rows)},et2_nextmatch.prototype._parseGrid=function(_grid){for(var y=0;y<_grid.rowData.length;y++)"th"==_grid.rowData[y].class||0==y?this._parseHeaderRow(_grid.cells[y],_grid.colData):this._parseDataRow(_grid.cells[y],_grid.rowData[y],_grid.colData);this.dataview.table.resize()},et2_nextmatch.prototype._getSubgrid=function(_row,_data,_controller){var rowId=_data.content[this.options.settings.row_id],grid=new et2_dataview_view_grid_1.et2_dataview_grid(_row,this.dataview.grid),controller=new et2_extension_nextmatch_controller_1.et2_nextmatch_controller(_controller,this.egw(),this.getInstanceManager().etemplate_exec_id,this,rowId,grid,this.rowProvider,this.options.settings.action_links,_controller.getObjectManager());return controller.update(),grid.setDestroyCallback((function(){controller.destroy()})),grid},et2_nextmatch.prototype._getInitialOrder=function(_rows,_rowId){var _order=[],len=0;for(var key in _rows)!isNaN(parseInt(key))&&parseInt(key)>len&&(len=parseInt(key));for(var i=0;i<len;i++){var uid=this.egw().app_name()+"::"+_rows[i][_rowId];this.egw().dataStoreUID(uid,_rows[i]),_order.push(uid)}return _order},et2_nextmatch.prototype._selectColumnsClick=function(e){for(var self=this,columnMgr=this.dataview.getColumnMgr(),LETTERS="~search_letter~",columns={},columns_selected=[],i=0;i<columnMgr.columns.length;i++){var col=columnMgr.columns[i],widget=this.columns[i].widget;if(col.visibility!=et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_DISABLED&&col.visibility!=et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT&&(col.caption&&(columns[col.id]=col.caption,col.visibility==et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE&&columns_selected.push(col.id)),widget.instanceOf(et2_nextmatch_customfields))){if(jQuery.isEmptyObject(widget.customfields)){delete columns[col.id];continue}for(var field_name in widget.customfields)columns[et2_nextmatch_customfields.PREFIX+field_name]=" - "+widget.customfields[field_name].label,widget.options.fields[field_name]&&columns_selected.push(et2_extension_customfields_1.et2_customfields_list.PREFIX+field_name)}}if(this.options.settings.lettersearch&&(columns[LETTERS]=egw.lang("Search letter"),this.header.lettersearch.is(":visible")&&columns_selected.push(LETTERS)),this.selectPopup)this.selectPopup.toggle();else{var autoRefresh_1,select_1=et2_core_widget_1.et2_createWidget("select",{multiple:!0,rows:8,empty_label:this.egw().lang("select columns"),selected_first:!1,value_class:"selcolumn_sortable_"},this);select_1.set_select_options(columns),select_1.set_value(columns_selected),this.options.disable_autorefresh||((autoRefresh_1=et2_core_widget_1.et2_createWidget("select",{empty_label:"Refresh"},this)).set_id("nm_autorefresh"),autoRefresh_1.set_select_options({30:"30 seconds",180:"3 Minutes",300:"5 Minutes",900:"15 Minutes",1800:"30 Minutes"}),autoRefresh_1.set_value(this._get_autorefresh()),autoRefresh_1.set_statustext(egw.lang("Automatically refresh list")));var defaultCheck=et2_core_widget_1.et2_createWidget("select",{empty_label:"Preference"},this);defaultCheck.set_id("nm_col_preference"),defaultCheck.set_select_options({default:{label:"Default",title:"Set these columns as the default"},reset:{label:"Reset",title:"Reset all user's column preferences"},force:{label:"Force",title:"Force column preference so users cannot change it"}}),defaultCheck.set_value(this.options.settings.columns_forced?"force":"");var okButton=et2_core_widget_1.et2_createWidget("buttononly",{background_image:!0,image:"check"},this);okButton.set_label(this.egw().lang("ok")),okButton.onclick=function(){for(var visibility={},i=0;i<columnMgr.columns.length;i++){var col_1=columnMgr.columns[i];col_1.caption&&col_1.visibility!==et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT&&col_1.visibility!==et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_DISABLED&&(visibility[col_1.id]={visible:!1})}var value=select_1.getValue();if(self.header.lettersearch){var show_letters=!0;value.indexOf(LETTERS)>=0?value.splice(value.indexOf(LETTERS),1):show_letters=!1,self._set_lettersearch(show_letters)}var column=0;for(i=0;i<value.length;i++){for(;value[i]!="col_"+column&&column<columnMgr.columns.length;)column++;if(visibility[value[i]]&&(visibility[value[i]].visible=!0),self.columns[column]&&self.columns[column].widget.instanceOf(et2_nextmatch_customfields)){var cf=self.columns[column].widget.options.customfields,visible=self.columns[column].widget.options.fields;for(var field_name in cf)visible[field_name]=!1;for(var j=0;j<value.length;j++)0==value[j].indexOf(et2_extension_customfields_1.et2_customfields_list.PREFIX)&&(visible[value[j].substring(1)]=!0,i++);self.columns[column].widget.set_visible(visible)}}columnMgr.setColumnVisibilitySet(visibility),this.sortedColumnsList=[],jQuery(select_1.getDOMNode()).find('li[class^="selcolumn_sortable_"]').each((function(i,v){var data_id=v.getAttribute("data-value"),value=select_1.getValue();if(data_id.match(/^col_/)&&-1!=value.indexOf(data_id)){var col_id=data_id.replace("col_",""),col_widget=self.columns[col_id].widget;if(col_widget.customfields)for(var field_name_1 in self.sortedColumnsList.push(col_widget.id),col_widget.customfields)(jQuery.isEmptyObject(col_widget.options.fields)||1==col_widget.options.fields[field_name_1])&&self.sortedColumnsList.push(et2_extension_customfields_1.et2_customfields_list.PREFIX+field_name_1);else self.sortedColumnsList.push(self._getColumnName(col_widget))}})),self.selectPopup.toggle(),self.dataview.updateColumns(),self._set_autorefresh(autoRefresh_1?autoRefresh_1.get_value():0),show_letters&&self.activeFilters.selectcols.push("lettersearch"),self.getInstanceManager().submit(),self.selectPopup=null};var cancelButton=et2_core_widget_1.et2_createWidget("buttononly",{background_image:!0,image:"cancel"},this);cancelButton.set_label(this.egw().lang("cancel")),cancelButton.onclick=function(){self.selectPopup.toggle(),self.selectPopup=null};var $select=jQuery(select_1.getDOMNode());$select.find(".ui-multiselect-checkboxes").sortable({placeholder:"ui-fav-sortable-placeholder",items:'li[class^="selcolumn_sortable_col"]',cancel:'li[class^="selcolumn_sortable_#"]',cursor:"move",tolerance:"pointer",axis:"y",containment:"parent",delay:250,beforeStop:function(event,ui){jQuery('li[class^="selcolumn_sortable_#"]',this).css({opacity:1})},start:function(event,ui){jQuery('li[class^="selcolumn_sortable_#"]',this).css({opacity:.5})},sort:function(event,ui){jQuery(this).sortable("refreshPositions")}}),$select.disableSelection(),$select.find('li[class^="selcolumn_sortable_"]').each((function(i,v){jQuery(v).attr("data-value",jQuery(v).find("input")[0].value)}));var $footerWrap=jQuery(document.createElement("div")).addClass("dialogFooterToolbar").append(okButton.getDOMNode()).append(cancelButton.getDOMNode());this.selectPopup=jQuery(document.createElement("div")).addClass("colselection ui-dialog ui-widget-content").append(select_1.getDOMNode()).append($footerWrap).appendTo(this.innerDiv),autoRefresh_1&&$footerWrap.append(autoRefresh_1.getSurroundings().getDOMNode(autoRefresh_1.getDOMNode())),this.egw().user("apps").admin&&$footerWrap.append(defaultCheck.getSurroundings().getDOMNode(defaultCheck.getDOMNode()))}var t_position=jQuery(e.target).position(),s_position=this.div.position(),max_height=this.getDOMNode().getElementsByClassName("egwGridView_outer")[0].tBodies[0].clientHeight-2*this.selectPopup.find(".dialogFooterToolbar").height();this.selectPopup.find(".ui-multiselect-checkboxes").css("max-height",max_height),this.selectPopup.css("top",t_position.top).css("left",s_position.left+this.div.width()-this.selectPopup.width())},et2_nextmatch.prototype.get_columns=function(){for(var colMgr=this.dataview.getColumnMgr(),visibility=colMgr.getColumnVisibilitySet(),colDisplay=[],custom_fields=[],i=0;i<colMgr.columns.length;i++){var widget=this.columns[i].widget,colName=this._getColumnName(widget);if(colName){if(widget.instanceOf(et2_nextmatch_customfields))for(var name_2 in colName=widget.id,widget.options.fields)widget.options.fields[name_2]&&custom_fields.push(et2_nextmatch_customfields.PREFIX+name_2);visibility[colMgr.columns[i].id].visible&&colDisplay.push(colName)}}return jQuery.merge(colDisplay,custom_fields),this.sortedColumnsList.length>0?this.sortedColumnsList:colDisplay},et2_nextmatch.prototype.set_columns=function(column_list,trigger_update){void 0===trigger_update&&(trigger_update=!1);for(var columnMgr=this.dataview.getColumnMgr(),visibility={},i=0;i<columnMgr.columns.length;i++){var col=columnMgr.columns[i];col.caption&&col.visibility!=et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT&&(visibility[col.id]={visible:!1})}for(i=0;i<this.columns.length;i++){var widget=this.columns[i].widget,colName=this._getColumnName(widget);if(-1!==column_list.indexOf(colName)&&void 0!==visibility[columnMgr.columns[i].id]&&(visibility[columnMgr.columns[i].id].visible=!0),widget&&widget.instanceOf(et2_nextmatch_customfields)){colName=widget.id,-1!==column_list.indexOf(colName)&&(visibility[columnMgr.columns[i].id].visible=!0);var cf=this.columns[i].widget.options.customfields,visible=this.columns[i].widget.options.fields;for(var field_name in cf)visible[field_name]=!1;for(var j=0;j<column_list.length;j++)0==column_list[j].indexOf(et2_extension_customfields_1.et2_customfields_list.PREFIX)&&(visible[column_list[j].substring(1)]=!0);widget.set_visible(visible)}}columnMgr.setColumnVisibilitySet(visibility),this.dataview._updateColumns(),this.iterateOver((function(widget){widget.resize()}),this,et2_IResizeable)},et2_nextmatch.prototype._set_lettersearch=function(letters_on){letters_on?this.header.lettersearch.show():this.header.lettersearch.hide();var lettersearch_preference="nextmatch-"+this.options.settings.columnselection_pref+"-lettersearch";this.egw().set_preference(this.egw().app_name(),lettersearch_preference,letters_on)},et2_nextmatch.prototype._set_autorefresh=function(time){this._autorefresh_timer&&(window.clearInterval(this._autorefresh_timer),delete this._autorefresh_timer);var refresh_preference="nextmatch-"+this.options.settings.columnselection_pref+"-autorefresh",app=this._get_appname();this._get_autorefresh()!=time&&this.egw().set_preference(app,refresh_preference,time),time>0&&(this._autorefresh_timer=setInterval(jQuery.proxy(this.controller.update,this.controller),1e3*time),jQuery(this.getInstanceManager().DOMContainer.parentNode).on("hide.et2_nextmatch",jQuery.proxy((function(e){window.clearInterval(this._autorefresh_timer),jQuery(e.target).off(e),this._autorefresh_timer=setTimeout(jQuery.proxy((function(){this._autorefresh_timer&&this.getInstanceManager()&&jQuery(this.getInstanceManager().DOMContainer.parentNode).one("show.et2_nextmatch",jQuery.proxy((function(){this.refresh(null,"edit")}),this))}),this),1e3*time)}),this)),jQuery(this.getInstanceManager().DOMContainer.parentNode).on("show.et2_nextmatch",jQuery.proxy((function(e){this._set_autorefresh(this._get_autorefresh()),jQuery(e.target).off(e)}),this)))},et2_nextmatch.prototype._get_autorefresh=function(){if(this.options.disable_autorefresh)return 0;var refresh_preference="nextmatch-"+this.options.settings.columnselection_pref+"-autorefresh";return this.egw().preference(refresh_preference,this._get_appname())},et2_nextmatch.prototype.set_disable_autorefresh=function(disabled){this.options.disable_autorefresh=disabled,this._set_autorefresh(this._get_autorefresh())},et2_nextmatch.prototype.set_template=function(template_name){var template=et2_core_widget_1.et2_createWidget("template",{id:template_name},this);if(this.template){if(this.template==template_name)return;this.dataview.destroy(),this.rowProvider.destroy(),this.controller.destroy(),this.controller=null;for(var i=this._children.length-1;i>=0;i--){var _node=this._children[i];_node!=this.header&&_node!==template&&(this.removeChild(_node),_node.destroy())}this.template==this.options.settings.columnselection_pref&&(this.options.settings.columnselection_pref=template_name),this.dataview=new et2_dataview_1.et2_dataview(this.innerDiv,this.egw())}if(template){if(!this.options.disabled){var parse=function(template){this.template=template_name;var definitionGrid=template.getChildren()[0];definitionGrid&&definitionGrid instanceof et2_widget_grid_1.et2_grid?(this._parseGrid(definitionGrid),setTimeout((function(){template.destroy()}),1),this.iterateOver((function(_node){_node.setNextmatch(this)}),this,et2_INextmatchHeader),!this.options.settings.num_rows&&this.controller&&this.controller.update(),this.options.settings.order&&this.options.settings.sort&&this.sortBy(this.options.settings.order,"ASC"==this.options.settings.sort,!1),this._set_autorefresh(this._get_autorefresh())):this.egw().debug("error","Nextmatch widget expects a grid to be the first child of the defined template.")},promise=[];return template.loadingFinished(promise),jQuery.when.apply(null,promise).done(jQuery.proxy((function(){parse.call(this,template),this.dynheight||(this.dynheight=this._getDynheight()),this.dynheight.initialized=!1,this.resize()}),this)),promise}}else this.egw().debug("error","Error while loading definition template for nextmatch widget.",template_name)},et2_nextmatch.prototype.set_hide_header=function(hide){hide?this.header.div.hide():this.header.div.show()},et2_nextmatch.prototype.set_header_left=function(template){this.header._build_header("left",template)},et2_nextmatch.prototype.set_header_right=function(template){this.header._build_header("right",template)},et2_nextmatch.prototype.set_header_row=function(template){this.header._build_header("row",template)},et2_nextmatch.prototype.set_no_filter=function(bool,filter_name){void 0===filter_name&&(filter_name="filter"),this.options["no_"+filter_name]=bool;var filter=this.header[filter_name];filter?filter.set_disabled(bool):bool&&(filter=this.header._build_select(filter_name,"select",this.settings[filter_name],this.settings[filter_name+"_no_lang"]))},et2_nextmatch.prototype.set_no_filter2=function(bool){this.set_no_filter(bool,"filter2")},et2_nextmatch.prototype.set_filter=function(value){var update=this.update_in_progress;this.update_in_progress=!0,this.activeFilters.filter=value,this.header.setFilters(this.activeFilters),this.update_in_progress=update},et2_nextmatch.prototype.set_filter2=function(value){var update=this.update_in_progress;this.update_in_progress=!0,this.activeFilters.filter2=value,this.header.setFilters(this.activeFilters),this.update_in_progress=update},et2_nextmatch.prototype.set_disabled=function(_value){var previous=this.disabled;_super.prototype.set_disabled.call(this,_value),previous&&!_value&&this.resize()},et2_nextmatch.prototype.set_actions=function(actions){if(actions!=this.options.actions&&null!=this.controller&&this.controller._actionManager){for(var i=this.controller._actionManager.children.length-1;i>=0;i--)this.controller._actionManager.children[i].remove();this.options.actions=actions,this.options.settings.action_links=this.controller._actionLinks=this._get_action_links(actions),this.controller._initActions(actions)}},et2_nextmatch.prototype.set_view=function(view){this.view="tile"==view?"tile":"row"},et2_nextmatch.prototype.set_onfiledrop=function(handler){this.options.onfiledrop=handler},et2_nextmatch.prototype.handle_drop=function(event,target){var _a,row=this.controller.getRowByNode(target),uid=(null===(_a=row)||void 0===_a?void 0:_a.uid)||null,files=[];if(!(event.originalEvent&&event.originalEvent.dataTransfer&&event.originalEvent.dataTransfer.files&&event.originalEvent.dataTransfer.files.length>0))return!1;if(files=event.originalEvent.dataTransfer.files,this.options.onfiledrop&&!this.options.onfiledrop.call(this,uid,files))return!1;if(event.stopPropagation(),event.preventDefault(),!row||!row.uid)return!1;var split=uid.split("::"),link_value={to_app:split.shift(),to_id:split.join("::")},link=et2_core_widget_1.et2_createWidget("link-to",{value:link_value},this);if(link.loadingFinished(),link.file_upload.set_drop_target(!1),row.row.tr){var status_1=jQuery(document.createElement("div")).addClass("et2_link_to").width(row.row.tr.width()).position({my:"left top",at:"left top",of:row.row.tr}).append(link.status_span).append(link.file_upload.progress).appendTo(row.row.tr);link.div.on("link.et2_link_to",(function(e,linked){linked?link._parent.refresh(uid,"edit"):jQuery("li.success",link.file_upload.progress).removeClass("success").addClass("validation_error"),status_1.delay(linked?1:2e3).fadeOut(500,(function(){link.destroy(),status_1.remove()}))}))}link.file_upload.set_value(files)},et2_nextmatch.prototype.getDOMNode=function(_sender){if(_sender==this||void 0===_sender)return this.div[0];if(_sender==this.header)return this.header.div[0];for(var i=0;i<this.columns.length;i++)if(this.columns[i]&&this.columns[i].widget&&_sender==this.columns[i].widget)return this.dataview.getHeaderContainerNode(i);return _sender&&_sender._parent&&_sender._parent==this?this.header.getDOMNode(_sender):null},et2_nextmatch.prototype.getValue=function(){for(var idsArr=this.getSelection().ids,i=0;i<idsArr.length;i++)idsArr[i]=idsArr[i].split("::").pop();var value={selected:idsArr};return jQuery.extend(value,this.activeFilters,this.value),void 0!==value.selectcols&&0!==value.selectcols.length||(value.selectcols=this.get_columns()),value},et2_nextmatch.prototype.resetDirty=function(){},et2_nextmatch.prototype.isDirty=function(){return!1},et2_nextmatch.prototype.isValid=function(){return!0},et2_nextmatch.prototype.set_value=function(_value){this.value=_value},et2_nextmatch.prototype.beforePrint=function(){this.div.addClass("print"),this.dynheight.outerNode.css("max-width",this.div.css("max-width")),this.resize(),this.dynheight.innerNode.css("height","auto");var range=this.controller._grid.getIndexRange();this.print.old_height=this.controller._grid._scrollHeight;var loaded_count=range.bottom-range.top+1,total=this.controller._grid.getTotalCount(),defer=jQuery.Deferred(),pref=this.options.settings.columnselection_pref;0==pref.indexOf("nextmatch")&&(pref="nextmatch-"+pref);var app=this.getInstanceManager().app,columns={},columnMgr=this.dataview.getColumnMgr();pref+="_print";for(var columns_selected=[],i=0;i<columnMgr.columns.length;i++){var col=columnMgr.columns[i],widget=this.columns[i].widget,colName=this._getColumnName(widget);if(col.caption&&col.visibility!==et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_ALWAYS_NOSELECT&&col.visibility!==et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_DISABLED&&(columns[colName]=col.caption,col.visibility===et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE&&columns_selected.push(colName)),widget.instanceOf(et2_nextmatch_customfields)&&(delete columns[colName],colName=widget.id,col.visibility===et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE&&!jQuery.isEmptyObject(widget.customfields)))for(var field_name in columns[colName]=col.caption,widget.customfields)columns[et2_nextmatch_customfields.PREFIX+field_name]=" - "+widget.customfields[field_name].label,widget.options.fields[field_name]&&columns_selected.indexOf(colName)>=0&&columns_selected.push(et2_nextmatch_customfields.PREFIX+field_name)}this.egw().preference(pref,app)&&this.set_columns(jQuery.extend([],this.egw().preference(pref,app)));var callback=jQuery.proxy((function(button,value){if(button!==et2_widget_dialog_1.et2_dialog.CANCEL_BUTTON){this.div.addClass(value.orientation),this.egw().set_preference(app,pref+"_orientation",value.orientation);var css="@page { size: "+value.orientation+"; }",head=document.head||document.getElementsByTagName("head")[0],style=document.createElement("style");style.type="text/css",style.media="print",style.styleSheet?style.styleSheet.cssText=css:style.appendChild(document.createTextNode(css)),head.appendChild(style),this.print.orientation_style=style,this.dynheight.outerNode.css("max-width",this.div.css("max-width")),this.set_columns(value.columns),this.egw().set_preference(app,pref,value.columns);var rows=parseInt(value.row_count);if(rows>total&&(rows=total),button===et2_widget_dialog_1.et2_dialog.OK_BUTTON&&rows==this.controller._grid.getTotalCount()&&(this.div.addClass("print"),jQuery(".egwGridView_scrollarea",this.div).css("height","auto")),"dialog[all]"===button||rows>loaded_count){var count_1=0,fetchedCount_1=0,cancel_1=!1,nm_1=this,dialog_1=et2_widget_dialog_1.et2_dialog.show_dialog((function(){count_1=total,cancel_1=!0,window.setTimeout((function(){defer.reject()}),0)}),egw.lang("Loading"),egw.lang("please wait..."),{},[{button_id:et2_widget_dialog_1.et2_dialog.CANCEL_BUTTON,text:"cancel",id:"dialog[cancel]",image:"cancel"}]);do{var ctx={self:this.controller,start:count_1,count:Math.min(rows,200),lastModification:this.controller._lastModification};nm_1.controller.dataStorePrefix&&(ctx.prefix=nm_1.controller.dataStorePrefix),nm_1.controller.dataFetch({start:count_1,num_rows:Math.min(rows,200)},(function(data){if(data&&data.order&&(fetchedCount_1+=data.order.length),nm_1.controller._fetchCallback.apply(this,arguments),fetchedCount_1>=rows){if(cancel_1)return dialog_1.destroy(),void defer.reject();nm_1.print.row_selector=".egwGridView_grid > tbody > tr:not(:nth-child(-n+"+rows+"))",egw.css(nm_1.print.row_selector,"display: none"),jQuery(".egwGridView_scrollarea",this.div).css("overflow-y","hidden"),jQuery(".egwGridView_scrollarea",this.div).css("height","auto"),window.setTimeout(jQuery.proxy((function(){dialog_1.destroy(),defer.resolve()}),nm_1),et2_dataview_view_grid_1.et2_dataview_grid.ET2_GRID_INVALIDATE_TIMEOUT)}}),ctx),count_1+=200}while(count_1<rows);nm_1.controller._grid.setScrollHeight(nm_1.controller._grid.getAverageHeight()*(rows+1))}else jQuery(".egwGridView_scrollarea",this.div).css("height","auto"),this.print.row_selector=".egwGridView_grid > tbody > tr:not(:nth-child(-n+"+rows+"))",egw.css(this.print.row_selector,"display: none"),jQuery(".egwGridView_scrollarea",this.div).css("overflow-y","hidden"),window.setTimeout((function(){defer.resolve()}),0)}else window.setTimeout((function(){defer.reject()}),0)}),this),value={content:{row_count:Math.min(100,total),columns:this.egw().preference(pref,app)||columns_selected,orientation:this.egw().preference(pref+"_orientation",app)},sel_options:{columns:columns}};return this._create_print_dialog.call(this,value,callback),defer},et2_nextmatch.prototype._create_print_dialog=function(value,callback){var base_url=this.getInstanceManager().template_base_url;"/"==base_url.substr(base_url.length-1)&&(base_url=base_url.slice(0,-1));var tab=this.get_tab_info(),title=this.options.settings.label?this.options.settings.label:tab?tab.label:"";et2_core_widget_1.et2_createWidget("dialog",{callback:callback,buttons:et2_widget_dialog_1.et2_dialog.BUTTONS_OK_CANCEL,title:this.egw().lang("Print")+" "+this.egw().lang(title),template:this.egw().link(base_url+"/api/templates/default/nm_print_dialog.xet"),value:value})},et2_nextmatch.prototype.afterPrint=function(){if(this.div.hasClass("print")){this.div.removeClass("print landscape portrait"),jQuery(this.print.orientation_style).remove(),delete this.print.orientation_style,jQuery(".egwGridView_scrollarea",this.div).css("overflow-y",""),this.controller._grid.setScrollHeight(this.print.old_height),delete this.print.old_height,this.print.row_selector&&(egw.css(this.print.row_selector,""),delete this.print.row_selector);var pref=[],app=this.getInstanceManager().app;(pref=0==this.options.settings.columnselection_pref.indexOf("nextmatch")?egw.preference(this.options.settings.columnselection_pref,app):egw.preference("nextmatch-"+this.options.settings.columnselection_pref,app))&&("string"==typeof pref&&(pref=pref.split(",")),this.set_columns(pref,app)),this.dynheight.outerNode.css("max-width","inherit"),this.resize()}},et2_nextmatch._attributes={template:{name:"Template",type:"string",description:"The id of the template which contains the grid layout."},hide_header:{name:"Hide header",type:"boolean",description:"Hide the header",default:!1},header_left:{name:"Left custom template",type:"string",description:"Customise the nextmatch - left side.  Provided template becomes a child of nextmatch, and any input widgets are automatically bound to refresh the nextmatch on change.  Any inputs with an onChange attribute can trigger the nextmatch to refresh by returning true.",default:""},header_right:{name:"Right custom template",type:"string",description:"Customise the nextmatch - right side.  Provided template becomes a child of nextmatch, and any input widgets are automatically bound to refresh the nextmatch on change.  Any inputs with an onChange attribute can trigger the nextmatch to refresh by returning true.",default:""},header_row:{name:"Inline custom template",type:"string",description:"Customise the nextmatch - inline, after row count.  Provided template becomes a child of nextmatch, and any input widgets are automatically bound to refresh the nextmatch on change.  Any inputs with an onChange attribute can trigger the nextmatch to refresh by returning true.",default:""},no_filter:{name:"No filter",type:"boolean",description:"Hide the first filter",default:et2_no_init},no_filter2:{name:"No filter2",type:"boolean",description:"Hide the second filter",default:et2_no_init},disable_autorefresh:{name:"Disable autorefresh",type:"boolean",description:"Disable the ability to autorefresh the nextmatch on a regular interval.  ",default:!1},disable_selection_advance:{name:"Disable selection advance",type:"boolean",description:"If a refresh deletes the currently selected row, we normally advance the selection to the next row.  Set to true to stop this.",default:!1},view:{name:"View",type:"string",description:"Display entries as either 'row' or 'tile'.  A matching template must also be set after changing this.",default:et2_no_init},onselect:{name:"onselect",type:"js",default:et2_no_init,description:"JS code which gets executed when rows are selected.  Can also be a app.appname.func(selected) style method"},onfiledrop:{name:"onFileDrop",type:"js",default:et2_no_init,description:"JS code that gets executed when a _file_ is dropped on a row.  Other drop interactions are handled by the action system.  Return false to prevent the default link action."},onadd:{name:"onAdd",type:"js",default:et2_no_init,description:"JS code that gets executed when a new entry is added via refresh().  Allows apps to override the default handling.  Return false to cancel the add."},settings:{name:"Settings",type:"any",description:"The nextmatch settings",default:{}}},et2_nextmatch.ADD="add",et2_nextmatch.UPDATE_IN_PLACE="update-in-place",et2_nextmatch.UPDATE="update",et2_nextmatch.EDIT="edit",et2_nextmatch.DELETE="delete",et2_nextmatch.legacyOptions=["template","hide_header","header_left","header_right"],et2_nextmatch}(et2_core_DOMWidget_1.et2_DOMWidget);exports.et2_nextmatch=et2_nextmatch,et2_core_widget_1.et2_register_widget(et2_nextmatch,["nextmatch"]);var et2_nextmatch_header_bar=function(_super){function et2_nextmatch_header_bar(_parent,_attrs,_child){var _this=_super.call(this,_parent,[_parent,_parent.options.settings],et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_nextmatch_header_bar._attributes,_child||{}))||this;return _this.nextmatch=_parent,_this.div=jQuery(document.createElement("div")).addClass("nextmatch_header"),_this._createHeader(),_this.update_in_progress=!1,_this}return __extends(et2_nextmatch_header_bar,_super),et2_nextmatch_header_bar.prototype.destroy=function(){this.nextmatch=null,_super.prototype.destroy.call(this),this.div=null},et2_nextmatch_header_bar.prototype.setNextmatch=function(nextmatch){var create_once=null==this.nextmatch;this.nextmatch=nextmatch,create_once&&this._createHeader(),this.nextmatch.dataview.grid.setInvalidateCallback((function(){this.count_total.text(this.nextmatch.dataview.grid.getTotalCount()+"")}),this)},et2_nextmatch_header_bar.prototype.set_actions=function(actions){},et2_nextmatch_header_bar.prototype._createHeader=function(){var button,self=this,nm_div=this.nextmatch.getDOMNode(),settings=this.nextmatch.options.settings;this.div.prependTo(nm_div),this.headers=[{id:this.nextmatch.options.header_left},{id:this.nextmatch.options.header_right},{id:this.nextmatch.options.header_row}],this.header_div=this.row_div=jQuery(document.createElement("div")).addClass("nextmatch_header_row").appendTo(this.div),this.filter_div=jQuery(document.createElement("div")).addClass("filtersContainer").appendTo(this.row_div),this.search_box=jQuery(document.createElement("div")).addClass("search").prependTo(egwIsMobile()?this.nextmatch.getDOMNode():this.row_div);var searchbox_options={id:"search",overlay:void 0!==settings.searchbox&&void 0!==settings.searchbox.overlay&&settings.searchbox.overlay,onchange:function(){self.nextmatch.applyFilters({search:this.get_value()})},value:settings.search,fix:!egwIsMobile()};if(this.et2_searchbox=et2_core_widget_1.et2_createWidget("searchbox",searchbox_options,this),this.nextmatch.activeFilters.search=settings.search,this.et2_searchbox.set_value(settings.search),egwIsMobile()&&(this.search_box.addClass("nm-mob-header"),jQuery(this.div).css({display:"inline-block"}).addClass("nm_header_hide"),jQuery(document.createElement("div")).addClass("nm_appname_header").text(egw.lang(egw.app_name())).appendTo(this.search_box),this.delete_action=jQuery(document.createElement("div")).addClass("nm_delete_action").prependTo(this.search_box),this.fav_span=jQuery(document.createElement("div")).addClass("nm_favorites_div").prependTo(this.search_box),this.toggle_header=jQuery(document.createElement("button")).addClass("nm_toggle_header").click((function(){jQuery(self.div).toggleClass("nm_header_hide"),jQuery(this).toggleClass("nm_toggle_header_on"),window.setTimeout((function(){self.nextmatch.resize()}),800)})).prependTo(this.search_box),this.action_header=jQuery(document.createElement("button")).addClass("nm_action_header").hide().click((function(e){jQuery("tr.selected",self.nextmatch.getDOMNode()).trigger({type:"contextmenu",which:3,originalEvent:e})})).prependTo(this.search_box)),settings.no_cat||(void 0===settings.cat_id_label&&(settings.cat_id_label=""),this.category=this._build_select("cat_id",settings.cat_is_select?"select":"select-cat",settings.cat_id,!0!==settings.cat_is_select,{multiple:!1,tags:!0,class:"select-cat",value_class:settings.cat_id_class})),settings.no_filter||(this.filter=this._build_select("filter","select",settings.filter,settings.filter_no_lang)),settings.no_filter2||(this.filter2=this._build_select("filter2","select",settings.filter2,settings.filter2_no_lang,{multiple:!1,tags:settings.filter2_tags,class:"select-cat",value_class:settings.filter2_class})),this.right_div=jQuery(document.createElement("div")).addClass("header_row_right").appendTo(this.row_div),this.count=jQuery(document.createElement("span")).addClass("header_count ui-corner-all"),this.count_total=jQuery(document.createElement("span")).appendTo(this.count).text(settings.total+""),this.count.prependTo(this.right_div),this._setup_favorites(settings.favorites),void 0!==settings.csv_fields&&0!=settings.csv_fields){var definition_1=settings.csv_fields;!0===settings.csv_fields&&(definition_1=egw.preference("nextmatch-export-definition",this.nextmatch.egw().app_name()));var button_1=et2_core_widget_1.et2_createWidget("buttononly",{id:"export",statustext:"Export",image:"download",background_image:!0},this);jQuery(button_1.getDOMNode()).click(this.nextmatch,(function(event){egw_openWindowCentered2(egw.link("/index.php",{menuaction:"importexport.importexport_export_ui.export_dialog",appname:event.data.egw().getAppName(),definition:definition_1}),"_blank",850,440,"yes")}))}this.header_row=jQuery(document.createElement("div")).addClass("header_row").appendTo(this.right_div);var current_letter=this.nextmatch.options.settings.searchletter?this.nextmatch.options.settings.searchletter:!!this.nextmatch.activeFilters&&this.nextmatch.activeFilters.searchletter;if(this.nextmatch.options.settings.lettersearch||current_letter){this.lettersearch=jQuery(document.createElement("table")).addClass("nextmatch_lettersearch").css("width","100%").appendTo(this.div);var tbody=jQuery(document.createElement("tbody")).appendTo(this.lettersearch),row=jQuery(document.createElement("tr")).appendTo(tbody),letters=this.egw().lang("ABCDEFGHIJKLMNOPQRSTUVWXYZ").split("");for(var i in letters)button=jQuery(document.createElement("td")).addClass("lettersearch").appendTo(row).attr("id",letters[i]).text(letters[i]),letters[i]==current_letter&&button.addClass("lettersearch_active");button=jQuery(document.createElement("td")).addClass("lettersearch").appendTo(row).attr("id","").text(egw.lang("all")),current_letter||button.addClass("lettersearch_active"),this.lettersearch.click(this.nextmatch,(function(event){jQuery("td",this).removeClass("lettersearch_active"),jQuery(event.target).addClass("lettersearch_active"),event.data.applyFilters({searchletter:event.target.id||!1})})),this.nextmatch.activeFilters.searchletter=current_letter}var lettersearch_preference="nextmatch-"+this.nextmatch.options.settings.columnselection_pref+"-lettersearch";this.lettersearch&&!egw.preference(lettersearch_preference,this.nextmatch.egw().app_name())&&this.lettersearch.hide()},et2_nextmatch_header_bar.prototype._build_header=function(location,template_name){var id="left"==location?0:"right"==location?1:2,existing=this.headers[id];if(existing&&existing._type){if(existing.id==template_name)return;existing.destroy(),this.headers[id]=null}if(template_name){var self=this,header=et2_core_widget_1.et2_createWidget("template",{id:template_name},this);this.headers[id]=header;var deferred=[];header.loadingFinished(deferred),jQuery.when.apply(jQuery,deferred).then((function(){switch(id){case 0:jQuery(header.getDOMNode()).prependTo(self.header_div);break;case 1:jQuery(header.getDOMNode()).prependTo(self.header_div.find("div.header_row_right"));break;case 2:window.setTimeout((function(){jQuery(header.getDOMNode()).insertAfter(self.header_div.find("div.search"))}),1)}self._bindHeaderInput(header)}))}},et2_nextmatch_header_bar.prototype._build_select=function(name,type,value,lang,extra){var _a,widget_options=jQuery.extend({id:name,label:this.nextmatch.options.settings[name+"_label"],no_lang:lang,disabled:this.nextmatch.options["no_"+name]},extra),mgr=this.nextmatch.getArrayMgr("content"),options=mgr.getEntry("options-"+name);options||(options=this.nextmatch.getArrayMgr("sel_options").getEntry(name)),options||(options=null===(_a=this.nextmatch.getArrayMgr("sel_options").getParentMgr())||void 0===_a?void 0:_a.getEntry(name)),options||(options=mgr.getEntry("rows[sel_options]["+name+"]"));for(var row_stuck=["${row}","{$row}"],i=0;!options&&i<row_stuck.length;i++){var row_id="";options&&0!=options.length||!this.nextmatch.getArrayMgr("sel_options").perspectiveData.row&&!this.nextmatch.getArrayMgr("sel_options").data[row_stuck[i]]||(row_id=name.replace(/[0-9]+/,row_stuck[i]),(options=this.nextmatch.getArrayMgr("sel_options").getEntry(row_id))||(row_id=row_stuck[i]+"["+name+"]",options=this.nextmatch.getArrayMgr("sel_options").getEntry(row_id))),options&&this.egw().debug("warn",'Nextmatch filter options in a weird place - "%s".  Should be in sel_options[%s].',row_id,name)}"cat_id"==name&&null!=options&&void 0===options[""]&&void 0!==options[0]&&""!=options[0].value&&(widget_options.empty_label=this.egw().lang("All categories"));var select=et2_core_widget_1.et2_createWidget(type,widget_options,this);options&&select.set_select_options(options),select.set_value(value),this.nextmatch.activeFilters[select.id]=select.get_value();var input=select.input;if(select.attributes.select_options.ignore=!0,this.nextmatch.options.settings[name+"_onchange"]){var onchange_1=this.nextmatch.options.settings[name+"_onchange"];onchange_1.match(/this\.form\.submit/)&&(this.egw().debug("warn","%s tries to submit form, which is not allowed.  Filter changes automatically refresh data with no reload.",name),onchange_1=onchange_1.replace(/this\.form\.submit\([^)]*\);?/,"return true;")),select.change=et2_compileLegacyJS(onchange_1,this.nextmatch,select.getInputNode()),this._bindHeaderInput(select)}else input.change(this.nextmatch,(function(event){var set={};set[name]=select.getValue(),event.data.applyFilters(set)}));return select},et2_nextmatch_header_bar.prototype._setup_favorites=function(filters){if(void 0!==filters&&!1!==filters){var widget_options={default_pref:"nextmatch-"+this.nextmatch.options.settings.columnselection_pref+"-favorite",app:this.getInstanceManager().app,filters:filters,sidebox_target:"favorite_sidebox_"+this.getInstanceManager().app};this.favorites=et2_core_widget_1.et2_createWidget("favorites",widget_options,this),jQuery(this.favorites.getDOMNode(this.favorites)).prependTo(egwIsMobile()?this.search_box.find(".nm_favorites_div").show():this.right_div)}},et2_nextmatch_header_bar.prototype.setFilters=function(filters){if(!this.update_in_progress){this.update_in_progress=!0;var mgr=new et2_core_arrayMgr_1.et2_arrayMgr(filters);this.iterateOver((function(child){if(void 0===child.id||0!=child.id.indexOf("favorite")){var value="";if(void 0!==child.set_value&&child.id){if(null==(value=mgr.getEntry(child.id))&&(value=""),value&&"object"!=typeof value&&child.instanceOf(et2_widget_selectbox_1.et2_selectbox)){var found=void 0!==child.options.select_options[value];if(jQuery.isArray(child.options.select_options))for(var o=0;o<child.options.select_options.length;++o)if(child.options.select_options[o].value==value){found=!0;break}if(!found){var old_options=child.options.select_options;old_options[value]=child.egw().lang("Loading"),child.set_select_options(old_options)}}child.set_value(value)}if("function"==typeof child.get_value&&child.id){var target=this;value=child.get_value();for(var indexes=child.id.replace(/&#x5B;/g,"[").split("["),i=0;i<indexes.length;i++)indexes[i]=indexes[i].replace(/&#x5D;/g,"").replace("]",""),i<indexes.length-1?(void 0===target[indexes[i]]&&(target[indexes[i]]={}),target=target[indexes[i]]):target[indexes[i]]=value}}}),filters),this.nextmatch.options.settings.lettersearch&&(jQuery("td",this.lettersearch).removeClass("lettersearch_active"),jQuery(filters.searchletter?"td#"+filters.searchletter:"td.lettersearch[id='']",this.lettersearch).addClass("lettersearch_active"),filters.searchletter=jQuery("td.lettersearch_active",this.lettersearch).attr("id")||!1),this.update_in_progress=!1}},et2_nextmatch_header_bar.prototype.getDOMNode=function(_sender){for(var filters=[this.category,this.filter,this.filter2],i=0;i<filters.length;i++)if(_sender==filters[i])return this.filter_div[0];if(_sender==this.et2_searchbox)return this.search_box[0];if("export"==_sender.id)return this.right_div[0];if(_sender&&"template"==_sender._type)for(i=0;i<this.headers.length;i++)if(_sender.id==this.headers[i].id&&_sender._parent==this)return 2==i?this.header_row[0]:this.header_div[0];return null},et2_nextmatch_header_bar.prototype._bindHeaderInput=function(sub_header){var header=this,bind_change=function(_widget){var widget_change=_widget.change;_widget.change=function(_node){var result=widget_change.call(_widget,_node,header.nextmatch),entry=header.nextmatch.activeFilters,path=_widget.getArrayMgr("content").explodeKey(_widget.id),i=0;if(path.length>0)for(;i<path.length;i++)entry=entry[path[i]];if((result||void 0===result)&&entry!=_widget.getValue()&&!header.update_in_progress)if(null==_widget._oldValue){var path_1=_widget.getArrayMgr("content").explodeKey(_widget.id);if(path_1.length>0){for(var entry_1=header.nextmatch.activeFilters,i_1=0;i_1<path_1.length-1;i_1++)entry_1=entry_1[path_1[i_1]];delete entry_1[path_1[i_1]]}header.nextmatch.applyFilters(header.nextmatch.activeFilters)}else{var value_1=this.getInstanceManager().getValues(sub_header);header.nextmatch.applyFilters(value_1[header.nextmatch.id])}return!0};var value={};value[_widget.id]=_widget._oldValue=_widget.getValue();var mgr=new et2_core_arrayMgr_1.et2_arrayMgr(value);jQuery.extend(!0,this.nextmatch.activeFilters,mgr.data)};sub_header.instanceOf(et2_core_inputWidget_1.et2_inputWidget)?bind_change.call(this,sub_header):sub_header.iterateOver(bind_change,this,et2_core_inputWidget_1.et2_inputWidget)},et2_nextmatch_header_bar._attributes={filter_label:{name:"Filter label",type:"string",description:"Label for filter",default:"",translate:!0},filter_help:{name:"Filter help",type:"string",description:"Help message for filter",default:"",translate:!0},filter:{name:"Filter value",type:"any",description:"Current value for filter",default:""},no_filter:{name:"No filter",type:"boolean",description:"Remove filter",default:!1}},et2_nextmatch_header_bar}(et2_core_DOMWidget_1.et2_DOMWidget);et2_core_widget_1.et2_register_widget(et2_nextmatch_header_bar,["nextmatch_header_bar"]);var et2_nextmatch_header=function(_super){function et2_nextmatch_header(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_nextmatch_header._attributes,_child||{}))||this;return _this.labelNode=jQuery(document.createElement("span")),_this.nextmatch=null,_this.setDOMNode(_this.labelNode[0]),_this}return __extends(et2_nextmatch_header,_super),et2_nextmatch_header.prototype.setNextmatch=function(_nextmatch){this.nextmatch=_nextmatch},et2_nextmatch_header.prototype.set_label=function(_value){this.label=_value,this.labelNode.text(_value),this.labelNode.toggleClass("et2_label_empty",!_value)},et2_nextmatch_header._attributes={label:{name:"Caption",type:"string",description:"Caption for the nextmatch header",translate:!0}},et2_nextmatch_header}(et2_core_baseWidget_1.et2_baseWidget);exports.et2_nextmatch_header=et2_nextmatch_header,et2_core_widget_1.et2_register_widget(et2_nextmatch_header,["nextmatch-header"]);var et2_nextmatch_customfields=function(_super){function et2_nextmatch_customfields(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_nextmatch_customfields._attributes,_child||{}))||this;return _this.table.css("width","100%"),_this}return __extends(et2_nextmatch_customfields,_super),et2_nextmatch_customfields.prototype.destroy=function(){this.nextmatch=null,_super.prototype.destroy.call(this)},et2_nextmatch_customfields.prototype.transformAttributes=function(_attrs){if(_super.prototype.transformAttributes.call(this,_attrs),!_attrs.customfields){var data=this.getArrayMgr("modifications").getEntry(this.id);for(var key in data||(data=this.getArrayMgr("modifications").getRoot().getEntry("~custom_fields~",!0)),data)"object"!=typeof data[key]||_attrs[key]||(_attrs[key]=data[key])}},et2_nextmatch_customfields.prototype.setNextmatch=function(_nextmatch){this.nextmatch=_nextmatch,this.loadFields()},et2_nextmatch_customfields.prototype.loadFields=function(){if(null!=this.nextmatch){for(var columnMgr=this.nextmatch.dataview.getColumnMgr(),nm_column=null,set_fields={},i=0;i<this.nextmatch.columns.length;i++)if(this.nextmatch.columns[i].widget==this){nm_column=columnMgr.columns[i];break}if(nm_column){var global_data=this.getArrayMgr("modifications").getRoot().getEntry("~custom_fields~");null!=global_data&&global_data.fields&&(this.options.fields=global_data.fields);var apps=egw.link_app_list();for(var field_name in this.options.customfields){var field=this.options.customfields[field_name],cf_id=et2_extension_customfields_1.et2_customfields_list.PREFIX+field_name;if(!this.rows[field_name]){var row=jQuery(document.createElement("tr")).appendTo(this.tbody),cf=jQuery(document.createElement("td")).appendTo(row);this.rows[cf_id]=cf[0];var widget=null;"select"==field.type||"select-account"==field.type?(field.values&&void 0!==field.values[""]&&delete field.values[""],widget=et2_core_widget_1.et2_createWidget("select-account"==field.type?"nextmatch-accountfilter":"nextmatch-filterheader",{id:cf_id,empty_label:field.label,select_options:field.values},this)):widget=apps[field.type]?et2_core_widget_1.et2_createWidget("nextmatch-entryheader",{id:cf_id,only_app:field.type,blur:field.label},this):et2_core_widget_1.et2_createWidget("nextmatch-sortheader",{id:cf_id,label:field.label},this),this.isAttached()&&!widget.isAttached()&&widget.loadingFinished(),jQuery.isEmptyObject(this.options.fields)||0!=this.options.fields[field_name]&&void 0!==this.options.fields[field_name]?jQuery.isEmptyObject(this.options.fields)&&(set_fields[field_name]=!0):cf.hide()}}jQuery.extend(this.options.fields,set_fields)}}},et2_nextmatch_customfields.prototype.set_visible=function(_fields){_super.prototype.set_visible.call(this,_fields);var self=this;this.nextmatch&&this.nextmatch.iterateOver((function(widget){widget!=self&&widget.set_visible(_fields)}),this,et2_extension_customfields_1.et2_customfields_list)},et2_nextmatch_customfields.prototype._genColumnCaption=function(){return egw.lang("Custom fields")},et2_nextmatch_customfields.prototype._getColumnName=function(){var name=this.id,visible=[];for(var field_name in this.options.customfields)jQuery.isEmptyObject(this.options.fields)||1==this.options.fields[field_name]?(visible.push(et2_extension_customfields_1.et2_customfields_list.PREFIX+field_name),jQuery(this.rows[field_name]).show()):void 0!==this.rows[field_name]&&jQuery(this.rows[field_name]).hide();visible.length?name+="_"+visible.join("_"):this.rows&&jQuery(this.rows[field_name]).parent().parent().children().show();var data=this.getArrayMgr("modifications").getEntry(this.id);for(var field in data||(data=this.getArrayMgr("modifications").getRoot().getEntry("~custom_fields~",!0)||{}),data.fields||(data.fields={}),this.options.customfields)data.fields[field]=null!=this.options.fields&&void 0!==this.options.fields[field]&&this.options.fields[field];return name},et2_nextmatch_customfields._attributes={customfields:{name:"Custom fields",description:"Auto filled"},fields:{name:"Visible fields",description:"Auto filled"}},et2_nextmatch_customfields}(et2_extension_customfields_1.et2_customfields_list);exports.et2_nextmatch_customfields=et2_nextmatch_customfields,et2_core_widget_1.et2_register_widget(et2_nextmatch_customfields,["nextmatch-customfields"]);var et2_nextmatch_sortheader=function(_super){function et2_nextmatch_sortheader(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_nextmatch_sortheader._attributes,_child||{}))||this;return _this.sortmode="none",_this.labelNode.addClass("nextmatch_sortheader none"),_this}return __extends(et2_nextmatch_sortheader,_super),et2_nextmatch_sortheader.prototype.click=function(_event){return!(!this.nextmatch||!_super.prototype.click.call(this,_event))&&(this.nextmatch.sortBy(this.id,"none"==this.sortmode?!("DESC"==this.options.sortmode.toUpperCase()):void 0),!0)},et2_nextmatch_sortheader.prototype.set_sortmode=function(_mode){this.nextmatch||this.setSortmode(_mode)},et2_nextmatch_sortheader.prototype.setSortmode=function(_mode){this.labelNode.removeClass(this.sortmode).addClass(_mode),this.sortmode=_mode},et2_nextmatch_sortheader._attributes={sortmode:{name:"Sort order",type:"string",description:"Default sort order",translate:!1}},et2_nextmatch_sortheader}(et2_nextmatch_header);exports.et2_nextmatch_sortheader=et2_nextmatch_sortheader,et2_core_widget_1.et2_register_widget(et2_nextmatch_sortheader,["nextmatch-sortheader"]);var et2_nextmatch_filterheader=function(_super){function et2_nextmatch_filterheader(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(et2_nextmatch_filterheader,_super),et2_nextmatch_filterheader.prototype.createInputWidget=function(){this.options.empty_label||this.options.select_options&&this.options.select_options[""]||(this.options.empty_label=this.options.label?this.options.label:egw.lang("All")),_super.prototype.createInputWidget.call(this),jQuery(this.getInputNode()).change(this,(function(event){if(void 0!==event.data.nextmatch){var col_filter={};col_filter[event.data.id]=event.data.input.val(),event.data.set_value(event.data.input.val()),event.data.nextmatch.applyFilters({col_filter:col_filter})}}))},et2_nextmatch_filterheader.prototype.setNextmatch=function(_nextmatch){this.nextmatch=_nextmatch,this.nextmatch.activeFilters.col_filter&&void 0!==this.nextmatch.activeFilters.col_filter[this.id]&&(this.set_value(this.nextmatch.activeFilters.col_filter[this.id]),_nextmatch.activeFilters.col_filter[this.id]=this.getValue())},et2_nextmatch_filterheader.prototype.resize=function(){this.input.css("max-width",jQuery(this.parentNode).innerWidth()+"px")},et2_nextmatch_filterheader}(et2_widget_selectbox_1.et2_selectbox);exports.et2_nextmatch_filterheader=et2_nextmatch_filterheader,et2_core_widget_1.et2_register_widget(et2_nextmatch_filterheader,["nextmatch-filterheader"]);var et2_nextmatch_accountfilterheader=function(_super){function et2_nextmatch_accountfilterheader(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(et2_nextmatch_accountfilterheader,_super),et2_nextmatch_accountfilterheader.prototype.createInputWidget=function(){this.options.empty_label||this.options.select_options[""]||(this.options.empty_label=this.options.label?this.options.label:egw.lang("All")),_super.prototype.createInputWidget.call(this),this.input.change(this,(function(event){if(void 0!==event.data.nextmatch){var col_filter={};col_filter[event.data.id]=event.data.getValue(),event.data.nextmatch.applyFilters({col_filter:col_filter})}}))},et2_nextmatch_accountfilterheader.prototype.setNextmatch=function(_nextmatch){this.nextmatch=_nextmatch,this.nextmatch.activeFilters.col_filter&&this.nextmatch.activeFilters.col_filter[this.id]&&this.set_value(this.nextmatch.activeFilters.col_filter[this.id])},et2_nextmatch_accountfilterheader.prototype.resize=function(){for(var max=jQuery(this.parentNode).innerWidth()-4,surroundings=this.getSurroundings()._widgetSurroundings,i=0;i<surroundings.length;i++)max-=jQuery(surroundings[i]).outerWidth();this.input.css("max-width",max+"px")},et2_nextmatch_accountfilterheader}(et2_widget_selectAccount_1.et2_selectAccount);exports.et2_nextmatch_accountfilterheader=et2_nextmatch_accountfilterheader,et2_core_widget_1.et2_register_widget(et2_nextmatch_accountfilterheader,["nextmatch-accountfilter"]);var et2_nextmatch_taglistheader=function(_super){function et2_nextmatch_taglistheader(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(et2_nextmatch_taglistheader,_super),et2_nextmatch_taglistheader.prototype.createInputWidget=function(){this.options.empty_label||this.options.select_options&&this.options.select_options[""]||(this.options.empty_label=this.options.label?this.options.label:egw.lang("All")),_super.prototype.createInputWidget.call(this)},et2_nextmatch_taglistheader.prototype.set_select_options=function(options){options&&options.length<=2&&"toggle"==this.options.multiple&&this.set_multiple(!1),_super.prototype.set_select_options.call(this,options)},et2_nextmatch_taglistheader.prototype.setNextmatch=function(_nextmatch){this.nextmatch=_nextmatch,this.nextmatch.activeFilters.col_filter&&void 0!==this.nextmatch.activeFilters.col_filter[this.id]&&(this.set_value(this.nextmatch.activeFilters.col_filter[this.id]),_nextmatch.activeFilters.col_filter[this.id]=this.getValue())},et2_nextmatch_taglistheader.prototype.resize=function(){this.div.css("height",""),this.div.css("max-width",jQuery(this.parentNode).innerWidth()+"px"),_super.prototype.resize.call(this)},et2_nextmatch_taglistheader._attributes={autocomplete_url:{default:""},multiple:{default:"toggle"},onchange:{default:function(event){if(void 0!==this.nextmatch){var col_filter={};col_filter[this.id]=this.getValue(),this.nextmatch.applyFilters({col_filter:col_filter})}}},rows:{default:2},class:{default:"nm_filterheader_taglist"}},et2_nextmatch_taglistheader}(et2_widget_taglist_1.et2_taglist);et2_core_widget_1.et2_register_widget(et2_nextmatch_taglistheader,["nextmatch-taglistheader"]);var et2_nextmatch_entryheader=function(_super){function et2_nextmatch_entryheader(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(et2_nextmatch_entryheader,_super),et2_nextmatch_entryheader.prototype.onchange=function(event,selected){var col_filter={};col_filter[this.id]=this.get_value(),this.nextmatch.applyFilters.call(this.nextmatch,{col_filter:col_filter})},et2_nextmatch_entryheader.prototype.getValue=function(){var value=_super.prototype.getValue.call(this);if("object"==typeof value&&null!=value){if(!value.app||!value.id)return null;"object"==typeof value.id&&value.id.shift&&1==value.id.length&&(value.id=value.id.shift()),"string"==typeof value.id&&(value=value.app+":"+value.id)}return value},et2_nextmatch_entryheader.prototype.setNextmatch=function(_nextmatch){this.nextmatch=_nextmatch,this.nextmatch.options.settings.col_filter&&this.nextmatch.options.settings.col_filter[this.id]&&(this.set_value(this.nextmatch.options.settings.col_filter[this.id]),this.getValue()!=this.nextmatch.activeFilters.col_filter[this.id]&&(this.nextmatch.activeFilters.col_filter[this.id]=this.getValue()),this.attributes.value.ignore=!0)},et2_nextmatch_entryheader}(et2_widget_link_1.et2_link_entry);et2_core_widget_1.et2_register_widget(et2_nextmatch_entryheader,["nextmatch-entryheader"]);var et2_nextmatch_customfilter=function(_super){function et2_nextmatch_customfilter(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_nextmatch_customfilter._attributes,_child||{}))||this;switch(_attrs.widget_type){case"link-entry":_attrs.type="nextmatch-entryheader";break;default:0===_attrs.widget_type.indexOf("select")?_attrs.type="nextmatch-filterheader":_attrs.type=_attrs.widget_type}jQuery.extend(_attrs.widget_options,{id:_this.id}),_attrs.id="",(_this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_nextmatch_customfilter._attributes,_child||{}))||this).real_node=et2_core_widget_1.et2_createWidget(_attrs.type,_attrs.widget_options,_this.getParent());var select_options=[],correct_type=_attrs.type;return _this.real_node.type=_attrs.widget_type,et2_widget_selectbox_1.et2_selectbox.find_select_options(_this.real_node,select_options,_attrs),_this.real_node._type=correct_type,"function"==typeof _this.real_node.set_select_options&&_this.real_node.set_select_options(select_options),_this}return __extends(et2_nextmatch_customfilter,_super),et2_nextmatch_customfilter.prototype.getDOMNode=function(_sender){return this.real_node?this.real_node.getDOMNode(_sender):null},et2_nextmatch_customfilter.prototype.getChildren=function(){return this.real_node.getChildren()||[]},et2_nextmatch_customfilter.prototype.setNextmatch=function(_nextmatch){if(this.real_node&&this.real_node.instanceOf(et2_INextmatchHeader))return this.real_node.setNextmatch(_nextmatch)},et2_nextmatch_customfilter._attributes={widget_type:{name:"Actual type",type:"string",description:"The actual type of widget you should use",no_lang:1},widget_options:{name:"Actual options",type:"any",description:"The options for the actual widget",no_lang:1,default:{}}},et2_nextmatch_customfilter}(et2_nextmatch_filterheader);et2_core_widget_1.et2_register_widget(et2_nextmatch_customfilter,["nextmatch-customfilter"]);
/**
 * EGroupware eTemplate2 - JS Favorite widget
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2013
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget");var et2_widget_dropdown_button_1=require("./et2_widget_dropdown_button"),et2_favorites=(et2_core_inheritance_1=require("./et2_core_inheritance"),function(_super){function et2_favorites(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_favorites._attributes,_child||{}))||this;if(_this.header=null,_this.nextmatch=null,_this.favSortedList=null,_this.sidebox_target=null,_this.nm_filter=!1,_this.sidebox_target=jQuery("#"+_this.options.sidebox_target),0==_this.sidebox_target.length&&null!=egw_getFramework()){var egw_fw=egw_getFramework();_this.sidebox_target=jQuery("#"+_this.options.sidebox_target,egw_fw.sidemenuDiv)}_this.favSortedList=["blank"];var apps=egw().user("apps");et2_favorites.is_admin=void 0!==apps.admin,_this.options.app||(_this.options.app=_this.getInstanceManager().app),_this.stored_filters=_this.load_favorites(_this.options.app),_this.preferred=egw.preference(_this.options.default_pref,_this.options.app),_this.preferred&&void 0!==_this.stored_filters[_this.preferred]||(_this.preferred="blank"),_this.set_id(_this.id),_this.init_filters(_this),_this.menu.addClass("favorites"),_this.set_value(_this.preferred,!0);var self=_this;jQuery(_this.menu).on("click","input:radio",(function(event){event.stopImmediatePropagation(),self.egw().set_preference(self.options.app,self.options.default_pref,jQuery(this).val()),self.preferred=jQuery(this).val(),self.sidebox_target.length&&(jQuery("div.ui-icon-heart",self.sidebox_target).replaceWith("<div class='sideboxstar'/>"),jQuery("li[data-id='"+self.preferred+"'] div.sideboxstar",self.sidebox_target).replaceWith("<div class='ui-icon ui-icon-heart'/>")),self.menu.hide(),self.button.addClass("ui-state-active",500,"swing",(function(){self.button.removeClass("ui-state-active",2e3)}))}));return jQuery(_this.menu).sortable({items:'li:not([data-id$="add"])',placeholder:"ui-fav-sortable-placeholder",delay:250,update:function(){self.favSortedList=jQuery(this).sortable("toArray",{attribute:"data-id"}),self.egw().set_preference(self.options.app,"fav_sort_pref",self.favSortedList),function(_favSList){for(var favS=jQuery.isArray(_favSList)?_favSList.slice(0).reverse():[],i=0;i<favS.length;i++)self.sidebox_target.children().find('[data-id$="'+favS[i]+'"]').prependTo(self.sidebox_target.children())}(self.favSortedList)}}),_this.menu.on("click","div.ui-icon-trash",app[self.options.app],(function(){app[self.options.app].delete_favorite.apply(this,arguments)})).on("mouseenter","div.ui-icon-trash",(function(){jQuery(this).wrap("<span class='ui-state-active'/>")})).on("mouseleave","div.ui-icon-trash",(function(){jQuery(this).unwrap()})),_this.sidebox_target.length>0&&_this.init_filters(_this),_this}return __extends(et2_favorites,_super),et2_favorites.prototype.load_favorites=function(app){var stored_filters={blank:{name:this.egw().lang("No filters"),state:{}}},preferences=egw.preference("*",app);for(var pref_name in preferences){if(0==pref_name.indexOf(et2_favorites.PREFIX)&&"object"==typeof preferences[pref_name])stored_filters[pref_name.substr(et2_favorites.PREFIX.length)]=preferences[pref_name],preferences[pref_name].filters&&(stored_filters[pref_name].state=preferences[pref_name].filters);"fav_sort_pref"==pref_name&&(this.favSortedList=preferences[pref_name],jQuery.isArray(this.favSortedList)||(this.favSortedList=this.favSortedList.split(",")))}if(void 0!==stored_filters&&stored_filters){for(var name_2 in stored_filters)this.favSortedList.indexOf(name_2)<0&&this.favSortedList.push(name_2);if(this.egw().set_preference(this.options.app,"fav_sort_pref",this.favSortedList),this.favSortedList.length>0){for(var sortedListObj={},i=0;i<this.favSortedList.length;i++)void 0!==stored_filters[this.favSortedList[i]]?sortedListObj[this.favSortedList[i]]=stored_filters[this.favSortedList[i]]:(this.favSortedList.splice(i,1),this.egw().set_preference(this.options.app,"fav_sort_pref",this.favSortedList));stored_filters=jQuery.extend(sortedListObj,stored_filters)}}else stored_filters={};return stored_filters},et2_favorites.prototype.init_filters=function(widget,filters){void 0===filters&&(filters=this.stored_filters);var options={};for(var name_3 in filters)options[name_3]="<input type='radio' name='"+this.internal_ids.menu+"[button][favorite]' value='"+name_3+"' title='"+this.egw().lang("Set as default")+"'/>"+(null!=filters[name_3].name?filters[name_3].name:name_3)+(0!=filters[name_3].group&&!et2_favorites.is_admin||"blank"==name_3?"":"<div class='ui-icon ui-icon-trash' title='"+this.egw().lang("Delete")+"'/>");this.nextmatch&&(options.add="<img src='"+this.egw().image("new")+"'/>"+this.egw().lang("Add current")),widget.set_select_options.call(widget,options),jQuery("input[value='"+this.preferred+"']:radio",this.menu).attr("checked",1)},et2_favorites.prototype.set_nm_filters=function(filters){this.nextmatch?this.nextmatch.applyFilters(filters):console.log(filters)},et2_favorites.prototype.onclick=function(node){this.preferred&&this.stored_filters[this.preferred]?void 0!==app[this.options.app]?app[this.options.app].setState(this.stored_filters[this.preferred]):this.set_nm_filters(jQuery.extend({},this.stored_filters[this.preferred].state)):alert(this.egw().lang("No default set"))},et2_favorites.prototype.change=function(selected_node){if(this.value=jQuery(selected_node).attr("data-id"),"add"==this.value&&this.nextmatch){var current_filters=jQuery.extend({},this.nextmatch.activeFilters);for(var extra in this.options.filters)void 0===current_filters&&(current_filters[extra]=this.nextmatch.options.settings[extra]);if(delete current_filters.selcolumns,1!=this.filters)for(var i=0;i<this.filters.length;i++)current_filters[this.options.filters[i]]=this.nextmatch.options.settings[this.options.filters[i]];app[this.options.app].add_favorite(current_filters),this.set_value(this.preferred,!0)}else"blank"==this.value&&this.set_nm_filters({})},et2_favorites.prototype.set_value=function(filter_name,parent){return parent?_super.prototype.set_value.call(this,filter_name):("add"==filter_name||app[this.options.app].setState(this.stored_filters[filter_name]),!1)},et2_favorites.prototype.getValue=function(){return null},et2_favorites.prototype.setNextmatch=function(nextmatch){this.nextmatch=nextmatch,this.nm_filter&&(this.set_value(this.nm_filter),this.nm_filter=!1),this.init_filters(this)},et2_favorites._attributes={default_pref:{name:"Default preference key",type:"string",description:"The preference key where default favorite is stored (not the value)"},sidebox_target:{name:"Sidebox target",type:"string",description:"ID of element to insert favorite list into",default:"favorite_sidebox"},app:{name:"Application",type:"string",description:"Application to show favorites for"},filters:{name:"Extra filters",type:"any",description:"Array of extra filters to include in the saved favorite"},id:{default:"favorite"},label:{default:""},label_updates:{default:!1},image:{default:egw().image("fav_filter")},statustext:{default:"Favorite queries",type:"string"}},et2_favorites.PREFIX="favorite_",et2_favorites}(et2_widget_dropdown_button_1.et2_dropdown_button));et2_core_widget_1.et2_register_widget(et2_favorites,["favorites"]);
/**
 * EGroupware eTemplate2 - JS widget class containing raw HTML
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_valueWidget_1=require("./et2_core_valueWidget"),et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_html=function(_super){function et2_html(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_html._attributes,_child||{}))||this;return _this.htmlNode=null,_this.supportedWidgetClasses=[],_this.htmlNode=jQuery(document.createElement("span")),"htmlarea"==_this.getType()&&_this.htmlNode.addClass("et2_textbox_ro"),_this.options.label&&_this.htmlNode.append('<span class="et2_label">'+_this.options.label+"</span>"),_this.setDOMNode(_this.htmlNode[0]),_this}return __extends(et2_html,_super),et2_html.prototype.loadContent=function(_data){var html={html:_data||"",js:""};egw_seperateJavaScript(html),this.options.label&&this.htmlNode.append('<span class="et2_label">'+this.options.label+"</span>"),this.htmlNode.append(html.html),this.htmlNode.append(html.js)},et2_html.prototype.set_value=function(_value){this.htmlNode.empty(),this.loadContent(_value)},et2_html.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value","class")},et2_html.prototype.getDetachedNodes=function(){return[this.htmlNode[0]]},et2_html.prototype.setDetachedAttributes=function(_nodes,_values){this.htmlNode=jQuery(_nodes[0]),void 0!==_values.value&&this.set_value(_values.value)},et2_html._attributes={label:{default:"",description:"The label is displayed by default in front (for radiobuttons behind) each widget (if not empty). If you want to specify a different position, use a '%s' in the label, which gets replaced by the widget itself. Eg. '%s Name' to have the label Name behind a checkbox. The label can contain variables, as descript for name. If the label starts with a '@' it is replaced by the value of the content-array at this index (with the '@'-removed and after expanding the variables).",ignore:!1,name:"Label",translate:!0,type:"string"},needed:{ignore:!0},value:{name:"Value",description:"The value of the widget",type:"html",default:et2_no_init}},et2_html}(et2_core_valueWidget_1.et2_valueWidget);exports.et2_html=et2_html,et2_core_widget_1.et2_register_widget(et2_html,["html","htmlarea_ro"]);
/**
 * EGroupware eTemplate2 - JS Widget base class
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_inputWidget_1=require("./et2_core_inputWidget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_editableWidget=function(_super){function et2_editableWidget(_parent,_attrs,_child){var _this=this;if(_attrs.readonly&&"string"==typeof _attrs.readonly){_attrs.readonly=!0;var toggle_readonly=_attrs.toggle_readonly}return _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_editableWidget._attributes,_child||{}))||this,void 0!==toggle_readonly&&(_this._toggle_readonly=toggle_readonly),_this}return __extends(et2_editableWidget,_super),et2_editableWidget.prototype.destroy=function(){var node=this.getInputNode();node&&jQuery(node).off(".et2_editableWidget"),_super.prototype.destroy.call(this)},et2_editableWidget.prototype.transformAttributes=function(_attrs){_super.prototype.transformAttributes.call(this,_attrs)},et2_editableWidget.prototype.attachToDOM=function(){var res=_super.prototype.attachToDOM.call(this),node=this.getDOMNode();return node&&this._toggle_readonly?jQuery(node).off(".et2_editableWidget").on("dblclick.et2_editableWidget",this,(function(e){e.data.dblclick.call(e.data,this)})).addClass("et2_clickable et2_editable"):jQuery(node).addClass("et2_editable_readonly"),res},et2_editableWidget.prototype.detatchFromDOM=function(){_super.prototype.detatchFromDOM.call(this)},et2_editableWidget.prototype.dblclick=function(_node){this.set_readonly(!1),jQuery("body").on("click.et2_editableWidget",this,(function(e){jQuery.contains(this,e.target)&&"textarea"!=e.target.type&&(jQuery(this).off("click.et2_editableWidget"),e.data.focusout.call(e.data,this))}))},et2_editableWidget.prototype.focusout=function(_node){var value=this.get_value(),oldValue=this._oldValue;if(this.set_readonly(!0),value!=oldValue){if(!this.options.save_callback)return this.set_value(value),this.getInstanceManager().submit();var params=[value];this.options.save_callback_params&&(params=params.concat(this.options.save_callback_params.split(","))),egw.json(this.options.save_callback,params,(function(){}),this,!0,this).sendRequest()}},et2_editableWidget.prototype.submit=function(_values){if(this.options.readonly)return!0;this.set_readonly(!0);var params=[this.get_value()];return this.options.save_callback_params&&(params=params.concat(this.options.save_callback_params.split(","))),this.options.save_callback&&egw.json(this.options.save_callback,params,(function(){}),this,!0,this).sendRequest(),!0},et2_editableWidget._attributes={readonly:{name:"readonly",type:"string",default:!1,description:"If set to 'editable' will start readonly, double clicking will make it editable and clicking out will save",ignore:!0},toggle_readonly:{name:"toggle_readonly",type:"boolean",default:!0,description:"Double clicking makes widget editable.  If off, must be made editable in some other way."},save_callback:{name:"save_callback",type:"string",default:et2_no_init,description:"Ajax callback to save changed value when readonly is 'editable'.  If not provided, a regular submit is done."},save_callback_params:{name:"readonly",type:"string",default:et2_no_init,description:"Additional parameters passed to save_callback"},editable_height:{name:"Editable height",description:"Set height for widget while in edit mode",type:"string"}},et2_editableWidget}(et2_core_inputWidget_1.et2_inputWidget);exports.et2_editableWidget=et2_editableWidget;
/**
 * EGroupware eTemplate2 - JS widget for HTML editing
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Hadi Nategh <hn@egroupware.org>
 * @copyright Hadi Nategh <hn@egroupware.org>
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});var et2_core_editableWidget_1=require("./et2_core_editableWidget"),et2_htmlarea=(et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget"),function(_super){function et2_htmlarea(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_htmlarea._attributes,_child||{}))||this;return _this.editor=null,_this.htmlNode=null,_this.editor=null,_this.supportedWidgetClasses=[],_this.htmlNode=jQuery(document.createElement(_this.options.readonly?"div":"textarea")).addClass("et2_textbox_ro"),_this.options.height&&_this.htmlNode.css("height",_this.options.height),_this.setDOMNode(_this.htmlNode[0]),_this}return __extends(et2_htmlarea,_super),et2_htmlarea.prototype.doLoadingFinished=function(){return _super.prototype.doLoadingFinished.call(this),this.init_editor(),!0},et2_htmlarea.prototype.init_editor=function(){if("ascii"!=this.mode&&null==this.editor&&!this.options.readonly){var imageUpload,self=this;imageUpload=this.options.imageUpload&&"/"!==this.options.imageUpload[0]&&"http"!=this.options.imageUpload.substr(0,4)?(imageUpload=egw.ajaxUrl("EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_htmlarea_upload")+"&request_id="+this.getInstanceManager().etemplate_exec_id+"&widget_id="+this.options.imageUpload+"&type=htmlarea").substr(egw.webserverUrl.length+1):imageUpload?this.options.imageUpload.substr(egw.webserverUrl.length+1):egw.ajaxUrl("EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_htmlarea_upload")+"&request_id="+this.getInstanceManager().etemplate_exec_id+"&type=htmlarea";var settings={target:this.htmlNode[0],body_id:this.dom_id+"_htmlarea",menubar:!1,statusbar:this.options.statusbar,toolbar_mode:this.options.toolbar_mode,branding:!1,resize:!1,height:this.options.height,width:this.options.width,end_container_on_empty_block:!0,mobile:{theme:"silver"},formats:{customparagraph:{block:"p",styles:{"margin-block-start":"0px","margin-block-end":"0px"}}},min_height:100,convert_urls:!1,language:et2_htmlarea.LANGUAGE_CODE[egw.preference("lang","common")],language_url:egw.webserverUrl+"/api/js/tinymce/langs/"+et2_htmlarea.LANGUAGE_CODE[egw.preference("lang","common")]+".js",paste_data_images:!0,paste_filter_drop:!0,browser_spellcheck:!0,contextmenu:!1,images_upload_url:imageUpload,file_picker_callback:jQuery.proxy(this._file_picker_callback,this),images_upload_handler:this.options.images_upload_handler,init_instance_callback:jQuery.proxy(this._instanceIsReady,this),auto_focus:!1,valid_children:this.options.valid_children,plugins:["print searchreplace autolink directionality ","visualblocks visualchars image link media template fullscreen","codesample table charmap hr pagebreak nonbreaking anchor toc ","insertdatetime advlist lists textcolor wordcount imagetools ","colorpicker textpattern help paste code searchreplace tabfocus"],toolbar:et2_htmlarea.TOOLBAR_SIMPLE,block_formats:"Paragraph=p;Heading 1=h1;Heading 2=h2;Heading 3=h3;Heading 4=h4;Heading 5=h5;Heading 6=h6;Preformatted=pre;Custom Paragraph=customparagraph",font_formats:"Andale Mono=andale mono,times;Arial=arial,helvetica,sans-serif;Arial Black=arial black,avant garde;Book Antiqua=book antiqua,palatino;Comic Sans MS=comic sans ms,sans-serif;Courier New=courier new,courier;Georgia=georgia,palatino;Helvetica=helvetica;Impact=impact,chicago;Segoe=segoe,segoe ui;Symbol=symbol;Tahoma=tahoma,arial,helvetica,sans-serif;Terminal=terminal,monaco;Times New Roman=times new roman,times;Trebuchet MS=trebuchet ms,geneva;Verdana=verdana,geneva;Webdings=webdings;Wingdings=wingdings,zapf dingbats",fontsize_formats:"8pt 10pt 12pt 14pt 18pt 24pt 36pt",setup:function(ed){ed.on("init",(function(){this.getDoc().body.style.fontSize=egw.preference("rte_font_size","common")+egw.preference("rte_font_unit","common"),this.getDoc().body.style.fontFamily=egw.preference("rte_font","common")}))}};jQuery.extend(settings,this._extendedSettings()),this.tinymce=tinymce.init(settings),this.tinymce.then((function(){self.set_value(self.htmlNode.val()),self.resetDirty(),self.editor&&self.editor.editorContainer&&(self.editor.formatter.toggle(egw.preference("rte_formatblock","common")),jQuery(self.editor.editorContainer).height(self.options.height),jQuery(self.editor.iframeElement.contentWindow.document).on("dragenter",(function(){jQuery("#dragover-tinymce").length<1&&jQuery("<style id='dragover-tinymce'>.dragover:after {height:calc(100% - "+jQuery(this).height()+"px) !important;}</style>").appendTo("head")})))}))}},et2_htmlarea.prototype.set_disabled=function(_value){_super.prototype.set_disabled.call(this,_value),_value?jQuery(this.tinymce_container).css("display","none"):jQuery(this.tinymce_container).css("display","flex")},et2_htmlarea.prototype.set_readonly=function(_value){if(this.options.readonly!==_value){var value=this.get_value();this.options.readonly=_value,this.options.readonly?(this.editor&&this.editor.remove(),this.htmlNode=jQuery(document.createElement(this.options.readonly?"div":"textarea")).addClass("et2_textbox_ro"),this.options.height&&this.htmlNode.css("height",this.options.height),this.editor=null,this.setDOMNode(this.htmlNode[0]),this.set_value(value)):this.editor||(this.htmlNode=jQuery(document.createElement("textarea")).val(value),(this.options.height||this.options.editable_height)&&this.htmlNode.css("height",this.options.editable_height?this.options.editable_height:this.options.height),this.setDOMNode(this.htmlNode[0]),this.init_editor())}},et2_htmlarea.prototype._file_picker_callback=function(_callback,_value,_meta){if("function"==typeof this.file_picker_callback)return this.file_picker_callback.call(arguments,this);var callback=_callback,etemplate=jQuery("form").data("etemplate"),vfsSelect=et2_createWidget("vfs-select",{id:"upload",mode:"open",name:"",button_caption:"Link",button_label:"Link",dialog_title:"Link file",method:"download"},etemplate&&etemplate.name&&!app[egw(window).app_name()]?etemplate2.getByTemplate(etemplate.name)[0].widgetContainer:app[egw(window).app_name()].et2);jQuery(vfsSelect.getDOMNode()).on("change",(function(){callback(vfsSelect.get_value(),{alt:vfsSelect.get_value()})})),vfsSelect.click()},et2_htmlarea.prototype._instanceIsReady=function(_editor){console.log("Editor: "+_editor.id+" is now initialized.");var focusedEl=jQuery(":focus");this.editor=_editor,this.editor.on("drop",(function(e){e.preventDefault()})),this.disabled||jQuery(this.editor.editorContainer).css("display","flex"),this.tinymce_container=this.editor.editorContainer,focusedEl.focus()},et2_htmlarea.prototype._extendedSettings=function(){var rte_menubar=egw.preference("rte_menubar","common"),rte_toolbar=egw.preference("rte_toolbar","common");rte_toolbar&&"object"==typeof rte_toolbar&&""==this.toolbar?rte_toolbar=Object.keys(rte_toolbar).map((function(key){return rte_toolbar[key]})):""!=this.toolbar&&(rte_toolbar=this.toolbar.split(","));var settings={fontsize_formats:et2_htmlarea.FONT_SIZE_FORMATS[egw.preference("rte_font_unit","common")],menubar:!(!parseInt(rte_menubar)||!this.menubar)||void 0===rte_menubar&&this.menubar};switch(this.mode){case"simple":settings.toolbar=et2_htmlarea.TOOLBAR_SIMPLE;break;case"extended":settings.toolbar=et2_htmlarea.TOOLBAR_EXTENDED;break;case"advanced":settings.toolbar=et2_htmlarea.TOOLBAR_ADVANCED;break;default:this.mode=""}if(rte_toolbar&&!this.mode){var toolbar_diff=et2_htmlarea.TOOLBAR_LIST.filter((function(i){return!(rte_toolbar.indexOf(i)>-1)}));settings.toolbar=et2_htmlarea.TOOLBAR_ADVANCED,toolbar_diff.forEach((function(a){var r=new RegExp(a);settings.toolbar=settings.toolbar.replace(r,"")}))}return settings},et2_htmlarea.prototype.destroy=function(){this.editor&&this.editor.destroy(),this.editor=null,this.tinymce=null,this.tinymce_container=null,this.htmlNode.remove(),this.htmlNode=null,_super.prototype.destroy.call(this)},et2_htmlarea.prototype.set_value=function(_value){this._oldValue=_value,this.editor?this.editor.setContent(_value):this.options.readonly?this.htmlNode.empty().append(_value):this.htmlNode.val(_value),this.value=_value},et2_htmlarea.prototype.getValue=function(){return this.editor?this.editor.getContent():this.options.readonly?this.value:this.htmlNode.val()},et2_htmlarea.prototype.resize=function(_height){if(_height&&"0"!==this.options.resize_ratio&&0!=(_height=""!=this.options.resize_ratio?_height*this.options.resize_ratio:_height))if(this.editor){var h=void 0;h=void 0!==this.editor.iframeElement&&this.editor.editorContainer.clientHeight>0?this.editor.editorContainer.clientHeight+_height>0?this.editor.editorContainer.clientHeight+_height:this.editor.settings.min_height:this.editor.settings.min_height+_height,jQuery(this.editor.editorContainer).height(h),jQuery(this.editor.iframeElement).height(h-(this.editor.editorContainer.getElementsByClassName("tox-toolbar")[0].clientHeight+this.editor.editorContainer.getElementsByClassName("tox-statusbar")[0].clientHeight))}else this.htmlNode.height(this.htmlNode.height()+_height)},et2_htmlarea._attributes={mode:{name:"Mode",description:"One of {ascii|simple|extended|advanced}",default:"",type:"string"},height:{name:"Height",default:et2_no_init,type:"string"},width:{name:"Width",default:et2_no_init,type:"string"},value:{name:"Value",description:"The value of the widget",type:"html",default:et2_no_init},imageUpload:{name:"imageUpload",description:"Url to upload images dragged in or id of link_to widget to it's vfs upload. Can also be just a name for which content array contains a path to upload the picture.",type:"string",default:null},file_picker_callback:{name:"File picker callback",description:"Callback function to get called when file picker is clicked",type:"js",default:et2_no_init},images_upload_handler:{name:"Images upload handler",description:"Callback function for handling image upload",type:"js",default:et2_no_init},menubar:{name:"Menubar",description:"Display menubar at the top of the editor",type:"boolean",default:!0},statusbar:{name:"Status bar",description:"Enable/disable status bar on the bottom of editor",type:"boolean",default:!0},valid_children:{name:"Valid children",description:"Enables to control what child tag is allowed or not allowed of the present tag. For instance: +body[style], makes style tag allowed inside body",type:"string",default:"+body[style]"},toolbar:{name:"Toolbar",description:"Comma separated string of toolbar actions. It will only be considered if no Mode is restricted.",default:"",type:"string"},toolbar_mode:{name:"toolbar mode",type:"string",default:"floating",description:"It allows to extend the toolbar to accommodate the overflowing toolbar buttons. {floating, sliding, scrolling, wrap}"}},et2_htmlarea.TOOLBAR_LIST=["undo","redo","formatselect","fontselect","fontsizeselect","bold","italic","strikethrough","forecolor","backcolor","link","alignleft","aligncenter","alignright","alignjustify","numlist","bullist","outdent","indent","ltr","rtl","removeformat","code","image","searchreplace","fullscreen","table"],et2_htmlarea.TOOLBAR_SIMPLE="undo redo|formatselect fontselect fontsizeselect | bold italic removeformat forecolor backcolor | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent| link image pastetext | table",et2_htmlarea.TOOLBAR_EXTENDED="fontselect fontsizeselect | bold italic strikethrough forecolor backcolor | link | alignleft aligncenter alignright alignjustify  | numlist bullist outdent indent | removeformat | image | fullscreen | table",et2_htmlarea.TOOLBAR_ADVANCED="undo redo| formatselect | fontselect fontsizeselect | bold italic strikethrough forecolor backcolor | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent ltr rtl | removeformat code| link image pastetext | searchreplace | fullscreen | table",et2_htmlarea.FONT_SIZE_FORMATS={pt:"8pt 9pt 10pt 11pt 12pt 14pt 16pt 18pt 20pt 22pt 24pt 26pt 28pt 36pt 48pt 72pt",px:"8px 9px 10px 11px 12px 14px 16px 18px 20px 22px 24px 26px 28px 36px 48px 72px"},et2_htmlarea.LANGUAGE_CODE={bg:"bg_BG",ca:"ca",cs:"cs",da:"da",de:"de",en:"en_CA",el:"el","es-es":"es",et:"et",eu:"eu",fa:"fa_IR",fi:"fi",fr:"fr_FR",hi:"",hr:"hr",hu:"hu_HU",id:"id",it:"it",iw:"",ja:"ja",ko:"ko_KR",lo:"",lt:"lt",lv:"lv",nl:"nl",no:"nb_NO",pl:"pl",pt:"pt_PT","pt-br":"pt_BR",ru:"ru",sk:"sk",sl:"sl_SI",sv:"sv_SE",th:"th_TH",tr:"tr_TR",uk:"en_GB",vi:"vi_VN",zh:"zh_CN","zh-tw":"zh_TW"},et2_htmlarea}(et2_core_editableWidget_1.et2_editableWidget));exports.et2_htmlarea=et2_htmlarea,et2_core_widget_1.et2_register_widget(et2_htmlarea,["htmlarea"]);
/**
 * EGroupware eTemplate2 - JS Tabs object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0}),require("./et2_core_common");et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget"),et2_core_valueWidget_1=require("./et2_core_valueWidget");var et2_extension_nextmatch_1=require("./et2_extension_nextmatch"),et2_tabbox=function(_super){function et2_tabbox(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_tabbox._attributes,_child||{}))||this;return _this.selected_index=0,_this.tabData=[],_this.container=jQuery(document.createElement("div")).addClass("et2_tabbox"),_this.flagContainer=jQuery(document.createElement("div")).addClass("et2_tabheader").appendTo(_this.container),_this.tabContainer=jQuery(document.createElement("div")).addClass("et2_tabs").appendTo(_this.container),_this}return __extends(et2_tabbox,_super),et2_tabbox.prototype.destroy=function(){_super.prototype.destroy.call(this),this.container=null,this.flagContainer=null,this.tabData=[]},et2_tabbox.prototype._readTabs=function(tabData,tabs){var selected="";this.selected_index=!1;var hidden={};if(this.id){var val,contentMgr=this.getArrayMgr("content");if(null!=contentMgr)null!==(val=contentMgr.getEntry(this.id))&&(selected=val);if(null!=(contentMgr=this.getArrayMgr("readonlys")))null!=(val=contentMgr.getEntry(this.id))&&(hidden=val)}var i=0;et2_filteredNodeIterator(tabs,(function(node,nodeName){if("tab"!=nodeName)throw"Error while parsing: Invalid tag '"+nodeName+"' in tabs tag";var index_name=et2_readAttrWithDefault(node,"id",""),hide=!1,widget_options={};if(index_name){selected==index_name&&(this.selected_index=i),hidden[index_name]&&(hide=!0);var classAttr=et2_readAttrWithDefault(node,"class","");classAttr&&(widget_options={class:classAttr})}tabData.push({id:index_name,label:this.egw().lang(et2_readAttrWithDefault(node,"label","Tab")),widget:null,widget_options:widget_options,contentDiv:null,flagDiv:null,hidden:hide,XMLNode:null,promise:null}),i++}),this);for(i=0;i<tabData.length&&!1===this.selected_index;i++)tabData[i].hidden||(this.selected_index=i)},et2_tabbox.prototype._readTabPanels=function(tabData,tabpanels){var i=0;et2_filteredNodeIterator(tabpanels,(function(node,nodeName){if(!(i<tabData.length))throw"Error while reading tabpanels tag, too many widgets!";tabData[i].XMLNode=node,i++}),this)},et2_tabbox.prototype.loadFromXML=function(_node){var tabsElems=et2_directChildrenByTagName(_node,"tabs"),tabpanelsElems=et2_directChildrenByTagName(_node,"tabpanels"),tabData=[],height=et2_readAttrWithDefault(_node.parentNode,"height",null);if(height&&this.tabContainer.css("height",height),!this.options.tabs||this.options.add_tabs)if(1==tabsElems.length&&1==tabpanelsElems.length){var tabs=tabsElems[0],tabpanels=tabpanelsElems[0];this._readTabs(tabData,tabs),this._readTabPanels(tabData,tabpanels)}else this.egw().debug("error","Error while parsing tabbox, none or multiple tabs or tabpanels tags!",this);if(this.options.tabs)for(var readonly=this.getArrayMgr("readonlys").getEntry(this.id)||{},i=0;i<this.options.tabs.length;i++){var tab=this.options.tabs[i],tab_id=tab.id||tab.template,tab_options={id:tab_id,template:tab.template,url:tab.url,content:void 0};tab.id&&(tab_options.content=tab.id),tabData[tab.prepend?"unshift":"push"].call(tabData,{id:tab_id,label:this.egw().lang(tab.label),widget:null,widget_options:tab_options,contentDiv:null,flagDiv:null,hidden:void 0!==tab.hidden?tab.hidden:readonly[tab_id]||!1,XMLNode:null,promise:null})}this.createTabs(tabData)},et2_tabbox.prototype.doLoadingFinished=function(){var tab_deferred=jQuery.Deferred(),promises=[],tabs=this;if(this._loadTab(this.selected_index,promises),!this.isInTree()||!this.isAttached())return _super.prototype.doLoadingFinished.call(this),this._children[0].loadingFinished(promises),window.setTimeout((function(){for(var i=0;i<tabs.tabData.length;i++)i!=tabs.selected_index&&tabs._loadTab(i,promises);jQuery.when.apply(jQuery,promises).then((function(){tab_deferred.resolve(),tabs.resetDirty()}))}),0),tab_deferred.promise()},et2_tabbox.prototype._loadTab=function(index,promises){var tabData=this.tabData[index];tabData&&!tabData.loaded&&(tabData.loaded=!0,null!=tabData.XMLNode?(tabData.hidden&&(tabData.XMLNode=tabData.XMLNode.cloneNode(),tabData.XMLNode.setAttribute("readonly",!0)),tabData.widget=this.createElementFromNode(tabData.XMLNode,tabData.XMLNode.nodeName.toLowerCase()),tabData.XMLNode=null):tabData.widget_options&&(tabData.widget=et2_core_widget_1.et2_createWidget("template",tabData.widget_options,this)))},et2_tabbox.prototype.transformAttributes=function(_attrs){_super.prototype.transformAttributes.call(this,_attrs);var data=this.getArrayMgr("modifications").getEntry(this.id);for(var key in data)"object"!=typeof data[key]||_attrs[key]||(_attrs[key]=data[key])},et2_tabbox.prototype.createTabs=function(tabData){this.tabData=tabData,this.tabContainer.empty(),this.flagContainer.empty();for(var i=0;i<this.tabData.length;i++){var entry=this.tabData[i];entry.flagDiv=jQuery(document.createElement("span")).addClass("et2_tabflag").appendTo(this.flagContainer),entry.widget_options&&void 0!==entry.widget_options.class&&entry.flagDiv.addClass(entry.widget_options.class),entry.flagDiv.text(entry.label||"Tab"),entry.hidden||1===this.tabData.length?entry.flagDiv.hide():entry.flagDiv.click({tabs:this,idx:i},(function(e){e.data.tabs.setActiveTab(e.data.idx)})),entry.contentDiv=jQuery(document.createElement("div")).addClass("et2_tabcntr").appendTo(this.tabContainer),"v"==this.options.align_tabs&&(entry.flagDiv.unbind("click"),entry.flagDiv.text(""),jQuery(document.createElement("div")).addClass("et2_tabtitle").text(entry.label||"Tab").click({tabs:this,idx:i},(function(e){e.data.tabs.flagContainer.children(":eq("+e.data.idx+")").toggleClass("active"),e.data.tabs.selected_index!=e.data.idx&&e.data.tabs.setActiveTab(e.data.idx)})).appendTo(entry.flagDiv),entry.contentDiv.appendTo(entry.flagDiv))}if("v"==this.options.align_tabs&&(this.container.addClass("vertical"),this.tabContainer.hide()),this.options.value){this.selected_index=0;for(i=0;i<this.tabData.length;i++)if(this.tabData[i].id==this.options.value){this.selected_index=i;break}}this.setActiveTab(this.selected_index)},et2_tabbox.prototype.get_active_tab=function(){return this.selected_index},et2_tabbox.prototype.setActiveTab=function(_idx){this.selected_index=_idx,jQuery(".et2_tabflag",this.flagContainer).removeClass("active"),this.tabContainer.children().hide(),this.flagContainer.children(":eq("+_idx+")").addClass("active"),this.tabContainer.children(":eq("+_idx+")").show(),this._children.length>0&&this.tabData&&this.tabData.length>0&&this.tabData[_idx].widget.iterateOver((function(nm){nm&&"nextmatch"==nm._type&&nm.resize()}),this.tabData[_idx].widget,et2_extension_nextmatch_1.et2_nextmatch)},et2_tabbox.prototype.activateTab=function(widget){for(var tab=widget;tab._parent&&"tabbox"!=tab._parent._type;)tab=tab._parent;this._children.indexOf(tab);for(var i=0;i<this.tabData.length;i++)if(this.tabData[i].widget==tab)return this.setActiveTab(i),!0;return!1},et2_tabbox.prototype.getDOMNode=function(_sender){if(_sender===this||void 0===_sender)return this.container[0];for(var i=0;i<this.tabData.length;i++)if(this.tabData[i].widget==_sender)return this.tabData[i].contentDiv[0];return null},et2_tabbox.prototype.set_tab_height=function(_height){this.tab_height=_height,this.tabContainer.css("height",_height)},et2_tabbox.prototype.set_height=function(_value){this.height=_value,this.tabContainer.css("height",_value)},et2_tabbox.prototype.getValue=function(){return!1!==this.selected_index?this.tabData[this.selected_index].id:void 0},et2_tabbox.prototype.isDirty=function(){return!1},et2_tabbox.prototype.resetDirty=function(){this.value=this.selected_index},et2_tabbox.prototype.isValid=function(messages){return!0},et2_tabbox.prototype.resize=function(_height){_height?this.set_height(this.tabContainer.height()+_height):0===_height&&this.set_height(this.tabContainer.height())},et2_tabbox.prototype.beforePrint=function(){jQuery(".et2_tabflag",this.flagContainer).removeClass("active"),this.tabContainer.css("height","");for(var i=0;i<this.tabData.length;i++){var entry=this.tabData[i];entry.hidden||(entry.flagDiv.insertBefore(entry.contentDiv),entry.contentDiv.show())}},et2_tabbox.prototype.afterPrint=function(){for(var i=0;i<this.tabData.length;i++){this.tabData[i].flagDiv.appendTo(this.flagContainer)}this.setActiveTab(this.get_active_tab())},et2_tabbox._attributes={tabs:{name:"Tabs",default:et2_no_init,description:"Array of [extra] tabs.  Each tab needs {label:..., template:...}.  Additional optional keys are prepend, hidden and id, for access into content array"},add_tabs:{name:"Add tabs",default:!1,description:"Set to true if tabs should be added to tabs from read from template, default false if not"},tab_height:{name:"Tabs innerHeight",default:"",description:"Set the innerHeight for the tab content"},align_tabs:{name:"Tabs alignment",type:"string",default:"h",description:"Set tabs and their headers arrangment either horizental (h) or vertical (v). Default value is horizental."}},et2_tabbox}(et2_core_valueWidget_1.et2_valueWidget);et2_core_widget_1.et2_register_widget(et2_tabbox,["tabbox"]);
/**
 * EGroupware eTemplate2 - JS Timestamp button object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2017
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_widget_button_1=require("./et2_widget_button"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_timestamper=function(_super){function et2_timestamper(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_timestamper._attributes,_child||{}))||this;return jQuery(_this.getDOMNode()).addClass("et2_timestamper"),_this}return __extends(et2_timestamper,_super),et2_timestamper.prototype.click=function(_ev){return this.options.readonly||this._insert_text(),!1},et2_timestamper.prototype._insert_text=function(){var text="",now=new Date((new Date).toLocaleString("en-US",{timeZone:this.options.timezone?this.options.timezone:egw.preference("tz")}));text+=date((this.options.format?this.options.format:egw.preference("dateformat")+" "+("12"===egw.preference("timeformat")?"h:ia":"H:i"))+" ",now);for(var user=parseInt(egw.user("account_id")),accounts=egw.accounts("accounts"),j=0;j<accounts.length;j++)if(accounts[j].value===user){text+=accounts[j].label;break}text+=": ";var widget=this._get_input(this.target),input=widget.input?widget.input:widget.getDOMNode();input.context&&(input=input.get(0));var scrollPos=input.scrollTop,browser=input.selectionStart||"0"==input.selectionStart?"standards":!!document.selection&&"ie",pos=0,tinymce=tinyMCE&&tinyMCE.EditorManager.get(input.id)||!1;"ie"==browser?(input.focus(),(range=document.selection.createRange()).moveStart("character",-input.value.length),pos=range.text.length):"standards"==browser&&(pos=input.selectionStart);if(tinymce)tinymce.insertContent(text);else{var range,front=input.value.substring(0,pos),back=input.value.substring(pos,input.value.length);if(input.value=front+text+back,pos+=text.length,"ie"==browser)input.focus(),(range=document.selection.createRange()).moveStart("character",-input.value.length),range.moveStart("character",pos),range.moveEnd("character",0),range.select();else"standards"==browser&&(input.selectionStart=pos,input.selectionEnd=pos,input.focus());input.scrollTop=scrollPos,input.focus()}for(var tab=widget;tab._parent&&"tabbox"!=tab._type;)tab=tab._parent;"tabbox"==tab._type&&tab.activateTab(widget)},et2_timestamper.prototype._get_input=function(target){var _a,input=null,widget=null;return"string"==typeof target?widget=this.getRoot().getWidgetById(target):target.instanceOf&&target.instanceOf(et2_IInput)?widget=target:"string"==typeof target&&target.indexOf("#")<0&&jQuery("#"+this.target).is("input")&&(input=this.target),widget||((null===(_a=input)||void 0===_a?void 0:_a.context)&&(input=input.get(0)),input)},et2_timestamper._attributes={target:{name:"Target field",type:"string",default:et2_no_init,description:"Which field to place the timestamp in"},format:{name:"Time format",type:"string",default:et2_no_init,description:"Format for the timestamp.  User is always after."},timezone:{name:"Timezone",type:"string",default:et2_no_init,description:"Timezone.  Default is user time."},statustext:{default:"Insert timestamp into description field"},image:{default:"timestamp"},background_image:{default:!0}},et2_timestamper}(et2_widget_button_1.et2_button);et2_core_widget_1.et2_register_widget(et2_timestamper,["button-timestamp","timestamper"]);
/**
 * EGroupware eTemplate2 - JS toolbar object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2013
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_DOMWidget_1=require("./et2_core_DOMWidget"),et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance");require("../egw_action/egw_action.js");et2_widget_dialog_1=require("./et2_widget_dialog");var et2_toolbar=function(_super){function et2_toolbar(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_toolbar._attributes,_child||{}))||this;return _this.value=null,_this.actionbox=null,_this.actionlist=null,_this.div=null,_this.countActions=0,_this.dropdowns={},_this.preference={},_this.menu=null,_this._objectManager=null,_this.div=jQuery(document.createElement("div")).addClass("et2_toolbar ui-widget-header ui-corner-all"),_this.set_id(_this.id),_this.actionbox=jQuery(document.createElement("div")).addClass("et2_toolbar_more").attr("id",_this.id+"-actionbox"),_this.actionlist=jQuery(document.createElement("div")).addClass("et2_toolbar_actionlist").attr("id",_this.id+"-actionlist"),_this.countActions=0,_this.dropdowns={},_this.preference={},_this._build_menu(et2_toolbar.default_toolbar,!0),_this}return __extends(et2_toolbar,_super),et2_toolbar.prototype.destroy=function(){this.div&&this.div.data("ui-menu")&&this.menu.menu("destroy"),this.div.empty().remove(),this.actionbox.empty().remove(),this.actionlist.empty().remove()},et2_toolbar.prototype._fix_preference=function(_action){if("mail-display_displayToolbar"===this.dom_id||"mail-index_toolbar"===this.dom_id)switch(_action.id){case"read":case"label1":case"label2":case"label3":case"label4":case"label5":this.set_prefered(_action.id,!_action.toolbarDefault);break;default:this.set_prefered(_action.id,!1)}else this.set_prefered(_action.id,!1/*!toolbarDefault*/)},et2_toolbar.prototype._countActions=function(actions){var totalCount=0,childCounter=function(action,count){var children=action.children||0,returnCounter=count||0;if(children)for(var nChild in returnCounter-=1,children)returnCounter+=1,returnCounter=childCounter(children[nChild],returnCounter);else returnCounter=count;return returnCounter};for(var nAction in actions)this.options.flat_list?totalCount+=childCounter(actions[nAction],1):totalCount++;return totalCount},et2_toolbar.prototype._build_menu=function(actions,isDefault){this.div.empty(),this.actionbox.empty(),this.actionlist.empty();var admin_setting=this.options.is_admin?'<span class="toolbar-admin-pref" title="'+egw.lang("Admin settings")+' ..."></span>':"";this.actionbox.append('<h class="ui-toolbar-menulistHeader">'+egw.lang("more")+" ..."+admin_setting+"</h>"),this.actionbox.append('<div id="'+this.id+'-menulist" class="ui-toolbar-menulist" ></div>');var that=this;this.options.is_admin&&this.actionbox.find(".toolbar-admin-pref").click((function(e){e.stopImmediatePropagation(),egw.json("EGroupware\\Api\\Etemplate\\Widget\\Toolbar::ajax_get_default_prefs",[egw.app_name(),that.dom_id],(function(_prefs){var prefs=[];for(var p in _prefs)!1===_prefs[p]&&prefs.push(p);that._admin_settings_dialog.call(that,actions,prefs)})).sendRequest(!0)}));var pref=egwIsMobile()?void 0:egw.preference(this.dom_id,this.egw().app_name());if(pref&&!jQuery.isArray(pref)&&(this.preference=pref),void 0!==pref||isDefault){if(!isDefault)for(var name in actions)void 0!==actions[name].children&&this.options.flat_list||void 0!==pref[name]||this._fix_preference(actions[name])}else for(var name in actions)void 0!==actions[name].children&&this.options.flat_list||!actions[name].id||this.set_prefered(actions[name].id,!actions[name].toolbarDefault);var menuLen=0;for(var key in this.preference)this.preference[key]&&menuLen++;this.countActions=this._countActions(actions)-menuLen;var last_group_id=null,_loop_1=function(name_1){var action=actions[name_1];if("string"==typeof action&&(action={id:name_1,caption:action}),void 0===action.group&&(action.group="default"),last_group_id!=action.group&&(0==jQuery('[data-group="'+action.group+'"]',this_1.actionlist).length&&jQuery('<span data-group="'+action.group+'">').appendTo(this_1.actionlist),last_group_id=action.group),!action.caption&&!action.icon&&!action.iconUrl)return"continue";if(action.children){var children={},add_children_1=function(root,children){for(var id in root.children){var info={id:id||root.children[id].id,label:root.children[id].caption},childaction={};root.children[id].iconUrl&&(info.icon=root.children[id].iconUrl),root.children[id].children&&add_children_1(root.children[id],info),children[id]=info,that.options.flat_list&&(childaction=root.children[id],void 0!==pref||isDefault?isDefault||void 0===pref[childaction.id]&&that._fix_preference(childaction):childaction.toolbarDefault?that.set_prefered(childaction.id,!1):that.set_prefered(childaction.id,!0),void 0!==root.children[id].group&&void 0!==root.group&&(childaction.group=root.group),that._make_button(childaction))}};if(add_children_1(action,children),this_1.options.flat_list&&children)return"continue";var dropdown=et2_core_widget_1.et2_createWidget("dropdown_button",{id:action.id},this_1);if(dropdown.set_select_options(children),dropdown.set_label(action.caption),void 0!==action.children)for(var child in action.children)action.children[child].default&&dropdown.set_label(action.children[child].caption);dropdown.set_image(action.iconUrl||""),dropdown.onchange=jQuery.proxy((function(selected,dropdown){var action=that._actionManager.getActionById(selected.attr("data-id"));dropdown.set_label(action.caption),action&&(this.value=action.id,action.execute([]))}),action),dropdown.onclick=jQuery.proxy((function(selected,dropdown){var action=that._actionManager.getActionById(this.getValue());action&&(this.value=action.id,action.execute([]))}),dropdown),jQuery(dropdown.getDOMNode()).attr("id",this_1.id+"-"+dropdown.id).addClass(this_1.preference[action.id]?"et2_toolbar-dropdown et2_toolbar-dropdown-menulist":"et2_toolbar-dropdown").appendTo(this_1.preference[action.id]?this_1.actionbox.children()[1]:jQuery("[data-group="+action.group+"]",this_1.actionlist))}else this_1._make_button(action)},this_1=this;for(var name_1 in actions)_loop_1(name_1);this.actionlist.find("span[data-group]").sort((function(lg,g){return+lg.getAttribute("data-group")-+g.getAttribute("data-group")})).appendTo(this.actionlist),this.actionlist.appendTo(this.div),this.actionbox.appendTo(this.div);var toolbar=this.actionlist.find("span[data-group]").children(),toolbox=this.actionbox,menulist=jQuery(this.actionbox.children()[1]);toolbar.draggable({cancel:"",zIndex:1e3,delay:500,containment:"document",cursor:"move",helper:"clone",appendTo:"body",stop:function(event,ui){that._build_menu(actions)}}),menulist.children().draggable({cancel:"",containment:"document",helper:"clone",appendTo:"body",zIndex:1e3,cursor:"move",start:function(){jQuery(that.actionlist).addClass("et2_toolbarDropArea")},stop:function(){jQuery(that.actionlist).removeClass("et2_toolbarDropArea")}}),toolbox.children().droppable({accept:toolbar,drop:function(event,ui){that.set_prefered(ui.draggable.attr("id").replace(that.id+"-",""),!0),ui.draggable.appendTo(menulist),0==that.actionlist.find(".ui-draggable").length&&(that.preference={},egw.set_preference(that.egw().app_name(),that.dom_id,that.preference))},tolerance:"touch"}),this.actionlist.droppable({tolerance:"pointer",drop:function(event,ui){that.set_prefered(ui.draggable.attr("id").replace(that.id+"-",""),!1),ui.draggable.appendTo(that.actionlist),that._build_menu(actions)}}),toolbox.accordion({heightStyle:"fill",collapsible:!0,active:"none",activate:function(event,ui){var menubox=event.target;0==ui.oldHeader.length&&jQuery("html").on("click.outsideOfMenu",(function(event){jQuery(menubox).accordion("option","active",2),jQuery(this).unbind(event),jQuery(menubox).children().removeClass("ui-state-focus")}))},create:function(event,ui){jQuery("html").unbind("click.outsideOfMenu")},beforeActivate:function(){if(egwIsMobile()?menulist.height(screen.availHeight-50):menulist.css({height:"inherit"}),0==menulist.children().length)return!1}})},et2_toolbar.prototype.set_prefered=function(_action,_state){this.preference[_action]=_state,egwIsMobile()||egw.set_preference(this.egw().app_name(),this.dom_id,this.preference)},et2_toolbar.prototype._make_button=function(action){var button_options={},button=jQuery(document.createElement("button")).addClass("et2_button et2_button_text et2_button_with_image").attr("id",this.id+"-"+action.id).attr("type","button").appendTo(this.preference[action.id]?this.actionbox.children()[1]:jQuery("[data-group="+action.group+"]",this.actionlist));if(this.egw().tooltipBind(button,action.hint?action.hint:action.caption),action.shortcut&&action.shortcut.caption,action&&action.checkbox)if(action.data.toggle_on||action.data.toggle_off){var toggle=et2_core_widget_1.et2_createWidget("checkbox",{id:this.id+"-"+action.id,toggle_on:action.data.toggle_on,toggle_off:action.data.toggle_off},this);toggle.doLoadingFinished(),toggle.set_value(action.checked),action.data.widget=toggle;var toggle_div=toggle.toggle;toggle_div.appendTo(button.parent()).attr("id",this.id+"-"+action.id),button.remove(),button=toggle_div}else this.checkbox(action.id)&&button.addClass("toolbar_toggled"+(void 0!==action.toggledClass?" "+action.toggledClass:""));action.iconUrl&&button.attr("style","background-image:url("+action.iconUrl+")"),action.caption&&(!(this.countActions<=parseInt(this.options.view_range)||this.preference[action.id])&&action.iconUrl||void 0===button[0]||action.checkbox&&action.data&&(action.data.toggle_on||action.data.toggle_off)||(button.addClass(action.iconUrl?"et2_toolbar_hasCaption":"et2_toolbar_onlyCaption"),button[0].textContent=action.caption)),action.icon&&(button_options.icon=action.icon),jQuery.isEmptyObject(button_options)||button.button(button_options);var self=this;button.click(action.id,jQuery.proxy((function(e){var action=this._actionManager.getActionById(e.data);action&&(action.checkbox&&self.checkbox(action.id,!action.checked),this.value=action.id,action.data.event=e,action.execute([]))}),this))},et2_toolbar.prototype._link_actions=function(actions){this._build_menu(actions);var self=this,gom=egw_getObjectManager(this.egw().app_name(),!0,1);null==this._objectManager&&(this._objectManager=gom.addObject(new egwActionObjectManager(this.id,this._actionManager)),this._objectManager.handleKeyPress=function(_keyCode,_shift,_ctrl,_alt){for(var i=0;i<self._actionManager.children.length;i++){var action=self._actionManager.children[i];if("object"==typeof action.shortcut&&action.shortcut&&_keyCode==action.shortcut.keyCode&&_ctrl==action.shortcut.ctrl&&_alt==action.shortcut.alt&&_shift==action.shortcut.shift)return self.value=action.id,action.execute([]),!0}return egwActionObject.prototype.handleKeyPress.call(this,_keyCode,_shift,_ctrl,_alt)},this._objectManager.parent.updateFocusedChild(this._objectManager,!0))},et2_toolbar.prototype.checkbox=function(_action,_value){if(_action&&void 0!==this._actionManager){var action_event=this._actionManager.getActionById(_action);if(!action_event||void 0===_value)return action_event?action_event.checked:void 0;action_event.set_checked(_value);var btn=jQuery("#"+this.id+"-"+_action);action_event.data&&action_event.data.widget?action_event.data.widget.set_value(_value):btn.length>0&&btn.toggleClass("toolbar_toggled"+(void 0!==action_event.data.toggledClass?" "+action_event.data.toggledClass:""),_value)}},et2_toolbar.prototype.getDOMNode=function(){return this.div[0]},et2_toolbar.prototype.getValue=function(){return this.value},et2_toolbar.prototype.isDirty=function(){return!1},et2_toolbar.prototype.resetDirty=function(){this.value=null},et2_toolbar.prototype.isValid=function(messages){return!0},et2_toolbar.prototype.doLoadingFinished=function(){return _super.prototype.doLoadingFinished.call(this),!1},et2_toolbar.prototype._admin_settings_dialog=function(_actions,_default_prefs){var buttons=[{text:egw.lang("Save"),id:"save"},{text:egw.lang("Close"),id:"close"}],self=this,sel_options={actions:[]},content={actions:[],reset:!1};for(var key in _actions){if(_actions[key].children&&this.options.flat_list)for(var child in _actions[key].children)sel_options.actions.push({id:child,value:child,label:_actions[key].children[child].caption,app:egw.app_name(),icon:_actions[key].children[child].iconUrl});else sel_options.actions.push({id:key,value:key,label:_actions[key].caption,app:egw.app_name(),icon:_actions[key].iconUrl});_default_prefs&&0!=_default_prefs.length||!_actions[key].toolbarDefault||content.actions.push(key)}_default_prefs&&_default_prefs.length>0&&(content.actions=_default_prefs),et2_core_widget_1.et2_createWidget("dialog",{callback:function(_button_id,_value){if("save"==_button_id&&_value){if(_value.actions){var pref=jQuery.extend({},self.preference);for(var i in pref)pref[i]=!0,_value.actions.includes(i)&&(pref[i]=!1);_value.actions=pref}egw.json("EGroupware\\Api\\Etemplate\\Widget\\Toolbar::ajax_setAdminSettings",[_value,self.dom_id,egw.app_name()],(function(_result){egw.message(_result)})).sendRequest(!0)}},title:egw.lang("admin settings for %1",this.dom_id),buttons:buttons,minWidth:600,minHeight:300,value:{content:content,sel_options:sel_options},template:egw.webserverUrl+"/api/templates/default/toolbarAdminSettings.xet?1",resizable:!1},et2_widget_dialog_1.et2_dialog._create_parent("api"))},et2_toolbar._attributes={view_range:{name:"View range",type:"string",default:"5",description:"Define minimum action view range to show actions by both icons and caption"},flat_list:{name:"Flat list",type:"boolean",default:!0,description:"Define whether the actions with children should be shown as dropdown or flat list"}},et2_toolbar.default_toolbar={view:{caption:"View",icons:{primary:"ui-icon-check"},group:1,toolbarDefault:!0},edit:{caption:"Edit",group:1,toolbarDefault:!0},save:{caption:"Save",group:2,toolbarDefault:!0}},et2_toolbar}(et2_core_DOMWidget_1.et2_DOMWidget);et2_core_widget_1.et2_register_widget(et2_toolbar,["toolbar"]);
/**
 * EGroupware eTemplate2 - JS Tree object
 *
 * @link http://community.egroupware.org/egroupware/api/js/dhtmlxtree/docsExplorer/dhtmlxtree/
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @author Ralf Becker
 * @copyright Nathan Gray 2011
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_inputWidget_1=require("./et2_core_inputWidget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_tree=function(_super){function et2_tree(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_tree._attributes,_child||{}))||this;return _this.input=null,_this._lt_regexp=/</g,_this.input=null,_this.div=jQuery(document.createElement("div")).addClass("dhtmlxTree"),_this.setDOMNode(_this.div[0]),_this}return __extends(et2_tree,_super),et2_tree.prototype.destroy=function(){this.input&&this.input.destructor(),this.input=null,_super.prototype.destroy.call(this)},et2_tree.prototype.transformAttributes=function(_attrs){if(_super.prototype.transformAttributes.call(this,_attrs),!this.options||!this.options.select_options||jQuery.isEmptyObject(this.options.select_options)){var name_parts=this.id.replace(/]/g,"").split("[");if(this.getArrayMgr("sel_options"))(content_options=this.getArrayMgr("sel_options").getRoot().getEntry(name_parts[name_parts.length-1]))||(content_options=this.getArrayMgr("sel_options").getEntry(this.id)),_attrs.select_options&&!jQuery.isEmptyObject(_attrs.select_options)&&content_options?_attrs.select_options=jQuery.extend({},_attrs.select_options,content_options):content_options&&(_attrs.select_options=content_options);if(null==_attrs.select_options){var content_options=this.getArrayMgr("content").getRoot().getEntry(name_parts[name_parts.length-1]);_attrs.select_options=content_options||this.getArrayMgr("content").getEntry("options-"+this.id)}null==_attrs.select_options&&(_attrs.select_options={})}},et2_tree.prototype.click=function(_node){},et2_tree.prototype.createTree=function(widget){if(widget.input=new dhtmlXTreeObject({parent:widget.div[0],width:"100%",height:"100%",image_path:widget.options.image_path,checkbox:widget.options.multiple}),widget.input.dlmtr=":}-*(",widget.options.std_images?widget.setImages.apply(widget,widget.options.std_images.split(",")):widget.setImages(),widget.input.AJAX_callback=function(dxmlObject){widget._dhtmlxtree_json_callback(JSON.parse(dxmlObject.xmlDoc.responseText),widget.input.lastLoadedXMLId),widget.options.multiple&&widget.set_value(widget.value)},widget.options.autoloading){var url=widget.options.autoloading;widget.input.setEscapingMode("utf8"),"/"!=url.charAt(0)&&"http"!=url.substr(0,4)&&(url="/json.php?menuaction="+url),this.autoloading_url=url,widget.input.setXMLAutoLoading(egw.link(url)),widget.input.setDataMode("JSON")}widget.options.multimarking&&widget.input.enableMultiselection(!!widget.options.multimarking,"strict"===widget.options.multimarking),widget.input.enableHighlighting(!!widget.options.highlighting);var open=egw.image("dhtmlxtree/open"),close=egw.image("dhtmlxtree/close");open&&close&&(widget.input.enableTreeLines(!1),open=this._rel_url(open),widget.input.setImageArrays("plus",open,open,open,open,open),close=this._rel_url(close),widget.input.setImageArrays("minus",close,close,close,close,close)),this._install_handler("onBeforeCheck",function(){return!this.options.readonly}.bind(this))},et2_tree.prototype._install_handler=function(_name,_handler){if("function"==typeof _handler){null==this.input&&this.createTree(this),"onchange"==_name&&(_name=this.options.multiple?"oncheck":"onselect");var handler_1=_handler,widget_1=this;this.input.attachEvent(_name,(function(_id){var args=jQuery.makeArray(arguments);return args.splice(1,0,widget_1),egwIsMobile()&&"string"==typeof args[2]&&framework.toggleMenu("on"),handler_1.apply(this,args)}))}},et2_tree.prototype.set_onchange=function(_handler){this._install_handler("onchange",_handler)},et2_tree.prototype.set_onclick=function(_handler){this._install_handler("onclick",_handler)},et2_tree.prototype.set_onselect=function(_handler){this._install_handler("onselect",_handler)},et2_tree.prototype.set_onopenstart=function(_handler){this._install_handler("onOpenStart",_handler)},et2_tree.prototype.set_onopenend=function(_handler){this._install_handler("onOpenEnd",_handler)},et2_tree.prototype.set_select_options=function(options){var custom_images=!1;if(this.options.select_options=options,null==this.input&&this.createTree(this),"tree-cat"==this.getType()){for(var data={id:0,item:[]},stack_1={},key=0;key<options.length;key++){if(options[key].data&&void 0!==options[key].data.icon&&options[key].data.icon){var img=this.egw().image(options[key].data.icon,options[key].appname);img&&(custom_images=!0,options[key].im0=options[key].im1=options[key].im2=img)}options[key].data&&void 0!==options[key].data.color&&options[key].data.color&&(options[key].style=options[key].style||"background-color:'"+options[key].data.color+"';"),options[key].description&&!options[key].tooltip&&(options[key].tooltip=options[key].description);var parent_id=parseInt(options[key].parent);isNaN(parent_id)&&(parent_id=0),stack_1[parent_id]||(stack_1[parent_id]=[]),stack_1[parent_id].push(options[key])}if(custom_images){var path=this.input.iconURL;this.input.setIconPath("");for(var k=0;k<this.input.imageArray.length;k++)this.input.imageArray[k]=path+this.input.imageArray[k]}var f_1=function(data,_f){if(stack_1[data.id]){data.item=stack_1[data.id];for(var j=0;j<data.item.length;j++)f_1(data.item[j],_f)}};f_1(data,f_1),options=data}void 0===options.id&&this.input.XMLsource?this.input.loadJSON(this.input.XMLsource):this.input.loadJSONObject(this._htmlencode_node(options))},et2_tree.prototype._htmlencode=function(_text){return _text&&_text.indexOf("<")>=0&&(_text=_text.replace(this._lt_regexp,"&lt;")),_text},et2_tree.prototype._htmlencode_node=function(_item){if(_item.text=this._htmlencode(_item.text),_item.item&&jQuery.isArray(_item.item))for(var i=0;i<_item.item.length;++i)this._htmlencode_node(_item.item[i]);return _item},et2_tree.prototype.set_value=function(new_value){if(this.value=this._oldValue="string"==typeof new_value&&this.options.multiple?new_value.split(","):new_value,null!=this.input)if(this.options.multiple){for(var checked=this.input.getAllChecked().split(this.input.dlmtr),i=0;i<checked.length;i++)this.input.setCheck(checked[i],!1);for(i=0;i<this.value.length;i++)this.input.setCheck(this.value[i],!0),this.options.autoloading||this.input.openItem(this.value[i])}else this.input.selectItem(this.value,!1),this.input.focusItem(this.value),this.input.openItem(this.value)},et2_tree.prototype._link_actions=function(actions){var objectManager=egw_getObjectManager(this.egw().app_name(),!0,1),treeObj=objectManager.getObjectById(this.id);null==treeObj&&(treeObj=objectManager.addObject(new egwActionObject(this.id,objectManager,null,this._actionManager,EGW_AO_FLAG_IS_CONTAINER),null,EGW_AO_FLAG_IS_CONTAINER)),treeObj.clear();var action_links=this._get_action_links(actions);if(void 0!==this.options.select_options){var apply_actions_1=function(treeObj,option){if(treeObj.addObject("number"==typeof option.id?String(option.id):option.id,new dhtmlxtreeItemAOI(this.input,option.id)).updateActionLinks(action_links),option.item&&option.item.length>0)for(var i=0;i<option.item.length;i++)apply_actions_1.call(this,treeObj,option.item[i])};apply_actions_1.call(this,treeObj,this.options.select_options)}},et2_tree.prototype.getValue=function(){if(null==this.input)return null;if(this.options.multiple){var allChecked=this.input.getAllChecked().split(this.input.dlmtr),allUnchecked=this.input.getAllUnchecked().split(this.input.dlmtr);if(this.options.autoloading){for(var res={},i=0;i<allChecked.length;i++)res[allChecked[i]]={value:!0};for(i=0;i<allUnchecked.length;i++)res[allUnchecked[i]]={value:!1};return res}return allChecked}return this.input.getSelectedItemId()},et2_tree.prototype.getSelectedLabel=function(){return null==this.input||this.options.multiple?null:this.input.getSelectedItemText()},et2_tree.prototype.renameItem=function(_id,_newItemId,_label){if(null==this.input)return null;this.input.changeItemId(_id,_newItemId);for(var treeObj=egw_getAppObjectManager().getObjectById(this.id),i=0;i<treeObj.children.length;i++)if(treeObj.children[i].id==_id){treeObj.children[i].id=_newItemId,treeObj.children[i].iface&&(treeObj.children[i].iface.id=_newItemId);break}void 0!==_label&&this.setLabel(_newItemId,_label)},et2_tree.prototype.deleteItem=function(_id,_selectParent){if(null==this.input)return null;this.input.deleteItem(_id,_selectParent);for(var treeObj=egw_getAppObjectManager().getObjectById(this.id),i=0;i<treeObj.children.length;i++)treeObj.children[i].id==_id&&treeObj.children.splice(i,1)},et2_tree.prototype.refreshItem=function(_id,data){if(null==this.input)return null;this.input.deleteChildItems(_id),this.input.setDataMode("JSON");var self=this;void 0!==data&&null!=data?this.input.loadJSONObject(data,(function(){self._dhtmlxtree_json_callback(data,_id)})):this.input.loadJSON(this.egw().link(this.autoloading_url,{id:_id}),(function(dxmlObject){self._dhtmlxtree_json_callback(JSON.parse(dxmlObject.xmlDoc.responseText),_id)}))},et2_tree.prototype.focusItem=function(_id){if(null==this.input)return null;this.input.focusItem(_id)},et2_tree.prototype.hasChildren=function(_id){return null==this.input?null:this.input.hasChildren(_id)},et2_tree.prototype._dhtmlxtree_json_callback=function(new_data,update_option_id){var parent_id=void 0!==update_option_id&&-1!=update_option_id?update_option_id:new_data.id,option=this._find_in_item(parent_id,this.options.select_options);option?jQuery.extend(option,new_data||{}):this.options.select_options=new_data,this.set_actions(this.options.actions||{})},et2_tree.prototype._find_in_item=function(_id,_item){if(_item&&_item.id==_id)return _item;if(_item&&void 0!==_item.item)for(var i=0;i<_item.item.length;++i){var found=this._find_in_item(_id,_item.item[i]);if(found)return found}return null},et2_tree.prototype.getNode=function(_id){return this._find_in_item(_id,this.options.select_options)},et2_tree.prototype.setLabel=function(_id,_label,_tooltip){if(null==this.input)return null;var tooltip=_tooltip||(this.getNode(_id)&&this.getNode(_id).tooltip?this.getNode(_id).tooltip:"");this.input.setItemText(_id,this._htmlencode(_label),tooltip)},et2_tree.prototype.setStyle=function(_id,_style){if(null==this.input)return null;this.input.setItemStyle(_id,_style)},et2_tree.prototype.getLabel=function(_id){return null==this.input?null:this.input.getItemText(_id)},et2_tree.prototype.getSelectedNode=function(){return null==this.input||this.options.multiple?null:this.input._selected[0]},et2_tree.prototype.getTreeNodeOpenItems=function(_nodeID,mode){if(null==this.input)return null;var oS,PoS,rv,z=this.input.getSubItems(_nodeID).split(this.input.dlmtr),returnValue=[_nodeID],modetorun="none";if(mode&&(modetorun=mode),PoS=this.input.getOpenState(_nodeID),"forced"==modetorun&&(PoS=1),1==PoS)for(var i=0;i<z.length;i++)if(-1==(oS=this.input.getOpenState(z[i]))&&returnValue.push(z[i]),0==oS&&returnValue.push(z[i]),1==oS){rv=this.getTreeNodeOpenItems(z[i]);for(var j=0;j<rv.length;j++)returnValue.push(rv[j])}return returnValue},et2_tree.prototype.getUserData=function(_nodeId,_name){return null==this.input?null:this.input.getUserData(_nodeId,_name)},et2_tree.prototype.setUserData=function(_nodeId,_name,_value){return null==this.input?null:this.input.setUserData(_nodeId,_name,_value)},et2_tree.prototype.openItem=function(_id,_open){if(null==this.input)return null;var is_open=1==this.input.getOpenState(_id);return void 0!==_open&&is_open!==_open&&(is_open?this.input.closeItem(_id):this.input.openItem(_id)),is_open},et2_tree.prototype.reSelectItem=function(_id){if(null==this.input)return null;this.input.selectItem(_id,!1,!1)},et2_tree.prototype.setImages=function(_leaf,_closed,_open,_id){for(var images=[_leaf||"dhtmlxtree/leaf",_closed||"dhtmlxtree/folderClosed",_open||"dhtmlxtree/folderOpen"],image_extensions=/\.(gif|png|jpe?g|svg)/i,i=0;i<3;++i){var image=images[i];image.match(image_extensions)||(images[i]=this._rel_url(this.egw().image(image)||image))}void 0===_id?this.input.setStdImages.apply(this.input,images):(images.unshift(_id),this.input.setItemImage2.apply(this.input,images))},et2_tree.prototype.setSubChecked=function(_id,_state){"toggle"===_state&&(_state=!this.input.isItemChecked(_id)),this.input.setSubChecked(_id,_state)},et2_tree.prototype._rel_url=function(_url){var path_parts=this.options.image_path.split(this.egw().webserverUrl);path_parts=path_parts[1].split("/");var url_parts=_url.split(this.egw().webserverUrl);url_parts=url_parts[1].split("/");for(var i=0;i<path_parts.length;++i){if(path_parts[i]!=url_parts[i]){for(;++i<path_parts.length;)url_parts.unshift("..");break}url_parts.shift()}return url_parts.join("/")},et2_tree._attributes={multiple:{name:"multiple",type:"boolean",default:!1,description:"Allow selecting multiple options"},select_options:{type:"any",name:"Select options",default:{},description:"Used to set the tree options."},onclick:{description:"JS code which gets executed when clicks on text of a node"},onselect:{name:"onSelect",type:"js",default:et2_no_init,description:"Javascript executed when user selects a node"},oncheck:{name:"onCheck",type:"js",default:et2_no_init,description:"Javascript executed when user checks a node"},onopenstart:{name:"onOpenStart",type:"js",default:et2_no_init,description:"Javascript function executed when user opens a node: function(_id, _widget, _hasChildren) returning true to allow opening!"},onopenend:{name:"onOpenEnd",type:"js",default:et2_no_init,description:"Javascript function executed when opening a node is finished: function(_id, _widget, _hasChildren)"},image_path:{name:"Image directory",type:"string",default:egw().webserverUrl+"/phpgwapi/templates/default/images/dhtmlxtree/",description:"Directory for tree structure images, set on server-side to 'dhtmlx' subdir of templates image-directory"},value:{type:"any",default:{}},actions:{name:"Actions array",type:"any",default:et2_no_init,description:"List of egw actions that can be done on the tree.  This includes context menu, drag and drop.  TODO: Link to action documentation"},autoloading:{name:"Autoloading",type:"string",default:"",description:"JSON URL or menuaction to be called for nodes marked with child=1, but not having children, GET parameter selected contains node-id"},std_images:{name:"Standard images",type:"string",default:"",description:"comma-separated names of icons for a leaf, closed and opend folder (default: leaf.png,folderClosed.png,folderOpen.png), images with extension get loaded from image_path, just 'image' or 'appname/image' are allowed too"},multimarking:{name:"multimarking",type:"any",default:!1,description:"Allow marking multiple nodes, default is false which means disabled multiselection, true or 'strict' activates it and 'strict' makes it strick to only same level marking"},highlighting:{name:"highlighting",type:"boolean",default:!1,description:"Add highlighting class on hovered over item, highlighting is disabled by default"}},et2_tree}(et2_core_inputWidget_1.et2_inputWidget);et2_core_widget_1.et2_register_widget(et2_tree,["tree","tree-cat"]);
/**
 * EGroupware eTemplate2 - JS History log
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright 2012 Nathan Gray
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_valueWidget_1=require("./et2_core_valueWidget"),et2_dataview_1=require("./et2_dataview"),et2_dataview_model_columns_1=require("./et2_dataview_model_columns"),et2_dataview_controller_1=require("./et2_dataview_controller");var et2_widget_diff_1=require("./et2_widget_diff"),et2_historylog=function(_super){function et2_historylog(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_historylog._attributes,_child||{}))||this;return _this.div=jQuery(document.createElement("div")).addClass("et2_historylog"),_this.innerDiv=jQuery(document.createElement("div")).appendTo(_this.div),_this}return __extends(et2_historylog,_super),et2_historylog.prototype.set_status_id=function(_new_id){this.options.status_id=_new_id},et2_historylog.prototype.doLoadingFinished=function(){_super.prototype.doLoadingFinished.call(this);var tab=this.get_tab_info();if(tab){tab.flagDiv.bind("click.history",{history:this,div:tab.flagDiv},(function(e){e.data.div.unbind("click.history"),e.data.div.bind("click.history",{history:e.data.history,div:tab.flagDiv},(function(e){e.data.history&&e.data.history.dynheight&&e.data.history.dynheight.update((function(_w,_h){e.data.history.dataview.resize(_w,_h)}))})),void 0===e.data.history.dataview&&(e.data.history.finishInit(),e.data.history.dynheight&&e.data.history.dynheight.update((function(_w,_h){e.data.history.dataview.resize(_w,_h)})))})),tab.contentDiv.is(":visible")&&void 0===this.dataview&&tab.flagDiv.trigger("click.history")}else this.finishInit();return!0},et2_historylog.prototype._createNamespace=function(){return!0},et2_historylog.prototype.finishInit=function(){if(this.options.value&&this.options.value.id){this._filters={record_id:this.options.value.id,appname:this.options.value.app,get_rows:this.options.get_rows},this.options.status_id===this.id&&this.egw().debug("warn","status_id attribute should not be the same as historylog ID"),this.div.parentsUntil(".et2_tabs").height("100%");var parent=this.get_tab_info();this.dynheight=new et2_dynheight(parent?parent.contentDiv:this.div.parent(),this.innerDiv,250),this.dataview=new et2_dataview_1.et2_dataview(this.innerDiv,this.egw());for(var dataview_columns=[],_columns="string"==typeof this.options.columns?this.options.columns.split(","):this.options.columns,i=0;i<et2_historylog.columns.length;i++)dataview_columns[i]={id:et2_historylog.columns[i].id,caption:et2_historylog.columns[i].caption,width:et2_historylog.columns[i].width,visibility:_columns.indexOf(et2_historylog.columns[i].id)<0?et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_INVISIBLE:et2_dataview_model_columns_1.et2_dataview_column.ET2_COL_VISIBILITY_VISIBLE};this.dataview.setColumns(dataview_columns),this.createWidgets();this.controller=new et2_dataview_controller_1.et2_dataview_controller(null,this.dataview.grid),this.controller.setContext(this),this.controller.setDataProvider(this),this.controller.setLinkCallback((function(){})),this.controller.setRowCallback(this.rowCallback),this.controller.setActionObjectManager(null);var total=void 0!==this.options.value.total?this.options.value.total:0;this.dataview.grid.setTotalCount(total),this.options.value.rows&&this.options.value.num_rows?(this.controller.loadInitialData(this.options.value.dataStorePrefix,this.options.value.row_id,this.options.value.rows),delete this.options.value.rows,this.dataview.grid.setTotalCount(total)):this.controller.update();for(i=0;i<et2_historylog.columns.length;i++)jQuery(this.dataview.getHeaderContainerNode(i)).text(et2_historylog.columns[i].caption);jQuery(window).on("resize."+this.options.value.app+this.options.value.id,function(){this&&void 0!==this.dynheight&&this.dynheight.update(function(_w,_h){this.dataview.resize(_w,_h)}.bind(this))}.bind(this))}},et2_historylog.prototype.destroy=function(){this.options.value&&!this.options.value.id&&jQuery(window).off("."+this.options.value.app+this.options.value.id);for(var i=0;i<et2_historylog.columns.length;i++)et2_historylog.columns[i].widget&&et2_historylog.columns[i].widget.destroy();for(var key in this.fields)this.fields[key].widget.destroy();this.dataview&&this.dataview.destroy(),this.controller&&this.controller.destroy(),this.dynheight&&this.dynheight.destroy(),_super.prototype.destroy.call(this)},et2_historylog.prototype.createWidgets=function(){for(var i_1=0;i_1<et2_historylog.columns.length;i_1++)if(et2_historylog.columns[i_1].widget_type){var attrs={readonly:!0,id:i_1==et2_historylog.FIELD?this.options.status_id:et2_historylog.columns[i_1].id};et2_historylog.columns[i_1].widget=et2_createWidget(et2_historylog.columns[i_1].widget_type,attrs,this),et2_historylog.columns[i_1].widget.transformAttributes(attrs),et2_historylog.columns[i_1].nodes=jQuery(et2_historylog.columns[i_1].widget.getDetachedNodes())}void 0===this.options.value["status-widgets"]["~link~"]&&(et2_historylog.columns[et2_historylog.FIELD].widget.optionValues["~link~"]=this.egw().lang("link"),this.options.value["status-widgets"]["~link~"]="link"),void 0===this.options.value["status-widgets"]["~file~"]&&(et2_historylog.columns[et2_historylog.FIELD].widget.optionValues["~file~"]=this.egw().lang("File"),this.options.value["status-widgets"]["~file~"]="vfs"),void 0===this.options.value["status-widgets"].user_agent_action&&(et2_historylog.columns[et2_historylog.FIELD].widget.optionValues.user_agent_action=this.egw().lang("User-agent & action")),this.fields={};var labels=et2_historylog.columns[et2_historylog.FIELD].widget.optionValues,cf_widget=et2_createWidget("customfields",{readonly:!0},this);for(var key_1 in cf_widget.loadFields(),cf_widget.getValue=function(){return null},cf_widget.widgets)if(labels[cf_widget.prefix+key_1]=cf_widget.options.customfields[key_1].label,cf_widget.widgets[key_1].getDetachedNodes){for(var nodes=cf_widget.widgets[key_1].getDetachedNodes(),i=0;i<nodes.length;i++)null==nodes[i]&&nodes.splice(i,1);this.fields[cf_widget.prefix+key_1]={attrs:cf_widget.widgets[key_1].options,widget:cf_widget.widgets[key_1],nodes:jQuery(nodes)}}for(var key in et2_historylog.columns[et2_historylog.FIELD].widget.set_select_options(labels),this.options.value["status-widgets"]){var attrs_1=jQuery.extend({readonly:!0,id:key},this.getArrayMgr("modifications").getEntry(key)),field=attrs_1.type||this.options.value["status-widgets"][key],widget=this._create_widget(key,field,attrs_1,null);if(null!==widget){widget.instanceOf(et2_selectbox)&&(widget.options.multiple=!0),widget.transformAttributes(attrs_1);for(var nodes_1=widget._children.length?[]:jQuery(widget.getDetachedNodes()),i_2=0;i_2<widget._children.length;i_2++)nodes_1.push(jQuery(widget._children[i_2].getDetachedNodes()));this.fields[key]={attrs:attrs_1,widget:widget,nodes:nodes_1}}}var diff=et2_createWidget("diff",{},this);this.diff={widget:diff,nodes:jQuery(diff.getDetachedNodes())}},et2_historylog.prototype._create_widget=function(key,field,attrs,options){var widget=null;if("object"==typeof field){var need_box=!1;//!this.getArrayMgr('sel_options').getEntry(key);
for(var j in field)if(et2_registry[field[j]]&&["template"].indexOf(field[j])<0){need_box=!0;break}if(need_box)for(var i in widget=et2_createWidget("vbox",attrs,this),field){var type=field[i],child_attrs=jQuery.extend({},attrs);"object"==typeof type?(child_attrs.select_options=field[i],type="select"):delete child_attrs.select_options,child_attrs.id=i;var child=this._create_widget(i,type,child_attrs,options);widget.addChild(child),child.transformAttributes(child_attrs)}else attrs.select_options=field}else if(field.indexOf(":")>0){options=field.split(":");field=options.shift()}if(null===widget&&(widget=et2_createWidget("string"==typeof field?field:"select",attrs,this)),!widget.instanceOf(et2_IDetachedDOM))return this.egw().debug("warn",this,"Invalid widget "+field+" for "+key+".  Status widgets must implement et2_IDetachedDOM."),null;if(options)for(var mgr=this.getArrayMgr("content"),legacy=widget.constructor.legacyOptions||[],i_3=0;i_3<options.length&&i_3<legacy.length;i_3++)if(""!==options[i_3]){var attr=widget.attributes[legacy[i_3]],attrValue=options[i_3];attrValue="boolean"===attr.type?mgr.parseBoolExpression(attrValue):mgr.expandName(attrValue),attrs[legacy[i_3]]=attrValue,"function"==typeof widget["set_"+legacy[i_3]]?widget["set_"+legacy[i_3]].call(widget,attrValue):widget.options[legacy[i_3]]=attrValue}return widget},et2_historylog.prototype.getDOMNode=function(_sender){if(_sender==this)return this.div[0];for(var i=0;i<et2_historylog.columns.length;i++)if(_sender==et2_historylog.columns[i].widget)return this.dataview.getHeaderContainerNode(i);return null},et2_historylog.prototype.dataFetch=function(_queriedRange,_callback,_context){if(this.value.id){this.options.value.num_rows&&(_queriedRange.num_rows=this.options.value.num_rows);this.egw().dataFetch(this.getInstanceManager().etemplate_exec_id,_queriedRange,this._filters,this.id,(function(_response){_callback.call(this,_response)}),_context,[])}},et2_historylog.prototype.dataRegisterUID=function(_uid,_callback,_context){this.egw().dataRegisterUID(_uid,_callback,_context,this.getInstanceManager().etemplate_exec_id,this.id)},et2_historylog.prototype.dataUnregisterUID=function(_uid,_callback,_context){},et2_historylog.prototype.rowCallback=function(_data,_row,_idx,_entry){var tr=_row.getDOMNode();jQuery(tr).attr("valign","top");var row=this.dataview.rowProvider.getPrototype("default"),self=this;return jQuery("div",row).each((function(i){var nodes=[],widget=et2_historylog.columns[i].widget,value=_data[et2_historylog.columns[i].id];if(et2_historylog.OWNER===i&&_data.share_email&&(widget=void 0,value=_data.share_email),void 0!==widget&&null!=widget||void 0===self.fields[_data.status]||!(i<et2_historylog.NEW_VALUE||i>=et2_historylog.NEW_VALUE&&(self.fields[_data.status].nodes||!self._needsDiffWidget(_data.status,_data[et2_historylog.columns[et2_historylog.OLD_VALUE].id]))))if(widget)nodes=et2_historylog.columns[i].nodes.clone();else if("object"==typeof _data[et2_historylog.columns[et2_historylog.NEW_VALUE].id]&&void 0!==_data[et2_historylog.columns[et2_historylog.NEW_VALUE].id]&&null!==_data[et2_historylog.columns[et2_historylog.NEW_VALUE].id]||self._needsDiffWidget(_data.status,_data[et2_historylog.columns[et2_historylog.OLD_VALUE].id])||self._needsDiffWidget(_data.status,_data[et2_historylog.columns[et2_historylog.NEW_VALUE].id])){var jthis=jQuery(this);i===et2_historylog.NEW_VALUE&&(widget=self.diff.widget,nodes=self.diff.nodes.clone(),widget&&widget.setDetachedAttributes(nodes,{value:value,label:jthis.parents("td").prev().text()}),self._spanValueColumns(jthis))}else nodes=jQuery("<span>").text(null===value?"":value);else{(widget=self.fields[_data.status].widget)._children.length||(nodes=self.fields[_data.status].nodes.clone());for(var j=0;j<widget._children.length;j++)nodes.push(self.fields[_data.status].nodes[j].clone()),widget._children[j].instanceOf(et2_widget_diff_1.et2_diff)&&self._spanValueColumns(jQuery(this))}if(widget)if(widget._children.length){var box=jQuery(widget.getDOMNode()).clone();for(j=0;j<widget._children.length;j++){var id=widget._children[j].id,widget_value=value&&value[id]||"";widget._children[j].setDetachedAttributes(nodes[j],{value:widget_value}),box.append(nodes[j])}nodes=box}else widget.setDetachedAttributes(nodes,{value:value});jQuery(this).append(nodes)})),jQuery(tr).append(row.children()),tr},et2_historylog.prototype._needsDiffWidget=function(columnName,value){return"string"!=typeof value&&value?(this.egw().debug("warn","Crazy diff value",value),!1):"***diff***"===value},et2_historylog.prototype._spanValueColumns=function(row){row.parents("td").attr("colspan",2).css("border-right","none"),row.css("width",this.dataview.getColumnMgr().getColumnWidth(et2_historylog.NEW_VALUE)+this.dataview.getColumnMgr().getColumnWidth(et2_historylog.OLD_VALUE)-10+"px"),row.parents("td").next().remove()},et2_historylog.prototype.resize=function(_height){if(void 0!==this.options&&_height&&void 0!==this.options.resize_ratio&&0!=(_height=""!=this.options.resize_ratio?_height*this.options.resize_ratio:_height)&&(0==this.div.height()&&(_height+=250),this.div.height(this.div.height()+_height),this.div.trigger("resize."+this.options.value.app+this.options.value.id)),this.dynheight&&this.dynheight.update(),this.dataview){var columns=this.dataview.getColumnMgr();jQuery(".et2_diff",this.div).closest(".innerContainer").width(columns.getColumnWidth(et2_historylog.NEW_VALUE)+columns.getColumnWidth(et2_historylog.OLD_VALUE))}},et2_historylog._attributes={value:{name:"Value",type:"any",description:"Object {app: ..., id: ..., status-widgets: {}} where status-widgets is a map of fields to widgets used to display those fields"},status_id:{name:"status_id",type:"string",default:"status",description:"The history widget is traditionally named 'status'.  If you name another widget in the same template 'status', you can use this attribute to re-name the history widget.  "},columns:{name:"columns",type:"string",default:"user_ts,owner,status,new_value,old_value",description:"Columns to display.  Default is user_ts,owner,status,new_value,old_value"},get_rows:{name:"get_rows",type:"string",default:"EGroupware\\Api\\Storage\\History::get_rows",description:"Method to get rows"}},et2_historylog.legacyOptions=["status_id"],et2_historylog.columns=[{id:"user_ts",caption:"Date",width:"120px",widget_type:"date-time",widget:null,nodes:null},{id:"owner",caption:"User",width:"150px",widget_type:"select-account",widget:null,nodes:null},{id:"status",caption:"Changed",width:"120px",widget_type:"select",widget:null,nodes:null},{id:"new_value",caption:"New Value",width:"50%",widget:null,nodes:null},{id:"old_value",caption:"Old Value",width:"50%",widget:null,nodes:null}],et2_historylog.TIMESTAMP=0,et2_historylog.OWNER=1,et2_historylog.FIELD=2,et2_historylog.NEW_VALUE=3,et2_historylog.OLD_VALUE=4,et2_historylog}(et2_core_valueWidget_1.et2_valueWidget);exports.et2_historylog=et2_historylog,et2_core_widget_1.et2_register_widget(et2_historylog,["historylog"]);
/**
 * EGroupware eTemplate2 - JS HRule object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_baseWidget_1=require("./et2_core_baseWidget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_hrule=function(_super){function et2_hrule(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_hrule._attributes,_child||{}))||this;return _this.setDOMNode(document.createElement("hr")),_this}return __extends(et2_hrule,_super),et2_hrule}(et2_core_baseWidget_1.et2_baseWidget);et2_core_widget_1.et2_register_widget(et2_hrule,["hrule"]),function(t){"function"==typeof define&&define.amd?define(["jquery"],t):t("object"==typeof exports?require("jquery"):jQuery)}((function(t){function i(t){return"number"==typeof t&&!isNaN(t)}function e(t){return void 0===t}function s(t,e){var s=[];return i(e)&&s.push(e),s.slice.apply(t,s)}function a(t,i){var e=s(arguments,2);return function(){return t.apply(i,e.concat(s(arguments)))}}function o(t){var i=t.match(/^(https?:)\/\/([^\:\/\?#]+):?(\d*)/i);return i&&(i[1]!==C.protocol||i[2]!==C.hostname||i[3]!==C.port)}function h(t){var i="timestamp="+(new Date).getTime();return t+(-1===t.indexOf("?")?"?":"&")+i}function n(t){return t?' crossOrigin="'+t+'"':""}function p(t){var e=[],s=t.rotate,a=t.scaleX,o=t.scaleY;return i(s)&&0!==s&&e.push("rotate("+s+"deg)"),i(a)&&1!==a&&e.push("scaleX("+a+")"),i(o)&&1!==o&&e.push("scaleY("+o+")"),e.length?e.join(" "):"none"}function l(t,i){var e,s,a=Ct(t.degree)%180,o=(a>90?180-a:a)*Math.PI/180,h=bt(o),n=Bt(o),r=t.width,p=t.height,l=t.aspectRatio;return i?s=(e=r/(n+h/l))/l:(e=r*n+p*h,s=r*h+p*n),{width:e,height:s}}function c(e,s){var a,o,h,n=t("<canvas>")[0],r=n.getContext("2d"),p=0,c=0,d=s.naturalWidth,g=s.naturalHeight,u=s.rotate,f=s.scaleX,m=s.scaleY,v=i(f)&&i(m)&&(1!==f||1!==m),w=i(u)&&0!==u,x=w||v,C=d*Ct(f||1),b=g*Ct(m||1);return v&&(a=C/2,o=b/2),w&&(a=(C=(h=l({width:C,height:b,degree:u})).width)/2,o=(b=h.height)/2),n.width=C,n.height=b,x&&(p=-d/2,c=-g/2,r.save(),r.translate(a,o)),w&&r.rotate(u*Math.PI/180),v&&r.scale(f,m),r.drawImage(e,$t(p),$t(c),$t(d),$t(g)),x&&r.restore(),n}function d(i){var e=i.length,s=0,a=0;return e&&(t.each(i,(function(t,i){s+=i.pageX,a+=i.pageY})),s/=e,a/=e),{pageX:s,pageY:a}}function u(t){var i,s,a,o,h,n,r,p,l,c=new D(t),d=c.byteLength;if(255===c.getUint8(0)&&216===c.getUint8(1))for(p=2;p<d;){if(255===c.getUint8(p)&&225===c.getUint8(p+1)){n=p;break}p++}if(n&&(s=n+10,"Exif"===function(t,i,e){var s,a="";for(s=i,e+=i;s<e;s++)a+=Lt(t.getUint8(s));return a}(c,n+4,4)&&(((o=18761===(h=c.getUint16(s)))||19789===h)&&42===c.getUint16(s+2,o)&&((a=c.getUint32(s+4,o))>=8&&(r=s+a)))),r)for(d=c.getUint16(r,o),l=0;l<d;l++)if(p=r+12*l+2,274===c.getUint16(p,o)){p+=8,i=c.getUint16(p,o),mt&&c.setUint16(p,1,o);break}return i}function v(i,e){this.$element=t(i),this.options=t.extend({},v.DEFAULTS,t.isPlainObject(e)&&e),this.isLoaded=!1,this.isBuilt=!1,this.isCompleted=!1,this.isRotated=!1,this.isCropped=!1,this.isDisabled=!1,this.isReplaced=!1,this.isLimited=!1,this.wheeling=!1,this.isImg=!1,this.originalUrl="",this.canvas=null,this.cropBox=null,this.init()}var w=t(window),x=t(document),C=window.location,b=window.navigator,B=window.ArrayBuffer,y=window.Uint8Array,D=window.DataView,$=window.btoa,L="cropper",T="cropper-modal",X="cropper-hide",Y="cropper-hidden",M="cropper-move",W="cropper-crop",H="cropper-disabled",z="mousedown touchstart pointerdown MSPointerDown",O="mousemove touchmove pointermove MSPointerMove",P="mouseup touchend touchcancel pointerup pointercancel MSPointerUp MSPointerCancel",E="wheel mousewheel DOMMouseScroll",U="dblclick",I="load."+L,F="error."+L,j="resize."+L,A="build."+L,S="built."+L,N="cropstart."+L,_="cropmove."+L,q="cropend."+L,K="crop."+L,Z="zoom."+L,Q=/^(e|w|s|n|se|sw|ne|nw|all|crop|move|zoom)$/,V=/^data:/,G=/^data:([^;]+);base64,/,J=/^data:image\/jpeg.*;base64,/,tt="preview",it="action",ht="se",nt="sw",rt="ne",pt="nw",ct="crop",dt="move",gt="zoom",ft=t.isFunction(t("<canvas>")[0].getContext),mt=b&&/(Macintosh|iPhone|iPod|iPad).*AppleWebKit/i.test(b.userAgent),vt=Number,wt=Math.min,xt=Math.max,Ct=Math.abs,bt=Math.sin,Bt=Math.cos,yt=Math.sqrt,Dt=Math.round,$t=Math.floor,Lt=String.fromCharCode;v.prototype={constructor:v,init:function(){var t,i=this.$element;if(i.is("img")){if(this.isImg=!0,this.originalUrl=t=i.attr("src"),!t)return;t=i.prop("src")}else i.is("canvas")&&ft&&(t=i[0].toDataURL());this.load(t)},trigger:function(i,e){var s=t.Event(i,e);return this.$element.trigger(s),s},load:function(i){var e,s,a=this.options,n=this.$element;if(i&&(n.one(A,a.build),!this.trigger(A).isDefaultPrevented())){if(this.url=i,this.image={},!a.checkOrientation||!B)return this.clone();if(e=t.proxy(this.read,this),V.test(i))return J.test(i)?e(function(t){var i,e=t.replace(G,""),s=atob(e),a=s.length,o=new B(a),h=new y(o);for(i=0;i<a;i++)h[i]=s.charCodeAt(i);return o}(i)):this.clone();(s=new XMLHttpRequest).onerror=s.onabort=t.proxy((function(){this.clone()}),this),s.onload=function(){e(this.response)},a.checkCrossOrigin&&o(i)&&n.prop("crossOrigin")&&(i=h(i)),s.open("get",i),s.responseType="arraybuffer",s.send()}},read:function(t){var i=this.options,e=u(t),s=this.image,a=0,o=1,h=1;if(e>1)switch(this.url=function(t){var i,e=new y(t),s=e.length,a="";for(i=0;i<s;i++)a+=Lt(e[i]);return"data:image/jpeg;base64,"+$(a)}(t),e){case 2:o=-1;break;case 3:a=-180;break;case 4:h=-1;break;case 5:a=90,h=-1;break;case 6:a=90;break;case 7:a=90,o=-1;break;case 8:a=-90}i.rotatable&&(s.rotate=a),i.scalable&&(s.scaleX=o,s.scaleY=h),this.clone()},clone:function(){var i,e,s=this.options,a=this.$element,r=this.url,p="";s.checkCrossOrigin&&o(r)&&((p=a.prop("crossOrigin"))?i=r:(p="anonymous",i=h(r))),this.crossOrigin=p,this.crossOriginUrl=i,this.$clone=e=t("<img"+n(p)+' src="'+(i||r)+'">'),this.isImg?a[0].complete?this.start():a.one(I,t.proxy(this.start,this)):e.one(I,t.proxy(this.start,this)).one(F,t.proxy(this.stop,this)).addClass(X).insertAfter(a)},start:function(){var i=this.$element,e=this.$clone;this.isImg||(e.off(F,this.stop),i=e),function(t,i){var e;t.naturalWidth&&!mt?i(t.naturalWidth,t.naturalHeight):((e=document.createElement("img")).onload=function(){i(this.width,this.height)},e.src=t.src)}(i[0],t.proxy((function(i,e){t.extend(this.image,{naturalWidth:i,naturalHeight:e,aspectRatio:i/e}),this.isLoaded=!0,this.build()}),this))},stop:function(){this.$clone.remove(),this.$clone=null},build:function(){var i,e,s,a=this.options,o=this.$element,h=this.$clone;this.isLoaded&&(this.isBuilt&&this.unbuild(),this.$container=o.parent(),this.$cropper=i=t(v.TEMPLATE),this.$canvas=i.find(".cropper-canvas").append(h),this.$dragBox=i.find(".cropper-drag-box"),this.$cropBox=e=i.find(".cropper-crop-box"),this.$viewBox=i.find(".cropper-view-box"),this.$face=s=e.find(".cropper-face"),o.addClass(Y).after(i),this.isImg||h.removeClass(X),this.initPreview(),this.bind(),a.aspectRatio=xt(0,a.aspectRatio)||NaN,a.viewMode=xt(0,wt(3,Dt(a.viewMode)))||0,a.autoCrop?(this.isCropped=!0,a.modal&&this.$dragBox.addClass(T)):e.addClass(Y),a.guides||e.find(".cropper-dashed").addClass(Y),a.center||e.find(".cropper-center").addClass(Y),a.cropBoxMovable&&s.addClass(M).data(it,"all"),a.highlight||s.addClass("cropper-invisible"),a.background&&i.addClass("cropper-bg"),a.cropBoxResizable||e.find(".cropper-line, .cropper-point").addClass(Y),this.setDragMode(a.dragMode),this.render(),this.isBuilt=!0,this.setData(a.data),o.one(S,a.built),this.completing=setTimeout(t.proxy((function(){this.trigger(S),this.trigger(K,this.getData()),this.isCompleted=!0}),this),0))},unbuild:function(){this.isBuilt&&(this.isCompleted||clearTimeout(this.completing),this.isBuilt=!1,this.isCompleted=!1,this.initialImage=null,this.initialCanvas=null,this.initialCropBox=null,this.container=null,this.canvas=null,this.cropBox=null,this.unbind(),this.resetPreview(),this.$preview=null,this.$viewBox=null,this.$cropBox=null,this.$dragBox=null,this.$canvas=null,this.$container=null,this.$cropper.remove(),this.$cropper=null)},render:function(){this.initContainer(),this.initCanvas(),this.initCropBox(),this.renderCanvas(),this.isCropped&&this.renderCropBox()},initContainer:function(){var t=this.options,i=this.$element,e=this.$container,s=this.$cropper;s.addClass(Y),i.removeClass(Y),s.css(this.container={width:xt(e.width(),vt(t.minContainerWidth)||200),height:xt(e.height(),vt(t.minContainerHeight)||100)}),i.addClass(Y),s.removeClass(Y)},initCanvas:function(){var i,e=this.options.viewMode,s=this.container,a=s.width,o=s.height,h=this.image,n=h.naturalWidth,r=h.naturalHeight,p=90===Ct(h.rotate),l=p?r:n,c=p?n:r,d=l/c,g=a,u=o;o*d>a?3===e?g=o*d:u=a/d:3===e?u=a/d:g=o*d,(i={naturalWidth:l,naturalHeight:c,aspectRatio:d,width:g,height:u}).oldLeft=i.left=(a-g)/2,i.oldTop=i.top=(o-u)/2,this.canvas=i,this.isLimited=1===e||2===e,this.limitCanvas(!0,!0),this.initialImage=t.extend({},h),this.initialCanvas=t.extend({},i)},limitCanvas:function(t,i){var e,s,a,o,h=this.options,n=h.viewMode,r=this.container,p=r.width,l=r.height,c=this.canvas,d=c.aspectRatio,g=this.cropBox,u=this.isCropped&&g;t&&(e=vt(h.minCanvasWidth)||0,s=vt(h.minCanvasHeight)||0,n&&(n>1?(e=xt(e,p),s=xt(s,l),3===n&&(s*d>e?e=s*d:s=e/d)):e?e=xt(e,u?g.width:0):s?s=xt(s,u?g.height:0):u&&(e=g.width,(s=g.height)*d>e?e=s*d:s=e/d)),e&&s?s*d>e?s=e/d:e=s*d:e?s=e/d:s&&(e=s*d),c.minWidth=e,c.minHeight=s,c.maxWidth=1/0,c.maxHeight=1/0),i&&(n?(a=p-c.width,o=l-c.height,c.minLeft=wt(0,a),c.minTop=wt(0,o),c.maxLeft=xt(0,a),c.maxTop=xt(0,o),u&&this.isLimited&&(c.minLeft=wt(g.left,g.left+g.width-c.width),c.minTop=wt(g.top,g.top+g.height-c.height),c.maxLeft=g.left,c.maxTop=g.top,2===n&&(c.width>=p&&(c.minLeft=wt(0,a),c.maxLeft=xt(0,a)),c.height>=l&&(c.minTop=wt(0,o),c.maxTop=xt(0,o))))):(c.minLeft=-c.width,c.minTop=-c.height,c.maxLeft=p,c.maxTop=l))},renderCanvas:function(t){var i,e,s=this.canvas,a=this.image,o=a.rotate,h=a.naturalWidth,n=a.naturalHeight;this.isRotated&&(this.isRotated=!1,(i=(e=l({width:a.width,height:a.height,degree:o})).width/e.height)!==s.aspectRatio&&(s.left-=(e.width-s.width)/2,s.top-=(e.height-s.height)/2,s.width=e.width,s.height=e.height,s.aspectRatio=i,s.naturalWidth=h,s.naturalHeight=n,o%180&&(e=l({width:h,height:n,degree:o}),s.naturalWidth=e.width,s.naturalHeight=e.height),this.limitCanvas(!0,!1))),(s.width>s.maxWidth||s.width<s.minWidth)&&(s.left=s.oldLeft),(s.height>s.maxHeight||s.height<s.minHeight)&&(s.top=s.oldTop),s.width=wt(xt(s.width,s.minWidth),s.maxWidth),s.height=wt(xt(s.height,s.minHeight),s.maxHeight),this.limitCanvas(!1,!0),s.oldLeft=s.left=wt(xt(s.left,s.minLeft),s.maxLeft),s.oldTop=s.top=wt(xt(s.top,s.minTop),s.maxTop),this.$canvas.css({width:s.width,height:s.height,left:s.left,top:s.top}),this.renderImage(),this.isCropped&&this.isLimited&&this.limitCropBox(!0,!0),t&&this.output()},renderImage:function(i){var e,s=this.canvas,a=this.image;a.rotate&&(e=l({width:s.width,height:s.height,degree:a.rotate,aspectRatio:a.aspectRatio},!0)),t.extend(a,e?{width:e.width,height:e.height,left:(s.width-e.width)/2,top:(s.height-e.height)/2}:{width:s.width,height:s.height,left:0,top:0}),this.$clone.css({width:a.width,height:a.height,marginLeft:a.left,marginTop:a.top,transform:p(a)}),i&&this.output()},initCropBox:function(){var i=this.options,e=this.canvas,s=i.aspectRatio,a=vt(i.autoCropArea)||.8,o={width:e.width,height:e.height};s&&(e.height*s>e.width?o.height=o.width/s:o.width=o.height*s),this.cropBox=o,this.limitCropBox(!0,!0),o.width=wt(xt(o.width,o.minWidth),o.maxWidth),o.height=wt(xt(o.height,o.minHeight),o.maxHeight),o.width=xt(o.minWidth,o.width*a),o.height=xt(o.minHeight,o.height*a),o.oldLeft=o.left=e.left+(e.width-o.width)/2,o.oldTop=o.top=e.top+(e.height-o.height)/2,this.initialCropBox=t.extend({},o)},limitCropBox:function(t,i){var e,s,a,o,h=this.options,n=h.aspectRatio,r=this.container,p=r.width,l=r.height,c=this.canvas,d=this.cropBox,g=this.isLimited;t&&(e=vt(h.minCropBoxWidth)||0,s=vt(h.minCropBoxHeight)||0,e=wt(e,p),s=wt(s,l),a=wt(p,g?c.width:p),o=wt(l,g?c.height:l),n&&(e&&s?s*n>e?s=e/n:e=s*n:e?s=e/n:s&&(e=s*n),o*n>a?o=a/n:a=o*n),d.minWidth=wt(e,a),d.minHeight=wt(s,o),d.maxWidth=a,d.maxHeight=o),i&&(g?(d.minLeft=xt(0,c.left),d.minTop=xt(0,c.top),d.maxLeft=wt(p,c.left+c.width)-d.width,d.maxTop=wt(l,c.top+c.height)-d.height):(d.minLeft=0,d.minTop=0,d.maxLeft=p-d.width,d.maxTop=l-d.height))},renderCropBox:function(){var t=this.options,i=this.container,e=i.width,s=i.height,a=this.cropBox;(a.width>a.maxWidth||a.width<a.minWidth)&&(a.left=a.oldLeft),(a.height>a.maxHeight||a.height<a.minHeight)&&(a.top=a.oldTop),a.width=wt(xt(a.width,a.minWidth),a.maxWidth),a.height=wt(xt(a.height,a.minHeight),a.maxHeight),this.limitCropBox(!1,!0),a.oldLeft=a.left=wt(xt(a.left,a.minLeft),a.maxLeft),a.oldTop=a.top=wt(xt(a.top,a.minTop),a.maxTop),t.movable&&t.cropBoxMovable&&this.$face.data(it,a.width===e&&a.height===s?dt:"all"),this.$cropBox.css({width:a.width,height:a.height,left:a.left,top:a.top}),this.isCropped&&this.isLimited&&this.limitCanvas(!0,!0),this.isDisabled||this.output()},output:function(){this.preview(),this.isCompleted&&this.trigger(K,this.getData())},initPreview:function(){var i,e=n(this.crossOrigin),s=e?this.crossOriginUrl:this.url;this.$preview=t(this.options.preview),this.$clone2=i=t("<img"+e+' src="'+s+'">'),this.$viewBox.html(i),this.$preview.each((function(){var i=t(this);i.data(tt,{width:i.width(),height:i.height(),html:i.html()}),i.html("<img"+e+' src="'+s+'" style="display:block;width:100%;height:auto;min-width:0!important;min-height:0!important;max-width:none!important;max-height:none!important;image-orientation:0deg!important;">')}))},resetPreview:function(){this.$preview.each((function(){var i=t(this),e=i.data(tt);i.css({width:e.width,height:e.height}).html(e.html).removeData(tt)}))},preview:function(){var i=this.image,e=this.canvas,s=this.cropBox,a=s.width,o=s.height,h=i.width,n=i.height,r=s.left-e.left-i.left,l=s.top-e.top-i.top;this.isCropped&&!this.isDisabled&&(this.$clone2.css({width:h,height:n,marginLeft:-r,marginTop:-l,transform:p(i)}),this.$preview.each((function(){var e=t(this),s=e.data(tt),c=s.width,d=s.height,g=c,u=d,f=1;a&&(u=o*(f=c/a)),o&&u>d&&(g=a*(f=d/o),u=d),e.css({width:g,height:u}).find("img").css({width:h*f,height:n*f,marginLeft:-r*f,marginTop:-l*f,transform:p(i)})})))},bind:function(){var i=this.options,e=this.$element,s=this.$cropper;t.isFunction(i.cropstart)&&e.on(N,i.cropstart),t.isFunction(i.cropmove)&&e.on(_,i.cropmove),t.isFunction(i.cropend)&&e.on(q,i.cropend),t.isFunction(i.crop)&&e.on(K,i.crop),t.isFunction(i.zoom)&&e.on(Z,i.zoom),s.on(z,t.proxy(this.cropStart,this)),i.zoomable&&i.zoomOnWheel&&s.on(E,t.proxy(this.wheel,this)),i.toggleDragModeOnDblclick&&s.on(U,t.proxy(this.dblclick,this)),x.on(O,this._cropMove=a(this.cropMove,this)).on(P,this._cropEnd=a(this.cropEnd,this)),i.responsive&&w.on(j,this._resize=a(this.resize,this))},unbind:function(){var i=this.options,e=this.$element,s=this.$cropper;t.isFunction(i.cropstart)&&e.off(N,i.cropstart),t.isFunction(i.cropmove)&&e.off(_,i.cropmove),t.isFunction(i.cropend)&&e.off(q,i.cropend),t.isFunction(i.crop)&&e.off(K,i.crop),t.isFunction(i.zoom)&&e.off(Z,i.zoom),s.off(z,this.cropStart),i.zoomable&&i.zoomOnWheel&&s.off(E,this.wheel),i.toggleDragModeOnDblclick&&s.off(U,this.dblclick),x.off(O,this._cropMove).off(P,this._cropEnd),i.responsive&&w.off(j,this._resize)},resize:function(){var i,e,s,a=this.options.restore,o=this.$container,h=this.container;!this.isDisabled&&h&&(1===(s=o.width()/h.width)&&o.height()===h.height||(a&&(i=this.getCanvasData(),e=this.getCropBoxData()),this.render(),a&&(this.setCanvasData(t.each(i,(function(t,e){i[t]=e*s}))),this.setCropBoxData(t.each(e,(function(t,i){e[t]=i*s}))))))},dblclick:function(){this.isDisabled||(this.$dragBox.hasClass(W)?this.setDragMode(dt):this.setDragMode(ct))},wheel:function(i){var e=i.originalEvent||i,s=vt(this.options.wheelZoomRatio)||.1,a=1;this.isDisabled||(i.preventDefault(),this.wheeling||(this.wheeling=!0,setTimeout(t.proxy((function(){this.wheeling=!1}),this),50),e.deltaY?a=e.deltaY>0?1:-1:e.wheelDelta?a=-e.wheelDelta/120:e.detail&&(a=e.detail>0?1:-1),this.zoom(-a*s,i)))},cropStart:function(i){var e,s,a=this.options,o=i.originalEvent,h=o&&o.touches,n=i;if(!this.isDisabled){if(h){if((e=h.length)>1){if(!a.zoomable||!a.zoomOnTouch||2!==e)return;n=h[1],this.startX2=n.pageX,this.startY2=n.pageY,s=gt}n=h[0]}if(s=s||t(n.target).data(it),Q.test(s)){if(this.trigger(N,{originalEvent:o,action:s}).isDefaultPrevented())return;i.preventDefault(),this.action=s,this.cropping=!1,this.startX=n.pageX||o&&o.pageX,this.startY=n.pageY||o&&o.pageY,s===ct&&(this.cropping=!0,this.$dragBox.addClass(T))}}},cropMove:function(t){var i,e=this.options,s=t.originalEvent,a=s&&s.touches,o=t,h=this.action;if(!this.isDisabled){if(a){if((i=a.length)>1){if(!e.zoomable||!e.zoomOnTouch||2!==i)return;o=a[1],this.endX2=o.pageX,this.endY2=o.pageY}o=a[0]}if(h){if(this.trigger(_,{originalEvent:s,action:h}).isDefaultPrevented())return;t.preventDefault(),this.endX=o.pageX||s&&s.pageX,this.endY=o.pageY||s&&s.pageY,this.change(o.shiftKey,h===gt?t:null)}}},cropEnd:function(t){var i=t.originalEvent,e=this.action;this.isDisabled||e&&(t.preventDefault(),this.cropping&&(this.cropping=!1,this.$dragBox.toggleClass(T,this.isCropped&&this.options.modal)),this.action="",this.trigger(q,{originalEvent:i,action:e}))},change:function(t,i){var e,s,o=this.options.aspectRatio,h=this.action,n=this.container,r=this.canvas,p=this.cropBox,l=p.width,c=p.height,d=p.left,g=p.top,u=d+l,f=g+c,m=0,v=0,w=n.width,x=n.height,C=!0;switch(!o&&t&&(o=l&&c?l/c:1),this.isLimited&&(m=p.minLeft,v=p.minTop,w=m+wt(n.width,r.width,r.left+r.width),x=v+wt(n.height,r.height,r.top+r.height)),s={x:this.endX-this.startX,y:this.endY-this.startY},o&&(s.X=s.y*o,s.Y=s.x/o),h){case"all":d+=s.x,g+=s.y;break;case"e":if(s.x>=0&&(u>=w||o&&(g<=v||f>=x))){C=!1;break}l+=s.x,o&&(c=l/o,g-=s.Y/2),l<0&&(h="w",l=0);break;case"n":if(s.y<=0&&(g<=v||o&&(d<=m||u>=w))){C=!1;break}c-=s.y,g+=s.y,o&&(l=c*o,d+=s.X/2),c<0&&(h="s",c=0);break;case"w":if(s.x<=0&&(d<=m||o&&(g<=v||f>=x))){C=!1;break}l-=s.x,d+=s.x,o&&(c=l/o,g+=s.Y/2),l<0&&(h="e",l=0);break;case"s":if(s.y>=0&&(f>=x||o&&(d<=m||u>=w))){C=!1;break}c+=s.y,o&&(l=c*o,d-=s.X/2),c<0&&(h="n",c=0);break;case rt:if(o){if(s.y<=0&&(g<=v||u>=w)){C=!1;break}c-=s.y,g+=s.y,l=c*o}else s.x>=0?u<w?l+=s.x:s.y<=0&&g<=v&&(C=!1):l+=s.x,s.y<=0?g>v&&(c-=s.y,g+=s.y):(c-=s.y,g+=s.y);l<0&&c<0?(h=nt,c=0,l=0):l<0?(h=pt,l=0):c<0&&(h=ht,c=0);break;case pt:if(o){if(s.y<=0&&(g<=v||d<=m)){C=!1;break}c-=s.y,g+=s.y,l=c*o,d+=s.X}else s.x<=0?d>m?(l-=s.x,d+=s.x):s.y<=0&&g<=v&&(C=!1):(l-=s.x,d+=s.x),s.y<=0?g>v&&(c-=s.y,g+=s.y):(c-=s.y,g+=s.y);l<0&&c<0?(h=ht,c=0,l=0):l<0?(h=rt,l=0):c<0&&(h=nt,c=0);break;case nt:if(o){if(s.x<=0&&(d<=m||f>=x)){C=!1;break}l-=s.x,d+=s.x,c=l/o}else s.x<=0?d>m?(l-=s.x,d+=s.x):s.y>=0&&f>=x&&(C=!1):(l-=s.x,d+=s.x),s.y>=0?f<x&&(c+=s.y):c+=s.y;l<0&&c<0?(h=rt,c=0,l=0):l<0?(h=ht,l=0):c<0&&(h=pt,c=0);break;case ht:if(o){if(s.x>=0&&(u>=w||f>=x)){C=!1;break}c=(l+=s.x)/o}else s.x>=0?u<w?l+=s.x:s.y>=0&&f>=x&&(C=!1):l+=s.x,s.y>=0?f<x&&(c+=s.y):c+=s.y;l<0&&c<0?(h=pt,c=0,l=0):l<0?(h=nt,l=0):c<0&&(h=rt,c=0);break;case dt:this.move(s.x,s.y),C=!1;break;case gt:this.zoom(function(t,i,e,s){var a=yt(t*t+i*i);return(yt(e*e+s*s)-a)/a}(Ct(this.startX-this.startX2),Ct(this.startY-this.startY2),Ct(this.endX-this.endX2),Ct(this.endY-this.endY2)),i),this.startX2=this.endX2,this.startY2=this.endY2,C=!1;break;case ct:if(!s.x||!s.y){C=!1;break}e=this.$cropper.offset(),d=this.startX-e.left,g=this.startY-e.top,l=p.minWidth,c=p.minHeight,s.x>0?h=s.y>0?ht:rt:s.x<0&&(d-=l,h=s.y>0?nt:pt),s.y<0&&(g-=c),this.isCropped||(this.$cropBox.removeClass(Y),this.isCropped=!0,this.isLimited&&this.limitCropBox(!0,!0))}C&&(p.width=l,p.height=c,p.left=d,p.top=g,this.action=h,this.renderCropBox()),this.startX=this.endX,this.startY=this.endY},crop:function(){this.isBuilt&&!this.isDisabled&&(this.isCropped||(this.isCropped=!0,this.limitCropBox(!0,!0),this.options.modal&&this.$dragBox.addClass(T),this.$cropBox.removeClass(Y)),this.setCropBoxData(this.initialCropBox))},reset:function(){this.isBuilt&&!this.isDisabled&&(this.image=t.extend({},this.initialImage),this.canvas=t.extend({},this.initialCanvas),this.cropBox=t.extend({},this.initialCropBox),this.renderCanvas(),this.isCropped&&this.renderCropBox())},clear:function(){this.isCropped&&!this.isDisabled&&(t.extend(this.cropBox,{left:0,top:0,width:0,height:0}),this.isCropped=!1,this.renderCropBox(),this.limitCanvas(!0,!0),this.renderCanvas(),this.$dragBox.removeClass(T),this.$cropBox.addClass(Y))},replace:function(t,i){!this.isDisabled&&t&&(this.isImg&&this.$element.attr("src",t),i?(this.url=t,this.$clone.attr("src",t),this.isBuilt&&this.$preview.find("img").add(this.$clone2).attr("src",t)):(this.isImg&&(this.isReplaced=!0),this.options.data=null,this.load(t)))},enable:function(){this.isBuilt&&(this.isDisabled=!1,this.$cropper.removeClass(H))},disable:function(){this.isBuilt&&(this.isDisabled=!0,this.$cropper.addClass(H))},destroy:function(){var t=this.$element;this.isLoaded?(this.isImg&&this.isReplaced&&t.attr("src",this.originalUrl),this.unbuild(),t.removeClass(Y)):this.isImg?t.off(I,this.start):this.$clone&&this.$clone.remove(),t.removeData(L)},move:function(t,i){var s=this.canvas;this.moveTo(e(t)?t:s.left+vt(t),e(i)?i:s.top+vt(i))},moveTo:function(t,s){var a=this.canvas,o=!1;e(s)&&(s=t),t=vt(t),s=vt(s),this.isBuilt&&!this.isDisabled&&this.options.movable&&(i(t)&&(a.left=t,o=!0),i(s)&&(a.top=s,o=!0),o&&this.renderCanvas(!0))},zoom:function(t,i){var e=this.canvas;t=(t=vt(t))<0?1/(1-t):1+t,this.zoomTo(e.width*t/e.naturalWidth,i)},zoomTo:function(t,i){var e,s,a,o,h,n=this.options,r=this.canvas,p=r.width,l=r.height,c=r.naturalWidth,g=r.naturalHeight;if((t=vt(t))>=0&&this.isBuilt&&!this.isDisabled&&n.zoomable){if(s=c*t,a=g*t,i&&(e=i.originalEvent),this.trigger(Z,{originalEvent:e,oldRatio:p/c,ratio:s/c}).isDefaultPrevented())return;e?(o=this.$cropper.offset(),h=e.touches?d(e.touches):{pageX:i.pageX||e.pageX||0,pageY:i.pageY||e.pageY||0},r.left-=(s-p)*((h.pageX-o.left-r.left)/p),r.top-=(a-l)*((h.pageY-o.top-r.top)/l)):(r.left-=(s-p)/2,r.top-=(a-l)/2),r.width=s,r.height=a,this.renderCanvas(!0)}},rotate:function(t){this.rotateTo((this.image.rotate||0)+vt(t))},rotateTo:function(t){i(t=vt(t))&&this.isBuilt&&!this.isDisabled&&this.options.rotatable&&(this.image.rotate=t%360,this.isRotated=!0,this.renderCanvas(!0))},scale:function(t,s){var a=this.image,o=!1;e(s)&&(s=t),t=vt(t),s=vt(s),this.isBuilt&&!this.isDisabled&&this.options.scalable&&(i(t)&&(a.scaleX=t,o=!0),i(s)&&(a.scaleY=s,o=!0),o&&this.renderImage(!0))},scaleX:function(t){var e=this.image.scaleY;this.scale(t,i(e)?e:1)},scaleY:function(t){var e=this.image.scaleX;this.scale(i(e)?e:1,t)},getData:function(i){var e,s,a=this.options,o=this.image,h=this.canvas,n=this.cropBox;return this.isBuilt&&this.isCropped?(s={x:n.left-h.left,y:n.top-h.top,width:n.width,height:n.height},e=o.width/o.naturalWidth,t.each(s,(function(t,a){a/=e,s[t]=i?Dt(a):a}))):s={x:0,y:0,width:0,height:0},a.rotatable&&(s.rotate=o.rotate||0),a.scalable&&(s.scaleX=o.scaleX||1,s.scaleY=o.scaleY||1),s},setData:function(e){var s,a,o,h=this.options,n=this.image,r=this.canvas,p={};t.isFunction(e)&&(e=e.call(this.element)),this.isBuilt&&!this.isDisabled&&t.isPlainObject(e)&&(h.rotatable&&i(e.rotate)&&e.rotate!==n.rotate&&(n.rotate=e.rotate,this.isRotated=s=!0),h.scalable&&(i(e.scaleX)&&e.scaleX!==n.scaleX&&(n.scaleX=e.scaleX,a=!0),i(e.scaleY)&&e.scaleY!==n.scaleY&&(n.scaleY=e.scaleY,a=!0)),s?this.renderCanvas():a&&this.renderImage(),o=n.width/n.naturalWidth,i(e.x)&&(p.left=e.x*o+r.left),i(e.y)&&(p.top=e.y*o+r.top),i(e.width)&&(p.width=e.width*o),i(e.height)&&(p.height=e.height*o),this.setCropBoxData(p))},getContainerData:function(){return this.isBuilt?this.container:{}},getImageData:function(){return this.isLoaded?this.image:{}},getCanvasData:function(){var i=this.canvas,e={};return this.isBuilt&&t.each(["left","top","width","height","naturalWidth","naturalHeight"],(function(t,s){e[s]=i[s]})),e},setCanvasData:function(e){var s=this.canvas,a=s.aspectRatio;t.isFunction(e)&&(e=e.call(this.$element)),this.isBuilt&&!this.isDisabled&&t.isPlainObject(e)&&(i(e.left)&&(s.left=e.left),i(e.top)&&(s.top=e.top),i(e.width)?(s.width=e.width,s.height=e.width/a):i(e.height)&&(s.height=e.height,s.width=e.height*a),this.renderCanvas(!0))},getCropBoxData:function(){var t,i=this.cropBox;return this.isBuilt&&this.isCropped&&(t={left:i.left,top:i.top,width:i.width,height:i.height}),t||{}},setCropBoxData:function(e){var s,a,o=this.cropBox,h=this.options.aspectRatio;t.isFunction(e)&&(e=e.call(this.$element)),this.isBuilt&&this.isCropped&&!this.isDisabled&&t.isPlainObject(e)&&(i(e.left)&&(o.left=e.left),i(e.top)&&(o.top=e.top),i(e.width)&&(s=!0,o.width=e.width),i(e.height)&&(a=!0,o.height=e.height),h&&(s?o.height=o.width/h:a&&(o.width=o.height*h)),this.renderCropBox())},getCroppedCanvas:function(i){var e,s,a,o,h,n,r,p,l,d,g;if(this.isBuilt&&ft)return this.isCropped?(t.isPlainObject(i)||(i={}),g=this.getData(),e=g.width,s=g.height,p=e/s,t.isPlainObject(i)&&(h=i.width,n=i.height,h?(n=h/p,r=h/e):n&&(h=n*p,r=n/s)),a=$t(h||e),o=$t(n||s),(l=t("<canvas>")[0]).width=a,l.height=o,d=l.getContext("2d"),i.fillColor&&(d.fillStyle=i.fillColor,d.fillRect(0,0,a,o)),d.drawImage.apply(d,function(){var t,i,a,o,h,n,p=c(this.$clone[0],this.image),l=p.width,d=p.height,u=this.canvas,f=[p],m=g.x+u.naturalWidth*(Ct(g.scaleX||1)-1)/2,v=g.y+u.naturalHeight*(Ct(g.scaleY||1)-1)/2;return m<=-e||m>l?m=t=a=h=0:m<=0?(a=-m,t=h=wt(l,e+(m=0))):m<=l&&(a=0,t=h=wt(e,l-m)),t<=0||v<=-s||v>d?v=i=o=n=0:v<=0?(o=-v,i=n=wt(d,s+(v=0))):v<=d&&(o=0,i=n=wt(s,d-v)),f.push($t(m),$t(v),$t(t),$t(i)),r&&(a*=r,o*=r,h*=r,n*=r),h>0&&n>0&&f.push($t(a),$t(o),$t(h),$t(n)),f}.call(this)),l):c(this.$clone[0],this.image)},setAspectRatio:function(t){var i=this.options;this.isDisabled||e(t)||(i.aspectRatio=xt(0,t)||NaN,this.isBuilt&&(this.initCropBox(),this.isCropped&&this.renderCropBox()))},setDragMode:function(t){var i,e,s=this.options;this.isLoaded&&!this.isDisabled&&(i=t===ct,e=s.movable&&t===dt,t=i||e?t:"none",this.$dragBox.data(it,t).toggleClass(W,i).toggleClass(M,e),s.cropBoxMovable||this.$face.data(it,t).toggleClass(W,i).toggleClass(M,e))}},v.DEFAULTS={viewMode:0,dragMode:"crop",aspectRatio:NaN,data:null,preview:"",responsive:!0,restore:!0,checkCrossOrigin:!0,checkOrientation:!0,modal:!0,guides:!0,center:!0,highlight:!0,background:!0,autoCrop:!0,autoCropArea:.8,movable:!0,rotatable:!0,scalable:!0,zoomable:!0,zoomOnTouch:!0,zoomOnWheel:!0,wheelZoomRatio:.1,cropBoxMovable:!0,cropBoxResizable:!0,toggleDragModeOnDblclick:!0,minCanvasWidth:0,minCanvasHeight:0,minCropBoxWidth:0,minCropBoxHeight:0,minContainerWidth:200,minContainerHeight:100,build:null,built:null,cropstart:null,cropmove:null,cropend:null,crop:null,zoom:null},v.setDefaults=function(i){t.extend(v.DEFAULTS,i)},v.TEMPLATE='<div class="cropper-container"><div class="cropper-wrap-box"><div class="cropper-canvas"></div></div><div class="cropper-drag-box"></div><div class="cropper-crop-box"><span class="cropper-view-box"></span><span class="cropper-dashed dashed-h"></span><span class="cropper-dashed dashed-v"></span><span class="cropper-center"></span><span class="cropper-face"></span><span class="cropper-line line-e" data-action="e"></span><span class="cropper-line line-n" data-action="n"></span><span class="cropper-line line-w" data-action="w"></span><span class="cropper-line line-s" data-action="s"></span><span class="cropper-point point-e" data-action="e"></span><span class="cropper-point point-n" data-action="n"></span><span class="cropper-point point-w" data-action="w"></span><span class="cropper-point point-s" data-action="s"></span><span class="cropper-point point-ne" data-action="ne"></span><span class="cropper-point point-nw" data-action="nw"></span><span class="cropper-point point-sw" data-action="sw"></span><span class="cropper-point point-se" data-action="se"></span></div></div>',v.other=t.fn.cropper,t.fn.cropper=function(i){var a,o=s(arguments,1);return this.each((function(){var e,s,h=t(this),n=h.data(L);if(!n){if(/destroy/.test(i))return;e=t.extend({},h.data(),t.isPlainObject(i)&&i),h.data(L,n=new v(this,e))}"string"==typeof i&&t.isFunction(s=n[i])&&(a=s.apply(n,o))})),e(a)?this:a},t.fn.cropper.Constructor=v,t.fn.cropper.setDefaults=v.setDefaults,t.fn.cropper.noConflict=function(){return t.fn.cropper=v.other,this}}));
/**
 * EGroupware eTemplate2 - JS Description object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2011
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_baseWidget_1=require("./et2_core_baseWidget"),et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_image=function(_super){function et2_image(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_image._attributes,_child||{}))||this;return _this.image=null,_this.image=jQuery(document.createElement("img")),_this.options.label&&_this.image.attr("alt",_this.options.label).attr("title",_this.options.label),_this.options.href&&_this.image.addClass("et2_clickable"),_this.options.class&&_this.image.addClass(_this.options.class),_this.setDOMNode(_this.image[0]),_this}return __extends(et2_image,_super),et2_image.prototype.click=function(_ev){this.options.href?this.egw().open_link(this.options.href,this.options.extra_link_target,this.options.extra_link_popup):_super.prototype.click.call(this,_ev)},et2_image.prototype.transformAttributes=function(_attrs){if(_super.prototype.transformAttributes.call(this,_attrs),void 0!==_attrs.src){var manager=this.getArrayMgr("content");if(manager&&_attrs.src){var src=manager.getEntry(_attrs.src,!1,!0);null!=src&&("object"==typeof src&&(src=egw().link("/index.php",src)),_attrs.src=src)}}},et2_image.prototype.set_label=function(_value){this.options.label=_value,_value=this.egw().lang(_value),this.image.attr("alt",_value).attr("title",_value)},et2_image.prototype.setValue=function(_value){this.set_src(_value)},et2_image.prototype.set_href=function(_value){if(!this.isInTree())return!1;this.options.href=_value,this.image.wrapAll('<a href="'+_value+'"></a>"');var href=this.options.href,popup=this.options.extra_link_popup,target=this.options.extra_link_target,self=this;return this.image.click((function(e){return self.options.expose_view?e.stopImmediatePropagation():egw.open_link(href,target,popup),e.preventDefault(),!1})),!0},et2_image.prototype.set_src=function(_value){if(!this.isInTree())return!1;if(this.options.src=_value,"/"==_value[0]||"http"==_value.substr(0,4)||"data:"==_value.substr(0,5))return this.image.attr("src",_value).show(),!0;var src=this.egw().image(_value);return src?(this.image.attr("src",src).show(),!0):(src=null,this.options.default_src&&(src=this.egw().image(this.options.default_src)),src?this.image.attr("src",src).show():this.image.css("display","none"),!1)},et2_image.prototype.getMedia=function(_value){var base_url=egw.webserverUrl.match(/^\/ig/)?egw(window).window.location.origin+egw.webserverUrl+"/":egw.webserverUrl+"/",mediaContent=[];return _value&&(mediaContent=[{title:this.options.label,href:base_url+_value,type:this.options.type+"/*",thumbnail:base_url+_value}]),mediaContent},et2_image.prototype.getDetachedAttributes=function(_attrs){_attrs.push("src","label","href")},et2_image.prototype.getDetachedNodes=function(){return[this.image[0]]},et2_image.prototype.setDetachedAttributes=function(_nodes,_values){this.image=jQuery(_nodes[0]),_values.src&&this.set_src(_values.src),_values.value&&this.setValue(_values.value),_values.label&&this.set_label(_values.label),_values.href&&(this.image.addClass("et2_clickable"),this.set_href(_values.href))},et2_image._attributes={src:{name:"Image",type:"string",description:"Displayed image"},default_src:{name:"Default image",type:"string",description:"Image to use if src is not found"},href:{name:"Link Target",type:"string",description:"Link URL, empty if you don't wan't to display a link.",default:et2_no_init},extra_link_target:{name:"Link target",type:"string",default:"_self",description:"Link target descriptor"},extra_link_popup:{name:"Popup",type:"string",description:"widthxheight, if popup should be used, eg. 640x480"},imagemap:{name:"Image map",description:"Currently not implemented"},label:{name:"Label",type:"string",description:"Label for image"},expose_view:{name:"Expose view",type:"boolean",default:!1,description:"Clicking on an image with href value would popup an expose view, and will show image referenced by href."}},et2_image.legacyOptions=["href","extra_link_target","imagemap","extra_link_popup","id"],et2_image}(et2_core_baseWidget_1.et2_baseWidget);et2_core_widget_1.et2_register_widget(et2_image,["image"]);var et2_appicon=function(_super){function et2_appicon(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(et2_appicon,_super),et2_appicon.prototype.set_src=function(_app){return _app||(_app=this.egw().app_name()),this.image.addClass("et2_appicon"),_super.prototype.set_src.call(this,"sitemgr-link"==_app?"sitemgr/sitemgr-link":(this.egw().app(_app,"icon_app")||_app)+"/"+(this.egw().app(_app,"icon")||"navbar"))},et2_appicon._attributes={default_src:{name:"Default image",type:"string",default:"nonav",description:"Image to use if there is no application icon"}},et2_appicon}(et2_image);et2_core_widget_1.et2_register_widget(et2_appicon,["appicon"]);var et2_avatar=function(_super){function et2_avatar(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_avatar._attributes,_child||{}))||this;return"circle"==_this.options.frame&&_this.image.attr("style","border-radius:50%"),_this.options.contact_id&&_this.setValue(_this.options.contact_id),_this}return __extends(et2_avatar,_super),et2_avatar.lavatar=function(_fname,_lname,_id){var bg=function(_str){for(var hash=0,i=0;i<_str.length;i++)hash=_str[i].charCodeAt(0)+hash;return et2_avatar.LAVATAR_BG_COLORS[hash%et2_avatar.LAVATAR_BG_COLORS.length]}(_fname+_lname+_id),size=et2_avatar.LAVATAR_SIZE*(window.devicePixelRatio?window.devicePixelRatio:1),text=(_fname?_fname[0].toUpperCase():"")+(_lname?_lname[0].toUpperCase():""),canvas=document.createElement("canvas");canvas.width=size,canvas.height=size;var context=canvas.getContext("2d");context.fillStyle=bg,context.fillRect(0,0,canvas.width,canvas.height),context.font=Math.round(canvas.width/2)+"px Arial",context.textAlign="center",context.fillStyle=et2_avatar.LAVATAR_TEXT_COLOR,context.fillText(text,size/2,size/1.5);var dataURL=canvas.toDataURL();return canvas.remove(),dataURL},et2_avatar.uploadAvatar_onFinish=function(e){var file=e.data.resumable.files[0].file,reader=new FileReader;reader.onload=function(e){jQuery("#_cropper_image").attr("src",e.target.result),jQuery("#_cropper_image").cropper("replace",e.target.result)},reader.readAsDataURL(file)},et2_avatar.prototype.set_contact_id=function(_contact_id){var params={},id="contact_id";this.image.addClass("et2_avatar"),_contact_id?_contact_id.match(/account:/)?(id="account_id",_contact_id=_contact_id.replace("account:","")):(id="contact_id",_contact_id=_contact_id.replace("contact:","")):_contact_id=this.egw().user("account_id"),this.options.src&&this.options.src.match("(&|\\?)contact_id="+_contact_id+"(&|\\$)")||(params[id]=_contact_id,this.set_src(egw.link("/api/avatar.php",params)))},et2_avatar.prototype.setValue=function(_value){this.set_contact_id(_value)},et2_avatar.prototype.getDetachedAttributes=function(_attrs){_attrs.push("contact_id","label","href")},et2_avatar.prototype.setDetachedAttributes=function(_nodes,_values){this.image=jQuery(_nodes[0]),_values.contact_id&&this.set_contact_id(_values.contact_id),_values.label&&this.set_label(_values.label),_values.href&&(this.image.addClass("et2_clickable"),this.set_href(_values.href))},et2_avatar.prototype._buildEditableLayer=function(_noDelete){var self=this,eml=jQuery(document.createElement("div")).addClass("eml").insertAfter(this.image);jQuery(document.createElement("div")).addClass("emlEdit").click((function(){var _title,_value,_buttons,_egw_or_appname,buttons=[{button_id:1,text:self.egw().lang("save"),id:"save",image:"check",default:!0},{button_id:0,text:self.egw().lang("cancel"),id:"cancel",image:"cancelled"}];_title=egw.lang("Edit avatar"),_value={photo:self.options.contact_id},_buttons=buttons,_egw_or_appname=null,et2_createWidget("dialog",{callback:function(_buttons,_value){if("save"==_buttons){var canvas=jQuery("#_cropper_image").cropper("getCroppedCanvas");self.image.attr("src",canvas.toDataURL("image/jpeg",1)),self.egw().json("addressbook.addressbook_ui.ajax_update_photo",[self.getInstanceManager().etemplate_exec_id,canvas.toDataURL("image/jpeg",1)],(function(res){res&&del.show()})).sendRequest()}},title:_title||egw.lang("Input required"),buttons:_buttons||et2_dialog.BUTTONS_OK_CANCEL,value:{content:_value},width:"90%",height:"450",resizable:!1,position:"top+10",template:egw.webserverUrl+"/api/templates/default/avatar_edit.xet?2"},et2_dialog._create_parent(_egw_or_appname))})).appendTo(eml);var del=jQuery(document.createElement("div")).addClass("emlDelete").click((function(){et2_dialog.show_dialog((function(_btn){_btn==et2_dialog.YES_BUTTON&&self.egw().json("addressbook.addressbook_ui.ajax_update_photo",[self.getInstanceManager().etemplate_exec_id,null],(function(res){res&&(self.image.attr("src",""),del.hide(),egw.refresh("Avatar Deleted.",egw.app_name()))})).sendRequest()}),egw.lang("Delete this photo?"),egw.lang("Delete"),null,et2_dialog.BUTTONS_YES_NO)})).appendTo(eml);_noDelete&&del.hide(),eml.css("opacity","0"),eml.parent().css("position","relative"),eml.on({mouseover:function(){eml.css("opacity","0.9")},mouseout:function(){eml.css("opacity","0")}})},et2_avatar.prototype.doLoadingFinished=function(){_super.prototype.doLoadingFinished.call(this);var self=this;return this.options.contact_id&&this.options.editable&&egw(window).json("addressbook.addressbook_ui.ajax_noPhotoExists",[this.options.contact_id],(function(noPhotoExists){noPhotoExists&&self.image.attr("src",""),self._buildEditableLayer(noPhotoExists)})).sendRequest(!0),this.options.crop&&jQuery(this.image).cropper({aspectRatio:1,crop:function(e){console.log(e)}}),!0},et2_avatar._attributes={contact_id:{name:"Contact id",type:"string",default:"",description:"Contact id should be either user account_id {account:number} or contact_id {contact:number or number}"},default_src:{ignore:!0},frame:{name:"Avatar frame",type:"string",default:"circle",description:"Define the shape of frame that avatar will be shown inside it. it can get {circle,rectangle} values which default value is cicle."},editable:{name:"Edit avatar",type:"boolean",default:!1,description:"Make avatar widget editable to be able to crop profile picture or upload a new photo"},crop:{name:"Crop avatar",type:"boolean",default:!1,description:"Create crop container and cropping feature"}},et2_avatar.LAVATAR_BG_COLORS=["#5a8770","#b2b7bb","#6fa9ab","#f5af29","#0088b9","#f18636","#d93a37","#a6b12e","#0088b9","#f18636","#d93a37","#a6b12e","#5c9bbc","#f5888d","#9a89b5","#407887","#9a89b5","#5a8770","#d33f33","#a2b01f","#f0b126","#0087bf","#f18636","#0087bf","#b2b7bb","#72acae","#9c8ab4","#5a8770","#eeb424","#407887"],et2_avatar.LAVATAR_TEXT_COLOR="#ffffff",et2_avatar.LAVATAR_SIZE=128,et2_avatar}(et2_image);et2_core_widget_1.et2_register_widget(et2_avatar,["avatar"]);var et2_avatar_ro=function(_super){function et2_avatar_ro(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_avatar_ro._attributes,_child||{}))||this;return _this.options.editable=!1,_this}return __extends(et2_avatar_ro,_super),et2_avatar_ro}(et2_avatar);et2_core_widget_1.et2_register_widget(et2_avatar_ro,["avatar_ro"]);var et2_lavatar=function(_super){function et2_lavatar(_parent,_attrs,_child){return _super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_lavatar._attributes,_child||{}))||this}return __extends(et2_lavatar,_super),et2_lavatar.prototype.set_src=function(_url){if(_url&&decodeURIComponent(_url).match("lavatar=1")&&(this.options.fname||this.options.lname)&&this.options.contact_id)return this.set_src(et2_avatar.lavatar(this.options.fname,this.options.lname,this.options.contact_id)),!1;_super.prototype.set_src.call(this,_url)},et2_lavatar._attributes={lname:{name:"last name",type:"string",default:"",description:""},fname:{name:"first name",type:"string",default:"",description:""},contact_id:{name:"contact id",type:"string",default:"",description:""}},et2_lavatar}(et2_image);et2_core_widget_1.et2_register_widget(et2_lavatar,["lavatar"]);
/**
 * EGroupware eTemplate2 - JS widget class for an iframe
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2013
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_valueWidget_1=require("./et2_core_valueWidget"),et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_iframe=function(_super){function et2_iframe(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_iframe._attributes,_child||{}))||this;return _this.htmlNode=null,_this.supportedWidgetClasses=[],_this.htmlNode=jQuery(document.createElement("iframe")),_this.options.label&&_this.htmlNode.append('<span class="et2_label">'+_this.options.label+"</span>"),_this.options.fullscreen&&_this.htmlNode.attr("allowfullscreen",1),_this.setDOMNode(_this.htmlNode[0]),_this}return __extends(et2_iframe,_super),et2_iframe.prototype.set_name=function(_name){this.options.name=_name,this.htmlNode.attr("name",_name)},et2_iframe.prototype.set_allow=function(_allow){this.options.allow=_allow,this.htmlNode.attr("allow",_allow)},et2_iframe.prototype.set_seamless=function(_seamless){this.options.seamless=_seamless,this.htmlNode.attr("seamless",_seamless)},et2_iframe.prototype.set_value=function(_value){void 0===_value&&(_value=""),0==_value.trim().indexOf("http")||0==_value.indexOf("about:")||"/"==_value[0]?this.set_src(_value):this.set_srcdoc(_value)},et2_iframe.prototype.set_src=function(_value){if(""!=_value.trim())if("about:blank"==_value.trim())this.htmlNode.attr("src",_value);else{var loader_1=jQuery('<div class="et2_iframe loading"/>');this.htmlNode.before(loader_1),window.setTimeout(jQuery.proxy((function(){this.htmlNode.attr("src",_value).one("load",(function(){loader_1.remove()}))}),this),0)}},et2_iframe.prototype.set_srcdoc=function(_value){this.htmlNode.attr("srcdoc",_value)},et2_iframe._attributes={label:{default:"",description:"The label is displayed by default in front (for radiobuttons behind) each widget (if not empty). If you want to specify a different position, use a '%s' in the label, which gets replaced by the widget itself. Eg. '%s Name' to have the label Name behind a checkbox. The label can contain variables, as descript for name. If the label starts with a '@' it is replaced by the value of the content-array at this index (with the '@'-removed and after expanding the variables).",ignore:!1,name:"Label",translate:!0,type:"string"},needed:{ignore:!0},seamless:{name:"Seamless",default:!0,description:"Specifies that the iframe should be rendered in a manner that makes it appear to be part of the containing document",translate:!1,type:"boolean"},name:{name:"Name",default:"",description:"Specifies name of frame, to be used as target for links",type:"string"},fullscreen:{name:"Fullscreen",default:!1,description:"Make the iframe compatible to be a fullscreen video player mode",type:"boolean"},src:{name:"Source",default:"",description:"Specifies URL for the iframe",type:"string"},allow:{name:"Allow",default:"",description:"Specifies list of allow features, e.g. camera",type:"string"}},et2_iframe}(et2_core_valueWidget_1.et2_valueWidget);et2_core_widget_1.et2_register_widget(et2_iframe,["iframe"]),function(){var Resumable=function(opts){if(!(this instanceof Resumable))return new Resumable(opts);if(this.version=1,this.support=!("undefined"==typeof File||"undefined"==typeof Blob||"undefined"==typeof FileList||!Blob.prototype.webkitSlice&&!Blob.prototype.mozSlice&&!Blob.prototype.slice),!this.support)return!1;var $=this;$.files=[],$.defaults={chunkSize:1048576,forceChunkSize:!1,simultaneousUploads:3,fileParameterName:"file",chunkNumberParameterName:"resumableChunkNumber",chunkSizeParameterName:"resumableChunkSize",currentChunkSizeParameterName:"resumableCurrentChunkSize",totalSizeParameterName:"resumableTotalSize",typeParameterName:"resumableType",identifierParameterName:"resumableIdentifier",fileNameParameterName:"resumableFilename",relativePathParameterName:"resumableRelativePath",totalChunksParameterName:"resumableTotalChunks",dragOverClass:"dragover",throttleProgressCallbacks:.5,query:{},headers:{},preprocess:null,preprocessFile:null,method:"multipart",uploadMethod:"POST",testMethod:"GET",prioritizeFirstAndLastChunk:!1,target:"/",testTarget:null,parameterNamespace:"",testChunks:!0,generateUniqueIdentifier:null,getTarget:null,maxChunkRetries:100,chunkRetryInterval:void 0,permanentErrors:[400,401,403,404,409,415,500,501],maxFiles:void 0,withCredentials:!1,xhrTimeout:0,clearInput:!0,chunkFormat:"blob",setChunkTypeFromFile:!1,maxFilesErrorCallback:function(files,errorCount){var maxFiles=$.getOpt("maxFiles");alert("Please upload no more than "+maxFiles+" file"+(1===maxFiles?"":"s")+" at a time.")},minFileSize:1,minFileSizeErrorCallback:function(file,errorCount){alert(file.fileName||file.name+" is too small, please upload files larger than "+$h.formatSize($.getOpt("minFileSize"))+".")},maxFileSize:void 0,maxFileSizeErrorCallback:function(file,errorCount){alert(file.fileName||file.name+" is too large, please upload files less than "+$h.formatSize($.getOpt("maxFileSize"))+".")},fileType:[],fileTypeErrorCallback:function(file,errorCount){alert(file.fileName||file.name+" has type not allowed, please upload files of type "+$.getOpt("fileType")+".")}},$.opts=opts||{},$.getOpt=function(o){var $opt=this;if(o instanceof Array){var options={};return $h.each(o,(function(option){options[option]=$opt.getOpt(option)})),options}if($opt instanceof ResumableChunk){if(void 0!==$opt.opts[o])return $opt.opts[o];$opt=$opt.fileObj}if($opt instanceof ResumableFile){if(void 0!==$opt.opts[o])return $opt.opts[o];$opt=$opt.resumableObj}if($opt instanceof Resumable)return void 0!==$opt.opts[o]?$opt.opts[o]:$opt.defaults[o]},$.indexOf=function(array,obj){if(array.indexOf)return array.indexOf(obj);for(var i=0;i<array.length;i++)if(array[i]===obj)return i;return-1},$.events=[],$.on=function(event,callback){$.events.push(event.toLowerCase(),callback)},$.fire=function(){for(var args=[],i=0;i<arguments.length;i++)args.push(arguments[i]);var event=args[0].toLowerCase();for(i=0;i<=$.events.length;i+=2)$.events[i]==event&&$.events[i+1].apply($,args.slice(1)),"catchall"==$.events[i]&&$.events[i+1].apply(null,args);"fileerror"==event&&$.fire("error",args[2],args[1]),"fileprogress"==event&&$.fire("progress")};var $h={stopEvent:function(e){e.stopPropagation(),e.preventDefault()},each:function(o,callback){if(void 0!==o.length){for(var i=0;i<o.length;i++)if(!1===callback(o[i]))return}else for(i in o)if(!1===callback(i,o[i]))return},generateUniqueIdentifier:function(file,event){var custom=$.getOpt("generateUniqueIdentifier");if("function"==typeof custom)return custom(file,event);var relativePath=file.webkitRelativePath||file.relativePath||file.fileName||file.name;return file.size+"-"+relativePath.replace(/[^0-9a-zA-Z_-]/gim,"")},contains:function(array,test){var result=!1;return $h.each(array,(function(value){return value!=test||(result=!0,!1)})),result},formatSize:function(size){return size<1024?size+" bytes":size<1048576?(size/1024).toFixed(0)+" KB":size<1073741824?(size/1024/1024).toFixed(1)+" MB":(size/1024/1024/1024).toFixed(1)+" GB"},getTarget:function(request,params){var target=$.getOpt("target");if("test"===request&&$.getOpt("testTarget")&&(target="/"===$.getOpt("testTarget")?$.getOpt("target"):$.getOpt("testTarget")),"function"==typeof target)return target(params);var separator=target.indexOf("?")<0?"?":"&",joinedParams=params.join("&");return joinedParams&&(target=target+separator+joinedParams),target}},onDrop=function(e){e.currentTarget.classList.remove($.getOpt("dragOverClass")),$h.stopEvent(e),e.dataTransfer&&e.dataTransfer.items?loadFiles(e.dataTransfer.items,e):e.dataTransfer&&e.dataTransfer.files&&loadFiles(e.dataTransfer.files,e)},onDragLeave=function(e){e.currentTarget.classList.remove($.getOpt("dragOverClass"))},onDragOverEnter=function(e){e.preventDefault();var dt=e.dataTransfer;$.indexOf(dt.types,"Files")>=0?(e.stopPropagation(),dt.dropEffect="copy",dt.effectAllowed="copy",e.currentTarget.classList.add($.getOpt("dragOverClass"))):(dt.dropEffect="none",dt.effectAllowed="none")};function processItem(item,path,items,cb){var entry;return item.isFile?item.file((function(file){file.relativePath=path+file.name,items.push(file),cb()})):(item.isDirectory?entry=item:item instanceof File&&items.push(item),"function"==typeof item.webkitGetAsEntry&&(entry=item.webkitGetAsEntry()),entry&&entry.isDirectory?function(directory,path,items,cb){var dirReader=directory.createReader(),allEntries=[];!function readEntries(){dirReader.readEntries((function(entries){if(entries.length)return allEntries=allEntries.concat(entries),readEntries();processCallbacks(allEntries.map((function(entry){return processItem.bind(null,entry,path,items)})),cb)}))}()}(entry,path+entry.name+"/",items,cb):("function"==typeof item.getAsFile&&(item=item.getAsFile())instanceof File&&(item.relativePath=path+item.name,items.push(item)),void cb()))}function processCallbacks(items,cb){if(!items||0===items.length)return cb();items[0]((function(){processCallbacks(items.slice(1),cb)}))}function loadFiles(items,event){if(items.length){$.fire("beforeAdd");var files=[];processCallbacks(Array.prototype.map.call(items,(function(item){var entry=item;return"function"==typeof item.webkitGetAsEntry&&(entry=item.webkitGetAsEntry()||item),processItem.bind(null,entry,"",files)})),(function(){files.length&&appendFilesFromFileList(files,event)}))}}var appendFilesFromFileList=function(fileList,event){var errorCount=0,o=$.getOpt(["maxFiles","minFileSize","maxFileSize","maxFilesErrorCallback","minFileSizeErrorCallback","maxFileSizeErrorCallback","fileType","fileTypeErrorCallback"]);if(void 0!==o.maxFiles&&o.maxFiles<fileList.length+$.files.length){if(1!==o.maxFiles||1!==$.files.length||1!==fileList.length)return o.maxFilesErrorCallback(fileList,errorCount++),!1;$.removeFile($.files[0])}var files=[],filesSkipped=[],remaining=fileList.length,decreaseReamining=function(){if(!--remaining){if(!files.length&&!filesSkipped.length)return;window.setTimeout((function(){$.fire("filesAdded",files,filesSkipped)}),0)}};$h.each(fileList,(function(file){var fileName=file.name,fileType=file.type;if(o.fileType.length>0){var fileTypeFound=!1;for(var index in o.fileType){o.fileType[index]=o.fileType[index].replace(/\s/g,"").toLowerCase();var extension=(o.fileType[index].match(/^[^.][^/]+$/)?".":"")+o.fileType[index];if(fileName.substr(-1*extension.length).toLowerCase()===extension||-1!==extension.indexOf("/")&&(-1!==extension.indexOf("*")&&fileType.substr(0,extension.indexOf("*"))===extension.substr(0,extension.indexOf("*"))||fileType===extension)){fileTypeFound=!0;break}}if(!fileTypeFound)return o.fileTypeErrorCallback(file,errorCount++),!0}if(void 0!==o.minFileSize&&file.size<o.minFileSize)return o.minFileSizeErrorCallback(file,errorCount++),!0;if(void 0!==o.maxFileSize&&file.size>o.maxFileSize)return o.maxFileSizeErrorCallback(file,errorCount++),!0;function addFile(uniqueIdentifier){$.getFromUniqueIdentifier(uniqueIdentifier)?filesSkipped.push(file):function(){file.uniqueIdentifier=uniqueIdentifier;var f=new ResumableFile($,file,uniqueIdentifier);$.files.push(f),files.push(f),f.container=void 0!==event?event.srcElement:null,window.setTimeout((function(){$.fire("fileAdded",f,event)}),0)}(),decreaseReamining()}var uniqueIdentifier=$h.generateUniqueIdentifier(file,event);uniqueIdentifier&&"function"==typeof uniqueIdentifier.then?uniqueIdentifier.then((function(uniqueIdentifier){addFile(uniqueIdentifier)}),(function(){decreaseReamining()})):addFile(uniqueIdentifier)}))};function ResumableFile(resumableObj,file,uniqueIdentifier){var $=this;$.opts={},$.getOpt=resumableObj.getOpt,$._prevProgress=0,$.resumableObj=resumableObj,$.file=file,$.fileName=file.fileName||file.name,$.size=file.size,$.relativePath=file.relativePath||file.webkitRelativePath||$.fileName,$.uniqueIdentifier=uniqueIdentifier,$._pause=!1,$.container="",$.preprocessState=0;var _error=void 0!==uniqueIdentifier,chunkEvent=function(event,message){switch(event){case"progress":$.resumableObj.fire("fileProgress",$,message);break;case"error":$.abort(),_error=!0,$.chunks=[],$.resumableObj.fire("fileError",$,message);break;case"success":if(_error)return;$.resumableObj.fire("fileProgress",$,message),$.isComplete()&&$.resumableObj.fire("fileSuccess",$,message);break;case"retry":$.resumableObj.fire("fileRetry",$)}};return $.chunks=[],$.abort=function(){var abortCount=0;$h.each($.chunks,(function(c){"uploading"==c.status()&&(c.abort(),abortCount++)})),abortCount>0&&$.resumableObj.fire("fileProgress",$)},$.cancel=function(){var _chunks=$.chunks;$.chunks=[],$h.each(_chunks,(function(c){"uploading"==c.status()&&(c.abort(),$.resumableObj.uploadNextChunk())})),$.resumableObj.removeFile($),$.resumableObj.fire("fileProgress",$)},$.retry=function(){$.bootstrap();var firedRetry=!1;$.resumableObj.on("chunkingComplete",(function(){firedRetry||$.resumableObj.upload(),firedRetry=!0}))},$.bootstrap=function(){$.abort(),_error=!1,$.chunks=[],$._prevProgress=0;for(var round=$.getOpt("forceChunkSize")?Math.ceil:Math.floor,maxOffset=Math.max(round($.file.size/$.getOpt("chunkSize")),1),offset=0;offset<maxOffset;offset++)!function(offset){window.setTimeout((function(){$.chunks.push(new ResumableChunk($.resumableObj,$,offset,chunkEvent)),$.resumableObj.fire("chunkingProgress",$,offset/maxOffset)}),0)}(offset);window.setTimeout((function(){$.resumableObj.fire("chunkingComplete",$)}),0)},$.progress=function(){if(_error)return 1;var ret=0,error=!1;return $h.each($.chunks,(function(c){"error"==c.status()&&(error=!0),ret+=c.progress(!0)})),ret=error||ret>.99999?1:ret,ret=Math.max($._prevProgress,ret),$._prevProgress=ret,ret},$.isUploading=function(){var uploading=!1;return $h.each($.chunks,(function(chunk){if("uploading"==chunk.status())return uploading=!0,!1})),uploading},$.isComplete=function(){var outstanding=!1;return 1!==$.preprocessState&&($h.each($.chunks,(function(chunk){var status=chunk.status();if("pending"==status||"uploading"==status||1===chunk.preprocessState)return outstanding=!0,!1})),!outstanding)},$.pause=function(pause){$._pause=void 0===pause?!$._pause:pause},$.isPaused=function(){return $._pause},$.preprocessFinished=function(){$.preprocessState=2,$.upload()},$.upload=function(){var found=!1;if(!1===$.isPaused()){var preprocess=$.getOpt("preprocessFile");if("function"==typeof preprocess)switch($.preprocessState){case 0:return $.preprocessState=1,preprocess($),!0;case 1:return!0}$h.each($.chunks,(function(chunk){if("pending"==chunk.status()&&1!==chunk.preprocessState)return chunk.send(),found=!0,!1}))}return found},$.markChunksCompleted=function(chunkNumber){if($.chunks&&!($.chunks.length<=chunkNumber))for(var num=0;num<chunkNumber;num++)$.chunks[num].markComplete=!0},$.resumableObj.fire("chunkingStart",$),$.bootstrap(),this}function ResumableChunk(resumableObj,fileObj,offset,callback){var $=this;$.opts={},$.getOpt=resumableObj.getOpt,$.resumableObj=resumableObj,$.fileObj=fileObj,$.fileObjSize=fileObj.size,$.fileObjType=fileObj.file.type,$.offset=offset,$.callback=callback,$.lastProgressCallback=new Date,$.tested=!1,$.retries=0,$.pendingRetry=!1,$.preprocessState=0,$.markComplete=!1;var chunkSize=$.getOpt("chunkSize");return $.loaded=0,$.startByte=$.offset*chunkSize,$.endByte=Math.min($.fileObjSize,($.offset+1)*chunkSize),$.fileObjSize-$.endByte<chunkSize&&!$.getOpt("forceChunkSize")&&($.endByte=$.fileObjSize),$.xhr=null,$.test=function(){$.xhr=new XMLHttpRequest;var testHandler=function(e){$.tested=!0;var status=$.status();"success"==status?($.callback(status,$.message()),$.resumableObj.uploadNextChunk()):$.send()};$.xhr.addEventListener("load",testHandler,!1),$.xhr.addEventListener("error",testHandler,!1),$.xhr.addEventListener("timeout",testHandler,!1);var params=[],parameterNamespace=$.getOpt("parameterNamespace"),customQuery=$.getOpt("query");"function"==typeof customQuery&&(customQuery=customQuery($.fileObj,$)),$h.each(customQuery,(function(k,v){params.push([encodeURIComponent(parameterNamespace+k),encodeURIComponent(v)].join("="))})),params=params.concat([["chunkNumberParameterName",$.offset+1],["chunkSizeParameterName",$.getOpt("chunkSize")],["currentChunkSizeParameterName",$.endByte-$.startByte],["totalSizeParameterName",$.fileObjSize],["typeParameterName",$.fileObjType],["identifierParameterName",$.fileObj.uniqueIdentifier],["fileNameParameterName",$.fileObj.fileName],["relativePathParameterName",$.fileObj.relativePath],["totalChunksParameterName",$.fileObj.chunks.length]].filter((function(pair){return $.getOpt(pair[0])})).map((function(pair){return[parameterNamespace+$.getOpt(pair[0]),encodeURIComponent(pair[1])].join("=")}))),$.xhr.open($.getOpt("testMethod"),$h.getTarget("test",params)),$.xhr.timeout=$.getOpt("xhrTimeout"),$.xhr.withCredentials=$.getOpt("withCredentials");var customHeaders=$.getOpt("headers");"function"==typeof customHeaders&&(customHeaders=customHeaders($.fileObj,$)),$h.each(customHeaders,(function(k,v){$.xhr.setRequestHeader(k,v)})),$.xhr.send(null)},$.preprocessFinished=function(){$.preprocessState=2,$.send()},$.send=function(){var preprocess=$.getOpt("preprocess");if("function"==typeof preprocess)switch($.preprocessState){case 0:return $.preprocessState=1,void preprocess($);case 1:return}if(!$.getOpt("testChunks")||$.tested){$.xhr=new XMLHttpRequest,$.xhr.upload.addEventListener("progress",(function(e){new Date-$.lastProgressCallback>1e3*$.getOpt("throttleProgressCallbacks")&&($.callback("progress"),$.lastProgressCallback=new Date),$.loaded=e.loaded||0}),!1),$.loaded=0,$.pendingRetry=!1,$.callback("progress");var doneHandler=function(e){var status=$.status();if("success"==status||"error"==status)$.callback(status,$.message()),$.resumableObj.uploadNextChunk();else{$.callback("retry",$.message()),$.abort(),$.retries++;var retryInterval=$.getOpt("chunkRetryInterval");void 0!==retryInterval?($.pendingRetry=!0,setTimeout($.send,retryInterval)):$.send()}};$.xhr.addEventListener("load",doneHandler,!1),$.xhr.addEventListener("error",doneHandler,!1),$.xhr.addEventListener("timeout",doneHandler,!1);var query=[["chunkNumberParameterName",$.offset+1],["chunkSizeParameterName",$.getOpt("chunkSize")],["currentChunkSizeParameterName",$.endByte-$.startByte],["totalSizeParameterName",$.fileObjSize],["typeParameterName",$.fileObjType],["identifierParameterName",$.fileObj.uniqueIdentifier],["fileNameParameterName",$.fileObj.fileName],["relativePathParameterName",$.fileObj.relativePath],["totalChunksParameterName",$.fileObj.chunks.length]].filter((function(pair){return $.getOpt(pair[0])})).reduce((function(query,pair){return query[$.getOpt(pair[0])]=pair[1],query}),{}),customQuery=$.getOpt("query");"function"==typeof customQuery&&(customQuery=customQuery($.fileObj,$)),$h.each(customQuery,(function(k,v){query[k]=v}));var func=$.fileObj.file.slice?"slice":$.fileObj.file.mozSlice?"mozSlice":$.fileObj.file.webkitSlice?"webkitSlice":"slice",bytes=$.fileObj.file[func]($.startByte,$.endByte,$.getOpt("setChunkTypeFromFile")?$.fileObj.file.type:""),data=null,params=[],parameterNamespace=$.getOpt("parameterNamespace");if("octet"===$.getOpt("method"))data=bytes,$h.each(query,(function(k,v){params.push([encodeURIComponent(parameterNamespace+k),encodeURIComponent(v)].join("="))}));else if(data=new FormData,$h.each(query,(function(k,v){data.append(parameterNamespace+k,v),params.push([encodeURIComponent(parameterNamespace+k),encodeURIComponent(v)].join("="))})),"blob"==$.getOpt("chunkFormat"))data.append(parameterNamespace+$.getOpt("fileParameterName"),bytes,$.fileObj.fileName);else if("base64"==$.getOpt("chunkFormat")){var fr=new FileReader;fr.onload=function(e){data.append(parameterNamespace+$.getOpt("fileParameterName"),fr.result),$.xhr.send(data)},fr.readAsDataURL(bytes)}var target=$h.getTarget("upload",params),method=$.getOpt("uploadMethod");$.xhr.open(method,target),"octet"===$.getOpt("method")&&$.xhr.setRequestHeader("Content-Type","application/octet-stream"),$.xhr.timeout=$.getOpt("xhrTimeout"),$.xhr.withCredentials=$.getOpt("withCredentials");var customHeaders=$.getOpt("headers");"function"==typeof customHeaders&&(customHeaders=customHeaders($.fileObj,$)),$h.each(customHeaders,(function(k,v){$.xhr.setRequestHeader(k,v)})),"blob"==$.getOpt("chunkFormat")&&$.xhr.send(data)}else $.test()},$.abort=function(){$.xhr&&$.xhr.abort(),$.xhr=null},$.status=function(){return $.pendingRetry?"uploading":$.markComplete?"success":$.xhr?$.xhr.readyState<4?"uploading":200==$.xhr.status||201==$.xhr.status?"success":$h.contains($.getOpt("permanentErrors"),$.xhr.status)||$.retries>=$.getOpt("maxChunkRetries")?"error":($.abort(),"pending"):"pending"},$.message=function(){return $.xhr?$.xhr.responseText:""},$.progress=function(relative){void 0===relative&&(relative=!1);var factor=relative?($.endByte-$.startByte)/$.fileObjSize:1;if($.pendingRetry)return 0;switch($.xhr&&$.xhr.status||$.markComplete||(factor*=.95),$.status()){case"success":case"error":return 1*factor;case"pending":return 0*factor;default:return $.loaded/($.endByte-$.startByte)*factor}},this}return $.uploadNextChunk=function(){var found=!1;if($.getOpt("prioritizeFirstAndLastChunk")&&($h.each($.files,(function(file){return file.chunks.length&&"pending"==file.chunks[0].status()&&0===file.chunks[0].preprocessState?(file.chunks[0].send(),found=!0,!1):file.chunks.length>1&&"pending"==file.chunks[file.chunks.length-1].status()&&0===file.chunks[file.chunks.length-1].preprocessState?(file.chunks[file.chunks.length-1].send(),found=!0,!1):void 0})),found))return!0;if($h.each($.files,(function(file){if(found=file.upload())return!1})),found)return!0;var outstanding=!1;return $h.each($.files,(function(file){if(!file.isComplete())return outstanding=!0,!1})),outstanding||$.fire("complete"),!1},$.assignBrowse=function(domNodes,isDirectory){void 0===domNodes.length&&(domNodes=[domNodes]),$h.each(domNodes,(function(domNode){var input;"INPUT"===domNode.tagName&&"file"===domNode.type?input=domNode:((input=document.createElement("input")).setAttribute("type","file"),input.style.display="none",domNode.addEventListener("click",(function(){input.style.opacity=0,input.style.display="block",input.focus(),input.click(),input.style.display="none"}),!1),domNode.appendChild(input));var maxFiles=$.getOpt("maxFiles");void 0===maxFiles||1!=maxFiles?input.setAttribute("multiple","multiple"):input.removeAttribute("multiple"),isDirectory?input.setAttribute("webkitdirectory","webkitdirectory"):input.removeAttribute("webkitdirectory");var fileTypes=$.getOpt("fileType");void 0!==fileTypes&&fileTypes.length>=1?input.setAttribute("accept",fileTypes.map((function(e){return(e=e.replace(/\s/g,"").toLowerCase()).match(/^[^.][^/]+$/)&&(e="."+e),e})).join(",")):input.removeAttribute("accept"),input.addEventListener("change",(function(e){appendFilesFromFileList(e.target.files,e),$.getOpt("clearInput")&&(e.target.value="")}),!1)}))},$.assignDrop=function(domNodes){void 0===domNodes.length&&(domNodes=[domNodes]),$h.each(domNodes,(function(domNode){domNode.addEventListener("dragover",onDragOverEnter,!1),domNode.addEventListener("dragenter",onDragOverEnter,!1),domNode.addEventListener("dragleave",onDragLeave,!1),domNode.addEventListener("drop",onDrop,!1)}))},$.unAssignDrop=function(domNodes){void 0===domNodes.length&&(domNodes=[domNodes]),$h.each(domNodes,(function(domNode){domNode.removeEventListener("dragover",onDragOverEnter),domNode.removeEventListener("dragenter",onDragOverEnter),domNode.removeEventListener("dragleave",onDragLeave),domNode.removeEventListener("drop",onDrop)}))},$.isUploading=function(){var uploading=!1;return $h.each($.files,(function(file){if(file.isUploading())return uploading=!0,!1})),uploading},$.upload=function(){if(!$.isUploading()){$.fire("uploadStart");for(var num=1;num<=$.getOpt("simultaneousUploads");num++)$.uploadNextChunk()}},$.pause=function(){$h.each($.files,(function(file){file.abort()})),$.fire("pause")},$.cancel=function(){$.fire("beforeCancel");for(var i=$.files.length-1;i>=0;i--)$.files[i].cancel();$.fire("cancel")},$.progress=function(){var totalDone=0,totalSize=0;return $h.each($.files,(function(file){totalDone+=file.progress()*file.size,totalSize+=file.size})),totalSize>0?totalDone/totalSize:0},$.addFile=function(file,event){appendFilesFromFileList([file],event)},$.addFiles=function(files,event){appendFilesFromFileList(files,event)},$.removeFile=function(file){for(var i=$.files.length-1;i>=0;i--)$.files[i]===file&&$.files.splice(i,1)},$.getFromUniqueIdentifier=function(uniqueIdentifier){var ret=!1;return $h.each($.files,(function(f){f.uniqueIdentifier==uniqueIdentifier&&(ret=f)})),ret},$.getSize=function(){var totalSize=0;return $h.each($.files,(function(file){totalSize+=file.size})),totalSize},$.handleDropEvent=function(e){onDrop(e)},$.handleChangeEvent=function(e){appendFilesFromFileList(e.target.files,e),e.target.value=""},$.updateQuery=function(query){$.opts.query=query},this};"undefined"!=typeof module?(module.exports=Resumable,module.exports.Resumable=Resumable):"function"==typeof define&&define.amd?define((function(){return Resumable})):window.Resumable=Resumable}();
/**
 * EGroupware eTemplate2 - JS Number object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2011
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_inputWidget_1=require("./et2_core_inputWidget"),et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_file=function(_super){function et2_file(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_file._attributes,_child||{}))||this;_this.asyncOptions={},_this.input=null,_this.progress=null,_this.span=null,_this.node=null,_this.input=null,_this.progress=null,_this.span=null,_this.disabled_buttons=jQuery("input[type='submit'], button"),_this.options.value=jQuery.extend({},_this.options.value),_this.options.id||(console.warn("File widget needs an ID.  Used 'file_widget'."),_this.options.id="file_widget"),"[]"==_this.options.id.substr(-2)?_this.options.multiple=!0:"/"===_this.options.id.substr(-1)&&(_this.options.multiple=!0,_attrs.multiple=!0);_this.getInstanceManager();return _this.asyncOptions=jQuery.extend({},_this.getAsyncOptions(_this)),_this.asyncOptions.fieldName=_this.options.id,_this.createInputWidget(),_this.set_readonly(_this.options.readonly),_this}return __extends(et2_file,_super),et2_file.prototype.destroy=function(){_super.prototype.destroy.call(this),this.set_drop_target(null),this.node=null,this.input=null,this.span=null,this.progress=null},et2_file.prototype.createInputWidget=function(){this.node=jQuery(document.createElement("div")).addClass("et2_file"),this.span=jQuery(document.createElement("span")).addClass("et2_file_span et2_button").appendTo(this.node),""!=this.options.label&&this.span.addClass("et2_button_text");var span=this.span;this.input=jQuery(document.createElement("input")).attr("type","file").attr("placeholder",this.options.blur).addClass("et2_file_upload").appendTo(this.node).hover((function(){jQuery(span).toggleClass("et2_file_spanHover")})).on({mousedown:function(){jQuery(span).addClass("et2_file_spanActive")},mouseup:function(){jQuery(span).removeClass("et2_file_spanActive")}}),this.options.accept&&this.input.attr("accept",this.options.accept);var self=this;if(this.options.readonly||this.span.click((function(){self.input.click()})),"undefined"!=typeof File&&void 0!==(new XMLHttpRequest).upload&&(this.resumable=new Resumable(this.asyncOptions),this.resumable.assignBrowse(this.input),this.resumable.on("fileAdded",jQuery.proxy(this._fileAdded,this)),this.resumable.on("fileProgress",jQuery.proxy(this._fileProgress,this)),this.resumable.on("fileSuccess",jQuery.proxy(this.finishUpload,this)),this.resumable.on("complete",jQuery.proxy(this.onFinish,this))),this.options.progress){var widget=this.getRoot().getWidgetById(this.options.progress);widget&&(this.progress=jQuery(widget.getDOMNode()))}this.progress||(this.progress=jQuery(document.createElement("div")).appendTo(this.node)),this.progress.addClass("progress"),this.options.multiple&&this.input.attr("multiple","multiple"),this.setDOMNode(this.node[0]),this.options.drop_target||this.resumable.assignDrop([this.getDOMNode()])},et2_file.prototype.getAsyncOptions=function(self){return{onStart:function(event,file_count){return self.onStart(event,file_count)},onFinish:function(event,file_count){self.onFinish.apply(self,[event,file_count])},onStartOne:function(event,file_name,index,file_count){},onFinishOne:function(event,response,name,number,total){return self.finishUpload(event,response,name,number,total)},onProgress:function(event,progress,name,number,total){return self.onProgress(event,progress,name,number,total)},onError:function(event,name,error){return self.onError(event,name,error)},beforeSend:function(form){return self.beforeSend(form)},chunkSize:this.options.chunk_size||1048576,target:egw.ajaxUrl("EGroupware\\Api\\Etemplate\\Widget\\File::ajax_upload"),query:function(file){return self.beforeSend(file)},testChunks:!1}},et2_file.prototype.set_drop_target=function(new_target){if(this.options.drop_target){var widget_1=this.getRoot().getWidgetById(this.options.drop_target),drop_target_1=widget_1&&widget_1.getDOMNode()||document.getElementById(this.options.drop_target);drop_target_1&&this.resumable.unAssignDrop(drop_target_1)}if(this.options.drop_target=new_target,this.options.drop_target){var widget=this.getRoot().getWidgetById(this.options.drop_target),drop_target=widget&&widget.getDOMNode()||document.getElementById(this.options.drop_target);drop_target?this.resumable.assignDrop([drop_target]):this.egw().debug("warn","Did not find file drop target %s",this.options.drop_target)}},et2_file.prototype.attachToDOM=function(){var res=_super.prototype.attachToDOM.call(this);return this.input.unbind("change.et2_inputWidget"),res},et2_file.prototype.getValue=function(){return this.options.value?this.options.value:this.input.val()},et2_file.prototype.set_value=function(value,event){if(value&&void 0!==value||(value={}),jQuery.isEmptyObject(value))return this.options.value={},1==this.resumable.progress()&&this.progress.empty(),this.input.wrap("<form>").closest("form").get(0).reset(),void this.input.unwrap();var addFile=jQuery.proxy((function(i,file){this.resumable.addFile(file,event)}),this);if("object"==typeof value&&value.length&&"object"==typeof value[0]&&value[0].name)try{this.input[0].files=value,jQuery.each(value,addFile)}catch(e){jQuery.each(value,addFile)}},et2_file.prototype.set_label=function(value){null!=this.span&&null!=value&&this.span.text(value)},et2_file.prototype.getInputNode=function(){return void 0!==this.input&&this.input[0]},et2_file.prototype.set_mime=function(mime){mime||(this.options.mime=null),0!=mime.indexOf("/")?this.options.mime=mime.toLowerCase():this.options.mime=mime},et2_file.prototype.set_multiple=function(_multiple){return this.options.multiple=_multiple,_multiple?this.input.attr("multiple","multiple"):this.input.removeAttr("multiple")},et2_file.prototype.checkMime=function(f){if(!this.options.mime)return!0;var mime="";if(0!=this.options.mime.indexOf("/"))mime=this.options.mime.toLowerCase();else{var parts=this.options.mime.substr(1).match(/(.*)\/([igm]?)$/);mime=new RegExp(parts[1],parts.length>2?parts[2]:"")}if(!mime||!f.type)return!0;var is_preg="object"==typeof mime;return!!(!is_preg&&f.type.toLowerCase()==mime||is_preg&&mime.test(f.type))},et2_file.prototype._fileAdded=function(file,event){if(void 0===event&&(event={}),this.resumable.isUploading()||this.onStart(event,this.resumable.files.length))return this.checkMime(file.file)?void(this.createStatus(event,file)&&(this.disabled_buttons.not("[disabled]").attr("disabled",!0).addClass("et2_button_ro").removeClass("et2_clickable").css("cursor","default"),this.resumable.upload())):this.createStatus(this.egw().lang("File is of wrong type (%1 != %2)!",file.file.type,this.options.mime),file)},et2_file.prototype.beforeSend=function(form){return{request_id:this.getInstanceManager().etemplate_exec_id,widget_id:this.id}},et2_file.prototype.onStart=function(event,file_count){return this.hideMessage(),event.data=this,this.options.progress_dropdownlist&&this._build_progressDropDownList(),!this.options.onStart||et2_call(this.options.onStart,event,file_count)},et2_file.prototype.onFinish=function(){this.disabled_buttons.removeAttr("disabled").css("cursor","pointer").removeClass("et2_button_ro");for(var file_count=this.resumable.files.length;this.resumable.files.length>0;)this.resumable.removeFile(this.resumable.files[this.resumable.files.length-1]);var event=jQuery.Event("upload");event.data=this;this.options.progress_dropdownlist&&(this.progress.removeClass("progress_dropDown_fileList"),jQuery(this.node).find("span").removeClass("totalProgress_loader"),jQuery("body").off("click")),(this.options.onFinish&&!jQuery.isEmptyObject(this.getValue())?et2_call(this.options.onFinish,event,file_count):0==file_count||!jQuery.isEmptyObject(this.getValue()))&&this.change(this.input)},et2_file.prototype._build_progressDropDownList=function(){this.progress.addClass("progress_dropDown_fileList"),jQuery(this.node).find("span").addClass("totalProgress_loader"),jQuery(this.node).find("span.et2_file_span").hover((function(){jQuery(".progress_dropDown_fileList").show()})),jQuery("body").on("click",(function(event){"remove"!=event.target.className&&jQuery(".progress_dropDown_fileList").hide()}))},et2_file.prototype.createStatus=function(_event,file){var error="object"==typeof _event?"":_event;if(this.options.max_file_size&&file.size>this.options.max_file_size&&(error=this.egw().lang("File too large.  Maximum %1",et2_vfsSize.prototype.human_size(this.options.max_file_size))),this.options.progress){var widget=this.getRoot().getWidgetById(this.options.progress);widget&&(this.progress=jQuery(widget.getDOMNode()),this.progress.addClass("progress"))}if(this.progress){var fileName=file.fileName||"file",status=jQuery("<li data-file='"+fileName.replace(/'/g,"&quot")+"'>"+fileName+"<div class='remove'/><span class='progressBar'><p/></span></li>").appendTo(this.progress);jQuery("div.remove",status).on("click",file,jQuery.proxy(this.cancel,this)),""!=error&&(status.addClass("message ui-state-error"),status.append("<div>"+error+"</diff>"),jQuery(".progressBar",status).css("display","none"))}return""==error},et2_file.prototype._fileProgress=function(file){return this.progress&&jQuery("li[data-file='"+file.fileName.replace(/'/g,"&quot")+"'] > span.progressBar > p").css("width",Math.ceil(100*file.progress())+"%"),!0},et2_file.prototype.onError=function(event,name,error){console.warn(event,name,error)},et2_file.prototype.finishUpload=function(file,response){var name=file.fileName||"file";if("string"==typeof response&&(response=jQuery.parseJSON(response)),response.response[0]&&void 0===response.response[0].data.length)for(var key in"object"==typeof this.options.value&&this.options.multiple||this.set_value({}),response.response[0].data)"string"==typeof response.response[0].data[key]?jQuery("[data-file='"+name.replace(/'/g,"&quot")+"']",this.progress).addClass("error").css("display","block").text(response.response[0].data[key]):(this.options.value[key]=response.response[0].data[key],this.options.multiple||this.createStatus({},file),this.progress&&jQuery("[data-file='"+name.replace(/'/g,"&quot")+"']",this.progress).addClass("message success"));else this.progress&&jQuery("[data-file='"+name.replace(/'/g,"&quot")+"']",this.progress).addClass("ui-state-error").css("display","block").text(this.egw().lang("Server error"));var event=jQuery.Event("upload");return event.data=this,"function"==typeof this.onFinishOne&&this.onFinishOne(event,response,name),!0},et2_file.prototype.remove_file=function(file){for(var key in"string"==typeof file&&(file={fileName:file}),this.options.value)if(this.options.value[key].name==file.fileName)return delete this.options.value[key],void jQuery('[data-file="'+file.fileName.replace(/'/g,"&quot")+'"]',this.node).remove();file.isComplete&&!file.isComplete()&&file.cancel&&file.cancel()},et2_file.prototype.cancel=function(e){e.preventDefault();var target=jQuery(e.target).parents("li");this.remove_file(e.data),target.remove(),jQuery(e.target).remove()},et2_file.prototype.set_readonly=function(_ro){if(void 0!==_ro)if(this.options.readonly=_ro,this.span.toggleClass("et2_file_ro",_ro),this.options.readonly)this.span.unbind("click");else{var self=this;this.span.off().bind("click",(function(){self.input.click()}))}},et2_file._attributes={multiple:{name:"Multiple files",type:"boolean",default:!1,description:"Allow the user to select more than one file to upload at a time.  Subject to browser support."},max_file_size:{name:"Maximum file size",type:"integer",default:0,description:"Largest file accepted, in bytes.  Subject to server limitations.  8MB = 8388608"},mime:{name:"Allowed file types",type:"string",default:et2_no_init,description:"Mime type (eg: image/png) or regex (eg: /^text//i) for allowed file types"},blur:{name:"Placeholder",type:"string",default:"",description:"This text get displayed if an input-field is empty and does not have the input-focus (blur). It can be used to show a default value or a kind of help-text."},progress:{name:"Progress node",type:"string",default:et2_no_init,description:"The ID of an alternate node (div) to display progress and results.  The Node is fetched with et2 getWidgetById so you MUST use the id assigned in XET-File (it may not be available at creation time, so we (re)check on createStatus time)"},onStart:{name:"Start event handler",type:"any",default:et2_no_init,description:"A (js) function called when an upload starts.  Return true to continue with upload, false to cancel."},onFinish:{name:"Finish event handler",type:"any",default:et2_no_init,description:"A (js) function called when all files to be uploaded are finished."},drop_target:{name:"Optional, additional drop target for HTML5 uploads",type:"string",default:et2_no_init,description:"The ID of an additional drop target for HTML5 drag-n-drop file uploads"},label:{name:"Label of file upload",type:"string",default:"Choose file...",description:"String caption to be displayed on file upload span"},progress_dropdownlist:{name:"List on files in progress like dropdown",type:"boolean",default:!1,description:"Style list of files in uploading progress like dropdown list with a total upload progress indicator"},onFinishOne:{name:"Finish event handler for each one",type:"js",default:et2_no_init,description:"A (js) function called when a file to be uploaded is finished."},accept:{name:"Acceptable extensions",type:"string",default:"",description:"Define types of files that the server accepts. Multiple types can be seperated by comma and the default is to accept everything."},chunk_size:{name:"Chunk size",type:"integer",default:1048576,description:"Max chunk size, gets set from server-side PHP (max_upload_size-1M)/2"}},et2_file}(et2_core_inputWidget_1.et2_inputWidget);exports.et2_file=et2_file,et2_core_widget_1.et2_register_widget(et2_file,["file"]);
/**
 * EGroupware eTemplate2 - JS Progrss object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Ralf Becker
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_valueWidget_1=require("./et2_core_valueWidget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_progress=function(_super){function et2_progress(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_progress._attributes,_child||{}))||this;_this.progress=null;var outer=document.createElement("div");return outer.className="et2_progress",_this.progress=document.createElement("div"),_this.progress.style.width="0",outer.appendChild(_this.progress),_this.options.href&&(outer.className+=" et2_clickable"),_this.options.class&&(outer.className+=" "+_this.options.class),_this.setDOMNode(outer),_this}return __extends(et2_progress,_super),et2_progress.prototype.click=function(e){_super.prototype.click.call(this,e),this.options.href&&this.egw().open_link(this.options.href,this.options.extra_link_target,this.options.extra_link_popup)},et2_progress.prototype.set_value=function(_value){_value=parseInt(_value)+"%",this.progress.style.width=_value,this.options.label||this.set_label(_value)},et2_progress.prototype.set_label=function(_value){this.node.title=_value},et2_progress.prototype.set_class=function(_value){var baseClass="et2_progress";this.options.href&&(baseClass+=" et2_clickable"),this.node.setAttribute("class",baseClass+" "+_value)},et2_progress.prototype.set_href=function(_value){if(!this.isInTree())return!1;if(this.options.href=_value,_value){jQuery(this.node).addClass("et2_clickable").wrapAll('<a href="'+_value+'"></a>"');var href_1=this.options.href,popup_1=this.options.extra_link_popup,target_1=this.options.extra_link_target;jQuery(this.node).parent().click((function(e){return egw.open_link(href_1,target_1,popup_1),e.preventDefault(),!1}))}else jQuery(this.node).parent("a").length&&jQuery(this.node).removeClass("et2_clickable").unwrap();return!0},et2_progress.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value","label","href")},et2_progress.prototype.getDetachedNodes=function(){return[this.node,this.progress]},et2_progress.prototype.setDetachedAttributes=function(_nodes,_values){this.node=_nodes[0],this.progress=_nodes[1],_values.label&&this.set_label(_values.label),_values.value?this.set_value(_values.value):_values.label&&this.set_value(_values.label),_values.href&&(jQuery(this.node).addClass("et2_clickable"),this.set_href(_values.href))},et2_progress._attributes={href:{name:"Link Target",type:"string",description:"Link URL, empty if you don't wan't to display a link."},extra_link_target:{name:"Link target",type:"string",default:"_self",description:"Link target descriptor"},extra_link_popup:{name:"Popup",type:"string",description:"widthxheight, if popup should be used, eg. 640x480"},label:{name:"Label",default:"",type:"string",description:"The label is displayed as the title.  The label can contain variables, as descript for name. If the label starts with a '@' it is replaced by the value of the content-array at this index (with the '@'-removed and after expanding the variables).",translate:!0}},et2_progress.legacyOptions=["href","extra_link_target","imagemap","extra_link_popup","id"],et2_progress}(et2_core_valueWidget_1.et2_valueWidget);et2_core_widget_1.et2_register_widget(et2_progress,["progress"]);
/**
 * EGroupware eTemplate2 - JS Portlet object - used by Home
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package home
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_valueWidget_1=require("./et2_core_valueWidget"),et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_DOMWidget_1=require("./et2_core_DOMWidget");var et2_portlet=function(_super){function et2_portlet(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_portlet._attributes,_child||{}))||this;_this.GRID=55,_this.default_actions={edit_settings:{icon:"edit",caption:"Configure",default:!0,hideOnDisabled:!0,group:"portlet"},remove_portlet:{icon:"delete",caption:"Remove",group:"portlet"}};var self=_this;return _this.div=jQuery(document.createElement("div")).addClass(_this.options.class).addClass("ui-widget ui-widget-content ui-corner-all").addClass("et2_portlet").attr("data-sizex",_this.options.width).attr("data-sizey",_this.options.height).attr("data-row",_this.options.row).attr("data-col",_this.options.col).resizable({autoHide:!0,grid:_this.GRID,stop:function(event,ui){self.set_width(Math.round(ui.size.width/self.GRID)),self.set_height(Math.round(ui.size.height/self.GRID)),self.egw().jsonq("home.home_ui.ajax_set_properties",[self.id,{},{width:self.options.width,height:self.options.height}],null,self),self.iterateOver((function(widget){widget.resize()}),null,et2_IResizeable)}}),_this.header=jQuery(document.createElement("div")).attr("id",_this.getInstanceManager().uniqueId+"_"+_this.id.replace(/\./g,"-")+"_header").addClass("ui-widget-header ui-corner-all").appendTo(_this.div).html(_this.options.title),_this.content=jQuery(document.createElement("div")).attr("id",_this.getInstanceManager().uniqueId+"_"+_this.id.replace(/\./g,"-")+"_content").appendTo(_this.div),_this.setDOMNode(_this.div[0]),_this}return __extends(et2_portlet,_super),et2_portlet.prototype.destroy=function(){for(var i=0;i<this._children.length;i++)this._children[i].getInstanceManager()!=this.getInstanceManager()&&this._children[i].getInstanceManager().clear();_super.prototype.destroy.call(this)},et2_portlet.prototype.doLoadingFinished=function(){return this.set_color(this.options.color),!0},et2_portlet.prototype.getDOMNode=function(_sender){return void 0!==_sender&&_sender!=this?this.content[0]:_super.prototype.getDOMNode.call(this,_sender)},et2_portlet.prototype.set_actions=function(actions){var defaults={};for(var action_name in this.default_actions)defaults[action_name]=this.default_actions[action_name],defaults[action_name].caption=this.egw().lang(this.default_actions[action_name].caption),"function"==typeof this[action_name]&&(defaults[action_name].onExecute=jQuery.proxy(this[action_name],this));this.options.actions=jQuery.extend(!0,{},defaults,actions),_super.prototype.set_actions.call(this,this.options.actions)},et2_portlet.prototype._link_actions=function(actions){var objectManager=egw_getAppObjectManager(!0),widget_object=objectManager.getObjectById(this.id);null==widget_object&&(widget_object=objectManager.insertObject(!1,new egwActionObject(this.id,objectManager,new et2_core_DOMWidget_1.et2_action_object_impl(this).getAOI(),this._actionManager||objectManager.manager.getActionById(this.id)||objectManager.manager))),widget_object.clear();var action_links=[];for(var i in actions){var id=void 0!==actions[i].id?actions[i].id:i,action={actionId:id,enabled:!0};"edit_settings"!=id||this.options.settings&&!jQuery.isEmptyObject(this.options.settings)||(this.egw().debug("log","No settings for portlet %o, edit_settings action removed",this),action.enabled=!1),action_links.push(action)}widget_object.updateActionLinks(action_links)},et2_portlet.prototype.edit_settings=function(){et2_createWidget("dialog",{callback:jQuery.proxy(this._process_edit,this),template:this.options.edit_template,value:{content:this.options.settings},buttons:et2_dialog.BUTTONS_OK_CANCEL},this).set_title(this.egw().lang("Edit")+" "+(this.options.title||""))},et2_portlet.prototype._process_edit=function(button_id,value){if(button_id==et2_dialog.OK_BUTTON){this.div.addClass("loading");var settings="string"==typeof value?{}:this.options.settings||{};this.egw().jsonq("home.home_ui.ajax_set_properties",[this.id,settings,value,!!this.settings&&this.settings.group],(function(data){if(!data||void 0===data.attributes)return!1;for(var key in this.div.removeClass("loading"),this.set_value(data.content),data.attributes)"function"==typeof this["set_"+key]?this["set_"+key].call(this,data.attributes[key]):this.attributes[key]&&(this.options[key]=data.attributes[key]);if(void 0!==data.edit_settings&&data.edit_settings&&this.edit_settings(),data.attributes.width||data.attributes.height)try{this.iterateOver((function(widget){widget.resize()}),null,et2_IResizeable)}catch(e){egw.debug("warn",e,this)}}),this),"object"==typeof value&&jQuery.extend(this.options.settings,value)}},et2_portlet.prototype.remove_portlet=function(){var self=this;et2_dialog.show_dialog((function(button_id){button_id==et2_dialog.OK_BUTTON&&(self._process_edit(button_id,"~remove~"),self.getParent().removeChild(self),self.destroy())}),this.egw().lang("Remove"),this.options.title,{},et2_dialog.BUTTONS_OK_CANCEL,et2_dialog.QUESTION_MESSAGE)},et2_portlet.prototype.set_value=function(value){this.content.html(value)},et2_portlet.prototype.set_title=function(value){this.header.contents().filter((function(){return 3===this.nodeType})).remove(),this.options.title=value,this.header.append(value)},et2_portlet.prototype.set_color=function(color){this.options.color=color,this.header.css("backgroundColor",color),this.header.css("color",jQuery.Color(this.header.css("backgroundColor")).lightness()>.5?"black":"white"),this.content.css("backgroundColor",color)},et2_portlet.prototype.set_width=function(value){this.options.width=value,this.div.attr("data-sizex",value),this.div.css("width","")},et2_portlet.prototype.set_height=function(value){this.options.height=value,this.div.attr("data-sizey",value),this.div.css("height","")},et2_portlet._attributes={title:{name:"Title",description:"Goes in the little bit at the top with the icons",type:"string",default:""},edit_template:{name:"Edit template",description:"Custom eTemplate used to customize / set up the portlet",type:"string",default:egw.webserverUrl+"/home/templates/default/edit.xet"},color:{name:"Color",description:"Set the portlet color",type:"string",default:""},settings:{name:"Customization settings",description:"Array of customization settings, similar in structure to preference settings",type:"any",default:et2_no_init},actions:{default:{}},width:{default:2,ignore:!0},height:{default:1,type:"integer"},rows:{ignore:!0,default:et2_no_init},cols:{ignore:!0,default:et2_no_init},resize_ratio:{ignore:!0,default:et2_no_init},row:{name:"Row",description:"Home page location (row) - handled by home app",default:1},col:{name:"Column",description:"Home page location(column) - handled by home app",default:1}},et2_portlet}(et2_core_valueWidget_1.et2_valueWidget);et2_core_widget_1.et2_register_widget(et2_portlet,["portlet"]);
/**

 * EGroupware eTemplate2 - JS Ajax select / auto complete object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2012
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_inputWidget_1=require("./et2_core_inputWidget"),et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_valueWidget_1=require("./et2_core_valueWidget"),et2_widget_selectbox_1=require("./et2_widget_selectbox");var et2_ajaxSelect=function(_super){function et2_ajaxSelect(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_ajaxSelect._attributes,_child||{}))||this;return _this.input=null,"string"==typeof _attrs.get_rows&&(_attrs.get_rows=_this.egw().link("/index.php",{menuaction:_this.options.get_rows})),_this.createInputWidget(),_this.input=null,_this.createInputWidget(),_this}return __extends(et2_ajaxSelect,_super),et2_ajaxSelect.prototype.createInputWidget=function(){this.input=jQuery(document.createElement("input")),this.input.addClass("et2_textbox"),this.setDOMNode(this.input[0]);var widget=this;this.input.autocomplete({delay:100,source:this.options.get_rows?this.options.get_rows:et2_widget_selectbox_1.et2_selectbox.find_select_options(this,this.options.values),select:function(event,ui){return widget.value=ui.item[widget.options.id_field],widget.options.get_title?"function"==typeof widget.options.get_title?widget.input.val(widget.options.get_title.call(widget.value)):widget.options.get_title:widget.input.val(ui.item.label),!1}})},et2_ajaxSelect.prototype.getValue=function(){return this.options.blur&&this.input.val()==this.options.blur?"":this.value},et2_ajaxSelect.prototype.set_value=function(_value){if(this.value=_value,this.input.autocomplete("instance")){var source=this.input.autocomplete("option","source");if("object"==typeof source)for(var i in source)if(void 0!==source[i].value&&void 0!==source[i].label&&source[i].value===_value)this.input.val(source[i].label);else if("string"==typeof source[i]){this.input.val(source[_value]);break}}},et2_ajaxSelect.prototype.set_blur=function(_value){_value?(this.input.attr("placeholder",_value+""),this.input[0].placeholder||(""==this.input.val()&&this.input.val(this.options.blur),this.input.focus(this,(function(e){e.data.input.val()==e.data.options.blur&&e.data.input.val("")})).blur(this,(function(e){""==e.data.input.val()&&e.data.input.val(e.data.options.blur)})))):this.input.removeAttr("placeholder")},et2_ajaxSelect._attributes={get_rows:{name:"Data source",type:"any",default:"",description:"Function to get search results, either a javascript function or server-side."},get_title:{name:"Title function",type:"any",default:"",description:"Function to get title for selected entry.  Used when closed, and if no template is given."},id_field:{name:"Result ID field",type:"string",default:"value",description:"Which key in result sub-array to look for row ID.  If omitted, the key for the row will be used."},template:{name:"Row template",type:"string",default:"",description:"ID of the template to use to display rows.  If omitted, title will be shown for each result."},filter:{name:"Filter",type:"string",default:"",description:"Apply filter to search results.  Same as nextmatch."},filter2:{name:"Filter 2",type:"string",default:"",description:"Apply filter to search results.  Same as nextmatch."},link:{name:"Read only link",type:"boolean",default:"true",description:"If readonly, widget will be text.  If link is set, widget will be a link."},values:{name:"Values",type:"any",default:{},description:"Specify the available options.  Use this, or Data source."}},et2_ajaxSelect}(et2_core_inputWidget_1.et2_inputWidget);et2_core_widget_1.et2_register_widget(et2_ajaxSelect,["ajax_select"]);var et2_ajaxSelect_ro=function(_super){function et2_ajaxSelect_ro(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_ajaxSelect_ro._attributes,_child||{}))||this;return _this.value="",_this.span=jQuery(document.createElement("span")),_this.setDOMNode(_this.span[0]),_this}return __extends(et2_ajaxSelect_ro,_super),et2_ajaxSelect_ro.prototype.set_value=function(_value){this.value=_value,_value||(_value=""),this.span.text(_value)},et2_ajaxSelect_ro.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value")},et2_ajaxSelect_ro.prototype.getDetachedNodes=function(){return[this.span[0]]},et2_ajaxSelect_ro.prototype.setDetachedAttributes=function(_nodes,_values){this.span=jQuery(_nodes[0]),void 0!==_values.value&&this.set_value(_values.value)},et2_ajaxSelect_ro._attributes={multiline:{ignore:!0}},et2_ajaxSelect_ro}(et2_core_valueWidget_1.et2_valueWidget);et2_core_widget_1.et2_register_widget(et2_ajaxSelect_ro,["ajax_select_ro"]);
/**
 * EGroupware - VFS SELECT Widget UI
 *
 * @link http://www.egroupware.org
 * @package et2_vfsSelect
 * @author Hadi Nategh <hn@egroupware.org>
 * @copyright (c) 2013-2017 by Hadi Nategh <hn@egroupware.org>
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});var egw_app_1=require("../jsapi/egw_app");require("../jsapi/egw_global");et2_widget_dialog_1=require("./et2_widget_dialog");var et2_widget_file_1=require("./et2_widget_file"),et2_widget_checkbox_1=(et2_widget_textbox_1=require("./et2_widget_textbox"),require("./et2_widget_checkbox")),vfsSelectUI=function(_super){function vfsSelectUI(){var _this=_super.call(this,"vfsSelectUI")||this;return _this.egw.langRequireApp(_this.egw.window,"filemanager"),_this}return __extends(vfsSelectUI,_super),vfsSelectUI.prototype.destroy=function(_app){delete this.path_widget,delete this.vfsSelectWidget,_super.prototype.destroy.call(this,_app)},vfsSelectUI.prototype.et2_ready=function(et2,name){this.path_widget=this.et2.getWidgetById("path"),this.dirContent=this.et2.getArrayMgr("content").data.dir},vfsSelectUI.prototype.dirname=function(_path){var parts=_path.split("/");return parts.pop(),parts.join("/")||"/"},vfsSelectUI.prototype.basename=function(_path){return _path.split("/").pop()},vfsSelectUI.prototype.get_path=function(){return this.path_widget.get_value()},vfsSelectUI.prototype.storeFile=function(_event){var path=this.get_path();if(!jQuery.isEmptyObject(_event.data.getValue())){var widget=_event.data;egw(window).json("EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_vfsSelect_storeFile",[widget.getValue(),path],this._storeFile_callback,this,!0,this).sendRequest(!0),widget.set_value("")}},vfsSelectUI.prototype._storeFile_callback=function(_data){(_data.msg||_data.uploaded)&&egw(window).message(_data.msg);var that=this;for(var file in _data.uploaded)if(_data.uploaded[file].confirm&&!_data.uploaded[file].confirmed){var buttons=[{text:this.egw.lang("Yes"),id:"overwrite",class:"ui-priority-primary",default:!0,image:"check"},{text:this.egw.lang("Rename"),id:"rename",image:"edit"},{text:this.egw.lang("Cancel"),id:"cancel"}];"is_dir"===_data.uploaded[file].confirm&&buttons.shift(),et2_widget_dialog_1.et2_dialog.show_prompt((function(_button_id,_value){var uploaded={};switch(uploaded[this.my_data.file]=this.my_data.data,_button_id){case"overwrite":uploaded[this.my_data.file].confirmed=!0;case"rename":return uploaded[this.my_data.file].name=_value,delete uploaded[this.my_data.file].confirm,void egw.json("EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_vfsSelect_storeFile",[uploaded,this.my_data.path],that._storeFile_callback,that,!0,that).sendRequest();case"cancel":that.et2.iterateOver((function(_widget){_widget.remove_file(this.my_data.data.name)}),this,et2_widget_file_1.et2_file)}}),"is_dir"===_data.uploaded[file].confirm?this.egw.lang("There's already a directory with that name!"):this.egw.lang("Do you want to overwrite existing file %1 in directory %2?",_data.uploaded[file].name,_data.path),this.egw.lang("File %1 already exists",_data.uploaded[file].name),_data.uploaded[file].name,buttons,file).my_data={file:file,path:_data.path,data:_data.uploaded[file]}}else this.submit()},vfsSelectUI.prototype.createdir=function(action,selected){var self=this;et2_widget_dialog_1.et2_dialog.show_prompt((function(button,dir){if(button&&dir){var path_1=self.get_path();self.egw.json("EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_create_dir",[dir,path_1],(function(msg){self.egw.message(msg),self.change_dir(("/"==path_1?"":path_1)+"/"+dir)})).sendRequest(!1)}}),this.egw.lang("New directory"),this.egw.lang("Create directory"))},vfsSelectUI.prototype.change_dir=function(_dir){".."==_dir&&(_dir=this.dirname(this.get_path())),this.path_widget.set_value(_dir)},vfsSelectUI.prototype.select_clicked=function(event,widget){if(widget&&"object"==typeof widget.value)if(widget.value.is_dir){var path_2=null;widget.getRoot().iterateOver((function(widget){"path"==widget.id&&(path_2=widget)}),null,et2_widget_textbox_1.et2_textbox),path_2&&path_2.set_value(widget.value.path)}else if(this.et2&&"open-multiple"!=this.et2.getArrayMgr("content").getEntry("mode"))this.et2.setValueById("name",widget.value.name);else{var file_1=widget.value.name;widget.getParent().iterateOver((function(widget){widget.options.selected_value==file_1&&widget.set_value(widget.get_value()==file_1?widget.options.unselected_value:file_1)}),null,et2_widget_checkbox_1.et2_checkbox)}else;return event.preventDefault(),event.stopPropagation(),!1},vfsSelectUI.prototype.do_action=function(action,widget){if(action){var field="",value="";switch(action){case"path":field="path",value=widget.getValue();break;case"home":field="action",value="home";break;case"app":field="app",value=widget.getValue();break;case"mime":field="mime",value=widget.getValue()}this.submit(field,value)}},vfsSelectUI.prototype.submit=function(_field,_val,_callback){var arrMgrs=this.et2.getArrayMgrs();_field&&(arrMgrs.content.data[_field]=_val,jQuery.extend(arrMgrs.content.data,arrMgrs.modifications.data),this.et2.setArrayMgrs(arrMgrs)),arrMgrs&&this.et2.getWidgetById("name")&&(arrMgrs.content.data.name=this.et2.getWidgetById("name").get_value()),this.vfsSelectWidget._content(arrMgrs.content.data,_callback)},vfsSelectUI.prototype.search=function(_widget){var dir=this.et2.getWidgetById("dir"),query=_widget.get_value();if(""!=query){var self=this;dir.set_value({content:function(_query){var result={},reg=RegExp(_query,"ig"),key=0;for(var i in self.dirContent)void 0!==self.dirContent[i].name&&self.dirContent[i].name.match(reg)?(result[key]=self.dirContent[i],key++):void 0===self.dirContent[i].name&&isNaN(i)&&(result[i]=self.dirContent[i]);return result}(query)})}else dir.set_value({content:this.dirContent})},vfsSelectUI}(egw_app_1.EgwApp);exports.vfsSelectUI=vfsSelectUI,app.classes.vfsSelectUI=vfsSelectUI;
/**
 * EGroupware eTemplate2 - JS VFS widgets
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Nathan Gray
 * @copyright Nathan Gray 2012
 */
var _a;__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_valueWidget_1=require("./et2_core_valueWidget"),et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance"),et2_widget_textbox_1=require("./et2_widget_textbox");var et2_widget_description_1=require("./et2_widget_description"),et2_vfs=(et2_widget_selectAccount_1=require("./et2_widget_selectAccount"),et2_widget_file_1=require("./et2_widget_file"),et2_widget_dialog_1=require("./et2_widget_dialog"),et2_core_inputWidget_1=require("./et2_core_inputWidget"),function(_super){function et2_vfs(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_vfs._attributes,_child||{}))||this;return _this.span=null,_this.value="",_this.span=jQuery(document.createElement("ul")).addClass("et2_vfs"),_this.setDOMNode(_this.span[0]),_this}return __extends(et2_vfs,_super),et2_vfs.prototype.getValue=function(){return this.value},et2_vfs.prototype.set_value=function(_value){if("object"!=typeof _value)return _value&&this.egw().debug("warn","%s only has path, needs full array",this.id,_value),void this.span.empty().text(_value);this.span.empty(),this.value=_value;var path_offset,path_parts,text,path=_value.path?_value.path:"/",sub_path=path.substring(0,_value.path.length-_value.name.length-1);_value.path.indexOf(_value.name)>=0&&"/"===sub_path[sub_path.length-1]?(path_offset=(path=sub_path).split("/").length,path_parts=_value.path.split("/")):(_value.path.indexOf(_value.name)>=0&&(path=sub_path),path_offset=0,path_parts=_value.name.split("/"));for(var data,node,_loop_1=function(i){if(path+=("/"==path?"":"/")+path_parts[i],text=egw.decodePath(path_parts[i]),"apps"==path_parts[1])switch(path_parts.length){case 2:1==i&&(text=this_1.egw().lang("applications"));break;case 3:2==i&&(text=this_1.egw().lang(path_parts[2]));break;case 4:if(!isNaN(text)){var link_title=this_1.egw().link_title(path_parts[2],path_parts[3],(function(title){title&&this.value.name!=title&&jQuery("li",this.span).last().text(title)}),this_1);link_title&&void 0!==link_title&&(text=link_title)}}var self_1=this_1;data={path:path,type:i<path_parts.length-1?et2_vfs.DIR_MIME_TYPE:_value.mime},node=jQuery(document.createElement("li")).addClass("vfsFilename").text(text+(i<path_parts.length-1?"/":"")).addClass("et2_clickable et2_link").click({data:data,egw:this_1.egw()},(function(e){self_1.onclick?self_1.click(e)&&e.data.egw.open(e.data.data,"file"):e.data.egw.open(e.data.data,"file")})).appendTo(this_1.span)},this_1=this,i=path_offset;i<path_parts.length;i++)_loop_1(i);this._bind_default_action(node,data)},et2_vfs.prototype._bind_default_action=function(node,data){for(var links=[],widget=this,defaultAction=null,object=null,app=this.getInstanceManager().app;0===links.length&&widget.getParent();)(object=egw_getAppObjectManager(app).getObjectById(widget.id))&&object.manager&&object.manager.children&&(links=object.manager.children),widget=widget.getParent();for(var k in links)if(links[k].default&&links[k].enabled.exec(links[k])){defaultAction=links[k];break}defaultAction&&!this.onclick&&node.off("click").click({data:data,egw:this.egw()},function(e){return window.setTimeout((function(){egw_keyHandler(EGW_KEY_ENTER,!1,!1,!1)})),!0}.bind({data:data,object:object}))},et2_vfs.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value")},et2_vfs.prototype.getDetachedNodes=function(){return[this.span[0]]},et2_vfs.prototype.setDetachedAttributes=function(_nodes,_values){this.span=jQuery(_nodes[0]),void 0!==_values.value&&this.set_value(_values.value)},et2_vfs._attributes={value:{type:"any",description:"Array of (stat) information about the file"}},et2_vfs.DIR_MIME_TYPE="httpd/unix-directory",et2_vfs}(et2_core_valueWidget_1.et2_valueWidget));exports.et2_vfs=et2_vfs,et2_core_widget_1.et2_register_widget(et2_vfs,["vfs"]);var et2_vfsName=function(_super){function et2_vfsName(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_vfsName._attributes,_child||{}))||this;return _this.input.addClass("et2_vfs"),_this}return __extends(et2_vfsName,_super),et2_vfsName.prototype.set_value=function(_value){_value.path&&(_value=_value.path);try{_value=egw.decodePath(_value)}catch(e){_value="Error! "+_value}_super.prototype.set_value.call(this,_value)},et2_vfsName.prototype.getValue=function(){return egw.encodePath(_super.prototype.getValue.call(this)||"")},et2_vfsName}(et2_widget_textbox_1.et2_textbox);et2_core_widget_1.et2_register_widget(et2_vfsName,["vfs-name"]);var et2_vfsPath=function(_super){function et2_vfsPath(_parent,_attrs,_child){return _super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_vfsPath._attributes,_child||{}))||this}return __extends(et2_vfsPath,_super),et2_vfsPath.prototype.createInputWidget=function(){_super.prototype.createInputWidget.call(this),this.div=jQuery(document.createElement("div")).addClass("et2_vfsPath"),this.span=jQuery(document.createElement("ul")).appendTo(this.div),this.div.prepend(this.input),this.setDOMNode(this.div[0]),this.span.on("wheel",(function(e){var delta=e.originalEvent.deltaY>0?30:-30;this.scrollLeft=this.scrollLeft-delta})),this.span.on("mouseover",(function(e){this.scrollWidth>this.clientWidth?jQuery(this).addClass("scrollable"):jQuery(this).removeClass("scrollable")})),this.input.on("focus",function(){this.input.val(this.options.value),this.span.hide()}.bind(this)).on("focusout",function(){this.span.css("display","flex"),this.input.val("")}.bind(this))},et2_vfsPath.prototype.change=function(_node){return this.input.val()&&this.set_value(this.input.val()),_super.prototype.change.call(this,_node)},et2_vfsPath.prototype.set_value=function(_value){if(_value.path&&(_value=_value.path),_value!==this.options.value||this._oldValue===et2_no_init){var path_parts=_value.split("/");"/"===_value&&(path_parts=[""]);var path="/",text="";this.span&&this.span.empty().css("display","flex"),this.input.val("");for(var _loop_2=function(i){path+=("/"==path?"":"/")+path_parts[i],text=egw.decodePath(path_parts[i]);var image="/"==path?this_2.egw().image("navbar","api"):this_2.egw().image(text);if("apps"==path_parts[1])if(1===i)text=this_2.egw().lang("applications");else if(2===i)text=this_2.egw().lang(path_parts[2]),image=this_2.egw().image("navbar",path_parts[2].toLowerCase());else if(!isNaN(text)){var link_title=this_2.egw().link_title(path_parts[2],path_parts[3],(function(title){title&&jQuery("li",this.span).first().text(title)}),this_2);link_title&&void 0!==link_title&&(text=link_title)}var self_2=this_2,node=jQuery(document.createElement("li")).addClass("vfsPath et2_clickable").text(text).click({data:path,egw:this_2.egw()},(function(e){return self_2.set_value(e.data.data)})).prependTo(this_2.span);image&&!this_2.options.noicon&&node.prepend(this_2.egw().image_element(image)),jQuery(this_2.getDOMNode()).append(this_2.span)},this_2=this,i=0;i<path_parts.length;i++)_loop_2(i);this.isAttached()&&this.options.value!==_value&&(this._oldValue=this.options.value,this.options.value=_value,this.change())}},et2_vfsPath.prototype.getValue=function(){return this.options?this.options.value:null},et2_vfsPath._attributes={noicon:{type:"boolean",description:"suppress folder icons",default:!0}},et2_vfsPath}(et2_vfsName);exports.et2_vfsPath=et2_vfsPath,et2_core_widget_1.et2_register_widget(et2_vfsPath,["vfs-path"]);var et2_vfsName_ro=function(_super){function et2_vfsName_ro(_parent,_attrs,_child){return _super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_vfsName_ro._attributes,_child||{}))||this}return __extends(et2_vfsName_ro,_super),et2_vfsName_ro.prototype.set_value=function(_value){_value.path&&(_value=_value.path);try{_value=egw.decodePath(_value)}catch(e){_value="Error! "+_value}_super.prototype.set_value.call(this,_value)},et2_vfsName_ro.prototype.getValue=function(){return egw.encodePath(_super.prototype.getValue.call(this)||"")},et2_vfsName_ro}(et2_widget_textbox_1.et2_textbox_ro);et2_core_widget_1.et2_register_widget(et2_vfsName_ro,["vfs-name_ro"]);var et2_vfsMime=function(_super){function et2_vfsMime(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(et2_vfsMime,_super),et2_vfsMime}(expose(((_a=function(_super){function et2_vfsMime(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_vfsMime._attributes,_child||{}))||this;return _this.iconOverlayContainer=null,_this.image=null,_this.iconOverlayContainer=jQuery(document.createElement("span")).addClass("iconOverlayContainer"),_this.image=jQuery(document.createElement("img")),_this.image.addClass("et2_vfs vfsMimeIcon"),_this.iconOverlayContainer.append(_this.image),_this.setDOMNode(_this.iconOverlayContainer[0]),_this}return __extends(et2_vfsMime,_super),et2_vfsMime.prototype.expose_onslide=function(gallery,index,slide){var content=!1;return this.options.expose_callback&&"function"==typeof this.options.expose_callback&&(content=this.options.expose_callback.call(this,[gallery,index]))&&this.add(content),content},et2_vfsMime.prototype.getMedia=function(_value){var base_url=egw.webserverUrl.match(/^\/ig/)?egw(window).window.location.origin+egw.webserverUrl:egw.webserverUrl,mediaContent=[{title:_value.name,type:_value.mime,href:_value.download_url}];return!_value.download_url||"/"!=_value.download_url[0]&&"http"==_value.download_url.substr(0,4)||(mediaContent[0].href=base_url+_value.download_url,mediaContent[0].href&&mediaContent[0].href.match(/\/webdav.php/,"ig")&&(mediaContent[0].download_href=mediaContent[0].href+"?download")),_value&&_value.mime&&_value.mime.match(/video\//,"ig")?mediaContent[0].thumbnail=this.egw().mime_icon(_value.mime,_value.path,void 0,_value.mtime):mediaContent[0].thumbnail=_value.path&&_value.mime?this.egw().mime_icon(_value.mime,_value.path,void 0,_value.mtime):this.image.attr("src")+"&thheight=128",mediaContent},et2_vfsMime.prototype.set_value=function(_value){"object"!=typeof _value&&this.egw().debug("warn","%s only has path, needs array with path & mime",this.id,_value);var src=this.egw().mime_icon(_value.mime,_value.path,void 0,_value.mtime);if(src){if(src.indexOf("thumbnail.php")>-1){if(this.options.size)src+="&thsize="+this.options.size;else if(this.options.thumb_mime_size){var mime_size=this.options.thumb_mime_size.split(","),mime_regex=RegExp(_value.mime.split("/")[0]);void 0!==mime_size&&jQuery.isArray(mime_size)&&!isNaN(mime_size[mime_size.length-1])&&isNaN(mime_size[0])&&this.options.thumb_mime_size.match(mime_regex[0],"ig")&&(src+="&thsize="+mime_size[mime_size.length-1])}this.image.css("max-width","100%")}if(this.image.attr("src",src),_value.mime&&_value.mime.match(/application\/vnd\.oasis\.opendocument\.(text|presentation|spreadsheet|chart)/))(this.image.parent().parent().parent().length>0?this.image.parent().parent().parent():this.image.parent()).tooltip({items:"img",position:{my:"right top",at:"left top",collision:"flipfit"},content:function(){return'<img src="'+this.src+'&thsize=512"/>'}})}(_value.mode&et2_vfsMode.types.l)==et2_vfsMode.types.l?void 0===this.overlayContainer&&(this.overlayContainer=jQuery(document.createElement("span")).addClass("overlayContainer"),this.overlayContainer.append(jQuery(document.createElement("img")).addClass("overlay").attr("src",this.egw().image("link","etemplate"))),this.iconOverlayContainer.append(this.overlayContainer)):void 0!==this.overlayContainer&&(this.overlayContainer.remove(),delete this.overlayContainer)},et2_vfsMime.prototype.getDetachedAttributes=function(_attrs){_attrs.push("value","class")},et2_vfsMime.prototype.getDetachedNodes=function(){return[this.node,this.iconOverlayContainer[0],this.image[0]]},et2_vfsMime.prototype.setDetachedAttributes=function(_nodes,_values){this.iconOverlayContainer=jQuery(_nodes[1]),this.image=jQuery(_nodes[2]),this.node=_nodes[0],this.overlayContainer=_nodes[0].children[1],void 0!==_values.class&&this.image.addClass(_values.class),void 0!==_values.value&&this.set_value(_values.value)},et2_vfsMime}(et2_core_valueWidget_1.et2_valueWidget))._attributes={value:{type:"any",description:"Array of (stat) information about the file"},size:{name:"Icon size",type:"integer",description:"Size of icon / thumbnail, in pixels",default:et2_no_init},expose_callback:{name:"expose_callback",type:"js",default:et2_no_init,description:"JS code which is executed when expose slides."},expose_view:{name:"Expose view",type:"boolean",default:!0,description:"Clicking on an image would popup an expose view"},thumb_mime_size:{name:"Image thumbnail size",type:"string",default:"",description:" Size of thumbnail in pixel for specified mime type with syntax of: mime_type(s),size (eg. image,video,128)"}},_a.legacyOptions=["size"],_a)));et2_core_widget_1.et2_register_widget(et2_vfsMime,["vfs-mime"]);var et2_vfsSize=function(_super){function et2_vfsSize(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_vfsSize._attributes,_child||{}))||this;return _this.span.addClass("et2_vfs"),_this}return __extends(et2_vfsSize,_super),et2_vfsSize.prototype.human_size=function(size){"number"!=typeof size&&(size=parseInt(size)),size||(size=0);for(var i=0;size>=1024;)size/=1024,++i;return size.toFixed(0==i?0:1)+" "+["B","KB","MB","GB","TB","PB","EB","ZB","YB"][i]},et2_vfsSize.prototype.set_value=function(_value){_value.size&&(_value=_value.size),jQuery(this.node).text(this.human_size(_value))},et2_vfsSize.prototype.setDetachedAttributes=function(_nodes,_values){void 0!==_values.value&&(this.node=_nodes[0],this.set_value(_values.value),delete _values.value),_super.prototype.setDetachedAttributes.call(this,_nodes,_values)},et2_vfsSize._attributes={value:{type:"integer"}},et2_vfsSize}(et2_widget_description_1.et2_description);et2_core_widget_1.et2_register_widget(et2_vfsSize,["vfs-size"]);var et2_vfsMode=function(_super){function et2_vfsMode(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_vfsMode._attributes,_child||{}))||this;return _this.span.addClass("et2_vfs"),_this}return __extends(et2_vfsMode,_super),et2_vfsMode.prototype.text_mode=function(_value){var text=[];if("number"!=typeof _value&&(_value=parseInt(_value)),!_value)return"----------";var type="u";for(var flag in et2_vfsMode.types)if((_value&et2_vfsMode.types[flag])==et2_vfsMode.types[flag]){type=flag;break}for(var i=0;i<3;i++){for(var perm in et2_vfsMode.perms)_value&et2_vfsMode.perms[perm]?text.unshift(perm):text.unshift("-");_value>>=3}for(i=0;i<et2_vfsMode.sticky.length;i++)if(et2_vfsMode.sticky[i].mask&_value){var current=text[et2_vfsMode.sticky[i].position];text[et2_vfsMode.sticky[i].position]=et2_vfsMode.sticky[i].char,"x"==current&&text[et2_vfsMode.sticky[i].position].toLowerCase()}return type+text.join("")},et2_vfsMode.prototype.set_value=function(_value){_value.size&&(_value=_value.size);var text=this.text_mode(_value);jQuery(this.node).text(text)},et2_vfsMode.prototype.setDetachedAttributes=function(_nodes,_values){void 0!==_values.value&&(this.node=_nodes[0],this.set_value(_values.value),delete _values.value),_super.prototype.setDetachedAttributes.call(this,_nodes,_values)},et2_vfsMode.types={l:40960,s:49152,p:4096,c:8192,d:16384,b:24576,"-":32768},et2_vfsMode.sticky=[{mask:512,char:"T",position:9},{mask:1024,char:"S",position:6},{mask:2048,char:"S",position:3}],et2_vfsMode.perms={x:1,w:2,r:4},et2_vfsMode}(et2_widget_description_1.et2_description);et2_core_widget_1.et2_register_widget(et2_vfsMode,["vfs-mode"]);var et2_vfsUid=function(_super){function et2_vfsUid(){return null!==_super&&_super.apply(this,arguments)||this}return __extends(et2_vfsUid,_super),et2_vfsUid.prototype.set_title=function(_node,_value){""==_value&&(arguments[1]="root"),_super.prototype.set_title.call(this,_node,_value)},et2_vfsUid}(et2_widget_selectAccount_1.et2_selectAccount_ro);et2_core_widget_1.et2_register_widget(et2_vfsUid,["vfs-uid","vfs-gid"]);var et2_vfsUpload=function(_super){function et2_vfsUpload(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_vfsUpload._attributes,_child||{}))||this;return _this.list=null,jQuery(_this.node).addClass("et2_vfs"),_this.options.path||(_this.options.path=_this.options.id),"/"==_this.options.path.substr(-1)&&_this.set_multiple(!0),_this.list=jQuery(document.createElement("table")).appendTo(_this.node),_this}return __extends(et2_vfsUpload,_super),et2_vfsUpload.prototype.getAsyncOptions=function(self){return jQuery.extend({},_super.prototype.getAsyncOptions.call(this,self),{target:egw.ajaxUrl("EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_upload")})},et2_vfsUpload.prototype.set_value=function(_value){for(;this._children.length>0;){var node=this._children[this._children.length-1];this.removeChild(node),node.destroy()}if(this.progress.empty(),this.list.empty(),"object"==typeof _value&&_value&&Object.keys(_value).length)for(var i in _value)this._addFile(_value[i]);return!0},et2_vfsUpload.prototype.getDOMNode=function(sender){if(sender&&sender!==this&&sender._type.indexOf("vfs")>=0){var value=sender.getValue&&sender.getValue()||sender.options.value||{},row=jQuery("[data-path='"+value.path.replace(/'/g,"&quot")+"']",this.list);return"vfs-mime"===sender._type?jQuery(".icon",row).get(0)||null:jQuery(".title",row).get(0)||null}return _super.prototype.getDOMNode.call(this,sender)},et2_vfsUpload.prototype.beforeSend=function(form){var extra=_super.prototype.beforeSend.call(this,form);return extra.path=this.options.path,extra},et2_vfsUpload.prototype.finishUpload=function(file,response){var result=_super.prototype.finishUpload.call(this,file,response);if("string"==typeof response&&(response=jQuery.parseJSON(response)),response.response[0]&&void 0===response.response[0].data.length)for(var key in response.response[0].data){var value=response.response[0].data[key];value&&value.path&&(this._addFile(value),jQuery("[data-file='"+file.fileName.replace(/'/g,"&quot")+"']",this.progress).hide())}return result},et2_vfsUpload.prototype._addFile=function(file_data){if(jQuery("[data-path='"+file_data.path.replace(/'/g,"&quot")+"']").remove().length)for(var child_index=this._children.length-1;child_index>=0;child_index--){var child=this._children[child_index];child.options.value.path===file_data.path&&(this.removeChild(child),child.destroy())}file_data&&void 0===file_data.download_url&&(file_data.download_url="/webdav.php"+file_data.path);var row=jQuery(document.createElement("tr")).attr("data-path",file_data.path.replace(/'/g,"&quot")).attr("draggable","true").appendTo(this.list);jQuery(document.createElement("td")).addClass("icon").appendTo(row),jQuery(document.createElement("td")).addClass("title").appendTo(row);var mime=et2_core_widget_1.et2_createWidget("vfs-mime",{value:file_data},this),vfs_attrs={value:file_data,onclick:void 0};if(file_data&&void 0!==file_data.download_url){var fe_mime=egw_get_file_editor_prefered_mimes(file_data.mime);"string"==typeof file_data.mime&&(file_data.mime.match(mime.mime_regexp,"ig")||fe_mime&&fe_mime.mime[file_data.mime])&&(vfs_attrs.onclick=function(ev){return ev.stopPropagation(),jQuery("img",this.parentNode.parentNode).trigger("click"),!1})}var vfs=et2_core_widget_1.et2_createWidget("vfs",vfs_attrs,this);if(this.isAttached()&&(mime.set_value(file_data),vfs.set_value(file_data),mime.doLoadingFinished(),vfs.doLoadingFinished()),!this.options.readonly){var self_3=this,delete_button=jQuery(document.createElement("td")).appendTo(row);jQuery("<div />").appendTo(delete_button).addClass("delete icon").bind("click",(function(){et2_core_widget_1.et2_createWidget("dialog",{callback:function(button){button==et2_widget_dialog_1.et2_dialog.YES_BUTTON&&egw.json("filemanager_ui::ajax_action",["delete",[row.attr("data-path").replace(/&quot/g,"'")],""],(function(data){data&&0==data.errs&&row.slideUp(null,row.remove),data&&data.msg&&self_3.egw().message(data.msg,0==data.errs?"success":"error")})).sendRequest()},message:self_3.egw().lang("Delete file")+"?",title:self_3.egw().lang("Confirmation required"),buttons:et2_widget_dialog_1.et2_dialog.BUTTONS_YES_NO,dialog_type:et2_widget_dialog_1.et2_dialog.QUESTION_MESSAGE,width:250},self_3)}))}},et2_vfsUpload._attributes={value:{type:"any"},path:{name:"Path",description:"Upload files to the specified VFS path",type:"string",default:""}},et2_vfsUpload.legacyOptions=["mime"],et2_vfsUpload}(et2_widget_file_1.et2_file);et2_core_widget_1.et2_register_widget(et2_vfsUpload,["vfs-upload"]);var et2_vfsSelect=function(_super){function et2_vfsSelect(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_vfsSelect._attributes,_child||{}))||this;return _this.modes=["open","open-multiple","saveas","select-dir"],_this.supportedWidgetClasses=[],_this.button=jQuery(document.createElement("button")).attr("title",_this.egw().lang("Select file(s) from VFS")).addClass("et2_button et2_vfs_btn").css("background-image","url("+_this.egw().image("filemanager/navbar")+")"),_this.options.readonly&&_this.button.hide(),""!=_this.options.button_caption&&_this.button.text(_this.options.button_caption),_this.setDOMNode(_this.button[0]),_this}return __extends(et2_vfsSelect,_super),et2_vfsSelect.prototype._content=function(_content,_callback){egw(window).loading_prompt("vfs-select",!0,"","body");var self=this;void 0!==app.vfsSelectUI&&(this.dialog&&this.dialog.div&&this.dialog.div.dialog("close"),delete app.vfsSelectUI);var attrs={mode:this.options.mode,label:this.options.button_label,path:this.options.path||null,mime:this.options.mime||null,name:this.options.name,method:this.options.method,recentPaths:et2_vfsSelect._getRecentPaths()},callback=_callback||this._buildDialog;egw(window).json("EGroupware\\Api\\Etemplate\\Widget\\Vfs::ajax_vfsSelect_content",[_content,attrs],(function(_content){egw(window).loading_prompt("vfs-select",!1),callback.apply(self,arguments)})).sendRequest(!0)},et2_vfsSelect.prototype._buildDialog=function(_data){if(_data.content.mode.match(/open|open-multiple|saveas|select-dir/)){var self=this,buttons=[{text:egw.lang(_data.content.label),id:"submit",image:_data.content.mode.match(/saveas|select-dir/)?"save":this.options.button_icon}],extra_buttons_action={};if(this.options.extra_buttons&&this.options.method)for(var i=0;i<this.options.extra_buttons.length;i++)delete this.options.extra_buttons[i].click,buttons.push(this.options.extra_buttons[i]),extra_buttons_action[this.options.extra_buttons[i].id]=this.options.extra_buttons[i].id;buttons.push({text:egw.lang("Close"),id:"close",image:"cancel"});var et2,etemplate=jQuery("form").data("etemplate");et2=etemplate&&etemplate.name&&!app[egw(window).app_name()]?etemplate2.getByTemplate(etemplate.name)[0]:etemplate2.getByApplication(egw(window).app_name())[0];var data=jQuery.extend(_data,{currentapp:egw(window).app_name(),etemplate_exec_id:et2.etemplate_exec_id});app.vfsSelectUI=new app.classes.vfsSelectUI,this.submit_callback=function(submit_button_id,submit_value,savemode){if(("submit"==submit_button_id||extra_buttons_action&&extra_buttons_action[submit_button_id])&&submit_value){var files=[];switch(_data.content.mode){case"open-multiple":if(submit_value.dir&&submit_value.dir.selected)for(var key in Object.keys(submit_value.dir.selected))""!=submit_value.dir.selected[key]&&files.push(submit_value.path+"/"+submit_value.dir.selected[key]);break;case"select-dir":files=submit_value.path;break;default:if("download"===self.options.method&&(submit_value.path=_data.content.download_baseUrl),files=submit_value.path+"/"+submit_value.name,"saveas"===self.options.mode&&!savemode)for(var p in _data.content.dir)if(_data.content.dir[p].name==submit_value.name){var saveModeDialogButtons=[{text:self.egw().lang("Yes"),id:"overwrite",class:"ui-priority-primary",default:!0,image:"check"},{text:self.egw().lang("Rename"),id:"rename",image:"edit"},{text:self.egw().lang("Cancel"),id:"cancel"}];return et2_widget_dialog_1.et2_dialog.show_prompt((function(_button_id,_value){switch(_button_id){case"overwrite":return self.submit_callback(submit_button_id,submit_value,"overwrite");case"rename":return submit_value.name=_value,self.submit_callback(submit_button_id,submit_value,"rename")}}),self.egw().lang("Do you want to overwrite existing file %1 in directory %2?",submit_value.name,submit_value.path),self.egw().lang("File %1 already exists",submit_value.name),submit_value.name,saveModeDialogButtons,null)}}return et2_vfsSelect._setRecentPaths(submit_value.path),self.value=files,self.options.method&&"download"!==self.options.method?egw(window).request(self.options.method,[self.options.method_id,files,submit_button_id,savemode]).then((function(data){jQuery(self.node).change()})):jQuery(self.node).change(),delete app.vfsSelectUI,!0}},this.dialog=et2_core_widget_1.et2_createWidget("dialog",{callback:this.submit_callback,title:this.options.dialog_title,buttons:buttons,minWidth:500,minHeight:400,width:400,value:data,template:egw.webserverUrl+"/api/templates/default/vfsSelectUI.xet?1",resizable:!1},et2_widget_dialog_1.et2_dialog._create_parent("api")),this.dialog.template.uniqueId="api.vfsSelectUI",app.vfsSelectUI.et2=this.dialog.template.widgetContainer,app.vfsSelectUI.vfsSelectWidget=this,this.dialog.div.parent().css({"z-index":1e5}),this.dialog.div.on("load",(function(e){app.vfsSelectUI.et2_ready(app.vfsSelectUI.et2,"api.vfsSelectUI")})),this.dialog.template.etemplate_exec_id=et2.etemplate_exec_id}else egw.debug("warn","Mode is not matched!")},et2_vfsSelect._setRecentPaths=function(_path){var recentPaths=egw.getSessionItem("api","vfsRecentPaths")?egw.getSessionItem("api","vfsRecentPaths").split(","):[];-1==recentPaths.indexOf(_path)&&recentPaths.push(_path),egw.setSessionItem("api","vfsRecentPaths",recentPaths)},et2_vfsSelect._getRecentPaths=function(){return egw.getSessionItem("api","vfsRecentPaths")?egw.getSessionItem("api","vfsRecentPaths").split(","):[]},et2_vfsSelect.prototype.click=function(e){this._content.call(this,null)},et2_vfsSelect.prototype.set_mode=function(mode){jQuery.inArray(mode,this.modes)<0?this.egw().debug("warn","Invalid mode for '%s': %s Valid options:",this.id,mode,this.modes):this.options.mode=mode},et2_vfsSelect.prototype.set_button_label=function(label){this.options.button_label=label},et2_vfsSelect.prototype.set_button_caption=function(caption){this.options.button_caption=caption},et2_vfsSelect.prototype.set_method_id=function(id){this.options.method_id=id},et2_vfsSelect.prototype.set_readonly=function(readonly){this.options.readonly=Boolean(readonly),this.options.readonly?this.button.hide():this.button.show()},et2_vfsSelect.prototype.set_value=function(value){this.value=value},et2_vfsSelect.prototype.getValue=function(){return this.value},et2_vfsSelect._attributes={mode:{name:"Dialog mode",type:"string",description:"One of {open|open-multiple|saveas|select-dir}",default:"open-multiple"},method:{name:"Server side callback",type:"string",description:"Server side callback to process selected value(s) in \n\t\tapp.class.method or class::method format.  The first parameter will \n\t\tbe Method ID, the second the file list. 'download' is reserved and it \n\t\tmeans it should use download_baseUrl instead of path in value (no method\n\t\t will be actually executed)."},method_id:{name:"Method ID",type:"any",description:"optional parameter passed to server side callback.\n\t\tCan be a string or a function.",default:""},path:{name:"Path",type:"string",description:"Start path in VFS.  Leave unset to use the last used path."},mime:{name:"Mime type",type:"any",description:"Limit display to the given mime-type"},button_label:{name:"Button label",description:"Set the label on the dialog's OK button.",default:"open"},value:{type:"any",description:"Array of paths (strings)"},button_caption:{name:"button caption",type:"string",default:"Select files from Filemanager ...",description:"Caption for vfs-select button.",translate:!0},button_icon:{name:"button icon",type:"string",default:"check",description:"Custom icon to show on submit button."},name:{name:"File name",type:"any",description:"file name",default:""},dialog_title:{name:"dialog title",type:"string",default:"Save as",description:"Title of dialog",translate:!0},extra_buttons:{name:"extra action buttons",type:"any",description:"Extra buttons passed to dialog. It's co-related to method."}},et2_vfsSelect}(et2_core_inputWidget_1.et2_inputWidget);exports.et2_vfsSelect=et2_vfsSelect,et2_core_widget_1.et2_register_widget(et2_vfsSelect,["vfs-select"]);
/**
 * EGroupware eTemplate2 - JS Description object
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Hadi Nategh <hn[at]stylite.de>
 * @copyright Stylite AG
 * @version $Id$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_baseWidget_1=require("./et2_core_baseWidget"),et2_core_inheritance_1=require("./et2_core_inheritance"),et2_core_widget_1=require("./et2_core_widget");var et2_video=function(_super){function et2_video(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_video._attributes,_child||{}))||this;return _this.video=null,_this.video=jQuery(document.createElement("video")),_this.options.controls&&_this.video.attr("controls",1),_this.options.autoplay&&_this.video.attr("autoplay",1),_this.options.muted&&_this.video.attr("muted",1),_this.options.video_src&&_this.set_src(_this.options.video_src),_this.options.loop&&_this.video.attr("loop",1),_this.setDOMNode(_this.video[0]),_this}return __extends(et2_video,_super),et2_video.prototype.set_src=function(_value){if(_value){var source=jQuery(document.createElement("source")).attr("src",_value).appendTo(this.video);this.options.src_type&&source.attr("type",this.options.src_type)}},et2_video.prototype.set_autoplay=function(_value){_value&&this.video.attr("autoplay",_value)},et2_video.prototype.set_controls=function(_value){_value&&this.video.attr("controls",_value)},et2_video.prototype.set_poster=function(_url){_url&&("/"===_url[0]||_url.match(/^https?:\/\//)||(_url=this.egw().image(_url)),this.video.attr("poster",_url))},et2_video.prototype.seek_video=function(_vtime){this.video[0].currentTime=_vtime},et2_video.prototype.play_video=function(){return this.video[0].play()},et2_video.prototype.pause_video=function(){this.video[0].pause()},et2_video.prototype.currentTime=function(){return this.video[0].currentTime},et2_video._attributes={video_src:{name:"Video",type:"string",description:"Source of video to display"},src_type:{name:"Source type",type:"string",description:"Defines the type the stream source provided"},muted:{name:"Audio control",type:"boolean",default:!1,description:"Defines that the audio output of the video should be muted"},autoplay:{name:"Autoply",type:"boolean",default:!1,description:"Defines if Video will start playing as soon as it is ready"},controls:{name:"Control buttons",type:"boolean",default:!1,description:"Defines if Video controls, play/pause buttons should be displayed"},poster:{name:"Video Poster",type:"string",default:"",description:"Specifies an image to be shown while video is loading or before user play it"},loop:{name:"Video loop",type:"boolean",default:!1,description:"Defines if the video should be played repeatedly"}},et2_video}(et2_core_baseWidget_1.et2_baseWidget);exports.et2_video=et2_video,et2_core_widget_1.et2_register_widget(et2_video,["video"]),
/*!
 *  BarCode Coder Library (BCC Library)
 *  BCCL Version 2.0
 *    
 *  Porting : jQuery barcode plugin 
 *  Version : 2.0.3
 *   
 *  Date    : 2013-01-06
 *  Author  : DEMONTE Jean-Baptiste <jbdemonte@gmail.com>
 *            HOUREZ Jonathan
 *             
 *  Web site: http://barcode-coder.com/
 *  dual licence :  http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
 *                  http://www.gnu.org/licenses/gpl.html
 */
function(b){var a={settings:{barWidth:1,barHeight:50,moduleSize:5,showHRI:!0,addQuietZone:!0,marginHRI:5,bgColor:"#FFFFFF",color:"#000000",fontSize:10,output:"css",posX:0,posY:0},intval:function(d){var c=typeof d;return"string"==c?(d=d.replace(/[^0-9-.]/g,""),d=parseInt(1*d,10),isNaN(d)||!isFinite(d)?0:d):"number"==c&&isFinite(d)?Math.floor(d):0},i25:{encoding:["NNWWN","WNNNW","NWNNW","WWNNN","NNWNW","WNWNN","NWWNN","NNNWW","WNNWN","NWNWN"],compute:function(g,j,f){if(j){"int25"==f&&g.length%2==0&&(g="0"+g);for(var c,h=!0,e=0,d=g.length-1;d>-1;d--){if(c=a.intval(g.charAt(d)),isNaN(c))return"";e+=h?3*c:c,h=!h}g+=((10-e%10)%10).toString()}else g.length%2!=0&&(g="0"+g);return g},getDigit:function(k,l,h){if(""==(k=this.compute(k,l,h)))return"";var f,d;if(result="","int25"==h){var g,e;for(result+="1010",f=0;f<k.length/2;f++)for(g=k.charAt(2*f),e=k.charAt(2*f+1),d=0;d<5;d++)result+="1","W"==this.encoding[g].charAt(d)&&(result+="1"),result+="0","W"==this.encoding[e].charAt(d)&&(result+="0");result+="1101"}else if("std25"==h){var m;for(result+="11011010",f=0;f<k.length;f++)for(m=k.charAt(f),d=0;d<5;d++)result+="1","W"==this.encoding[m].charAt(d)&&(result+="11"),result+="0";result+="11010110"}return result}},ean:{encoding:[["0001101","0100111","1110010"],["0011001","0110011","1100110"],["0010011","0011011","1101100"],["0111101","0100001","1000010"],["0100011","0011101","1011100"],["0110001","0111001","1001110"],["0101111","0000101","1010000"],["0111011","0010001","1000100"],["0110111","0001001","1001000"],["0001011","0010111","1110100"]],first:["000000","001011","001101","001110","010011","011001","011100","010101","010110","011010"],getDigit:function(j,h){var k,e="ean8"==h?7:12;if((j=j.substring(0,e)).length!=e)return"";for(var g=0;g<j.length;g++)if((k=j.charAt(g))<"0"||k>"9")return"";j=this.compute(j,h);var d="101";if("ean8"==h){for(g=0;g<4;g++)d+=this.encoding[a.intval(j.charAt(g))][0];d+="01010";for(g=4;g<8;g++)d+=this.encoding[a.intval(j.charAt(g))][2]}else{var f=this.first[a.intval(j.charAt(0))];for(g=1;g<7;g++)d+=this.encoding[a.intval(j.charAt(g))][a.intval(f.charAt(g-1))];d+="01010";for(g=7;g<13;g++)d+=this.encoding[a.intval(j.charAt(g))][2]}return d+="101"},compute:function(f,e){var c="ean13"==e?12:7;f=f.substring(0,c);var d=0,g=!0;for(i=f.length-1;i>-1;i--)d+=(g?3:1)*a.intval(f.charAt(i)),g=!g;return f+((10-d%10)%10).toString()}},upc:{getDigit:function(c){return c.length<12&&(c="0"+c),a.ean.getDigit(c,"ean13")},compute:function(c){return c.length<12&&(c="0"+c),a.ean.compute(c,"ean13").substr(1)}},msi:{encoding:["100100100100","100100100110","100100110100","100100110110","100110100100","100110100110","100110110100","100110110110","110100100100","110100100110"],compute:function(c,d){return"object"==typeof d?("mod10"==d.crc1?c=this.computeMod10(c):"mod11"==d.crc1&&(c=this.computeMod11(c)),"mod10"==d.crc2?c=this.computeMod10(c):"mod11"==d.crc2&&(c=this.computeMod11(c))):"boolean"==typeof d&&d&&(c=this.computeMod10(c)),c},computeMod10:function(h){var e,c=h.length%2,g=0,f=0;for(e=0;e<h.length;e++)c?g=10*g+a.intval(h.charAt(e)):f+=a.intval(h.charAt(e)),c=!c;var d=(2*g).toString();for(e=0;e<d.length;e++)f+=a.intval(d.charAt(e));return h+((10-f%10)%10).toString()},computeMod11:function(e){for(var d=0,f=2,c=e.length-1;c>=0;c--)d+=f*a.intval(e.charAt(c)),f=7==f?2:f+1;return e+((11-d%11)%11).toString()},getDigit:function(f,g){var d=0,c="";for(f=this.compute(f,!1),c="110",i=0;i<f.length;i++){if((d="0123456789".indexOf(f.charAt(i)))<0)return"";c+=this.encoding[d]}return c+="1001"}},code11:{encoding:["101011","1101011","1001011","1100101","1011011","1101101","1001101","1010011","1101001","110101","101101"],getDigit:function(e){var j,m,p="0123456789-",q="",f="0";for(q="10110010",j=0;j<e.length;j++){if((m=p.indexOf(e.charAt(j)))<0)return"";q+=this.encoding[m]+f}var o=0,h=0,l=1,d=0;for(j=e.length-1;j>=0;j--)l=10==l?1:l+1,h+=(o=10==o?1:o+1)*(m=p.indexOf(e.charAt(j))),d+=l*m;var n=h%11,g=(d+=n)%11;return q+=this.encoding[n]+f,e.length>=10&&(q+=this.encoding[g]+f),q+="1011001"}},code39:{encoding:["101001101101","110100101011","101100101011","110110010101","101001101011","110100110101","101100110101","101001011011","110100101101","101100101101","110101001011","101101001011","110110100101","101011001011","110101100101","101101100101","101010011011","110101001101","101101001101","101011001101","110101010011","101101010011","110110101001","101011010011","110101101001","101101101001","101010110011","110101011001","101101011001","101011011001","110010101011","100110101011","110011010101","100101101011","110010110101","100110110101","100101011011","110010101101","100110101101","100100100101","100100101001","100101001001","101001001001","100101101101"],getDigit:function(h){var f,e,d="";if(h.indexOf("*")>=0)return"";for(h=("*"+h+"*").toUpperCase(),f=0;f<h.length;f++){if((e="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ-. $/+%*".indexOf(h.charAt(f)))<0)return"";f>0&&(d+="0"),d+=this.encoding[e]}return d}},code93:{encoding:["100010100","101001000","101000100","101000010","100101000","100100100","100100010","101010000","100010010","100001010","110101000","110100100","110100010","110010100","110010010","110001010","101101000","101100100","101100010","100110100","100011010","101011000","101001100","101000110","100101100","100010110","110110100","110110010","110101100","110100110","110010110","110011010","101101100","101100110","100110110","100111010","100101110","111010100","111010010","111001010","101101110","101110110","110101110","100100110","111011010","111010110","100110010","101011110"],getDigit:function(e,j){var n="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ-. $/+%____*",o="";if(e.indexOf("*")>=0)return"";for(e=e.toUpperCase(),o+=this.encoding[47],i=0;i<e.length;i++){if(l=e.charAt(i),index=n.indexOf(l),"_"==l||index<0)return"";o+=this.encoding[index]}if(j){var l,m=0,g=0,h=1,d=0;for(i=e.length-1;i>=0;i--)m=20==m?1:m+1,h=15==h?1:h+1,index=n.indexOf(e.charAt(i)),g+=m*index,d+=h*index;var f=(d+=l=g%47)%47;o+=this.encoding[l],o+=this.encoding[f]}return o+=this.encoding[47],o+="1"}},code128:{encoding:["11011001100","11001101100","11001100110","10010011000","10010001100","10001001100","10011001000","10011000100","10001100100","11001001000","11001000100","11000100100","10110011100","10011011100","10011001110","10111001100","10011101100","10011100110","11001110010","11001011100","11001001110","11011100100","11001110100","11101101110","11101001100","11100101100","11100100110","11101100100","11100110100","11100110010","11011011000","11011000110","11000110110","10100011000","10001011000","10001000110","10110001000","10001101000","10001100010","11010001000","11000101000","11000100010","10110111000","10110001110","10001101110","10111011000","10111000110","10001110110","11101110110","11010001110","11000101110","11011101000","11011100010","11011101110","11101011000","11101000110","11100010110","11101101000","11101100010","11100011010","11101111010","11001000010","11110001010","10100110000","10100001100","10010110000","10010000110","10000101100","10000100110","10110010000","10110000100","10011010000","10011000010","10000110100","10000110010","11000010010","11001010000","11110111010","11000010100","10001111010","10100111100","10010111100","10010011110","10111100100","10011110100","10011110010","11110100100","11110010100","11110010010","11011011110","11011110110","11110110110","10101111000","10100011110","10001011110","10111101000","10111100010","11110101000","11110100010","10111011110","10111101110","11101011110","11110101110","11010000100","11010010000","11010011100","11000111010"],getDigit:function(e){var d=" !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~",o="",l=0,f=0,k=0,h=0,n=0;for(k=0;k<e.length;k++)if(-1==d.indexOf(e.charAt(k)))return"";var g=e.length>1,m="";for(k=0;k<3&&k<e.length;k++)g&=(m=e.charAt(k))>="0"&&m<="9";for(l=g?105:104,o=this.encoding[l],k=0;k<e.length;){if(g)(k==e.length||e.charAt(k)<"0"||e.charAt(k)>"9"||e.charAt(k+1)<"0"||e.charAt(k+1)>"9")&&(g=!1,o+=this.encoding[100],l+=100*++f);else{for(h=0;k+h<e.length&&e.charAt(k+h)>="0"&&e.charAt(k+h)<="9";)h++;(g=h>5||k+h-1==e.length&&h>3)&&(o+=this.encoding[99],l+=99*++f)}g?(n=a.intval(e.charAt(k)+e.charAt(k+1)),k+=2):(n=d.indexOf(e.charAt(k)),k+=1),o+=this.encoding[n],l+=++f*n}return o+=this.encoding[l%103],o+=this.encoding[106],o+="11"}},codabar:{encoding:["101010011","101011001","101001011","110010101","101101001","110101001","100101011","100101101","100110101","110100101","101001101","101100101","1101011011","1101101011","1101101101","1011011011","1011001001","1010010011","1001001011","1010011001"],getDigit:function(h){var f,e,d="";for(d+=this.encoding[16]+"0",f=0;f<h.length;f++){if((e="0123456789-$:/.+".indexOf(h.charAt(f)))<0)return"";d+=this.encoding[e]+"0"}return d+=this.encoding[16]}},datamatrix:{lengthRows:[10,12,14,16,18,20,22,24,26,32,36,40,44,48,52,64,72,80,88,96,104,120,132,144,8,8,12,12,16,16],lengthCols:[10,12,14,16,18,20,22,24,26,32,36,40,44,48,52,64,72,80,88,96,104,120,132,144,18,32,26,36,36,48],dataCWCount:[3,5,8,12,18,22,30,36,44,62,86,114,144,174,204,280,368,456,576,696,816,1050,1304,1558,5,10,16,22,32,49],solomonCWCount:[5,7,10,12,14,18,20,24,28,36,42,48,56,68,84,112,144,192,224,272,336,408,496,620,7,11,14,18,24,28],dataRegionRows:[8,10,12,14,16,18,20,22,24,14,16,18,20,22,24,14,16,18,20,22,24,18,20,22,6,6,10,10,14,14],dataRegionCols:[8,10,12,14,16,18,20,22,24,14,16,18,20,22,24,14,16,18,20,22,24,18,20,22,16,14,24,16,16,22],regionRows:[1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,4,4,4,4,4,4,6,6,6,1,1,1,1,1,1],regionCols:[1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,4,4,4,4,4,4,6,6,6,1,2,1,2,2,2],interleavedBlocks:[1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,4,4,4,4,6,6,8,8,1,1,1,1,1,1],logTab:[-255,255,1,240,2,225,241,53,3,38,226,133,242,43,54,210,4,195,39,114,227,106,134,28,243,140,44,23,55,118,211,234,5,219,196,96,40,222,115,103,228,78,107,125,135,8,29,162,244,186,141,180,45,99,24,49,56,13,119,153,212,199,235,91,6,76,220,217,197,11,97,184,41,36,223,253,116,138,104,193,229,86,79,171,108,165,126,145,136,34,9,74,30,32,163,84,245,173,187,204,142,81,181,190,46,88,100,159,25,231,50,207,57,147,14,67,120,128,154,248,213,167,200,63,236,110,92,176,7,161,77,124,221,102,218,95,198,90,12,152,98,48,185,179,42,209,37,132,224,52,254,239,117,233,139,22,105,27,194,113,230,206,87,158,80,189,172,203,109,175,166,62,127,247,146,66,137,192,35,252,10,183,75,216,31,83,33,73,164,144,85,170,246,65,174,61,188,202,205,157,143,169,82,72,182,215,191,251,47,178,89,151,101,94,160,123,26,112,232,21,51,238,208,131,58,69,148,18,15,16,68,17,121,149,129,19,155,59,249,70,214,250,168,71,201,156,64,60,237,130,111,20,93,122,177,150],aLogTab:[1,2,4,8,16,32,64,128,45,90,180,69,138,57,114,228,229,231,227,235,251,219,155,27,54,108,216,157,23,46,92,184,93,186,89,178,73,146,9,18,36,72,144,13,26,52,104,208,141,55,110,220,149,7,14,28,56,112,224,237,247,195,171,123,246,193,175,115,230,225,239,243,203,187,91,182,65,130,41,82,164,101,202,185,95,190,81,162,105,210,137,63,126,252,213,135,35,70,140,53,106,212,133,39,78,156,21,42,84,168,125,250,217,159,19,38,76,152,29,58,116,232,253,215,131,43,86,172,117,234,249,223,147,11,22,44,88,176,77,154,25,50,100,200,189,87,174,113,226,233,255,211,139,59,118,236,245,199,163,107,214,129,47,94,188,85,170,121,242,201,191,83,166,97,194,169,127,254,209,143,51,102,204,181,71,142,49,98,196,165,103,206,177,79,158,17,34,68,136,61,122,244,197,167,99,198,161,111,222,145,15,30,60,120,240,205,183,67,134,33,66,132,37,74,148,5,10,20,40,80,160,109,218,153,31,62,124,248,221,151,3,6,12,24,48,96,192,173,119,238,241,207,179,75,150,1],champGaloisMult:function(d,c){return d&&c?this.aLogTab[(this.logTab[d]+this.logTab[c])%255]:0},champGaloisDoub:function(d,c){return d?c?this.aLogTab[(this.logTab[d]+c)%255]:d:0},champGaloisSum:function(d,c){return d^c},selectIndex:function(d,c){if((d<1||d>1558)&&!c)return-1;if((d<1||d>49)&&c)return-1;var e=0;for(c&&(e=24);this.dataCWCount[e]<d;)e++;return e},encodeDataCodeWordsASCII:function(f){var d,g,e=new Array,h=0;for(d=0;d<f.length;d++)(g=f.charCodeAt(d))>127?(e[h]=235,g-=127,h++):g>=48&&g<=57&&d+1<f.length&&f.charCodeAt(d+1)>=48&&f.charCodeAt(d+1)<=57?(g=10*(g-48)+(f.charCodeAt(d+1)-48),g+=130,d++):g++,e[h]=g,h++;return e},addPadCW:function(d,g,f){var e,c;if(!(g>=f))for(d[g]=129,c=g+1;c<f;c++)e=149*(c+1)%253+1,d[c]=(129+e)%254},calculSolFactorTable:function(c){var e,d,f=new Array;for(e=0;e<=c;e++)f[e]=1;for(e=1;e<=c;e++)for(d=e-1;d>=0;d--)f[d]=this.champGaloisDoub(f[d],e),d>0&&(f[d]=this.champGaloisSum(f[d],f[d-1]));return f},addReedSolomonCW:function(e,d,n,m,c){var h,g,f,p=0,o=e/c,l=new Array;for(f=0;f<c;f++){for(h=0;h<o;h++)l[h]=0;for(h=f;h<n;h+=c)for(p=this.champGaloisSum(m[h],l[o-1]),g=o-1;g>=0;g--)l[g]=p?this.champGaloisMult(p,d[g]):0,g>0&&(l[g]=this.champGaloisSum(l[g-1],l[g]));for(g=n+f,h=o-1;h>=0;h--)m[g]=l[h],g+=c}return m},getBits:function(c){for(var e=new Array,d=0;d<8;d++)e[d]=c&128>>d?1:0;return e},next:function(h,j,f,k,e,g){var d=0,l=4,c=0;do{l==j&&0==c?(this.patternShapeSpecial1(e,g,k[d],j,f),d++):h<3&&l==j-2&&0==c&&f%4!=0?(this.patternShapeSpecial2(e,g,k[d],j,f),d++):l==j-2&&0==c&&f%8==4?(this.patternShapeSpecial3(e,g,k[d],j,f),d++):l==j+4&&2==c&&f%8==0&&(this.patternShapeSpecial4(e,g,k[d],j,f),d++);do{l<j&&c>=0&&1!=g[l][c]&&(this.patternShapeStandard(e,g,k[d],l,c,j,f),d++),l-=2,c+=2}while(l>=0&&c<f);l+=1,c+=3;do{l>=0&&c<f&&1!=g[l][c]&&(this.patternShapeStandard(e,g,k[d],l,c,j,f),d++),l+=2,c-=2}while(l<j&&c>=0);l+=3,c+=1}while(l<j||c<f)},patternShapeStandard:function(g,d,h,j,c,e,f){this.placeBitInDatamatrix(g,d,h[0],j-2,c-2,e,f),this.placeBitInDatamatrix(g,d,h[1],j-2,c-1,e,f),this.placeBitInDatamatrix(g,d,h[2],j-1,c-2,e,f),this.placeBitInDatamatrix(g,d,h[3],j-1,c-1,e,f),this.placeBitInDatamatrix(g,d,h[4],j-1,c,e,f),this.placeBitInDatamatrix(g,d,h[5],j,c-2,e,f),this.placeBitInDatamatrix(g,d,h[6],j,c-1,e,f),this.placeBitInDatamatrix(g,d,h[7],j,c,e,f)},patternShapeSpecial1:function(f,c,g,d,e){this.placeBitInDatamatrix(f,c,g[0],d-1,0,d,e),this.placeBitInDatamatrix(f,c,g[1],d-1,1,d,e),this.placeBitInDatamatrix(f,c,g[2],d-1,2,d,e),this.placeBitInDatamatrix(f,c,g[3],0,e-2,d,e),this.placeBitInDatamatrix(f,c,g[4],0,e-1,d,e),this.placeBitInDatamatrix(f,c,g[5],1,e-1,d,e),this.placeBitInDatamatrix(f,c,g[6],2,e-1,d,e),this.placeBitInDatamatrix(f,c,g[7],3,e-1,d,e)},patternShapeSpecial2:function(f,c,g,d,e){this.placeBitInDatamatrix(f,c,g[0],d-3,0,d,e),this.placeBitInDatamatrix(f,c,g[1],d-2,0,d,e),this.placeBitInDatamatrix(f,c,g[2],d-1,0,d,e),this.placeBitInDatamatrix(f,c,g[3],0,e-4,d,e),this.placeBitInDatamatrix(f,c,g[4],0,e-3,d,e),this.placeBitInDatamatrix(f,c,g[5],0,e-2,d,e),this.placeBitInDatamatrix(f,c,g[6],0,e-1,d,e),this.placeBitInDatamatrix(f,c,g[7],1,e-1,d,e)},patternShapeSpecial3:function(f,c,g,d,e){this.placeBitInDatamatrix(f,c,g[0],d-3,0,d,e),this.placeBitInDatamatrix(f,c,g[1],d-2,0,d,e),this.placeBitInDatamatrix(f,c,g[2],d-1,0,d,e),this.placeBitInDatamatrix(f,c,g[3],0,e-2,d,e),this.placeBitInDatamatrix(f,c,g[4],0,e-1,d,e),this.placeBitInDatamatrix(f,c,g[5],1,e-1,d,e),this.placeBitInDatamatrix(f,c,g[6],2,e-1,d,e),this.placeBitInDatamatrix(f,c,g[7],3,e-1,d,e)},patternShapeSpecial4:function(f,c,g,d,e){this.placeBitInDatamatrix(f,c,g[0],d-1,0,d,e),this.placeBitInDatamatrix(f,c,g[1],d-1,e-1,d,e),this.placeBitInDatamatrix(f,c,g[2],0,e-3,d,e),this.placeBitInDatamatrix(f,c,g[3],0,e-2,d,e),this.placeBitInDatamatrix(f,c,g[4],0,e-1,d,e),this.placeBitInDatamatrix(f,c,g[5],1,e-3,d,e),this.placeBitInDatamatrix(f,c,g[6],1,e-2,d,e),this.placeBitInDatamatrix(f,c,g[7],1,e-1,d,e)},placeBitInDatamatrix:function(g,d,j,h,c,e,f){h<0&&(h+=e,c+=4-(e+4)%8),c<0&&(c+=f,h+=4-(f+4)%8),1!=d[h][c]&&(g[h][c]=j,d[h][c]=1)},addFinderPattern:function(k,m,h,l,c){var n=(l+2)*m,d=(c+2)*h,e=new Array;e[0]=new Array;for(var f=0;f<d+2;f++)e[0][f]=0;for(var g=0;g<n;g++){e[g+1]=new Array,e[g+1][0]=0,e[g+1][d+1]=0;for(f=0;f<d;f++)g%(l+2)==0?e[g+1][f+1]=f%2==0?1:0:g%(l+2)==l+1?e[g+1][f+1]=1:f%(c+2)==c+1?e[g+1][f+1]=g%2==0?0:1:f%(c+2)==0?e[g+1][f+1]=1:(e[g+1][f+1]=0,e[g+1][f+1]=k[g-1-2*parseInt(g/(l+2))][f-1-2*parseInt(f/(c+2))])}e[n+1]=new Array;for(f=0;f<d+2;f++)e[n+1][f]=0;return e},getDigit:function(l,q){var p=this.encodeDataCodeWordsASCII(l),j=p.length,f=this.selectIndex(j,q),m=this.dataCWCount[f],x=this.solomonCWCount[f],c=m+x,y=this.lengthRows[f],z=this.lengthCols[f],e=this.regionRows[f],d=this.regionCols[f],k=this.dataRegionRows[f],w=this.dataRegionCols[f],t=y-2*e,h=z-2*d,u=this.interleavedBlocks[f],s=x/u;this.addPadCW(p,j,m);var r=this.calculSolFactorTable(s);this.addReedSolomonCW(x,r,m,p,u);for(var o=new Array,n=0;n<c;n++)o[n]=this.getBits(p[n]);var A=new Array,v=new Array;for(n=0;n<h;n++)A[n]=new Array,v[n]=new Array;return t*h%8==4&&(A[t-2][h-2]=1,A[t-1][h-1]=1,A[t-1][h-2]=0,A[t-2][h-1]=0,v[t-2][h-2]=1,v[t-1][h-1]=1,v[t-1][h-2]=1,v[t-2][h-1]=1),this.next(0,t,h,o,A,v),A=this.addFinderPattern(A,e,d,k,w)}},lec:{cInt:function(e,f){for(var d="",c=0;c<f;c++)d+=String.fromCharCode(255&e),e>>=8;return d},cRgb:function(e,d,c){return String.fromCharCode(c)+String.fromCharCode(d)+String.fromCharCode(e)},cHexColor:function(h){var d=parseInt("0x"+h.substr(1)),c=255&d,f=255&(d>>=8),e=d>>8;return this.cRgb(e,f,c)}},hexToRGB:function(h){var d=parseInt("0x"+h.substr(1)),c=255&d;return{r:(d>>=8)>>8,g:255&d,b:c}},isHexColor:function(d){var c=new RegExp("#[0-91-F]","gi");return d.match(c)},base64Encode:function(o){for(var h,f,e,n,m,l,j,c="",d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",g=0;g<o.length;)n=(h=o.charCodeAt(g++))>>2,m=(3&h)<<4|(f=o.charCodeAt(g++))>>4,l=(15&f)<<2|(e=o.charCodeAt(g++))>>6,j=63&e,isNaN(f)?l=j=64:isNaN(e)&&(j=64),c+=d.charAt(n)+d.charAt(m)+d.charAt(l)+d.charAt(j);return c},bitStringTo2DArray:function(f){var e=[];e[0]=[];for(var c=0;c<f.length;c++)e[0][c]=f.charAt(c);return e},resize:function(d,c){return d.css("padding","0px").css("overflow","auto").css("width",c+"px").html(""),d},digitToBmpRenderer:function(t,v,o,g,n,z){var e=o.length,f=o[0].length,u=0,r=this.isHexColor(v.bgColor)?this.lec.cHexColor(v.bgColor):this.lec.cRgb(255,255,255),q=this.isHexColor(v.color)?this.lec.cHexColor(v.color):this.lec.cRgb(0,0,0),d="",c="";for(u=0;u<n;u++)d+=r,c+=q;var m=(4-n*f*3%4)%4,C=(n*f+m)*z*e,w="";for(u=0;u<m;u++)w+="\0";for(var A="BM"+this.lec.cInt(54+C,4)+"\0\0\0\0"+this.lec.cInt(54,4)+this.lec.cInt(40,4)+this.lec.cInt(n*f,4)+this.lec.cInt(z*e,4)+this.lec.cInt(1,2)+this.lec.cInt(24,2)+"\0\0\0\0"+this.lec.cInt(C,4)+this.lec.cInt(2835,4)+this.lec.cInt(2835,4)+this.lec.cInt(0,4)+this.lec.cInt(0,4),h=e-1;h>=0;h--){for(var l="",j=0;j<f;j++)l+="0"==o[h][j]?d:c;l+=w;for(var s=0;s<z;s++)A+=l}var B=document.createElement("object");B.setAttribute("type","image/bmp"),B.setAttribute("data","data:image/bmp;base64,"+this.base64Encode(A)),this.resize(t,n*f+m).append(B)},digitToBmp:function(g,f,j,d){var c=a.intval(f.barWidth),e=a.intval(f.barHeight);this.digitToBmpRenderer(g,f,this.bitStringTo2DArray(j),d,c,e)},digitToBmp2D:function(f,e,g,c){var d=a.intval(e.moduleSize);this.digitToBmpRenderer(f,e,g,c,d,d)},digitToCssRenderer:function(q,c,m,e,p,g){for(var f,h,r=m.length,d=m[0].length,j="",o='<div style="float: left; font-size: 0px; background-color: '+c.bgColor+"; height: "+g+'px; width: &Wpx"></div>',l='<div style="float: left; font-size: 0px; width:0; border-left: &Wpx solid '+c.color+"; height: "+g+'px;"></div>',k=0;k<r;k++){f=0,h=m[k][0];for(var n=0;n<d;n++)h==m[k][n]?f++:(j+=("0"==h?o:l).replace("&W",f*p),h=m[k][n],f=1);f>0&&(j+=("0"==h?o:l).replace("&W",f*p))}c.showHRI&&(j+='<div style="clear:both; width: 100%; background-color: '+c.bgColor+"; color: "+c.color+"; text-align: center; font-size: "+c.fontSize+"px; margin-top: "+c.marginHRI+'px;">'+e+"</div>"),this.resize(q,p*d).html(j)},digitToCss:function(g,f,j,d){var c=a.intval(f.barWidth),e=a.intval(f.barHeight);this.digitToCssRenderer(g,f,this.bitStringTo2DArray(j),d,c,e)},digitToCss2D:function(f,e,g,c){var d=a.intval(e.moduleSize);this.digitToCssRenderer(f,e,g,c,d,d)},digitToSvgRenderer:function(q,s,m,f,k,t){var d=m.length,e=m[0].length,p=k*e,l=t*d;if(s.showHRI){var g=a.intval(s.fontSize);l+=a.intval(s.marginHRI)+g}var n='<svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="'+p+'" height="'+l+'">';n+='<rect width="'+p+'" height="'+l+'" x="0" y="0" fill="'+s.bgColor+'" />';for(var r,o,c='<rect width="&W" height="'+t+'" x="&X" y="&Y" fill="'+s.color+'" />',h=0;h<d;h++){r=0,o=m[h][0];for(var j=0;j<e;j++)o==m[h][j]?r++:("1"==o&&(n+=c.replace("&W",r*k).replace("&X",(j-r)*k).replace("&Y",h*t)),o=m[h][j],r=1);r>0&&"1"==o&&(n+=c.replace("&W",r*k).replace("&X",(e-r)*k).replace("&Y",h*t))}s.showHRI&&(n+='<g transform="translate('+Math.floor(p/2)+' 0)">',n+='<text y="'+(l-Math.floor(g/2))+'" text-anchor="middle" style="font-family: Arial; font-size: '+g+'px;" fill="'+s.color+'">'+f+"</text>",n+="</g>"),n+="</svg>";var u=document.createElement("object");u.setAttribute("type","image/svg+xml"),u.setAttribute("data","data:image/svg+xml,"+n),this.resize(q,p).append(u)},digitToSvg:function(g,f,j,d){var c=a.intval(f.barWidth),e=a.intval(f.barHeight);this.digitToSvgRenderer(g,f,this.bitStringTo2DArray(j),d,c,e)},digitToSvg2D:function(f,e,g,c){var d=a.intval(e.moduleSize);this.digitToSvgRenderer(f,e,g,c,d,d)},digitToCanvasRenderer:function(s,e,o,g,m,f,q,k){var c=s.get(0);if(c&&c.getContext){var t=o.length,d=o[0].length,r=c.getContext("2d");r.lineWidth=1,r.lineCap="butt",r.fillStyle=e.bgColor,r.fillRect(m,f,d*q,t*k),r.fillStyle=e.color;for(var n=0;n<t;n++){for(var j=0,l=o[n][0],p=0;p<d;p++)l==o[n][p]?j++:("1"==l&&r.fillRect(m+(p-j)*q,f+n*k,q*j,k),l=o[n][p],j=1);j>0&&"1"==l&&r.fillRect(m+(d-j)*q,f+n*k,q*j,k)}if(e.showHRI){var h=r.measureText(g);r.fillText(g,m+Math.floor((d*q-h.width)/2),f+t*k+e.fontSize+e.marginHRI)}}},digitToCanvas:function(j,g,l,e){var d=a.intval(g.barWidth),f=a.intval(g.barHeight),c=a.intval(g.posX),k=a.intval(g.posY);this.digitToCanvasRenderer(j,g,this.bitStringTo2DArray(l),e,c,k,d,f)},digitToCanvas2D:function(g,f,j,d){var e=a.intval(f.moduleSize),c=a.intval(f.posX),h=a.intval(f.posY);this.digitToCanvasRenderer(g,f,j,d,c,h,e,e)}};b.fn.extend({barcode:function(h,m,f){var n="",g="",d="",k=!0,o=!1,j=!1;if("string"==typeof h?d=h:"object"==typeof h&&(d="string"==typeof h.code?h.code:"",k=void 0===h.crc||h.crc,o=void 0!==h.rect&&h.rect),""==d)return!1;for(var c in void 0===f&&(f=[]),a.settings)null==f[c]&&(f[c]=a.settings[c]);switch(m){case"std25":case"int25":n=a.i25.getDigit(d,k,m),g=a.i25.compute(d,k,m);break;case"ean8":case"ean13":n=a.ean.getDigit(d,m),g=a.ean.compute(d,m);break;case"upc":n=a.upc.getDigit(d),g=a.upc.compute(d);break;case"code11":n=a.code11.getDigit(d),g=d;break;case"code39":n=a.code39.getDigit(d),g=d;break;case"code93":n=a.code93.getDigit(d,k),g=d;break;case"code128":n=a.code128.getDigit(d),g=d;break;case"codabar":n=a.codabar.getDigit(d),g=d;break;case"msi":n=a.msi.getDigit(d,k),g=a.msi.compute(d,k);break;case"datamatrix":n=a.datamatrix.getDigit(d,o),g=d,j=!0}if(0==n.length)return b(this);!j&&f.addQuietZone&&(n="0000000000"+n+"0000000000");var l=b(this),e="digitTo"+f.output.charAt(0).toUpperCase()+f.output.substr(1)+(j?"2D":"");return"function"==typeof a[e]&&a[e](l,f,n,g),l}})}(jQuery);
/**
 * EGroupware eTemplate2 - JS barcode widget
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Hadi Nategh <hn[at]stylite.de>
 * @copyright Stylite AG
 * @version $Id:$
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_barcode=function(_super){function et2_barcode(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_barcode._attributes,_child||{}))||this;return _this.div=jQuery(document.createElement("div")).attr({class:"et2_barcode"}),_this.set_id(_this.id),_this.setDOMNode(_this.div[0]),_this.createWidget(),_this}return __extends(et2_barcode,_super),et2_barcode.prototype.createWidget=function(){this.settings={output:this.options.format,bgColor:this.options.bgColor,color:this.options.barColor,barWidth:this.options.barWidth,barHeight:this.options.barHeight},this.get_value()&&this.div.barcode(this.get_value(),this.options.code_type,this.settings)},et2_barcode.prototype.set_value=function(_val){void 0!==_val&&(this.value=_val,this.createWidget())},et2_barcode.prototype.get_value=function(){return this.value},et2_barcode.TYPE_CODEBAR="codebar",et2_barcode.TYPE_CODE11="code11",et2_barcode.TYPE_CODE39="code39",et2_barcode.TYPE_CODE128="code128",et2_barcode.TYPE_EAN8="ean8",et2_barcode.TYPE_EAN13="ean13",et2_barcode.TYPE_STD25="std25",et2_barcode.TYPE_INT25="int25",et2_barcode.TYPE_MSI="msi",et2_barcode.TYPE_DATAMATRIX="datamatrix",et2_barcode.FORMAT_CSS="css",et2_barcode.FORMAT_SVG="svg",et2_barcode.FORMAT_bmp="bmp",et2_barcode.FORMAT_CANVAS="canvas",et2_barcode._attributes={code_type:{name:"code type",type:"string",default:et2_barcode.TYPE_DATAMATRIX,description:"Barcode type to be generated, default is QR barcode"},bgColor:{name:"bgColor",type:"string",default:"#FFFFFF",description:"Defines backgorund color of barcode container"},barColor:{name:"barColor",type:"string",default:"#000000",description:"Defines color of the bars in barcode."},format:{name:"format",type:"string",default:"css",description:"Defines in which format the barcode should be rendered. Default is SVG."},barWidth:{name:"bar width",type:"string",default:"1",description:"Defines width of each bar in the barcode."},barHeight:{name:"bar height",type:"string",default:"50",description:"Defines heigh of each bar in the barcode."}},et2_barcode}((et2_core_valueWidget_1=require("./et2_core_valueWidget")).et2_valueWidget);
/**
 * EGroupware eTemplate2 - JS Itempicker object
 * derived from et2_link_entry widget @copyright 2011 Nathan Gray
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Christian Binder
 * @author Nathan Gray
 * @copyright 2012 Christian Binder
 * @copyright 2011 Nathan Gray
 */
function itempickerDocumentAction(context,data){var formid="itempicker_action_form",form="<form id='"+formid+"' action='index.php?menuaction="+data.app+"."+data.app+"_merge.download_by_request' method='POST'><input type='hidden' name='data_document_name' value='"+data.value.name+"' /><input type='hidden' name='data_document_dir' value='"+data.value.dir+"' /><input type='hidden' name='data_checked' value='"+data.checked.join(",")+"' /></form>";jQuery("body").append(form),jQuery("#"+formid).submit().remove()}exports.et2_barcode=et2_barcode,et2_core_widget_1.et2_register_widget(et2_barcode,["barcode"]);
/**
 * EGroupware eTemplate2 - JS Itempicker object
 * derived from et2_link_entry widget @copyright 2011 Nathan Gray
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Christian Binder
 * @author Nathan Gray
 * @copyright 2012 Christian Binder
 * @copyright 2011 Nathan Gray
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget"),et2_core_inputWidget_1=require("./et2_core_inputWidget"),et2_core_inheritance_1=require("./et2_core_inheritance");var et2_itempicker=function(_super){function et2_itempicker(_parent,_attrs,_child){var _this=_super.call(this,_parent,_attrs,et2_core_inheritance_1.ClassWithAttributes.extendAttributes(et2_itempicker._attributes,_child||{}))||this;return _this.last_search="",_this.action=null,_this.current_app="",_this.div=null,_this.left=null,_this.right=null,_this.right_container=null,_this.app_select=null,_this.search=null,_this.button_action=null,_this.itemlist=null,_this.div=null,_this.left=null,_this.right=null,_this.right_container=null,_this.app_select=null,_this.search=null,_this.button_action=null,_this.itemlist=null,null!==_this.options.action&&"string"==typeof _this.options.action?_this.action=new egwFnct(_this,"javaScript:"+_this.options.action):console.log("itempicker widget: no action provided for button"),_this.createInputWidget(),_this}return __extends(et2_itempicker,_super),et2_itempicker.prototype.clearSearchResults=function(){this.search.val(""),this.itemlist.html(""),this.search.focus(),this.clear.hide()},et2_itempicker.prototype.createInputWidget=function(){var _self=this;this.div=jQuery(document.createElement("div")),this.left=jQuery(document.createElement("div")),this.right=jQuery(document.createElement("div")),this.right_container=jQuery(document.createElement("div")),this.app_select=jQuery(document.createElement("ul")),this.search=jQuery(document.createElement("input")),this.clear=jQuery(document.createElement("span")),this.itemlist=jQuery(document.createElement("div")),this.div.addClass("et2_itempicker"),this.left.addClass("et2_itempicker_left"),this.right.addClass("et2_itempicker_right"),this.right_container.addClass("et2_itempicker_right_container"),this.app_select.addClass("et2_itempicker_app_select");var item_count=0;for(var key in this.options.select_options){var img_icon=this.egw().image(key+"/navbar");if(null!==img_icon){var img=jQuery(document.createElement("img"));img.attr("src",img_icon);var item=jQuery(document.createElement("li"));item.attr("id",key).click((function(){_self.selectApplication(jQuery(this))})).append(img),0==item_count&&this.selectApplication(item),this.app_select.append(item),item_count++}}this.search.addClass("et2_itempicker_search"),this.search.keyup((function(){var request={};request.term=jQuery(this).val(),_self.query(request)})),this.set_blur(this.options.blur,this.search),this.clear.addClass("et2_itempicker_clear ui-icon ui-icon-close").click((function(){_self.clearSearchResults()})).hide(),this.button_action=et2_createWidget("button"),jQuery(this.button_action.getDOMNode()).addClass("et2_itempicker_button_action"),this.button_action.set_label(this.egw().lang(this.options.action_label)),this.button_action.click=function(){_self.doAction()},this.itemlist.attr("id","itempicker_itemlist"),this.itemlist.addClass("et2_itempicker_itemlist"),this.left.append(this.app_select),this.right_container.append(this.search),this.right_container.append(this.clear),this.right_container.append(this.button_action.getDOMNode()),this.right_container.append(this.itemlist),this.right.append(this.right_container),this.div.append(this.right),this.div.append(this.left),this.setDOMNode(this.div[0])},et2_itempicker.prototype.doAction=function(){if(null!==this.action){var data={};return data.app=this.current_app,data.value=this.options.value,data.checked=this.getSelectedItems(),this.action.exec(this,data)}return!1},et2_itempicker.prototype.getSelectedItems=function(){var items=[];return jQuery(this.itemlist).children("ul").children("li.selected").each((function(index){items[index]=jQuery(this).attr("id")})),items},et2_itempicker.prototype.query=function(request){return request.term.length<3||(this.last_search=request.term,!(this.options.query&&"function"==typeof this.options.query&&!this.options.query(request,response))&&(this.itemlist.addClass("loading"),this.clear.css("display","inline-block"),void egw.json("EGroupware\\Api\\Etemplate\\Widget\\ItemPicker::ajax_item_search",[this.current_app,"",request.term,request.options],this.queryResults,this,!0,this).sendRequest()))},et2_itempicker.prototype.queryResults=function(data){this.itemlist.removeClass("loading"),this.updateItemList(data)},et2_itempicker.prototype.selectApplication=function(app){return this.clearSearchResults(),jQuery(".et2_itempicker_app_select li").removeClass("selected"),app.addClass("selected"),this.current_app=app.attr("id"),!0},et2_itempicker.prototype.set_blur=function(_value,input){void 0===input&&(input=this.search),_value?(input.attr("placeholder",_value),input[0].placeholder||(""==input.val()&&input.val(_value),input.focus(input,(function(e){var placeholder=_value;e.data.val()==placeholder&&e.data.val("")})).blur(input,(function(e){var placeholder=_value;""==e.data.val()&&e.data.val(placeholder)})),""==input.val()&&input.val(_value))):this.search.removeAttr("placeholder")},et2_itempicker.prototype.transformAttributes=function(_attrs){if(_super.prototype.transformAttributes.call(this,_attrs),_attrs.select_options={},_attrs.application)for(var apps=et2_csvSplit(_attrs.application,null,","),i=0;i<apps.length;i++)_attrs.select_options[apps[i]]=this.egw().lang(apps[i]);else _attrs.select_options=this.egw().link_app_list("query");null==_attrs.select_options&&(_attrs.select_options=this.getArrayMgr("content").getEntry("options-"+this.id)),null==_attrs.select_options&&(_attrs.select_options={})},et2_itempicker.prototype.updateItemList=function(data){var list=jQuery(document.createElement("ul")),item_count=0;for(var id in data){var item=jQuery(document.createElement("li"));item_count%2==0?item.addClass("row_on"):item.addClass("row_off"),item.attr("id",id).html(data[id]).click((function(e){var _a;if(e.ctrlKey||e.metaKey)jQuery(this).addClass("selected");else if(e.shiftKey){var start=jQuery(this).siblings(".selected").first();if(0==(null===(_a=start)||void 0===_a?void 0:_a.length))return jQuery(this).addClass("selected"),!0;var end=jQuery(this);if(start.index()>end.index()){var startOld=start;start=end,end=startOld}start.addClass("selected"),start.nextUntil(end).addClass("selected"),end.addClass("selected")}else jQuery(this).siblings(".selected").removeClass("selected"),jQuery(this).addClass("selected")})),list.append(item),item_count++}this.itemlist.html(list)},et2_itempicker._attributes={action:{name:"Action callback",type:"string",default:!1,description:"Callback for action.  Must be a function(context, data)"},action_label:{name:"Action label",type:"string",default:"Action",description:"Label for action button"},application:{name:"Application",type:"string",default:"",description:"Limit to the listed application or applications (comma separated)"},blur:{name:"Placeholder",type:"string",default:et2_no_init,description:"This text get displayed if an input-field is empty and does not have the input-focus (blur). It can be used to show a default value or a kind of help-text."},value:{name:"value",type:"any",default:"",description:"Optional itempicker value(s) - can be used for e.g. environmental information"},query:{name:"Query callback",type:"any",default:!1,description:"Callback before query to server.  Must return true, or false to abort query."}},et2_itempicker.legacyOptions=["application"],et2_itempicker}(et2_core_inputWidget_1.et2_inputWidget);et2_core_widget_1.et2_register_widget(et2_itempicker,["itempicker"]);
/**
 * EGroupware eTemplate2 - JS widget class containing javascript
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Ralf Becker
 */
__extends=this&&this.__extends||function(){var extendStatics=function(d,b){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(d,b){d.__proto__=b}||function(d,b){for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p])})(d,b)};return function(d,b){function __(){this.constructor=d}extendStatics(d,b),d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)}}();Object.defineProperty(exports,"__esModule",{value:!0});et2_core_widget_1=require("./et2_core_widget");var et2_script=function(_super){function et2_script(_parent,_attrs,_child){var _this=_super.call(this)||this;return _this.supportedWidgetClasses=[],_this}return __extends(et2_script,_super),et2_script.prototype.loadContent=function(_content){try{new Function(_content).call(window)}catch(e){this.egw.debug("error","Error while executing script: ",_content,e)}},et2_script}((et2_core_widget_2=require("./et2_core_widget")).et2_widget);et2_core_widget_1.et2_register_widget(et2_script,["script"]),
/**
 * EGroupware eTemplate2 - Execution layer for legacy event code
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011-13
 * @version $Id: et2_core_phpExpressionCompiler.js 38256 2012-03-05 13:07:38Z igel457 $
 */
function(){this.et2_compileLegacyJS=function(_code,_widget,_context){if("1"===(_code=function(_val,widget){if(-1!=_val.indexOf("egw::link(")&&(_val=_val.replace(/egw::link\(/g,"egw.link(")),-1!=_val.indexOf("form::name(")){var _cname=!!widget.getPath()&&widget.getPath().join("[");_val=_val.replace(/form::name\(/g,"'"+widget.getRoot()._inst.uniqueId+"_'+"+(_cname?"et2_form_name('"+_cname+"',":"("))}return-1!=_val.indexOf("egw::lang(")&&(_val=_val.replace(/egw::lang\(/g,"egw.lang(")),-1!=_val.indexOf("confirm(")&&(_val=_val.replace(/confirm\((['"])(.*?)(\?)?['"]\)/,"confirm(egw.lang($1$2$1)+'$3')")),-1!=_val.indexOf("window.open(")&&(_val=_val.replace(/window.open\('(.*)','(.*)','dependent=yes,width=([^,]*),height=([^,]*),scrollbars=yes,status=(.*)'\)/,"egw_openWindowCentered2('$1', '$2', $3, $4, '$5')")),-1!=_val.indexOf("xajax_doXMLHTTP('etemplate.")&&(_val=_val.replace(/^xajax_doXMLHTTP\('etemplate\.([a-z]+_widget\.[a-zA-Z0-9_]+)\'/,"xajax_doXMLHTTP('"+egw.getAppName()+".$1.etemplate'")),-1!=_val.indexOf("this.form.submit()")&&(_val=_val.replace("this.form.submit()","widget.getInstanceManager().submit()")),_val}(_code,_widget))&&(_code="widget.getInstanceManager().submit(); return false;"),_code.indexOf("$")>=0||_code.indexOf("@")>=0){var mgr=_widget.getArrayMgr("content");mgr&&(_code=mgr.expandName(_code))}var context=_context||null;if(!context&&_widget.implements(et2_IDOMNode)&&(context=_widget.getDOMNode()),-1===_code.indexOf("(")){for(var parts=_code.split("."),existing_func=parts.pop(),parent=_widget.egw().window,i=0;i<parts.length&&void 0!==parent[parts[i]];++i)parent=parent[parts[i]];if("function"==typeof parent[existing_func])return parent[existing_func]}try{"string"==typeof _code&&0==_code.indexOf("app")&&_code.split(".").length>=3&&-1==_code.indexOf("(")&&(_code+="(ev,widget)"),_code=_code.replace(/(window\.)?app\./,"widget.getInstanceManager().app_obj.");var func=new Function("ev","widget",_code)}catch(e){return _widget.egw().debug("error","Error while compiling JS code ",_code),function(){return!1}}return function(ev){return egw.debug("log","Executing legacy JS code: ",_code),arguments&&arguments.length>2&&egw.debug("warn","Legacy JS code only supports 2 arguments (event and widget)",_code,arguments),func.call(context,ev,_widget)}}}.call(window),
/**
 * EGroupware eTemplate2 - JS file which contains the complete et2 module
 *
 * @license http://opensource.org/licenses/gpl-license.php GPL - GNU General Public License
 * @package etemplate
 * @subpackage api
 * @link http://www.egroupware.org
 * @author Andreas Stöckel
 * @copyright Stylite 2011
 * @version $Id$
 *

/*egw:uses
    // Include all widget classes here
    et2_widget_template;
    et2_widget_grid;
    et2_widget_box;
    et2_widget_hbox;
    et2_widget_groupbox;
    et2_widget_split;
    et2_widget_button;
    et2_widget_color;
    et2_widget_description;
    et2_widget_entry;
    et2_widget_textbox;
    et2_widget_number;
    et2_widget_password;
    et2_widget_url;
    et2_widget_selectbox;
    et2_widget_checkbox;
    et2_widget_radiobox;
    et2_widget_date;
    et2_widget_dialog;
    et2_widget_diff;
    et2_widget_dropdown_button;
    et2_widget_styles;
    et2_widget_favorites;
    et2_widget_html;
    et2_widget_htmlarea;
    et2_widget_tabs;
    et2_widget_taglist;
    et2_widget_timestamper;
    et2_widget_toolbar;
    et2_widget_tree;
    et2_widget_historylog;
    et2_widget_hrule;
    et2_widget_image;
    et2_widget_iframe;
    et2_widget_file;
    et2_widget_link;
    et2_widget_progress;
    et2_widget_portlet;
    et2_widget_selectAccount;
    et2_widget_ajaxSelect;
    et2_widget_vfs;
    et2_widget_video;
    et2_widget_barcode;
    et2_widget_itempicker;
    et2_widget_script;
    et2_widget_countdown;
    et2_extension_nextmatch;
    et2_extension_customfields;

    // Requirements for the etemplate2 object
    et2_core_common;
    et2_core_xml;
    et2_core_arrayMgr;
    et2_core_interfaces;
    et2_core_legacyJSFunctions;

    // Include the client side api core
    jsapi.egw_core;
    jsapi.egw_json;
*/
Object.defineProperty(exports,"__esModule",{value:!0});et2_core_baseWidget_1=require("./et2_core_baseWidget"),egw_app_1=require("../jsapi/egw_app");var etemplate2=function(){function etemplate2(_container,_menuaction,_uniqueId){void 0===_menuaction&&(_menuaction="EGroupware\\Api\\Etemplate::ajax_process_content"),this._DOMContainer=_container,this.menuaction=_menuaction,this.uniqueId=_uniqueId||(_container.getAttribute("id")?_container.getAttribute("id").replace(".","-"):""),this._widgetContainer=null;try{opener&&opener.etemplate2?etemplate2.templates=opener.etemplate2.templates:top.etemplate2&&(etemplate2.templates=top.etemplate2.templates)}catch(e){console.log("Security exception accessing etemplate2.prototype of opener or top!")}void 0===etemplate2.templates&&(etemplate2.templates={})}return etemplate2.prototype.resize=function(e){var event=e,self=this,excess_height=!1;void 0!==window.framework&&void 0!==window.framework.get_wExcessHeight&&(excess_height=window.framework.get_wExcessHeight(window)),void 0!==event&&"resize"==event.type?(this.resize_timeout&&clearTimeout(this.resize_timeout),this.resize_timeout=setTimeout((function(){if(self.resize_timeout=!1,self._widgetContainer){var appHeader=jQuery("#divAppboxHeader");excess_height=egw(window).is_popup()?jQuery(window).height()-jQuery(self._DOMContainer).height()-appHeader.outerHeight()+11:0,appHeader.length>0&&appHeader.is(":visible")&&(excess_height-=appHeader.outerHeight()-9),screen.availHeight<jQuery(self._DOMContainer).height()&&(excess_height=0),jQuery(self.DOMContainer).is(":visible")&&self._widgetContainer.iterateOver((function(_widget){_widget.resize(excess_height)}),self,et2_IResizeable)}}),100)):this._widgetContainer&&this._widgetContainer.iterateOver((function(_widget){_widget.resize(excess_height)}),this,et2_IResizeable)},etemplate2.prototype.clear=function(){for(var name_1 in jQuery(this._DOMContainer).trigger("clear"),this.uniqueId&&jQuery(window).off("."+this.uniqueId),this.destroy_session&&(this.destroy_session(),this.unbind_unload()),null!=this._widgetContainer&&(this._widgetContainer.egw().unregisterJSONPlugin(this.handle_assign,this,"assign"),this._widgetContainer.destroy(),this._widgetContainer=null),jQuery(this._DOMContainer).empty(),etemplate2.templates)if(void 0!==etemplate2._byTemplate[name_1])for(var i=0;i<etemplate2._byTemplate[name_1].length;i++)etemplate2._byTemplate[name_1][i]==this&&etemplate2._byTemplate[name_1].splice(i,1);if(this.app_obj!==window.app)for(var app_name in this.app_obj)this.app_obj[app_name]instanceof egw_app_1.EgwApp&&this.app_obj[app_name].destroy()},Object.defineProperty(etemplate2.prototype,"widgetContainer",{get:function(){return this._widgetContainer},enumerable:!0,configurable:!0}),Object.defineProperty(etemplate2.prototype,"DOMContainer",{get:function(){return this._DOMContainer},enumerable:!0,configurable:!0}),Object.defineProperty(etemplate2.prototype,"etemplate_exec_id",{get:function(){return this._etemplate_exec_id},enumerable:!0,configurable:!0}),etemplate2.prototype._createArrayManagers=function(_data){void 0===_data&&(_data={});for(var neededEntries=["content","sel_options","readonlys","modifications","validation_errors"],i=0;i<neededEntries.length;i++)void 0!==_data[neededEntries[i]]&&_data[neededEntries[i]]||(egw.debug("log","Created not passed entry '"+neededEntries[i]+"' in data array."),_data[neededEntries[i]]={});var result={};for(var key in _data)switch(key){case"etemplate_exec_id":case"app_header":break;case"readonlys":result[key]=new et2_readonlysArrayMgr(_data[key]),result[key].perspectiveData.owner=this._widgetContainer;break;default:result[key]=new et2_arrayMgr(_data[key]),result[key].perspectiveData.owner=this._widgetContainer}return result},etemplate2.prototype.bind_unload=function(){window===egw_topWindow()||this.close_prompt||(this.close_prompt=this._close_changed_prompt.bind(this),window.addEventListener("beforeunload",this.close_prompt)),this._etemplate_exec_id&&(this.destroy_session=jQuery.proxy((function(ev){egw.json("EGroupware\\Api\\Etemplate::ajax_destroy_session",[this._etemplate_exec_id],null,null,"keepalive").sendRequest()}),this),window.addEventListener("beforeunload",this.destroy_session))},etemplate2.prototype._close_changed_prompt=function(e){!this._skip_close_prompt&&this.isDirty()&&(e.preventDefault(),e.returnValue="")},etemplate2.prototype.skip_close_prompt=function(skip){void 0===skip&&(skip=!0),this._skip_close_prompt=skip},etemplate2.prototype.unbind_unload=function(){if(window.removeEventListener("beforeunload",this.destroy_session),window.removeEventListener("beforeunload",this.close_prompt),window.onbeforeunload===this.destroy_session)window.onbeforeunload=null;else{var onbeforeunload_1=window.onbeforeunload;window.onbeforeunload=null,window.setTimeout((function(){window.onbeforeunload=onbeforeunload_1}),100)}delete this.destroy_session},etemplate2.prototype.download=function(_url){var a=document.createElement("a");a.href=_url,a.download="download",a.click()},etemplate2.prototype.load=function(_name,_url,_data,_callback,_app,_no_et2_ready,_open_target){var app=_app||window.app;this.name=_name,_url&&"/"!=_url[0]?(this.template_base_url=_url.match(/https?:\/\/[^/]+/).shift(),_url=_url.split(this.template_base_url)[1]):this.template_base_url="",this.template_base_url+=_url.split(_name.split(".").shift())[0],egw().debug("info","Loaded data",_data);var currentapp=this.app=_data.currentapp||egw().app_name(),appname=_name.split(".")[0];(!_app&&appname&&appname!=currentapp||_open_target)&&(app={classes:window.app.classes}),this.app_obj=app;var msg=_data.content.msg;if(void 0!==msg&&(egw(window).message(msg),delete _data.content.msg),egw(currentapp,window).registerJSONPlugin(this.handle_assign,this,"assign"),egw.debug_level()>=3&&console.groupCollapsed&&egw.window.console.groupCollapsed("Loading %s into ",_name,"#"+this._DOMContainer.id),egw.debug_level()>=4){console.time&&console.time(_name),console.profile&&console.profile(_name);var start_time=(new Date).getTime()}jQuery.isArray(_data.langRequire)||(_data.langRequire=[]),egw(currentapp,window).langRequire(window,_data.langRequire,(function(){this.clear();var app_callback=null;"object"!=typeof app[appname]&&"function"==typeof app.classes[appname]?app[appname]=new app.classes[appname]:appname&&"object"!=typeof app[appname]&&egw.debug("warn","Did not load '%s' JS object",appname),"object"!=typeof app[this.app]&&"function"==typeof app.classes[this.app]&&(app[this.app]=new app.classes[this.app]),"object"==typeof app[appname]&&(app_callback=function(_et2,_name){app[appname].et2_ready(_et2,_name)}),this._widgetContainer=new et2_core_baseWidget_1.et2_container(null),this._widgetContainer.setApiInstance(egw(currentapp,egw.elemWindow(this._DOMContainer))),this._widgetContainer.setInstanceManager(this),this._widgetContainer.setParentDOMNode(this._DOMContainer),_data&&(this._etemplate_exec_id=_data.etemplate_exec_id,"string"==typeof _data.app_header&&window.egw_app_header(_data.app_header),this.bind_unload());var _load=function(){egw.debug("log","Loading template..."),egw.debug_level()>=4&&console.timeStamp&&console.timeStamp("Begin rendering template"),void 0===etemplate2._byTemplate[_name]&&(etemplate2._byTemplate[_name]=[]),etemplate2._byTemplate[_name].push(this),this._widgetContainer.loadFromXML(etemplate2.templates[this.name]);var deferred=[];if(this._widgetContainer.loadingFinished(deferred),jQuery(window).on("resize."+this.uniqueId,this,(function(e){e.data.resize(e)})),egw.debug_level()>=3&&console.groupEnd&&egw.window.console.groupEnd(),deferred.length>0){var still_deferred_1=0;jQuery(deferred).each((function(){"pending"==this.state()&&still_deferred_1++})),still_deferred_1>0&&egw.debug("log","Template loaded, waiting for %d/%d deferred to finish...",still_deferred_1,deferred.length)}jQuery.when.apply(jQuery,deferred).done(jQuery.proxy((function(){if(egw.debug("log","Finished loading %s, triggering load event",_name),void 0!==window.framework&&void 0!==window.framework.et2_loadingFinished&&window.framework.et2_loadingFinished(egw(window).window),this.resize(),this._widgetContainer._egw.is_popup()&&0==jQuery("[autofocus]",this._DOMContainer).focus().length){var $input=jQuery("input:visible",this._DOMContainer).not(".et2_date").filter((function(){var $this=jQuery(this);return!$this.attr("tabindex")||parseInt($this.attr("tabIndex"))>=0})).first();(egwIsMobile()&&""==$input.val()||!egwIsMobile())&&$input.focus()}if("function"==typeof _callback&&_callback.call(window,this,_name),app_callback&&_callback!=app_callback&&!_no_et2_ready&&app_callback.call(window,this,_name),appname&&appname!=this.app&&"object"==typeof app[this.app]&&!_no_et2_ready&&app[this.app].et2_ready(this,this.name),jQuery(this._DOMContainer).trigger("load",this),etemplate2.templates[this.name].attributes.onload){var onload_1=et2_checkType(etemplate2.templates[this.name].attributes.onload.value,"js","onload",{});"string"==typeof onload_1&&(onload_1=et2_compileLegacyJS(onload_1,this,this._widgetContainer)),onload_1.call(this._widgetContainer)}if(egw.debug_level()>=4){console.timeEnd&&console.timeEnd(_name),console.profileEnd&&console.profileEnd(_name);var end_time=(new Date).getTime(),gen_time_div=jQuery("#divGenTime_"+appname);gen_time_div.length||(gen_time_div=jQuery(".pageGenTime")),gen_time_div.find(".et2RenderTime").remove(),gen_time_div.append('<span class="et2RenderTime">'+egw.lang("eT2 rendering took %1s",""+(end_time-start_time)/1e3)+"</span>")}}),this))};try{if(etemplate2.templates[_name])return this._widgetContainer.setArrayMgrs(this._createArrayManagers(_data)),void _load.apply(this,[])}catch(e){if("Permission denied"!=e.message)throw e;etemplate2.templates={}}et2_loadXMLFromURL(_url,(function(_xmldoc){for(var i=0;i<_xmldoc.childNodes.length;i++){var template=_xmldoc.childNodes[i];"template"==template.nodeName.toLowerCase()&&(etemplate2.templates[template.getAttribute("id")]=template,_name||(this.name=template.getAttribute("id")))}_load.apply(this,[])}),this),this._widgetContainer.setArrayMgrs(this._createArrayManagers(_data))}),this)},etemplate2.prototype.isDirty=function(){var dirty=!1;return this._widgetContainer.iterateOver((function(_widget){_widget.isDirty&&_widget.isDirty()&&(console.info(_widget.id+" is dirty",_widget),dirty=!0)}),this),dirty},etemplate2.prototype.autocomplete_fixer=function(){var form=this._DOMContainer;navigator.userAgent.match(/safari/i)&&!navigator.userAgent.match(/chrome/i)&&jQuery('input[type="password"]').length>0||form&&(form.onsubmit=function(e){e.stopPropagation()},navigator.userAgent.match(/(firefox|safari|iceweasel)/i)&&!navigator.userAgent.match(/chrome/i)&&jQuery(form).attr({action:egw.webserverUrl+"/api/templates/default/empty.html",method:"post"}),jQuery(form).trigger("submit"))},etemplate2.prototype._set_button=function(button,values){if("string"==typeof button&&(button=this._widgetContainer.getWidgetById(button)),button&&!values.button){var i=void 0;values.button={};var path=button.getPath(),target=values;for(i=0;i<path.length;i++)values[path[i]]||(values[path[i]]={}),target=values[path[i]];if(target!=values||-1!=button.id.indexOf("[")&&0==path.length){var indexes=button.id.split("[");if(indexes.length>1){(indexes=[indexes.shift(),indexes.join("[")])[1]=indexes[1].substring(0,indexes[1].length-1);var children=indexes[1].split("][");children.length&&(indexes=jQuery.merge([indexes[0]],children))}var idx="";for(i=0;i<indexes.length;i++)target[idx=indexes[i]]&&!target[idx].$row_cont||(target[idx]=!(i<indexes.length-1)||{}),target=target[idx]}else(void 0===values.button||jQuery.isEmptyObject(values.button))&&(delete values.button,values[button.id]=!0)}},etemplate2.prototype.submit=function(button,async,no_validation,_container){var api=this._widgetContainer.egw();void 0===no_validation&&(no_validation=!1);var container=_container||this._widgetContainer,values=this.getValues(container),canSubmit=!0;(no_validation||container.iterateOver((function(_widget){!1===_widget.submit(values)&&(canSubmit=!1)}),this,et2_ISubmitListener),canSubmit)&&(void 0!==async&&"string"!=typeof async||(api.loading_prompt("et2_submit_spinner",!0,api.lang("string"==typeof async?async:"Please wait...")),async=!0),button&&this._set_button(button,values),this.menuaction?(this.autocomplete_fixer(),this.unbind_unload(),api.json(this.menuaction,[this._etemplate_exec_id,values,no_validation],(function(){api.loading_prompt("et2_submit_spinner",!1)}),this,async).sendRequest()):this._widgetContainer.egw().debug("warn","Missing menuaction for submit.  Values: ",values));return canSubmit},etemplate2.prototype.postSubmit=function(button){var values=this.getValues(this._widgetContainer),canSubmit=!0;if(this._widgetContainer.iterateOver((function(_widget){!1===_widget.submit(values)&&(canSubmit=!1)}),this,et2_ISubmitListener),canSubmit){button&&this._set_button(button,values),this.unbind_unload();var form=jQuery("<form id='form' action='"+egw().webserverUrl+"/index.php?menuaction="+this._widgetContainer.egw().getAppName()+".EGroupware\\Api\\Etemplate.process_exec&ajax=true' method='POST'>"),input=(jQuery(document.createElement("input")).attr("name","etemplate_exec_id").attr("type","hidden").val(this._etemplate_exec_id).appendTo(form),document.createElement("input"));input.type="hidden",input.name="value",input.value=egw().jsonEncode(values),form.append(input),form.appendTo(jQuery("body")).submit(),window.setTimeout(jQuery.proxy(this.bind_unload,this),100)}},etemplate2.prototype.getValues=function(_root){var result={};return _root.iterateOver((function(_widget){if(""!=_widget.id){var path=_widget.getPath(),id=_widget.id,indexes=id.split("[");if(indexes.length>1){(indexes=[indexes.shift(),indexes.join("[")])[1]=indexes[1].substring(0,indexes[1].length-1);var children=indexes[1].split("][");children.length&&(indexes=jQuery.merge([indexes[0]],children)),id=(path=path.concat(indexes)).pop()}for(var _target=result,i=0;i<path.length;i++)void 0===_target[path[i]]&&(_target[path[i]]={}),"object"==typeof _target[path[i]]?_target=_target[path[i]]:egw.debug("error","ID collision while writing at path node '"+path[i]+"'");""===id&&(id=void 0===_target?0:Object.keys(_target).length);var value=_widget.getValue();if(void 0===_target[id]||"object"==typeof _target[id]&&"object"==typeof value||_widget.getParent().instanceOf(et2_nextmatch_header_bar)||egw.debug("warn",_widget,"Overwriting value of '"+_widget.id+"', id exists twice!"),null!==value)"object"==typeof _target[id]&&"object"==typeof value?_target[id]=jQuery.extend({},_target[id],value):_target[id]=value;else if(jQuery.isEmptyObject(_target)){_target=result;for(i=0;i<path.length-1;i++)_target=_target[path[i]];delete _target[path[path.length-1]]}_widget.resetDirty()}}),this,et2_IInput),egw().debug("info","Value",result),result},etemplate2.prototype.refresh=function(msg,app,id,type){var refresh_done=!1;return this._widgetContainer.iterateOver((function(_widget){_widget.refresh(id,type),refresh_done=!0}),this,et2_nextmatch),refresh_done},etemplate2.app_refresh=function(_msg,_app,_id,_type){for(var refresh_done=!1,app=_app.split("-"),et2=etemplate2.getByApplication(app[0]),i=0;i<et2.length;i++)if(app[1]){if(et2[i].uniqueId.match(_app)){refresh_done=et2[i].refresh(_msg,app[0],_id,_type)||refresh_done;break}}else refresh_done=et2[i].refresh(_msg,app[0],_id,_type)||refresh_done;return refresh_done},etemplate2.prototype.print=function(){var deferred=[];return 0===jQuery(this._DOMContainer).filter(":visible").length?[]:(this._widgetContainer.iterateOver((function(_widget){if(_widget.getInstanceManager()==this&&0!==jQuery(_widget.getDOMNode()).filter(":visible").length){var result=_widget.beforePrint();"object"==typeof result&&result.done&&deferred.push(result)}}),this,et2_IPrint),deferred)},etemplate2.getByTemplate=function(template){return void 0!==etemplate2._byTemplate[template]?etemplate2._byTemplate[template]:[]},etemplate2.getByApplication=function(app){var list=[];for(var name_2 in etemplate2._byTemplate)0==name_2.indexOf(app+".")&&(list=list.concat(etemplate2._byTemplate[name_2]));return list},etemplate2.getById=function(id){for(var name_3 in etemplate2._byTemplate)for(var i=0;i<etemplate2._byTemplate[name_3].length;i++){var et=etemplate2._byTemplate[name_3][i];if(et._DOMContainer.getAttribute("id")==id)return et}return null},etemplate2.handle_load=function(_type,_response){var data=_response.data;jQuery.isArray(data["refresh-opener"])&&(window.opener&&(egw=window.egw(opener)).refresh.apply(egw,data["refresh-opener"]));var egw=window.egw(window);if("object"==typeof data.data&&"string"==typeof data.data.app_header&&(egw.app_header(data.data.app_header,data.data.currentapp||null),delete data.data.app_header),jQuery.isArray(data.message)&&egw.message.apply(egw,data.message),data["window-close"])return"string"==typeof data["window-close"]&&"true"!==data["window-close"]&&alert(data["window-close"]),egw.close(),!0;if(data["window-focus"]&&window.focus(),window.framework&&jQuery.isArray(data.setSidebox)&&(data["fw-target"]&&(data.setSidebox[0]=data["fw-target"]),window.framework.setSidebox.apply(window.framework,data.setSidebox)),"string"==typeof data.url&&"object"==typeof data.data){if(this&&"function"==typeof this.load)return this._DOMContainer.id=this.uniqueId=data.DOMNodeID,this.load(data.name,data.url,data.data),!0;var node=document.getElementById(data.DOMNodeID),uniqueId=data.DOMNodeID;if(node){if(node.children.length){var old=etemplate2.getById(node.id);old&&old.clear()}return data.open_target&&!uniqueId.match(data.open_target)&&(uniqueId=data.DOMNodeID.replace(".","-")+"-"+data.open_target),new etemplate2(node,data.menuaction,uniqueId).load(data.name,data.url,data.data,null,null,null,data["fw-target"]),!0}egw.debug("error","Could not find target node %s",data.DOMNodeId)}throw"Error while parsing et2_load response"},etemplate2.handle_validation_error=function(_type,_response){for(var id in _response.data){var widget=this._widgetContainer.getWidgetById(id);if(widget&&widget.instanceOf(et2_core_baseWidget_1.et2_baseWidget)){widget.showMessage(_response.data[id],"validation_error");for(var tmpWidget=widget;tmpWidget.getParent()&&"tabbox"!=tmpWidget.getType();)tmpWidget=tmpWidget.getParent();"tabbox"==tmpWidget.getType()&&tmpWidget.activateTab(widget)}}egw().debug("warn","Validation errors",_response.data)},etemplate2.prototype.handle_assign=function(type,res,req){if(void 0!==res.data.id&&void 0!==res.data.key&&void 0!==res.data.value){if(void 0===res.data.etemplate_exec_id||res.data.etemplate_exec_id!=this._etemplate_exec_id)return!1;if("etemplate_exec_id"==res.data.key)return this._etemplate_exec_id=res.data.value,!0;if(null==this._widgetContainer)return egw.debug("warn","Tried to call assign on an un-loaded etemplate",res.data),!1;var widget=this._widgetContainer.getWidgetById(res.data.id);if(widget){if("function"!=typeof widget["set_"+res.data.key])return egw.debug("warn","Cannot set %s attribute %s via JSON assign, no set_%s()",res.data.id,res.data.key,res.data.key),!1;try{return widget["set_"+res.data.key].call(widget,res.data.value),!0}catch(e){egw.debug("error","When assigning %s on %s via AJAX, \n"+(e.message||e+""),res.data.key,res.data.id,widget)}}return!1}throw"Invalid parameters"},etemplate2.templates={},etemplate2._byTemplate={},etemplate2}();exports.etemplate2=etemplate2,egw(window).registerJSONPlugin(etemplate2.handle_load,null,"et2_load"),egw(window).registerJSONPlugin(etemplate2.handle_validation_error,null,"et2_validation_error");